declare global {
	function require(name: string): any;
}

declare function gc() : void;
declare type UnrealEngineClass = any;
declare type timeout_handle = any;
declare function setTimeout(fn : (milliseconds: number) => void, timeout : number) : timeout_handle;
declare function clearTimeout(handle : timeout_handle) : void;
declare class UnrealEngineMulticastDelegate<T> {
	Add(fn : T): void;
	Remove(fn : T): void;
}

declare class UnrealEngineDelegate<T> {
	Add(fn : T): void;
	Remove(fn : T): void;
}

declare class Process {
	nextTick(fn : (number) => void): void;
}

declare var process : Process;

declare class Memory {
	exec(ab : ArrayBuffer, fn : (ab : ArrayBuffer) => void): void;
	access(obj : JavascriptMemoryObject): ArrayBuffer;
}

declare var memory : Memory;

declare var GEngine : Engine;

declare var GWorld : World;

declare var Root : JavascriptComponent | any;

declare namespace JSX {
	interface IntrinsicElements {
		[elemName: string]: any;
		div: any;
		span: any;
		text: any;
		img: any;
		input: any;
	}
}

declare type ECastToControlRigBlueprintCases = 'CastSucceeded' | 'CastFailed' | 'ECastToControlRigBlueprintCases_MAX';
declare var ECastToControlRigBlueprintCases : { CastSucceeded:'CastSucceeded',CastFailed:'CastFailed',ECastToControlRigBlueprintCases_MAX:'ECastToControlRigBlueprintCases_MAX', };
declare class Guid { 
	A: number;
	B: number;
	C: number;
	D: number;
	clone() : Guid;
	static C(Other: UObject | any): Guid;
	Conv_GuidToString(): string;
	EqualEqual_GuidGuid(B: Guid): boolean;
	Invalidate_Guid(): {InGuid: Guid};
	IsValid_Guid(): boolean;
	NotEqual_GuidGuid(B: Guid): boolean;
	static Conv_GuidToString(InGuid: Guid): string;
	static EqualEqual_GuidGuid(A: Guid,B: Guid): boolean;
	static Invalidate_Guid(InGuid?: Guid): {InGuid: Guid};
	static IsValid_Guid(InGuid: Guid): boolean;
	static NotEqual_GuidGuid(A: Guid,B: Guid): boolean;
	static NewGuid(): Guid;
}

declare class BlueprintCore extends UObject { 
	SkeletonGeneratedClass: UnrealEngineClass;
	GeneratedClass: UnrealEngineClass;
	bLegacyNeedToPurgeSkelRefs: boolean;
	BlueprintGuid: Guid;
	static Load(ResourceName: string): BlueprintCore;
	static Find(Outer: UObject, ResourceName: string): BlueprintCore;
	static GetDefaultObject(): BlueprintCore;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlueprintCore;
	static C(Other: UObject | any): BlueprintCore;
}

declare type EBlueprintType = 'BPTYPE_Normal' | 'BPTYPE_Const' | 'BPTYPE_MacroLibrary' | 'BPTYPE_Interface' | 'BPTYPE_LevelScript' | 'BPTYPE_FunctionLibrary' | 'BPTYPE_MAX';
declare var EBlueprintType : { BPTYPE_Normal:'BPTYPE_Normal',BPTYPE_Const:'BPTYPE_Const',BPTYPE_MacroLibrary:'BPTYPE_MacroLibrary',BPTYPE_Interface:'BPTYPE_Interface',BPTYPE_LevelScript:'BPTYPE_LevelScript',BPTYPE_FunctionLibrary:'BPTYPE_FunctionLibrary',BPTYPE_MAX:'BPTYPE_MAX', };
declare type EShouldCookBlueprintPropertyGuids = 'No' | 'Yes' | 'Inherit' | 'EShouldCookBlueprintPropertyGuids_MAX';
declare var EShouldCookBlueprintPropertyGuids : { No:'No',Yes:'Yes',Inherit:'Inherit',EShouldCookBlueprintPropertyGuids_MAX:'EShouldCookBlueprintPropertyGuids_MAX', };
declare type EBlueprintNativizationFlag = 'Disabled' | 'Dependency' | 'ExplicitlyEnabled' | 'EBlueprintNativizationFlag_MAX';
declare var EBlueprintNativizationFlag : { Disabled:'Disabled',Dependency:'Dependency',ExplicitlyEnabled:'ExplicitlyEnabled',EBlueprintNativizationFlag_MAX:'EBlueprintNativizationFlag_MAX', };
declare type EBlueprintCompileMode = 'Default' | 'Development' | 'FinalRelease' | 'EBlueprintCompileMode_MAX';
declare var EBlueprintCompileMode : { Default:'Default',Development:'Development',FinalRelease:'FinalRelease',EBlueprintCompileMode_MAX:'EBlueprintCompileMode_MAX', };
declare type EBlueprintStatus = 'BS_Unknown' | 'BS_Dirty' | 'BS_Error' | 'BS_UpToDate' | 'BS_BeingCreated' | 'BS_UpToDateWithWarnings' | 'BS_MAX';
declare var EBlueprintStatus : { BS_Unknown:'BS_Unknown',BS_Dirty:'BS_Dirty',BS_Error:'BS_Error',BS_UpToDate:'BS_UpToDate',BS_BeingCreated:'BS_BeingCreated',BS_UpToDateWithWarnings:'BS_UpToDateWithWarnings',BS_MAX:'BS_MAX', };
declare type ETickingGroup = 'TG_PrePhysics' | 'TG_StartPhysics' | 'TG_DuringPhysics' | 'TG_EndPhysics' | 'TG_PostPhysics' | 'TG_PostUpdateWork' | 'TG_LastDemotable' | 'TG_NewlySpawned' | 'TG_MAX';
declare var ETickingGroup : { TG_PrePhysics:'TG_PrePhysics',TG_StartPhysics:'TG_StartPhysics',TG_DuringPhysics:'TG_DuringPhysics',TG_EndPhysics:'TG_EndPhysics',TG_PostPhysics:'TG_PostPhysics',TG_PostUpdateWork:'TG_PostUpdateWork',TG_LastDemotable:'TG_LastDemotable',TG_NewlySpawned:'TG_NewlySpawned',TG_MAX:'TG_MAX', };
declare class TickFunction { 
	TickGroup: ETickingGroup;
	EndTickGroup: ETickingGroup;
	bTickEvenWhenPaused: boolean;
	bCanEverTick: boolean;
	bStartWithTickEnabled: boolean;
	bAllowTickOnDedicatedServer: boolean;
	TickInterval: number;
	clone() : TickFunction;
	static C(Other: UObject | any): TickFunction;
}

declare class ActorComponentTickFunction extends TickFunction { 
	clone() : ActorComponentTickFunction;
	static C(Other: UObject | any): ActorComponentTickFunction;
}

declare class AssetUserData extends UObject { 
	static Load(ResourceName: string): AssetUserData;
	static Find(Outer: UObject, ResourceName: string): AssetUserData;
	static GetDefaultObject(): AssetUserData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetUserData;
	static C(Other: UObject | any): AssetUserData;
}

declare type EComponentCreationMethod = 'Native' | 'SimpleConstructionScript' | 'UserConstructionScript' | 'Instance' | 'EComponentCreationMethod_MAX';
declare var EComponentCreationMethod : { Native:'Native',SimpleConstructionScript:'SimpleConstructionScript',UserConstructionScript:'UserConstructionScript',Instance:'Instance',EComponentCreationMethod_MAX:'EComponentCreationMethod_MAX', };
declare class SimpleMemberReference { 
	MemberParent: UObject;
	MemberName: string;
	MemberGuid: Guid;
	clone() : SimpleMemberReference;
	static C(Other: UObject | any): SimpleMemberReference;
}

declare class ActorTickFunction extends TickFunction { 
	clone() : ActorTickFunction;
	static C(Other: UObject | any): ActorTickFunction;
}

declare type EActorUpdateOverlapsMethod = 'UseConfigDefault' | 'AlwaysUpdate' | 'OnlyUpdateMovable' | 'NeverUpdate' | 'EActorUpdateOverlapsMethod_MAX';
declare var EActorUpdateOverlapsMethod : { UseConfigDefault:'UseConfigDefault',AlwaysUpdate:'AlwaysUpdate',OnlyUpdateMovable:'OnlyUpdateMovable',NeverUpdate:'NeverUpdate',EActorUpdateOverlapsMethod_MAX:'EActorUpdateOverlapsMethod_MAX', };
declare type ENetRole = 'ROLE_None' | 'ROLE_SimulatedProxy' | 'ROLE_AutonomousProxy' | 'ROLE_Authority' | 'ROLE_MAX';
declare var ENetRole : { ROLE_None:'ROLE_None',ROLE_SimulatedProxy:'ROLE_SimulatedProxy',ROLE_AutonomousProxy:'ROLE_AutonomousProxy',ROLE_Authority:'ROLE_Authority',ROLE_MAX:'ROLE_MAX', };
declare type EActorGridPlacement = 'Bounds' | 'Location' | 'AlwaysLoaded' | 'None' | 'EActorGridPlacement_MAX';
declare var EActorGridPlacement : { Bounds:'Bounds',Location:'Location',AlwaysLoaded:'AlwaysLoaded',None:'None',EActorGridPlacement_MAX:'EActorGridPlacement_MAX', };
declare class QuaternionSpringState { 
	clone() : QuaternionSpringState;
	static C(Other: UObject | any): QuaternionSpringState;
	ResetQuaternionSpringState(): {SpringState: QuaternionSpringState};
	SetQuaternionSpringStateAngularVelocity(AngularVelocity?: Vector): {SpringState: QuaternionSpringState};
	static ResetQuaternionSpringState(SpringState?: QuaternionSpringState): {SpringState: QuaternionSpringState};
	static SetQuaternionSpringStateAngularVelocity(SpringState?: QuaternionSpringState,AngularVelocity?: Vector): {SpringState: QuaternionSpringState};
}

declare class Quat { 
	X: number;
	Y: number;
	Z: number;
	W: number;
	clone() : Quat;
	static C(Other: UObject | any): Quat;
	Add_QuatQuat(B: Quat): Quat;
	BreakQuat(X?: number,Y?: number,Z?: number,W?: number): {X: number, Y: number, Z: number, W: number};
	EqualEqual_QuatQuat(B: Quat,Tolerance: number): boolean;
	Multiply_QuatQuat(B: Quat): Quat;
	NotEqual_QuatQuat(B: Quat,ErrorTolerance: number): boolean;
	Quat_AngularDistance(B: Quat): number;
	Quat_EnforceShortestArcWith(B?: Quat): {A: Quat};
	Quat_Euler(): Vector;
	Quat_Exp(): Quat;
	Quat_GetAngle(): number;
	Quat_GetAxisX(): Vector;
	Quat_GetAxisY(): Vector;
	Quat_GetAxisZ(): Vector;
	Quat_GetRotationAxis(): Vector;
	Quat_Inversed(): Quat;
	Quat_IsFinite(): boolean;
	Quat_IsIdentity(Tolerance: number): boolean;
	Quat_IsNonFinite(): boolean;
	Quat_IsNormalized(): boolean;
	Quat_Log(): Quat;
	Quat_Normalize(Tolerance?: number): {Q: Quat};
	Quat_Normalized(Tolerance: number): Quat;
	Quat_RotateVector(V: Vector): Vector;
	Quat_Rotator(): Rotator;
	Quat_SetComponents(X?: number,Y?: number,Z?: number,W?: number): {Q: Quat};
	Quat_SetFromEuler(Euler?: Vector): {Q: Quat};
	Quat_Size(): number;
	Quat_SizeSquared(): number;
	Quat_UnrotateVector(V: Vector): Vector;
	Quat_VectorForward(): Vector;
	Quat_VectorRight(): Vector;
	Quat_VectorUp(): Vector;
	QuaternionSpringInterp(Target: Quat,SpringState?: QuaternionSpringState,Stiffness?: number,CriticalDampingFactor?: number,DeltaTime?: number,Mass?: number,TargetVelocityAmount?: number,bInitializeFromTarget?: boolean): {SpringState: QuaternionSpringState, $: Quat};
	Subtract_QuatQuat(B: Quat): Quat;
	static Add_QuatQuat(A: Quat,B: Quat): Quat;
	static BreakQuat(InQuat: Quat,X?: number,Y?: number,Z?: number,W?: number): {X: number, Y: number, Z: number, W: number};
	static EqualEqual_QuatQuat(A: Quat,B: Quat,Tolerance: number): boolean;
	static Multiply_QuatQuat(A: Quat,B: Quat): Quat;
	static NotEqual_QuatQuat(A: Quat,B: Quat,ErrorTolerance: number): boolean;
	static Quat_AngularDistance(A: Quat,B: Quat): number;
	static Quat_EnforceShortestArcWith(A?: Quat,B?: Quat): {A: Quat};
	static Quat_Euler(Q: Quat): Vector;
	static Quat_Exp(Q: Quat): Quat;
	static Quat_GetAngle(Q: Quat): number;
	static Quat_GetAxisX(Q: Quat): Vector;
	static Quat_GetAxisY(Q: Quat): Vector;
	static Quat_GetAxisZ(Q: Quat): Vector;
	static Quat_GetRotationAxis(Q: Quat): Vector;
	static Quat_Inversed(Q: Quat): Quat;
	static Quat_IsFinite(Q: Quat): boolean;
	static Quat_IsIdentity(Q: Quat,Tolerance: number): boolean;
	static Quat_IsNonFinite(Q: Quat): boolean;
	static Quat_IsNormalized(Q: Quat): boolean;
	static Quat_Log(Q: Quat): Quat;
	static Quat_Normalize(Q?: Quat,Tolerance?: number): {Q: Quat};
	static Quat_Normalized(Q: Quat,Tolerance: number): Quat;
	static Quat_RotateVector(Q: Quat,V: Vector): Vector;
	static Quat_Rotator(Q: Quat): Rotator;
	static Quat_SetComponents(Q?: Quat,X?: number,Y?: number,Z?: number,W?: number): {Q: Quat};
	static Quat_SetFromEuler(Q?: Quat,Euler?: Vector): {Q: Quat};
	static Quat_Size(Q: Quat): number;
	static Quat_SizeSquared(Q: Quat): number;
	static Quat_UnrotateVector(Q: Quat,V: Vector): Vector;
	static Quat_VectorForward(Q: Quat): Vector;
	static Quat_VectorRight(Q: Quat): Vector;
	static Quat_VectorUp(Q: Quat): Vector;
	static QuaternionSpringInterp(Current: Quat,Target: Quat,SpringState?: QuaternionSpringState,Stiffness?: number,CriticalDampingFactor?: number,DeltaTime?: number,Mass?: number,TargetVelocityAmount?: number,bInitializeFromTarget?: boolean): {SpringState: QuaternionSpringState, $: Quat};
	static Subtract_QuatQuat(A: Quat,B: Quat): Quat;
	static MakeQuat(X: number,Y: number,Z: number,W: number): Quat;
	static Quat_Identity(): Quat;
}

declare type EMotionExtractor_MotionType = 'Translation' | 'Rotation' | 'Scale' | 'TranslationSpeed' | 'RotationSpeed' | 'EMotionExtractor_MAX';
declare var EMotionExtractor_MotionType : { Translation:'Translation',Rotation:'Rotation',Scale:'Scale',TranslationSpeed:'TranslationSpeed',RotationSpeed:'RotationSpeed',EMotionExtractor_MAX:'EMotionExtractor_MAX', };
declare type EMotionExtractor_Axis = 'X' | 'Y' | 'Z' | 'XY' | 'XZ' | 'YZ' | 'XYZ' | 'EMotionExtractor_MAX';
declare var EMotionExtractor_Axis : { X:'X',Y:'Y',Z:'Z',XY:'XY',XZ:'XZ',YZ:'YZ',XYZ:'XYZ',EMotionExtractor_MAX:'EMotionExtractor_MAX', };
declare class Plane extends Vector { 
	W: number;
	clone() : Plane;
	static C(Other: UObject | any): Plane;
}

declare type EMatrixColumns = 'First' | 'Second' | 'Third' | 'Fourth' | 'EMatrixColumns_MAX';
declare var EMatrixColumns : { First:'First',Second:'Second',Third:'Third',Fourth:'Fourth',EMatrixColumns_MAX:'EMatrixColumns_MAX', };
declare type EAxis = 'None' | 'X' | 'Y' | 'Z' | 'EAxis_MAX';
declare var EAxis : { None:'None',X:'X',Y:'Y',Z:'Z',EAxis_MAX:'EAxis_MAX', };
declare class Vector4 { 
	X: number;
	Y: number;
	Z: number;
	W: number;
	clone() : Vector4;
	static C(Other: UObject | any): Vector4;
	Add_Vector4Vector4(B: Vector4): Vector4;
	BreakVector4(X?: number,Y?: number,Z?: number,W?: number): {X: number, Y: number, Z: number, W: number};
	Conv_Vector4ToQuaternion(): Quat;
	Conv_Vector4ToRotator(): Rotator;
	Conv_Vector4ToVector(): Vector;
	Divide_Vector4Vector4(B: Vector4): Vector4;
	EqualEqual_Vector4Vector4(B: Vector4,ErrorTolerance: number): boolean;
	EqualExactly_Vector4Vector4(B: Vector4): boolean;
	Multiply_Vector4Vector4(B: Vector4): Vector4;
	NotEqual_Vector4Vector4(B: Vector4,ErrorTolerance: number): boolean;
	NotEqualExactly_Vector4Vector4(B: Vector4): boolean;
	Subtract_Vector4Vector4(B: Vector4): Vector4;
	Vector4_Assign(InVector?: Vector4): {A: Vector4};
	Vector4_CrossProduct3(B: Vector4): Vector4;
	Vector4_DotProduct(B: Vector4): number;
	Vector4_DotProduct3(B: Vector4): number;
	Vector4_IsNAN(): boolean;
	Vector4_IsNearlyZero3(Tolerance: number): boolean;
	Vector4_IsNormal3(): boolean;
	Vector4_IsUnit3(SquaredLenthTolerance: number): boolean;
	Vector4_IsZero(): boolean;
	Vector4_MirrorByVector3(SurfaceNormal: Vector4): Vector4;
	Vector4_Negated(): Vector4;
	Vector4_Normal3(Tolerance: number): Vector4;
	Vector4_Normalize3(Tolerance?: number): {A: Vector4};
	Vector4_NormalUnsafe3(): Vector4;
	Vector4_Set(X?: number,Y?: number,Z?: number,W?: number): {A: Vector4};
	Vector4_Size(): number;
	Vector4_Size3(): number;
	Vector4_SizeSquared(): number;
	Vector4_SizeSquared3(): number;
	static Add_Vector4Vector4(A: Vector4,B: Vector4): Vector4;
	static BreakVector4(InVec: Vector4,X?: number,Y?: number,Z?: number,W?: number): {X: number, Y: number, Z: number, W: number};
	static Conv_Vector4ToQuaternion(InVec: Vector4): Quat;
	static Conv_Vector4ToRotator(InVec: Vector4): Rotator;
	static Conv_Vector4ToVector(InVector4: Vector4): Vector;
	static Divide_Vector4Vector4(A: Vector4,B: Vector4): Vector4;
	static EqualEqual_Vector4Vector4(A: Vector4,B: Vector4,ErrorTolerance: number): boolean;
	static EqualExactly_Vector4Vector4(A: Vector4,B: Vector4): boolean;
	static Multiply_Vector4Vector4(A: Vector4,B: Vector4): Vector4;
	static NotEqual_Vector4Vector4(A: Vector4,B: Vector4,ErrorTolerance: number): boolean;
	static NotEqualExactly_Vector4Vector4(A: Vector4,B: Vector4): boolean;
	static Subtract_Vector4Vector4(A: Vector4,B: Vector4): Vector4;
	static Vector4_Assign(A?: Vector4,InVector?: Vector4): {A: Vector4};
	static Vector4_CrossProduct3(A: Vector4,B: Vector4): Vector4;
	static Vector4_DotProduct(A: Vector4,B: Vector4): number;
	static Vector4_DotProduct3(A: Vector4,B: Vector4): number;
	static Vector4_IsNAN(A: Vector4): boolean;
	static Vector4_IsNearlyZero3(A: Vector4,Tolerance: number): boolean;
	static Vector4_IsNormal3(A: Vector4): boolean;
	static Vector4_IsUnit3(A: Vector4,SquaredLenthTolerance: number): boolean;
	static Vector4_IsZero(A: Vector4): boolean;
	static Vector4_MirrorByVector3(Direction: Vector4,SurfaceNormal: Vector4): Vector4;
	static Vector4_Negated(A: Vector4): Vector4;
	static Vector4_Normal3(A: Vector4,Tolerance: number): Vector4;
	static Vector4_Normalize3(A?: Vector4,Tolerance?: number): {A: Vector4};
	static Vector4_NormalUnsafe3(A: Vector4): Vector4;
	static Vector4_Set(A?: Vector4,X?: number,Y?: number,Z?: number,W?: number): {A: Vector4};
	static Vector4_Size(A: Vector4): number;
	static Vector4_Size3(A: Vector4): number;
	static Vector4_SizeSquared(A: Vector4): number;
	static Vector4_SizeSquared3(A: Vector4): number;
	static MakeVector4(X: number,Y: number,Z: number,W: number): Vector4;
	static Vector4_Zero(): Vector4;
}

declare class Matrix { 
	XPlane: Plane;
	YPlane: Plane;
	ZPlane: Plane;
	WPlane: Plane;
	clone() : Matrix;
	static C(Other: UObject | any): Matrix;
	Conv_MatrixToString(): string;
	Add_MatrixMatrix(B: Matrix): Matrix;
	Conv_MatrixToRotator(): Rotator;
	Conv_MatrixToTransform(): Transform;
	EqualEqual_MatrixMatrix(B: Matrix,Tolerance: number): boolean;
	Matrix_ApplyScale(Scale: number): Matrix;
	Matrix_ConcatenateTranslation(Translation: Vector): Matrix;
	Matrix_ContainsNaN(): boolean;
	Matrix_GetColumn(Column: EMatrixColumns): Vector;
	Matrix_GetDeterminant(): number;
	Matrix_GetFrustumBottomPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetFrustumFarPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetFrustumLeftPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetFrustumNearPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetFrustumRightPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetFrustumTopPlane(OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	Matrix_GetInverse(): Matrix;
	Matrix_GetMatrixWithoutScale(Tolerance: number): Matrix;
	Matrix_GetMaximumAxisScale(): number;
	Matrix_GetOrigin(): Vector;
	Matrix_GetRotator(): Rotator;
	Matrix_GetRotDeterminant(): number;
	Matrix_GetScaledAxes(X?: Vector,Y?: Vector,Z?: Vector): {X: Vector, Y: Vector, Z: Vector};
	Matrix_GetScaledAxis(Axis: EAxis): Vector;
	Matrix_GetScaleVector(Tolerance: number): Vector;
	Matrix_GetTransposeAdjoint(): Matrix;
	Matrix_GetTransposed(): Matrix;
	Matrix_GetUnitAxes(X?: Vector,Y?: Vector,Z?: Vector): {X: Vector, Y: Vector, Z: Vector};
	Matrix_GetUnitAxis(Axis: EAxis): Vector;
	Matrix_InverseTransformPosition(V: Vector): Vector;
	Matrix_InverseTransformVector(V: Vector): Vector;
	Matrix_Mirror(MirrorAxis: EAxis,FlipAxis: EAxis): Matrix;
	Matrix_RemoveScaling(Tolerance?: number): {M: Matrix};
	Matrix_RemoveTranslation(): Matrix;
	Matrix_ScaleTranslation(Scale3D: Vector): Matrix;
	Matrix_SetAxis(Axis?: EAxis,AxisVector?: Vector): {M: Matrix};
	Matrix_SetColumn(Column?: EMatrixColumns,Value?: Vector): {M: Matrix};
	Matrix_SetOrigin(NewOrigin?: Vector): {M: Matrix};
	Matrix_ToQuat(): Quat;
	Matrix_TransformPosition(V: Vector): Vector4;
	Matrix_TransformVector(V: Vector): Vector4;
	Matrix_TransformVector4(V: Vector4): Vector4;
	Multiply_MatrixFloat(B: number): Matrix;
	Multiply_MatrixMatrix(B: Matrix): Matrix;
	NotEqual_MatrixMatrix(B: Matrix,Tolerance: number): boolean;
	TransformVector4(Vec4: Vector4): Vector4;
	static Conv_MatrixToString(InMatrix: Matrix): string;
	static Add_MatrixMatrix(A: Matrix,B: Matrix): Matrix;
	static Conv_MatrixToRotator(InMatrix: Matrix): Rotator;
	static Conv_MatrixToTransform(InMatrix: Matrix): Transform;
	static EqualEqual_MatrixMatrix(A: Matrix,B: Matrix,Tolerance: number): boolean;
	static Matrix_ApplyScale(M: Matrix,Scale: number): Matrix;
	static Matrix_ConcatenateTranslation(M: Matrix,Translation: Vector): Matrix;
	static Matrix_ContainsNaN(M: Matrix): boolean;
	static Matrix_GetColumn(M: Matrix,Column: EMatrixColumns): Vector;
	static Matrix_GetDeterminant(M: Matrix): number;
	static Matrix_GetFrustumBottomPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetFrustumFarPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetFrustumLeftPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetFrustumNearPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetFrustumRightPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetFrustumTopPlane(M: Matrix,OutPlane?: Plane): {OutPlane: Plane, $: boolean};
	static Matrix_GetInverse(M: Matrix): Matrix;
	static Matrix_GetMatrixWithoutScale(M: Matrix,Tolerance: number): Matrix;
	static Matrix_GetMaximumAxisScale(M: Matrix): number;
	static Matrix_GetOrigin(InMatrix: Matrix): Vector;
	static Matrix_GetRotator(M: Matrix): Rotator;
	static Matrix_GetRotDeterminant(M: Matrix): number;
	static Matrix_GetScaledAxes(M: Matrix,X?: Vector,Y?: Vector,Z?: Vector): {X: Vector, Y: Vector, Z: Vector};
	static Matrix_GetScaledAxis(M: Matrix,Axis: EAxis): Vector;
	static Matrix_GetScaleVector(M: Matrix,Tolerance: number): Vector;
	static Matrix_GetTransposeAdjoint(M: Matrix): Matrix;
	static Matrix_GetTransposed(M: Matrix): Matrix;
	static Matrix_GetUnitAxes(M: Matrix,X?: Vector,Y?: Vector,Z?: Vector): {X: Vector, Y: Vector, Z: Vector};
	static Matrix_GetUnitAxis(M: Matrix,Axis: EAxis): Vector;
	static Matrix_InverseTransformPosition(M: Matrix,V: Vector): Vector;
	static Matrix_InverseTransformVector(M: Matrix,V: Vector): Vector;
	static Matrix_Mirror(M: Matrix,MirrorAxis: EAxis,FlipAxis: EAxis): Matrix;
	static Matrix_RemoveScaling(M?: Matrix,Tolerance?: number): {M: Matrix};
	static Matrix_RemoveTranslation(M: Matrix): Matrix;
	static Matrix_ScaleTranslation(M: Matrix,Scale3D: Vector): Matrix;
	static Matrix_SetAxis(M?: Matrix,Axis?: EAxis,AxisVector?: Vector): {M: Matrix};
	static Matrix_SetColumn(M?: Matrix,Column?: EMatrixColumns,Value?: Vector): {M: Matrix};
	static Matrix_SetOrigin(M?: Matrix,NewOrigin?: Vector): {M: Matrix};
	static Matrix_ToQuat(M: Matrix): Quat;
	static Matrix_TransformPosition(M: Matrix,V: Vector): Vector4;
	static Matrix_TransformVector(M: Matrix,V: Vector): Vector4;
	static Matrix_TransformVector4(M: Matrix,V: Vector4): Vector4;
	static Multiply_MatrixFloat(A: Matrix,B: number): Matrix;
	static Multiply_MatrixMatrix(A: Matrix,B: Matrix): Matrix;
	static NotEqual_MatrixMatrix(A: Matrix,B: Matrix,Tolerance: number): boolean;
	static TransformVector4(Matrix: Matrix,Vec4: Vector4): Vector4;
	static Matrix_Identity(): Matrix;
}

declare type EEasingFunc = 'Linear' | 'Step' | 'SinusoidalIn' | 'SinusoidalOut' | 'SinusoidalInOut' | 'EaseIn' | 'EaseOut' | 'EaseInOut' | 'ExpoIn' | 'ExpoOut' | 'ExpoInOut' | 'CircularIn' | 'CircularOut' | 'CircularInOut' | 'EEasingFunc_MAX';
declare var EEasingFunc : { Linear:'Linear',Step:'Step',SinusoidalIn:'SinusoidalIn',SinusoidalOut:'SinusoidalOut',SinusoidalInOut:'SinusoidalInOut',EaseIn:'EaseIn',EaseOut:'EaseOut',EaseInOut:'EaseInOut',ExpoIn:'ExpoIn',ExpoOut:'ExpoOut',ExpoInOut:'ExpoInOut',CircularIn:'CircularIn',CircularOut:'CircularOut',CircularInOut:'CircularInOut',EEasingFunc_MAX:'EEasingFunc_MAX', };
declare type ELerpInterpolationMode = 'QuatInterp' | 'EulerInterp' | 'DualQuatInterp' | 'ELerpInterpolationMode_MAX';
declare var ELerpInterpolationMode : { QuatInterp:'QuatInterp',EulerInterp:'EulerInterp',DualQuatInterp:'DualQuatInterp',ELerpInterpolationMode_MAX:'ELerpInterpolationMode_MAX', };
declare class IntPoint { 
	X: number;
	Y: number;
	clone() : IntPoint;
	static C(Other: UObject | any): IntPoint;
	Conv_IntPointToString(): string;
	Add_IntPointInt(B: number): IntPoint;
	Add_IntPointIntPoint(B: IntPoint): IntPoint;
	Conv_IntPointToVector2D(): Vector2D;
	Divide_IntPointInt(B: number): IntPoint;
	Divide_IntPointIntPoint(B: IntPoint): IntPoint;
	Equal_IntPointIntPoint(B: IntPoint): boolean;
	Multiply_IntPointInt(B: number): IntPoint;
	Multiply_IntPointIntPoint(B: IntPoint): IntPoint;
	NotEqual_IntPointIntPoint(B: IntPoint): boolean;
	Subtract_IntPointInt(B: number): IntPoint;
	Subtract_IntPointIntPoint(B: IntPoint): IntPoint;
	ResizeXRCamera(): IntPoint;
	static Conv_IntPointToString(InIntPoint: IntPoint): string;
	static Add_IntPointInt(A: IntPoint,B: number): IntPoint;
	static Add_IntPointIntPoint(A: IntPoint,B: IntPoint): IntPoint;
	static Conv_IntPointToVector2D(InIntPoint: IntPoint): Vector2D;
	static Divide_IntPointInt(A: IntPoint,B: number): IntPoint;
	static Divide_IntPointIntPoint(A: IntPoint,B: IntPoint): IntPoint;
	static Equal_IntPointIntPoint(A: IntPoint,B: IntPoint): boolean;
	static Multiply_IntPointInt(A: IntPoint,B: number): IntPoint;
	static Multiply_IntPointIntPoint(A: IntPoint,B: IntPoint): IntPoint;
	static NotEqual_IntPointIntPoint(A: IntPoint,B: IntPoint): boolean;
	static Subtract_IntPointInt(A: IntPoint,B: number): IntPoint;
	static Subtract_IntPointIntPoint(A: IntPoint,B: IntPoint): IntPoint;
	static ResizeXRCamera(InSize: IntPoint): IntPoint;
	static IntPoint_Down(): IntPoint;
	static IntPoint_Left(): IntPoint;
	static IntPoint_One(): IntPoint;
	static IntPoint_Right(): IntPoint;
	static IntPoint_Up(): IntPoint;
	static IntPoint_Zero(): IntPoint;
}

declare class Box2D { 
	Min: Vector2D;
	Max: Vector2D;
	bIsValid: number;
	clone() : Box2D;
	static C(Other: UObject | any): Box2D;
}

declare type EARLineTraceChannels = 'None' | 'FeaturePoint' | 'GroundPlane' | 'PlaneUsingExtent' | 'PlaneUsingBoundaryPolygon' | 'EARLineTraceChannels_MAX';
declare var EARLineTraceChannels : { None:'None',FeaturePoint:'FeaturePoint',GroundPlane:'GroundPlane',PlaneUsingExtent:'PlaneUsingExtent',PlaneUsingBoundaryPolygon:'PlaneUsingBoundaryPolygon',EARLineTraceChannels_MAX:'EARLineTraceChannels_MAX', };
declare type EARTrackingState = 'Unknown' | 'Tracking' | 'NotTracking' | 'StoppedTracking' | 'EARTrackingState_MAX';
declare var EARTrackingState : { Unknown:'Unknown',Tracking:'Tracking',NotTracking:'NotTracking',StoppedTracking:'StoppedTracking',EARTrackingState_MAX:'EARTrackingState_MAX', };
declare type EBrushType = 'Brush_Default' | 'Brush_Add' | 'Brush_Subtract' | 'Brush_MAX';
declare var EBrushType : { Brush_Default:'Brush_Default',Brush_Add:'Brush_Add',Brush_Subtract:'Brush_Subtract',Brush_MAX:'Brush_MAX', };
declare class LinearColor { 
	R: number;
	G: number;
	B: number;
	A: number;
	clone() : LinearColor;
	static C(Other: UObject | any): LinearColor;
	Conv_ColorToString(): string;
	Add_LinearColorLinearColor(B: LinearColor): LinearColor;
	BreakColor(R?: number,G?: number,B?: number,A?: number): {R: number, G: number, B: number, A: number};
	CInterpTo(Target: LinearColor,DeltaTime: number,InterpSpeed: number): LinearColor;
	Conv_LinearColorToColor(InUseSRGB: boolean): Color;
	Conv_LinearColorToVector(): Vector;
	Divide_LinearColorLinearColor(B: LinearColor): LinearColor;
	EqualEqual_LinearColorLinearColor(B: LinearColor): boolean;
	HSVToRGB_Vector(rgb?: LinearColor): {rgb: LinearColor};
	HSVToRGBLinear(): LinearColor;
	LinearColor_Desaturated(InDesaturation: number): LinearColor;
	LinearColor_Distance(C2: LinearColor): number;
	LinearColor_GetLuminance(): number;
	LinearColor_GetMax(): number;
	LinearColor_GetMin(): number;
	LinearColor_IsNearEqual(B: LinearColor,Tolerance: number): boolean;
	LinearColor_Quantize(): Color;
	LinearColor_QuantizeRound(): Color;
	LinearColor_Set(InColor?: LinearColor): {InOutColor: LinearColor};
	LinearColor_SetFromHSV(H?: number,S?: number,V?: number,A?: number): {InOutColor: LinearColor};
	LinearColor_SetFromPow22(InColor?: Color): {InOutColor: LinearColor};
	LinearColor_SetFromSRGB(InSRGB?: Color): {InOutColor: LinearColor};
	LinearColor_SetRandomHue(): {InOutColor: LinearColor};
	LinearColor_SetRGBA(R?: number,G?: number,B?: number,A?: number): {InOutColor: LinearColor};
	LinearColor_SetTemperature(InTemperature?: number): {InOutColor: LinearColor};
	LinearColor_ToNewOpacity(InOpacity: number): LinearColor;
	LinearColor_ToRGBE(): Color;
	LinearColorLerp(B: LinearColor,Alpha: number): LinearColor;
	LinearColorLerpUsingHSV(B: LinearColor,Alpha: number): LinearColor;
	Multiply_LinearColorFloat(B: number): LinearColor;
	Multiply_LinearColorLinearColor(B: LinearColor): LinearColor;
	NotEqual_LinearColorLinearColor(B: LinearColor): boolean;
	RGBLinearToHSV(): LinearColor;
	RGBToHSV(H?: number,S?: number,V?: number,A?: number): {H: number, S: number, V: number, A: number};
	RGBToHSV_Vector(HSV?: LinearColor): {HSV: LinearColor};
	SelectColor(B: LinearColor,bPickA: boolean): LinearColor;
	Subtract_LinearColorLinearColor(B: LinearColor): LinearColor;
	Conv_ColorToText(): string;
	static Conv_ColorToString(InColor: LinearColor): string;
	static Add_LinearColorLinearColor(A: LinearColor,B: LinearColor): LinearColor;
	static BreakColor(InColor: LinearColor,R?: number,G?: number,B?: number,A?: number): {R: number, G: number, B: number, A: number};
	static CInterpTo(Current: LinearColor,Target: LinearColor,DeltaTime: number,InterpSpeed: number): LinearColor;
	static Conv_LinearColorToColor(InLinearColor: LinearColor,InUseSRGB: boolean): Color;
	static Conv_LinearColorToVector(InLinearColor: LinearColor): Vector;
	static Divide_LinearColorLinearColor(A: LinearColor,B: LinearColor): LinearColor;
	static EqualEqual_LinearColorLinearColor(A: LinearColor,B: LinearColor): boolean;
	static HSVToRGB_Vector(HSV: LinearColor,rgb?: LinearColor): {rgb: LinearColor};
	static HSVToRGBLinear(HSV: LinearColor): LinearColor;
	static LinearColor_Desaturated(InColor: LinearColor,InDesaturation: number): LinearColor;
	static LinearColor_Distance(C1: LinearColor,C2: LinearColor): number;
	static LinearColor_GetLuminance(InColor: LinearColor): number;
	static LinearColor_GetMax(InColor: LinearColor): number;
	static LinearColor_GetMin(InColor: LinearColor): number;
	static LinearColor_IsNearEqual(A: LinearColor,B: LinearColor,Tolerance: number): boolean;
	static LinearColor_Quantize(InColor: LinearColor): Color;
	static LinearColor_QuantizeRound(InColor: LinearColor): Color;
	static LinearColor_Set(InOutColor?: LinearColor,InColor?: LinearColor): {InOutColor: LinearColor};
	static LinearColor_SetFromHSV(InOutColor?: LinearColor,H?: number,S?: number,V?: number,A?: number): {InOutColor: LinearColor};
	static LinearColor_SetFromPow22(InOutColor?: LinearColor,InColor?: Color): {InOutColor: LinearColor};
	static LinearColor_SetFromSRGB(InOutColor?: LinearColor,InSRGB?: Color): {InOutColor: LinearColor};
	static LinearColor_SetRandomHue(InOutColor?: LinearColor): {InOutColor: LinearColor};
	static LinearColor_SetRGBA(InOutColor?: LinearColor,R?: number,G?: number,B?: number,A?: number): {InOutColor: LinearColor};
	static LinearColor_SetTemperature(InOutColor?: LinearColor,InTemperature?: number): {InOutColor: LinearColor};
	static LinearColor_ToNewOpacity(InColor: LinearColor,InOpacity: number): LinearColor;
	static LinearColor_ToRGBE(InLinearColor: LinearColor): Color;
	static LinearColorLerp(A: LinearColor,B: LinearColor,Alpha: number): LinearColor;
	static LinearColorLerpUsingHSV(A: LinearColor,B: LinearColor,Alpha: number): LinearColor;
	static Multiply_LinearColorFloat(A: LinearColor,B: number): LinearColor;
	static Multiply_LinearColorLinearColor(A: LinearColor,B: LinearColor): LinearColor;
	static NotEqual_LinearColorLinearColor(A: LinearColor,B: LinearColor): boolean;
	static RGBLinearToHSV(rgb: LinearColor): LinearColor;
	static RGBToHSV(InColor: LinearColor,H?: number,S?: number,V?: number,A?: number): {H: number, S: number, V: number, A: number};
	static RGBToHSV_Vector(rgb: LinearColor,HSV?: LinearColor): {HSV: LinearColor};
	static SelectColor(A: LinearColor,B: LinearColor,bPickA: boolean): LinearColor;
	static Subtract_LinearColorLinearColor(A: LinearColor,B: LinearColor): LinearColor;
	static Conv_ColorToText(InColor: LinearColor): string;
	static Conv_DoubleToLinearColor(InDouble: number): LinearColor;
	static Conv_FloatToLinearColor(InFloat: number): LinearColor;
	static HSVToRGB(H: number,S: number,V: number,A: number): LinearColor;
	static LinearColor_Black(): LinearColor;
	static LinearColor_Blue(): LinearColor;
	static LinearColor_Gray(): LinearColor;
	static LinearColor_Green(): LinearColor;
	static LinearColor_Red(): LinearColor;
	static LinearColor_Transparent(): LinearColor;
	static LinearColor_White(): LinearColor;
	static LinearColor_Yellow(): LinearColor;
	static MakeColor(R: number,G: number,B: number,A: number): LinearColor;
}

declare class Color { 
	B: number;
	G: number;
	R: number;
	A: number;
	clone() : Color;
	static C(Other: UObject | any): Color;
	Conv_ColorToLinearColor(): LinearColor;
	static Conv_ColorToLinearColor(InColor: Color): LinearColor;
}

declare class Model extends UObject { 
	static Load(ResourceName: string): Model;
	static Find(Outer: UObject, ResourceName: string): Model;
	static GetDefaultObject(): Model;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Model;
	static C(Other: UObject | any): Model;
}

declare type EPhysicsType = 'PhysType_Default' | 'PhysType_Kinematic' | 'PhysType_Simulated' | 'PhysType_MAX';
declare var EPhysicsType : { PhysType_Default:'PhysType_Default',PhysType_Kinematic:'PhysType_Kinematic',PhysType_Simulated:'PhysType_Simulated',PhysType_MAX:'PhysType_MAX', };
declare type ECollisionTraceFlag = 'CTF_UseDefault' | 'CTF_UseSimpleAndComplex' | 'CTF_UseSimpleAsComplex' | 'CTF_UseComplexAsSimple' | 'CTF_MAX';
declare var ECollisionTraceFlag : { CTF_UseDefault:'CTF_UseDefault',CTF_UseSimpleAndComplex:'CTF_UseSimpleAndComplex',CTF_UseSimpleAsComplex:'CTF_UseSimpleAsComplex',CTF_UseComplexAsSimple:'CTF_UseComplexAsSimple',CTF_MAX:'CTF_MAX', };
declare type EBodyCollisionResponse = 'BodyCollision_Enabled' | 'BodyCollision_Disabled' | 'BodyCollision_MAX';
declare var EBodyCollisionResponse : { BodyCollision_Enabled:'BodyCollision_Enabled',BodyCollision_Disabled:'BodyCollision_Disabled',BodyCollision_MAX:'BodyCollision_MAX', };
declare class BodySetupCore extends UObject { 
	BoneName: string;
	PhysicsType: EPhysicsType;
	CollisionTraceFlag: ECollisionTraceFlag;
	CollisionReponse: EBodyCollisionResponse;
	static Load(ResourceName: string): BodySetupCore;
	static Find(Outer: UObject, ResourceName: string): BodySetupCore;
	static GetDefaultObject(): BodySetupCore;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BodySetupCore;
	static C(Other: UObject | any): BodySetupCore;
}

declare type ECollisionEnabled = 'NoCollision' | 'QueryOnly' | 'PhysicsOnly' | 'QueryAndPhysics' | 'ProbeOnly' | 'QueryAndProbe' | 'ECollisionEnabled_MAX';
declare var ECollisionEnabled : { NoCollision:'NoCollision',QueryOnly:'QueryOnly',PhysicsOnly:'PhysicsOnly',QueryAndPhysics:'QueryAndPhysics',ProbeOnly:'ProbeOnly',QueryAndProbe:'QueryAndProbe',ECollisionEnabled_MAX:'ECollisionEnabled_MAX', };
declare class KShapeElem { 
	RestOffset: number;
	bIsGenerated: boolean;
	Name: string;
	bContributeToMass: boolean;
	CollisionEnabled: ECollisionEnabled;
	clone() : KShapeElem;
	static C(Other: UObject | any): KShapeElem;
}

declare class KSphereElem extends KShapeElem { 
	TM: Matrix;
	Center: Vector;
	Radius: number;
	clone() : KSphereElem;
	static C(Other: UObject | any): KSphereElem;
}

declare class KBoxElem extends KShapeElem { 
	TM: Matrix;
	Orientation: Quat;
	Center: Vector;
	Rotation: Rotator;
	X: number;
	Y: number;
	Z: number;
	clone() : KBoxElem;
	static C(Other: UObject | any): KBoxElem;
}

declare class KSphylElem extends KShapeElem { 
	TM: Matrix;
	Orientation: Quat;
	Center: Vector;
	Rotation: Rotator;
	Radius: number;
	Length: number;
	clone() : KSphylElem;
	static C(Other: UObject | any): KSphylElem;
}

declare class TopLevelAssetPath { 
	PackageName: string;
	AssetName: string;
	clone() : TopLevelAssetPath;
	static C(Other: UObject | any): TopLevelAssetPath;
}

declare class SoftObjectPath { 
	AssetPath: TopLevelAssetPath;
	SubPathString: string;
	clone() : SoftObjectPath;
	static C(Other: UObject | any): SoftObjectPath;
	BreakSoftObjectPath(PathString?: string): {PathString: string};
	Conv_SoftObjPathToSoftObjRef(): UObject;
	static BreakSoftObjectPath(InSoftObjectPath: SoftObjectPath,PathString?: string): {PathString: string};
	static Conv_SoftObjPathToSoftObjRef(SoftObjectPath: SoftObjectPath): UObject;
	static MakeSoftObjectPath(PathString: string): SoftObjectPath;
}

declare class ActorDesc { 
	Guid: Guid;
	Class: SoftObjectPath;
	Name: string;
	Label: string;
	Bounds: Box;
	RuntimeGrid: string;
	bIsSpatiallyLoaded: boolean;
	bActorIsEditorOnly: boolean;
	ActorPackage: string;
	ActorPath: string;
	clone() : ActorDesc;
	static C(Other: UObject | any): ActorDesc;
}

declare class RandomStream { 
	InitialSeed: number;
	Seed: number;
	clone() : RandomStream;
	static C(Other: UObject | any): RandomStream;
	BreakRandomStream(InitialSeed?: number): {InitialSeed: number};
	RandomBoolFromStream(): boolean;
	RandomFloatFromStream(): number;
	RandomUnitVectorFromStream(): Vector;
	ResetRandomStream(): void;
	SeedRandomStream(): {Stream: RandomStream};
	SetRandomStreamSeed(NewSeed?: number): {Stream: RandomStream};
	static BreakRandomStream(InRandomStream: RandomStream,InitialSeed?: number): {InitialSeed: number};
	static RandomBoolFromStream(Stream: RandomStream): boolean;
	static RandomFloatFromStream(Stream: RandomStream): number;
	static RandomUnitVectorFromStream(Stream: RandomStream): Vector;
	static ResetRandomStream(Stream: RandomStream): void;
	static SeedRandomStream(Stream?: RandomStream): {Stream: RandomStream};
	static SetRandomStreamSeed(Stream?: RandomStream,NewSeed?: number): {Stream: RandomStream};
	static MakeRandomStream(InitialSeed: number): RandomStream;
}

declare class Box { 
	Min: Vector;
	Max: Vector;
	IsValid: number;
	clone() : Box;
	static C(Other: UObject | any): Box;
	GetIntersectingActorDescs(OutActorDescs?: ActorDesc[]): {OutActorDescs: ActorDesc[], $: boolean};
	RandomPointInBoundingBox_Box(): Vector;
	RandomPointInBoundingBoxFromStream_Box(Stream: RandomStream): Vector;
	static GetIntersectingActorDescs(InBox: Box,OutActorDescs?: ActorDesc[]): {OutActorDescs: ActorDesc[], $: boolean};
	static RandomPointInBoundingBox_Box(Box: Box): Vector;
	static RandomPointInBoundingBoxFromStream_Box(Box: Box,Stream: RandomStream): Vector;
	static GetEditorWorldBounds(): Box;
	static GetRuntimeWorldBounds(): Box;
}

declare class KConvexElem extends KShapeElem { 
	VertexData: Vector[];
	IndexData: number[];
	ElemBox: Box;
	Transform: Transform;
	clone() : KConvexElem;
	static C(Other: UObject | any): KConvexElem;
}

declare class KTaperedCapsuleElem extends KShapeElem { 
	Center: Vector;
	Rotation: Rotator;
	Radius0: number;
	Radius1: number;
	Length: number;
	clone() : KTaperedCapsuleElem;
	static C(Other: UObject | any): KTaperedCapsuleElem;
}

declare class KLevelSetElem extends KShapeElem { 
	Transform: Transform;
	clone() : KLevelSetElem;
	static C(Other: UObject | any): KLevelSetElem;
}

declare class KAggregateGeom { 
	SphereElems: KSphereElem[];
	BoxElems: KBoxElem[];
	SphylElems: KSphylElem[];
	ConvexElems: KConvexElem[];
	TaperedCapsuleElems: KTaperedCapsuleElem[];
	LevelSetElems: KLevelSetElem[];
	clone() : KAggregateGeom;
	static C(Other: UObject | any): KAggregateGeom;
}

declare type EFrictionCombineMode = 'Average' | 'Min' | 'Multiply' | 'Max' | 'EFrictionCombineMode_MAX';
declare var EFrictionCombineMode : { Average:'Average',Min:'Min',Multiply:'Multiply',Max:'Max',EFrictionCombineMode_MAX:'EFrictionCombineMode_MAX', };
declare class PhysicalMaterialPropertyBase extends UObject { 
	static Load(ResourceName: string): PhysicalMaterialPropertyBase;
	static Find(Outer: UObject, ResourceName: string): PhysicalMaterialPropertyBase;
	static GetDefaultObject(): PhysicalMaterialPropertyBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicalMaterialPropertyBase;
	static C(Other: UObject | any): PhysicalMaterialPropertyBase;
}

declare type EPhysicalSurface = 'SurfaceType_Default' | 'SurfaceType1' | 'SurfaceType2' | 'SurfaceType3' | 'SurfaceType4' | 'SurfaceType5' | 'SurfaceType6' | 'SurfaceType7' | 'SurfaceType8' | 'SurfaceType9' | 'SurfaceType10' | 'SurfaceType11' | 'SurfaceType12' | 'SurfaceType13' | 'SurfaceType14' | 'SurfaceType15' | 'SurfaceType16' | 'SurfaceType17' | 'SurfaceType18' | 'SurfaceType19' | 'SurfaceType20' | 'SurfaceType21' | 'SurfaceType22' | 'SurfaceType23' | 'SurfaceType24' | 'SurfaceType25' | 'SurfaceType26' | 'SurfaceType27' | 'SurfaceType28' | 'SurfaceType29' | 'SurfaceType30' | 'SurfaceType31' | 'SurfaceType32' | 'SurfaceType33' | 'SurfaceType34' | 'SurfaceType35' | 'SurfaceType36' | 'SurfaceType37' | 'SurfaceType38' | 'SurfaceType39' | 'SurfaceType40' | 'SurfaceType41' | 'SurfaceType42' | 'SurfaceType43' | 'SurfaceType44' | 'SurfaceType45' | 'SurfaceType46' | 'SurfaceType47' | 'SurfaceType48' | 'SurfaceType49' | 'SurfaceType50' | 'SurfaceType51' | 'SurfaceType52' | 'SurfaceType53' | 'SurfaceType54' | 'SurfaceType55' | 'SurfaceType56' | 'SurfaceType57' | 'SurfaceType58' | 'SurfaceType59' | 'SurfaceType60' | 'SurfaceType61' | 'SurfaceType62' | 'SurfaceType_Max' | 'EPhysicalSurface_MAX';
declare var EPhysicalSurface : { SurfaceType_Default:'SurfaceType_Default',SurfaceType1:'SurfaceType1',SurfaceType2:'SurfaceType2',SurfaceType3:'SurfaceType3',SurfaceType4:'SurfaceType4',SurfaceType5:'SurfaceType5',SurfaceType6:'SurfaceType6',SurfaceType7:'SurfaceType7',SurfaceType8:'SurfaceType8',SurfaceType9:'SurfaceType9',SurfaceType10:'SurfaceType10',SurfaceType11:'SurfaceType11',SurfaceType12:'SurfaceType12',SurfaceType13:'SurfaceType13',SurfaceType14:'SurfaceType14',SurfaceType15:'SurfaceType15',SurfaceType16:'SurfaceType16',SurfaceType17:'SurfaceType17',SurfaceType18:'SurfaceType18',SurfaceType19:'SurfaceType19',SurfaceType20:'SurfaceType20',SurfaceType21:'SurfaceType21',SurfaceType22:'SurfaceType22',SurfaceType23:'SurfaceType23',SurfaceType24:'SurfaceType24',SurfaceType25:'SurfaceType25',SurfaceType26:'SurfaceType26',SurfaceType27:'SurfaceType27',SurfaceType28:'SurfaceType28',SurfaceType29:'SurfaceType29',SurfaceType30:'SurfaceType30',SurfaceType31:'SurfaceType31',SurfaceType32:'SurfaceType32',SurfaceType33:'SurfaceType33',SurfaceType34:'SurfaceType34',SurfaceType35:'SurfaceType35',SurfaceType36:'SurfaceType36',SurfaceType37:'SurfaceType37',SurfaceType38:'SurfaceType38',SurfaceType39:'SurfaceType39',SurfaceType40:'SurfaceType40',SurfaceType41:'SurfaceType41',SurfaceType42:'SurfaceType42',SurfaceType43:'SurfaceType43',SurfaceType44:'SurfaceType44',SurfaceType45:'SurfaceType45',SurfaceType46:'SurfaceType46',SurfaceType47:'SurfaceType47',SurfaceType48:'SurfaceType48',SurfaceType49:'SurfaceType49',SurfaceType50:'SurfaceType50',SurfaceType51:'SurfaceType51',SurfaceType52:'SurfaceType52',SurfaceType53:'SurfaceType53',SurfaceType54:'SurfaceType54',SurfaceType55:'SurfaceType55',SurfaceType56:'SurfaceType56',SurfaceType57:'SurfaceType57',SurfaceType58:'SurfaceType58',SurfaceType59:'SurfaceType59',SurfaceType60:'SurfaceType60',SurfaceType61:'SurfaceType61',SurfaceType62:'SurfaceType62',SurfaceType_Max:'SurfaceType_Max',EPhysicalSurface_MAX:'EPhysicalSurface_MAX', };
declare class PhysicalMaterial extends UObject { 
	Friction: number;
	StaticFriction: number;
	FrictionCombineMode: EFrictionCombineMode;
	bOverrideFrictionCombineMode: boolean;
	Restitution: number;
	RestitutionCombineMode: EFrictionCombineMode;
	bOverrideRestitutionCombineMode: boolean;
	Density: number;
	SleepLinearVelocityThreshold: number;
	SleepAngularVelocityThreshold: number;
	SleepCounterThreshold: number;
	RaiseMassToPower: number;
	DestructibleDamageThresholdScale: number;
	PhysicalMaterialProperty: PhysicalMaterialPropertyBase;
	SurfaceType: EPhysicalSurface;
	static Load(ResourceName: string): PhysicalMaterial;
	static Find(Outer: UObject, ResourceName: string): PhysicalMaterial;
	static GetDefaultObject(): PhysicalMaterial;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicalMaterial;
	static C(Other: UObject | any): PhysicalMaterial;
}

declare type EWalkableSlopeBehavior = 'WalkableSlope_Default' | 'WalkableSlope_Increase' | 'WalkableSlope_Decrease' | 'WalkableSlope_Unwalkable' | 'WalkableSlope_Max';
declare var EWalkableSlopeBehavior : { WalkableSlope_Default:'WalkableSlope_Default',WalkableSlope_Increase:'WalkableSlope_Increase',WalkableSlope_Decrease:'WalkableSlope_Decrease',WalkableSlope_Unwalkable:'WalkableSlope_Unwalkable',WalkableSlope_Max:'WalkableSlope_Max', };
declare class WalkableSlopeOverride { 
	WalkableSlopeBehavior: EWalkableSlopeBehavior;
	WalkableSlopeAngle: number;
	clone() : WalkableSlopeOverride;
	static C(Other: UObject | any): WalkableSlopeOverride;
}

declare class BodyInstanceCore { 
	bSimulatePhysics: boolean;
	bOverrideMass: boolean;
	bEnableGravity: boolean;
	bAutoWeld: boolean;
	bStartAwake: boolean;
	bGenerateWakeEvents: boolean;
	bUpdateMassWhenScaleChanges: boolean;
	clone() : BodyInstanceCore;
	static C(Other: UObject | any): BodyInstanceCore;
}

declare type ECollisionChannel = 'ECC_WorldStatic' | 'ECC_WorldDynamic' | 'ECC_Pawn' | 'ECC_Visibility' | 'ECC_Camera' | 'ECC_PhysicsBody' | 'ECC_Vehicle' | 'ECC_Destructible' | 'ECC_EngineTraceChannel1' | 'ECC_EngineTraceChannel2' | 'ECC_EngineTraceChannel3' | 'ECC_EngineTraceChannel4' | 'ECC_EngineTraceChannel5' | 'ECC_EngineTraceChannel6' | 'ECC_GameTraceChannel1' | 'ECC_GameTraceChannel2' | 'ECC_GameTraceChannel3' | 'ECC_GameTraceChannel4' | 'ECC_GameTraceChannel5' | 'ECC_GameTraceChannel6' | 'ECC_GameTraceChannel7' | 'ECC_GameTraceChannel8' | 'ECC_GameTraceChannel9' | 'ECC_GameTraceChannel10' | 'ECC_GameTraceChannel11' | 'ECC_GameTraceChannel12' | 'ECC_GameTraceChannel13' | 'ECC_GameTraceChannel14' | 'ECC_GameTraceChannel15' | 'ECC_GameTraceChannel16' | 'ECC_GameTraceChannel17' | 'ECC_GameTraceChannel18' | 'ECC_OverlapAll_Deprecated' | 'ECC_MAX';
declare var ECollisionChannel : { ECC_WorldStatic:'ECC_WorldStatic',ECC_WorldDynamic:'ECC_WorldDynamic',ECC_Pawn:'ECC_Pawn',ECC_Visibility:'ECC_Visibility',ECC_Camera:'ECC_Camera',ECC_PhysicsBody:'ECC_PhysicsBody',ECC_Vehicle:'ECC_Vehicle',ECC_Destructible:'ECC_Destructible',ECC_EngineTraceChannel1:'ECC_EngineTraceChannel1',ECC_EngineTraceChannel2:'ECC_EngineTraceChannel2',ECC_EngineTraceChannel3:'ECC_EngineTraceChannel3',ECC_EngineTraceChannel4:'ECC_EngineTraceChannel4',ECC_EngineTraceChannel5:'ECC_EngineTraceChannel5',ECC_EngineTraceChannel6:'ECC_EngineTraceChannel6',ECC_GameTraceChannel1:'ECC_GameTraceChannel1',ECC_GameTraceChannel2:'ECC_GameTraceChannel2',ECC_GameTraceChannel3:'ECC_GameTraceChannel3',ECC_GameTraceChannel4:'ECC_GameTraceChannel4',ECC_GameTraceChannel5:'ECC_GameTraceChannel5',ECC_GameTraceChannel6:'ECC_GameTraceChannel6',ECC_GameTraceChannel7:'ECC_GameTraceChannel7',ECC_GameTraceChannel8:'ECC_GameTraceChannel8',ECC_GameTraceChannel9:'ECC_GameTraceChannel9',ECC_GameTraceChannel10:'ECC_GameTraceChannel10',ECC_GameTraceChannel11:'ECC_GameTraceChannel11',ECC_GameTraceChannel12:'ECC_GameTraceChannel12',ECC_GameTraceChannel13:'ECC_GameTraceChannel13',ECC_GameTraceChannel14:'ECC_GameTraceChannel14',ECC_GameTraceChannel15:'ECC_GameTraceChannel15',ECC_GameTraceChannel16:'ECC_GameTraceChannel16',ECC_GameTraceChannel17:'ECC_GameTraceChannel17',ECC_GameTraceChannel18:'ECC_GameTraceChannel18',ECC_OverlapAll_Deprecated:'ECC_OverlapAll_Deprecated',ECC_MAX:'ECC_MAX', };
declare type ESleepFamily = 'Normal' | 'Sensitive' | 'Custom' | 'ESleepFamily_MAX';
declare var ESleepFamily : { Normal:'Normal',Sensitive:'Sensitive',Custom:'Custom',ESleepFamily_MAX:'ESleepFamily_MAX', };
declare type EDOFMode = 'Default' | 'SixDOF' | 'YZPlane' | 'XZPlane' | 'XYPlane' | 'CustomPlane' | 'None' | 'EDOFMode_MAX';
declare var EDOFMode : { Default:'Default',SixDOF:'SixDOF',YZPlane:'YZPlane',XZPlane:'XZPlane',XYPlane:'XYPlane',CustomPlane:'CustomPlane',None:'None',EDOFMode_MAX:'EDOFMode_MAX', };
declare type ECollisionResponse = 'ECR_Ignore' | 'ECR_Overlap' | 'ECR_Block' | 'ECR_MAX';
declare var ECollisionResponse : { ECR_Ignore:'ECR_Ignore',ECR_Overlap:'ECR_Overlap',ECR_Block:'ECR_Block',ECR_MAX:'ECR_MAX', };
declare class CollisionResponseContainer { 
	WorldStatic: ECollisionResponse;
	WorldDynamic: ECollisionResponse;
	Pawn: ECollisionResponse;
	Visibility: ECollisionResponse;
	Camera: ECollisionResponse;
	PhysicsBody: ECollisionResponse;
	Vehicle: ECollisionResponse;
	Destructible: ECollisionResponse;
	EngineTraceChannel1: ECollisionResponse;
	EngineTraceChannel2: ECollisionResponse;
	EngineTraceChannel3: ECollisionResponse;
	EngineTraceChannel4: ECollisionResponse;
	EngineTraceChannel5: ECollisionResponse;
	EngineTraceChannel6: ECollisionResponse;
	GameTraceChannel1: ECollisionResponse;
	GameTraceChannel2: ECollisionResponse;
	GameTraceChannel3: ECollisionResponse;
	GameTraceChannel4: ECollisionResponse;
	GameTraceChannel5: ECollisionResponse;
	GameTraceChannel6: ECollisionResponse;
	GameTraceChannel7: ECollisionResponse;
	GameTraceChannel8: ECollisionResponse;
	GameTraceChannel9: ECollisionResponse;
	GameTraceChannel10: ECollisionResponse;
	GameTraceChannel11: ECollisionResponse;
	GameTraceChannel12: ECollisionResponse;
	GameTraceChannel13: ECollisionResponse;
	GameTraceChannel14: ECollisionResponse;
	GameTraceChannel15: ECollisionResponse;
	GameTraceChannel16: ECollisionResponse;
	GameTraceChannel17: ECollisionResponse;
	GameTraceChannel18: ECollisionResponse;
	clone() : CollisionResponseContainer;
	static C(Other: UObject | any): CollisionResponseContainer;
}

declare class ResponseChannel { 
	Channel: string;
	Response: ECollisionResponse;
	clone() : ResponseChannel;
	static C(Other: UObject | any): ResponseChannel;
}

declare class CollisionResponse { 
	ResponseToChannels: CollisionResponseContainer;
	ResponseArray: ResponseChannel[];
	clone() : CollisionResponse;
	static C(Other: UObject | any): CollisionResponse;
}

declare class BodyInstance extends BodyInstanceCore { 
	ObjectType: ECollisionChannel;
	CollisionEnabled: ECollisionEnabled;
	SleepFamily: ESleepFamily;
	DOFMode: EDOFMode;
	bUseCCD: boolean;
	bIgnoreAnalyticCollisions: boolean;
	bNotifyRigidBodyCollision: boolean;
	bSmoothEdgeCollisions: boolean;
	bLockTranslation: boolean;
	bLockRotation: boolean;
	bLockXTranslation: boolean;
	bLockYTranslation: boolean;
	bLockZTranslation: boolean;
	bLockXRotation: boolean;
	bLockYRotation: boolean;
	bLockZRotation: boolean;
	bOverrideMaxAngularVelocity: boolean;
	bOverrideMaxDepenetrationVelocity: boolean;
	bOverrideWalkableSlopeOnInstance: boolean;
	bInterpolateWhenSubStepping: boolean;
	bInertiaConditioning: boolean;
	ResponseToChannels: CollisionResponseContainer;
	CollisionProfileName: string;
	PositionSolverIterationCount: number;
	VelocitySolverIterationCount: number;
	CollisionResponses: CollisionResponse;
	MaxDepenetrationVelocity: number;
	MassInKgOverride: number;
	LinearDamping: number;
	AngularDamping: number;
	CustomDOFPlaneNormal: Vector;
	COMNudge: Vector;
	MassScale: number;
	InertiaTensorScale: Vector;
	WalkableSlopeOverride: WalkableSlopeOverride;
	PhysMaterialOverride: PhysicalMaterial;
	MaxAngularVelocity: number;
	CustomSleepThresholdMultiplier: number;
	StabilizationThresholdMultiplier: number;
	PhysicsBlendWeight: number;
	clone() : BodyInstance;
	static C(Other: UObject | any): BodyInstance;
}

declare class BodySetup extends BodySetupCore { 
	AggGeom: KAggregateGeom;
	bAlwaysFullAnimWeight: boolean;
	bConsiderForBounds: boolean;
	bMeshCollideAll: boolean;
	bDoubleSidedGeometry: boolean;
	bGenerateNonMirroredCollision: boolean;
	bSharedCookedData: boolean;
	bGenerateMirroredCollision: boolean;
	bSupportUVsAndFaceRemap: boolean;
	bNeverNeedsCookedCollisionData: boolean;
	PhysMaterial: PhysicalMaterial;
	WalkableSlopeOverride: WalkableSlopeOverride;
	BuildScale: number;
	DefaultInstance: BodyInstance;
	BuildScale3D: Vector;
	static Load(ResourceName: string): BodySetup;
	static Find(Outer: UObject, ResourceName: string): BodySetup;
	static GetDefaultObject(): BodySetup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BodySetup;
	static C(Other: UObject | any): BodySetup;
}

declare class BrushComponent extends PrimitiveComponent { 
	Brush: Model;
	BrushBodySetup: BodySetup;
	PrePivot: Vector;
	static Load(ResourceName: string): BrushComponent;
	static Find(Outer: UObject, ResourceName: string): BrushComponent;
	static GetDefaultObject(): BrushComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BrushComponent;
	static C(Other: UObject | any): BrushComponent;
}

declare class BuilderPoly { 
	VertexIndices: number[];
	Direction: number;
	ItemName: string;
	PolyFlags: number;
	clone() : BuilderPoly;
	static C(Other: UObject | any): BuilderPoly;
}

declare class LayerActorStats { 
	Type: UnrealEngineClass;
	Total: number;
	clone() : LayerActorStats;
	static C(Other: UObject | any): LayerActorStats;
}

declare class Layer extends UObject { 
	LayerName: string;
	bIsVisible: boolean;
	ActorStats: LayerActorStats[];
	static Load(ResourceName: string): Layer;
	static Find(Outer: UObject, ResourceName: string): Layer;
	static GetDefaultObject(): Layer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Layer;
	static C(Other: UObject | any): Layer;
}

declare class ThumbnailInfo extends UObject { 
	static Load(ResourceName: string): ThumbnailInfo;
	static Find(Outer: UObject, ResourceName: string): ThumbnailInfo;
	static GetDefaultObject(): ThumbnailInfo;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ThumbnailInfo;
	static C(Other: UObject | any): ThumbnailInfo;
}

declare class ModelComponent extends PrimitiveComponent { 
	ModelBodySetup: BodySetup;
	static Load(ResourceName: string): ModelComponent;
	static Find(Outer: UObject, ResourceName: string): ModelComponent;
	static GetDefaultObject(): ModelComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ModelComponent;
	static C(Other: UObject | any): ModelComponent;
}

declare class LevelActorContainer extends UObject { 
	Actors: Actor[];
	static Load(ResourceName: string): LevelActorContainer;
	static Find(Outer: UObject, ResourceName: string): LevelActorContainer;
	static GetDefaultObject(): LevelActorContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelActorContainer;
	static C(Other: UObject | any): LevelActorContainer;
}

declare class LevelScriptBlueprint extends Blueprint { 
	FriendlyName: string;
	static Load(ResourceName: string): LevelScriptBlueprint;
	static Find(Outer: UObject, ResourceName: string): LevelScriptBlueprint;
	static GetDefaultObject(): LevelScriptBlueprint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelScriptBlueprint;
	static C(Other: UObject | any): LevelScriptBlueprint;
}

declare class IntVector { 
	X: number;
	Y: number;
	Z: number;
	clone() : IntVector;
	static C(Other: UObject | any): IntVector;
	Conv_IntVectorToString(): string;
	Conv_IntVectorToVector(): Vector;
	static Conv_IntVectorToString(InIntVec: IntVector): string;
	static Conv_IntVectorToVector(InIntVector: IntVector): Vector;
	static Conv_IntToIntVector(inInt: number): IntVector;
}

declare class LevelScriptActor extends Actor { 
	bInputEnabled: boolean;
	static GetDefaultObject(): LevelScriptActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelScriptActor;
	WorldOriginLocationChanged(OldOriginLocation: IntVector,NewOriginLocation: IntVector): void;
	SetCinematicMode(bCinematicMode: boolean,bHidePlayer: boolean,bAffectsHUD: boolean,bAffectsMovement: boolean,bAffectsTurning: boolean): void;
	RemoteEvent(EventName: string): boolean;
	LevelReset(): void;
	static C(Other: UObject | any): LevelScriptActor;
}

declare class NavAreaBase extends UObject { 
	static Load(ResourceName: string): NavAreaBase;
	static Find(Outer: UObject, ResourceName: string): NavAreaBase;
	static GetDefaultObject(): NavAreaBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavAreaBase;
	static C(Other: UObject | any): NavAreaBase;
}

declare class ShapeComponent extends PrimitiveComponent { 
	ShapeBodySetup: BodySetup;
	AreaClass: UnrealEngineClass;
	ShapeColor: Color;
	bDrawOnlyIfSelected: boolean;
	bShouldCollideWhenPlacing: boolean;
	bDynamicObstacle: boolean;
	AreaClassOverride: UnrealEngineClass;
	bUseSystemDefaultObstacleAreaClass: boolean;
	static Load(ResourceName: string): ShapeComponent;
	static Find(Outer: UObject, ResourceName: string): ShapeComponent;
	static GetDefaultObject(): ShapeComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ShapeComponent;
	static C(Other: UObject | any): ShapeComponent;
}

declare class CapsuleComponent extends ShapeComponent { 
	CapsuleHalfHeight: number;
	CapsuleRadius: number;
	CapsuleHeight: number;
	static Load(ResourceName: string): CapsuleComponent;
	static Find(Outer: UObject, ResourceName: string): CapsuleComponent;
	static GetDefaultObject(): CapsuleComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CapsuleComponent;
	SetCapsuleSize(InRadius: number,InHalfHeight: number,bUpdateOverlaps: boolean): void;
	SetCapsuleRadius(Radius: number,bUpdateOverlaps: boolean): void;
	SetCapsuleHalfHeight(HalfHeight: number,bUpdateOverlaps: boolean): void;
	GetUnscaledCapsuleSize_WithoutHemisphere(OutRadius?: number,OutHalfHeightWithoutHemisphere?: number): {OutRadius: number, OutHalfHeightWithoutHemisphere: number};
	GetUnscaledCapsuleSize(OutRadius?: number,OutHalfHeight?: number): {OutRadius: number, OutHalfHeight: number};
	GetUnscaledCapsuleRadius(): number;
	GetUnscaledCapsuleHalfHeight_WithoutHemisphere(): number;
	GetUnscaledCapsuleHalfHeight(): number;
	GetShapeScale(): number;
	GetScaledCapsuleSize_WithoutHemisphere(OutRadius?: number,OutHalfHeightWithoutHemisphere?: number): {OutRadius: number, OutHalfHeightWithoutHemisphere: number};
	GetScaledCapsuleSize(OutRadius?: number,OutHalfHeight?: number): {OutRadius: number, OutHalfHeight: number};
	GetScaledCapsuleRadius(): number;
	GetScaledCapsuleHalfHeight_WithoutHemisphere(): number;
	GetScaledCapsuleHalfHeight(): number;
	static C(Other: UObject | any): CapsuleComponent;
}

declare class PerQualityLevelInt { 
	Default: number;
	PerQuality: Map<number, number>;
	clone() : PerQualityLevelInt;
	static C(Other: UObject | any): PerQualityLevelInt;
}

declare class StreamableRenderAsset extends UObject { 
	ForceMipLevelsToBeResidentTimestamp: number;
	NumCinematicMipLevels: number;
	NoRefStreamingLODBias: PerQualityLevelInt;
	StreamingIndex: number;
	CachedCombinedLODBias: number;
	NeverStream: boolean;
	bGlobalForceMipLevelsToBeResident: boolean;
	bHasStreamingUpdatePending: boolean;
	bForceMiplevelsToBeResident: boolean;
	bIgnoreStreamingMipBias: boolean;
	bUseCinematicMipLevels: boolean;
	static Load(ResourceName: string): StreamableRenderAsset;
	static Find(Outer: UObject, ResourceName: string): StreamableRenderAsset;
	static GetDefaultObject(): StreamableRenderAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StreamableRenderAsset;
	SetForceMipLevelsToBeResident(Seconds: number,CinematicLODGroupMask: number): void;
	static C(Other: UObject | any): StreamableRenderAsset;
}

declare type ETextureSourceCompressionFormat = 'TSCF_None' | 'TSCF_PNG' | 'TSCF_JPEG' | 'TSCF_MAX';
declare var ETextureSourceCompressionFormat : { TSCF_None:'TSCF_None',TSCF_PNG:'TSCF_PNG',TSCF_JPEG:'TSCF_JPEG',TSCF_MAX:'TSCF_MAX', };
declare type ETextureSourceFormat = 'TSF_Invalid' | 'TSF_G8' | 'TSF_BGRA8' | 'TSF_BGRE8' | 'TSF_RGBA16' | 'TSF_RGBA16F' | 'TSF_RGBA8_DEPRECATED' | 'TSF_RGBE8_DEPRECATED' | 'TSF_G16' | 'TSF_RGBA32F' | 'TSF_R16F' | 'TSF_R32F' | 'TSF_MAX' | 'TSF_RGBA8' | 'TSF_RGBE8';
declare var ETextureSourceFormat : { TSF_Invalid:'TSF_Invalid',TSF_G8:'TSF_G8',TSF_BGRA8:'TSF_BGRA8',TSF_BGRE8:'TSF_BGRE8',TSF_RGBA16:'TSF_RGBA16',TSF_RGBA16F:'TSF_RGBA16F',TSF_RGBA8_DEPRECATED:'TSF_RGBA8_DEPRECATED',TSF_RGBE8_DEPRECATED:'TSF_RGBE8_DEPRECATED',TSF_G16:'TSF_G16',TSF_RGBA32F:'TSF_RGBA32F',TSF_R16F:'TSF_R16F',TSF_R32F:'TSF_R32F',TSF_MAX:'TSF_MAX',TSF_RGBA8:'TSF_RGBA8',TSF_RGBE8:'TSF_RGBE8', };
declare class TextureSourceBlock { 
	BlockX: number;
	BlockY: number;
	SizeX: number;
	SizeY: number;
	NumSlices: number;
	NumMips: number;
	clone() : TextureSourceBlock;
	static C(Other: UObject | any): TextureSourceBlock;
}

declare class TextureSource { 
	ID: Guid;
	BaseBlockX: number;
	BaseBlockY: number;
	SizeX: number;
	SizeY: number;
	NumSlices: number;
	NumMips: number;
	NumLayers: number;
	bPNGCompressed: boolean;
	bLongLatCubemap: boolean;
	CompressionFormat: ETextureSourceCompressionFormat;
	bGuidIsHash: boolean;
	Format: ETextureSourceFormat;
	LayerFormat: ETextureSourceFormat[];
	Blocks: TextureSourceBlock[];
	BlockDataOffsets: number[];
	clone() : TextureSource;
	static C(Other: UObject | any): TextureSource;
}

declare class AssetImportInfo { 
	clone() : AssetImportInfo;
	static C(Other: UObject | any): AssetImportInfo;
}

declare class AssetImportData extends UObject { 
	SourceFilePath: string;
	SourceFileTimestamp: string;
	SourceData: AssetImportInfo;
	static Load(ResourceName: string): AssetImportData;
	static Find(Outer: UObject, ResourceName: string): AssetImportData;
	static GetDefaultObject(): AssetImportData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetImportData;
	ScriptedAddFilename(InPath: string,Index: number,SourceFileLabel: string): void;
	K2_GetFirstFilename(): string;
	K2_ExtractFilenames(): string[];
	static C(Other: UObject | any): AssetImportData;
}

declare type ETextureLossyCompressionAmount = 'TLCA_Default' | 'TLCA_None' | 'TLCA_Lowest' | 'TLCA_Low' | 'TLCA_Medium' | 'TLCA_High' | 'TLCA_Highest' | 'TLCA_MAX';
declare var ETextureLossyCompressionAmount : { TLCA_Default:'TLCA_Default',TLCA_None:'TLCA_None',TLCA_Lowest:'TLCA_Lowest',TLCA_Low:'TLCA_Low',TLCA_Medium:'TLCA_Medium',TLCA_High:'TLCA_High',TLCA_Highest:'TLCA_Highest',TLCA_MAX:'TLCA_MAX', };
declare type ETextureCompressionQuality = 'TCQ_Default' | 'TCQ_Lowest' | 'TCQ_Low' | 'TCQ_Medium' | 'TCQ_High' | 'TCQ_Highest' | 'TCQ_MAX';
declare var ETextureCompressionQuality : { TCQ_Default:'TCQ_Default',TCQ_Lowest:'TCQ_Lowest',TCQ_Low:'TCQ_Low',TCQ_Medium:'TCQ_Medium',TCQ_High:'TCQ_High',TCQ_Highest:'TCQ_Highest',TCQ_MAX:'TCQ_MAX', };
declare type ETexturePowerOfTwoSetting = 'None' | 'PadToPowerOfTwo' | 'PadToSquarePowerOfTwo' | 'ETexturePowerOfTwoSetting_MAX';
declare var ETexturePowerOfTwoSetting : { None:'None',PadToPowerOfTwo:'PadToPowerOfTwo',PadToSquarePowerOfTwo:'PadToSquarePowerOfTwo',ETexturePowerOfTwoSetting_MAX:'ETexturePowerOfTwoSetting_MAX', };
declare type TextureMipGenSettings = 'TMGS_FromTextureGroup' | 'TMGS_SimpleAverage' | 'TMGS_Sharpen0' | 'TMGS_Sharpen1' | 'TMGS_Sharpen2' | 'TMGS_Sharpen3' | 'TMGS_Sharpen4' | 'TMGS_Sharpen5' | 'TMGS_Sharpen6' | 'TMGS_Sharpen7' | 'TMGS_Sharpen8' | 'TMGS_Sharpen9' | 'TMGS_Sharpen10' | 'TMGS_NoMipmaps' | 'TMGS_LeaveExistingMips' | 'TMGS_Blur1' | 'TMGS_Blur2' | 'TMGS_Blur3' | 'TMGS_Blur4' | 'TMGS_Blur5' | 'TMGS_Unfiltered' | 'TMGS_Angular' | 'TMGS_MAX';
declare var TextureMipGenSettings : { TMGS_FromTextureGroup:'TMGS_FromTextureGroup',TMGS_SimpleAverage:'TMGS_SimpleAverage',TMGS_Sharpen0:'TMGS_Sharpen0',TMGS_Sharpen1:'TMGS_Sharpen1',TMGS_Sharpen2:'TMGS_Sharpen2',TMGS_Sharpen3:'TMGS_Sharpen3',TMGS_Sharpen4:'TMGS_Sharpen4',TMGS_Sharpen5:'TMGS_Sharpen5',TMGS_Sharpen6:'TMGS_Sharpen6',TMGS_Sharpen7:'TMGS_Sharpen7',TMGS_Sharpen8:'TMGS_Sharpen8',TMGS_Sharpen9:'TMGS_Sharpen9',TMGS_Sharpen10:'TMGS_Sharpen10',TMGS_NoMipmaps:'TMGS_NoMipmaps',TMGS_LeaveExistingMips:'TMGS_LeaveExistingMips',TMGS_Blur1:'TMGS_Blur1',TMGS_Blur2:'TMGS_Blur2',TMGS_Blur3:'TMGS_Blur3',TMGS_Blur4:'TMGS_Blur4',TMGS_Blur5:'TMGS_Blur5',TMGS_Unfiltered:'TMGS_Unfiltered',TMGS_Angular:'TMGS_Angular',TMGS_MAX:'TMGS_MAX', };
declare type ECompositeTextureMode = 'CTM_Disabled' | 'CTM_NormalRoughnessToRed' | 'CTM_NormalRoughnessToGreen' | 'CTM_NormalRoughnessToBlue' | 'CTM_NormalRoughnessToAlpha' | 'CTM_MAX';
declare var ECompositeTextureMode : { CTM_Disabled:'CTM_Disabled',CTM_NormalRoughnessToRed:'CTM_NormalRoughnessToRed',CTM_NormalRoughnessToGreen:'CTM_NormalRoughnessToGreen',CTM_NormalRoughnessToBlue:'CTM_NormalRoughnessToBlue',CTM_NormalRoughnessToAlpha:'CTM_NormalRoughnessToAlpha',CTM_MAX:'CTM_MAX', };
declare type TextureCompressionSettings = 'TC_Default' | 'TC_Normalmap' | 'TC_Masks' | 'TC_Grayscale' | 'TC_Displacementmap' | 'TC_VectorDisplacementmap' | 'TC_HDR' | 'TC_EditorIcon' | 'TC_Alpha' | 'TC_DistanceFieldFont' | 'TC_HDR_Compressed' | 'TC_BC7' | 'TC_HalfFloat' | 'TC_LQ' | 'TC_EncodedReflectionCapture' | 'TC_SingleFloat' | 'TC_HDR_F32' | 'TC_MAX';
declare var TextureCompressionSettings : { TC_Default:'TC_Default',TC_Normalmap:'TC_Normalmap',TC_Masks:'TC_Masks',TC_Grayscale:'TC_Grayscale',TC_Displacementmap:'TC_Displacementmap',TC_VectorDisplacementmap:'TC_VectorDisplacementmap',TC_HDR:'TC_HDR',TC_EditorIcon:'TC_EditorIcon',TC_Alpha:'TC_Alpha',TC_DistanceFieldFont:'TC_DistanceFieldFont',TC_HDR_Compressed:'TC_HDR_Compressed',TC_BC7:'TC_BC7',TC_HalfFloat:'TC_HalfFloat',TC_LQ:'TC_LQ',TC_EncodedReflectionCapture:'TC_EncodedReflectionCapture',TC_SingleFloat:'TC_SingleFloat',TC_HDR_F32:'TC_HDR_F32',TC_MAX:'TC_MAX', };
declare class TextureFormatSettings { 
	CompressionSettings: TextureCompressionSettings;
	CompressionNoAlpha: boolean;
	CompressionForceAlpha: boolean;
	CompressionNone: boolean;
	CompressionYCoCg: boolean;
	SRGB: boolean;
	clone() : TextureFormatSettings;
	static C(Other: UObject | any): TextureFormatSettings;
}

declare type TextureFilter = 'TF_Nearest' | 'TF_Bilinear' | 'TF_Trilinear' | 'TF_Default' | 'TF_MAX';
declare var TextureFilter : { TF_Nearest:'TF_Nearest',TF_Bilinear:'TF_Bilinear',TF_Trilinear:'TF_Trilinear',TF_Default:'TF_Default',TF_MAX:'TF_MAX', };
declare type ETextureMipLoadOptions = 'Default' | 'AllMips' | 'OnlyFirstMip' | 'ETextureMipLoadOptions_MAX';
declare var ETextureMipLoadOptions : { Default:'Default',AllMips:'AllMips',OnlyFirstMip:'OnlyFirstMip',ETextureMipLoadOptions_MAX:'ETextureMipLoadOptions_MAX', };
declare type TextureGroup = 'TEXTUREGROUP_World' | 'TEXTUREGROUP_WorldNormalMap' | 'TEXTUREGROUP_WorldSpecular' | 'TEXTUREGROUP_Character' | 'TEXTUREGROUP_CharacterNormalMap' | 'TEXTUREGROUP_CharacterSpecular' | 'TEXTUREGROUP_Weapon' | 'TEXTUREGROUP_WeaponNormalMap' | 'TEXTUREGROUP_WeaponSpecular' | 'TEXTUREGROUP_Vehicle' | 'TEXTUREGROUP_VehicleNormalMap' | 'TEXTUREGROUP_VehicleSpecular' | 'TEXTUREGROUP_Cinematic' | 'TEXTUREGROUP_Effects' | 'TEXTUREGROUP_EffectsNotFiltered' | 'TEXTUREGROUP_Skybox' | 'TEXTUREGROUP_UI' | 'TEXTUREGROUP_Lightmap' | 'TEXTUREGROUP_RenderTarget' | 'TEXTUREGROUP_MobileFlattened' | 'TEXTUREGROUP_ProcBuilding_Face' | 'TEXTUREGROUP_ProcBuilding_LightMap' | 'TEXTUREGROUP_Shadowmap' | 'TEXTUREGROUP_ColorLookupTable' | 'TEXTUREGROUP_Terrain_Heightmap' | 'TEXTUREGROUP_Terrain_Weightmap' | 'TEXTUREGROUP_Bokeh' | 'TEXTUREGROUP_IESLightProfile' | 'TEXTUREGROUP_Pixels2D' | 'TEXTUREGROUP_HierarchicalLOD' | 'TEXTUREGROUP_Impostor' | 'TEXTUREGROUP_ImpostorNormalDepth' | 'TEXTUREGROUP_8BitData' | 'TEXTUREGROUP_16BitData' | 'TEXTUREGROUP_Project01' | 'TEXTUREGROUP_Project02' | 'TEXTUREGROUP_Project03' | 'TEXTUREGROUP_Project04' | 'TEXTUREGROUP_Project05' | 'TEXTUREGROUP_Project06' | 'TEXTUREGROUP_Project07' | 'TEXTUREGROUP_Project08' | 'TEXTUREGROUP_Project09' | 'TEXTUREGROUP_Project10' | 'TEXTUREGROUP_Project11' | 'TEXTUREGROUP_Project12' | 'TEXTUREGROUP_Project13' | 'TEXTUREGROUP_Project14' | 'TEXTUREGROUP_Project15' | 'TEXTUREGROUP_Project16' | 'TEXTUREGROUP_Project17' | 'TEXTUREGROUP_Project18' | 'TEXTUREGROUP_MAX';
declare var TextureGroup : { TEXTUREGROUP_World:'TEXTUREGROUP_World',TEXTUREGROUP_WorldNormalMap:'TEXTUREGROUP_WorldNormalMap',TEXTUREGROUP_WorldSpecular:'TEXTUREGROUP_WorldSpecular',TEXTUREGROUP_Character:'TEXTUREGROUP_Character',TEXTUREGROUP_CharacterNormalMap:'TEXTUREGROUP_CharacterNormalMap',TEXTUREGROUP_CharacterSpecular:'TEXTUREGROUP_CharacterSpecular',TEXTUREGROUP_Weapon:'TEXTUREGROUP_Weapon',TEXTUREGROUP_WeaponNormalMap:'TEXTUREGROUP_WeaponNormalMap',TEXTUREGROUP_WeaponSpecular:'TEXTUREGROUP_WeaponSpecular',TEXTUREGROUP_Vehicle:'TEXTUREGROUP_Vehicle',TEXTUREGROUP_VehicleNormalMap:'TEXTUREGROUP_VehicleNormalMap',TEXTUREGROUP_VehicleSpecular:'TEXTUREGROUP_VehicleSpecular',TEXTUREGROUP_Cinematic:'TEXTUREGROUP_Cinematic',TEXTUREGROUP_Effects:'TEXTUREGROUP_Effects',TEXTUREGROUP_EffectsNotFiltered:'TEXTUREGROUP_EffectsNotFiltered',TEXTUREGROUP_Skybox:'TEXTUREGROUP_Skybox',TEXTUREGROUP_UI:'TEXTUREGROUP_UI',TEXTUREGROUP_Lightmap:'TEXTUREGROUP_Lightmap',TEXTUREGROUP_RenderTarget:'TEXTUREGROUP_RenderTarget',TEXTUREGROUP_MobileFlattened:'TEXTUREGROUP_MobileFlattened',TEXTUREGROUP_ProcBuilding_Face:'TEXTUREGROUP_ProcBuilding_Face',TEXTUREGROUP_ProcBuilding_LightMap:'TEXTUREGROUP_ProcBuilding_LightMap',TEXTUREGROUP_Shadowmap:'TEXTUREGROUP_Shadowmap',TEXTUREGROUP_ColorLookupTable:'TEXTUREGROUP_ColorLookupTable',TEXTUREGROUP_Terrain_Heightmap:'TEXTUREGROUP_Terrain_Heightmap',TEXTUREGROUP_Terrain_Weightmap:'TEXTUREGROUP_Terrain_Weightmap',TEXTUREGROUP_Bokeh:'TEXTUREGROUP_Bokeh',TEXTUREGROUP_IESLightProfile:'TEXTUREGROUP_IESLightProfile',TEXTUREGROUP_Pixels2D:'TEXTUREGROUP_Pixels2D',TEXTUREGROUP_HierarchicalLOD:'TEXTUREGROUP_HierarchicalLOD',TEXTUREGROUP_Impostor:'TEXTUREGROUP_Impostor',TEXTUREGROUP_ImpostorNormalDepth:'TEXTUREGROUP_ImpostorNormalDepth',TEXTUREGROUP_8BitData:'TEXTUREGROUP_8BitData',TEXTUREGROUP_16BitData:'TEXTUREGROUP_16BitData',TEXTUREGROUP_Project01:'TEXTUREGROUP_Project01',TEXTUREGROUP_Project02:'TEXTUREGROUP_Project02',TEXTUREGROUP_Project03:'TEXTUREGROUP_Project03',TEXTUREGROUP_Project04:'TEXTUREGROUP_Project04',TEXTUREGROUP_Project05:'TEXTUREGROUP_Project05',TEXTUREGROUP_Project06:'TEXTUREGROUP_Project06',TEXTUREGROUP_Project07:'TEXTUREGROUP_Project07',TEXTUREGROUP_Project08:'TEXTUREGROUP_Project08',TEXTUREGROUP_Project09:'TEXTUREGROUP_Project09',TEXTUREGROUP_Project10:'TEXTUREGROUP_Project10',TEXTUREGROUP_Project11:'TEXTUREGROUP_Project11',TEXTUREGROUP_Project12:'TEXTUREGROUP_Project12',TEXTUREGROUP_Project13:'TEXTUREGROUP_Project13',TEXTUREGROUP_Project14:'TEXTUREGROUP_Project14',TEXTUREGROUP_Project15:'TEXTUREGROUP_Project15',TEXTUREGROUP_Project16:'TEXTUREGROUP_Project16',TEXTUREGROUP_Project17:'TEXTUREGROUP_Project17',TEXTUREGROUP_Project18:'TEXTUREGROUP_Project18',TEXTUREGROUP_MAX:'TEXTUREGROUP_MAX', };
declare class PerPlatformFloat { 
	Default: number;
	PerPlatform: Map<string, number>;
	clone() : PerPlatformFloat;
	static C(Other: UObject | any): PerPlatformFloat;
}

declare type ETextureDownscaleOptions = 'Default' | 'Unfiltered' | 'SimpleAverage' | 'Sharpen0' | 'Sharpen1' | 'Sharpen2' | 'Sharpen3' | 'Sharpen4' | 'Sharpen5' | 'Sharpen6' | 'Sharpen7' | 'Sharpen8' | 'Sharpen9' | 'Sharpen10' | 'ETextureDownscaleOptions_MAX';
declare var ETextureDownscaleOptions : { Default:'Default',Unfiltered:'Unfiltered',SimpleAverage:'SimpleAverage',Sharpen0:'Sharpen0',Sharpen1:'Sharpen1',Sharpen2:'Sharpen2',Sharpen3:'Sharpen3',Sharpen4:'Sharpen4',Sharpen5:'Sharpen5',Sharpen6:'Sharpen6',Sharpen7:'Sharpen7',Sharpen8:'Sharpen8',Sharpen9:'Sharpen9',Sharpen10:'Sharpen10',ETextureDownscaleOptions_MAX:'ETextureDownscaleOptions_MAX', };
declare type ETextureSourceEncoding = 'TSE_None' | 'TSE_Linear' | 'TSE_sRGB' | 'TSE_ST2084' | 'TSE_Gamma22' | 'TSE_BT1886' | 'TSE_Gamma26' | 'TSE_Cineon' | 'TSE_REDLog' | 'TSE_REDLog3G10' | 'TSE_SLog1' | 'TSE_SLog2' | 'TSE_SLog3' | 'TSE_AlexaV3LogC' | 'TSE_CanonLog' | 'TSE_ProTune' | 'TSE_VLog' | 'TSE_MAX';
declare var ETextureSourceEncoding : { TSE_None:'TSE_None',TSE_Linear:'TSE_Linear',TSE_sRGB:'TSE_sRGB',TSE_ST2084:'TSE_ST2084',TSE_Gamma22:'TSE_Gamma22',TSE_BT1886:'TSE_BT1886',TSE_Gamma26:'TSE_Gamma26',TSE_Cineon:'TSE_Cineon',TSE_REDLog:'TSE_REDLog',TSE_REDLog3G10:'TSE_REDLog3G10',TSE_SLog1:'TSE_SLog1',TSE_SLog2:'TSE_SLog2',TSE_SLog3:'TSE_SLog3',TSE_AlexaV3LogC:'TSE_AlexaV3LogC',TSE_CanonLog:'TSE_CanonLog',TSE_ProTune:'TSE_ProTune',TSE_VLog:'TSE_VLog',TSE_MAX:'TSE_MAX', };
declare type ETextureColorSpace = 'TCS_None' | 'TCS_sRGB' | 'TCS_Rec2020' | 'TCS_ACESAP0' | 'TCS_ACESAP1' | 'TCS_P3DCI' | 'TCS_P3D65' | 'TCS_REDWideGamut' | 'TCS_SonySGamut3' | 'TCS_SonySGamut3Cine' | 'TCS_AlexaWideGamut' | 'TCS_CanonCinemaGamut' | 'TCS_GoProProtuneNative' | 'TCS_PanasonicVGamut' | 'TCS_Custom' | 'TCS_MAX';
declare var ETextureColorSpace : { TCS_None:'TCS_None',TCS_sRGB:'TCS_sRGB',TCS_Rec2020:'TCS_Rec2020',TCS_ACESAP0:'TCS_ACESAP0',TCS_ACESAP1:'TCS_ACESAP1',TCS_P3DCI:'TCS_P3DCI',TCS_P3D65:'TCS_P3D65',TCS_REDWideGamut:'TCS_REDWideGamut',TCS_SonySGamut3:'TCS_SonySGamut3',TCS_SonySGamut3Cine:'TCS_SonySGamut3Cine',TCS_AlexaWideGamut:'TCS_AlexaWideGamut',TCS_CanonCinemaGamut:'TCS_CanonCinemaGamut',TCS_GoProProtuneNative:'TCS_GoProProtuneNative',TCS_PanasonicVGamut:'TCS_PanasonicVGamut',TCS_Custom:'TCS_Custom',TCS_MAX:'TCS_MAX', };
declare type ETextureChromaticAdaptationMethod = 'TCAM_None' | 'TCAM_Bradford' | 'TCAM_CAT02' | 'TCAM_MAX';
declare var ETextureChromaticAdaptationMethod : { TCAM_None:'TCAM_None',TCAM_Bradford:'TCAM_Bradford',TCAM_CAT02:'TCAM_CAT02',TCAM_MAX:'TCAM_MAX', };
declare class TextureSourceColorSettings { 
	EncodingOverride: ETextureSourceEncoding;
	ColorSpace: ETextureColorSpace;
	RedChromaticityCoordinate: Vector2D;
	GreenChromaticityCoordinate: Vector2D;
	BlueChromaticityCoordinate: Vector2D;
	WhiteChromaticityCoordinate: Vector2D;
	ChromaticAdaptationMethod: ETextureChromaticAdaptationMethod;
	clone() : TextureSourceColorSettings;
	static C(Other: UObject | any): TextureSourceColorSettings;
}

declare type EDesiredImageFormat = 'PNG' | 'JPG' | 'BMP' | 'EXR' | 'EDesiredImageFormat_MAX';
declare var EDesiredImageFormat : { PNG:'PNG',JPG:'JPG',BMP:'BMP',EXR:'EXR',EDesiredImageFormat_MAX:'EDesiredImageFormat_MAX', };
declare class ImageWriteOptions { 
	Format: EDesiredImageFormat;
	OnComplete: UnrealEngineDelegate<(bSuccess: boolean) => void>;
	CompressionQuality: number;
	bOverwriteFile: boolean;
	bAsync: boolean;
	clone() : ImageWriteOptions;
	static C(Other: UObject | any): ImageWriteOptions;
}

declare class Texture extends StreamableRenderAsset { 
	Source: TextureSource;
	LightingGuid: Guid;
	SourceFilePath: string;
	AssetImportData: AssetImportData;
	AdjustBrightness: number;
	AdjustBrightnessCurve: number;
	AdjustVibrance: number;
	AdjustSaturation: number;
	AdjustRGBCurve: number;
	AdjustHue: number;
	AdjustMinAlpha: number;
	AdjustMaxAlpha: number;
	CompressionNoAlpha: boolean;
	CompressionForceAlpha: boolean;
	CompressionNone: boolean;
	CompressFinal: boolean;
	DeferCompression: boolean;
	LossyCompressionAmount: ETextureLossyCompressionAmount;
	OodleTextureSdkVersion: string;
	MaxTextureSize: number;
	CompressionQuality: ETextureCompressionQuality;
	CompressionCacheId: Guid;
	bDitherMipMapAlpha: boolean;
	bDoScaleMipsForAlphaCoverage: boolean;
	AlphaCoverageThresholds: Vector4;
	bUseNewMipFilter: boolean;
	bPreserveBorder: boolean;
	bFlipGreenChannel: boolean;
	PowerOfTwoMode: ETexturePowerOfTwoSetting;
	PaddingColor: Color;
	bChromaKeyTexture: boolean;
	ChromaKeyThreshold: number;
	ChromaKeyColor: Color;
	MipGenSettings: TextureMipGenSettings;
	CompositeTexture: Texture;
	CompositeTextureMode: ECompositeTextureMode;
	CompositePower: number;
	LayerFormatSettings: TextureFormatSettings[];
	LevelIndex: number;
	LODBias: number;
	CompressionSettings: TextureCompressionSettings;
	Filter: TextureFilter;
	MipLoadOptions: ETextureMipLoadOptions;
	LODGroup: TextureGroup;
	Downscale: PerPlatformFloat;
	DownscaleOptions: ETextureDownscaleOptions;
	SRGB: boolean;
	bUseLegacyGamma: boolean;
	SourceColorSettings: TextureSourceColorSettings;
	bNoTiling: boolean;
	VirtualTextureStreaming: boolean;
	CompressionYCoCg: boolean;
	bNotOfflineProcessed: boolean;
	bAsyncResourceReleaseHasBeenStarted: boolean;
	AssetUserData: AssetUserData[];
	static Load(ResourceName: string): Texture;
	static Find(Outer: UObject, ResourceName: string): Texture;
	static GetDefaultObject(): Texture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Texture;
	Blueprint_GetMemorySize(): number;
	static C(Other: UObject | any): Texture;
	SetSplashScreen(Scale: Vector2D,Offset: Vector,bShowLoadingMovie: boolean,bShowOnSet: boolean): void;
	ExportToDisk(Filename: string,Options: ImageWriteOptions): void;
	AddLoadingScreenSplash(Translation: Vector,Rotation: Rotator,Size: Vector2D,DeltaRotation: Rotator,bClearBeforeAdd: boolean): void;
	SetLoadingScreen(Scale: Vector2D,Offset: Vector,bShowLoadingMovie: boolean,bShowOnSet: boolean): void;
	SetSpectatorScreenTexture(): void;
	static SetSplashScreen(Texture: Texture,Scale: Vector2D,Offset: Vector,bShowLoadingMovie: boolean,bShowOnSet: boolean): void;
	static ExportToDisk(Texture: Texture,Filename: string,Options: ImageWriteOptions): void;
	static AddLoadingScreenSplash(Texture: Texture,Translation: Vector,Rotation: Rotator,Size: Vector2D,DeltaRotation: Rotator,bClearBeforeAdd: boolean): void;
	static SetLoadingScreen(Texture: Texture,Scale: Vector2D,Offset: Vector,bShowLoadingMovie: boolean,bShowOnSet: boolean): void;
	static SetSpectatorScreenTexture(InTexture: Texture): void;
}

declare type TextureAddress = 'TA_Wrap' | 'TA_Clamp' | 'TA_Mirror' | 'TA_MAX';
declare var TextureAddress : { TA_Wrap:'TA_Wrap',TA_Clamp:'TA_Clamp',TA_Mirror:'TA_Mirror',TA_MAX:'TA_MAX', };
declare type EImportanceWeight = 'Luminance' | 'Red' | 'Green' | 'Blue' | 'Alpha' | 'EImportanceWeight_MAX';
declare var EImportanceWeight : { Luminance:'Luminance',Red:'Red',Green:'Green',Blue:'Blue',Alpha:'Alpha',EImportanceWeight_MAX:'EImportanceWeight_MAX', };
declare class ImportanceTexture { 
	Size: IntPoint;
	NumMips: number;
	MarginalCDF: number[];
	ConditionalCDF: number[];
	TextureData: Color[];
	Texture: Texture2D;
	Weighting: EImportanceWeight;
	clone() : ImportanceTexture;
	static C(Other: UObject | any): ImportanceTexture;
	BreakImportanceTexture(Texture?: Texture2D,WeightingFunc?: EImportanceWeight): {Texture: Texture2D, WeightingFunc: EImportanceWeight};
	ImportanceSample(Rand: Vector2D,Samples: number,Intensity: number,SamplePosition?: Vector2D,SampleColor?: LinearColor,SampleIntensity?: number,SampleSize?: number): {SamplePosition: Vector2D, SampleColor: LinearColor, SampleIntensity: number, SampleSize: number};
	static BreakImportanceTexture(ImportanceTexture: ImportanceTexture,Texture?: Texture2D,WeightingFunc?: EImportanceWeight): {Texture: Texture2D, WeightingFunc: EImportanceWeight};
	static ImportanceSample(Texture: ImportanceTexture,Rand: Vector2D,Samples: number,Intensity: number,SamplePosition?: Vector2D,SampleColor?: LinearColor,SampleIntensity?: number,SampleSize?: number): {SamplePosition: Vector2D, SampleColor: LinearColor, SampleIntensity: number, SampleSize: number};
}

declare type ESlateBrushDrawType = 'NoDrawType' | 'Box' | 'Border' | 'Image' | 'RoundedBox' | 'ESlateBrushDrawType_MAX';
declare var ESlateBrushDrawType : { NoDrawType:'NoDrawType',Box:'Box',Border:'Border',Image:'Image',RoundedBox:'RoundedBox',ESlateBrushDrawType_MAX:'ESlateBrushDrawType_MAX', };
declare type ESlateBrushTileType = 'NoTile' | 'Horizontal' | 'Vertical' | 'Both' | 'ESlateBrushTileType_MAX';
declare var ESlateBrushTileType : { NoTile:'NoTile',Horizontal:'Horizontal',Vertical:'Vertical',Both:'Both',ESlateBrushTileType_MAX:'ESlateBrushTileType_MAX', };
declare type ESlateBrushMirrorType = 'NoMirror' | 'Horizontal' | 'Vertical' | 'Both' | 'ESlateBrushMirrorType_MAX';
declare var ESlateBrushMirrorType : { NoMirror:'NoMirror',Horizontal:'Horizontal',Vertical:'Vertical',Both:'Both',ESlateBrushMirrorType_MAX:'ESlateBrushMirrorType_MAX', };
declare type ESlateBrushImageType = 'NoImage' | 'FullColor' | 'Linear' | 'Vector' | 'ESlateBrushImageType_MAX';
declare var ESlateBrushImageType : { NoImage:'NoImage',FullColor:'FullColor',Linear:'Linear',Vector:'Vector',ESlateBrushImageType_MAX:'ESlateBrushImageType_MAX', };
declare class Margin { 
	Left: number;
	Top: number;
	Right: number;
	Bottom: number;
	clone() : Margin;
	static C(Other: UObject | any): Margin;
}

declare type ESlateColorStylingMode = 'UseColor_Specified' | 'UseColor_ColorTable' | 'UseColor_Foreground' | 'UseColor_Foreground_Subdued' | 'UseColor_UseStyle' | 'UseColor_MAX';
declare var ESlateColorStylingMode : { UseColor_Specified:'UseColor_Specified',UseColor_ColorTable:'UseColor_ColorTable',UseColor_Foreground:'UseColor_Foreground',UseColor_Foreground_Subdued:'UseColor_Foreground_Subdued',UseColor_UseStyle:'UseColor_UseStyle',UseColor_MAX:'UseColor_MAX', };
declare class SlateColor { 
	SpecifiedColor: LinearColor;
	ColorUseRule: ESlateColorStylingMode;
	clone() : SlateColor;
	static C(Other: UObject | any): SlateColor;
	static SlateColor_UseForeground(): SlateColor;
	static SlateColor_UseSubduedForeground(): SlateColor;
}

declare type ESlateBrushRoundingType = 'FixedRadius' | 'HalfHeightRadius' | 'ESlateBrushRoundingType_MAX';
declare var ESlateBrushRoundingType : { FixedRadius:'FixedRadius',HalfHeightRadius:'HalfHeightRadius',ESlateBrushRoundingType_MAX:'ESlateBrushRoundingType_MAX', };
declare class SlateBrushOutlineSettings { 
	CornerRadii: Vector4;
	Color: SlateColor;
	Width: number;
	RoundingType: ESlateBrushRoundingType;
	bUseBrushTransparency: boolean;
	clone() : SlateBrushOutlineSettings;
	static C(Other: UObject | any): SlateBrushOutlineSettings;
}

declare class Vector2f { 
	X: number;
	Y: number;
	clone() : Vector2f;
	static C(Other: UObject | any): Vector2f;
}

declare class Box2f { 
	Min: Vector2f;
	Max: Vector2f;
	bIsValid: number;
	clone() : Box2f;
	static C(Other: UObject | any): Box2f;
}

declare class MaterialInterfaceEditorOnlyData extends UObject { 
	static Load(ResourceName: string): MaterialInterfaceEditorOnlyData;
	static Find(Outer: UObject, ResourceName: string): MaterialInterfaceEditorOnlyData;
	static GetDefaultObject(): MaterialInterfaceEditorOnlyData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialInterfaceEditorOnlyData;
	static C(Other: UObject | any): MaterialInterfaceEditorOnlyData;
}

declare class SubsurfaceProfileStruct { 
	SurfaceAlbedo: LinearColor;
	MeanFreePathColor: LinearColor;
	MeanFreePathDistance: number;
	WorldUnitScale: number;
	bEnableBurley: boolean;
	bEnableMeanFreePath: boolean;
	Tint: LinearColor;
	ScatterRadius: number;
	SubsurfaceColor: LinearColor;
	FalloffColor: LinearColor;
	BoundaryColorBleed: LinearColor;
	ExtinctionScale: number;
	NormalScale: number;
	ScatteringDistribution: number;
	IOR: number;
	Roughness0: number;
	Roughness1: number;
	LobeMix: number;
	TransmissionTintColor: LinearColor;
	clone() : SubsurfaceProfileStruct;
	static C(Other: UObject | any): SubsurfaceProfileStruct;
}

declare class SubsurfaceProfile extends UObject { 
	Settings: SubsurfaceProfileStruct;
	static Load(ResourceName: string): SubsurfaceProfile;
	static Find(Outer: UObject, ResourceName: string): SubsurfaceProfile;
	static GetDefaultObject(): SubsurfaceProfile;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SubsurfaceProfile;
	static C(Other: UObject | any): SubsurfaceProfile;
}

declare class LightmassMaterialInterfaceSettings { 
	EmissiveBoost: number;
	DiffuseBoost: number;
	ExportResolutionScale: number;
	bCastShadowAsMasked: boolean;
	bOverrideCastShadowAsMasked: boolean;
	bOverrideEmissiveBoost: boolean;
	bOverrideDiffuseBoost: boolean;
	bOverrideExportResolutionScale: boolean;
	clone() : LightmassMaterialInterfaceSettings;
	static C(Other: UObject | any): LightmassMaterialInterfaceSettings;
}

declare class MaterialTextureInfo { 
	SamplingScale: number;
	UVChannelIndex: number;
	TextureName: string;
	TextureReference: SoftObjectPath;
	TextureIndex: number;
	clone() : MaterialTextureInfo;
	static C(Other: UObject | any): MaterialTextureInfo;
}

declare class PhysicalMaterialMask extends UObject { 
	AssetImportData: AssetImportData;
	MaskTexture: Texture;
	UVChannelIndex: number;
	AddressX: TextureAddress;
	AddressY: TextureAddress;
	static Load(ResourceName: string): PhysicalMaterialMask;
	static Find(Outer: UObject, ResourceName: string): PhysicalMaterialMask;
	static GetDefaultObject(): PhysicalMaterialMask;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicalMaterialMask;
	static C(Other: UObject | any): PhysicalMaterialMask;
}

declare type EMaterialParameterAssociation = 'LayerParameter' | 'BlendParameter' | 'GlobalParameter' | 'EMaterialParameterAssociation_MAX';
declare var EMaterialParameterAssociation : { LayerParameter:'LayerParameter',BlendParameter:'BlendParameter',GlobalParameter:'GlobalParameter',EMaterialParameterAssociation_MAX:'EMaterialParameterAssociation_MAX', };
declare class MaterialFunctionInterfaceEditorOnlyData extends UObject { 
	static Load(ResourceName: string): MaterialFunctionInterfaceEditorOnlyData;
	static Find(Outer: UObject, ResourceName: string): MaterialFunctionInterfaceEditorOnlyData;
	static GetDefaultObject(): MaterialFunctionInterfaceEditorOnlyData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialFunctionInterfaceEditorOnlyData;
	static C(Other: UObject | any): MaterialFunctionInterfaceEditorOnlyData;
}

declare type EMaterialFunctionUsage = 'Default' | 'MaterialLayer' | 'MaterialLayerBlend' | 'EMaterialFunctionUsage_MAX';
declare var EMaterialFunctionUsage : { Default:'Default',MaterialLayer:'MaterialLayer',MaterialLayerBlend:'MaterialLayerBlend',EMaterialFunctionUsage_MAX:'EMaterialFunctionUsage_MAX', };
declare type EMaterialDomain = 'MD_Surface' | 'MD_DeferredDecal' | 'MD_LightFunction' | 'MD_Volume' | 'MD_PostProcess' | 'MD_UI' | 'MD_RuntimeVirtualTexture' | 'MD_MAX';
declare var EMaterialDomain : { MD_Surface:'MD_Surface',MD_DeferredDecal:'MD_DeferredDecal',MD_LightFunction:'MD_LightFunction',MD_Volume:'MD_Volume',MD_PostProcess:'MD_PostProcess',MD_UI:'MD_UI',MD_RuntimeVirtualTexture:'MD_RuntimeVirtualTexture',MD_MAX:'MD_MAX', };
declare type EBlendMode = 'BLEND_Opaque' | 'BLEND_Masked' | 'BLEND_Translucent' | 'BLEND_Additive' | 'BLEND_Modulate' | 'BLEND_AlphaComposite' | 'BLEND_AlphaHoldout' | 'BLEND_MAX';
declare var EBlendMode : { BLEND_Opaque:'BLEND_Opaque',BLEND_Masked:'BLEND_Masked',BLEND_Translucent:'BLEND_Translucent',BLEND_Additive:'BLEND_Additive',BLEND_Modulate:'BLEND_Modulate',BLEND_AlphaComposite:'BLEND_AlphaComposite',BLEND_AlphaHoldout:'BLEND_AlphaHoldout',BLEND_MAX:'BLEND_MAX', };
declare type EStrataBlendMode = 'SBM_Opaque' | 'SBM_Masked' | 'SBM_TranslucentGreyTransmittance' | 'SBM_TranslucentColoredTransmittance' | 'SBM_ColoredTransmittanceOnly' | 'SBM_AlphaHoldout' | 'SBM_MAX';
declare var EStrataBlendMode : { SBM_Opaque:'SBM_Opaque',SBM_Masked:'SBM_Masked',SBM_TranslucentGreyTransmittance:'SBM_TranslucentGreyTransmittance',SBM_TranslucentColoredTransmittance:'SBM_TranslucentColoredTransmittance',SBM_ColoredTransmittanceOnly:'SBM_ColoredTransmittanceOnly',SBM_AlphaHoldout:'SBM_AlphaHoldout',SBM_MAX:'SBM_MAX', };
declare type EDecalBlendMode = 'DBM_Translucent' | 'DBM_Stain' | 'DBM_Normal' | 'DBM_Emissive' | 'DBM_DBuffer_ColorNormalRoughness' | 'DBM_DBuffer_Color' | 'DBM_DBuffer_ColorNormal' | 'DBM_DBuffer_ColorRoughness' | 'DBM_DBuffer_Normal' | 'DBM_DBuffer_NormalRoughness' | 'DBM_DBuffer_Roughness' | 'DBM_DBuffer_Emissive' | 'DBM_DBuffer_AlphaComposite' | 'DBM_DBuffer_EmissiveAlphaComposite' | 'DBM_Volumetric_DistanceFunction' | 'DBM_AlphaComposite' | 'DBM_AmbientOcclusion' | 'DBM_MAX';
declare var EDecalBlendMode : { DBM_Translucent:'DBM_Translucent',DBM_Stain:'DBM_Stain',DBM_Normal:'DBM_Normal',DBM_Emissive:'DBM_Emissive',DBM_DBuffer_ColorNormalRoughness:'DBM_DBuffer_ColorNormalRoughness',DBM_DBuffer_Color:'DBM_DBuffer_Color',DBM_DBuffer_ColorNormal:'DBM_DBuffer_ColorNormal',DBM_DBuffer_ColorRoughness:'DBM_DBuffer_ColorRoughness',DBM_DBuffer_Normal:'DBM_DBuffer_Normal',DBM_DBuffer_NormalRoughness:'DBM_DBuffer_NormalRoughness',DBM_DBuffer_Roughness:'DBM_DBuffer_Roughness',DBM_DBuffer_Emissive:'DBM_DBuffer_Emissive',DBM_DBuffer_AlphaComposite:'DBM_DBuffer_AlphaComposite',DBM_DBuffer_EmissiveAlphaComposite:'DBM_DBuffer_EmissiveAlphaComposite',DBM_Volumetric_DistanceFunction:'DBM_Volumetric_DistanceFunction',DBM_AlphaComposite:'DBM_AlphaComposite',DBM_AmbientOcclusion:'DBM_AmbientOcclusion',DBM_MAX:'DBM_MAX', };
declare type EMaterialDecalResponse = 'MDR_None' | 'MDR_ColorNormalRoughness' | 'MDR_Color' | 'MDR_ColorNormal' | 'MDR_ColorRoughness' | 'MDR_Normal' | 'MDR_NormalRoughness' | 'MDR_Roughness' | 'MDR_MAX';
declare var EMaterialDecalResponse : { MDR_None:'MDR_None',MDR_ColorNormalRoughness:'MDR_ColorNormalRoughness',MDR_Color:'MDR_Color',MDR_ColorNormal:'MDR_ColorNormal',MDR_ColorRoughness:'MDR_ColorRoughness',MDR_Normal:'MDR_Normal',MDR_NormalRoughness:'MDR_NormalRoughness',MDR_Roughness:'MDR_Roughness',MDR_MAX:'MDR_MAX', };
declare class MaterialOverrideNanite { 
	OverrideMaterialRef: MaterialInterface;
	bEnableOverride: boolean;
	OverrideMaterial: MaterialInterface;
	clone() : MaterialOverrideNanite;
	static C(Other: UObject | any): MaterialOverrideNanite;
}

declare type EMaterialShadingModel = 'MSM_Unlit' | 'MSM_DefaultLit' | 'MSM_Subsurface' | 'MSM_PreintegratedSkin' | 'MSM_ClearCoat' | 'MSM_SubsurfaceProfile' | 'MSM_TwoSidedFoliage' | 'MSM_Hair' | 'MSM_Cloth' | 'MSM_Eye' | 'MSM_SingleLayerWater' | 'MSM_ThinTranslucent' | 'MSM_Strata' | 'MSM_NUM' | 'MSM_FromMaterialExpression' | 'MSM_MAX';
declare var EMaterialShadingModel : { MSM_Unlit:'MSM_Unlit',MSM_DefaultLit:'MSM_DefaultLit',MSM_Subsurface:'MSM_Subsurface',MSM_PreintegratedSkin:'MSM_PreintegratedSkin',MSM_ClearCoat:'MSM_ClearCoat',MSM_SubsurfaceProfile:'MSM_SubsurfaceProfile',MSM_TwoSidedFoliage:'MSM_TwoSidedFoliage',MSM_Hair:'MSM_Hair',MSM_Cloth:'MSM_Cloth',MSM_Eye:'MSM_Eye',MSM_SingleLayerWater:'MSM_SingleLayerWater',MSM_ThinTranslucent:'MSM_ThinTranslucent',MSM_Strata:'MSM_Strata',MSM_NUM:'MSM_NUM',MSM_FromMaterialExpression:'MSM_FromMaterialExpression',MSM_MAX:'MSM_MAX', };
declare class MaterialShadingModelField { 
	ShadingModelField: number;
	clone() : MaterialShadingModelField;
	static C(Other: UObject | any): MaterialShadingModelField;
}

declare type EMaterialTranslucencyPass = 'MTP_BeforeDOF' | 'MTP_AfterDOF' | 'MTP_AfterMotionBlur' | 'MTP_MAX';
declare var EMaterialTranslucencyPass : { MTP_BeforeDOF:'MTP_BeforeDOF',MTP_AfterDOF:'MTP_AfterDOF',MTP_AfterMotionBlur:'MTP_AfterMotionBlur',MTP_MAX:'MTP_MAX', };
declare type ETranslucencyLightingMode = 'TLM_VolumetricNonDirectional' | 'TLM_VolumetricDirectional' | 'TLM_VolumetricPerVertexNonDirectional' | 'TLM_VolumetricPerVertexDirectional' | 'TLM_Surface' | 'TLM_SurfacePerPixelLighting' | 'TLM_MAX';
declare var ETranslucencyLightingMode : { TLM_VolumetricNonDirectional:'TLM_VolumetricNonDirectional',TLM_VolumetricDirectional:'TLM_VolumetricDirectional',TLM_VolumetricPerVertexNonDirectional:'TLM_VolumetricPerVertexNonDirectional',TLM_VolumetricPerVertexDirectional:'TLM_VolumetricPerVertexDirectional',TLM_Surface:'TLM_Surface',TLM_SurfacePerPixelLighting:'TLM_SurfacePerPixelLighting',TLM_MAX:'TLM_MAX', };
declare type EMaterialFloatPrecisionMode = 'MFPM_Default' | 'MFPM_Full_MaterialExpressionOnly' | 'MFPM_Full' | 'MFPM_Half' | 'MFPM_MAX';
declare var EMaterialFloatPrecisionMode : { MFPM_Default:'MFPM_Default',MFPM_Full_MaterialExpressionOnly:'MFPM_Full_MaterialExpressionOnly',MFPM_Full:'MFPM_Full',MFPM_Half:'MFPM_Half',MFPM_MAX:'MFPM_MAX', };
declare type EMaterialShadingRate = 'MSR_1x1' | 'MSR_2x1' | 'MSR_1x2' | 'MSR_2x2' | 'MSR_4x2' | 'MSR_2x4' | 'MSR_4x4' | 'MSR_Count' | 'MSR_MAX';
declare var EMaterialShadingRate : { MSR_1x1:'MSR_1x1',MSR_2x1:'MSR_2x1',MSR_1x2:'MSR_1x2',MSR_2x2:'MSR_2x2',MSR_4x2:'MSR_4x2',MSR_2x4:'MSR_2x4',MSR_4x4:'MSR_4x4',MSR_Count:'MSR_Count',MSR_MAX:'MSR_MAX', };
declare type EBlendableLocation = 'BL_AfterTonemapping' | 'BL_BeforeTonemapping' | 'BL_BeforeTranslucency' | 'BL_ReplacingTonemapper' | 'BL_SSRInput' | 'BL_MAX';
declare var EBlendableLocation : { BL_AfterTonemapping:'BL_AfterTonemapping',BL_BeforeTonemapping:'BL_BeforeTonemapping',BL_BeforeTranslucency:'BL_BeforeTranslucency',BL_ReplacingTonemapper:'BL_ReplacingTonemapper',BL_SSRInput:'BL_SSRInput',BL_MAX:'BL_MAX', };
declare type EMaterialStencilCompare = 'MSC_Less' | 'MSC_LessEqual' | 'MSC_Greater' | 'MSC_GreaterEqual' | 'MSC_Equal' | 'MSC_NotEqual' | 'MSC_Never' | 'MSC_Always' | 'MSC_Count' | 'MSC_MAX';
declare var EMaterialStencilCompare : { MSC_Less:'MSC_Less',MSC_LessEqual:'MSC_LessEqual',MSC_Greater:'MSC_Greater',MSC_GreaterEqual:'MSC_GreaterEqual',MSC_Equal:'MSC_Equal',MSC_NotEqual:'MSC_NotEqual',MSC_Never:'MSC_Never',MSC_Always:'MSC_Always',MSC_Count:'MSC_Count',MSC_MAX:'MSC_MAX', };
declare type ERefractionMode = 'RM_IndexOfRefraction' | 'RM_PixelNormalOffset' | 'RM_MAX';
declare var ERefractionMode : { RM_IndexOfRefraction:'RM_IndexOfRefraction',RM_PixelNormalOffset:'RM_PixelNormalOffset',RM_MAX:'RM_MAX', };
declare type EEdGraphPinDirection = 'EGPD_Input' | 'EGPD_Output' | 'EGPD_MAX';
declare var EEdGraphPinDirection : { EGPD_Input:'EGPD_Input',EGPD_Output:'EGPD_Output',EGPD_MAX:'EGPD_MAX', };
declare class EdGraphTerminalType { 
	TerminalCategory: string;
	TerminalSubCategory: string;
	TerminalSubCategoryObject: UObject;
	bTerminalIsConst: boolean;
	bTerminalIsWeakPointer: boolean;
	bTerminalIsUObjectWrapper: boolean;
	clone() : EdGraphTerminalType;
	static C(Other: UObject | any): EdGraphTerminalType;
}

declare type EPinContainerType = 'None' | 'Array' | 'Set' | 'Map' | 'EPinContainerType_MAX';
declare var EPinContainerType : { None:'None',Array:'Array',Set:'Set',Map:'Map',EPinContainerType_MAX:'EPinContainerType_MAX', };
declare class EdGraphPinType { 
	PinCategory: string;
	PinSubCategory: string;
	PinSubCategoryObject: UObject;
	PinSubCategoryMemberReference: SimpleMemberReference;
	PinValueType: EdGraphTerminalType;
	ContainerType: EPinContainerType;
	bIsArray: boolean;
	bIsReference: boolean;
	bIsConst: boolean;
	bIsWeakPointer: boolean;
	bIsUObjectWrapper: boolean;
	bSerializeAsSinglePrecisionFloat: boolean;
	clone() : EdGraphPinType;
	static C(Other: UObject | any): EdGraphPinType;
}

declare class EdGraphPin_Deprecated extends UObject { 
	PinName: string;
	PinFriendlyName: string;
	PinToolTip: string;
	Direction: EEdGraphPinDirection;
	PinType: EdGraphPinType;
	DefaultValue: string;
	AutogeneratedDefaultValue: string;
	DefaultObject: UObject;
	DefaultTextValue: string;
	LinkedTo: EdGraphPin_Deprecated[];
	SubPins: EdGraphPin_Deprecated[];
	ParentPin: EdGraphPin_Deprecated;
	ReferencePassThroughConnection: EdGraphPin_Deprecated;
	bHidden: boolean;
	bNotConnectable: boolean;
	bDefaultValueIsReadOnly: boolean;
	bDefaultValueIsIgnored: boolean;
	bAdvancedView: boolean;
	bDisplayAsMutableRef: boolean;
	PersistentGuid: Guid;
	static Load(ResourceName: string): EdGraphPin_Deprecated;
	static Find(Outer: UObject, ResourceName: string): EdGraphPin_Deprecated;
	static GetDefaultObject(): EdGraphPin_Deprecated;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphPin_Deprecated;
	static C(Other: UObject | any): EdGraphPin_Deprecated;
}

declare type ENodeAdvancedPins = 'NoPins' | 'Shown' | 'Hidden' | 'ENodeAdvancedPins_MAX';
declare var ENodeAdvancedPins : { NoPins:'NoPins',Shown:'Shown',Hidden:'Hidden',ENodeAdvancedPins_MAX:'ENodeAdvancedPins_MAX', };
declare type ENodeEnabledState = 'Enabled' | 'Disabled' | 'DevelopmentOnly' | 'ENodeEnabledState_MAX';
declare var ENodeEnabledState : { Enabled:'Enabled',Disabled:'Disabled',DevelopmentOnly:'DevelopmentOnly',ENodeEnabledState_MAX:'ENodeEnabledState_MAX', };
declare type EJavascriptPinContainerType = 'None' | 'Array' | 'Set' | 'Map' | 'EJavascriptPinContainerType_MAX';
declare var EJavascriptPinContainerType : { None:'None',Array:'Array',Set:'Set',Map:'Map',EJavascriptPinContainerType_MAX:'EJavascriptPinContainerType_MAX', };
declare class JavascriptEdGraphPin { 
	clone() : JavascriptEdGraphPin;
	static C(Other: UObject | any): JavascriptEdGraphPin;
	BreakAllPinLinks(): void;
	BreakLinkTo(B: JavascriptEdGraphPin): void;
	GetDirection(): EEdGraphPinDirection;
	GetLinkedPinNum(): number;
	GetLinkedTo(): JavascriptEdGraphPin[];
	GetOwningNode(): EdGraphNode;
	GetParentPin(): JavascriptEdGraphPin;
	GetPinContainerType(): EJavascriptPinContainerType;
	GetPinGUID(): Guid;
	GetPinIndex(): number;
	GetPinName(): string;
	GetPinRefObject(): UObject;
	GetPinType(): EdGraphPinType;
	GetSubPins(): JavascriptEdGraphPin[];
	IsPinHidden(): boolean;
	IsValid(): boolean;
	MakeLinkTo(B: JavascriptEdGraphPin): void;
	SetParentPin(Parent: JavascriptEdGraphPin): void;
	SetPinAdvancedView(bAdvancedView: boolean): void;
	SetPinContainerType(ContainerType: EJavascriptPinContainerType): void;
	SetPinHidden(bHidden: boolean): void;
	SetPinInfo(InPinName: string,InPinToolTip: string): void;
	SetPinRefObject(InObject: UObject): void;
	SetPinType(PinType: EdGraphPinType): void;
	static BreakAllPinLinks(A: JavascriptEdGraphPin): void;
	static BreakLinkTo(A: JavascriptEdGraphPin,B: JavascriptEdGraphPin): void;
	static GetDirection(A: JavascriptEdGraphPin): EEdGraphPinDirection;
	static GetLinkedPinNum(A: JavascriptEdGraphPin): number;
	static GetLinkedTo(A: JavascriptEdGraphPin): JavascriptEdGraphPin[];
	static GetOwningNode(A: JavascriptEdGraphPin): EdGraphNode;
	static GetParentPin(A: JavascriptEdGraphPin): JavascriptEdGraphPin;
	static GetPinContainerType(A: JavascriptEdGraphPin): EJavascriptPinContainerType;
	static GetPinGUID(A: JavascriptEdGraphPin): Guid;
	static GetPinIndex(A: JavascriptEdGraphPin): number;
	static GetPinName(A: JavascriptEdGraphPin): string;
	static GetPinRefObject(InPin: JavascriptEdGraphPin): UObject;
	static GetPinType(A: JavascriptEdGraphPin): EdGraphPinType;
	static GetSubPins(A: JavascriptEdGraphPin): JavascriptEdGraphPin[];
	static IsPinHidden(A: JavascriptEdGraphPin): boolean;
	static IsValid(A: JavascriptEdGraphPin): boolean;
	static MakeLinkTo(A: JavascriptEdGraphPin,B: JavascriptEdGraphPin): void;
	static SetParentPin(A: JavascriptEdGraphPin,Parent: JavascriptEdGraphPin): void;
	static SetPinAdvancedView(A: JavascriptEdGraphPin,bAdvancedView: boolean): void;
	static SetPinContainerType(A: JavascriptEdGraphPin,ContainerType: EJavascriptPinContainerType): void;
	static SetPinHidden(A: JavascriptEdGraphPin,bHidden: boolean): void;
	static SetPinInfo(A: JavascriptEdGraphPin,InPinName: string,InPinToolTip: string): void;
	static SetPinRefObject(InPin: JavascriptEdGraphPin,InObject: UObject): void;
	static SetPinType(Pin: JavascriptEdGraphPin,PinType: EdGraphPinType): void;
	static GetDefaultObject(): JavascriptEdGraphPin;
}

declare class EdGraphNode extends UObject { 
	DeprecatedPins: EdGraphPin_Deprecated[];
	NodePosX: number;
	NodePosY: number;
	NodeWidth: number;
	NodeHeight: number;
	AdvancedPinDisplay: ENodeAdvancedPins;
	EnabledState: ENodeEnabledState;
	bDisplayAsDisabled: boolean;
	bUserSetEnabledState: boolean;
	bIsNodeEnabled: boolean;
	bCanResizeNode: boolean;
	bIsIntermediateNode: boolean;
	bHasCompilerMessage: boolean;
	bCommentBubblePinned: boolean;
	bCommentBubbleVisible: boolean;
	bCommentBubbleMakeVisible: boolean;
	bCanRenameNode: boolean;
	NodeUpgradeMessage: string;
	NodeComment: string;
	ErrorType: number;
	ErrorMsg: string;
	NodeGuid: Guid;
	static Load(ResourceName: string): EdGraphNode;
	static Find(Outer: UObject, ResourceName: string): EdGraphNode;
	static GetDefaultObject(): EdGraphNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphNode;
	static C(Other: UObject | any): EdGraphNode;
	AutowireNewNode(FromPin: JavascriptEdGraphPin): void;
	CanDuplicateNode(): boolean;
	CanUserDeleteNode(): boolean;
	DestroyNode(): void;
	FindPin(PinName: string,Direction: EEdGraphPinDirection): JavascriptEdGraphPin;
	GetPins(): JavascriptEdGraphPin[];
	ResizeNode(NewSize: Vector2D): void;
	static AutowireNewNode(UNode: EdGraphNode,FromPin: JavascriptEdGraphPin): void;
	static CanDuplicateNode(UNode: EdGraphNode): boolean;
	static CanUserDeleteNode(UNode: EdGraphNode): boolean;
	static DestroyNode(UNode: EdGraphNode): void;
	static FindPin(UNode: EdGraphNode,PinName: string,Direction: EEdGraphPinDirection): JavascriptEdGraphPin;
	static GetPins(UNode: EdGraphNode): JavascriptEdGraphPin[];
	static ResizeNode(UNode: EdGraphNode,NewSize: Vector2D): void;
}

declare class ExpressionInput { 
	Expression: MaterialExpression;
	OutputIndex: number;
	InputName: string;
	mask: number;
	MaskR: number;
	MaskG: number;
	MaskB: number;
	MaskA: number;
	clone() : ExpressionInput;
	static C(Other: UObject | any): ExpressionInput;
}

declare type EFunctionInputType = 'FunctionInput_Scalar' | 'FunctionInput_Vector2' | 'FunctionInput_Vector3' | 'FunctionInput_Vector4' | 'FunctionInput_Texture2D' | 'FunctionInput_TextureCube' | 'FunctionInput_Texture2DArray' | 'FunctionInput_VolumeTexture' | 'FunctionInput_StaticBool' | 'FunctionInput_MaterialAttributes' | 'FunctionInput_TextureExternal' | 'FunctionInput_MAX';
declare var EFunctionInputType : { FunctionInput_Scalar:'FunctionInput_Scalar',FunctionInput_Vector2:'FunctionInput_Vector2',FunctionInput_Vector3:'FunctionInput_Vector3',FunctionInput_Vector4:'FunctionInput_Vector4',FunctionInput_Texture2D:'FunctionInput_Texture2D',FunctionInput_TextureCube:'FunctionInput_TextureCube',FunctionInput_Texture2DArray:'FunctionInput_Texture2DArray',FunctionInput_VolumeTexture:'FunctionInput_VolumeTexture',FunctionInput_StaticBool:'FunctionInput_StaticBool',FunctionInput_MaterialAttributes:'FunctionInput_MaterialAttributes',FunctionInput_TextureExternal:'FunctionInput_TextureExternal',FunctionInput_MAX:'FunctionInput_MAX', };
declare class Vector4f { 
	X: number;
	Y: number;
	Z: number;
	W: number;
	clone() : Vector4f;
	static C(Other: UObject | any): Vector4f;
}

declare class MaterialExpressionFunctionInput extends MaterialExpression { 
	Preview: ExpressionInput;
	InputName: string;
	Description: string;
	ID: Guid;
	InputType: EFunctionInputType;
	PreviewValue: Vector4f;
	bUsePreviewValueAsDefault: boolean;
	SortPriority: number;
	bCompilingFunctionPreview: boolean;
	static Load(ResourceName: string): MaterialExpressionFunctionInput;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionFunctionInput;
	static GetDefaultObject(): MaterialExpressionFunctionInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionFunctionInput;
	static C(Other: UObject | any): MaterialExpressionFunctionInput;
}

declare class FunctionExpressionInput { 
	ExpressionInput: MaterialExpressionFunctionInput;
	ExpressionInputId: Guid;
	Input: ExpressionInput;
	clone() : FunctionExpressionInput;
	static C(Other: UObject | any): FunctionExpressionInput;
}

declare class MaterialExpressionFunctionOutput extends MaterialExpression { 
	OutputName: string;
	Description: string;
	SortPriority: number;
	A: ExpressionInput;
	bLastPreviewed: boolean;
	ID: Guid;
	static Load(ResourceName: string): MaterialExpressionFunctionOutput;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionFunctionOutput;
	static GetDefaultObject(): MaterialExpressionFunctionOutput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionFunctionOutput;
	static C(Other: UObject | any): MaterialExpressionFunctionOutput;
}

declare class ExpressionOutput { 
	OutputName: string;
	mask: number;
	MaskR: number;
	MaskG: number;
	MaskB: number;
	MaskA: number;
	clone() : ExpressionOutput;
	static C(Other: UObject | any): ExpressionOutput;
}

declare class FunctionExpressionOutput { 
	ExpressionOutput: MaterialExpressionFunctionOutput;
	ExpressionOutputId: Guid;
	Output: ExpressionOutput;
	clone() : FunctionExpressionOutput;
	static C(Other: UObject | any): FunctionExpressionOutput;
}

declare class MaterialParameterInfo { 
	Name: string;
	Association: EMaterialParameterAssociation;
	Index: number;
	clone() : MaterialParameterInfo;
	static C(Other: UObject | any): MaterialParameterInfo;
}

declare class MaterialExpressionMaterialFunctionCall extends MaterialExpression { 
	MaterialFunction: MaterialFunctionInterface;
	FunctionInputs: FunctionExpressionInput[];
	FunctionOutputs: FunctionExpressionOutput[];
	FunctionParameterInfo: MaterialParameterInfo;
	static Load(ResourceName: string): MaterialExpressionMaterialFunctionCall;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionMaterialFunctionCall;
	static GetDefaultObject(): MaterialExpressionMaterialFunctionCall;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionMaterialFunctionCall;
	SetMaterialFunction(NewMaterialFunction: MaterialFunctionInterface): boolean;
	static C(Other: UObject | any): MaterialExpressionMaterialFunctionCall;
}

declare class ExpressionExecOutput { 
	Expression: MaterialExpression;
	clone() : ExpressionExecOutput;
	static C(Other: UObject | any): ExpressionExecOutput;
}

declare class MaterialExpressionExecBegin extends MaterialExpression { 
	exec: ExpressionExecOutput;
	static Load(ResourceName: string): MaterialExpressionExecBegin;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionExecBegin;
	static GetDefaultObject(): MaterialExpressionExecBegin;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionExecBegin;
	static C(Other: UObject | any): MaterialExpressionExecBegin;
}

declare class MaterialExpressionExecEnd extends MaterialExpression { 
	static Load(ResourceName: string): MaterialExpressionExecEnd;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionExecEnd;
	static GetDefaultObject(): MaterialExpressionExecEnd;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionExecEnd;
	static C(Other: UObject | any): MaterialExpressionExecEnd;
}

declare class MaterialFunction extends MaterialFunctionInterface { 
	ParentFunction: MaterialFunction;
	Description: string;
	bExposeToLibrary: boolean;
	bPrefixParameterNames: boolean;
	bEnableExecWire: boolean;
	bEnableNewHLSLGenerator: boolean;
	LibraryCategories: string[];
	LibraryCategoriesText: string[];
	PreviewMaterial: Material;
	DependentFunctionExpressionCandidates: MaterialExpressionMaterialFunctionCall[];
	PreviewBlendMode: EBlendMode;
	bReentrantFlag: boolean;
	FunctionExpressions: MaterialExpression[];
	FunctionEditorComments: MaterialExpressionComment[];
	ExpressionExecBegin: MaterialExpressionExecBegin;
	ExpressionExecEnd: MaterialExpressionExecEnd;
	static Load(ResourceName: string): MaterialFunction;
	static Find(Outer: UObject, ResourceName: string): MaterialFunction;
	static GetDefaultObject(): MaterialFunction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialFunction;
	static C(Other: UObject | any): MaterialFunction;
	CreateMaterialExpressionInFunction(ExpressionClass: UnrealEngineClass,NodePosX: number,NodePosY: number): MaterialExpression;
	DeleteAllMaterialExpressionsInFunction(): void;
	DeleteMaterialExpressionInFunction(Expression: MaterialExpression): void;
	GetNumMaterialExpressionsInFunction(): number;
	LayoutMaterialFunctionExpressions(): void;
	static CreateMaterialExpressionInFunction(MaterialFunction: MaterialFunction,ExpressionClass: UnrealEngineClass,NodePosX: number,NodePosY: number): MaterialExpression;
	static DeleteAllMaterialExpressionsInFunction(MaterialFunction: MaterialFunction): void;
	static DeleteMaterialExpressionInFunction(MaterialFunction: MaterialFunction,Expression: MaterialExpression): void;
	static GetNumMaterialExpressionsInFunction(MaterialFunction: MaterialFunction): number;
	static LayoutMaterialFunctionExpressions(MaterialFunction: MaterialFunction): void;
}

declare type EMaterialProperty = 'MP_EmissiveColor' | 'MP_Opacity' | 'MP_OpacityMask' | 'MP_DiffuseColor' | 'MP_SpecularColor' | 'MP_BaseColor' | 'MP_Metallic' | 'MP_Specular' | 'MP_Roughness' | 'MP_Anisotropy' | 'MP_Normal' | 'MP_Tangent' | 'MP_WorldPositionOffset' | 'MP_WorldDisplacement_DEPRECATED' | 'MP_TessellationMultiplier_DEPRECATED' | 'MP_SubsurfaceColor' | 'MP_CustomData0' | 'MP_CustomData1' | 'MP_AmbientOcclusion' | 'MP_Refraction' | 'MP_CustomizedUVs0' | 'MP_CustomizedUVs1' | 'MP_CustomizedUVs2' | 'MP_CustomizedUVs3' | 'MP_CustomizedUVs4' | 'MP_CustomizedUVs5' | 'MP_CustomizedUVs6' | 'MP_CustomizedUVs7' | 'MP_PixelDepthOffset' | 'MP_ShadingModel' | 'MP_FrontMaterial' | 'MP_MaterialAttributes' | 'MP_CustomOutput' | 'MP_MAX';
declare var EMaterialProperty : { MP_EmissiveColor:'MP_EmissiveColor',MP_Opacity:'MP_Opacity',MP_OpacityMask:'MP_OpacityMask',MP_DiffuseColor:'MP_DiffuseColor',MP_SpecularColor:'MP_SpecularColor',MP_BaseColor:'MP_BaseColor',MP_Metallic:'MP_Metallic',MP_Specular:'MP_Specular',MP_Roughness:'MP_Roughness',MP_Anisotropy:'MP_Anisotropy',MP_Normal:'MP_Normal',MP_Tangent:'MP_Tangent',MP_WorldPositionOffset:'MP_WorldPositionOffset',MP_WorldDisplacement_DEPRECATED:'MP_WorldDisplacement_DEPRECATED',MP_TessellationMultiplier_DEPRECATED:'MP_TessellationMultiplier_DEPRECATED',MP_SubsurfaceColor:'MP_SubsurfaceColor',MP_CustomData0:'MP_CustomData0',MP_CustomData1:'MP_CustomData1',MP_AmbientOcclusion:'MP_AmbientOcclusion',MP_Refraction:'MP_Refraction',MP_CustomizedUVs0:'MP_CustomizedUVs0',MP_CustomizedUVs1:'MP_CustomizedUVs1',MP_CustomizedUVs2:'MP_CustomizedUVs2',MP_CustomizedUVs3:'MP_CustomizedUVs3',MP_CustomizedUVs4:'MP_CustomizedUVs4',MP_CustomizedUVs5:'MP_CustomizedUVs5',MP_CustomizedUVs6:'MP_CustomizedUVs6',MP_CustomizedUVs7:'MP_CustomizedUVs7',MP_PixelDepthOffset:'MP_PixelDepthOffset',MP_ShadingModel:'MP_ShadingModel',MP_FrontMaterial:'MP_FrontMaterial',MP_MaterialAttributes:'MP_MaterialAttributes',MP_CustomOutput:'MP_CustomOutput',MP_MAX:'MP_MAX', };
declare class MaterialExpression extends UObject { 
	MaterialExpressionEditorX: number;
	MaterialExpressionEditorY: number;
	GraphNode: EdGraphNode;
	SubgraphExpression: MaterialExpression;
	MaterialExpressionGuid: Guid;
	Material: Material;
	UFunction: MaterialFunction;
	Desc: string;
	bRealtimePreview: boolean;
	bNeedToUpdatePreview: boolean;
	bIsParameterExpression: boolean;
	bCommentBubbleVisible: boolean;
	bShowOutputNameOnPin: boolean;
	bShowMaskColorsOnPin: boolean;
	bHidePreviewWindow: boolean;
	bCollapsed: boolean;
	bShaderInputData: boolean;
	bShowInputs: boolean;
	bShowOutputs: boolean;
	MenuCategories: string[];
	Outputs: ExpressionOutput[];
	static Load(ResourceName: string): MaterialExpression;
	static Find(Outer: UObject, ResourceName: string): MaterialExpression;
	static GetDefaultObject(): MaterialExpression;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpression;
	static C(Other: UObject | any): MaterialExpression;
	ConnectMaterialExpressions(FromOutputName: string,ToExpression: MaterialExpression,ToInputName: string): boolean;
	ConnectMaterialProperty(FromOutputName: string,Property: EMaterialProperty): boolean;
	GetInputNodeOutputNameForMaterialExpression(InputNode: MaterialExpression,OutputName?: string): {OutputName: string, $: boolean};
	GetMaterialExpressionNodePosition(NodePosX?: number,NodePosY?: number): {NodePosX: number, NodePosY: number};
	static ConnectMaterialExpressions(FromExpression: MaterialExpression,FromOutputName: string,ToExpression: MaterialExpression,ToInputName: string): boolean;
	static ConnectMaterialProperty(FromExpression: MaterialExpression,FromOutputName: string,Property: EMaterialProperty): boolean;
	static GetInputNodeOutputNameForMaterialExpression(MaterialExpression: MaterialExpression,InputNode: MaterialExpression,OutputName?: string): {OutputName: string, $: boolean};
	static GetMaterialExpressionNodePosition(MaterialExpression: MaterialExpression,NodePosX?: number,NodePosY?: number): {NodePosX: number, NodePosY: number};
}

declare class MaterialExpressionComment extends MaterialExpression { 
	SizeX: number;
	SizeY: number;
	Text: string;
	CommentColor: LinearColor;
	FontSize: number;
	static Load(ResourceName: string): MaterialExpressionComment;
	static Find(Outer: UObject, ResourceName: string): MaterialExpressionComment;
	static GetDefaultObject(): MaterialExpressionComment;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialExpressionComment;
	static C(Other: UObject | any): MaterialExpressionComment;
}

declare class ParameterGroupData { 
	GroupName: string;
	GroupSortPriority: number;
	clone() : ParameterGroupData;
	static C(Other: UObject | any): ParameterGroupData;
}

declare class MaterialInput { 
	Expression: MaterialExpression;
	OutputIndex: number;
	InputName: string;
	mask: number;
	MaskR: number;
	MaskG: number;
	MaskB: number;
	MaskA: number;
	clone() : MaterialInput;
	static C(Other: UObject | any): MaterialInput;
}

declare class ColorMaterialInput extends MaterialInput { 
	UseConstant: boolean;
	Constant: Color;
	clone() : ColorMaterialInput;
	static C(Other: UObject | any): ColorMaterialInput;
}

declare class ScalarMaterialInput extends MaterialInput { 
	UseConstant: boolean;
	Constant: number;
	clone() : ScalarMaterialInput;
	static C(Other: UObject | any): ScalarMaterialInput;
}

declare class Vector3f { 
	X: number;
	Y: number;
	Z: number;
	clone() : Vector3f;
	static C(Other: UObject | any): Vector3f;
	Conv_Vector3fToString(): string;
	BreakVector3f(X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static Conv_Vector3fToString(InVec: Vector3f): string;
	static BreakVector3f(InVec: Vector3f,X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
}

declare class VectorMaterialInput extends MaterialInput { 
	UseConstant: boolean;
	Constant: Vector3f;
	clone() : VectorMaterialInput;
	static C(Other: UObject | any): VectorMaterialInput;
}

declare class Vector2MaterialInput extends MaterialInput { 
	UseConstant: boolean;
	ConstantX: number;
	ConstantY: number;
	clone() : Vector2MaterialInput;
	static C(Other: UObject | any): Vector2MaterialInput;
}

declare class MaterialAttributesInput extends ExpressionInput { 
	PropertyConnectedBitmask: number;
	clone() : MaterialAttributesInput;
	static C(Other: UObject | any): MaterialAttributesInput;
}

declare class ShadingModelMaterialInput extends MaterialInput { 
	clone() : ShadingModelMaterialInput;
	static C(Other: UObject | any): ShadingModelMaterialInput;
}

declare class StrataMaterialInput extends MaterialInput { 
	clone() : StrataMaterialInput;
	static C(Other: UObject | any): StrataMaterialInput;
}

declare type EMaterialUsage = 'MATUSAGE_SkeletalMesh' | 'MATUSAGE_ParticleSprites' | 'MATUSAGE_BeamTrails' | 'MATUSAGE_MeshParticles' | 'MATUSAGE_StaticLighting' | 'MATUSAGE_MorphTargets' | 'MATUSAGE_SplineMesh' | 'MATUSAGE_InstancedStaticMeshes' | 'MATUSAGE_GeometryCollections' | 'MATUSAGE_Clothing' | 'MATUSAGE_NiagaraSprites' | 'MATUSAGE_NiagaraRibbons' | 'MATUSAGE_NiagaraMeshParticles' | 'MATUSAGE_GeometryCache' | 'MATUSAGE_Water' | 'MATUSAGE_HairStrands' | 'MATUSAGE_LidarPointCloud' | 'MATUSAGE_VirtualHeightfieldMesh' | 'MATUSAGE_Nanite' | 'MATUSAGE_MAX';
declare var EMaterialUsage : { MATUSAGE_SkeletalMesh:'MATUSAGE_SkeletalMesh',MATUSAGE_ParticleSprites:'MATUSAGE_ParticleSprites',MATUSAGE_BeamTrails:'MATUSAGE_BeamTrails',MATUSAGE_MeshParticles:'MATUSAGE_MeshParticles',MATUSAGE_StaticLighting:'MATUSAGE_StaticLighting',MATUSAGE_MorphTargets:'MATUSAGE_MorphTargets',MATUSAGE_SplineMesh:'MATUSAGE_SplineMesh',MATUSAGE_InstancedStaticMeshes:'MATUSAGE_InstancedStaticMeshes',MATUSAGE_GeometryCollections:'MATUSAGE_GeometryCollections',MATUSAGE_Clothing:'MATUSAGE_Clothing',MATUSAGE_NiagaraSprites:'MATUSAGE_NiagaraSprites',MATUSAGE_NiagaraRibbons:'MATUSAGE_NiagaraRibbons',MATUSAGE_NiagaraMeshParticles:'MATUSAGE_NiagaraMeshParticles',MATUSAGE_GeometryCache:'MATUSAGE_GeometryCache',MATUSAGE_Water:'MATUSAGE_Water',MATUSAGE_HairStrands:'MATUSAGE_HairStrands',MATUSAGE_LidarPointCloud:'MATUSAGE_LidarPointCloud',MATUSAGE_VirtualHeightfieldMesh:'MATUSAGE_VirtualHeightfieldMesh',MATUSAGE_Nanite:'MATUSAGE_Nanite',MATUSAGE_MAX:'MATUSAGE_MAX', };
declare class Material extends MaterialInterface { 
	PhysMaterial: PhysicalMaterial;
	PhysMaterialMask: PhysicalMaterialMask;
	PhysicalMaterialMap: PhysicalMaterial;
	RenderTracePhysicalMaterialOutputs: PhysicalMaterial[];
	MaterialDomain: EMaterialDomain;
	BlendMode: EBlendMode;
	StrataBlendMode: EStrataBlendMode;
	DecalBlendMode: EDecalBlendMode;
	MaterialDecalResponse: EMaterialDecalResponse;
	NaniteOverrideMaterial: MaterialOverrideNanite;
	CachedConnectedInputs: number;
	ShadingModel: EMaterialShadingModel;
	bCastDynamicShadowAsMasked: boolean;
	ShadingModels: MaterialShadingModelField;
	UsedShadingModels: string;
	OpacityMaskClipValue: number;
	bEnableSeparateTranslucency: boolean;
	bEnableResponsiveAA: boolean;
	bScreenSpaceReflections: boolean;
	bContactShadows: boolean;
	TwoSided: boolean;
	DitheredLODTransition: boolean;
	DitherOpacityMask: boolean;
	bAllowNegativeEmissiveColor: boolean;
	TranslucencyPass: EMaterialTranslucencyPass;
	TranslucencyLightingMode: ETranslucencyLightingMode;
	bEnableMobileSeparateTranslucency: boolean;
	NumCustomizedUVs: number;
	TranslucencyDirectionalLightingIntensity: number;
	TranslucentShadowDensityScale: number;
	TranslucentSelfShadowDensityScale: number;
	TranslucentSelfShadowSecondDensityScale: number;
	TranslucentSelfShadowSecondOpacity: number;
	TranslucentBackscatteringExponent: number;
	TranslucentMultipleScatteringExtinction: LinearColor;
	TranslucentShadowStartOffset: number;
	bDisableDepthTest: boolean;
	bWriteOnlyAlpha: boolean;
	bGenerateSphericalParticleNormals: boolean;
	bTangentSpaceNormal: boolean;
	bUseEmissiveForDynamicAreaLighting: boolean;
	bUsedAsSpecialEngineMaterial: boolean;
	bUsedWithSkeletalMesh: boolean;
	bUsedWithEditorCompositing: boolean;
	bUsedWithParticleSprites: boolean;
	bUsedWithBeamTrails: boolean;
	bUsedWithMeshParticles: boolean;
	bUsedWithNiagaraSprites: boolean;
	bUsedWithNiagaraRibbons: boolean;
	bUsedWithNiagaraMeshParticles: boolean;
	bUsedWithGeometryCache: boolean;
	bUsedWithStaticLighting: boolean;
	bUsedWithMorphTargets: boolean;
	bUsedWithSplineMeshes: boolean;
	bUsedWithInstancedStaticMeshes: boolean;
	bUsedWithGeometryCollections: boolean;
	bUsesDistortion: boolean;
	bUsedWithClothing: boolean;
	bUsedWithWater: boolean;
	bUsedWithHairStrands: boolean;
	bUsedWithLidarPointCloud: boolean;
	bUsedWithVirtualHeightfieldMesh: boolean;
	bUsedWithNanite: boolean;
	bUsedWithUI: boolean;
	bAutomaticallySetUsageInEditor: boolean;
	bFullyRough: boolean;
	bUseFullPrecision: boolean;
	FloatPrecisionMode: EMaterialFloatPrecisionMode;
	bUseLightmapDirectionality: boolean;
	bMobileEnableHighQualityBRDF: boolean;
	bUseAlphaToCoverage: boolean;
	bForwardRenderUsePreintegratedGFForSimpleIBL: boolean;
	bUseHQForwardReflections: boolean;
	bForwardBlendsSkyLightCubemaps: boolean;
	bUsePlanarForwardReflections: boolean;
	bNormalCurvatureToRoughness: boolean;
	AllowTranslucentCustomDepthWrites: boolean;
	Wireframe: boolean;
	ShadingRate: EMaterialShadingRate;
	EditorX: number;
	EditorY: number;
	EditorPitch: number;
	EditorYaw: number;
	bCanMaskedBeAssumedOpaque: boolean;
	bIsMasked: boolean;
	bIsPreviewMaterial: boolean;
	bIsFunctionPreviewMaterial: boolean;
	bUseMaterialAttributes: boolean;
	bEnableExecWire: boolean;
	bEnableNewHLSLGenerator: boolean;
	bCastRayTracedShadows: boolean;
	bUseTranslucencyVertexFog: boolean;
	bApplyCloudFogging: boolean;
	bIsSky: boolean;
	bComputeFogPerPixel: boolean;
	bOutputTranslucentVelocity: boolean;
	bAllowDevelopmentShaderCompile: boolean;
	bIsMaterialEditorStatsMaterial: boolean;
	BlendableLocation: EBlendableLocation;
	BlendableOutputAlpha: boolean;
	bEnableStencilTest: boolean;
	StencilCompare: EMaterialStencilCompare;
	StencilRefValue: number;
	RefractionMode: ERefractionMode;
	BlendablePriority: number;
	bIsBlendable: boolean;
	UsageFlagWarnings: number;
	RefractionDepthBias: number;
	StateId: Guid;
	bSavedCachedExpressionData: boolean;
	ReferencedTextureGuids: Guid[];
	EditorComments: MaterialExpressionComment[];
	ExpressionExecBegin: MaterialExpressionExecBegin;
	ExpressionExecEnd: MaterialExpressionExecEnd;
	Expressions: MaterialExpression[];
	ParameterGroupData: ParameterGroupData[];
	DiffuseColor: ColorMaterialInput;
	SpecularColor: ColorMaterialInput;
	BaseColor: ColorMaterialInput;
	Metallic: ScalarMaterialInput;
	Specular: ScalarMaterialInput;
	Roughness: ScalarMaterialInput;
	Anisotropy: ScalarMaterialInput;
	Normal: VectorMaterialInput;
	Tangent: VectorMaterialInput;
	EmissiveColor: ColorMaterialInput;
	Opacity: ScalarMaterialInput;
	OpacityMask: ScalarMaterialInput;
	WorldPositionOffset: VectorMaterialInput;
	SubsurfaceColor: ColorMaterialInput;
	ClearCoat: ScalarMaterialInput;
	ClearCoatRoughness: ScalarMaterialInput;
	AmbientOcclusion: ScalarMaterialInput;
	Refraction: ScalarMaterialInput;
	CustomizedUVs: Vector2MaterialInput;
	MaterialAttributes: MaterialAttributesInput;
	PixelDepthOffset: ScalarMaterialInput;
	ShadingModelFromMaterialExpression: ShadingModelMaterialInput;
	FrontMaterial: StrataMaterialInput;
	static Load(ResourceName: string): Material;
	static Find(Outer: UObject, ResourceName: string): Material;
	static GetDefaultObject(): Material;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Material;
	static C(Other: UObject | any): Material;
	CreateMaterialExpression(ExpressionClass: UnrealEngineClass,NodePosX: number,NodePosY: number): MaterialExpression;
	DeleteAllMaterialExpressions(): void;
	DeleteMaterialExpression(Expression: MaterialExpression): void;
	DuplicateMaterialExpression(MaterialFunction: MaterialFunction,Expression: MaterialExpression): MaterialExpression;
	GetInputsForMaterialExpression(MaterialExpression: MaterialExpression): MaterialExpression[];
	GetMaterialDefaultScalarParameterValue(ParameterName: string): number;
	GetMaterialDefaultStaticSwitchParameterValue(ParameterName: string): boolean;
	GetMaterialDefaultTextureParameterValue(ParameterName: string): Texture;
	GetMaterialDefaultVectorParameterValue(ParameterName: string): LinearColor;
	GetMaterialPropertyInputNode(Property: EMaterialProperty): MaterialExpression;
	GetMaterialPropertyInputNodeOutputName(Property: EMaterialProperty): string;
	GetMaterialSelectedNodes(): Set<UObject>;
	GetNumMaterialExpressions(): number;
	GetUsedTextures(): Texture[];
	HasMaterialUsage(Usage: EMaterialUsage): boolean;
	LayoutMaterialExpressions(): void;
	RecompileMaterial(): void;
	SetMaterialUsage(Usage: EMaterialUsage,bNeedsRecompile?: boolean): {bNeedsRecompile: boolean, $: boolean};
	static CreateMaterialExpression(Material: Material,ExpressionClass: UnrealEngineClass,NodePosX: number,NodePosY: number): MaterialExpression;
	static DeleteAllMaterialExpressions(Material: Material): void;
	static DeleteMaterialExpression(Material: Material,Expression: MaterialExpression): void;
	static DuplicateMaterialExpression(Material: Material,MaterialFunction: MaterialFunction,Expression: MaterialExpression): MaterialExpression;
	static GetInputsForMaterialExpression(Material: Material,MaterialExpression: MaterialExpression): MaterialExpression[];
	static GetMaterialDefaultScalarParameterValue(Material: Material,ParameterName: string): number;
	static GetMaterialDefaultStaticSwitchParameterValue(Material: Material,ParameterName: string): boolean;
	static GetMaterialDefaultTextureParameterValue(Material: Material,ParameterName: string): Texture;
	static GetMaterialDefaultVectorParameterValue(Material: Material,ParameterName: string): LinearColor;
	static GetMaterialPropertyInputNode(Material: Material,Property: EMaterialProperty): MaterialExpression;
	static GetMaterialPropertyInputNodeOutputName(Material: Material,Property: EMaterialProperty): string;
	static GetMaterialSelectedNodes(Material: Material): Set<UObject>;
	static GetNumMaterialExpressions(Material: Material): number;
	static GetUsedTextures(Material: Material): Texture[];
	static HasMaterialUsage(Material: Material,Usage: EMaterialUsage): boolean;
	static LayoutMaterialExpressions(Material: Material): void;
	static RecompileMaterial(Material: Material): void;
	static SetMaterialUsage(Material: Material,Usage: EMaterialUsage,bNeedsRecompile?: boolean): {bNeedsRecompile: boolean, $: boolean};
}

declare class MaterialFunctionInterface extends UObject { 
	EditorOnlyData: MaterialFunctionInterfaceEditorOnlyData;
	StateId: Guid;
	MaterialFunctionUsage: EMaterialFunctionUsage;
	CombinedInputTypes: number;
	CombinedOutputTypes: number;
	ThumbnailInfo: ThumbnailInfo;
	static Load(ResourceName: string): MaterialFunctionInterface;
	static Find(Outer: UObject, ResourceName: string): MaterialFunctionInterface;
	static GetDefaultObject(): MaterialFunctionInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialFunctionInterface;
	static C(Other: UObject | any): MaterialFunctionInterface;
	UpdateMaterialFunction(PreviewMaterial: Material): void;
	static UpdateMaterialFunction(MaterialFunction: MaterialFunctionInterface,PreviewMaterial: Material): void;
}

declare type EAttachLocation = 'KeepRelativeOffset' | 'KeepWorldPosition' | 'SnapToTarget' | 'SnapToTargetIncludingScale' | 'EAttachLocation_MAX';
declare var EAttachLocation : { KeepRelativeOffset:'KeepRelativeOffset',KeepWorldPosition:'KeepWorldPosition',SnapToTarget:'SnapToTarget',SnapToTargetIncludingScale:'SnapToTargetIncludingScale',EAttachLocation_MAX:'EAttachLocation_MAX', };
declare class CurveBase extends UObject { 
	AssetImportData: AssetImportData;
	ImportPath: string;
	static Load(ResourceName: string): CurveBase;
	static Find(Outer: UObject, ResourceName: string): CurveBase;
	static GetDefaultObject(): CurveBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveBase;
	GetValueRange(MinValue?: number,MaxValue?: number): {MinValue: number, MaxValue: number};
	GetTimeRange(MinTime?: number,MaxTime?: number): {MinTime: number, MaxTime: number};
	static C(Other: UObject | any): CurveBase;
}

declare class KeyHandleMap { 
	clone() : KeyHandleMap;
	static C(Other: UObject | any): KeyHandleMap;
}

declare class IndexedCurve { 
	KeyHandlesToIndices: KeyHandleMap;
	clone() : IndexedCurve;
	static C(Other: UObject | any): IndexedCurve;
}

declare type ERichCurveExtrapolation = 'RCCE_Cycle' | 'RCCE_CycleWithOffset' | 'RCCE_Oscillate' | 'RCCE_Linear' | 'RCCE_Constant' | 'RCCE_None' | 'RCCE_MAX';
declare var ERichCurveExtrapolation : { RCCE_Cycle:'RCCE_Cycle',RCCE_CycleWithOffset:'RCCE_CycleWithOffset',RCCE_Oscillate:'RCCE_Oscillate',RCCE_Linear:'RCCE_Linear',RCCE_Constant:'RCCE_Constant',RCCE_None:'RCCE_None',RCCE_MAX:'RCCE_MAX', };
declare class RealCurve extends IndexedCurve { 
	DefaultValue: number;
	PreInfinityExtrap: ERichCurveExtrapolation;
	PostInfinityExtrap: ERichCurveExtrapolation;
	clone() : RealCurve;
	static C(Other: UObject | any): RealCurve;
}

declare type ERichCurveInterpMode = 'RCIM_Linear' | 'RCIM_Constant' | 'RCIM_Cubic' | 'RCIM_None' | 'RCIM_MAX';
declare var ERichCurveInterpMode : { RCIM_Linear:'RCIM_Linear',RCIM_Constant:'RCIM_Constant',RCIM_Cubic:'RCIM_Cubic',RCIM_None:'RCIM_None',RCIM_MAX:'RCIM_MAX', };
declare type ERichCurveTangentMode = 'RCTM_Auto' | 'RCTM_User' | 'RCTM_Break' | 'RCTM_None' | 'RCTM_MAX';
declare var ERichCurveTangentMode : { RCTM_Auto:'RCTM_Auto',RCTM_User:'RCTM_User',RCTM_Break:'RCTM_Break',RCTM_None:'RCTM_None',RCTM_MAX:'RCTM_MAX', };
declare type ERichCurveTangentWeightMode = 'RCTWM_WeightedNone' | 'RCTWM_WeightedArrive' | 'RCTWM_WeightedLeave' | 'RCTWM_WeightedBoth' | 'RCTWM_MAX';
declare var ERichCurveTangentWeightMode : { RCTWM_WeightedNone:'RCTWM_WeightedNone',RCTWM_WeightedArrive:'RCTWM_WeightedArrive',RCTWM_WeightedLeave:'RCTWM_WeightedLeave',RCTWM_WeightedBoth:'RCTWM_WeightedBoth',RCTWM_MAX:'RCTWM_MAX', };
declare class RichCurveKey { 
	InterpMode: ERichCurveInterpMode;
	TangentMode: ERichCurveTangentMode;
	TangentWeightMode: ERichCurveTangentWeightMode;
	Time: number;
	Value: number;
	ArriveTangent: number;
	ArriveTangentWeight: number;
	LeaveTangent: number;
	LeaveTangentWeight: number;
	clone() : RichCurveKey;
	static C(Other: UObject | any): RichCurveKey;
}

declare class RichCurve extends RealCurve { 
	Keys: RichCurveKey[];
	clone() : RichCurve;
	static C(Other: UObject | any): RichCurve;
}

declare class CurveLinearColor extends CurveBase { 
	FloatCurves: RichCurve;
	AdjustHue: number;
	AdjustSaturation: number;
	AdjustBrightness: number;
	AdjustBrightnessCurve: number;
	AdjustVibrance: number;
	AdjustMinAlpha: number;
	AdjustMaxAlpha: number;
	static Load(ResourceName: string): CurveLinearColor;
	static Find(Outer: UObject, ResourceName: string): CurveLinearColor;
	static GetDefaultObject(): CurveLinearColor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveLinearColor;
	GetUnadjustedLinearColorValue(InTime: number): LinearColor;
	GetLinearColorValue(InTime: number): LinearColor;
	GetClampedLinearColorValue(InTime: number): LinearColor;
	static C(Other: UObject | any): CurveLinearColor;
}

declare class CurveAtlasColorAdjustments { 
	bChromaKeyTexture: boolean;
	AdjustBrightness: number;
	AdjustBrightnessCurve: number;
	AdjustVibrance: number;
	AdjustSaturation: number;
	AdjustRGBCurve: number;
	AdjustHue: number;
	AdjustMinAlpha: number;
	AdjustMaxAlpha: number;
	clone() : CurveAtlasColorAdjustments;
	static C(Other: UObject | any): CurveAtlasColorAdjustments;
}

declare class CurveLinearColorAtlas extends Texture2D { 
	bIsDirty: boolean;
	TextureSize: number;
	bSquareResolution: boolean;
	TextureHeight: number;
	GradientCurves: CurveLinearColor[];
	bDisableAllAdjustments: boolean;
	bHasCachedColorAdjustments: boolean;
	CachedColorAdjustments: CurveAtlasColorAdjustments;
	static Load(ResourceName: string): CurveLinearColorAtlas;
	static Find(Outer: UObject, ResourceName: string): CurveLinearColorAtlas;
	static GetDefaultObject(): CurveLinearColorAtlas;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveLinearColorAtlas;
	GetCurvePosition(InCurve: CurveLinearColor,Position?: number): {Position: number, $: boolean};
	static C(Other: UObject | any): CurveLinearColorAtlas;
}

declare class ScalarParameterAtlasInstanceData { 
	bIsUsedAsAtlasPosition: boolean;
	Curve: CurveLinearColor;
	Atlas: CurveLinearColorAtlas;
	clone() : ScalarParameterAtlasInstanceData;
	static C(Other: UObject | any): ScalarParameterAtlasInstanceData;
}

declare class ScalarParameterValue { 
	ParameterName: string;
	AtlasData: ScalarParameterAtlasInstanceData;
	ParameterInfo: MaterialParameterInfo;
	ParameterValue: number;
	ExpressionGUID: Guid;
	clone() : ScalarParameterValue;
	static C(Other: UObject | any): ScalarParameterValue;
}

declare class VectorParameterValue { 
	ParameterName: string;
	ParameterInfo: MaterialParameterInfo;
	ParameterValue: LinearColor;
	ExpressionGUID: Guid;
	clone() : VectorParameterValue;
	static C(Other: UObject | any): VectorParameterValue;
}

declare class Vector4d { 
	X: number;
	Y: number;
	Z: number;
	W: number;
	clone() : Vector4d;
	static C(Other: UObject | any): Vector4d;
}

declare class DoubleVectorParameterValue { 
	ParameterInfo: MaterialParameterInfo;
	ParameterValue: Vector4d;
	ExpressionGUID: Guid;
	clone() : DoubleVectorParameterValue;
	static C(Other: UObject | any): DoubleVectorParameterValue;
}

declare class TextureParameterValue { 
	ParameterName: string;
	ParameterInfo: MaterialParameterInfo;
	ParameterValue: Texture;
	ExpressionGUID: Guid;
	clone() : TextureParameterValue;
	static C(Other: UObject | any): TextureParameterValue;
}

declare type ERuntimeVirtualTextureMaterialType = 'BaseColor' | 'BaseColor_Normal_DEPRECATED' | 'BaseColor_Normal_Roughness' | 'BaseColor_Normal_Specular' | 'BaseColor_Normal_Specular_YCoCg' | 'BaseColor_Normal_Specular_Mask_YCoCg' | 'WorldHeight' | 'Count' | 'ERuntimeVirtualTextureMaterialType_MAX';
declare var ERuntimeVirtualTextureMaterialType : { BaseColor:'BaseColor',BaseColor_Normal_DEPRECATED:'BaseColor_Normal_DEPRECATED',BaseColor_Normal_Roughness:'BaseColor_Normal_Roughness',BaseColor_Normal_Specular:'BaseColor_Normal_Specular',BaseColor_Normal_Specular_YCoCg:'BaseColor_Normal_Specular_YCoCg',BaseColor_Normal_Specular_Mask_YCoCg:'BaseColor_Normal_Specular_Mask_YCoCg',WorldHeight:'WorldHeight',Count:'Count',ERuntimeVirtualTextureMaterialType_MAX:'ERuntimeVirtualTextureMaterialType_MAX', };
declare class RuntimeVirtualTextureStreamingProxy extends Texture2D { 
	static Load(ResourceName: string): RuntimeVirtualTextureStreamingProxy;
	static Find(Outer: UObject, ResourceName: string): RuntimeVirtualTextureStreamingProxy;
	static GetDefaultObject(): RuntimeVirtualTextureStreamingProxy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RuntimeVirtualTextureStreamingProxy;
	static C(Other: UObject | any): RuntimeVirtualTextureStreamingProxy;
}

declare class RuntimeVirtualTexture extends UObject { 
	TileCount: number;
	TileSize: number;
	TileBorderSize: number;
	MaterialType: ERuntimeVirtualTextureMaterialType;
	bCompressTextures: boolean;
	bUseLowQualityCompression: boolean;
	bClearTextures: boolean;
	bSinglePhysicalSpace: boolean;
	bPrivateSpace: boolean;
	bAdaptive: boolean;
	bContinuousUpdate: boolean;
	RemoveLowMips: number;
	LODGroup: TextureGroup;
	Size: number;
	StreamingTexture: RuntimeVirtualTextureStreamingProxy;
	static Load(ResourceName: string): RuntimeVirtualTexture;
	static Find(Outer: UObject, ResourceName: string): RuntimeVirtualTexture;
	static GetDefaultObject(): RuntimeVirtualTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RuntimeVirtualTexture;
	GetTileSize(): number;
	GetTileCount(): number;
	GetTileBorderSize(): number;
	GetSize(): number;
	GetPageTableSize(): number;
	static C(Other: UObject | any): RuntimeVirtualTexture;
}

declare class RuntimeVirtualTextureParameterValue { 
	ParameterInfo: MaterialParameterInfo;
	ParameterValue: RuntimeVirtualTexture;
	ExpressionGUID: Guid;
	clone() : RuntimeVirtualTextureParameterValue;
	static C(Other: UObject | any): RuntimeVirtualTextureParameterValue;
}

declare type EFontCacheType = 'Offline' | 'Runtime' | 'EFontCacheType_MAX';
declare var EFontCacheType : { Offline:'Offline',Runtime:'Runtime',EFontCacheType_MAX:'EFontCacheType_MAX', };
declare class FontCharacter { 
	StartU: number;
	StartV: number;
	USize: number;
	VSize: number;
	TextureIndex: number;
	VerticalOffset: number;
	clone() : FontCharacter;
	static C(Other: UObject | any): FontCharacter;
}

declare type EFontImportCharacterSet = 'FontICS_Default' | 'FontICS_Ansi' | 'FontICS_Symbol' | 'FontICS_MAX';
declare var EFontImportCharacterSet : { FontICS_Default:'FontICS_Default',FontICS_Ansi:'FontICS_Ansi',FontICS_Symbol:'FontICS_Symbol',FontICS_MAX:'FontICS_MAX', };
declare class FontImportOptionsData { 
	FontName: string;
	Height: number;
	bEnableAntialiasing: boolean;
	bEnableBold: boolean;
	bEnableItalic: boolean;
	bEnableUnderline: boolean;
	bAlphaOnly: boolean;
	CharacterSet: EFontImportCharacterSet;
	Chars: string;
	UnicodeRange: string;
	CharsFilePath: string;
	CharsFileWildcard: string;
	bCreatePrintableOnly: boolean;
	bIncludeASCIIRange: boolean;
	ForegroundColor: LinearColor;
	bEnableDropShadow: boolean;
	TexturePageWidth: number;
	TexturePageMaxHeight: number;
	XPadding: number;
	YPadding: number;
	ExtendBoxTop: number;
	ExtendBoxBottom: number;
	ExtendBoxRight: number;
	ExtendBoxLeft: number;
	bEnableLegacyMode: boolean;
	Kerning: number;
	bUseDistanceFieldAlpha: boolean;
	DistanceFieldScaleFactor: number;
	DistanceFieldScanRadiusScale: number;
	clone() : FontImportOptionsData;
	static C(Other: UObject | any): FontImportOptionsData;
}

declare type EFontHinting = 'Default' | 'Auto' | 'AutoLight' | 'Monochrome' | 'None' | 'EFontHinting_MAX';
declare var EFontHinting : { Default:'Default',Auto:'Auto',AutoLight:'AutoLight',Monochrome:'Monochrome',None:'None',EFontHinting_MAX:'EFontHinting_MAX', };
declare type EFontLoadingPolicy = 'LazyLoad' | 'Stream' | 'Inline' | 'EFontLoadingPolicy_MAX';
declare var EFontLoadingPolicy : { LazyLoad:'LazyLoad',Stream:'Stream',Inline:'Inline',EFontLoadingPolicy_MAX:'EFontLoadingPolicy_MAX', };
declare class FontBulkData extends UObject { 
	static Load(ResourceName: string): FontBulkData;
	static Find(Outer: UObject, ResourceName: string): FontBulkData;
	static GetDefaultObject(): FontBulkData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FontBulkData;
	static C(Other: UObject | any): FontBulkData;
}

declare class FontData { 
	FontFilename: string;
	Hinting: EFontHinting;
	LoadingPolicy: EFontLoadingPolicy;
	SubFaceIndex: number;
	FontFaceAsset: UObject;
	BulkDataPtr: FontBulkData;
	FontData: number[];
	clone() : FontData;
	static C(Other: UObject | any): FontData;
}

declare class TypefaceEntry { 
	Name: string;
	Font: FontData;
	clone() : TypefaceEntry;
	static C(Other: UObject | any): TypefaceEntry;
}

declare class Typeface { 
	Fonts: TypefaceEntry[];
	clone() : Typeface;
	static C(Other: UObject | any): Typeface;
}

declare class CompositeFallbackFont { 
	Typeface: Typeface;
	ScalingFactor: number;
	clone() : CompositeFallbackFont;
	static C(Other: UObject | any): CompositeFallbackFont;
}

declare type ERangeBoundTypes = 'Exclusive' | 'Inclusive' | 'Open' | 'ERangeBoundTypes_MAX';
declare var ERangeBoundTypes : { Exclusive:'Exclusive',Inclusive:'Inclusive',Open:'Open',ERangeBoundTypes_MAX:'ERangeBoundTypes_MAX', };
declare class Int32RangeBound { 
	Type: ERangeBoundTypes;
	Value: number;
	clone() : Int32RangeBound;
	static C(Other: UObject | any): Int32RangeBound;
}

declare class Int32Range { 
	LowerBound: Int32RangeBound;
	UpperBound: Int32RangeBound;
	clone() : Int32Range;
	static C(Other: UObject | any): Int32Range;
}

declare class CompositeSubFont extends CompositeFallbackFont { 
	CharacterRanges: Int32Range[];
	Cultures: string;
	EditorName: string;
	clone() : CompositeSubFont;
	static C(Other: UObject | any): CompositeSubFont;
}

declare class CompositeFont { 
	DefaultTypeface: Typeface;
	FallbackTypeface: CompositeFallbackFont;
	SubTypefaces: CompositeSubFont[];
	clone() : CompositeFont;
	static C(Other: UObject | any): CompositeFont;
}

declare class Font extends UObject { 
	FontCacheType: EFontCacheType;
	Characters: FontCharacter[];
	Textures: Texture2D[];
	IsRemapped: number;
	EmScale: number;
	Ascent: number;
	Descent: number;
	Leading: number;
	Kerning: number;
	ImportOptions: FontImportOptionsData;
	NumCharacters: number;
	MaxCharHeight: number[];
	ScalingFactor: number;
	LegacyFontSize: number;
	LegacyFontName: string;
	CompositeFont: CompositeFont;
	static Load(ResourceName: string): Font;
	static Find(Outer: UObject, ResourceName: string): Font;
	static GetDefaultObject(): Font;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Font;
	static C(Other: UObject | any): Font;
}

declare class FontParameterValue { 
	ParameterName: string;
	ParameterInfo: MaterialParameterInfo;
	FontValue: Font;
	FontPage: number;
	ExpressionGUID: Guid;
	clone() : FontParameterValue;
	static C(Other: UObject | any): FontParameterValue;
}

declare class MaterialInstanceBasePropertyOverrides { 
	bOverride_OpacityMaskClipValue: boolean;
	bOverride_BlendMode: boolean;
	bOverride_ShadingModel: boolean;
	bOverride_DitheredLODTransition: boolean;
	bOverride_CastDynamicShadowAsMasked: boolean;
	bOverride_TwoSided: boolean;
	bOverride_OutputTranslucentVelocity: boolean;
	TwoSided: boolean;
	DitheredLODTransition: boolean;
	bCastDynamicShadowAsMasked: boolean;
	bOutputTranslucentVelocity: boolean;
	BlendMode: EBlendMode;
	ShadingModel: EMaterialShadingModel;
	OpacityMaskClipValue: number;
	clone() : MaterialInstanceBasePropertyOverrides;
	static C(Other: UObject | any): MaterialInstanceBasePropertyOverrides;
}

declare class MaterialLayersFunctionsRuntimeData { 
	Layers: MaterialFunctionInterface[];
	Blends: MaterialFunctionInterface[];
	clone() : MaterialLayersFunctionsRuntimeData;
	static C(Other: UObject | any): MaterialLayersFunctionsRuntimeData;
}

declare class StaticParameterSetRuntimeData { 
	MaterialLayers: MaterialLayersFunctionsRuntimeData;
	bHasMaterialLayers: boolean;
	clone() : StaticParameterSetRuntimeData;
	static C(Other: UObject | any): StaticParameterSetRuntimeData;
}

declare class StaticParameterBase { 
	ParameterInfo: MaterialParameterInfo;
	bOverride: boolean;
	ExpressionGUID: Guid;
	clone() : StaticParameterBase;
	static C(Other: UObject | any): StaticParameterBase;
}

declare class StaticSwitchParameter extends StaticParameterBase { 
	Value: boolean;
	clone() : StaticSwitchParameter;
	static C(Other: UObject | any): StaticSwitchParameter;
}

declare class StaticComponentMaskParameter extends StaticParameterBase { 
	R: boolean;
	G: boolean;
	B: boolean;
	A: boolean;
	clone() : StaticComponentMaskParameter;
	static C(Other: UObject | any): StaticComponentMaskParameter;
}

declare class StaticTerrainLayerWeightParameter { 
	ParameterInfo: MaterialParameterInfo;
	ExpressionGUID: Guid;
	bOverride: boolean;
	LayerName: string;
	WeightmapIndex: number;
	bWeightBasedBlend: boolean;
	clone() : StaticTerrainLayerWeightParameter;
	static C(Other: UObject | any): StaticTerrainLayerWeightParameter;
}

declare type EMaterialLayerLinkState = 'Uninitialized' | 'LinkedToParent' | 'UnlinkedFromParent' | 'NotFromParent' | 'EMaterialLayerLinkState_MAX';
declare var EMaterialLayerLinkState : { Uninitialized:'Uninitialized',LinkedToParent:'LinkedToParent',UnlinkedFromParent:'UnlinkedFromParent',NotFromParent:'NotFromParent',EMaterialLayerLinkState_MAX:'EMaterialLayerLinkState_MAX', };
declare class MaterialLayersFunctionsEditorOnlyData { 
	LayerStates: boolean[];
	LayerNames: string[];
	RestrictToLayerRelatives: boolean[];
	RestrictToBlendRelatives: boolean[];
	LayerGuids: Guid[];
	LayerLinkStates: EMaterialLayerLinkState[];
	DeletedParentLayerGuids: Guid[];
	clone() : MaterialLayersFunctionsEditorOnlyData;
	static C(Other: UObject | any): MaterialLayersFunctionsEditorOnlyData;
}

declare class StaticParameterSetEditorOnlyData { 
	StaticSwitchParameters: StaticSwitchParameter[];
	StaticComponentMaskParameters: StaticComponentMaskParameter[];
	TerrainLayerWeightParameters: StaticTerrainLayerWeightParameter[];
	MaterialLayers: MaterialLayersFunctionsEditorOnlyData;
	clone() : StaticParameterSetEditorOnlyData;
	static C(Other: UObject | any): StaticParameterSetEditorOnlyData;
}

declare class MaterialLayersFunctions extends MaterialLayersFunctionsRuntimeData { 
	EditorOnly: MaterialLayersFunctionsEditorOnlyData;
	LayerStates: boolean[];
	LayerNames: string[];
	RestrictToLayerRelatives: boolean[];
	RestrictToBlendRelatives: boolean[];
	LayerGuids: Guid[];
	LayerLinkStates: EMaterialLayerLinkState[];
	DeletedParentLayerGuids: Guid[];
	clone() : MaterialLayersFunctions;
	static C(Other: UObject | any): MaterialLayersFunctions;
}

declare class StaticMaterialLayersParameter extends StaticParameterBase { 
	Value: MaterialLayersFunctions;
	clone() : StaticMaterialLayersParameter;
	static C(Other: UObject | any): StaticMaterialLayersParameter;
}

declare class StaticParameterSet extends StaticParameterSetRuntimeData { 
	EditorOnly: StaticParameterSetEditorOnlyData;
	MaterialLayersParameters: StaticMaterialLayersParameter[];
	StaticSwitchParameters: StaticSwitchParameter[];
	StaticComponentMaskParameters: StaticComponentMaskParameter[];
	TerrainLayerWeightParameters: StaticTerrainLayerWeightParameter[];
	clone() : StaticParameterSet;
	static C(Other: UObject | any): StaticParameterSet;
}

declare class MaterialInstance extends MaterialInterface { 
	PhysMaterial: PhysicalMaterial;
	PhysicalMaterialMap: PhysicalMaterial;
	Parent: MaterialInterface;
	NaniteOverrideMaterial: MaterialOverrideNanite;
	bHasStaticPermutationResource: boolean;
	bOverrideSubsurfaceProfile: boolean;
	ScalarParameterValues: ScalarParameterValue[];
	VectorParameterValues: VectorParameterValue[];
	DoubleVectorParameterValues: DoubleVectorParameterValue[];
	TextureParameterValues: TextureParameterValue[];
	RuntimeVirtualTextureParameterValues: RuntimeVirtualTextureParameterValue[];
	FontParameterValues: FontParameterValue[];
	bOverrideBaseProperties: boolean;
	BasePropertyOverrides: MaterialInstanceBasePropertyOverrides;
	StaticParametersRuntime: StaticParameterSetRuntimeData;
	ReferencedTextureGuids: Guid[];
	StaticParameters: StaticParameterSet;
	bSavedCachedData: boolean;
	static Load(ResourceName: string): MaterialInstance;
	static Find(Outer: UObject, ResourceName: string): MaterialInstance;
	static GetDefaultObject(): MaterialInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialInstance;
	static C(Other: UObject | any): MaterialInstance;
}

declare class MaterialInstanceDynamic extends MaterialInstance { 
	static Load(ResourceName: string): MaterialInstanceDynamic;
	static Find(Outer: UObject, ResourceName: string): MaterialInstanceDynamic;
	static GetDefaultObject(): MaterialInstanceDynamic;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialInstanceDynamic;
	SetVectorParameterValueByInfo(ParameterInfo: MaterialParameterInfo,Value: LinearColor): void;
	SetVectorParameterValue(ParameterName: string,Value: LinearColor): void;
	SetTextureParameterValueByInfo(ParameterInfo: MaterialParameterInfo,Value: Texture): void;
	SetTextureParameterValue(ParameterName: string,Value: Texture): void;
	SetScalarParameterValueByInfo(ParameterInfo: MaterialParameterInfo,Value: number): void;
	SetScalarParameterValue(ParameterName: string,Value: number): void;
	SetScalarParameterByIndex(ParameterIndex: number,Value: number): boolean;
	SetRuntimeVirtualTextureParameterValueByInfo(ParameterInfo: MaterialParameterInfo,Value: RuntimeVirtualTexture): void;
	SetRuntimeVirtualTextureParameterValue(ParameterName: string,Value: RuntimeVirtualTexture): void;
	SetDoubleVectorParameterValue(ParameterName: string,Value: Vector4): void;
	K2_InterpolateMaterialInstanceParams(SourceA: MaterialInstance,SourceB: MaterialInstance,Alpha: number): void;
	K2_GetVectorParameterValueByInfo(ParameterInfo: MaterialParameterInfo): LinearColor;
	K2_GetVectorParameterValue(ParameterName: string): LinearColor;
	K2_GetTextureParameterValueByInfo(ParameterInfo: MaterialParameterInfo): Texture;
	K2_GetTextureParameterValue(ParameterName: string): Texture;
	K2_GetScalarParameterValueByInfo(ParameterInfo: MaterialParameterInfo): number;
	K2_GetScalarParameterValue(ParameterName: string): number;
	K2_CopyMaterialInstanceParameters(Source: MaterialInterface,bQuickParametersOnly: boolean): void;
	InitializeScalarParameterAndGetIndex(ParameterName: string,Value: number,OutParameterIndex?: number): {OutParameterIndex: number, $: boolean};
	CopyParameterOverrides(MaterialInstance: MaterialInstance): void;
	CopyInterpParameters(Source: MaterialInstance): void;
	static C(Other: UObject | any): MaterialInstanceDynamic;
}

declare class DecalComponent extends SceneComponent { 
	DecalMaterial: MaterialInterface;
	SortOrder: number;
	FadeScreenSize: number;
	FadeStartDelay: number;
	FadeDuration: number;
	FadeInDuration: number;
	FadeInStartDelay: number;
	bDestroyOwnerAfterFade: boolean;
	DecalSize: Vector;
	static Load(ResourceName: string): DecalComponent;
	static Find(Outer: UObject, ResourceName: string): DecalComponent;
	static GetDefaultObject(): DecalComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DecalComponent;
	SetSortOrder(Value: number): void;
	SetFadeScreenSize(NewFadeScreenSize: number): void;
	SetFadeOut(StartDelay: number,Duration: number,DestroyOwnerAfterFade: boolean): void;
	SetFadeIn(StartDelay: number,Duaration: number): void;
	SetDecalMaterial(NewDecalMaterial: MaterialInterface): void;
	GetFadeStartDelay(): number;
	GetFadeInStartDelay(): number;
	GetFadeInDuration(): number;
	GetFadeDuration(): number;
	GetDecalMaterial(): MaterialInterface;
	CreateDynamicMaterialInstance(): MaterialInstanceDynamic;
	static C(Other: UObject | any): DecalComponent;
}

declare class AssetData { 
	ObjectPath: string;
	PackageName: string;
	PackagePath: string;
	AssetName: string;
	AssetClass: string;
	AssetClassPath: TopLevelAssetPath;
	clone() : AssetData;
	static C(Other: UObject | any): AssetData;
	GetAllTagsByAssetData(OutArray?: string[]): {OutArray: string[]};
	GetTagValueByAssetData(Name: string,OutValue?: string): {OutValue: string, $: boolean};
	static GetAllTagsByAssetData(AssetData: AssetData,OutArray?: string[]): {OutArray: string[]};
	static GetTagValueByAssetData(AssetData: AssetData,Name: string,OutValue?: string): {OutValue: string, $: boolean};
	static FindAssetData(AssetPath: string): AssetData;
}

declare class MaterialStatistics { 
	NumVertexShaderInstructions: number;
	NumPixelShaderInstructions: number;
	NumSamplers: number;
	NumVertexTextureSamples: number;
	NumPixelTextureSamples: number;
	NumVirtualTextureSamples: number;
	NumUVScalars: number;
	NumInterpolatorScalars: number;
	clone() : MaterialStatistics;
	static C(Other: UObject | any): MaterialStatistics;
}

declare class MaterialInterface extends UObject { 
	EditorOnlyData: MaterialInterfaceEditorOnlyData;
	SubsurfaceProfile: SubsurfaceProfile;
	LightmassSettings: LightmassMaterialInterfaceSettings;
	bTextureStreamingDataSorted: boolean;
	TextureStreamingDataVersion: number;
	TextureStreamingData: MaterialTextureInfo[];
	AssetUserData: AssetUserData[];
	TextureStreamingDataMissingEntries: MaterialTextureInfo[];
	PreviewMesh: SoftObjectPath;
	ThumbnailInfo: ThumbnailInfo;
	LayerParameterExpansion: Map<string, boolean>;
	ParameterOverviewExpansion: Map<string, boolean>;
	AssetImportData: AssetImportData;
	LightingGuid: Guid;
	static Load(ResourceName: string): MaterialInterface;
	static Find(Outer: UObject, ResourceName: string): MaterialInterface;
	static GetDefaultObject(): MaterialInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialInterface;
	SetForceMipLevelsToBeResident(OverrideForceMiplevelsToBeResident: boolean,bForceMiplevelsToBeResidentValue: boolean,ForceDuration: number,CinematicTextureGroups: number,bFastResponse: boolean): void;
	GetPhysicalMaterialMask(): PhysicalMaterialMask;
	GetPhysicalMaterialFromMap(Index: number): PhysicalMaterial;
	GetPhysicalMaterial(): PhysicalMaterial;
	GetParameterInfo(Association: EMaterialParameterAssociation,ParameterName: string,LayerFunction: MaterialFunctionInterface): MaterialParameterInfo;
	GetBlendMode(): EBlendMode;
	GetBaseMaterial(): Material;
	static C(Other: UObject | any): MaterialInterface;
	SpawnDecalAttached(DecalSize: Vector,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,LifeSpan: number): DecalComponent;
	MakeBrushFromMaterial(Width: number,Height: number): SlateBrush;
	GetChildInstances(ChildInstances?: AssetData[]): {ChildInstances: AssetData[]};
	GetScalarParameterNames(ParameterNames?: string[]): {ParameterNames: string[]};
	GetScalarParameterSource(ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	GetStaticSwitchParameterNames(ParameterNames?: string[]): {ParameterNames: string[]};
	GetStaticSwitchParameterSource(ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	GetStatistics(): MaterialStatistics;
	GetTextureParameterNames(ParameterNames?: string[]): {ParameterNames: string[]};
	GetTextureParameterSource(ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	GetVectorParameterNames(ParameterNames?: string[]): {ParameterNames: string[]};
	GetVectorParameterSource(ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	static SpawnDecalAttached(DecalMaterial: MaterialInterface,DecalSize: Vector,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,LifeSpan: number): DecalComponent;
	static MakeBrushFromMaterial(Material: MaterialInterface,Width: number,Height: number): SlateBrush;
	static GetChildInstances(Parent: MaterialInterface,ChildInstances?: AssetData[]): {ChildInstances: AssetData[]};
	static GetScalarParameterNames(Material: MaterialInterface,ParameterNames?: string[]): {ParameterNames: string[]};
	static GetScalarParameterSource(Material: MaterialInterface,ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	static GetStaticSwitchParameterNames(Material: MaterialInterface,ParameterNames?: string[]): {ParameterNames: string[]};
	static GetStaticSwitchParameterSource(Material: MaterialInterface,ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	static GetStatistics(Material: MaterialInterface): MaterialStatistics;
	static GetTextureParameterNames(Material: MaterialInterface,ParameterNames?: string[]): {ParameterNames: string[]};
	static GetTextureParameterSource(Material: MaterialInterface,ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
	static GetVectorParameterNames(Material: MaterialInterface,ParameterNames?: string[]): {ParameterNames: string[]};
	static GetVectorParameterSource(Material: MaterialInterface,ParameterName: string,ParameterSource?: SoftObjectPath): {ParameterSource: SoftObjectPath, $: boolean};
}

declare class SlateBrush { 
	bIsDynamicallyLoaded: boolean;
	bHasUObject: boolean;
	DrawAs: ESlateBrushDrawType;
	Tiling: ESlateBrushTileType;
	Mirroring: ESlateBrushMirrorType;
	ImageType: ESlateBrushImageType;
	ImageSize: Vector2D;
	Margin: Margin;
	Tint: LinearColor;
	TintColor: SlateColor;
	OutlineSettings: SlateBrushOutlineSettings;
	ResourceObject: UObject;
	ResourceName: string;
	UVRegion: Box2f;
	clone() : SlateBrush;
	static C(Other: UObject | any): SlateBrush;
	GetBrushResource(): UObject;
	GetBrushResourceAsMaterial(): MaterialInterface;
	GetBrushResourceAsTexture2D(): Texture2D;
	GetDynamicMaterial(): {Brush: SlateBrush, $: MaterialInstanceDynamic};
	SetBrushResourceToMaterial(Material?: MaterialInterface): {Brush: SlateBrush};
	SetBrushResourceToTexture(Texture?: Texture2D): {Brush: SlateBrush};
	EqualEqual_SlateBrush(B: SlateBrush): boolean;
	static GetBrushResource(Brush: SlateBrush): UObject;
	static GetBrushResourceAsMaterial(Brush: SlateBrush): MaterialInterface;
	static GetBrushResourceAsTexture2D(Brush: SlateBrush): Texture2D;
	static GetDynamicMaterial(Brush?: SlateBrush): {Brush: SlateBrush, $: MaterialInstanceDynamic};
	static SetBrushResourceToMaterial(Brush?: SlateBrush,Material?: MaterialInterface): {Brush: SlateBrush};
	static SetBrushResourceToTexture(Brush?: SlateBrush,Texture?: Texture2D): {Brush: SlateBrush};
	static EqualEqual_SlateBrush(A: SlateBrush,B: SlateBrush): boolean;
	static NoResourceBrush(): SlateBrush;
}

declare class Texture2D extends Texture { 
	FirstResourceMemMip: number;
	bTemporarilyDisableStreaming: boolean;
	bHasBeenPaintedInEditor: boolean;
	AddressX: TextureAddress;
	AddressY: TextureAddress;
	ImportedSize: IntPoint;
	static Load(ResourceName: string): Texture2D;
	static Find(Outer: UObject, ResourceName: string): Texture2D;
	static GetDefaultObject(): Texture2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Texture2D;
	Blueprint_GetSizeY(): number;
	Blueprint_GetSizeX(): number;
	static C(Other: UObject | any): Texture2D;
	MakeImportanceTexture(WeightingFunc: EImportanceWeight): ImportanceTexture;
	MakeBrushFromTexture(Width: number,Height: number): SlateBrush;
	static MakeImportanceTexture(Texture: Texture2D,WeightingFunc: EImportanceWeight): ImportanceTexture;
	static MakeBrushFromTexture(Texture: Texture2D,Width: number,Height: number): SlateBrush;
}

declare class SpriteCategoryInfo { 
	Category: string;
	DisplayName: string;
	Description: string;
	clone() : SpriteCategoryInfo;
	static C(Other: UObject | any): SpriteCategoryInfo;
}

declare class BillboardComponent extends PrimitiveComponent { 
	Sprite: Texture2D;
	bIsScreenSizeScaled: boolean;
	ScreenSize: number;
	U: number;
	UL: number;
	V: number;
	VL: number;
	OpacityMaskRefVal: number;
	SpriteCategoryName: string;
	SpriteInfo: SpriteCategoryInfo;
	bUseInEditorScaling: boolean;
	bShowLockedLocation: boolean;
	static Load(ResourceName: string): BillboardComponent;
	static Find(Outer: UObject, ResourceName: string): BillboardComponent;
	static GetDefaultObject(): BillboardComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BillboardComponent;
	SetUV(NewU: number,NewUL: number,NewV: number,NewVL: number): void;
	SetSpriteAndUV(NewSprite: Texture2D,NewU: number,NewUL: number,NewV: number,NewVL: number): void;
	SetSprite(NewSprite: Texture2D): void;
	SetOpacityMaskRefVal(RefVal: number): void;
	static C(Other: UObject | any): BillboardComponent;
}

declare class NavigationObjectBase extends Actor { 
	CapsuleComponent: CapsuleComponent;
	GoodSprite: BillboardComponent;
	BadSprite: BillboardComponent;
	bIsPIEPlayerStart: boolean;
	static GetDefaultObject(): NavigationObjectBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationObjectBase;
	static C(Other: UObject | any): NavigationObjectBase;
}

declare class NavigationDataChunk extends UObject { 
	NavigationDataName: string;
	static Load(ResourceName: string): NavigationDataChunk;
	static Find(Outer: UObject, ResourceName: string): NavigationDataChunk;
	static GetDefaultObject(): NavigationDataChunk;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationDataChunk;
	static C(Other: UObject | any): NavigationDataChunk;
}

declare type ELightingBuildQuality = 'Quality_Preview' | 'Quality_Medium' | 'Quality_High' | 'Quality_Production' | 'Quality_MAX';
declare var ELightingBuildQuality : { Quality_Preview:'Quality_Preview',Quality_Medium:'Quality_Medium',Quality_High:'Quality_High',Quality_Production:'Quality_Production',Quality_MAX:'Quality_MAX', };
declare class MapBuildDataRegistry extends UObject { 
	LevelLightingQuality: ELightingBuildQuality;
	static Load(ResourceName: string): MapBuildDataRegistry;
	static Find(Outer: UObject, ResourceName: string): MapBuildDataRegistry;
	static GetDefaultObject(): MapBuildDataRegistry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MapBuildDataRegistry;
	static C(Other: UObject | any): MapBuildDataRegistry;
}

declare type ETextureSizingType = 'TextureSizingType_UseSingleTextureSize' | 'TextureSizingType_UseAutomaticBiasedSizes' | 'TextureSizingType_UseManualOverrideTextureSize' | 'TextureSizingType_UseSimplygonAutomaticSizing' | 'TextureSizingType_AutomaticFromTexelDensity' | 'TextureSizingType_AutomaticFromMeshScreenSize' | 'TextureSizingType_AutomaticFromMeshDrawDistance' | 'TextureSizingType_MAX';
declare var ETextureSizingType : { TextureSizingType_UseSingleTextureSize:'TextureSizingType_UseSingleTextureSize',TextureSizingType_UseAutomaticBiasedSizes:'TextureSizingType_UseAutomaticBiasedSizes',TextureSizingType_UseManualOverrideTextureSize:'TextureSizingType_UseManualOverrideTextureSize',TextureSizingType_UseSimplygonAutomaticSizing:'TextureSizingType_UseSimplygonAutomaticSizing',TextureSizingType_AutomaticFromTexelDensity:'TextureSizingType_AutomaticFromTexelDensity',TextureSizingType_AutomaticFromMeshScreenSize:'TextureSizingType_AutomaticFromMeshScreenSize',TextureSizingType_AutomaticFromMeshDrawDistance:'TextureSizingType_AutomaticFromMeshDrawDistance',TextureSizingType_MAX:'TextureSizingType_MAX', };
declare type EMaterialMergeType = 'MaterialMergeType_Default' | 'MaterialMergeType_Simplygon' | 'MaterialMergeType_MAX';
declare var EMaterialMergeType : { MaterialMergeType_Default:'MaterialMergeType_Default',MaterialMergeType_Simplygon:'MaterialMergeType_Simplygon',MaterialMergeType_MAX:'MaterialMergeType_MAX', };
declare class MaterialProxySettings { 
	TextureSizingType: ETextureSizingType;
	TextureSize: IntPoint;
	TargetTexelDensityPerMeter: number;
	MeshMaxScreenSizePercent: number;
	MeshMinDrawDistance: number;
	GutterSpace: number;
	MetallicConstant: number;
	RoughnessConstant: number;
	AnisotropyConstant: number;
	SpecularConstant: number;
	OpacityConstant: number;
	OpacityMaskConstant: number;
	AmbientOcclusionConstant: number;
	MaterialMergeType: EMaterialMergeType;
	BlendMode: EBlendMode;
	bAllowTwoSidedMaterial: boolean;
	bNormalMap: boolean;
	bTangentMap: boolean;
	bMetallicMap: boolean;
	bRoughnessMap: boolean;
	bAnisotropyMap: boolean;
	bSpecularMap: boolean;
	bEmissiveMap: boolean;
	bOpacityMap: boolean;
	bOpacityMaskMap: boolean;
	bAmbientOcclusionMap: boolean;
	DiffuseTextureSize: IntPoint;
	NormalTextureSize: IntPoint;
	TangentTextureSize: IntPoint;
	MetallicTextureSize: IntPoint;
	RoughnessTextureSize: IntPoint;
	AnisotropyTextureSize: IntPoint;
	SpecularTextureSize: IntPoint;
	EmissiveTextureSize: IntPoint;
	OpacityTextureSize: IntPoint;
	OpacityMaskTextureSize: IntPoint;
	AmbientOcclusionTextureSize: IntPoint;
	clone() : MaterialProxySettings;
	static C(Other: UObject | any): MaterialProxySettings;
}

declare class LevelSimplificationDetails { 
	bCreatePackagePerAsset: boolean;
	DetailsPercentage: number;
	StaticMeshMaterialSettings: MaterialProxySettings;
	bOverrideLandscapeExportLOD: boolean;
	LandscapeExportLOD: number;
	LandscapeMaterialSettings: MaterialProxySettings;
	bBakeFoliageToLandscape: boolean;
	bBakeGrassToLandscape: boolean;
	clone() : LevelSimplificationDetails;
	static C(Other: UObject | any): LevelSimplificationDetails;
}

declare type EActorPackagingScheme = 'Original' | 'Reduced' | 'EActorPackagingScheme_MAX';
declare var EActorPackagingScheme : { Original:'Original',Reduced:'Reduced',EActorPackagingScheme_MAX:'EActorPackagingScheme_MAX', };
declare class Info extends Actor { 
	SpriteComponent: BillboardComponent;
	static GetDefaultObject(): Info;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Info;
	static C(Other: UObject | any): Info;
}

declare type EVisibilityAggressiveness = 'VIS_LeastAggressive' | 'VIS_ModeratelyAggressive' | 'VIS_MostAggressive' | 'VIS_Max';
declare var EVisibilityAggressiveness : { VIS_LeastAggressive:'VIS_LeastAggressive',VIS_ModeratelyAggressive:'VIS_ModeratelyAggressive',VIS_MostAggressive:'VIS_MostAggressive',VIS_Max:'VIS_Max', };
declare class Field extends UObject { 
	static Load(ResourceName: string): Field;
	static Find(Outer: UObject, ResourceName: string): Field;
	static GetDefaultObject(): Field;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Field;
	static C(Other: UObject | any): Field;
	HasMetaData(Key: string): boolean;
	GetMetaData(Key: string): string;
	static HasMetaData(Field: Field,Key: string): boolean;
	static GetMetaData(Field: Field,Key: string): string;
}

declare class Struct extends Field { 
	static Load(ResourceName: string): Struct;
	static Find(Outer: UObject, ResourceName: string): Struct;
	static GetDefaultObject(): Struct;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Struct;
	static C(Other: UObject | any): Struct;
}

declare class DynamicBlueprintBinding extends UObject { 
	static Load(ResourceName: string): DynamicBlueprintBinding;
	static Find(Outer: UObject, ResourceName: string): DynamicBlueprintBinding;
	static GetDefaultObject(): DynamicBlueprintBinding;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicBlueprintBinding;
	static C(Other: UObject | any): DynamicBlueprintBinding;
}

declare class DatasmithObjectTemplate extends UObject { 
	static Load(ResourceName: string): DatasmithObjectTemplate;
	static Find(Outer: UObject, ResourceName: string): DatasmithObjectTemplate;
	static GetDefaultObject(): DatasmithObjectTemplate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DatasmithObjectTemplate;
	static C(Other: UObject | any): DatasmithObjectTemplate;
}

declare class DatasmithAssetUserData extends AssetUserData { 
	MetaData: Map<string, string>;
	ObjectTemplates: Map<UnrealEngineClass, DatasmithObjectTemplate>;
	static Load(ResourceName: string): DatasmithAssetUserData;
	static Find(Outer: UObject, ResourceName: string): DatasmithAssetUserData;
	static GetDefaultObject(): DatasmithAssetUserData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DatasmithAssetUserData;
	static C(Other: UObject | any): DatasmithAssetUserData;
}

declare class Subsystem extends UObject { 
	static Load(ResourceName: string): Subsystem;
	static Find(Outer: UObject, ResourceName: string): Subsystem;
	static GetDefaultObject(): Subsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Subsystem;
	static C(Other: UObject | any): Subsystem;
}

declare class DynamicSubsystem extends Subsystem { 
	static Load(ResourceName: string): DynamicSubsystem;
	static Find(Outer: UObject, ResourceName: string): DynamicSubsystem;
	static GetDefaultObject(): DynamicSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DynamicSubsystem;
	static C(Other: UObject | any): DynamicSubsystem;
}

declare class EngineSubsystem extends DynamicSubsystem { 
	static Load(ResourceName: string): EngineSubsystem;
	static Find(Outer: UObject, ResourceName: string): EngineSubsystem;
	static GetDefaultObject(): EngineSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EngineSubsystem;
	static C(Other: UObject | any): EngineSubsystem;
}

declare type EDataLayerRuntimeState = 'Unloaded' | 'Loaded' | 'Activated' | 'EDataLayerRuntimeState_MAX';
declare var EDataLayerRuntimeState : { Unloaded:'Unloaded',Loaded:'Loaded',Activated:'Activated',EDataLayerRuntimeState_MAX:'EDataLayerRuntimeState_MAX', };
declare type EDataLayerType = 'Runtime' | 'Editor' | 'Unknown' | 'Size' | 'EDataLayerType_MAX';
declare var EDataLayerType : { Runtime:'Runtime',Editor:'Editor',Unknown:'Unknown',Size:'Size',EDataLayerType_MAX:'EDataLayerType_MAX', };
declare class DataLayerInstance extends UObject { 
	bIsVisible: boolean;
	bIsInitiallyVisible: boolean;
	bIsInitiallyLoadedInEditor: boolean;
	bIsLoadedInEditor: boolean;
	bIsLoadedInEditorChangedByUserOperation: boolean;
	bIsLocked: boolean;
	InitialRuntimeState: EDataLayerRuntimeState;
	Parent: DataLayerInstance;
	Children: DataLayerInstance[];
	static Load(ResourceName: string): DataLayerInstance;
	static Find(Outer: UObject, ResourceName: string): DataLayerInstance;
	static GetDefaultObject(): DataLayerInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataLayerInstance;
	IsVisible(): boolean;
	IsRuntime(): boolean;
	IsInitiallyVisible(): boolean;
	IsEffectiveVisible(): boolean;
	GetType(): EDataLayerType;
	GetInitialRuntimeState(): EDataLayerRuntimeState;
	GetDebugColor(): Color;
	static C(Other: UObject | any): DataLayerInstance;
}

declare class ActorInstanceHandle { 
	Actor: Actor;
	clone() : ActorInstanceHandle;
	static C(Other: UObject | any): ActorInstanceHandle;
}

declare class SoftClassPath extends SoftObjectPath { 
	clone() : SoftClassPath;
	static C(Other: UObject | any): SoftClassPath;
	BreakSoftClassPath(PathString?: string): {PathString: string};
	Conv_SoftClassPathToSoftClassRef(): Class;
	static BreakSoftClassPath(InSoftClassPath: SoftClassPath,PathString?: string): {PathString: string};
	static Conv_SoftClassPathToSoftClassRef(SoftClassPath: SoftClassPath): Class;
	static MakeSoftClassPath(PathString: string): SoftClassPath;
}

declare class PrimaryAssetType { 
	Name: string;
	clone() : PrimaryAssetType;
	static C(Other: UObject | any): PrimaryAssetType;
	Conv_PrimaryAssetTypeToString(): string;
	EqualEqual_PrimaryAssetType(B: PrimaryAssetType): boolean;
	GetPrimaryAssetIdList(OutPrimaryAssetIdList?: PrimaryAssetId[]): {OutPrimaryAssetIdList: PrimaryAssetId[]};
	IsValidPrimaryAssetType(): boolean;
	NotEqual_PrimaryAssetType(B: PrimaryAssetType): boolean;
	static Conv_PrimaryAssetTypeToString(PrimaryAssetType: PrimaryAssetType): string;
	static EqualEqual_PrimaryAssetType(A: PrimaryAssetType,B: PrimaryAssetType): boolean;
	static GetPrimaryAssetIdList(PrimaryAssetType: PrimaryAssetType,OutPrimaryAssetIdList?: PrimaryAssetId[]): {OutPrimaryAssetIdList: PrimaryAssetId[]};
	static IsValidPrimaryAssetType(PrimaryAssetType: PrimaryAssetType): boolean;
	static NotEqual_PrimaryAssetType(A: PrimaryAssetType,B: PrimaryAssetType): boolean;
}

declare class PrimaryAssetId { 
	PrimaryAssetType: PrimaryAssetType;
	PrimaryAssetName: string;
	clone() : PrimaryAssetId;
	static C(Other: UObject | any): PrimaryAssetId;
	Conv_PrimaryAssetIdToString(): string;
	EqualEqual_PrimaryAssetId(B: PrimaryAssetId): boolean;
	GetClassFromPrimaryAssetId(): UnrealEngineClass;
	GetCurrentBundleState(bForceCurrentState: boolean,OutBundles?: string[]): {OutBundles: string[], $: boolean};
	GetObjectFromPrimaryAssetId(): UObject;
	GetSoftClassReferenceFromPrimaryAssetId(): Class;
	GetSoftObjectReferenceFromPrimaryAssetId(): UObject;
	IsValidPrimaryAssetId(): boolean;
	NotEqual_PrimaryAssetId(B: PrimaryAssetId): boolean;
	UnloadPrimaryAsset(): void;
	static Conv_PrimaryAssetIdToString(PrimaryAssetId: PrimaryAssetId): string;
	static EqualEqual_PrimaryAssetId(A: PrimaryAssetId,B: PrimaryAssetId): boolean;
	static GetClassFromPrimaryAssetId(PrimaryAssetId: PrimaryAssetId): UnrealEngineClass;
	static GetCurrentBundleState(PrimaryAssetId: PrimaryAssetId,bForceCurrentState: boolean,OutBundles?: string[]): {OutBundles: string[], $: boolean};
	static GetObjectFromPrimaryAssetId(PrimaryAssetId: PrimaryAssetId): UObject;
	static GetSoftClassReferenceFromPrimaryAssetId(PrimaryAssetId: PrimaryAssetId): Class;
	static GetSoftObjectReferenceFromPrimaryAssetId(PrimaryAssetId: PrimaryAssetId): UObject;
	static IsValidPrimaryAssetId(PrimaryAssetId: PrimaryAssetId): boolean;
	static NotEqual_PrimaryAssetId(A: PrimaryAssetId,B: PrimaryAssetId): boolean;
	static UnloadPrimaryAsset(PrimaryAssetId: PrimaryAssetId): void;
}

declare class SaveGame extends UObject { 
	static Load(ResourceName: string): SaveGame;
	static Find(Outer: UObject, ResourceName: string): SaveGame;
	static GetDefaultObject(): SaveGame;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SaveGame;
	static C(Other: UObject | any): SaveGame;
	SaveGameToSlot(SlotName: string,UserIndex: number): boolean;
	static SaveGameToSlot(SaveGameObject: SaveGame,SlotName: string,UserIndex: number): boolean;
}

declare type EInterfaceValidResult = 'Valid' | 'Invalid' | 'EInterfaceValidResult_MAX';
declare var EInterfaceValidResult : { Valid:'Valid',Invalid:'Invalid',EInterfaceValidResult_MAX:'EInterfaceValidResult_MAX', };
declare class CameraLensInterfaceClassSupport { 
	Class: UnrealEngineClass;
	clone() : CameraLensInterfaceClassSupport;
	static C(Other: UObject | any): CameraLensInterfaceClassSupport;
	GetInterfaceClass(): UnrealEngineClass;
	IsInterfaceClassValid(Result?: EInterfaceValidResult): {Result: EInterfaceValidResult};
	static GetInterfaceClass(CameraLens: CameraLensInterfaceClassSupport): UnrealEngineClass;
	static IsInterfaceClassValid(CameraLens: CameraLensInterfaceClassSupport,Result?: EInterfaceValidResult): {Result: EInterfaceValidResult};
}

declare class EditorSubsystem extends DynamicSubsystem { 
	static Load(ResourceName: string): EditorSubsystem;
	static Find(Outer: UObject, ResourceName: string): EditorSubsystem;
	static GetDefaultObject(): EditorSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EditorSubsystem;
	static C(Other: UObject | any): EditorSubsystem;
}

declare class Visual extends UObject { 
	static Load(ResourceName: string): Visual;
	static Find(Outer: UObject, ResourceName: string): Visual;
	static GetDefaultObject(): Visual;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Visual;
	static C(Other: UObject | any): Visual;
}

declare class PanelWidget extends Widget { 
	Slots: PanelSlot[];
	static Load(ResourceName: string): PanelWidget;
	static Find(Outer: UObject, ResourceName: string): PanelWidget;
	static GetDefaultObject(): PanelWidget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PanelWidget;
	RemoveChildAt(Index: number): boolean;
	RemoveChild(Content: Widget): boolean;
	HasChild(Content: Widget): boolean;
	HasAnyChildren(): boolean;
	GetChildrenCount(): number;
	GetChildIndex(Content: Widget): number;
	GetChildAt(Index: number): Widget;
	GetAllChildren(): Widget[];
	ClearChildren(): void;
	AddChild(Content: Widget): PanelSlot;
	static C(Other: UObject | any): PanelWidget;
}

declare class PanelSlot extends Visual { 
	Parent: PanelWidget;
	Content: Widget;
	static Load(ResourceName: string): PanelSlot;
	static Find(Outer: UObject, ResourceName: string): PanelSlot;
	static GetDefaultObject(): PanelSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PanelSlot;
	static C(Other: UObject | any): PanelSlot;
}

declare type ESlateVisibility = 'Visible' | 'Collapsed' | 'Hidden' | 'HitTestInvisible' | 'SelfHitTestInvisible' | 'ESlateVisibility_MAX';
declare var ESlateVisibility : { Visible:'Visible',Collapsed:'Collapsed',Hidden:'Hidden',HitTestInvisible:'HitTestInvisible',SelfHitTestInvisible:'SelfHitTestInvisible',ESlateVisibility_MAX:'ESlateVisibility_MAX', };
declare class WidgetTransform { 
	Translation: Vector2D;
	Scale: Vector2D;
	Shear: Vector2D;
	Angle: number;
	clone() : WidgetTransform;
	static C(Other: UObject | any): WidgetTransform;
}

declare type EFlowDirectionPreference = 'Inherit' | 'Culture' | 'LeftToRight' | 'RightToLeft' | 'EFlowDirectionPreference_MAX';
declare var EFlowDirectionPreference : { Inherit:'Inherit',Culture:'Culture',LeftToRight:'LeftToRight',RightToLeft:'RightToLeft',EFlowDirectionPreference_MAX:'EFlowDirectionPreference_MAX', };
declare type ESlateAccessibleBehavior = 'NotAccessible' | 'Auto' | 'Summary' | 'Custom' | 'ToolTip' | 'ESlateAccessibleBehavior_MAX';
declare var ESlateAccessibleBehavior : { NotAccessible:'NotAccessible',Auto:'Auto',Summary:'Summary',Custom:'Custom',ToolTip:'ToolTip',ESlateAccessibleBehavior_MAX:'ESlateAccessibleBehavior_MAX', };
declare type EMouseCursor = 'None' | 'Default' | 'TextEditBeam' | 'ResizeLeftRight' | 'ResizeUpDown' | 'ResizeSouthEast' | 'ResizeSouthWest' | 'CardinalCross' | 'Crosshairs' | 'Hand' | 'GrabHand' | 'GrabHandClosed' | 'SlashedCircle' | 'EyeDropper' | 'EMouseCursor_MAX';
declare var EMouseCursor : { None:'None',Default:'Default',TextEditBeam:'TextEditBeam',ResizeLeftRight:'ResizeLeftRight',ResizeUpDown:'ResizeUpDown',ResizeSouthEast:'ResizeSouthEast',ResizeSouthWest:'ResizeSouthWest',CardinalCross:'CardinalCross',Crosshairs:'Crosshairs',Hand:'Hand',GrabHand:'GrabHand',GrabHandClosed:'GrabHandClosed',SlashedCircle:'SlashedCircle',EyeDropper:'EyeDropper',EMouseCursor_MAX:'EMouseCursor_MAX', };
declare type EWidgetClipping = 'Inherit' | 'ClipToBounds' | 'ClipToBoundsWithoutIntersecting' | 'ClipToBoundsAlways' | 'OnDemand' | 'EWidgetClipping_MAX';
declare var EWidgetClipping : { Inherit:'Inherit',ClipToBounds:'ClipToBounds',ClipToBoundsWithoutIntersecting:'ClipToBoundsWithoutIntersecting',ClipToBoundsAlways:'ClipToBoundsAlways',OnDemand:'OnDemand',EWidgetClipping_MAX:'EWidgetClipping_MAX', };
declare class SlateAccessibleWidgetData extends UObject { 
	bCanChildrenBeAccessible: boolean;
	AccessibleBehavior: ESlateAccessibleBehavior;
	AccessibleSummaryBehavior: ESlateAccessibleBehavior;
	AccessibleText: string;
	AccessibleTextDelegate: UnrealEngineDelegate<() => string>;
	AccessibleSummaryText: string;
	AccessibleSummaryTextDelegate: UnrealEngineDelegate<() => string>;
	static Load(ResourceName: string): SlateAccessibleWidgetData;
	static Find(Outer: UObject, ResourceName: string): SlateAccessibleWidgetData;
	static GetDefaultObject(): SlateAccessibleWidgetData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SlateAccessibleWidgetData;
	static C(Other: UObject | any): SlateAccessibleWidgetData;
}

declare type EUINavigationRule = 'Escape' | 'Explicit' | 'Wrap' | 'Stop' | 'Custom' | 'CustomBoundary' | 'Invalid' | 'EUINavigationRule_MAX';
declare var EUINavigationRule : { Escape:'Escape',Explicit:'Explicit',Wrap:'Wrap',Stop:'Stop',Custom:'Custom',CustomBoundary:'CustomBoundary',Invalid:'Invalid',EUINavigationRule_MAX:'EUINavigationRule_MAX', };
declare type EUINavigation = 'Left' | 'Right' | 'Up' | 'Down' | 'Next' | 'Previous' | 'Num' | 'Invalid' | 'EUINavigation_MAX';
declare var EUINavigation : { Left:'Left',Right:'Right',Up:'Up',Down:'Down',Next:'Next',Previous:'Previous',Num:'Num',Invalid:'Invalid',EUINavigation_MAX:'EUINavigation_MAX', };
declare class WidgetNavigationData { 
	Rule: EUINavigationRule;
	WidgetToFocus: string;
	Widget: Widget;
	CustomDelegate: UnrealEngineDelegate<(Navigation: EUINavigation) => Widget>;
	clone() : WidgetNavigationData;
	static C(Other: UObject | any): WidgetNavigationData;
}

declare class WidgetNavigation extends UObject { 
	Up: WidgetNavigationData;
	Down: WidgetNavigationData;
	Left: WidgetNavigationData;
	Right: WidgetNavigationData;
	Next: WidgetNavigationData;
	Previous: WidgetNavigationData;
	static Load(ResourceName: string): WidgetNavigation;
	static Find(Outer: UObject, ResourceName: string): WidgetNavigation;
	static GetDefaultObject(): WidgetNavigation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetNavigation;
	static C(Other: UObject | any): WidgetNavigation;
}

declare class PropertyPathSegment { 
	Name: string;
	ArrayIndex: number;
	struct: Struct;
	clone() : PropertyPathSegment;
	static C(Other: UObject | any): PropertyPathSegment;
}

declare class UFunction extends Struct { 
	static Load(ResourceName: string): UFunction;
	static Find(Outer: UObject, ResourceName: string): UFunction;
	static GetDefaultObject(): UFunction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UFunction;
	static C(Other: UObject | any): UFunction;
	GetFunctionParmsSize(): number;
	static GetFunctionParmsSize(UFunction: UFunction): number;
}

declare class CachedPropertyPath { 
	Segments: PropertyPathSegment[];
	CachedFunction: UFunction;
	clone() : CachedPropertyPath;
	static C(Other: UObject | any): CachedPropertyPath;
}

declare class DynamicPropertyPath extends CachedPropertyPath { 
	clone() : DynamicPropertyPath;
	static C(Other: UObject | any): DynamicPropertyPath;
}

declare class PropertyBinding extends UObject { 
	SourceObject: UObject;
	SourcePath: DynamicPropertyPath;
	DestinationProperty: string;
	static Load(ResourceName: string): PropertyBinding;
	static Find(Outer: UObject, ResourceName: string): PropertyBinding;
	static GetDefaultObject(): PropertyBinding;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PropertyBinding;
	static C(Other: UObject | any): PropertyBinding;
}

declare class LocalMessage extends UObject { 
	static Load(ResourceName: string): LocalMessage;
	static Find(Outer: UObject, ResourceName: string): LocalMessage;
	static GetDefaultObject(): LocalMessage;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LocalMessage;
	static C(Other: UObject | any): LocalMessage;
}

declare class UniqueNetIdWrapper { 
	clone() : UniqueNetIdWrapper;
	static C(Other: UObject | any): UniqueNetIdWrapper;
}

declare class UniqueNetIdRepl extends UniqueNetIdWrapper { 
	ReplicationBytes: number[];
	clone() : UniqueNetIdRepl;
	static C(Other: UObject | any): UniqueNetIdRepl;
}

declare type EAutoReceiveInput = 'Disabled' | 'Player0' | 'Player1' | 'Player2' | 'Player3' | 'Player4' | 'Player5' | 'Player6' | 'Player7' | 'EAutoReceiveInput_MAX';
declare var EAutoReceiveInput : { Disabled:'Disabled',Player0:'Player0',Player1:'Player1',Player2:'Player2',Player3:'Player3',Player4:'Player4',Player5:'Player5',Player6:'Player6',Player7:'Player7',EAutoReceiveInput_MAX:'EAutoReceiveInput_MAX', };
declare type EAutoPossessAI = 'Disabled' | 'PlacedInWorld' | 'Spawned' | 'PlacedInWorldOrSpawned' | 'EAutoPossessAI_MAX';
declare var EAutoPossessAI : { Disabled:'Disabled',PlacedInWorld:'PlacedInWorld',Spawned:'Spawned',PlacedInWorldOrSpawned:'PlacedInWorldOrSpawned',EAutoPossessAI_MAX:'EAutoPossessAI_MAX', };
declare type EUINavigationAction = 'Accept' | 'Back' | 'Num' | 'Invalid' | 'EUINavigationAction_MAX';
declare var EUINavigationAction : { Accept:'Accept',Back:'Back',Num:'Num',Invalid:'Invalid',EUINavigationAction_MAX:'EUINavigationAction_MAX', };
declare type EControllerHand = 'Left' | 'Right' | 'AnyHand' | 'Pad' | 'ExternalCamera' | 'Gun' | 'HMD' | 'Special_1' | 'Special_2' | 'Special_3' | 'Special_4' | 'Special_5' | 'Special_6' | 'Special_7' | 'Special_8' | 'Special_9' | 'Special_10' | 'Special_11' | 'ControllerHand_Count' | 'EControllerHand_MAX';
declare var EControllerHand : { Left:'Left',Right:'Right',AnyHand:'AnyHand',Pad:'Pad',ExternalCamera:'ExternalCamera',Gun:'Gun',HMD:'HMD',Special_1:'Special_1',Special_2:'Special_2',Special_3:'Special_3',Special_4:'Special_4',Special_5:'Special_5',Special_6:'Special_6',Special_7:'Special_7',Special_8:'Special_8',Special_9:'Special_9',Special_10:'Special_10',Special_11:'Special_11',ControllerHand_Count:'ControllerHand_Count',EControllerHand_MAX:'EControllerHand_MAX', };
declare class Key { 
	KeyName: string;
	clone() : Key;
	static C(Other: UObject | any): Key;
	EqualEqual_KeyKey(B: Key): boolean;
	Key_GetDisplayName(bLongDisplayName: boolean): string;
	Key_GetNavigationAction(): EUINavigationAction;
	Key_IsAnalog(): boolean;
	Key_IsAxis1D(): boolean;
	Key_IsAxis2D(): boolean;
	Key_IsAxis3D(): boolean;
	Key_IsButtonAxis(): boolean;
	Key_IsDigital(): boolean;
	Key_IsGamepadKey(): boolean;
	Key_IsKeyboardKey(): boolean;
	Key_IsModifierKey(): boolean;
	Key_IsMouseButton(): boolean;
	Key_IsValid(): boolean;
	Key_IsVectorAxis(): boolean;
	BreakKey(InteractionProfile?: string,Hand?: EControllerHand,MotionSource?: string,Indentifier?: string,Component?: string): {InteractionProfile: string, Hand: EControllerHand, MotionSource: string, Indentifier: string, Component: string};
	static EqualEqual_KeyKey(A: Key,B: Key): boolean;
	static Key_GetDisplayName(Key: Key,bLongDisplayName: boolean): string;
	static Key_GetNavigationAction(InKey: Key): EUINavigationAction;
	static Key_IsAnalog(Key: Key): boolean;
	static Key_IsAxis1D(Key: Key): boolean;
	static Key_IsAxis2D(Key: Key): boolean;
	static Key_IsAxis3D(Key: Key): boolean;
	static Key_IsButtonAxis(Key: Key): boolean;
	static Key_IsDigital(Key: Key): boolean;
	static Key_IsGamepadKey(Key: Key): boolean;
	static Key_IsKeyboardKey(Key: Key): boolean;
	static Key_IsModifierKey(Key: Key): boolean;
	static Key_IsMouseButton(Key: Key): boolean;
	static Key_IsValid(Key: Key): boolean;
	static Key_IsVectorAxis(Key: Key): boolean;
	static BreakKey(InKey: Key,InteractionProfile?: string,Hand?: EControllerHand,MotionSource?: string,Indentifier?: string,Component?: string): {InteractionProfile: string, Hand: EControllerHand, MotionSource: string, Indentifier: string, Component: string};
}

declare class KeyBind { 
	Key: Key;
	Command: string;
	Control: boolean;
	Shift: boolean;
	Alt: boolean;
	Cmd: boolean;
	bIgnoreCtrl: boolean;
	bIgnoreShift: boolean;
	bIgnoreAlt: boolean;
	bIgnoreCmd: boolean;
	bDisabled: boolean;
	clone() : KeyBind;
	static C(Other: UObject | any): KeyBind;
}

declare class PlayerInput extends UObject { 
	DebugExecBindings: KeyBind[];
	InvertedAxis: string[];
	static Load(ResourceName: string): PlayerInput;
	static Find(Outer: UObject, ResourceName: string): PlayerInput;
	static GetDefaultObject(): PlayerInput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayerInput;
	SetMouseSensitivity(Sensitivity: number): void;
	SetBind(BindName: string,Command: string): void;
	InvertAxisKey(AxisKey: Key): void;
	InvertAxis(AxisName: string): void;
	GetOuterAPlayerController(): PlayerController;
	ClearSmoothing(): void;
	static C(Other: UObject | any): PlayerInput;
}

declare class CachedKeyToActionInfo { 
	PlayerInput: PlayerInput;
	clone() : CachedKeyToActionInfo;
	static C(Other: UObject | any): CachedKeyToActionInfo;
}

declare type EEndPlayReason = 'Destroyed' | 'LevelTransition' | 'EndPlayInEditor' | 'RemovedFromWorld' | 'Quit' | 'EEndPlayReason_MAX';
declare var EEndPlayReason : { Destroyed:'Destroyed',LevelTransition:'LevelTransition',EndPlayInEditor:'EndPlayInEditor',RemovedFromWorld:'RemovedFromWorld',Quit:'Quit',EEndPlayReason_MAX:'EEndPlayReason_MAX', };
declare type EControllerAnalogStick = 'CAS_LeftStick' | 'CAS_RightStick' | 'CAS_MAX';
declare var EControllerAnalogStick : { CAS_LeftStick:'CAS_LeftStick',CAS_RightStick:'CAS_RightStick',CAS_MAX:'CAS_MAX', };
declare class InputComponent extends ActorComponent { 
	CachedKeyToActionInfo: CachedKeyToActionInfo[];
	static Load(ResourceName: string): InputComponent;
	static Find(Outer: UObject, ResourceName: string): InputComponent;
	static GetDefaultObject(): InputComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InputComponent;
	WasControllerKeyJustReleased(Key: Key): boolean;
	WasControllerKeyJustPressed(Key: Key): boolean;
	OnInputOwnerEndPlayed(InOwner: Actor,EndPlayReason: EEndPlayReason): void;
	IsControllerKeyDown(Key: Key): boolean;
	GetTouchState(FingerIndex: number,LocationX?: number,LocationY?: number,bIsCurrentlyPressed?: boolean): {LocationX: number, LocationY: number, bIsCurrentlyPressed: boolean};
	GetControllerVectorKeyState(Key: Key): Vector;
	GetControllerMouseDelta(DeltaX?: number,DeltaY?: number): {DeltaX: number, DeltaY: number};
	GetControllerKeyTimeDown(Key: Key): number;
	GetControllerAnalogStickState(WhichStick: EControllerAnalogStick,StickX?: number,StickY?: number): {StickX: number, StickY: number};
	GetControllerAnalogKeyState(Key: Key): number;
	static C(Other: UObject | any): InputComponent;
}

declare type EPlaneConstraintAxisSetting = 'Custom' | 'X' | 'Y' | 'Z' | 'UseGlobalPhysicsSetting' | 'EPlaneConstraintAxisSetting_MAX';
declare var EPlaneConstraintAxisSetting : { Custom:'Custom',X:'X',Y:'Y',Z:'Z',UseGlobalPhysicsSetting:'UseGlobalPhysicsSetting',EPlaneConstraintAxisSetting_MAX:'EPlaneConstraintAxisSetting_MAX', };
declare class Vector_NetQuantize extends Vector { 
	clone() : Vector_NetQuantize;
	static C(Other: UObject | any): Vector_NetQuantize;
	BreakVector_NetQuantize(X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static BreakVector_NetQuantize(InVec: Vector_NetQuantize,X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static MakeVector_NetQuantize(X: number,Y: number,Z: number): Vector_NetQuantize;
}

declare class Vector_NetQuantizeNormal extends Vector { 
	clone() : Vector_NetQuantizeNormal;
	static C(Other: UObject | any): Vector_NetQuantizeNormal;
	BreakVector_NetQuantizeNormal(X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static BreakVector_NetQuantizeNormal(InVec: Vector_NetQuantizeNormal,X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static MakeVector_NetQuantizeNormal(X: number,Y: number,Z: number): Vector_NetQuantizeNormal;
}

declare class HitResult { 
	FaceIndex: number;
	Time: number;
	Distance: number;
	Location: Vector_NetQuantize;
	ImpactPoint: Vector_NetQuantize;
	Normal: Vector_NetQuantizeNormal;
	ImpactNormal: Vector_NetQuantizeNormal;
	TraceStart: Vector_NetQuantize;
	TraceEnd: Vector_NetQuantize;
	PenetrationDepth: number;
	MyItem: number;
	Item: number;
	ElementIndex: number;
	bBlockingHit: boolean;
	bStartPenetrating: boolean;
	PhysMaterial: PhysicalMaterial;
	HitObjectHandle: ActorInstanceHandle;
	Component: PrimitiveComponent;
	BoneName: string;
	MyBoneName: string;
	clone() : HitResult;
	static C(Other: UObject | any): HitResult;
	BreakHitResult(bBlockingHit?: boolean,bInitialOverlap?: boolean,Time?: number,Distance?: number,Location?: Vector,ImpactPoint?: Vector,Normal?: Vector,ImpactNormal?: Vector,PhysMat?: PhysicalMaterial,HitActor?: Actor,HitComponent?: PrimitiveComponent,HitBoneName?: string,BoneName?: string,HitItem?: number,ElementIndex?: number,FaceIndex?: number,TraceStart?: Vector,TraceEnd?: Vector): {bBlockingHit: boolean, bInitialOverlap: boolean, Time: number, Distance: number, Location: Vector, ImpactPoint: Vector, Normal: Vector, ImpactNormal: Vector, PhysMat: PhysicalMaterial, HitActor: Actor, HitComponent: PrimitiveComponent, HitBoneName: string, BoneName: string, HitItem: number, ElementIndex: number, FaceIndex: number, TraceStart: Vector, TraceEnd: Vector};
	FindCollisionUV(UVChannel: number,UV?: Vector2D): {UV: Vector2D, $: boolean};
	GetSurfaceType(): EPhysicalSurface;
	static BreakHitResult(Hit: HitResult,bBlockingHit?: boolean,bInitialOverlap?: boolean,Time?: number,Distance?: number,Location?: Vector,ImpactPoint?: Vector,Normal?: Vector,ImpactNormal?: Vector,PhysMat?: PhysicalMaterial,HitActor?: Actor,HitComponent?: PrimitiveComponent,HitBoneName?: string,BoneName?: string,HitItem?: number,ElementIndex?: number,FaceIndex?: number,TraceStart?: Vector,TraceEnd?: Vector): {bBlockingHit: boolean, bInitialOverlap: boolean, Time: number, Distance: number, Location: Vector, ImpactPoint: Vector, Normal: Vector, ImpactNormal: Vector, PhysMat: PhysicalMaterial, HitActor: Actor, HitComponent: PrimitiveComponent, HitBoneName: string, BoneName: string, HitItem: number, ElementIndex: number, FaceIndex: number, TraceStart: Vector, TraceEnd: Vector};
	static FindCollisionUV(Hit: HitResult,UVChannel: number,UV?: Vector2D): {UV: Vector2D, $: boolean};
	static GetSurfaceType(Hit: HitResult): EPhysicalSurface;
	static MakeHitResult(bBlockingHit: boolean,bInitialOverlap: boolean,Time: number,Distance: number,Location: Vector,ImpactPoint: Vector,Normal: Vector,ImpactNormal: Vector,PhysMat: PhysicalMaterial,HitActor: Actor,HitComponent: PrimitiveComponent,HitBoneName: string,BoneName: string,HitItem: number,ElementIndex: number,FaceIndex: number,TraceStart: Vector,TraceEnd: Vector): HitResult;
}

declare class MovementComponent extends ActorComponent { 
	UpdatedComponent: SceneComponent;
	UpdatedPrimitive: PrimitiveComponent;
	Velocity: Vector;
	PlaneConstraintNormal: Vector;
	PlaneConstraintOrigin: Vector;
	bUpdateOnlyIfRendered: boolean;
	bAutoUpdateTickRegistration: boolean;
	bTickBeforeOwner: boolean;
	bAutoRegisterUpdatedComponent: boolean;
	bConstrainToPlane: boolean;
	bSnapToPlaneAtStart: boolean;
	bAutoRegisterPhysicsVolumeUpdates: boolean;
	bComponentShouldUpdatePhysicsVolume: boolean;
	PlaneConstraintAxisSetting: EPlaneConstraintAxisSetting;
	static Load(ResourceName: string): MovementComponent;
	static Find(Outer: UObject, ResourceName: string): MovementComponent;
	static GetDefaultObject(): MovementComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovementComponent;
	StopMovementImmediately(): void;
	SnapUpdatedComponentToPlane(): void;
	SetUpdatedComponent(NewUpdatedComponent: SceneComponent): void;
	SetPlaneConstraintOrigin(PlaneOrigin: Vector): void;
	SetPlaneConstraintNormal(PlaneNormal: Vector): void;
	SetPlaneConstraintFromVectors(Forward: Vector,Up: Vector): void;
	SetPlaneConstraintEnabled(bEnabled: boolean): void;
	SetPlaneConstraintAxisSetting(NewAxisSetting: EPlaneConstraintAxisSetting): void;
	PhysicsVolumeChanged(NewVolume: PhysicsVolume): void;
	K2_MoveUpdatedComponent(Delta: Vector,NewRotation: Rotator,OutHit?: HitResult,bSweep?: boolean,bTeleport?: boolean): {OutHit: HitResult, $: boolean};
	IsExceedingMaxSpeed(MaxSpeed: number): boolean;
	GetPlaneConstraintOrigin(): Vector;
	GetPlaneConstraintNormal(): Vector;
	GetPlaneConstraintAxisSetting(): EPlaneConstraintAxisSetting;
	GetPhysicsVolume(): PhysicsVolume;
	GetMaxSpeed(): number;
	GetGravityZ(): number;
	ConstrainNormalToPlane(Normal: Vector): Vector;
	ConstrainLocationToPlane(Location: Vector): Vector;
	ConstrainDirectionToPlane(Direction: Vector): Vector;
	static C(Other: UObject | any): MovementComponent;
}

declare class MovementProperties { 
	bCanCrouch: boolean;
	bCanJump: boolean;
	bCanWalk: boolean;
	bCanSwim: boolean;
	bCanFly: boolean;
	clone() : MovementProperties;
	static C(Other: UObject | any): MovementProperties;
}

declare class NavAgentProperties extends MovementProperties { 
	AgentRadius: number;
	AgentHeight: number;
	AgentStepHeight: number;
	NavWalkingSearchHeightScale: number;
	PreferredNavData: SoftClassPath;
	clone() : NavAgentProperties;
	static C(Other: UObject | any): NavAgentProperties;
}

declare class NavMovementComponent extends MovementComponent { 
	NavAgentProps: NavAgentProperties;
	FixedPathBrakingDistance: number;
	bUpdateNavAgentWithOwnersCollision: boolean;
	bUseAccelerationForPaths: boolean;
	bUseFixedBrakingDistanceForPaths: boolean;
	MovementState: MovementProperties;
	PathFollowingComp: UObject;
	static Load(ResourceName: string): NavMovementComponent;
	static Find(Outer: UObject, ResourceName: string): NavMovementComponent;
	static GetDefaultObject(): NavMovementComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavMovementComponent;
	StopMovementKeepPathing(): void;
	StopActiveMovement(): void;
	IsSwimming(): boolean;
	IsMovingOnGround(): boolean;
	IsFlying(): boolean;
	IsFalling(): boolean;
	IsCrouching(): boolean;
	static C(Other: UObject | any): NavMovementComponent;
}

declare class PawnMovementComponent extends NavMovementComponent { 
	PawnOwner: Pawn;
	static Load(ResourceName: string): PawnMovementComponent;
	static Find(Outer: UObject, ResourceName: string): PawnMovementComponent;
	static GetDefaultObject(): PawnMovementComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnMovementComponent;
	IsMoveInputIgnored(): boolean;
	GetPendingInputVector(): Vector;
	GetPawnOwner(): Pawn;
	GetLastInputVector(): Vector;
	ConsumeInputVector(): Vector;
	AddInputVector(WorldVector: Vector,bForce: boolean): void;
	static C(Other: UObject | any): PawnMovementComponent;
}

declare class Pawn extends Actor { 
	bUseControllerRotationPitch: boolean;
	bUseControllerRotationYaw: boolean;
	bUseControllerRotationRoll: boolean;
	bCanAffectNavigationGeneration: boolean;
	bIsLocalViewTarget: boolean;
	BaseEyeHeight: number;
	AutoPossessPlayer: EAutoReceiveInput;
	AutoPossessAI: EAutoPossessAI;
	RemoteViewPitch: number;
	AIControllerClass: UnrealEngineClass;
	PlayerState: PlayerState;
	LastHitBy: Controller;
	Controller: Controller;
	PreviousController: Controller;
	ReceiveControllerChangedDelegate: UnrealEngineMulticastDelegate<(Pawn: Pawn, OldController: Controller, NewController: Controller) => void>;
	ReceiveRestartedDelegate: UnrealEngineMulticastDelegate<(Pawn: Pawn) => void>;
	ControlInputVector: Vector;
	LastControlInputVector: Vector;
	OverrideInputComponentClass: UnrealEngineClass;
	static GetDefaultObject(): Pawn;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Pawn;
	SpawnDefaultController(): void;
	SetCanAffectNavigationGeneration(bNewValue: boolean,bForceUpdate: boolean): void;
	ReceiveUnpossessed(OldController: Controller): void;
	ReceiveRestarted(): void;
	ReceivePossessed(NewController: Controller): void;
	ReceiveControllerChanged(OldController: Controller,NewController: Controller): void;
	PawnMakeNoise(Loudness: number,NoiseLocation: Vector,bUseNoiseMakerLocation: boolean,NoiseMaker: Actor): void;
	OnRep_PlayerState(): void;
	OnRep_Controller(): void;
	IsPlayerControlled(): boolean;
	IsPawnControlled(): boolean;
	IsMoveInputIgnored(): boolean;
	IsLocallyViewed(): boolean;
	IsLocallyControlled(): boolean;
	IsControlled(): boolean;
	IsBotControlled(): boolean;
	GetPendingMovementInputVector(): Vector;
	GetOverrideInputComponentClass(): UnrealEngineClass;
	GetNavAgentLocation(): Vector;
	GetMovementComponent(): PawnMovementComponent;
	static GetMovementBaseActor(Pawn: Pawn): Actor;
	GetLocalViewingPlayerController(): PlayerController;
	GetLastMovementInputVector(): Vector;
	GetControlRotation(): Rotator;
	GetController(): Controller;
	GetBaseAimRotation(): Rotator;
	DetachFromControllerPendingDestroy(): void;
	ConsumeMovementInputVector(): Vector;
	AddMovementInput(WorldDirection: Vector,ScaleValue: number,bForce: boolean): void;
	AddControllerYawInput(Val: number): void;
	AddControllerRollInput(Val: number): void;
	AddControllerPitchInput(Val: number): void;
	static C(Other: UObject | any): Pawn;
	SendAIMessage(Message: string,MessageSource: UObject,bSuccess: boolean): void;
	static SendAIMessage(Target: Pawn,Message: string,MessageSource: UObject,bSuccess: boolean): void;
}

declare class PlayerState extends Info { 
	Score: number;
	PlayerId: number;
	CompressedPing: number;
	bShouldUpdateReplicatedPing: boolean;
	bIsSpectator: boolean;
	bOnlySpectator: boolean;
	bIsABot: boolean;
	bIsInactive: boolean;
	bFromPreviousLevel: boolean;
	StartTime: number;
	EngineMessageClass: UnrealEngineClass;
	SavedNetworkAddress: string;
	UniqueId: UniqueNetIdRepl;
	OnPawnSet: UnrealEngineMulticastDelegate<(Player: PlayerState, NewPawn: Pawn, OldPawn: Pawn) => void>;
	PawnPrivate: Pawn;
	PlayerNamePrivate: string;
	static GetDefaultObject(): PlayerState;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayerState;
	ReceiveOverrideWith(OldPlayerState: PlayerState): void;
	ReceiveCopyProperties(NewPlayerState: PlayerState): void;
	OnRep_UniqueId(): void;
	OnRep_Score(): void;
	OnRep_PlayerName(): void;
	OnRep_PlayerId(): void;
	OnRep_bIsInactive(): void;
	OnPawnPrivateDestroyed(InActor: Actor): void;
	IsSpectator(): boolean;
	IsOnlyASpectator(): boolean;
	IsABot(): boolean;
	GetScore(): number;
	GetPlayerName(): string;
	GetPlayerId(): number;
	GetPlayerController(): PlayerController;
	GetPingInMilliseconds(): number;
	GetPawn(): Pawn;
	GetCompressedPing(): number;
	BP_GetUniqueId(): UniqueNetIdRepl;
	static C(Other: UObject | any): PlayerState;
}

declare class DamageType extends UObject { 
	bCausedByWorld: boolean;
	bScaleMomentumByMass: boolean;
	bRadialDamageVelChange: boolean;
	DamageImpulse: number;
	DestructibleImpulse: number;
	DestructibleDamageSpreadScale: number;
	DamageFalloff: number;
	static Load(ResourceName: string): DamageType;
	static Find(Outer: UObject, ResourceName: string): DamageType;
	static GetDefaultObject(): DamageType;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DamageType;
	static C(Other: UObject | any): DamageType;
}

declare class MeshComponent extends PrimitiveComponent { 
	OverrideMaterials: MaterialInterface[];
	OverlayMaterial: MaterialInterface;
	OverlayMaterialMaxDrawDistance: number;
	bEnableMaterialParameterCaching: boolean;
	static Load(ResourceName: string): MeshComponent;
	static Find(Outer: UObject, ResourceName: string): MeshComponent;
	static GetDefaultObject(): MeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshComponent;
	SetVectorParameterValueOnMaterials(ParameterName: string,ParameterValue: Vector): void;
	SetScalarParameterValueOnMaterials(ParameterName: string,ParameterValue: number): void;
	SetOverlayMaterialMaxDrawDistance(InMaxDrawDistance: number): void;
	SetOverlayMaterial(NewOverlayMaterial: MaterialInterface): void;
	PrestreamTextures(Seconds: number,bPrioritizeCharacterTextures: boolean,CinematicTextureGroups: number): void;
	IsMaterialSlotNameValid(MaterialSlotName: string): boolean;
	GetOverlayMaterial(): MaterialInterface;
	GetMaterialSlotNames(): string[];
	GetMaterials(): MaterialInterface[];
	GetMaterialIndex(MaterialSlotName: string): number;
	static C(Other: UObject | any): MeshComponent;
}

declare class SkeletalMeshSocket extends UObject { 
	SocketName: string;
	BoneName: string;
	RelativeLocation: Vector;
	RelativeRotation: Rotator;
	RelativeScale: Vector;
	bForceAlwaysAnimated: boolean;
	static Load(ResourceName: string): SkeletalMeshSocket;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshSocket;
	static GetDefaultObject(): SkeletalMeshSocket;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshSocket;
	InitializeSocketFromLocation(SkelComp: SkeletalMeshComponent,WorldLocation: Vector,WorldNormal: Vector): void;
	GetSocketLocation(SkelComp: SkeletalMeshComponent): Vector;
	static C(Other: UObject | any): SkeletalMeshSocket;
}

declare class SkinnedAsset extends StreamableRenderAsset { 
	static Load(ResourceName: string): SkinnedAsset;
	static Find(Outer: UObject, ResourceName: string): SkinnedAsset;
	static GetDefaultObject(): SkinnedAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkinnedAsset;
	FindSocketInfo(InSocketName: string,OutTransform?: Transform,OutBoneIndex?: number,OutIndex?: number): {OutTransform: Transform, OutBoneIndex: number, OutIndex: number, $: SkeletalMeshSocket};
	FindSocket(InSocketName: string): SkeletalMeshSocket;
	static C(Other: UObject | any): SkinnedAsset;
}

declare class SkeletalMeshEditorData extends UObject { 
	static Load(ResourceName: string): SkeletalMeshEditorData;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshEditorData;
	static GetDefaultObject(): SkeletalMeshEditorData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshEditorData;
	static C(Other: UObject | any): SkeletalMeshEditorData;
}

declare type EBoneTranslationRetargetingMode = 'Animation' | 'Skeleton' | 'AnimationScaled' | 'AnimationRelative' | 'OrientAndScale' | 'EBoneTranslationRetargetingMode_MAX';
declare var EBoneTranslationRetargetingMode : { Animation:'Animation',Skeleton:'Skeleton',AnimationScaled:'AnimationScaled',AnimationRelative:'AnimationRelative',OrientAndScale:'OrientAndScale',EBoneTranslationRetargetingMode_MAX:'EBoneTranslationRetargetingMode_MAX', };
declare class BoneNode { 
	Name: string;
	ParentIndex: number;
	TranslationRetargetingMode: EBoneTranslationRetargetingMode;
	clone() : BoneNode;
	static C(Other: UObject | any): BoneNode;
}

declare class VirtualBone { 
	SourceBoneName: string;
	TargetBoneName: string;
	VirtualBoneName: string;
	clone() : VirtualBone;
	static C(Other: UObject | any): VirtualBone;
}

declare class SmartNameContainer { 
	clone() : SmartNameContainer;
	static C(Other: UObject | any): SmartNameContainer;
}

declare class BoneReference { 
	BoneName: string;
	clone() : BoneReference;
	static C(Other: UObject | any): BoneReference;
}

declare class BlendProfileBoneEntry { 
	BoneReference: BoneReference;
	BlendScale: number;
	clone() : BlendProfileBoneEntry;
	static C(Other: UObject | any): BlendProfileBoneEntry;
}

declare type EBlendProfileMode = 'TimeFactor' | 'WeightFactor' | 'BlendMask' | 'EBlendProfileMode_MAX';
declare var EBlendProfileMode : { TimeFactor:'TimeFactor',WeightFactor:'WeightFactor',BlendMask:'BlendMask',EBlendProfileMode_MAX:'EBlendProfileMode_MAX', };
declare class BlendProfile extends UObject { 
	OwningSkeleton: Skeleton;
	ProfileEntries: BlendProfileBoneEntry[];
	Mode: EBlendProfileMode;
	static Load(ResourceName: string): BlendProfile;
	static Find(Outer: UObject, ResourceName: string): BlendProfile;
	static GetDefaultObject(): BlendProfile;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlendProfile;
	static C(Other: UObject | any): BlendProfile;
}

declare class AnimSlotGroup { 
	GroupName: string;
	SlotNames: string[];
	clone() : AnimSlotGroup;
	static C(Other: UObject | any): AnimSlotGroup;
}

declare class DataAsset extends UObject { 
	NativeClass: UnrealEngineClass;
	static Load(ResourceName: string): DataAsset;
	static Find(Outer: UObject, ResourceName: string): DataAsset;
	static GetDefaultObject(): DataAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataAsset;
	static C(Other: UObject | any): DataAsset;
}

declare type EConstraintTransform = 'Absolute' | 'Relative' | 'EConstraintTransform_MAX';
declare var EConstraintTransform : { Absolute:'Absolute',Relative:'Relative',EConstraintTransform_MAX:'EConstraintTransform_MAX', };
declare class RigTransformConstraint { 
	TranformType: EConstraintTransform;
	ParentSpace: string;
	Weight: number;
	clone() : RigTransformConstraint;
	static C(Other: UObject | any): RigTransformConstraint;
}

declare class TransformBaseConstraint { 
	TransformConstraints: RigTransformConstraint[];
	clone() : TransformBaseConstraint;
	static C(Other: UObject | any): TransformBaseConstraint;
}

declare class TransformBase { 
	UNode: string;
	Constraints: TransformBaseConstraint;
	clone() : TransformBase;
	static C(Other: UObject | any): TransformBase;
}

declare class UNode { 
	Name: string;
	ParentName: string;
	Transform: Transform;
	DisplayName: string;
	bAdvanced: boolean;
	clone() : UNode;
	static C(Other: UObject | any): UNode;
}

declare class Rig extends UObject { 
	TransformBases: TransformBase[];
	Nodes: UNode[];
	static Load(ResourceName: string): Rig;
	static Find(Outer: UObject, ResourceName: string): Rig;
	static GetDefaultObject(): Rig;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Rig;
	static C(Other: UObject | any): Rig;
}

declare class NameMapping { 
	NodeName: string;
	BoneName: string;
	clone() : NameMapping;
	static C(Other: UObject | any): NameMapping;
}

declare class RigConfiguration { 
	Rig: Rig;
	BoneMappingTable: NameMapping[];
	clone() : RigConfiguration;
	static C(Other: UObject | any): RigConfiguration;
}

declare class PreviewAttachedObjectPair { 
	AttachedObject: UObject;
	UObject: UObject;
	AttachedTo: string;
	clone() : PreviewAttachedObjectPair;
	static C(Other: UObject | any): PreviewAttachedObjectPair;
}

declare class PreviewAssetAttachContainer { 
	AttachedObjects: PreviewAttachedObjectPair[];
	clone() : PreviewAssetAttachContainer;
	static C(Other: UObject | any): PreviewAssetAttachContainer;
}

declare type ERawCurveTrackTypes = 'RCT_Float' | 'RCT_Vector' | 'RCT_Transform' | 'RCT_MAX';
declare var ERawCurveTrackTypes : { RCT_Float:'RCT_Float',RCT_Vector:'RCT_Vector',RCT_Transform:'RCT_Transform',RCT_MAX:'RCT_MAX', };
declare type ETransformCurveChannel = 'Position' | 'Rotation' | 'Scale' | 'Invalid' | 'ETransformCurveChannel_MAX';
declare var ETransformCurveChannel : { Position:'Position',Rotation:'Rotation',Scale:'Scale',Invalid:'Invalid',ETransformCurveChannel_MAX:'ETransformCurveChannel_MAX', };
declare type EVectorCurveChannel = 'X' | 'Y' | 'Z' | 'Invalid' | 'EVectorCurveChannel_MAX';
declare var EVectorCurveChannel : { X:'X',Y:'Y',Z:'Z',Invalid:'Invalid',EVectorCurveChannel_MAX:'EVectorCurveChannel_MAX', };
declare class AnimationCurveIdentifier { 
	clone() : AnimationCurveIdentifier;
	static C(Other: UObject | any): AnimationCurveIdentifier;
	GetName(): {Identifier: AnimationCurveIdentifier, $: string};
	GetTransformChildCurveIdentifier(Channel?: ETransformCurveChannel,Axis?: EVectorCurveChannel): {InOutIdentifier: AnimationCurveIdentifier, $: boolean};
	GetType(): {Identifier: AnimationCurveIdentifier, $: ERawCurveTrackTypes};
	IsValid(): {Identifier: AnimationCurveIdentifier, $: boolean};
	static GetName(Identifier?: AnimationCurveIdentifier): {Identifier: AnimationCurveIdentifier, $: string};
	static GetTransformChildCurveIdentifier(InOutIdentifier?: AnimationCurveIdentifier,Channel?: ETransformCurveChannel,Axis?: EVectorCurveChannel): {InOutIdentifier: AnimationCurveIdentifier, $: boolean};
	static GetType(Identifier?: AnimationCurveIdentifier): {Identifier: AnimationCurveIdentifier, $: ERawCurveTrackTypes};
	static IsValid(Identifier?: AnimationCurveIdentifier): {Identifier: AnimationCurveIdentifier, $: boolean};
}

declare class AnimGroupInfo { 
	Name: string;
	Color: LinearColor;
	clone() : AnimGroupInfo;
	static C(Other: UObject | any): AnimGroupInfo;
}

declare class AnimMetaData extends UObject { 
	static Load(ResourceName: string): AnimMetaData;
	static Find(Outer: UObject, ResourceName: string): AnimMetaData;
	static GetDefaultObject(): AnimMetaData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimMetaData;
	static C(Other: UObject | any): AnimMetaData;
}

declare class AssetMapping { 
	SourceAsset: AnimationAsset;
	TargetAsset: AnimationAsset;
	clone() : AssetMapping;
	static C(Other: UObject | any): AssetMapping;
}

declare class AssetMappingTable extends UObject { 
	MappedAssets: AssetMapping[];
	static Load(ResourceName: string): AssetMappingTable;
	static Find(Outer: UObject, ResourceName: string): AssetMappingTable;
	static GetDefaultObject(): AssetMappingTable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AssetMappingTable;
	static C(Other: UObject | any): AssetMappingTable;
}

declare class SmartName { 
	DisplayName: string;
	clone() : SmartName;
	static C(Other: UObject | any): SmartName;
}

declare class PoseAssetInfluence { 
	PoseIndex: number;
	BoneTransformIndex: number;
	clone() : PoseAssetInfluence;
	static C(Other: UObject | any): PoseAssetInfluence;
}

declare class PoseAssetInfluences { 
	Influences: PoseAssetInfluence[];
	clone() : PoseAssetInfluences;
	static C(Other: UObject | any): PoseAssetInfluences;
}

declare class PoseData { 
	SourceLocalSpacePose: Transform[];
	SourceCurveData: number[];
	LocalSpacePose: Transform[];
	CurveData: number[];
	clone() : PoseData;
	static C(Other: UObject | any): PoseData;
}

declare class AnimCurveBase { 
	LastObservedName: string;
	Name: SmartName;
	Color: LinearColor;
	CurveTypeFlags: number;
	clone() : AnimCurveBase;
	static C(Other: UObject | any): AnimCurveBase;
}

declare class PoseDataContainer { 
	PoseNames: SmartName[];
	Tracks: string[];
	TrackBoneIndices: number[];
	TrackPoseInfluenceIndices: PoseAssetInfluences[];
	Poses: PoseData[];
	Curves: AnimCurveBase[];
	clone() : PoseDataContainer;
	static C(Other: UObject | any): PoseDataContainer;
}

declare class AnimCompositeBase extends AnimSequenceBase { 
	static Load(ResourceName: string): AnimCompositeBase;
	static Find(Outer: UObject, ResourceName: string): AnimCompositeBase;
	static GetDefaultObject(): AnimCompositeBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimCompositeBase;
	static C(Other: UObject | any): AnimCompositeBase;
}

declare type EMontageBlendMode = 'Standard' | 'Inertialization' | 'EMontageBlendMode_MAX';
declare var EMontageBlendMode : { Standard:'Standard',Inertialization:'Inertialization',EMontageBlendMode_MAX:'EMontageBlendMode_MAX', };
declare class CurveFloat extends CurveBase { 
	FloatCurve: RichCurve;
	bIsEventCurve: boolean;
	static Load(ResourceName: string): CurveFloat;
	static Find(Outer: UObject, ResourceName: string): CurveFloat;
	static GetDefaultObject(): CurveFloat;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveFloat;
	GetFloatValue(InTime: number): number;
	static C(Other: UObject | any): CurveFloat;
}

declare type EAlphaBlendOption = 'Linear' | 'Cubic' | 'HermiteCubic' | 'Sinusoidal' | 'QuadraticInOut' | 'CubicInOut' | 'QuarticInOut' | 'QuinticInOut' | 'CircularIn' | 'CircularOut' | 'CircularInOut' | 'ExpIn' | 'ExpOut' | 'ExpInOut' | 'Custom' | 'EAlphaBlendOption_MAX';
declare var EAlphaBlendOption : { Linear:'Linear',Cubic:'Cubic',HermiteCubic:'HermiteCubic',Sinusoidal:'Sinusoidal',QuadraticInOut:'QuadraticInOut',CubicInOut:'CubicInOut',QuarticInOut:'QuarticInOut',QuinticInOut:'QuinticInOut',CircularIn:'CircularIn',CircularOut:'CircularOut',CircularInOut:'CircularInOut',ExpIn:'ExpIn',ExpOut:'ExpOut',ExpInOut:'ExpInOut',Custom:'Custom',EAlphaBlendOption_MAX:'EAlphaBlendOption_MAX', };
declare class AlphaBlend { 
	CustomCurve: CurveFloat;
	BlendTime: number;
	BlendOption: EAlphaBlendOption;
	clone() : AlphaBlend;
	static C(Other: UObject | any): AlphaBlend;
}

declare class AnimSyncMarker { 
	MarkerName: string;
	Time: number;
	TrackIndex: number;
	Guid: Guid;
	clone() : AnimSyncMarker;
	static C(Other: UObject | any): AnimSyncMarker;
}

declare class MarkerSyncData { 
	AuthoredSyncMarkers: AnimSyncMarker[];
	clone() : MarkerSyncData;
	static C(Other: UObject | any): MarkerSyncData;
}

declare class CompositeSection extends AnimLinkableElement { 
	SectionName: string;
	StartTime: number;
	NextSectionName: string;
	MetaData: AnimMetaData[];
	clone() : CompositeSection;
	static C(Other: UObject | any): CompositeSection;
}

declare class AnimSegment { 
	AnimReference: AnimSequenceBase;
	CachedPlayLength: number;
	StartPos: number;
	AnimStartTime: number;
	AnimEndTime: number;
	AnimPlayRate: number;
	LoopingCount: number;
	clone() : AnimSegment;
	static C(Other: UObject | any): AnimSegment;
}

declare class AnimTrack { 
	AnimSegments: AnimSegment[];
	clone() : AnimTrack;
	static C(Other: UObject | any): AnimTrack;
}

declare class SlotAnimationTrack { 
	SlotName: string;
	AnimTrack: AnimTrack;
	clone() : SlotAnimationTrack;
	static C(Other: UObject | any): SlotAnimationTrack;
}

declare class BranchingPoint extends AnimLinkableElement { 
	EventName: string;
	DisplayTime: number;
	TriggerTimeOffset: number;
	clone() : BranchingPoint;
	static C(Other: UObject | any): BranchingPoint;
}

declare type ERootMotionRootLock = 'RefPose' | 'AnimFirstFrame' | 'Zero' | 'ERootMotionRootLock_MAX';
declare var ERootMotionRootLock : { RefPose:'RefPose',AnimFirstFrame:'AnimFirstFrame',Zero:'Zero',ERootMotionRootLock_MAX:'ERootMotionRootLock_MAX', };
declare type EAnimNotifyEventType = 'Begin' | 'End' | 'EAnimNotifyEventType_MAX';
declare var EAnimNotifyEventType : { Begin:'Begin',End:'End',EAnimNotifyEventType_MAX:'EAnimNotifyEventType_MAX', };
declare class BranchingPointMarker { 
	NotifyIndex: number;
	TriggerTime: number;
	NotifyEventType: EAnimNotifyEventType;
	clone() : BranchingPointMarker;
	static C(Other: UObject | any): BranchingPointMarker;
}

declare class TimeStretchCurveMarker { 
	Time: number;
	Alpha: number;
	clone() : TimeStretchCurveMarker;
	static C(Other: UObject | any): TimeStretchCurveMarker;
}

declare class TimeStretchCurve { 
	SamplingRate: number;
	CurveValueMinPrecision: number;
	Markers: TimeStretchCurveMarker[];
	Sum_dT_i_by_C_i: number;
	clone() : TimeStretchCurve;
	static C(Other: UObject | any): TimeStretchCurve;
}

declare class AlphaBlendArgs { 
	CustomCurve: CurveFloat;
	BlendTime: number;
	BlendOption: EAlphaBlendOption;
	clone() : AlphaBlendArgs;
	static C(Other: UObject | any): AlphaBlendArgs;
}

declare class MontageBlendSettings { 
	BlendProfile: BlendProfile;
	Blend: AlphaBlendArgs;
	BlendMode: EMontageBlendMode;
	clone() : MontageBlendSettings;
	static C(Other: UObject | any): MontageBlendSettings;
}

declare class AnimMontage extends AnimCompositeBase { 
	BlendModeIn: EMontageBlendMode;
	BlendModeOut: EMontageBlendMode;
	BlendIn: AlphaBlend;
	BlendInTime: number;
	BlendOut: AlphaBlend;
	BlendOutTime: number;
	BlendOutTriggerTime: number;
	SyncGroup: string;
	SyncSlotIndex: number;
	MarkerData: MarkerSyncData;
	CompositeSections: CompositeSection[];
	SlotAnimTracks: SlotAnimationTrack[];
	BranchingPoints: BranchingPoint[];
	bEnableRootMotionTranslation: boolean;
	bEnableRootMotionRotation: boolean;
	bEnableAutoBlendOut: boolean;
	BlendProfileIn: BlendProfile;
	BlendProfileOut: BlendProfile;
	RootMotionRootLock: ERootMotionRootLock;
	PreviewBasePose: AnimSequence;
	BranchingPointMarkers: BranchingPointMarker[];
	BranchingPointStateNotifyIndices: number[];
	TimeStretchCurve: TimeStretchCurve;
	TimeStretchCurveName: string;
	static Load(ResourceName: string): AnimMontage;
	static Find(Outer: UObject, ResourceName: string): AnimMontage;
	static GetDefaultObject(): AnimMontage;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimMontage;
	IsValidSectionName(InSectionName: string): boolean;
	GetSectionName(SectionIndex: number): string;
	GetSectionIndex(InSectionName: string): number;
	GetNumSections(): number;
	GetDefaultBlendOutTime(): number;
	GetDefaultBlendInTime(): number;
	GetBlendOutArgs(): AlphaBlendArgs;
	GetBlendInArgs(): AlphaBlendArgs;
	static CreateSlotAnimationAsDynamicMontage_WithBlendSettings(Asset: AnimSequenceBase,SlotNodeName: string,BlendInSettings: MontageBlendSettings,BlendOutSettings: MontageBlendSettings,InPlayRate: number,LoopCount: number,InBlendOutTriggerTime: number): AnimMontage;
	static C(Other: UObject | any): AnimMontage;
	GetMontageSlotNames(SlotNames?: string[]): {SlotNames: string[]};
	static GetMontageSlotNames(AnimationMontage: AnimMontage,SlotNames?: string[]): {SlotNames: string[]};
}

declare type EAnimLinkMethod = 'Absolute' | 'Relative' | 'Proportional' | 'EAnimLinkMethod_MAX';
declare var EAnimLinkMethod : { Absolute:'Absolute',Relative:'Relative',Proportional:'Proportional',EAnimLinkMethod_MAX:'EAnimLinkMethod_MAX', };
declare class AnimLinkableElement { 
	LinkedMontage: AnimMontage;
	SlotIndex: number;
	SegmentIndex: number;
	LinkMethod: EAnimLinkMethod;
	CachedLinkMethod: EAnimLinkMethod;
	SegmentBeginTime: number;
	SegmentLength: number;
	LinkValue: number;
	LinkedSequence: AnimSequenceBase;
	clone() : AnimLinkableElement;
	static C(Other: UObject | any): AnimLinkableElement;
}

declare class ScriptStruct extends Struct { 
	static Load(ResourceName: string): ScriptStruct;
	static Find(Outer: UObject, ResourceName: string): ScriptStruct;
	static GetDefaultObject(): ScriptStruct;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ScriptStruct;
	static C(Other: UObject | any): ScriptStruct;
}

declare class TableRowBase { 
	clone() : TableRowBase;
	static C(Other: UObject | any): TableRowBase;
}

declare class DataTable extends UObject { 
	RowStruct: ScriptStruct;
	bStripFromClientBuilds: boolean;
	bIgnoreExtraFields: boolean;
	bIgnoreMissingFields: boolean;
	ImportKeyField: string;
	AssetImportData: AssetImportData;
	ImportPath: string;
	RowStructName: string;
	RowStructPathName: TopLevelAssetPath;
	RowsSerializedWithTags: number[];
	TemporarilyReferencedObjects: Set<UObject>;
	static Load(ResourceName: string): DataTable;
	static Find(Outer: UObject, ResourceName: string): DataTable;
	static GetDefaultObject(): DataTable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataTable;
	static C(Other: UObject | any): DataTable;
	GetDataTableAsJSON(InDTExportFlags: number): string;
	DoesDataTableRowExist(RowName: string): boolean;
	FillDataTableFromCSVFile(CSVFilePath: string): boolean;
	FillDataTableFromCSVString(CSVString: string): boolean;
	FillDataTableFromJSONFile(JSONFilePath: string,ImportRowStruct: ScriptStruct): boolean;
	FillDataTableFromJSONString(JsonString: string): boolean;
	GetDataTableColumnAsString(PropertyName: string): string[];
	GetDataTableRowFromName(RowName: string,OutRow?: TableRowBase): {OutRow: TableRowBase, $: boolean};
	GetDataTableRowNames(OutRowNames?: string[]): {OutRowNames: string[]};
	static GetDataTableAsJSON(InDataTable: DataTable,InDTExportFlags: number): string;
	static DoesDataTableRowExist(Table: DataTable,RowName: string): boolean;
	static FillDataTableFromCSVFile(DataTable: DataTable,CSVFilePath: string): boolean;
	static FillDataTableFromCSVString(DataTable: DataTable,CSVString: string): boolean;
	static FillDataTableFromJSONFile(DataTable: DataTable,JSONFilePath: string,ImportRowStruct: ScriptStruct): boolean;
	static FillDataTableFromJSONString(DataTable: DataTable,JsonString: string): boolean;
	static GetDataTableColumnAsString(DataTable: DataTable,PropertyName: string): string[];
	static GetDataTableRowFromName(Table: DataTable,RowName: string,OutRow?: TableRowBase): {OutRow: TableRowBase, $: boolean};
	static GetDataTableRowNames(Table: DataTable,OutRowNames?: string[]): {OutRowNames: string[]};
}

declare type EMirrorFindReplaceMethod = 'Prefix' | 'Suffix' | 'RegularExpression' | 'EMirrorFindReplaceMethod_MAX';
declare var EMirrorFindReplaceMethod : { Prefix:'Prefix',Suffix:'Suffix',RegularExpression:'RegularExpression',EMirrorFindReplaceMethod_MAX:'EMirrorFindReplaceMethod_MAX', };
declare class MirrorFindReplaceExpression { 
	FindExpression: string;
	ReplaceExpression: string;
	FindReplaceMethod: EMirrorFindReplaceMethod;
	clone() : MirrorFindReplaceExpression;
	static C(Other: UObject | any): MirrorFindReplaceExpression;
}

declare class MirrorDataTable extends DataTable { 
	MirrorFindReplaceExpressions: MirrorFindReplaceExpression[];
	MirrorAxis: EAxis;
	Skeleton: Skeleton;
	static Load(ResourceName: string): MirrorDataTable;
	static Find(Outer: UObject, ResourceName: string): MirrorDataTable;
	static GetDefaultObject(): MirrorDataTable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MirrorDataTable;
	static C(Other: UObject | any): MirrorDataTable;
}

declare type ERootMotionMode = 'NoRootMotionExtraction' | 'IgnoreRootMotion' | 'RootMotionFromEverything' | 'RootMotionFromMontagesOnly' | 'ERootMotionMode_MAX';
declare var ERootMotionMode : { NoRootMotionExtraction:'NoRootMotionExtraction',IgnoreRootMotion:'IgnoreRootMotion',RootMotionFromEverything:'RootMotionFromEverything',RootMotionFromMontagesOnly:'RootMotionFromMontagesOnly',ERootMotionMode_MAX:'ERootMotionMode_MAX', };
declare class AnimNotifyArray { 
	Notifies: AnimNotifyEventReference[];
	clone() : AnimNotifyArray;
	static C(Other: UObject | any): AnimNotifyArray;
}

declare class AnimNotifyQueue { 
	AnimNotifies: AnimNotifyEventReference[];
	UnfilteredMontageAnimNotifies: Map<string, AnimNotifyArray>;
	clone() : AnimNotifyQueue;
	static C(Other: UObject | any): AnimNotifyQueue;
}

declare class AnimNotifyState extends UObject { 
	NotifyColor: Color;
	bShouldFireInEditor: boolean;
	static Load(ResourceName: string): AnimNotifyState;
	static Find(Outer: UObject, ResourceName: string): AnimNotifyState;
	static GetDefaultObject(): AnimNotifyState;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimNotifyState;
	Received_NotifyTick(MeshComp: SkeletalMeshComponent,Animation: AnimSequenceBase,FrameDeltaTime: number,EventReference: AnimNotifyEventReference): boolean;
	Received_NotifyEnd(MeshComp: SkeletalMeshComponent,Animation: AnimSequenceBase,EventReference: AnimNotifyEventReference): boolean;
	Received_NotifyBegin(MeshComp: SkeletalMeshComponent,Animation: AnimSequenceBase,TotalDuration: number,EventReference: AnimNotifyEventReference): boolean;
	GetNotifyName(): string;
	GetDefaultTriggerWeightThreshold(): number;
	static C(Other: UObject | any): AnimNotifyState;
}

declare class PoseSnapshot { 
	LocalTransforms: Transform[];
	BoneNames: string[];
	SkeletalMeshName: string;
	SnapshotName: string;
	bIsValid: boolean;
	clone() : PoseSnapshot;
	static C(Other: UObject | any): PoseSnapshot;
}

declare type ETeleportType = 'None' | 'TeleportPhysics' | 'ResetPhysics' | 'ETeleportType_MAX';
declare var ETeleportType : { None:'None',TeleportPhysics:'TeleportPhysics',ResetPhysics:'ResetPhysics',ETeleportType_MAX:'ETeleportType_MAX', };
declare type ETransitionRequestQueueMode = 'Shared' | 'Unique' | 'ETransitionRequestQueueMode_MAX';
declare var ETransitionRequestQueueMode : { Shared:'Shared',Unique:'Unique',ETransitionRequestQueueMode_MAX:'ETransitionRequestQueueMode_MAX', };
declare type ETransitionRequestOverwriteMode = 'Append' | 'Ignore' | 'Overwrite' | 'ETransitionRequestOverwriteMode_MAX';
declare var ETransitionRequestOverwriteMode : { Append:'Append',Ignore:'Ignore',Overwrite:'Overwrite',ETransitionRequestOverwriteMode_MAX:'ETransitionRequestOverwriteMode_MAX', };
declare type EMontagePlayReturnType = 'MontageLength' | 'Duration' | 'EMontagePlayReturnType_MAX';
declare var EMontagePlayReturnType : { MontageLength:'MontageLength',Duration:'Duration',EMontagePlayReturnType_MAX:'EMontagePlayReturnType_MAX', };
declare class MarkerSyncAnimPosition { 
	PreviousMarkerName: string;
	NextMarkerName: string;
	PositionBetweenMarkers: number;
	clone() : MarkerSyncAnimPosition;
	static C(Other: UObject | any): MarkerSyncAnimPosition;
}

declare type EAnimCurveType = 'AttributeCurve' | 'MaterialCurve' | 'MorphTargetCurve' | 'MaxAnimCurveType' | 'EAnimCurveType_MAX';
declare var EAnimCurveType : { AttributeCurve:'AttributeCurve',MaterialCurve:'MaterialCurve',MorphTargetCurve:'MorphTargetCurve',MaxAnimCurveType:'MaxAnimCurveType',EAnimCurveType_MAX:'EAnimCurveType_MAX', };
declare class CachedAnimStateData { 
	StateMachineName: string;
	StateName: string;
	clone() : CachedAnimStateData;
	static C(Other: UObject | any): CachedAnimStateData;
}

declare type EAnimNodeReferenceConversionResult = 'Succeeded' | 'Failed' | 'EAnimNodeReferenceConversionResult_MAX';
declare var EAnimNodeReferenceConversionResult : { Succeeded:'Succeeded',Failed:'Failed',EAnimNodeReferenceConversionResult_MAX:'EAnimNodeReferenceConversionResult_MAX', };
declare class SkeletalControlReference extends AnimNodeReference { 
	clone() : SkeletalControlReference;
	static C(Other: UObject | any): SkeletalControlReference;
	GetAlpha(): number;
	SetAlpha(Alpha: number): SkeletalControlReference;
	static GetAlpha(SkeletalControl: SkeletalControlReference): number;
	static SetAlpha(SkeletalControl: SkeletalControlReference,Alpha: number): SkeletalControlReference;
}

declare class SequencePlayerReference extends AnimNodeReference { 
	clone() : SequencePlayerReference;
	static C(Other: UObject | any): SequencePlayerReference;
	ComputePlayRateFromDuration(Duration: number): number;
	GetAccumulatedTime(): number;
	GetLoopAnimation(): boolean;
	GetPlayRate(): number;
	GetSequence(SequenceBase?: AnimSequenceBase): {SequenceBase: AnimSequenceBase, $: SequencePlayerReference};
	GetSequencePure(): AnimSequenceBase;
	GetStartPosition(): number;
	SetAccumulatedTime(Time: number): SequencePlayerReference;
	SetPlayRate(PlayRate: number): SequencePlayerReference;
	SetSequence(Sequence: AnimSequenceBase): SequencePlayerReference;
	SetStartPosition(StartPosition: number): SequencePlayerReference;
	static ComputePlayRateFromDuration(SequencePlayer: SequencePlayerReference,Duration: number): number;
	static GetAccumulatedTime(SequencePlayer: SequencePlayerReference): number;
	static GetLoopAnimation(SequencePlayer: SequencePlayerReference): boolean;
	static GetPlayRate(SequencePlayer: SequencePlayerReference): number;
	static GetSequence(SequencePlayer: SequencePlayerReference,SequenceBase?: AnimSequenceBase): {SequenceBase: AnimSequenceBase, $: SequencePlayerReference};
	static GetSequencePure(SequencePlayer: SequencePlayerReference): AnimSequenceBase;
	static GetStartPosition(SequencePlayer: SequencePlayerReference): number;
	static SetAccumulatedTime(SequencePlayer: SequencePlayerReference,Time: number): SequencePlayerReference;
	static SetPlayRate(SequencePlayer: SequencePlayerReference,PlayRate: number): SequencePlayerReference;
	static SetSequence(SequencePlayer: SequencePlayerReference,Sequence: AnimSequenceBase): SequencePlayerReference;
	static SetStartPosition(SequencePlayer: SequencePlayerReference,StartPosition: number): SequencePlayerReference;
}

declare class SequenceEvaluatorReference extends AnimNodeReference { 
	clone() : SequenceEvaluatorReference;
	static C(Other: UObject | any): SequenceEvaluatorReference;
	GetAccumulatedTime(): number;
	GetSequence(): AnimSequenceBase;
	SetExplicitTime(Time: number): SequenceEvaluatorReference;
	SetSequence(Sequence: AnimSequenceBase): SequenceEvaluatorReference;
	static GetAccumulatedTime(SequenceEvaluator: SequenceEvaluatorReference): number;
	static GetSequence(SequenceEvaluator: SequenceEvaluatorReference): AnimSequenceBase;
	static SetExplicitTime(SequenceEvaluator: SequenceEvaluatorReference,Time: number): SequenceEvaluatorReference;
	static SetSequence(SequenceEvaluator: SequenceEvaluatorReference,Sequence: AnimSequenceBase): SequenceEvaluatorReference;
}

declare class LinkedAnimGraphReference extends AnimNodeReference { 
	clone() : LinkedAnimGraphReference;
	static C(Other: UObject | any): LinkedAnimGraphReference;
	GetLinkedAnimInstance(): AnimInstance;
	HasLinkedAnimInstance(): boolean;
	static GetLinkedAnimInstance(UNode: LinkedAnimGraphReference): AnimInstance;
	static HasLinkedAnimInstance(UNode: LinkedAnimGraphReference): boolean;
}

declare class AnimationStateMachineReference extends AnimNodeReference { 
	clone() : AnimationStateMachineReference;
	static C(Other: UObject | any): AnimationStateMachineReference;
}

declare class AnimationStateResultReference extends AnimNodeReference { 
	clone() : AnimationStateResultReference;
	static C(Other: UObject | any): AnimationStateResultReference;
}

declare class LayeredBoneBlendReference extends AnimNodeReference { 
	clone() : LayeredBoneBlendReference;
	static C(Other: UObject | any): LayeredBoneBlendReference;
	GetNumPoses(): number;
	static GetNumPoses(LayeredBoneBlend: LayeredBoneBlendReference): number;
}

declare type EFilterInterpolationType = 'BSIT_Average' | 'BSIT_Linear' | 'BSIT_Cubic' | 'BSIT_EaseInOut' | 'BSIT_ExponentialDecay' | 'BSIT_SpringDamper' | 'BSIT_MAX';
declare var EFilterInterpolationType : { BSIT_Average:'BSIT_Average',BSIT_Linear:'BSIT_Linear',BSIT_Cubic:'BSIT_Cubic',BSIT_EaseInOut:'BSIT_EaseInOut',BSIT_ExponentialDecay:'BSIT_ExponentialDecay',BSIT_SpringDamper:'BSIT_SpringDamper',BSIT_MAX:'BSIT_MAX', };
declare class InterpolationParameter { 
	InterpolationTime: number;
	DampingRatio: number;
	MaxSpeed: number;
	InterpolationType: EFilterInterpolationType;
	clone() : InterpolationParameter;
	static C(Other: UObject | any): InterpolationParameter;
}

declare class AnalysisProperties extends UObject { 
	UFunction: string;
	static Load(ResourceName: string): AnalysisProperties;
	static Find(Outer: UObject, ResourceName: string): AnalysisProperties;
	static GetDefaultObject(): AnalysisProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnalysisProperties;
	static C(Other: UObject | any): AnalysisProperties;
}

declare type ENotifyTriggerMode = 'AllAnimations' | 'HighestWeightedAnimation' | 'None' | 'ENotifyTriggerMode_MAX';
declare var ENotifyTriggerMode : { AllAnimations:'AllAnimations',HighestWeightedAnimation:'HighestWeightedAnimation',None:'None',ENotifyTriggerMode_MAX:'ENotifyTriggerMode_MAX', };
declare type EPreferredTriangulationDirection = 'None' | 'Tangential' | 'Radial' | 'EPreferredTriangulationDirection_MAX';
declare var EPreferredTriangulationDirection : { None:'None',Tangential:'Tangential',Radial:'Radial',EPreferredTriangulationDirection_MAX:'EPreferredTriangulationDirection_MAX', };
declare class PerBoneInterpolation { 
	BoneReference: BoneReference;
	InterpolationSpeedPerSec: number;
	clone() : PerBoneInterpolation;
	static C(Other: UObject | any): PerBoneInterpolation;
}

declare class BlendSample { 
	Animation: AnimSequence;
	SampleValue: Vector;
	RateScale: number;
	bIsValid: boolean;
	clone() : BlendSample;
	static C(Other: UObject | any): BlendSample;
}

declare class EditorElement { 
	Indices: number;
	Weights: number;
	clone() : EditorElement;
	static C(Other: UObject | any): EditorElement;
}

declare class BlendSpaceSegment { 
	SampleIndices: number;
	Vertices: number;
	clone() : BlendSpaceSegment;
	static C(Other: UObject | any): BlendSpaceSegment;
}

declare class BlendSpaceTriangleEdgeInfo { 
	Normal: Vector2D;
	NeighbourTriangleIndex: number;
	AdjacentPerimeterTriangleIndices: number;
	AdjacentPerimeterVertexIndices: number;
	clone() : BlendSpaceTriangleEdgeInfo;
	static C(Other: UObject | any): BlendSpaceTriangleEdgeInfo;
}

declare class BlendSpaceTriangle { 
	SampleIndices: number;
	Vertices: Vector2D;
	EdgeInfo: BlendSpaceTriangleEdgeInfo;
	clone() : BlendSpaceTriangle;
	static C(Other: UObject | any): BlendSpaceTriangle;
}

declare class BlendSpaceData { 
	Segments: BlendSpaceSegment[];
	Triangles: BlendSpaceTriangle[];
	clone() : BlendSpaceData;
	static C(Other: UObject | any): BlendSpaceData;
}

declare class BlendParameter { 
	DisplayName: string;
	Min: number;
	Max: number;
	GridNum: number;
	bSnapToGrid: boolean;
	bWrapInput: boolean;
	clone() : BlendParameter;
	static C(Other: UObject | any): BlendParameter;
}

declare type EBlendSpaceAxis = 'BSA_None' | 'BSA_X' | 'BSA_Y' | 'BSA_MAX';
declare var EBlendSpaceAxis : { BSA_None:'BSA_None',BSA_X:'BSA_X',BSA_Y:'BSA_Y',BSA_MAX:'BSA_MAX', };
declare class BlendSpace extends AnimationAsset { 
	bContainsRotationOffsetMeshSpaceSamples: boolean;
	InterpolationParam: InterpolationParameter;
	AnalysisProperties: AnalysisProperties;
	TargetWeightInterpolationSpeedPerSec: number;
	bTargetWeightInterpolationEaseInOut: boolean;
	bAllowMeshSpaceBlending: boolean;
	bLoop: boolean;
	PreviewBasePose: AnimSequence;
	AnimLength: number;
	NotifyTriggerMode: ENotifyTriggerMode;
	bInterpolateUsingGrid: boolean;
	PreferredTriangulationDirection: EPreferredTriangulationDirection;
	PerBoneBlend: PerBoneInterpolation[];
	SampleIndexWithMarkers: number;
	SampleData: BlendSample[];
	GridSamples: EditorElement[];
	BlendSpaceData: BlendSpaceData;
	BlendParameters: BlendParameter;
	AxisToScaleAnimation: EBlendSpaceAxis;
	DimensionIndices: number[];
	static Load(ResourceName: string): BlendSpace;
	static Find(Outer: UObject, ResourceName: string): BlendSpace;
	static GetDefaultObject(): BlendSpace;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlendSpace;
	static C(Other: UObject | any): BlendSpace;
}

declare class BlendSpacePlayerReference extends AnimNodeReference { 
	clone() : BlendSpacePlayerReference;
	static C(Other: UObject | any): BlendSpacePlayerReference;
	GetBlendSpace(): BlendSpace;
	GetLoop(): boolean;
	GetPlayRate(): number;
	GetPosition(): Vector;
	GetStartPosition(): number;
	SetBlendSpace(BlendSpace: BlendSpace): BlendSpacePlayerReference;
	SetLoop(bLoop: boolean): BlendSpacePlayerReference;
	SetPlayRate(PlayRate: number): BlendSpacePlayerReference;
	SetResetPlayTimeWhenBlendSpaceChanges(bReset: boolean): BlendSpacePlayerReference;
	ShouldResetPlayTimeWhenBlendSpaceChanges(): boolean;
	static GetBlendSpace(BlendSpacePlayer: BlendSpacePlayerReference): BlendSpace;
	static GetLoop(BlendSpacePlayer: BlendSpacePlayerReference): boolean;
	static GetPlayRate(BlendSpacePlayer: BlendSpacePlayerReference): number;
	static GetPosition(BlendSpacePlayer: BlendSpacePlayerReference): Vector;
	static GetStartPosition(BlendSpacePlayer: BlendSpacePlayerReference): number;
	static SetBlendSpace(BlendSpacePlayer: BlendSpacePlayerReference,BlendSpace: BlendSpace): BlendSpacePlayerReference;
	static SetLoop(BlendSpacePlayer: BlendSpacePlayerReference,bLoop: boolean): BlendSpacePlayerReference;
	static SetPlayRate(BlendSpacePlayer: BlendSpacePlayerReference,PlayRate: number): BlendSpacePlayerReference;
	static SetResetPlayTimeWhenBlendSpaceChanges(BlendSpacePlayer: BlendSpacePlayerReference,bReset: boolean): BlendSpacePlayerReference;
	static ShouldResetPlayTimeWhenBlendSpaceChanges(BlendSpacePlayer: BlendSpacePlayerReference): boolean;
}

declare class AnimNodeReference { 
	clone() : AnimNodeReference;
	static C(Other: UObject | any): AnimNodeReference;
	ConvertToSkeletalControl(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SkeletalControlReference};
	ConvertToSkeletalControlPure(SkeletalControl?: SkeletalControlReference,Result?: boolean): {SkeletalControl: SkeletalControlReference, Result: boolean};
	ConvertToSequencePlayer(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SequencePlayerReference};
	ConvertToSequencePlayerPure(SequencePlayer?: SequencePlayerReference,Result?: boolean): {SequencePlayer: SequencePlayerReference, Result: boolean};
	ConvertToSequenceEvaluator(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SequenceEvaluatorReference};
	ConvertToSequenceEvaluatorPure(SequenceEvaluator?: SequenceEvaluatorReference,Result?: boolean): {SequenceEvaluator: SequenceEvaluatorReference, Result: boolean};
	ConvertToLinkedAnimGraph(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: LinkedAnimGraphReference};
	ConvertToLinkedAnimGraphPure(LinkedAnimGraph?: LinkedAnimGraphReference,Result?: boolean): {LinkedAnimGraph: LinkedAnimGraphReference, Result: boolean};
	ConvertToAnimationStateMachine(AnimationState?: AnimationStateMachineReference,Result?: EAnimNodeReferenceConversionResult): {AnimationState: AnimationStateMachineReference, Result: EAnimNodeReferenceConversionResult};
	ConvertToAnimationStateMachinePure(AnimationState?: AnimationStateMachineReference,Result?: boolean): {AnimationState: AnimationStateMachineReference, Result: boolean};
	ConvertToAnimationStateResult(AnimationState?: AnimationStateResultReference,Result?: EAnimNodeReferenceConversionResult): {AnimationState: AnimationStateResultReference, Result: EAnimNodeReferenceConversionResult};
	ConvertToAnimationStateResultPure(AnimationState?: AnimationStateResultReference,Result?: boolean): {AnimationState: AnimationStateResultReference, Result: boolean};
	ConvertToLayeredBlendPerBonePure(LayeredBoneBlend?: LayeredBoneBlendReference,Result?: boolean): {LayeredBoneBlend: LayeredBoneBlendReference, Result: boolean};
	ConvertToLayeredBoneBlend(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: LayeredBoneBlendReference};
	ConvertToBlendSpacePlayer(Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: BlendSpacePlayerReference};
	ConvertToBlendSpacePlayerPure(BlendSpacePlayer?: BlendSpacePlayerReference,Result?: boolean): {BlendSpacePlayer: BlendSpacePlayerReference, Result: boolean};
	static ConvertToSkeletalControl(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SkeletalControlReference};
	static ConvertToSkeletalControlPure(UNode: AnimNodeReference,SkeletalControl?: SkeletalControlReference,Result?: boolean): {SkeletalControl: SkeletalControlReference, Result: boolean};
	static ConvertToSequencePlayer(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SequencePlayerReference};
	static ConvertToSequencePlayerPure(UNode: AnimNodeReference,SequencePlayer?: SequencePlayerReference,Result?: boolean): {SequencePlayer: SequencePlayerReference, Result: boolean};
	static ConvertToSequenceEvaluator(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: SequenceEvaluatorReference};
	static ConvertToSequenceEvaluatorPure(UNode: AnimNodeReference,SequenceEvaluator?: SequenceEvaluatorReference,Result?: boolean): {SequenceEvaluator: SequenceEvaluatorReference, Result: boolean};
	static ConvertToLinkedAnimGraph(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: LinkedAnimGraphReference};
	static ConvertToLinkedAnimGraphPure(UNode: AnimNodeReference,LinkedAnimGraph?: LinkedAnimGraphReference,Result?: boolean): {LinkedAnimGraph: LinkedAnimGraphReference, Result: boolean};
	static ConvertToAnimationStateMachine(UNode: AnimNodeReference,AnimationState?: AnimationStateMachineReference,Result?: EAnimNodeReferenceConversionResult): {AnimationState: AnimationStateMachineReference, Result: EAnimNodeReferenceConversionResult};
	static ConvertToAnimationStateMachinePure(UNode: AnimNodeReference,AnimationState?: AnimationStateMachineReference,Result?: boolean): {AnimationState: AnimationStateMachineReference, Result: boolean};
	static ConvertToAnimationStateResult(UNode: AnimNodeReference,AnimationState?: AnimationStateResultReference,Result?: EAnimNodeReferenceConversionResult): {AnimationState: AnimationStateResultReference, Result: EAnimNodeReferenceConversionResult};
	static ConvertToAnimationStateResultPure(UNode: AnimNodeReference,AnimationState?: AnimationStateResultReference,Result?: boolean): {AnimationState: AnimationStateResultReference, Result: boolean};
	static ConvertToLayeredBlendPerBonePure(UNode: AnimNodeReference,LayeredBoneBlend?: LayeredBoneBlendReference,Result?: boolean): {LayeredBoneBlend: LayeredBoneBlendReference, Result: boolean};
	static ConvertToLayeredBoneBlend(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: LayeredBoneBlendReference};
	static ConvertToBlendSpacePlayer(UNode: AnimNodeReference,Result?: EAnimNodeReferenceConversionResult): {Result: EAnimNodeReferenceConversionResult, $: BlendSpacePlayerReference};
	static ConvertToBlendSpacePlayerPure(UNode: AnimNodeReference,BlendSpacePlayer?: BlendSpacePlayerReference,Result?: boolean): {BlendSpacePlayer: BlendSpacePlayerReference, Result: boolean};
}

declare class AnimInstance extends UObject { 
	CurrentSkeleton: Skeleton;
	RootMotionMode: ERootMotionMode;
	bUseMultiThreadedAnimationUpdate: boolean;
	bUsingCopyPoseFromMesh: boolean;
	bReceiveNotifiesFromLinkedInstances: boolean;
	bPropagateNotifiesToLinkedInstances: boolean;
	bUseMainInstanceMontageEvaluationData: boolean;
	bQueueMontageEvents: boolean;
	OnMontageBlendingOut: UnrealEngineMulticastDelegate<(Montage: AnimMontage, bInterrupted: boolean) => void>;
	OnMontageStarted: UnrealEngineMulticastDelegate<(Montage: AnimMontage) => void>;
	OnMontageEnded: UnrealEngineMulticastDelegate<(Montage: AnimMontage, bInterrupted: boolean) => void>;
	OnAllMontageInstancesEnded: UnrealEngineMulticastDelegate<() => void>;
	PostCompileValidationClassName: SoftClassPath;
	NotifyQueue: AnimNotifyQueue;
	ActiveAnimNotifyState: AnimNotifyEvent[];
	ActiveAnimNotifyEventReference: AnimNotifyEventReference[];
	static Load(ResourceName: string): AnimInstance;
	static Find(Outer: UObject, ResourceName: string): AnimInstance;
	static GetDefaultObject(): AnimInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimInstance;
	WasAnimNotifyTriggeredInStateMachine(MachineIndex: number,AnimNotifyType: UnrealEngineClass): boolean;
	WasAnimNotifyTriggeredInSourceState(MachineIndex: number,StateIndex: number,AnimNotifyType: UnrealEngineClass): boolean;
	WasAnimNotifyTriggeredInAnyState(AnimNotifyType: UnrealEngineClass): boolean;
	WasAnimNotifyStateActiveInStateMachine(MachineIndex: number,AnimNotifyStateType: UnrealEngineClass): boolean;
	WasAnimNotifyStateActiveInSourceState(MachineIndex: number,StateIndex: number,AnimNotifyStateType: UnrealEngineClass): boolean;
	WasAnimNotifyStateActiveInAnyState(AnimNotifyStateType: UnrealEngineClass): boolean;
	WasAnimNotifyNameTriggeredInStateMachine(MachineIndex: number,NotifyName: string): boolean;
	WasAnimNotifyNameTriggeredInSourceState(MachineIndex: number,StateIndex: number,NotifyName: string): boolean;
	WasAnimNotifyNameTriggeredInAnyState(NotifyName: string): boolean;
	UnlockAIResources(bUnlockMovement: boolean,UnlockAILogic: boolean): void;
	UnlinkAnimClassLayers(InClass: UnrealEngineClass): void;
	TryGetPawnOwner(): Pawn;
	StopSlotAnimation(InBlendOutTime: number,SlotNodeName: string): void;
	SnapshotPose(Snapshot?: PoseSnapshot): {Snapshot: PoseSnapshot};
	SetUseMainInstanceMontageEvaluationData(bSet: boolean): void;
	SetRootMotionMode(Value: ERootMotionMode): void;
	SetReceiveNotifiesFromLinkedInstances(bSet: boolean): void;
	SetPropagateNotifiesToLinkedInstances(bSet: boolean): void;
	SetMorphTarget(MorphTargetName: string,Value: number): void;
	SavePoseSnapshot(SnapshotName: string): void;
	ResetDynamics(InTeleportType: ETeleportType): void;
	RequestTransitionEvent(EventName: string,RequestTimeout: number,QueueMode: ETransitionRequestQueueMode,OverwriteMode: ETransitionRequestOverwriteMode): boolean;
	RequestSlotGroupInertialization(InSlotGroupName: string,Duration: number,BlendProfile: BlendProfile): void;
	RemovePoseSnapshot(SnapshotName: string): void;
	QueryTransitionEvent(MachineIndex: number,TransitionIndex: number,EventName: string): boolean;
	QueryAndMarkTransitionEvent(MachineIndex: number,TransitionIndex: number,EventName: string): boolean;
	PlaySlotAnimationAsDynamicMontage_WithBlendSettings(Asset: AnimSequenceBase,SlotNodeName: string,BlendInSettings: MontageBlendSettings,BlendOutSettings: MontageBlendSettings,InPlayRate: number,LoopCount: number,BlendOutTriggerTime: number,InTimeToStartMontageAt: number): AnimMontage;
	PlaySlotAnimationAsDynamicMontage_WithBlendArgs(Asset: AnimSequenceBase,SlotNodeName: string,BlendIn: AlphaBlendArgs,BlendOut: AlphaBlendArgs,InPlayRate: number,LoopCount: number,BlendOutTriggerTime: number,InTimeToStartMontageAt: number): AnimMontage;
	PlaySlotAnimationAsDynamicMontage(Asset: AnimSequenceBase,SlotNodeName: string,BlendInTime: number,BlendOutTime: number,InPlayRate: number,LoopCount: number,BlendOutTriggerTime: number,InTimeToStartMontageAt: number): AnimMontage;
	MontageSync_StopFollowing(MontageFollower: AnimMontage): void;
	MontageSync_Follow(MontageFollower: AnimMontage,OtherAnimInstance: AnimInstance,MontageLeader: AnimMontage): void;
	Montage_StopWithBlendSettings(BlendOutSettings: MontageBlendSettings,Montage: AnimMontage): void;
	Montage_StopWithBlendOut(BlendOut: AlphaBlendArgs,Montage: AnimMontage): void;
	Montage_StopGroupByName(InBlendOutTime: number,GroupName: string): void;
	Montage_Stop(InBlendOutTime: number,Montage: AnimMontage): void;
	Montage_SetPosition(Montage: AnimMontage,NewPosition: number): void;
	Montage_SetPlayRate(Montage: AnimMontage,NewPlayRate: number): void;
	Montage_SetNextSection(SectionNameToChange: string,NextSection: string,Montage: AnimMontage): void;
	Montage_Resume(Montage: AnimMontage): void;
	Montage_PlayWithBlendSettings(MontageToPlay: AnimMontage,BlendInSettings: MontageBlendSettings,InPlayRate: number,ReturnValueType: EMontagePlayReturnType,InTimeToStartMontageAt: number,bStopAllMontages: boolean): number;
	Montage_PlayWithBlendIn(MontageToPlay: AnimMontage,BlendIn: AlphaBlendArgs,InPlayRate: number,ReturnValueType: EMontagePlayReturnType,InTimeToStartMontageAt: number,bStopAllMontages: boolean): number;
	Montage_Play(MontageToPlay: AnimMontage,InPlayRate: number,ReturnValueType: EMontagePlayReturnType,InTimeToStartMontageAt: number,bStopAllMontages: boolean): number;
	Montage_Pause(Montage: AnimMontage): void;
	Montage_JumpToSectionsEnd(SectionName: string,Montage: AnimMontage): void;
	Montage_JumpToSection(SectionName: string,Montage: AnimMontage): void;
	Montage_IsPlaying(Montage: AnimMontage): boolean;
	Montage_IsActive(Montage: AnimMontage): boolean;
	Montage_GetPosition(Montage: AnimMontage): number;
	Montage_GetPlayRate(Montage: AnimMontage): number;
	Montage_GetIsStopped(Montage: AnimMontage): boolean;
	Montage_GetCurrentSection(Montage: AnimMontage): string;
	Montage_GetBlendTime(Montage: AnimMontage): number;
	LockAIResources(bLockMovement: boolean,LockAILogic: boolean): void;
	LinkAnimGraphByTag(InTag: string,InClass: UnrealEngineClass): void;
	LinkAnimClassLayers(InClass: UnrealEngineClass): void;
	IsUsingMainInstanceMontageEvaluationData(): boolean;
	IsSyncGroupBetweenMarkers(InSyncGroupName: string,PreviousMarker: string,NextMarker: string,bRespectMarkerOrder: boolean): boolean;
	IsPlayingSlotAnimation(Asset: AnimSequenceBase,SlotNodeName: string): boolean;
	IsAnyMontagePlaying(): boolean;
	HasMarkerBeenHitThisFrame(SyncGroup: string,MarkerName: string): boolean;
	GetTimeToClosestMarker(SyncGroup: string,MarkerName: string,OutMarkerTime?: number): {OutMarkerTime: number, $: boolean};
	GetSyncGroupPosition(InSyncGroupName: string): MarkerSyncAnimPosition;
	GetRelevantAnimTimeRemainingFraction(MachineIndex: number,StateIndex: number): number;
	GetRelevantAnimTimeRemaining(MachineIndex: number,StateIndex: number): number;
	GetRelevantAnimTimeFraction(MachineIndex: number,StateIndex: number): number;
	GetRelevantAnimTime(MachineIndex: number,StateIndex: number): number;
	GetRelevantAnimLength(MachineIndex: number,StateIndex: number): number;
	GetReceiveNotifiesFromLinkedInstances(): boolean;
	GetPropagateNotifiesToLinkedInstances(): boolean;
	GetOwningComponent(): SkeletalMeshComponent;
	GetOwningActor(): Actor;
	GetLinkedAnimLayerInstancesByGroup(InGroup: string,OutLinkedInstances?: AnimInstance[]): {OutLinkedInstances: AnimInstance[]};
	GetLinkedAnimLayerInstanceByGroupAndClass(InGroup: string,InClass: UnrealEngineClass): AnimInstance;
	GetLinkedAnimLayerInstanceByGroup(InGroup: string): AnimInstance;
	GetLinkedAnimLayerInstanceByClass(InClass: UnrealEngineClass): AnimInstance;
	GetLinkedAnimGraphInstancesByTag(InTag: string,OutLinkedInstances?: AnimInstance[]): {OutLinkedInstances: AnimInstance[]};
	GetLinkedAnimGraphInstanceByTag(InTag: string): AnimInstance;
	GetInstanceTransitionTimeElapsedFraction(MachineIndex: number,TransitionIndex: number): number;
	GetInstanceTransitionTimeElapsed(MachineIndex: number,TransitionIndex: number): number;
	GetInstanceTransitionCrossfadeDuration(MachineIndex: number,TransitionIndex: number): number;
	GetInstanceStateWeight(MachineIndex: number,StateIndex: number): number;
	GetInstanceMachineWeight(MachineIndex: number): number;
	GetInstanceCurrentStateElapsedTime(MachineIndex: number): number;
	GetInstanceAssetPlayerTimeFromEndFraction(AssetPlayerIndex: number): number;
	GetInstanceAssetPlayerTimeFromEnd(AssetPlayerIndex: number): number;
	GetInstanceAssetPlayerTimeFraction(AssetPlayerIndex: number): number;
	GetInstanceAssetPlayerTime(AssetPlayerIndex: number): number;
	GetInstanceAssetPlayerLength(AssetPlayerIndex: number): number;
	GetDeltaSeconds(): number;
	GetCurveValueWithDefault(CurveName: string,DefaultValue: number,OutValue?: number): {OutValue: number, $: boolean};
	GetCurveValue(CurveName: string): number;
	GetCurrentStateName(MachineIndex: number): string;
	GetCurrentActiveMontage(): AnimMontage;
	GetAllCurveNames(OutNames?: string[]): {OutNames: string[]};
	GetActiveCurveNames(CurveType: EAnimCurveType,OutNames?: string[]): {OutNames: string[]};
	ClearTransitionEvents(EventName: string): void;
	ClearMorphTargets(): void;
	ClearAllTransitionEvents(): void;
	CalculateDirection(Velocity: Vector,BaseRotation: Rotator): number;
	BlueprintUpdateAnimation(DeltaTimeX: number): void;
	BlueprintThreadSafeUpdateAnimation(DeltaTime: number): void;
	BlueprintPostEvaluateAnimation(): void;
	BlueprintLinkedAnimationLayersInitialized(): void;
	BlueprintInitializeAnimation(): void;
	BlueprintBeginPlay(): void;
	static C(Other: UObject | any): AnimInstance;
	StateMachine_GetGlobalWeight(CachedAnimStateData: CachedAnimStateData): number;
	StateMachine_GetLocalWeight(CachedAnimStateData: CachedAnimStateData): number;
	StateMachine_IsStateRelevant(CachedAnimStateData: CachedAnimStateData): boolean;
	GetAnimNodeReference(Index: number): AnimNodeReference;
	LockAIResourcesWithAnimation(bLockMovement: boolean,LockAILogic: boolean): void;
	UnlockAIResourcesWithAnimation(bUnlockMovement: boolean,UnlockAILogic: boolean): void;
	static StateMachine_GetGlobalWeight(InAnimInstance: AnimInstance,CachedAnimStateData: CachedAnimStateData): number;
	static StateMachine_GetLocalWeight(InAnimInstance: AnimInstance,CachedAnimStateData: CachedAnimStateData): number;
	static StateMachine_IsStateRelevant(InAnimInstance: AnimInstance,CachedAnimStateData: CachedAnimStateData): boolean;
	static GetAnimNodeReference(Instance: AnimInstance,Index: number): AnimNodeReference;
	static LockAIResourcesWithAnimation(AnimInstance: AnimInstance,bLockMovement: boolean,LockAILogic: boolean): void;
	static UnlockAIResourcesWithAnimation(AnimInstance: AnimInstance,bUnlockMovement: boolean,UnlockAILogic: boolean): void;
}

declare class AnimNotifyEventReference { 
	MirrorTable: MirrorDataTable;
	NotifySource: UObject;
	clone() : AnimNotifyEventReference;
	static C(Other: UObject | any): AnimNotifyEventReference;
	IsTriggeredByState(AnimInstance: AnimInstance,StateName: string): boolean;
	IsTriggeredByStateInStateMachine(AnimInstance: AnimInstance,StateMachineName: string,StateName: string): boolean;
	IsTriggeredByStateMachine(AnimInstance: AnimInstance,StateMachineName: string): boolean;
	GetMirrorDataTable(): MirrorDataTable;
	IsTriggeredByMirroredAnimation(): boolean;
	NotifyStateReachedEnd(): boolean;
	static IsTriggeredByState(EventReference: AnimNotifyEventReference,AnimInstance: AnimInstance,StateName: string): boolean;
	static IsTriggeredByStateInStateMachine(EventReference: AnimNotifyEventReference,AnimInstance: AnimInstance,StateMachineName: string,StateName: string): boolean;
	static IsTriggeredByStateMachine(EventReference: AnimNotifyEventReference,AnimInstance: AnimInstance,StateMachineName: string): boolean;
	static GetMirrorDataTable(EventReference: AnimNotifyEventReference): MirrorDataTable;
	static IsTriggeredByMirroredAnimation(EventReference: AnimNotifyEventReference): boolean;
	static NotifyStateReachedEnd(EventReference: AnimNotifyEventReference): boolean;
}

declare class AnimNotify extends UObject { 
	NotifyColor: Color;
	bShouldFireInEditor: boolean;
	static Load(ResourceName: string): AnimNotify;
	static Find(Outer: UObject, ResourceName: string): AnimNotify;
	static GetDefaultObject(): AnimNotify;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimNotify;
	Received_Notify(MeshComp: SkeletalMeshComponent,Animation: AnimSequenceBase,EventReference: AnimNotifyEventReference): boolean;
	GetNotifyName(): string;
	GetDefaultTriggerWeightThreshold(): number;
	static C(Other: UObject | any): AnimNotify;
}

declare type EMontageNotifyTickType = 'Queued' | 'BranchingPoint' | 'EMontageNotifyTickType_MAX';
declare var EMontageNotifyTickType : { Queued:'Queued',BranchingPoint:'BranchingPoint',EMontageNotifyTickType_MAX:'EMontageNotifyTickType_MAX', };
declare type ENotifyFilterType = 'NoFiltering' | 'LOD' | 'ENotifyFilterType_MAX';
declare var ENotifyFilterType : { NoFiltering:'NoFiltering',LOD:'LOD',ENotifyFilterType_MAX:'ENotifyFilterType_MAX', };
declare class AnimNotifyEvent extends AnimLinkableElement { 
	DisplayTime: number;
	TriggerTimeOffset: number;
	EndTriggerTimeOffset: number;
	TriggerWeightThreshold: number;
	NotifyName: string;
	Notify: AnimNotify;
	NotifyStateClass: AnimNotifyState;
	Duration: number;
	EndLink: AnimLinkableElement;
	bConvertedFromBranchingPoint: boolean;
	MontageTickType: EMontageNotifyTickType;
	NotifyTriggerChance: number;
	NotifyFilterType: ENotifyFilterType;
	NotifyFilterLOD: number;
	bTriggerOnDedicatedServer: boolean;
	bTriggerOnFollower: boolean;
	NotifyColor: Color;
	Guid: Guid;
	TrackIndex: number;
	clone() : AnimNotifyEvent;
	static C(Other: UObject | any): AnimNotifyEvent;
	GetAnimNotifyEventDuration(): number;
	GetAnimNotifyEventTriggerTime(): number;
	static GetAnimNotifyEventDuration(NotifyEvent: AnimNotifyEvent): number;
	static GetAnimNotifyEventTriggerTime(NotifyEvent: AnimNotifyEvent): number;
}

declare class FloatCurve extends AnimCurveBase { 
	FloatCurve: RichCurve;
	clone() : FloatCurve;
	static C(Other: UObject | any): FloatCurve;
}

declare class VectorCurve extends AnimCurveBase { 
	FloatCurves: RichCurve;
	clone() : VectorCurve;
	static C(Other: UObject | any): VectorCurve;
}

declare class TransformCurve extends AnimCurveBase { 
	TranslationCurve: VectorCurve;
	RotationCurve: VectorCurve;
	ScaleCurve: VectorCurve;
	clone() : TransformCurve;
	static C(Other: UObject | any): TransformCurve;
}

declare class RawCurveTracks { 
	FloatCurves: FloatCurve[];
	VectorCurves: VectorCurve[];
	TransformCurves: TransformCurve[];
	clone() : RawCurveTracks;
	static C(Other: UObject | any): RawCurveTracks;
}

declare class AnimNotifyTrack { 
	TrackName: string;
	TrackColor: LinearColor;
	clone() : AnimNotifyTrack;
	static C(Other: UObject | any): AnimNotifyTrack;
}

declare type EAnimDataModelNotifyType = 'BracketOpened' | 'BracketClosed' | 'TrackAdded' | 'TrackChanged' | 'TrackRemoved' | 'SequenceLengthChanged' | 'FrameRateChanged' | 'CurveAdded' | 'CurveChanged' | 'CurveRemoved' | 'CurveFlagsChanged' | 'CurveRenamed' | 'CurveScaled' | 'CurveColorChanged' | 'AttributeAdded' | 'AttributeRemoved' | 'AttributeChanged' | 'Populated' | 'Reset' | 'Invalid' | 'EAnimDataModelNotifyType_MAX';
declare var EAnimDataModelNotifyType : { BracketOpened:'BracketOpened',BracketClosed:'BracketClosed',TrackAdded:'TrackAdded',TrackChanged:'TrackChanged',TrackRemoved:'TrackRemoved',SequenceLengthChanged:'SequenceLengthChanged',FrameRateChanged:'FrameRateChanged',CurveAdded:'CurveAdded',CurveChanged:'CurveChanged',CurveRemoved:'CurveRemoved',CurveFlagsChanged:'CurveFlagsChanged',CurveRenamed:'CurveRenamed',CurveScaled:'CurveScaled',CurveColorChanged:'CurveColorChanged',AttributeAdded:'AttributeAdded',AttributeRemoved:'AttributeRemoved',AttributeChanged:'AttributeChanged',Populated:'Populated',Reset:'Reset',Invalid:'Invalid',EAnimDataModelNotifyType_MAX:'EAnimDataModelNotifyType_MAX', };
declare class EmptyPayload { 
	clone() : EmptyPayload;
	static C(Other: UObject | any): EmptyPayload;
}

declare class AnimDataModelNotifPayload { 
	clone() : AnimDataModelNotifPayload;
	static C(Other: UObject | any): AnimDataModelNotifPayload;
	CopyPayload(ExpectedStruct: ScriptStruct,OutPayload?: EmptyPayload): {OutPayload: EmptyPayload};
	GetPayload(): EmptyPayload;
	static CopyPayload(Payload: AnimDataModelNotifPayload,ExpectedStruct: ScriptStruct,OutPayload?: EmptyPayload): {OutPayload: EmptyPayload};
	static GetPayload(Payload: AnimDataModelNotifPayload): EmptyPayload;
}

declare class Quat4f { 
	X: number;
	Y: number;
	Z: number;
	W: number;
	clone() : Quat4f;
	static C(Other: UObject | any): Quat4f;
}

declare class RawAnimSequenceTrack { 
	PosKeys: Vector3f[];
	RotKeys: Quat4f[];
	ScaleKeys: Vector3f[];
	clone() : RawAnimSequenceTrack;
	static C(Other: UObject | any): RawAnimSequenceTrack;
	GetPositionalKeys(): Vector[];
	GetRotationalKeys(): Quat[];
	GetScaleKeys(): Vector[];
	static GetPositionalKeys(Track: RawAnimSequenceTrack): Vector[];
	static GetRotationalKeys(Track: RawAnimSequenceTrack): Quat[];
	static GetScaleKeys(Track: RawAnimSequenceTrack): Vector[];
}

declare class BoneAnimationTrack { 
	InternalTrackData: RawAnimSequenceTrack;
	BoneTreeIndex: number;
	Name: string;
	clone() : BoneAnimationTrack;
	static C(Other: UObject | any): BoneAnimationTrack;
}

declare class FrameRate { 
	Numerator: number;
	Denominator: number;
	clone() : FrameRate;
	static C(Other: UObject | any): FrameRate;
	BreakFrameRate(Numerator?: number,Denominator?: number): {Numerator: number, Denominator: number};
	Conv_FrameRateToSeconds(): number;
	IsValid_Framerate(): boolean;
	IsValid_MultipleOf(OtherFramerate: FrameRate): boolean;
	static BreakFrameRate(InFrameRate: FrameRate,Numerator?: number,Denominator?: number): {Numerator: number, Denominator: number};
	static Conv_FrameRateToSeconds(InFrameRate: FrameRate): number;
	static IsValid_Framerate(InFrameRate: FrameRate): boolean;
	static IsValid_MultipleOf(InFrameRate: FrameRate,OtherFramerate: FrameRate): boolean;
	static MakeFrameRate(Numerator: number,Denominator: number): FrameRate;
	static GetTimecodeFrameRate(): FrameRate;
}

declare class AnimationCurveData { 
	FloatCurves: FloatCurve[];
	TransformCurves: TransformCurve[];
	clone() : AnimationCurveData;
	static C(Other: UObject | any): AnimationCurveData;
}

declare class AnimationAttributeIdentifier { 
	Name: string;
	BoneName: string;
	BoneIndex: number;
	ScriptStruct: ScriptStruct;
	ScriptStructPath: SoftObjectPath;
	clone() : AnimationAttributeIdentifier;
	static C(Other: UObject | any): AnimationAttributeIdentifier;
	IsValid(): {Identifier: AnimationAttributeIdentifier, $: boolean};
	static IsValid(Identifier?: AnimationAttributeIdentifier): {Identifier: AnimationAttributeIdentifier, $: boolean};
}

declare class AttributeKey { 
	Time: number;
	clone() : AttributeKey;
	static C(Other: UObject | any): AttributeKey;
}

declare class AttributeCurve extends IndexedCurve { 
	Keys: AttributeKey[];
	ScriptStructPath: SoftObjectPath;
	ScriptStruct: ScriptStruct;
	bShouldInterpolate: boolean;
	clone() : AttributeCurve;
	static C(Other: UObject | any): AttributeCurve;
}

declare class AnimatedBoneAttribute { 
	Identifier: AnimationAttributeIdentifier;
	Curve: AttributeCurve;
	clone() : AnimatedBoneAttribute;
	static C(Other: UObject | any): AnimatedBoneAttribute;
}

declare class AnimDataModel extends UObject { 
	BracketCounter: number;
	ModifiedEventDynamic: UnrealEngineMulticastDelegate<(NotifType: EAnimDataModelNotifyType, Model: AnimDataModel, Payload: AnimDataModelNotifPayload) => void>;
	BoneAnimationTracks: BoneAnimationTrack[];
	PlayLength: number;
	FrameRate: FrameRate;
	NumberOfFrames: number;
	NumberOfKeys: number;
	CurveData: AnimationCurveData;
	AnimatedBoneAttributes: AnimatedBoneAttribute[];
	static Load(ResourceName: string): AnimDataModel;
	static Find(Outer: UObject, ResourceName: string): AnimDataModel;
	static GetDefaultObject(): AnimDataModel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimDataModel;
	IsValidBoneTrackIndex(TrackIndex: number): boolean;
	GetPlayLength(): number;
	GetNumBoneTracks(): number;
	GetNumberOfTransformCurves(): number;
	GetNumberOfKeys(): number;
	GetNumberOfFrames(): number;
	GetNumberOfFloatCurves(): number;
	GetFrameRate(): FrameRate;
	GetBoneTrackNames(OutNames?: string[]): {OutNames: string[]};
	GetBoneTrackIndexByName(TrackName: string): number;
	GetBoneTrackIndex(Track: BoneAnimationTrack): number;
	GetBoneTrackByName(TrackName: string): BoneAnimationTrack;
	GetBoneTrackByIndex(TrackIndex: number): BoneAnimationTrack;
	GetBoneAnimationTracks(): BoneAnimationTrack[];
	GetAnimationSequence(): AnimSequence;
	static C(Other: UObject | any): AnimDataModel;
	GetAttributeKey(AttributeIdentifier: AnimationAttributeIdentifier,Time: number,Value?: number): {Value: number, $: boolean};
	GetAttributeKeys(AttributeIdentifier: AnimationAttributeIdentifier,OutTimes?: number[],Values?: number[]): {OutTimes: number[], Values: number[], $: boolean};
	static GetAttributeKey(AnimationDataModel: AnimDataModel,AttributeIdentifier: AnimationAttributeIdentifier,Time: number,Value?: number): {Value: number, $: boolean};
	static GetAttributeKeys(AnimationDataModel: AnimDataModel,AttributeIdentifier: AnimationAttributeIdentifier,OutTimes?: number[],Values?: number[]): {OutTimes: number[], Values: number[], $: boolean};
}

declare class Interface extends UObject { 
	static Load(ResourceName: string): Interface;
	static Find(Outer: UObject, ResourceName: string): Interface;
	static GetDefaultObject(): Interface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Interface;
	static C(Other: UObject | any): Interface;
}

declare type EAnimAssetCurveFlags = 'AACF_NONE' | 'AACF_DriveMorphTarget_DEPRECATED' | 'AACF_DriveAttribute_DEPRECATED' | 'AACF_Editable' | 'AACF_DriveMaterial_DEPRECATED' | 'AACF_Metadata' | 'AACF_DriveTrack' | 'AACF_Disabled' | 'AACF_MAX';
declare var EAnimAssetCurveFlags : { AACF_NONE:'AACF_NONE',AACF_DriveMorphTarget_DEPRECATED:'AACF_DriveMorphTarget_DEPRECATED',AACF_DriveAttribute_DEPRECATED:'AACF_DriveAttribute_DEPRECATED',AACF_Editable:'AACF_Editable',AACF_DriveMaterial_DEPRECATED:'AACF_DriveMaterial_DEPRECATED',AACF_Metadata:'AACF_Metadata',AACF_DriveTrack:'AACF_DriveTrack',AACF_Disabled:'AACF_Disabled',AACF_MAX:'AACF_MAX', };
declare class AnimationDataController extends Interface { 
	static Load(ResourceName: string): AnimationDataController;
	static Find(Outer: UObject, ResourceName: string): AnimationDataController;
	static GetDefaultObject(): AnimationDataController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationDataController;
	UpdateCurveNamesFromSkeleton(Skeleton: Skeleton,SupportedCurveType: ERawCurveTrackTypes,bShouldTransact: boolean): void;
	SetTransformCurveKeys(CurveId: AnimationCurveIdentifier,TransformValues: Transform[],TimeKeys: number[],bShouldTransact: boolean): boolean;
	SetTransformCurveKey(CurveId: AnimationCurveIdentifier,Time: number,Value: Transform,bShouldTransact: boolean): boolean;
	SetPlayLength(Length: number,bShouldTransact: boolean): void;
	SetModel(InModel: AnimDataModel): void;
	SetFrameRate(FrameRate: FrameRate,bShouldTransact: boolean): void;
	SetCurveKeys(CurveId: AnimationCurveIdentifier,CurveKeys: RichCurveKey[],bShouldTransact: boolean): boolean;
	SetCurveKey(CurveId: AnimationCurveIdentifier,Key: RichCurveKey,bShouldTransact: boolean): boolean;
	SetCurveFlags(CurveId: AnimationCurveIdentifier,Flags: number,bShouldTransact: boolean): boolean;
	SetCurveFlag(CurveId: AnimationCurveIdentifier,Flag: EAnimAssetCurveFlags,bState: boolean,bShouldTransact: boolean): boolean;
	SetCurveColor(CurveId: AnimationCurveIdentifier,Color: LinearColor,bShouldTransact: boolean): boolean;
	SetBoneTrackKeys(BoneName: string,PositionalKeys: Vector[],RotationalKeys: Quat[],ScalingKeys: Vector[],bShouldTransact: boolean): boolean;
	ScaleCurve(CurveId: AnimationCurveIdentifier,Origin: number,Factor: number,bShouldTransact: boolean): boolean;
	ResizePlayLength(NewLength: number,T0: number,T1: number,bShouldTransact: boolean): void;
	Resize(Length: number,T0: number,T1: number,bShouldTransact: boolean): void;
	RenameCurve(CurveToRenameId: AnimationCurveIdentifier,NewCurveId: AnimationCurveIdentifier,bShouldTransact: boolean): boolean;
	RemoveTransformCurveKey(CurveId: AnimationCurveIdentifier,Time: number,bShouldTransact: boolean): boolean;
	RemoveCurveKey(CurveId: AnimationCurveIdentifier,Time: number,bShouldTransact: boolean): boolean;
	RemoveCurve(CurveId: AnimationCurveIdentifier,bShouldTransact: boolean): boolean;
	RemoveBoneTrack(BoneName: string,bShouldTransact: boolean): boolean;
	RemoveAttributeKey(AttributeIdentifier: AnimationAttributeIdentifier,Time: number,bShouldTransact: boolean): boolean;
	RemoveAttribute(AttributeIdentifier: AnimationAttributeIdentifier,bShouldTransact: boolean): boolean;
	RemoveAllCurvesOfType(SupportedCurveType: ERawCurveTrackTypes,bShouldTransact: boolean): void;
	RemoveAllBoneTracks(bShouldTransact: boolean): void;
	RemoveAllAttributesForBone(BoneName: string,bShouldTransact: boolean): number;
	RemoveAllAttributes(bShouldTransact: boolean): number;
	OpenBracket(InTitle: string,bShouldTransact: boolean): void;
	InsertBoneTrack(BoneName: string,DesiredIndex: number,bShouldTransact: boolean): number;
	GetModel(): AnimDataModel;
	FindOrAddCurveNamesOnSkeleton(Skeleton: Skeleton,SupportedCurveType: ERawCurveTrackTypes,bShouldTransact: boolean): void;
	DuplicateCurve(CopyCurveId: AnimationCurveIdentifier,NewCurveId: AnimationCurveIdentifier,bShouldTransact: boolean): boolean;
	DuplicateAttribute(AttributeIdentifier: AnimationAttributeIdentifier,NewAttributeIdentifier: AnimationAttributeIdentifier,bShouldTransact: boolean): boolean;
	CloseBracket(bShouldTransact: boolean): void;
	AddCurve(CurveId: AnimationCurveIdentifier,CurveFlags: number,bShouldTransact: boolean): boolean;
	AddBoneTrack(BoneName: string,bShouldTransact: boolean): number;
	AddAttribute(AttributeIdentifier: AnimationAttributeIdentifier,bShouldTransact: boolean): boolean;
	static C(Other: UObject | any): AnimationDataController;
}

declare type EAnimDataEvalType = 'Source' | 'Raw' | 'Compressed' | 'EAnimDataEvalType_MAX';
declare var EAnimDataEvalType : { Source:'Source',Raw:'Raw',Compressed:'Compressed',EAnimDataEvalType_MAX:'EAnimDataEvalType_MAX', };
declare class AnimPoseEvaluationOptions { 
	EvaluationType: EAnimDataEvalType;
	bShouldRetarget: boolean;
	bExtractRootMotion: boolean;
	OptionalSkeletalMesh: SkeletalMesh;
	bRetrieveAdditiveAsFullPose: boolean;
	bEvaluateCurves: boolean;
	clone() : AnimPoseEvaluationOptions;
	static C(Other: UObject | any): AnimPoseEvaluationOptions;
}

declare class FrameNumber { 
	Value: number;
	clone() : FrameNumber;
	static C(Other: UObject | any): FrameNumber;
	MakeQualifiedFrameTime(FrameRate: FrameRate,SubFrame: number): QualifiedFrameTime;
	Add_FrameNumberFrameNumber(B: FrameNumber): FrameNumber;
	Add_FrameNumberInteger(B: number): FrameNumber;
	Conv_FrameNumberToInteger(): number;
	Divide_FrameNumberInteger(B: number): FrameNumber;
	Multiply_FrameNumberInteger(B: number): FrameNumber;
	Subtract_FrameNumberFrameNumber(B: FrameNumber): FrameNumber;
	Subtract_FrameNumberInteger(B: number): FrameNumber;
	static MakeQualifiedFrameTime(Frame: FrameNumber,FrameRate: FrameRate,SubFrame: number): QualifiedFrameTime;
	static Add_FrameNumberFrameNumber(A: FrameNumber,B: FrameNumber): FrameNumber;
	static Add_FrameNumberInteger(A: FrameNumber,B: number): FrameNumber;
	static Conv_FrameNumberToInteger(InFrameNumber: FrameNumber): number;
	static Divide_FrameNumberInteger(A: FrameNumber,B: number): FrameNumber;
	static Multiply_FrameNumberInteger(A: FrameNumber,B: number): FrameNumber;
	static Subtract_FrameNumberFrameNumber(A: FrameNumber,B: FrameNumber): FrameNumber;
	static Subtract_FrameNumberInteger(A: FrameNumber,B: number): FrameNumber;
}

declare class FrameTime { 
	FrameNumber: FrameNumber;
	SubFrame: number;
	clone() : FrameTime;
	static C(Other: UObject | any): FrameTime;
	SnapFrameTimeToRate(SourceRate: FrameRate,SnapToRate: FrameRate): FrameTime;
	TransformTime(SourceRate: FrameRate,DestinationRate: FrameRate): FrameTime;
	static SnapFrameTimeToRate(SourceTime: FrameTime,SourceRate: FrameRate,SnapToRate: FrameRate): FrameTime;
	static TransformTime(SourceTime: FrameTime,SourceRate: FrameRate,DestinationRate: FrameRate): FrameTime;
	static Multiply_SecondsFrameRate(TimeInSeconds: number,FrameRate: FrameRate): FrameTime;
}

declare class QualifiedFrameTime { 
	Time: FrameTime;
	Rate: FrameRate;
	clone() : QualifiedFrameTime;
	static C(Other: UObject | any): QualifiedFrameTime;
	BreakQualifiedFrameTime(Frame?: FrameNumber,FrameRate?: FrameRate,SubFrame?: number): {Frame: FrameNumber, FrameRate: FrameRate, SubFrame: number};
	Conv_QualifiedFrameTimeToSeconds(): number;
	static BreakQualifiedFrameTime(InFrameTime: QualifiedFrameTime,Frame?: FrameNumber,FrameRate?: FrameRate,SubFrame?: number): {Frame: FrameNumber, FrameRate: FrameRate, SubFrame: number};
	static Conv_QualifiedFrameTimeToSeconds(InFrameTime: QualifiedFrameTime): number;
}

declare class AnimSequenceBase extends AnimationAsset { 
	Notifies: AnimNotifyEvent[];
	SequenceLength: number;
	RateScale: number;
	bLoop: boolean;
	RawCurveData: RawCurveTracks;
	AnimNotifyTracks: AnimNotifyTrack[];
	DataModel: AnimDataModel;
	Controller: AnimationDataController;
	static Load(ResourceName: string): AnimSequenceBase;
	static Find(Outer: UObject, ResourceName: string): AnimSequenceBase;
	static GetDefaultObject(): AnimSequenceBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimSequenceBase;
	static C(Other: UObject | any): AnimSequenceBase;
	ReplaceAnimNotifyClass(NotifyName: string,NewNotifyName: string,NewNotifyClass: UObject): number;
	AddTransformAttribute(AttributeName: string,BoneName: string,Keys: number[],Values: Transform[]): boolean;
	GetAnimPoseAtFrame(FrameIndex: number,EvaluationOptions: AnimPoseEvaluationOptions,Pose?: AnimPose): {Pose: AnimPose};
	GetAnimPoseAtTime(Time: number,EvaluationOptions: AnimPoseEvaluationOptions,Pose?: AnimPose): {Pose: AnimPose};
	AddAnimationNotifyEvent(NotifyTrackName: string,StartTime: number,NotifyClass: UnrealEngineClass): AnimNotify;
	AddAnimationNotifyEventObject(StartTime: number,Notify: AnimNotify,NotifyTrackName: string): void;
	AddAnimationNotifyStateEvent(NotifyTrackName: string,StartTime: number,Duration: number,NotifyStateClass: UnrealEngineClass): AnimNotifyState;
	AddAnimationNotifyStateEventObject(StartTime: number,Duration: number,NotifyState: AnimNotifyState,NotifyTrackName: string): void;
	AddAnimationNotifyTrack(NotifyTrackName: string,TrackColor: LinearColor): void;
	CopyAnimNotifiesFromSequence(DestinationAnimationSequenceBase: AnimSequenceBase,bDeleteExistingNotifies: boolean): void;
	EvaluateRootBoneTimecodeAttributesAtTime(EvalTime: number,OutQualifiedFrameTime?: QualifiedFrameTime): {OutQualifiedFrameTime: QualifiedFrameTime, $: boolean};
	EvaluateRootBoneTimecodeSubframeAttributeAtTime(EvalTime: number,OutSubframe?: number): {OutSubframe: number, $: boolean};
	FindBonePathToRoot(BoneName: string,BonePath?: string[]): {BonePath: string[]};
	GetAnimationNotifyEventNames(EventNames?: string[]): {EventNames: string[]};
	GetAnimationNotifyEvents(NotifyEvents?: AnimNotifyEvent[]): {NotifyEvents: AnimNotifyEvent[]};
	GetAnimationNotifyEventsForTrack(NotifyTrackName: string,Events?: AnimNotifyEvent[]): {Events: AnimNotifyEvent[]};
	GetAnimationNotifyTrackNames(TrackNames?: string[]): {TrackNames: string[]};
	GetAnimationTrackNames(TrackNames?: string[]): {TrackNames: string[]};
	GetBonePoseForFrame(BoneName: string,Frame: number,bExtractRootMotion: boolean,Pose?: Transform): {Pose: Transform};
	GetBonePoseForTime(BoneName: string,Time: number,bExtractRootMotion: boolean,Pose?: Transform): {Pose: Transform};
	GetBonePosesForFrame(BoneNames: string[],Frame: number,bExtractRootMotion: boolean,Poses?: Transform[],PreviewMesh?: SkeletalMesh): {Poses: Transform[]};
	GetBonePosesForTime(BoneNames: string[],Time: number,bExtractRootMotion: boolean,Poses?: Transform[],PreviewMesh?: SkeletalMesh): {Poses: Transform[]};
	GetFrameAtTime(Time: number,Frame?: number): {Frame: number};
	GetNumFrames(NumFrames?: number): {NumFrames: number};
	GetNumKeys(NumKeys?: number): {NumKeys: number};
	GetRateScale(RateScale?: number): {RateScale: number};
	GetRawTrackData(TrackName: string,PositionKeys?: Vector[],RotationKeys?: Quat[],ScalingKeys?: Vector[]): {PositionKeys: Vector[], RotationKeys: Quat[], ScalingKeys: Vector[]};
	GetRawTrackPositionData(TrackName: string,PositionData?: Vector[]): {PositionData: Vector[]};
	GetRawTrackRotationData(TrackName: string,RotationData?: Quat[]): {RotationData: Quat[]};
	GetRawTrackScaleData(TrackName: string,ScaleData?: Vector[]): {ScaleData: Vector[]};
	GetSequenceLength(Length?: number): {Length: number};
	GetTimeAtFrame(Frame: number,Time?: number): {Time: number};
	IsValidAnimNotifyTrackName(NotifyTrackName: string): boolean;
	IsValidRawAnimationTrackName(TrackName: string): boolean;
	IsValidTime(Time: number,IsValid?: boolean): {IsValid: boolean};
	RemoveAllAnimationNotifyTracks(): void;
	RemoveAnimationNotifyEventsByName(NotifyName: string): number;
	RemoveAnimationNotifyEventsByTrack(NotifyTrackName: string): number;
	RemoveAnimationNotifyTrack(NotifyTrackName: string): void;
	ReplaceAnimNotifies(OldNotifyClass: UnrealEngineClass,NewNotifyClass: UnrealEngineClass,OnNotifyReplaced: UnrealEngineDelegate<(OldNotify: AnimNotify, NewNotify: AnimNotify) => void>): void;
	ReplaceAnimNotifyStates(OldNotifyClass: UnrealEngineClass,NewNotifyClass: UnrealEngineClass,OnNotifyStateReplaced: UnrealEngineDelegate<(OldNotifyState: AnimNotifyState, NewNotifyState: AnimNotifyState) => void>): void;
	SetRateScale(RateScale: number): void;
	static ReplaceAnimNotifyClass(Sequence: AnimSequenceBase,NotifyName: string,NewNotifyName: string,NewNotifyClass: UObject): number;
	static AddTransformAttribute(AnimSequenceBase: AnimSequenceBase,AttributeName: string,BoneName: string,Keys: number[],Values: Transform[]): boolean;
	static GetAnimPoseAtFrame(AnimationSequenceBase: AnimSequenceBase,FrameIndex: number,EvaluationOptions: AnimPoseEvaluationOptions,Pose?: AnimPose): {Pose: AnimPose};
	static GetAnimPoseAtTime(AnimationSequenceBase: AnimSequenceBase,Time: number,EvaluationOptions: AnimPoseEvaluationOptions,Pose?: AnimPose): {Pose: AnimPose};
	static AddAnimationNotifyEvent(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string,StartTime: number,NotifyClass: UnrealEngineClass): AnimNotify;
	static AddAnimationNotifyEventObject(AnimationSequenceBase: AnimSequenceBase,StartTime: number,Notify: AnimNotify,NotifyTrackName: string): void;
	static AddAnimationNotifyStateEvent(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string,StartTime: number,Duration: number,NotifyStateClass: UnrealEngineClass): AnimNotifyState;
	static AddAnimationNotifyStateEventObject(AnimationSequenceBase: AnimSequenceBase,StartTime: number,Duration: number,NotifyState: AnimNotifyState,NotifyTrackName: string): void;
	static AddAnimationNotifyTrack(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string,TrackColor: LinearColor): void;
	static CopyAnimNotifiesFromSequence(SourceAnimationSequenceBase: AnimSequenceBase,DestinationAnimationSequenceBase: AnimSequenceBase,bDeleteExistingNotifies: boolean): void;
	static EvaluateRootBoneTimecodeAttributesAtTime(AnimationSequenceBase: AnimSequenceBase,EvalTime: number,OutQualifiedFrameTime?: QualifiedFrameTime): {OutQualifiedFrameTime: QualifiedFrameTime, $: boolean};
	static EvaluateRootBoneTimecodeSubframeAttributeAtTime(AnimationSequenceBase: AnimSequenceBase,EvalTime: number,OutSubframe?: number): {OutSubframe: number, $: boolean};
	static FindBonePathToRoot(AnimationSequenceBase: AnimSequenceBase,BoneName: string,BonePath?: string[]): {BonePath: string[]};
	static GetAnimationNotifyEventNames(AnimationSequenceBase: AnimSequenceBase,EventNames?: string[]): {EventNames: string[]};
	static GetAnimationNotifyEvents(AnimationSequenceBase: AnimSequenceBase,NotifyEvents?: AnimNotifyEvent[]): {NotifyEvents: AnimNotifyEvent[]};
	static GetAnimationNotifyEventsForTrack(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string,Events?: AnimNotifyEvent[]): {Events: AnimNotifyEvent[]};
	static GetAnimationNotifyTrackNames(AnimationSequenceBase: AnimSequenceBase,TrackNames?: string[]): {TrackNames: string[]};
	static GetAnimationTrackNames(AnimationSequenceBase: AnimSequenceBase,TrackNames?: string[]): {TrackNames: string[]};
	static GetBonePoseForFrame(AnimationSequenceBase: AnimSequenceBase,BoneName: string,Frame: number,bExtractRootMotion: boolean,Pose?: Transform): {Pose: Transform};
	static GetBonePoseForTime(AnimationSequenceBase: AnimSequenceBase,BoneName: string,Time: number,bExtractRootMotion: boolean,Pose?: Transform): {Pose: Transform};
	static GetBonePosesForFrame(AnimationSequenceBase: AnimSequenceBase,BoneNames: string[],Frame: number,bExtractRootMotion: boolean,Poses?: Transform[],PreviewMesh?: SkeletalMesh): {Poses: Transform[]};
	static GetBonePosesForTime(AnimationSequenceBase: AnimSequenceBase,BoneNames: string[],Time: number,bExtractRootMotion: boolean,Poses?: Transform[],PreviewMesh?: SkeletalMesh): {Poses: Transform[]};
	static GetFrameAtTime(AnimationSequenceBase: AnimSequenceBase,Time: number,Frame?: number): {Frame: number};
	static GetNumFrames(AnimationSequenceBase: AnimSequenceBase,NumFrames?: number): {NumFrames: number};
	static GetNumKeys(AnimationSequenceBase: AnimSequenceBase,NumKeys?: number): {NumKeys: number};
	static GetRateScale(AnimationSequenceBase: AnimSequenceBase,RateScale?: number): {RateScale: number};
	static GetRawTrackData(AnimationSequenceBase: AnimSequenceBase,TrackName: string,PositionKeys?: Vector[],RotationKeys?: Quat[],ScalingKeys?: Vector[]): {PositionKeys: Vector[], RotationKeys: Quat[], ScalingKeys: Vector[]};
	static GetRawTrackPositionData(AnimationSequenceBase: AnimSequenceBase,TrackName: string,PositionData?: Vector[]): {PositionData: Vector[]};
	static GetRawTrackRotationData(AnimationSequenceBase: AnimSequenceBase,TrackName: string,RotationData?: Quat[]): {RotationData: Quat[]};
	static GetRawTrackScaleData(AnimationSequenceBase: AnimSequenceBase,TrackName: string,ScaleData?: Vector[]): {ScaleData: Vector[]};
	static GetSequenceLength(AnimationSequenceBase: AnimSequenceBase,Length?: number): {Length: number};
	static GetTimeAtFrame(AnimationSequenceBase: AnimSequenceBase,Frame: number,Time?: number): {Time: number};
	static IsValidAnimNotifyTrackName(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string): boolean;
	static IsValidRawAnimationTrackName(AnimationSequenceBase: AnimSequenceBase,TrackName: string): boolean;
	static IsValidTime(AnimationSequenceBase: AnimSequenceBase,Time: number,IsValid?: boolean): {IsValid: boolean};
	static RemoveAllAnimationNotifyTracks(AnimationSequenceBase: AnimSequenceBase): void;
	static RemoveAnimationNotifyEventsByName(AnimationSequenceBase: AnimSequenceBase,NotifyName: string): number;
	static RemoveAnimationNotifyEventsByTrack(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string): number;
	static RemoveAnimationNotifyTrack(AnimationSequenceBase: AnimSequenceBase,NotifyTrackName: string): void;
	static ReplaceAnimNotifies(AnimationSequenceBase: AnimSequenceBase,OldNotifyClass: UnrealEngineClass,NewNotifyClass: UnrealEngineClass,OnNotifyReplaced: UnrealEngineDelegate<(OldNotify: AnimNotify, NewNotify: AnimNotify) => void>): void;
	static ReplaceAnimNotifyStates(AnimationSequenceBase: AnimSequenceBase,OldNotifyClass: UnrealEngineClass,NewNotifyClass: UnrealEngineClass,OnNotifyStateReplaced: UnrealEngineDelegate<(OldNotifyState: AnimNotifyState, NewNotifyState: AnimNotifyState) => void>): void;
	static SetRateScale(AnimationSequenceBase: AnimSequenceBase,RateScale: number): void;
}

declare class TrackToSkeletonMap { 
	BoneTreeIndex: number;
	clone() : TrackToSkeletonMap;
	static C(Other: UObject | any): TrackToSkeletonMap;
}

declare class AnimBoneCompressionCodec extends UObject { 
	Description: string;
	static Load(ResourceName: string): AnimBoneCompressionCodec;
	static Find(Outer: UObject, ResourceName: string): AnimBoneCompressionCodec;
	static GetDefaultObject(): AnimBoneCompressionCodec;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimBoneCompressionCodec;
	static C(Other: UObject | any): AnimBoneCompressionCodec;
}

declare class AnimBoneCompressionSettings extends UObject { 
	Codecs: AnimBoneCompressionCodec[];
	ErrorThreshold: number;
	bForceBelowThreshold: boolean;
	static Load(ResourceName: string): AnimBoneCompressionSettings;
	static Find(Outer: UObject, ResourceName: string): AnimBoneCompressionSettings;
	static GetDefaultObject(): AnimBoneCompressionSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimBoneCompressionSettings;
	static C(Other: UObject | any): AnimBoneCompressionSettings;
}

declare class AnimCurveCompressionCodec extends UObject { 
	static Load(ResourceName: string): AnimCurveCompressionCodec;
	static Find(Outer: UObject, ResourceName: string): AnimCurveCompressionCodec;
	static GetDefaultObject(): AnimCurveCompressionCodec;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimCurveCompressionCodec;
	static C(Other: UObject | any): AnimCurveCompressionCodec;
}

declare class AnimCurveCompressionSettings extends UObject { 
	Codec: AnimCurveCompressionCodec;
	static Load(ResourceName: string): AnimCurveCompressionSettings;
	static Find(Outer: UObject, ResourceName: string): AnimCurveCompressionSettings;
	static GetDefaultObject(): AnimCurveCompressionSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimCurveCompressionSettings;
	static C(Other: UObject | any): AnimCurveCompressionSettings;
}

declare type EAdditiveAnimationType = 'AAT_None' | 'AAT_LocalSpaceBase' | 'AAT_RotationOffsetMeshSpace' | 'AAT_MAX';
declare var EAdditiveAnimationType : { AAT_None:'AAT_None',AAT_LocalSpaceBase:'AAT_LocalSpaceBase',AAT_RotationOffsetMeshSpace:'AAT_RotationOffsetMeshSpace',AAT_MAX:'AAT_MAX', };
declare type EAdditiveBasePoseType = 'ABPT_None' | 'ABPT_RefPose' | 'ABPT_AnimScaled' | 'ABPT_AnimFrame' | 'ABPT_LocalAnimFrame' | 'ABPT_MAX';
declare var EAdditiveBasePoseType : { ABPT_None:'ABPT_None',ABPT_RefPose:'ABPT_RefPose',ABPT_AnimScaled:'ABPT_AnimScaled',ABPT_AnimFrame:'ABPT_AnimFrame',ABPT_LocalAnimFrame:'ABPT_LocalAnimFrame',ABPT_MAX:'ABPT_MAX', };
declare type EAnimInterpolationType = 'Linear' | 'Step' | 'EAnimInterpolationType_MAX';
declare var EAnimInterpolationType : { Linear:'Linear',Step:'Step',EAnimInterpolationType_MAX:'EAnimInterpolationType_MAX', };
declare class CustomAttribute { 
	Name: string;
	VariantType: number;
	Times: number[];
	clone() : CustomAttribute;
	static C(Other: UObject | any): CustomAttribute;
}

declare class CustomAttributePerBoneData { 
	BoneTreeIndex: number;
	Attributes: CustomAttribute[];
	clone() : CustomAttributePerBoneData;
	static C(Other: UObject | any): CustomAttributePerBoneData;
}

declare class AnimSequenceLevelSequenceLink extends AssetUserData { 
	SkelTrackGuid: Guid;
	PathToLevelSequence: SoftObjectPath;
	static Load(ResourceName: string): AnimSequenceLevelSequenceLink;
	static Find(Outer: UObject, ResourceName: string): AnimSequenceLevelSequenceLink;
	static GetDefaultObject(): AnimSequenceLevelSequenceLink;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimSequenceLevelSequenceLink;
	static C(Other: UObject | any): AnimSequenceLevelSequenceLink;
}

declare class AnimSequence extends AnimSequenceBase { 
	ImportFileFramerate: number;
	ImportResampleFramerate: number;
	NumFrames: number;
	NumberOfKeys: number;
	SamplingFrameRate: FrameRate;
	TrackToSkeletonMapTable: TrackToSkeletonMap[];
	RawDataGuid: Guid;
	AnimationTrackNames: string[];
	bAllowFrameStripping: boolean;
	CompressionErrorThresholdScale: number;
	BoneCompressionSettings: AnimBoneCompressionSettings;
	CurveCompressionSettings: AnimCurveCompressionSettings;
	AdditiveAnimType: EAdditiveAnimationType;
	RefPoseType: EAdditiveBasePoseType;
	RefFrameIndex: number;
	RefPoseSeq: AnimSequence;
	RetargetSource: string;
	RetargetSourceAsset: SkeletalMesh;
	RetargetSourceAssetReferencePose: Transform[];
	Interpolation: EAnimInterpolationType;
	bEnableRootMotion: boolean;
	RootMotionRootLock: ERootMotionRootLock;
	bForceRootLock: boolean;
	bUseNormalizedRootMotionScale: boolean;
	bRootMotionSettingsCopiedFromMontage: boolean;
	CompressCommandletVersion: number;
	bDoNotOverrideCompression: boolean;
	AssetImportData: AssetImportData;
	SourceFilePath: string;
	SourceFileTimestamp: string;
	bNeedsRebake: boolean;
	AuthoredSyncMarkers: AnimSyncMarker[];
	TargetFrameRate: FrameRate;
	NumberOfSampledKeys: number;
	NumberOfSampledFrames: number;
	ResampledAnimationTrackData: BoneAnimationTrack[];
	PerBoneCustomAttributeData: CustomAttributePerBoneData[];
	AttributeCurves: Map<AnimationAttributeIdentifier, AttributeCurve>;
	static Load(ResourceName: string): AnimSequence;
	static Find(Outer: UObject, ResourceName: string): AnimSequence;
	static GetDefaultObject(): AnimSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimSequence;
	RemoveCustomAttribute(BoneName: string,AttributeName: string): void;
	RemoveAllCustomAttributesForBone(BoneName: string): void;
	RemoveAllCustomAttributes(): void;
	AddBoneStringCustomAttribute(BoneName: string,AttributeName: string,TimeKeys: number[],ValueKeys: string[]): void;
	AddBoneIntegerCustomAttribute(BoneName: string,AttributeName: string,TimeKeys: number[],ValueKeys: number[]): void;
	AddBoneFloatCustomAttribute(BoneName: string,AttributeName: string,TimeKeys: number[],ValueKeys: number[]): void;
	static C(Other: UObject | any): AnimSequence;
	GetLevelSequenceLinkFromAnimSequence(): AnimSequenceLevelSequenceLink;
	GetMovingRangesFromRootMotion(StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	GetStoppedRangesFromRootMotion(StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	AddAnimationSyncMarker(MarkerName: string,Time: number,NotifyTrackName: string): void;
	AddCurve(CurveName: string,CurveType: ERawCurveTrackTypes,bMetaDataCurve: boolean): void;
	AddFloatCurveKey(CurveName: string,Time: number,Value: number): void;
	AddFloatCurveKeys(CurveName: string,Times: number[],Values: number[]): void;
	AddTransformationCurveKey(CurveName: string,Time: number,Transform: Transform): void;
	AddTransformationCurveKeys(CurveName: string,Times: number[],Transforms: Transform[]): void;
	AddVectorCurveKey(CurveName: string,Time: number,Vector: Vector): void;
	AddVectorCurveKeys(CurveName: string,Times: number[],Vectors: Vector[]): void;
	AddVirtualBone(SourceBoneName: string,TargetBoneName: string,VirtualBoneName?: string): {VirtualBoneName: string};
	DoesBoneNameExist(BoneName: string,bExists?: boolean): {bExists: boolean};
	DoesCurveExist(CurveName: string,CurveType: ERawCurveTrackTypes): boolean;
	FinalizeBoneAnimation(): void;
	GetAdditiveAnimationType(AdditiveAnimationType?: EAdditiveAnimationType): {AdditiveAnimationType: EAdditiveAnimationType};
	GetAdditiveBasePoseType(AdditiveBasePoseType?: EAdditiveBasePoseType): {AdditiveBasePoseType: EAdditiveBasePoseType};
	GetAnimationCurveNames(CurveType: ERawCurveTrackTypes,CurveNames?: string[]): {CurveNames: string[]};
	GetAnimationInterpolationType(InterpolationType?: EAnimInterpolationType): {InterpolationType: EAnimInterpolationType};
	GetAnimationSyncMarkers(Markers?: AnimSyncMarker[]): {Markers: AnimSyncMarker[]};
	GetAnimationSyncMarkersForTrack(NotifyTrackName: string,Markers?: AnimSyncMarker[]): {Markers: AnimSyncMarker[]};
	GetBoneCompressionSettings(CompressionSettings?: AnimBoneCompressionSettings): {CompressionSettings: AnimBoneCompressionSettings};
	GetCurveCompressionSettings(CompressionSettings?: AnimCurveCompressionSettings): {CompressionSettings: AnimCurveCompressionSettings};
	GetFloatKeys(CurveName: string,Times?: number[],Values?: number[]): {Times: number[], Values: number[]};
	GetRootMotionLockType(LockType?: ERootMotionRootLock): {LockType: ERootMotionRootLock};
	GetTransformationKeys(CurveName: string,Times?: number[],Values?: Transform[]): {Times: number[], Values: Transform[]};
	GetUniqueMarkerNames(MarkerNames?: string[]): {MarkerNames: string[]};
	GetVectorKeys(CurveName: string,Times?: number[],Values?: Vector[]): {Times: number[], Values: Vector[]};
	IsRootMotionEnabled(): boolean;
	IsRootMotionLockForced(): boolean;
	IsValidAnimationSyncMarkerName(MarkerName: string): boolean;
	RemoveAllAnimationSyncMarkers(): void;
	RemoveAllBoneAnimation(): void;
	RemoveAllCurveData(): void;
	RemoveAllVirtualBones(): void;
	RemoveAnimationSyncMarkersByName(MarkerName: string): number;
	RemoveAnimationSyncMarkersByTrack(NotifyTrackName: string): number;
	RemoveBoneAnimation(BoneName: string,bIncludeChildren: boolean,bFinalize: boolean): void;
	RemoveCurve(CurveName: string,bRemoveNameFromSkeleton: boolean): void;
	RemoveVirtualBone(VirtualBoneName: string): void;
	RemoveVirtualBones(VirtualBoneNames: string[]): void;
	SetAdditiveAnimationType(AdditiveAnimationType: EAdditiveAnimationType): void;
	SetAdditiveBasePoseType(AdditiveBasePoseType: EAdditiveBasePoseType): void;
	SetAnimationInterpolationType(InterpolationType: EAnimInterpolationType): void;
	SetBoneCompressionSettings(CompressionSettings: AnimBoneCompressionSettings): void;
	SetCurveCompressionSettings(CompressionSettings: AnimCurveCompressionSettings): void;
	SetIsRootMotionLockForced(bForced: boolean): void;
	SetRootMotionEnabled(bEnabled: boolean): void;
	SetRootMotionLockType(RootMotionLockType: ERootMotionRootLock): void;
	static GetLevelSequenceLinkFromAnimSequence(InAnimSequence: AnimSequence): AnimSequenceLevelSequenceLink;
	static GetMovingRangesFromRootMotion(AnimSequence: AnimSequence,StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	static GetStoppedRangesFromRootMotion(AnimSequence: AnimSequence,StopSpeedThreshold: number,SampleRate: number): Vector2D[];
	static AddAnimationSyncMarker(AnimationSequence: AnimSequence,MarkerName: string,Time: number,NotifyTrackName: string): void;
	static AddCurve(AnimationSequence: AnimSequence,CurveName: string,CurveType: ERawCurveTrackTypes,bMetaDataCurve: boolean): void;
	static AddFloatCurveKey(AnimationSequence: AnimSequence,CurveName: string,Time: number,Value: number): void;
	static AddFloatCurveKeys(AnimationSequence: AnimSequence,CurveName: string,Times: number[],Values: number[]): void;
	static AddTransformationCurveKey(AnimationSequence: AnimSequence,CurveName: string,Time: number,Transform: Transform): void;
	static AddTransformationCurveKeys(AnimationSequence: AnimSequence,CurveName: string,Times: number[],Transforms: Transform[]): void;
	static AddVectorCurveKey(AnimationSequence: AnimSequence,CurveName: string,Time: number,Vector: Vector): void;
	static AddVectorCurveKeys(AnimationSequence: AnimSequence,CurveName: string,Times: number[],Vectors: Vector[]): void;
	static AddVirtualBone(AnimationSequence: AnimSequence,SourceBoneName: string,TargetBoneName: string,VirtualBoneName?: string): {VirtualBoneName: string};
	static DoesBoneNameExist(AnimationSequence: AnimSequence,BoneName: string,bExists?: boolean): {bExists: boolean};
	static DoesCurveExist(AnimationSequence: AnimSequence,CurveName: string,CurveType: ERawCurveTrackTypes): boolean;
	static FinalizeBoneAnimation(AnimationSequence: AnimSequence): void;
	static GetAdditiveAnimationType(AnimationSequence: AnimSequence,AdditiveAnimationType?: EAdditiveAnimationType): {AdditiveAnimationType: EAdditiveAnimationType};
	static GetAdditiveBasePoseType(AnimationSequence: AnimSequence,AdditiveBasePoseType?: EAdditiveBasePoseType): {AdditiveBasePoseType: EAdditiveBasePoseType};
	static GetAnimationCurveNames(AnimationSequence: AnimSequence,CurveType: ERawCurveTrackTypes,CurveNames?: string[]): {CurveNames: string[]};
	static GetAnimationInterpolationType(AnimationSequence: AnimSequence,InterpolationType?: EAnimInterpolationType): {InterpolationType: EAnimInterpolationType};
	static GetAnimationSyncMarkers(AnimationSequence: AnimSequence,Markers?: AnimSyncMarker[]): {Markers: AnimSyncMarker[]};
	static GetAnimationSyncMarkersForTrack(AnimationSequence: AnimSequence,NotifyTrackName: string,Markers?: AnimSyncMarker[]): {Markers: AnimSyncMarker[]};
	static GetBoneCompressionSettings(AnimationSequence: AnimSequence,CompressionSettings?: AnimBoneCompressionSettings): {CompressionSettings: AnimBoneCompressionSettings};
	static GetCurveCompressionSettings(AnimationSequence: AnimSequence,CompressionSettings?: AnimCurveCompressionSettings): {CompressionSettings: AnimCurveCompressionSettings};
	static GetFloatKeys(AnimationSequence: AnimSequence,CurveName: string,Times?: number[],Values?: number[]): {Times: number[], Values: number[]};
	static GetRootMotionLockType(AnimationSequence: AnimSequence,LockType?: ERootMotionRootLock): {LockType: ERootMotionRootLock};
	static GetTransformationKeys(AnimationSequence: AnimSequence,CurveName: string,Times?: number[],Values?: Transform[]): {Times: number[], Values: Transform[]};
	static GetUniqueMarkerNames(AnimationSequence: AnimSequence,MarkerNames?: string[]): {MarkerNames: string[]};
	static GetVectorKeys(AnimationSequence: AnimSequence,CurveName: string,Times?: number[],Values?: Vector[]): {Times: number[], Values: Vector[]};
	static IsRootMotionEnabled(AnimationSequence: AnimSequence): boolean;
	static IsRootMotionLockForced(AnimationSequence: AnimSequence): boolean;
	static IsValidAnimationSyncMarkerName(AnimationSequence: AnimSequence,MarkerName: string): boolean;
	static RemoveAllAnimationSyncMarkers(AnimationSequence: AnimSequence): void;
	static RemoveAllBoneAnimation(AnimationSequence: AnimSequence): void;
	static RemoveAllCurveData(AnimationSequence: AnimSequence): void;
	static RemoveAllVirtualBones(AnimationSequence: AnimSequence): void;
	static RemoveAnimationSyncMarkersByName(AnimationSequence: AnimSequence,MarkerName: string): number;
	static RemoveAnimationSyncMarkersByTrack(AnimationSequence: AnimSequence,NotifyTrackName: string): number;
	static RemoveBoneAnimation(AnimationSequence: AnimSequence,BoneName: string,bIncludeChildren: boolean,bFinalize: boolean): void;
	static RemoveCurve(AnimationSequence: AnimSequence,CurveName: string,bRemoveNameFromSkeleton: boolean): void;
	static RemoveVirtualBone(AnimationSequence: AnimSequence,VirtualBoneName: string): void;
	static RemoveVirtualBones(AnimationSequence: AnimSequence,VirtualBoneNames: string[]): void;
	static SetAdditiveAnimationType(AnimationSequence: AnimSequence,AdditiveAnimationType: EAdditiveAnimationType): void;
	static SetAdditiveBasePoseType(AnimationSequence: AnimSequence,AdditiveBasePoseType: EAdditiveBasePoseType): void;
	static SetAnimationInterpolationType(AnimationSequence: AnimSequence,InterpolationType: EAnimInterpolationType): void;
	static SetBoneCompressionSettings(AnimationSequence: AnimSequence,CompressionSettings: AnimBoneCompressionSettings): void;
	static SetCurveCompressionSettings(AnimationSequence: AnimSequence,CompressionSettings: AnimCurveCompressionSettings): void;
	static SetIsRootMotionLockForced(AnimationSequence: AnimSequence,bForced: boolean): void;
	static SetRootMotionEnabled(AnimationSequence: AnimSequence,bEnabled: boolean): void;
	static SetRootMotionLockType(AnimationSequence: AnimSequence,RootMotionLockType: ERootMotionRootLock): void;
}

declare class PoseAsset extends AnimationAsset { 
	PoseContainer: PoseDataContainer;
	bAdditivePose: boolean;
	BasePoseIndex: number;
	RetargetSource: string;
	RetargetSourceAsset: SkeletalMesh;
	RetargetSourceAssetReferencePose: Transform[];
	SourceAnimation: AnimSequence;
	SourceAnimationRawDataGUID: Guid;
	static Load(ResourceName: string): PoseAsset;
	static Find(Outer: UObject, ResourceName: string): PoseAsset;
	static GetDefaultObject(): PoseAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PoseAsset;
	UpdatePoseFromAnimation(AnimSequence: AnimSequence): void;
	RenamePose(OriginalPoseName: string,NewPoseName: string): void;
	GetPoseNames(PoseNames?: string[]): {PoseNames: string[]};
	static C(Other: UObject | any): PoseAsset;
}

declare class AnimationAsset extends UObject { 
	Skeleton: Skeleton;
	MetaData: AnimMetaData[];
	ParentAsset: AnimationAsset;
	ChildrenAssets: AnimationAsset[];
	AssetMappingTable: AssetMappingTable;
	AssetUserData: AssetUserData[];
	ThumbnailInfo: ThumbnailInfo;
	PreviewPoseAsset: PoseAsset;
	PreviewSkeletalMesh: SkeletalMesh;
	static Load(ResourceName: string): AnimationAsset;
	static Find(Outer: UObject, ResourceName: string): AnimationAsset;
	static GetDefaultObject(): AnimationAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationAsset;
	SetPreviewSkeletalMesh(PreviewMesh: SkeletalMesh): void;
	GetPlayLength(): number;
	static C(Other: UObject | any): AnimationAsset;
	CreateAttributeIdentifier(AttributeName: string,BoneName: string,AttributeType: ScriptStruct,bValidateExistsOnAsset: boolean): AnimationAttributeIdentifier;
	GetSkeleton(): Skeleton;
	AddMetaData(MetaDataClass: UnrealEngineClass,MetaDataInstance?: AnimMetaData): {MetaDataInstance: AnimMetaData};
	AddMetaDataObject(MetaDataObject: AnimMetaData): void;
	ContainsMetaDataOfClass(MetaDataClass: UnrealEngineClass): boolean;
	GetMetaData(MetaData?: AnimMetaData[]): {MetaData: AnimMetaData[]};
	GetMetaDataOfClass(MetaDataClass: UnrealEngineClass,MetaDataOfClass?: AnimMetaData[]): {MetaDataOfClass: AnimMetaData[]};
	RemoveAllMetaData(): void;
	RemoveMetaData(MetaDataObject: AnimMetaData): void;
	RemoveMetaDataOfClass(MetaDataClass: UnrealEngineClass): void;
	static CreateAttributeIdentifier(AnimationAsset: AnimationAsset,AttributeName: string,BoneName: string,AttributeType: ScriptStruct,bValidateExistsOnAsset: boolean): AnimationAttributeIdentifier;
	static GetSkeleton(InAsset: AnimationAsset): Skeleton;
	static AddMetaData(AnimationAsset: AnimationAsset,MetaDataClass: UnrealEngineClass,MetaDataInstance?: AnimMetaData): {MetaDataInstance: AnimMetaData};
	static AddMetaDataObject(AnimationAsset: AnimationAsset,MetaDataObject: AnimMetaData): void;
	static ContainsMetaDataOfClass(AnimationAsset: AnimationAsset,MetaDataClass: UnrealEngineClass): boolean;
	static GetMetaData(AnimationAsset: AnimationAsset,MetaData?: AnimMetaData[]): {MetaData: AnimMetaData[]};
	static GetMetaDataOfClass(AnimationAsset: AnimationAsset,MetaDataClass: UnrealEngineClass,MetaDataOfClass?: AnimMetaData[]): {MetaDataOfClass: AnimMetaData[]};
	static RemoveAllMetaData(AnimationAsset: AnimationAsset): void;
	static RemoveMetaData(AnimationAsset: AnimationAsset,MetaDataObject: AnimMetaData): void;
	static RemoveMetaDataOfClass(AnimationAsset: AnimationAsset,MetaDataClass: UnrealEngineClass): void;
}

declare class AnimParentNodeAssetOverride { 
	NewAsset: AnimationAsset;
	ParentNodeGuid: Guid;
	clone() : AnimParentNodeAssetOverride;
	static C(Other: UObject | any): AnimParentNodeAssetOverride;
}

declare class PoseWatchFolder extends UObject { 
	Label: string;
	Parent: PoseWatchFolder;
	bIsVisible: boolean;
	bIsExpanded: boolean;
	static Load(ResourceName: string): PoseWatchFolder;
	static Find(Outer: UObject, ResourceName: string): PoseWatchFolder;
	static GetDefaultObject(): PoseWatchFolder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PoseWatchFolder;
	static C(Other: UObject | any): PoseWatchFolder;
}

declare class Vector3d { 
	X: number;
	Y: number;
	Z: number;
	clone() : Vector3d;
	static C(Other: UObject | any): Vector3d;
}

declare class PoseWatchElement extends UObject { 
	bIsVisible: boolean;
	bHasColor: boolean;
	Color: Color;
	Label: string;
	IconName: string;
	Parent: PoseWatch;
	static Load(ResourceName: string): PoseWatchElement;
	static Find(Outer: UObject, ResourceName: string): PoseWatchElement;
	static GetDefaultObject(): PoseWatchElement;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PoseWatchElement;
	static C(Other: UObject | any): PoseWatchElement;
}

declare class PoseWatch extends UObject { 
	UNode: EdGraphNode;
	ViewportMask: BlendProfile;
	bInvertViewportMask: boolean;
	BlendScaleThreshold: number;
	ViewportOffset: Vector3d;
	Elements: PoseWatchElement[];
	bDeleteOnDeselection: boolean;
	bIsVisible: boolean;
	bIsNodeEnabled: boolean;
	bIsExpanded: boolean;
	Color: Color;
	Label: string;
	IconName: string;
	Parent: PoseWatchFolder;
	static Load(ResourceName: string): PoseWatch;
	static Find(Outer: UObject, ResourceName: string): PoseWatch;
	static GetDefaultObject(): PoseWatch;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PoseWatch;
	static C(Other: UObject | any): PoseWatch;
}

declare type EPreviewAnimationBlueprintApplicationMethod = 'LinkedLayers' | 'LinkedAnimGraph' | 'EPreviewAnimationBlueprintApplicationMethod_MAX';
declare var EPreviewAnimationBlueprintApplicationMethod : { LinkedLayers:'LinkedLayers',LinkedAnimGraph:'LinkedAnimGraph',EPreviewAnimationBlueprintApplicationMethod_MAX:'EPreviewAnimationBlueprintApplicationMethod_MAX', };
declare class EdGraphSchema extends UObject { 
	static Load(ResourceName: string): EdGraphSchema;
	static Find(Outer: UObject, ResourceName: string): EdGraphSchema;
	static GetDefaultObject(): EdGraphSchema;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraphSchema;
	static C(Other: UObject | any): EdGraphSchema;
	SetNodeMetaData(UNode: EdGraphNode,KeyValue: string): boolean;
	TryConnection(A: JavascriptEdGraphPin,B: JavascriptEdGraphPin): boolean;
	static SetNodeMetaData(Schema: EdGraphSchema,UNode: EdGraphNode,KeyValue: string): boolean;
	static TryConnection(Schema: EdGraphSchema,A: JavascriptEdGraphPin,B: JavascriptEdGraphPin): boolean;
}

declare class EdGraph extends UObject { 
	Schema: UnrealEngineClass;
	Nodes: EdGraphNode[];
	bEditable: boolean;
	bAllowDeletion: boolean;
	bAllowRenaming: boolean;
	SubGraphs: EdGraph[];
	GraphGuid: Guid;
	InterfaceGuid: Guid;
	static Load(ResourceName: string): EdGraph;
	static Find(Outer: UObject, ResourceName: string): EdGraph;
	static GetDefaultObject(): EdGraph;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EdGraph;
	static C(Other: UObject | any): EdGraph;
	RenameGraph(NewNameStr: string): void;
	static RenameGraph(Graph: EdGraph,NewNameStr: string): void;
}

declare class AnimGraphBlendOptions { 
	BlendInTime: number;
	BlendInProfile: BlendProfile;
	BlendOutTime: number;
	BlendOutProfile: BlendProfile;
	clone() : AnimGraphBlendOptions;
	static C(Other: UObject | any): AnimGraphBlendOptions;
}

declare class K2Node extends EdGraphNode { 
	static Load(ResourceName: string): K2Node;
	static Find(Outer: UObject, ResourceName: string): K2Node;
	static GetDefaultObject(): K2Node;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node;
	static C(Other: UObject | any): K2Node;
}

declare class OptionalPinFromProperty { 
	PropertyName: string;
	PropertyFriendlyName: string;
	PropertyTooltip: string;
	CategoryName: string;
	bShowPin: boolean;
	bCanToggleVisibility: boolean;
	bPropertyIsCustomized: boolean;
	bHasOverridePin: boolean;
	bIsMarkedForAdvancedDisplay: boolean;
	bIsOverrideEnabled: boolean;
	bIsSetValuePinVisible: boolean;
	bIsOverridePinVisible: boolean;
	clone() : OptionalPinFromProperty;
	static C(Other: UObject | any): OptionalPinFromProperty;
}

declare type EAnimGraphNodePropertyBindingType = 'None' | 'Property' | 'Function' | 'EAnimGraphNodePropertyBindingType_MAX';
declare var EAnimGraphNodePropertyBindingType : { None:'None',Property:'Property',Function:'Function',EAnimGraphNodePropertyBindingType_MAX:'EAnimGraphNodePropertyBindingType_MAX', };
declare class AnimGraphNodePropertyBinding { 
	PinType: EdGraphPinType;
	PromotedPinType: EdGraphPinType;
	PropertyName: string;
	ArrayIndex: number;
	PathAsText: string;
	PropertyPath: string[];
	ContextId: string;
	CompiledContext: string;
	CompiledContextDesc: string;
	Type: EAnimGraphNodePropertyBindingType;
	bIsBound: boolean;
	bIsPromotion: boolean;
	clone() : AnimGraphNodePropertyBinding;
	static C(Other: UObject | any): AnimGraphNodePropertyBinding;
}

declare type EBlueprintUsage = 'NoProperties' | 'DoesNotUseBlueprint' | 'UsesBlueprint' | 'EBlueprintUsage_MAX';
declare var EBlueprintUsage : { NoProperties:'NoProperties',DoesNotUseBlueprint:'DoesNotUseBlueprint',UsesBlueprint:'UsesBlueprint',EBlueprintUsage_MAX:'EBlueprintUsage_MAX', };
declare class MemberReference { 
	MemberParent: UObject;
	MemberScope: string;
	MemberName: string;
	MemberGuid: Guid;
	bSelfContext: boolean;
	bWasDeprecated: boolean;
	clone() : MemberReference;
	static C(Other: UObject | any): MemberReference;
}

declare class AnimGraphNode_Base extends K2Node { 
	ShowPinForProperties: OptionalPinFromProperty[];
	PropertyBindings: Map<string, AnimGraphNodePropertyBinding>;
	AlwaysDynamicProperties: Set<string>;
	BlueprintUsage: EBlueprintUsage;
	InitialUpdateFunction: MemberReference;
	BecomeRelevantFunction: MemberReference;
	UpdateFunction: MemberReference;
	Tag: string;
	static Load(ResourceName: string): AnimGraphNode_Base;
	static Find(Outer: UObject, ResourceName: string): AnimGraphNode_Base;
	static GetDefaultObject(): AnimGraphNode_Base;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimGraphNode_Base;
	static C(Other: UObject | any): AnimGraphNode_Base;
}

declare class AnimationGraph extends EdGraph { 
	BlendOptions: AnimGraphBlendOptions;
	static Load(ResourceName: string): AnimationGraph;
	static Find(Outer: UObject, ResourceName: string): AnimationGraph;
	static GetDefaultObject(): AnimationGraph;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationGraph;
	GetGraphNodesOfClass(NodeClass: UnrealEngineClass,GraphNodes?: AnimGraphNode_Base[],bIncludeChildClasses?: boolean): {GraphNodes: AnimGraphNode_Base[]};
	static C(Other: UObject | any): AnimationGraph;
}

declare class AnimBlueprint extends Blueprint { 
	TargetSkeleton: Skeleton;
	Groups: AnimGroupInfo[];
	bIsTemplate: boolean;
	bUseMultiThreadedAnimationUpdate: boolean;
	bWarnAboutBlueprintUsage: boolean;
	ParentAssetOverrides: AnimParentNodeAssetOverride[];
	PoseWatchFolders: PoseWatchFolder[];
	PoseWatches: PoseWatch[];
	PreviewSkeletalMesh: SkeletalMesh;
	PreviewAnimationBlueprint: AnimBlueprint;
	PreviewAnimationBlueprintApplicationMethod: EPreviewAnimationBlueprintApplicationMethod;
	PreviewAnimationBlueprintTag: string;
	static Load(ResourceName: string): AnimBlueprint;
	static Find(Outer: UObject, ResourceName: string): AnimBlueprint;
	static GetDefaultObject(): AnimBlueprint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimBlueprint;
	static C(Other: UObject | any): AnimBlueprint;
	AddNodeAssetOverride(Target: AnimationAsset,Override: AnimationAsset,bPrintAppliedOverrides: boolean): void;
	GetAnimationGraphs(AnimationGraphs?: AnimationGraph[]): {AnimationGraphs: AnimationGraph[]};
	GetNodesOfClass(NodeClass: UnrealEngineClass,GraphNodes?: AnimGraphNode_Base[],bIncludeChildClasses?: boolean): {GraphNodes: AnimGraphNode_Base[]};
	static AddNodeAssetOverride(AnimBlueprint: AnimBlueprint,Target: AnimationAsset,Override: AnimationAsset,bPrintAppliedOverrides: boolean): void;
	static GetAnimationGraphs(AnimationBlueprint: AnimBlueprint,AnimationGraphs?: AnimationGraph[]): {AnimationGraphs: AnimationGraph[]};
	static GetNodesOfClass(AnimationBlueprint: AnimBlueprint,NodeClass: UnrealEngineClass,GraphNodes?: AnimGraphNode_Base[],bIncludeChildClasses?: boolean): {GraphNodes: AnimGraphNode_Base[]};
}

declare type EAnimPoseSpaces = 'Local' | 'World' | 'EAnimPoseSpaces_MAX';
declare var EAnimPoseSpaces : { Local:'Local',World:'World',EAnimPoseSpaces_MAX:'EAnimPoseSpaces_MAX', };
declare class AnimPose { 
	BoneNames: string[];
	BoneIndices: number[];
	ParentBoneIndices: number[];
	LocalSpacePoses: Transform[];
	WorldSpacePoses: Transform[];
	RefLocalSpacePoses: Transform[];
	RefWorldSpacePoses: Transform[];
	CurveNames: string[];
	CurveValues: number[];
	clone() : AnimPose;
	static C(Other: UObject | any): AnimPose;
	EvaluateAnimationBlueprintWithInputPose(TargetSkeletalMesh: SkeletalMesh,AnimationBlueprint: AnimBlueprint,OutPose?: AnimPose): {OutPose: AnimPose};
	GetBoneNames(Bones?: string[]): {Bones: string[]};
	GetBonePose(BoneName: string,Space: EAnimPoseSpaces): Transform;
	GetCurveNames(Curves?: string[]): {Curves: string[]};
	GetCurveWeight(CurveName: string): number;
	GetRefBonePose(BoneName: string,Space: EAnimPoseSpaces): Transform;
	GetRefPoseRelativeTransform(FromBoneName: string,ToBoneName: string,Space: EAnimPoseSpaces): Transform;
	GetRelativeToRefPoseTransform(BoneName: string,Space: EAnimPoseSpaces): Transform;
	GetRelativeTransform(FromBoneName: string,ToBoneName: string,Space: EAnimPoseSpaces): Transform;
	IsValid(): boolean;
	SetBonePose(Transform?: Transform,BoneName?: string,Space?: EAnimPoseSpaces): {Pose: AnimPose};
	static EvaluateAnimationBlueprintWithInputPose(InputPose: AnimPose,TargetSkeletalMesh: SkeletalMesh,AnimationBlueprint: AnimBlueprint,OutPose?: AnimPose): {OutPose: AnimPose};
	static GetBoneNames(Pose: AnimPose,Bones?: string[]): {Bones: string[]};
	static GetBonePose(Pose: AnimPose,BoneName: string,Space: EAnimPoseSpaces): Transform;
	static GetCurveNames(Pose: AnimPose,Curves?: string[]): {Curves: string[]};
	static GetCurveWeight(Pose: AnimPose,CurveName: string): number;
	static GetRefBonePose(Pose: AnimPose,BoneName: string,Space: EAnimPoseSpaces): Transform;
	static GetRefPoseRelativeTransform(Pose: AnimPose,FromBoneName: string,ToBoneName: string,Space: EAnimPoseSpaces): Transform;
	static GetRelativeToRefPoseTransform(Pose: AnimPose,BoneName: string,Space: EAnimPoseSpaces): Transform;
	static GetRelativeTransform(Pose: AnimPose,FromBoneName: string,ToBoneName: string,Space: EAnimPoseSpaces): Transform;
	static IsValid(Pose: AnimPose): boolean;
	static SetBonePose(Pose?: AnimPose,Transform?: Transform,BoneName?: string,Space?: EAnimPoseSpaces): {Pose: AnimPose};
}

declare class Skeleton extends UObject { 
	BoneTree: BoneNode[];
	RefLocalPoses: Transform[];
	VirtualBoneGuid: Guid;
	VirtualBones: VirtualBone[];
	CompatibleSkeletons: Skeleton[];
	Sockets: SkeletalMeshSocket[];
	SmartNames: SmartNameContainer;
	BlendProfiles: BlendProfile[];
	SlotGroups: AnimSlotGroup[];
	PreviewSkeletalMesh: SkeletalMesh;
	AdditionalPreviewSkeletalMeshes: DataAsset;
	RigConfig: RigConfiguration;
	AnimationNotifies: string[];
	PreviewAttachedAssetContainer: PreviewAssetAttachContainer;
	AssetUserData: AssetUserData[];
	static Load(ResourceName: string): Skeleton;
	static Find(Outer: UObject, ResourceName: string): Skeleton;
	static GetDefaultObject(): Skeleton;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Skeleton;
	GetBlendProfile(InProfileName: string): BlendProfile;
	AddCompatibleSkeleton(SourceSkeleton: Skeleton): void;
	static C(Other: UObject | any): Skeleton;
	FindCurveIdentifier(Name: string,CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier;
	GetCurveIdentifier(Name: string,CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier;
	GetCurveIdentifiers(CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier[];
	GetReferencePose(OutPose?: AnimPose): {OutPose: AnimPose};
	CopyAnimationCurveNamesToSkeleton(NewSkeleton: Skeleton,SequenceBase: AnimSequenceBase,CurveType: ERawCurveTrackTypes): void;
	static FindCurveIdentifier(InSkeleton: Skeleton,Name: string,CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier;
	static GetCurveIdentifier(InSkeleton: Skeleton,Name: string,CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier;
	static GetCurveIdentifiers(InSkeleton: Skeleton,CurveType: ERawCurveTrackTypes): AnimationCurveIdentifier[];
	static GetReferencePose(Skeleton: Skeleton,OutPose?: AnimPose): {OutPose: AnimPose};
	static CopyAnimationCurveNamesToSkeleton(OldSkeleton: Skeleton,NewSkeleton: Skeleton,SequenceBase: AnimSequenceBase,CurveType: ERawCurveTrackTypes): void;
}

declare class BoxSphereBounds { 
	Origin: Vector;
	BoxExtent: Vector;
	SphereRadius: number;
	clone() : BoxSphereBounds;
	static C(Other: UObject | any): BoxSphereBounds;
	BreakBoxSphereBounds(Origin?: Vector,BoxExtent?: Vector,SphereRadius?: number): {Origin: Vector, BoxExtent: Vector, SphereRadius: number};
	static BreakBoxSphereBounds(InBoxSphereBounds: BoxSphereBounds,Origin?: Vector,BoxExtent?: Vector,SphereRadius?: number): {Origin: Vector, BoxExtent: Vector, SphereRadius: number};
}

declare class MeshUVChannelInfo { 
	bInitialized: boolean;
	bOverrideDensities: boolean;
	LocalUVDensities: number;
	clone() : MeshUVChannelInfo;
	static C(Other: UObject | any): MeshUVChannelInfo;
}

declare class SkeletalMaterial { 
	MaterialInterface: MaterialInterface;
	MaterialSlotName: string;
	bEnableShadowCasting: boolean;
	bRecomputeTangent: boolean;
	ImportedMaterialSlotName: string;
	UVChannelData: MeshUVChannelInfo;
	clone() : SkeletalMaterial;
	static C(Other: UObject | any): SkeletalMaterial;
}

declare class BoneMirrorInfo { 
	SourceIndex: number;
	BoneFlipAxis: EAxis;
	clone() : BoneMirrorInfo;
	static C(Other: UObject | any): BoneMirrorInfo;
}

declare class SkeletalMeshBuildSettings { 
	bRecomputeNormals: boolean;
	bRecomputeTangents: boolean;
	bUseMikkTSpace: boolean;
	bComputeWeightedNormals: boolean;
	bRemoveDegenerates: boolean;
	bUseHighPrecisionTangentBasis: boolean;
	bUseFullPrecisionUVs: boolean;
	bUseBackwardsCompatibleF16TruncUVs: boolean;
	ThresholdPosition: number;
	ThresholdTangentNormal: number;
	ThresholdUV: number;
	MorphThresholdPosition: number;
	clone() : SkeletalMeshBuildSettings;
	static C(Other: UObject | any): SkeletalMeshBuildSettings;
}

declare type SkeletalMeshTerminationCriterion = 'SMTC_NumOfTriangles' | 'SMTC_NumOfVerts' | 'SMTC_TriangleOrVert' | 'SMTC_AbsNumOfTriangles' | 'SMTC_AbsNumOfVerts' | 'SMTC_AbsTriangleOrVert' | 'SMTC_MAX';
declare var SkeletalMeshTerminationCriterion : { SMTC_NumOfTriangles:'SMTC_NumOfTriangles',SMTC_NumOfVerts:'SMTC_NumOfVerts',SMTC_TriangleOrVert:'SMTC_TriangleOrVert',SMTC_AbsNumOfTriangles:'SMTC_AbsNumOfTriangles',SMTC_AbsNumOfVerts:'SMTC_AbsNumOfVerts',SMTC_AbsTriangleOrVert:'SMTC_AbsTriangleOrVert',SMTC_MAX:'SMTC_MAX', };
declare type SkeletalMeshOptimizationType = 'SMOT_NumOfTriangles' | 'SMOT_MaxDeviation' | 'SMOT_TriangleOrDeviation' | 'SMOT_MAX';
declare var SkeletalMeshOptimizationType : { SMOT_NumOfTriangles:'SMOT_NumOfTriangles',SMOT_MaxDeviation:'SMOT_MaxDeviation',SMOT_TriangleOrDeviation:'SMOT_TriangleOrDeviation',SMOT_MAX:'SMOT_MAX', };
declare type SkeletalMeshOptimizationImportance = 'SMOI_Off' | 'SMOI_Lowest' | 'SMOI_Low' | 'SMOI_Normal' | 'SMOI_High' | 'SMOI_Highest' | 'SMOI_MAX';
declare var SkeletalMeshOptimizationImportance : { SMOI_Off:'SMOI_Off',SMOI_Lowest:'SMOI_Lowest',SMOI_Low:'SMOI_Low',SMOI_Normal:'SMOI_Normal',SMOI_High:'SMOI_High',SMOI_Highest:'SMOI_Highest',SMOI_MAX:'SMOI_MAX', };
declare class SkeletalMeshOptimizationSettings { 
	TerminationCriterion: SkeletalMeshTerminationCriterion;
	NumOfTrianglesPercentage: number;
	NumOfVertPercentage: number;
	MaxNumOfTriangles: number;
	MaxNumOfVerts: number;
	MaxNumOfTrianglesPercentage: number;
	MaxNumOfVertsPercentage: number;
	MaxDeviationPercentage: number;
	ReductionMethod: SkeletalMeshOptimizationType;
	SilhouetteImportance: SkeletalMeshOptimizationImportance;
	TextureImportance: SkeletalMeshOptimizationImportance;
	ShadingImportance: SkeletalMeshOptimizationImportance;
	SkinningImportance: SkeletalMeshOptimizationImportance;
	bRemapMorphTargets: boolean;
	bRecalcNormals: boolean;
	WeldingThreshold: number;
	NormalsThreshold: number;
	MaxBonesPerVertex: number;
	bEnforceBoneBoundaries: boolean;
	bMergeCoincidentVertBones: boolean;
	VolumeImportance: number;
	bLockEdges: boolean;
	bLockColorBounaries: boolean;
	BaseLOD: number;
	BonesToRemove: BoneReference[];
	BakePose: AnimSequence;
	clone() : SkeletalMeshOptimizationSettings;
	static C(Other: UObject | any): SkeletalMeshOptimizationSettings;
}

declare class SectionReference { 
	SectionIndex: number;
	clone() : SectionReference;
	static C(Other: UObject | any): SectionReference;
}

declare type ESkinCacheUsage = 'Auto' | 'Disabled' | 'Enabled' | 'ESkinCacheUsage_MAX';
declare var ESkinCacheUsage : { Auto:'Auto',Disabled:'Disabled',Enabled:'Enabled',ESkinCacheUsage_MAX:'ESkinCacheUsage_MAX', };
declare class SkeletalMeshLODInfo { 
	ScreenSize: PerPlatformFloat;
	LODHysteresis: number;
	LODMaterialMap: number[];
	bEnableShadowCasting: boolean[];
	RemovedBones: string[];
	BuildSettings: SkeletalMeshBuildSettings;
	ReductionSettings: SkeletalMeshOptimizationSettings;
	BonesToRemove: BoneReference[];
	BonesToPrioritize: BoneReference[];
	SectionsToPrioritize: SectionReference[];
	WeightOfPrioritization: number;
	BakePose: AnimSequence;
	BakePoseOverride: AnimSequence;
	SourceImportFilename: string;
	SkinCacheUsage: ESkinCacheUsage;
	MorphTargetPositionErrorTolerance: number;
	bHasBeenSimplified: boolean;
	bHasPerLODVertexColors: boolean;
	bAllowCPUAccess: boolean;
	bSupportUniformlyDistributedSampling: boolean;
	bImportWithBaseMesh: boolean;
	clone() : SkeletalMeshLODInfo;
	static C(Other: UObject | any): SkeletalMeshLODInfo;
}

declare class PerPlatformInt { 
	Default: number;
	PerPlatform: Map<string, number>;
	clone() : PerPlatformInt;
	static C(Other: UObject | any): PerPlatformInt;
}

declare class PerPlatformBool { 
	Default: boolean;
	PerPlatform: Map<string, boolean>;
	clone() : PerPlatformBool;
	static C(Other: UObject | any): PerPlatformBool;
}

declare type EBoneFilterActionOption = 'Remove' | 'Keep' | 'Invalid' | 'EBoneFilterActionOption_MAX';
declare var EBoneFilterActionOption : { Remove:'Remove',Keep:'Keep',Invalid:'Invalid',EBoneFilterActionOption_MAX:'EBoneFilterActionOption_MAX', };
declare class BoneFilter { 
	bExcludeSelf: boolean;
	BoneName: string;
	clone() : BoneFilter;
	static C(Other: UObject | any): BoneFilter;
}

declare class SkeletalMeshLODGroupSettings { 
	ScreenSize: PerPlatformFloat;
	LODHysteresis: number;
	BoneFilterActionOption: EBoneFilterActionOption;
	BoneList: BoneFilter[];
	BonesToPrioritize: string[];
	SectionsToPrioritize: number[];
	WeightOfPrioritization: number;
	BakePose: AnimSequence;
	ReductionSettings: SkeletalMeshOptimizationSettings;
	clone() : SkeletalMeshLODGroupSettings;
	static C(Other: UObject | any): SkeletalMeshLODGroupSettings;
}

declare class SkeletalMeshLODSettings extends DataAsset { 
	MinQualityLevelLOD: PerQualityLevelInt;
	MinLOD: PerPlatformInt;
	DisableBelowMinLodStripping: PerPlatformBool;
	bOverrideLODStreamingSettings: boolean;
	bSupportLODStreaming: PerPlatformBool;
	MaxNumStreamedLODs: PerPlatformInt;
	MaxNumOptionalLODs: PerPlatformInt;
	LODGroups: SkeletalMeshLODGroupSettings[];
	static Load(ResourceName: string): SkeletalMeshLODSettings;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshLODSettings;
	static GetDefaultObject(): SkeletalMeshLODSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshLODSettings;
	static C(Other: UObject | any): SkeletalMeshLODSettings;
}

declare class PhysicalAnimationData { 
	BodyName: string;
	bIsLocalSimulation: boolean;
	OrientationStrength: number;
	AngularVelocityStrength: number;
	PositionStrength: number;
	VelocityStrength: number;
	MaxLinearForce: number;
	MaxAngularForce: number;
	clone() : PhysicalAnimationData;
	static C(Other: UObject | any): PhysicalAnimationData;
}

declare class PhysicalAnimationProfile { 
	ProfileName: string;
	PhysicalAnimationData: PhysicalAnimationData;
	clone() : PhysicalAnimationProfile;
	static C(Other: UObject | any): PhysicalAnimationProfile;
}

declare class SkeletalBodySetup extends BodySetup { 
	CurrentPhysicalAnimationProfile: PhysicalAnimationProfile;
	bSkipScaleFromAnimation: boolean;
	PhysicalAnimationData: PhysicalAnimationProfile[];
	static Load(ResourceName: string): SkeletalBodySetup;
	static Find(Outer: UObject, ResourceName: string): SkeletalBodySetup;
	static GetDefaultObject(): SkeletalBodySetup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalBodySetup;
	static C(Other: UObject | any): SkeletalBodySetup;
}

declare class ConstraintInstanceBase { 
	clone() : ConstraintInstanceBase;
	static C(Other: UObject | any): ConstraintInstanceBase;
}

declare class ConstraintBaseParams { 
	Stiffness: number;
	Damping: number;
	Restitution: number;
	ContactDistance: number;
	bSoftConstraint: boolean;
	clone() : ConstraintBaseParams;
	static C(Other: UObject | any): ConstraintBaseParams;
}

declare type ELinearConstraintMotion = 'LCM_Free' | 'LCM_Limited' | 'LCM_Locked' | 'LCM_MAX';
declare var ELinearConstraintMotion : { LCM_Free:'LCM_Free',LCM_Limited:'LCM_Limited',LCM_Locked:'LCM_Locked',LCM_MAX:'LCM_MAX', };
declare class LinearConstraint extends ConstraintBaseParams { 
	Limit: number;
	XMotion: ELinearConstraintMotion;
	YMotion: ELinearConstraintMotion;
	ZMotion: ELinearConstraintMotion;
	clone() : LinearConstraint;
	static C(Other: UObject | any): LinearConstraint;
}

declare type EAngularConstraintMotion = 'ACM_Free' | 'ACM_Limited' | 'ACM_Locked' | 'ACM_MAX';
declare var EAngularConstraintMotion : { ACM_Free:'ACM_Free',ACM_Limited:'ACM_Limited',ACM_Locked:'ACM_Locked',ACM_MAX:'ACM_MAX', };
declare class ConeConstraint extends ConstraintBaseParams { 
	Swing1LimitDegrees: number;
	Swing2LimitDegrees: number;
	Swing1Motion: EAngularConstraintMotion;
	Swing2Motion: EAngularConstraintMotion;
	clone() : ConeConstraint;
	static C(Other: UObject | any): ConeConstraint;
}

declare class TwistConstraint extends ConstraintBaseParams { 
	TwistLimitDegrees: number;
	TwistMotion: EAngularConstraintMotion;
	clone() : TwistConstraint;
	static C(Other: UObject | any): TwistConstraint;
}

declare class ConstraintDrive { 
	Stiffness: number;
	Damping: number;
	MaxForce: number;
	bEnablePositionDrive: boolean;
	bEnableVelocityDrive: boolean;
	clone() : ConstraintDrive;
	static C(Other: UObject | any): ConstraintDrive;
}

declare class LinearDriveConstraint { 
	PositionTarget: Vector;
	VelocityTarget: Vector;
	XDrive: ConstraintDrive;
	YDrive: ConstraintDrive;
	ZDrive: ConstraintDrive;
	bEnablePositionDrive: boolean;
	clone() : LinearDriveConstraint;
	static C(Other: UObject | any): LinearDriveConstraint;
}

declare type EAngularDriveMode = 'SLERP' | 'TwistAndSwing' | 'EAngularDriveMode_MAX';
declare var EAngularDriveMode : { SLERP:'SLERP',TwistAndSwing:'TwistAndSwing',EAngularDriveMode_MAX:'EAngularDriveMode_MAX', };
declare class AngularDriveConstraint { 
	TwistDrive: ConstraintDrive;
	SwingDrive: ConstraintDrive;
	SlerpDrive: ConstraintDrive;
	OrientationTarget: Rotator;
	AngularVelocityTarget: Vector;
	AngularDriveMode: EAngularDriveMode;
	clone() : AngularDriveConstraint;
	static C(Other: UObject | any): AngularDriveConstraint;
}

declare type EConstraintPlasticityType = 'CCPT_Free' | 'CCPT_Shrink' | 'CCPT_Grow' | 'CCPT_MAX';
declare var EConstraintPlasticityType : { CCPT_Free:'CCPT_Free',CCPT_Shrink:'CCPT_Shrink',CCPT_Grow:'CCPT_Grow',CCPT_MAX:'CCPT_MAX', };
declare class ConstraintProfileProperties { 
	ProjectionLinearTolerance: number;
	ProjectionAngularTolerance: number;
	ProjectionLinearAlpha: number;
	ProjectionAngularAlpha: number;
	ShockPropagationAlpha: number;
	LinearBreakThreshold: number;
	LinearPlasticityThreshold: number;
	AngularBreakThreshold: number;
	AngularPlasticityThreshold: number;
	ContactTransferScale: number;
	LinearLimit: LinearConstraint;
	ConeLimit: ConeConstraint;
	TwistLimit: TwistConstraint;
	bDisableCollision: boolean;
	bParentDominates: boolean;
	bEnableShockPropagation: boolean;
	bEnableProjection: boolean;
	bAngularBreakable: boolean;
	bAngularPlasticity: boolean;
	bLinearBreakable: boolean;
	bLinearPlasticity: boolean;
	LinearDrive: LinearDriveConstraint;
	AngularDrive: AngularDriveConstraint;
	LinearPlasticityType: EConstraintPlasticityType;
	clone() : ConstraintProfileProperties;
	static C(Other: UObject | any): ConstraintProfileProperties;
}

declare class ConstraintInstance extends ConstraintInstanceBase { 
	JointName: string;
	ConstraintBone1: string;
	ConstraintBone2: string;
	Pos1: Vector;
	PriAxis1: Vector;
	SecAxis1: Vector;
	Pos2: Vector;
	PriAxis2: Vector;
	SecAxis2: Vector;
	AngularRotationOffset: Rotator;
	bScaleLinearLimits: boolean;
	ProfileInstance: ConstraintProfileProperties;
	bDisableCollision: boolean;
	bEnableProjection: boolean;
	ProjectionLinearTolerance: number;
	ProjectionAngularTolerance: number;
	LinearXMotion: ELinearConstraintMotion;
	LinearYMotion: ELinearConstraintMotion;
	LinearZMotion: ELinearConstraintMotion;
	LinearLimitSize: number;
	bLinearLimitSoft: boolean;
	LinearLimitStiffness: number;
	LinearLimitDamping: number;
	bLinearBreakable: boolean;
	LinearBreakThreshold: number;
	AngularSwing1Motion: EAngularConstraintMotion;
	AngularTwistMotion: EAngularConstraintMotion;
	AngularSwing2Motion: EAngularConstraintMotion;
	bSwingLimitSoft: boolean;
	bTwistLimitSoft: boolean;
	Swing1LimitAngle: number;
	TwistLimitAngle: number;
	Swing2LimitAngle: number;
	SwingLimitStiffness: number;
	SwingLimitDamping: number;
	TwistLimitStiffness: number;
	TwistLimitDamping: number;
	bAngularBreakable: boolean;
	AngularBreakThreshold: number;
	bLinearXPositionDrive: boolean;
	bLinearXVelocityDrive: boolean;
	bLinearYPositionDrive: boolean;
	bLinearYVelocityDrive: boolean;
	bLinearZPositionDrive: boolean;
	bLinearZVelocityDrive: boolean;
	bLinearPositionDrive: boolean;
	bLinearVelocityDrive: boolean;
	LinearPositionTarget: Vector;
	LinearVelocityTarget: Vector;
	LinearDriveSpring: number;
	LinearDriveDamping: number;
	LinearDriveForceLimit: number;
	bSwingPositionDrive: boolean;
	bSwingVelocityDrive: boolean;
	bTwistPositionDrive: boolean;
	bTwistVelocityDrive: boolean;
	bAngularSlerpDrive: boolean;
	bAngularOrientationDrive: boolean;
	bEnableSwingDrive: boolean;
	bEnableTwistDrive: boolean;
	bAngularVelocityDrive: boolean;
	AngularPositionTarget: Quat;
	AngularDriveMode: EAngularDriveMode;
	AngularOrientationTarget: Rotator;
	AngularVelocityTarget: Vector;
	AngularDriveSpring: number;
	AngularDriveDamping: number;
	AngularDriveForceLimit: number;
	clone() : ConstraintInstance;
	static C(Other: UObject | any): ConstraintInstance;
}

declare class PhysicsConstraintProfileHandle { 
	ProfileProperties: ConstraintProfileProperties;
	ProfileName: string;
	clone() : PhysicsConstraintProfileHandle;
	static C(Other: UObject | any): PhysicsConstraintProfileHandle;
}

declare class PhysicsConstraintTemplate extends UObject { 
	DefaultInstance: ConstraintInstance;
	ProfileHandles: PhysicsConstraintProfileHandle[];
	DefaultProfile: ConstraintProfileProperties;
	JointName: string;
	ConstraintBone1: string;
	ConstraintBone2: string;
	Pos1: Vector;
	PriAxis1: Vector;
	SecAxis1: Vector;
	Pos2: Vector;
	PriAxis2: Vector;
	SecAxis2: Vector;
	bEnableProjection: boolean;
	ProjectionLinearTolerance: number;
	ProjectionAngularTolerance: number;
	LinearXMotion: ELinearConstraintMotion;
	LinearYMotion: ELinearConstraintMotion;
	LinearZMotion: ELinearConstraintMotion;
	LinearLimitSize: number;
	bLinearLimitSoft: boolean;
	LinearLimitStiffness: number;
	LinearLimitDamping: number;
	bLinearBreakable: boolean;
	LinearBreakThreshold: number;
	AngularSwing1Motion: EAngularConstraintMotion;
	AngularSwing2Motion: EAngularConstraintMotion;
	AngularTwistMotion: EAngularConstraintMotion;
	bSwingLimitSoft: boolean;
	bTwistLimitSoft: boolean;
	Swing1LimitAngle: number;
	Swing2LimitAngle: number;
	TwistLimitAngle: number;
	SwingLimitStiffness: number;
	SwingLimitDamping: number;
	TwistLimitStiffness: number;
	TwistLimitDamping: number;
	bAngularBreakable: boolean;
	AngularBreakThreshold: number;
	static Load(ResourceName: string): PhysicsConstraintTemplate;
	static Find(Outer: UObject, ResourceName: string): PhysicsConstraintTemplate;
	static GetDefaultObject(): PhysicsConstraintTemplate;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicsConstraintTemplate;
	static C(Other: UObject | any): PhysicsConstraintTemplate;
}

declare class PhysicsAssetSolverSettings { 
	PositionIterations: number;
	VelocityIterations: number;
	ProjectionIterations: number;
	CullDistance: number;
	MaxDepenetrationVelocity: number;
	FixedTimeStep: number;
	bUseLinearJointSolver: boolean;
	clone() : PhysicsAssetSolverSettings;
	static C(Other: UObject | any): PhysicsAssetSolverSettings;
}

declare class SolverIterations { 
	SolverIterations: number;
	JointIterations: number;
	CollisionIterations: number;
	SolverPushOutIterations: number;
	JointPushOutIterations: number;
	CollisionPushOutIterations: number;
	clone() : SolverIterations;
	static C(Other: UObject | any): SolverIterations;
}

declare type EPhysicsAssetSolverType = 'RBAN' | 'World' | 'EPhysicsAssetSolverType_MAX';
declare var EPhysicsAssetSolverType : { RBAN:'RBAN',World:'World',EPhysicsAssetSolverType_MAX:'EPhysicsAssetSolverType_MAX', };
declare class ConstraintInstanceAccessor { 
	Owner: UObject;
	Index: number;
	clone() : ConstraintInstanceAccessor;
	static C(Other: UObject | any): ConstraintInstanceAccessor;
	CopyParams(SourceAccessor?: ConstraintInstanceAccessor,bKeepPosition?: boolean,bKeepRotation?: boolean): {Accessor: ConstraintInstanceAccessor, SourceAccessor: ConstraintInstanceAccessor};
	GetAngularBreakable(bAngularBreakable?: boolean,AngularBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor, bAngularBreakable: boolean, AngularBreakThreshold: number};
	GetAngularDriveMode(OutDriveMode?: EAngularDriveMode): {Accessor: ConstraintInstanceAccessor, OutDriveMode: EAngularDriveMode};
	GetAngularDriveParams(OutPositionStrength?: number,OutVelocityStrength?: number,OutForceLimit?: number): {Accessor: ConstraintInstanceAccessor, OutPositionStrength: number, OutVelocityStrength: number, OutForceLimit: number};
	GetAngularLimits(Swing1MotionType?: EAngularConstraintMotion,Swing1LimitAngle?: number,Swing2MotionType?: EAngularConstraintMotion,Swing2LimitAngle?: number,TwistMotionType?: EAngularConstraintMotion,TwistLimitAngle?: number): {Accessor: ConstraintInstanceAccessor, Swing1MotionType: EAngularConstraintMotion, Swing1LimitAngle: number, Swing2MotionType: EAngularConstraintMotion, Swing2LimitAngle: number, TwistMotionType: EAngularConstraintMotion, TwistLimitAngle: number};
	GetAngularOrientationTarget(OutPosTarget?: Rotator): {Accessor: ConstraintInstanceAccessor, OutPosTarget: Rotator};
	GetAngularPlasticity(bAngularPlasticity?: boolean,AngularPlasticityThreshold?: number): {Accessor: ConstraintInstanceAccessor, bAngularPlasticity: boolean, AngularPlasticityThreshold: number};
	GetAngularSoftSwingLimitParams(bSoftSwingLimit?: boolean,SwingLimitStiffness?: number,SwingLimitDamping?: number,SwingLimitRestitution?: number,SwingLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftSwingLimit: boolean, SwingLimitStiffness: number, SwingLimitDamping: number, SwingLimitRestitution: number, SwingLimitContactDistance: number};
	GetAngularSoftTwistLimitParams(bSoftTwistLimit?: boolean,TwistLimitStiffness?: number,TwistLimitDamping?: number,TwistLimitRestitution?: number,TwistLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftTwistLimit: boolean, TwistLimitStiffness: number, TwistLimitDamping: number, TwistLimitRestitution: number, TwistLimitContactDistance: number};
	GetAngularVelocityDriveSLERP(bOutEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableSLERP: boolean};
	GetAngularVelocityDriveTwistAndSwing(bOutEnableTwistDrive?: boolean,bOutEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableTwistDrive: boolean, bOutEnableSwingDrive: boolean};
	GetAngularVelocityTarget(OutVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutVelTarget: Vector};
	GetAttachedBodyNames(ParentBody?: string,ChildBody?: string): {Accessor: ConstraintInstanceAccessor, ParentBody: string, ChildBody: string};
	GetContactTransferScale(ContactTransferScale?: number): {Accessor: ConstraintInstanceAccessor, ContactTransferScale: number};
	GetDisableCollsion(): {Accessor: ConstraintInstanceAccessor, $: boolean};
	GetLinearBreakable(bLinearBreakable?: boolean,LinearBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor, bLinearBreakable: boolean, LinearBreakThreshold: number};
	GetLinearDriveParams(OutPositionStrength?: number,OutVelocityStrength?: number,OutForceLimit?: number): {Accessor: ConstraintInstanceAccessor, OutPositionStrength: number, OutVelocityStrength: number, OutForceLimit: number};
	GetLinearLimits(XMotion?: ELinearConstraintMotion,YMotion?: ELinearConstraintMotion,ZMotion?: ELinearConstraintMotion,Limit?: number): {Accessor: ConstraintInstanceAccessor, XMotion: ELinearConstraintMotion, YMotion: ELinearConstraintMotion, ZMotion: ELinearConstraintMotion, Limit: number};
	GetLinearPlasticity(bLinearPlasticity?: boolean,LinearPlasticityThreshold?: number,PlasticityType?: EConstraintPlasticityType): {Accessor: ConstraintInstanceAccessor, bLinearPlasticity: boolean, LinearPlasticityThreshold: number, PlasticityType: EConstraintPlasticityType};
	GetLinearPositionDrive(bOutEnableDriveX?: boolean,bOutEnableDriveY?: boolean,bOutEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableDriveX: boolean, bOutEnableDriveY: boolean, bOutEnableDriveZ: boolean};
	GetLinearPositionTarget(OutPosTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutPosTarget: Vector};
	GetLinearSoftLimitParams(bSoftLinearLimit?: boolean,LinearLimitStiffness?: number,LinearLimitDamping?: number,LinearLimitRestitution?: number,LinearLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftLinearLimit: boolean, LinearLimitStiffness: number, LinearLimitDamping: number, LinearLimitRestitution: number, LinearLimitContactDistance: number};
	GetLinearVelocityDrive(bOutEnableDriveX?: boolean,bOutEnableDriveY?: boolean,bOutEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableDriveX: boolean, bOutEnableDriveY: boolean, bOutEnableDriveZ: boolean};
	GetLinearVelocityTarget(OutVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutVelTarget: Vector};
	GetOrientationDriveSLERP(bOutEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableSLERP: boolean};
	GetOrientationDriveTwistAndSwing(bOutEnableTwistDrive?: boolean,bOutEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableTwistDrive: boolean, bOutEnableSwingDrive: boolean};
	GetParentDominates(): {Accessor: ConstraintInstanceAccessor, $: boolean};
	GetProjectionParams(bEnableProjection?: boolean,ProjectionLinearAlpha?: number,ProjectionAngularAlpha?: number): {Accessor: ConstraintInstanceAccessor, bEnableProjection: boolean, ProjectionLinearAlpha: number, ProjectionAngularAlpha: number};
	SetAngularBreakable(bAngularBreakable?: boolean,AngularBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularDriveMode(DriveMode?: EAngularDriveMode): {Accessor: ConstraintInstanceAccessor};
	SetAngularDriveParams(PositionStrength?: number,VelocityStrength?: number,InForceLimit?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularLimits(Swing1MotionType?: EAngularConstraintMotion,Swing1LimitAngle?: number,Swing2MotionType?: EAngularConstraintMotion,Swing2LimitAngle?: number,TwistMotionType?: EAngularConstraintMotion,TwistLimitAngle?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularOrientationTarget(InPosTarget?: Rotator): {Accessor: ConstraintInstanceAccessor};
	SetAngularPlasticity(bAngularPlasticity?: boolean,AngularPlasticityThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularSoftSwingLimitParams(bSoftSwingLimit?: boolean,SwingLimitStiffness?: number,SwingLimitDamping?: number,SwingLimitRestitution?: number,SwingLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularSoftTwistLimitParams(bSoftTwistLimit?: boolean,TwistLimitStiffness?: number,TwistLimitDamping?: number,TwistLimitRestitution?: number,TwistLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	SetAngularVelocityDriveSLERP(bEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetAngularVelocityDriveTwistAndSwing(bEnableTwistDrive?: boolean,bEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetAngularVelocityTarget(InVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	SetContactTransferScale(ContactTransferScale?: number): {Accessor: ConstraintInstanceAccessor};
	SetDisableCollision(bDisableCollision?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetLinearBreakable(bLinearBreakable?: boolean,LinearBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	SetLinearDriveParams(PositionStrength?: number,VelocityStrength?: number,InForceLimit?: number): {Accessor: ConstraintInstanceAccessor};
	SetLinearLimits(XMotion?: ELinearConstraintMotion,YMotion?: ELinearConstraintMotion,ZMotion?: ELinearConstraintMotion,Limit?: number): {Accessor: ConstraintInstanceAccessor};
	SetLinearPlasticity(bLinearPlasticity?: boolean,LinearPlasticityThreshold?: number,PlasticityType?: EConstraintPlasticityType): {Accessor: ConstraintInstanceAccessor};
	SetLinearPositionDrive(bEnableDriveX?: boolean,bEnableDriveY?: boolean,bEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetLinearPositionTarget(InPosTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	SetLinearSoftLimitParams(bSoftLinearLimit?: boolean,LinearLimitStiffness?: number,LinearLimitDamping?: number,LinearLimitRestitution?: number,LinearLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	SetLinearVelocityDrive(bEnableDriveX?: boolean,bEnableDriveY?: boolean,bEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetLinearVelocityTarget(InVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	SetOrientationDriveSLERP(bEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetOrientationDriveTwistAndSwing(bEnableTwistDrive?: boolean,bEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetParentDominates(bParentDominates?: boolean): {Accessor: ConstraintInstanceAccessor};
	SetProjectionParams(bEnableProjection?: boolean,ProjectionLinearAlpha?: number,ProjectionAngularAlpha?: number): {Accessor: ConstraintInstanceAccessor};
	static CopyParams(Accessor?: ConstraintInstanceAccessor,SourceAccessor?: ConstraintInstanceAccessor,bKeepPosition?: boolean,bKeepRotation?: boolean): {Accessor: ConstraintInstanceAccessor, SourceAccessor: ConstraintInstanceAccessor};
	static GetAngularBreakable(Accessor?: ConstraintInstanceAccessor,bAngularBreakable?: boolean,AngularBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor, bAngularBreakable: boolean, AngularBreakThreshold: number};
	static GetAngularDriveMode(Accessor?: ConstraintInstanceAccessor,OutDriveMode?: EAngularDriveMode): {Accessor: ConstraintInstanceAccessor, OutDriveMode: EAngularDriveMode};
	static GetAngularDriveParams(Accessor?: ConstraintInstanceAccessor,OutPositionStrength?: number,OutVelocityStrength?: number,OutForceLimit?: number): {Accessor: ConstraintInstanceAccessor, OutPositionStrength: number, OutVelocityStrength: number, OutForceLimit: number};
	static GetAngularLimits(Accessor?: ConstraintInstanceAccessor,Swing1MotionType?: EAngularConstraintMotion,Swing1LimitAngle?: number,Swing2MotionType?: EAngularConstraintMotion,Swing2LimitAngle?: number,TwistMotionType?: EAngularConstraintMotion,TwistLimitAngle?: number): {Accessor: ConstraintInstanceAccessor, Swing1MotionType: EAngularConstraintMotion, Swing1LimitAngle: number, Swing2MotionType: EAngularConstraintMotion, Swing2LimitAngle: number, TwistMotionType: EAngularConstraintMotion, TwistLimitAngle: number};
	static GetAngularOrientationTarget(Accessor?: ConstraintInstanceAccessor,OutPosTarget?: Rotator): {Accessor: ConstraintInstanceAccessor, OutPosTarget: Rotator};
	static GetAngularPlasticity(Accessor?: ConstraintInstanceAccessor,bAngularPlasticity?: boolean,AngularPlasticityThreshold?: number): {Accessor: ConstraintInstanceAccessor, bAngularPlasticity: boolean, AngularPlasticityThreshold: number};
	static GetAngularSoftSwingLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftSwingLimit?: boolean,SwingLimitStiffness?: number,SwingLimitDamping?: number,SwingLimitRestitution?: number,SwingLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftSwingLimit: boolean, SwingLimitStiffness: number, SwingLimitDamping: number, SwingLimitRestitution: number, SwingLimitContactDistance: number};
	static GetAngularSoftTwistLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftTwistLimit?: boolean,TwistLimitStiffness?: number,TwistLimitDamping?: number,TwistLimitRestitution?: number,TwistLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftTwistLimit: boolean, TwistLimitStiffness: number, TwistLimitDamping: number, TwistLimitRestitution: number, TwistLimitContactDistance: number};
	static GetAngularVelocityDriveSLERP(Accessor?: ConstraintInstanceAccessor,bOutEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableSLERP: boolean};
	static GetAngularVelocityDriveTwistAndSwing(Accessor?: ConstraintInstanceAccessor,bOutEnableTwistDrive?: boolean,bOutEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableTwistDrive: boolean, bOutEnableSwingDrive: boolean};
	static GetAngularVelocityTarget(Accessor?: ConstraintInstanceAccessor,OutVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutVelTarget: Vector};
	static GetAttachedBodyNames(Accessor?: ConstraintInstanceAccessor,ParentBody?: string,ChildBody?: string): {Accessor: ConstraintInstanceAccessor, ParentBody: string, ChildBody: string};
	static GetContactTransferScale(Accessor?: ConstraintInstanceAccessor,ContactTransferScale?: number): {Accessor: ConstraintInstanceAccessor, ContactTransferScale: number};
	static GetDisableCollsion(Accessor?: ConstraintInstanceAccessor): {Accessor: ConstraintInstanceAccessor, $: boolean};
	static GetLinearBreakable(Accessor?: ConstraintInstanceAccessor,bLinearBreakable?: boolean,LinearBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor, bLinearBreakable: boolean, LinearBreakThreshold: number};
	static GetLinearDriveParams(Accessor?: ConstraintInstanceAccessor,OutPositionStrength?: number,OutVelocityStrength?: number,OutForceLimit?: number): {Accessor: ConstraintInstanceAccessor, OutPositionStrength: number, OutVelocityStrength: number, OutForceLimit: number};
	static GetLinearLimits(Accessor?: ConstraintInstanceAccessor,XMotion?: ELinearConstraintMotion,YMotion?: ELinearConstraintMotion,ZMotion?: ELinearConstraintMotion,Limit?: number): {Accessor: ConstraintInstanceAccessor, XMotion: ELinearConstraintMotion, YMotion: ELinearConstraintMotion, ZMotion: ELinearConstraintMotion, Limit: number};
	static GetLinearPlasticity(Accessor?: ConstraintInstanceAccessor,bLinearPlasticity?: boolean,LinearPlasticityThreshold?: number,PlasticityType?: EConstraintPlasticityType): {Accessor: ConstraintInstanceAccessor, bLinearPlasticity: boolean, LinearPlasticityThreshold: number, PlasticityType: EConstraintPlasticityType};
	static GetLinearPositionDrive(Accessor?: ConstraintInstanceAccessor,bOutEnableDriveX?: boolean,bOutEnableDriveY?: boolean,bOutEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableDriveX: boolean, bOutEnableDriveY: boolean, bOutEnableDriveZ: boolean};
	static GetLinearPositionTarget(Accessor?: ConstraintInstanceAccessor,OutPosTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutPosTarget: Vector};
	static GetLinearSoftLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftLinearLimit?: boolean,LinearLimitStiffness?: number,LinearLimitDamping?: number,LinearLimitRestitution?: number,LinearLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor, bSoftLinearLimit: boolean, LinearLimitStiffness: number, LinearLimitDamping: number, LinearLimitRestitution: number, LinearLimitContactDistance: number};
	static GetLinearVelocityDrive(Accessor?: ConstraintInstanceAccessor,bOutEnableDriveX?: boolean,bOutEnableDriveY?: boolean,bOutEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableDriveX: boolean, bOutEnableDriveY: boolean, bOutEnableDriveZ: boolean};
	static GetLinearVelocityTarget(Accessor?: ConstraintInstanceAccessor,OutVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor, OutVelTarget: Vector};
	static GetOrientationDriveSLERP(Accessor?: ConstraintInstanceAccessor,bOutEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableSLERP: boolean};
	static GetOrientationDriveTwistAndSwing(Accessor?: ConstraintInstanceAccessor,bOutEnableTwistDrive?: boolean,bOutEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor, bOutEnableTwistDrive: boolean, bOutEnableSwingDrive: boolean};
	static GetParentDominates(Accessor?: ConstraintInstanceAccessor): {Accessor: ConstraintInstanceAccessor, $: boolean};
	static GetProjectionParams(Accessor?: ConstraintInstanceAccessor,bEnableProjection?: boolean,ProjectionLinearAlpha?: number,ProjectionAngularAlpha?: number): {Accessor: ConstraintInstanceAccessor, bEnableProjection: boolean, ProjectionLinearAlpha: number, ProjectionAngularAlpha: number};
	static SetAngularBreakable(Accessor?: ConstraintInstanceAccessor,bAngularBreakable?: boolean,AngularBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularDriveMode(Accessor?: ConstraintInstanceAccessor,DriveMode?: EAngularDriveMode): {Accessor: ConstraintInstanceAccessor};
	static SetAngularDriveParams(Accessor?: ConstraintInstanceAccessor,PositionStrength?: number,VelocityStrength?: number,InForceLimit?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularLimits(Accessor?: ConstraintInstanceAccessor,Swing1MotionType?: EAngularConstraintMotion,Swing1LimitAngle?: number,Swing2MotionType?: EAngularConstraintMotion,Swing2LimitAngle?: number,TwistMotionType?: EAngularConstraintMotion,TwistLimitAngle?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularOrientationTarget(Accessor?: ConstraintInstanceAccessor,InPosTarget?: Rotator): {Accessor: ConstraintInstanceAccessor};
	static SetAngularPlasticity(Accessor?: ConstraintInstanceAccessor,bAngularPlasticity?: boolean,AngularPlasticityThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularSoftSwingLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftSwingLimit?: boolean,SwingLimitStiffness?: number,SwingLimitDamping?: number,SwingLimitRestitution?: number,SwingLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularSoftTwistLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftTwistLimit?: boolean,TwistLimitStiffness?: number,TwistLimitDamping?: number,TwistLimitRestitution?: number,TwistLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	static SetAngularVelocityDriveSLERP(Accessor?: ConstraintInstanceAccessor,bEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetAngularVelocityDriveTwistAndSwing(Accessor?: ConstraintInstanceAccessor,bEnableTwistDrive?: boolean,bEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetAngularVelocityTarget(Accessor?: ConstraintInstanceAccessor,InVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	static SetContactTransferScale(Accessor?: ConstraintInstanceAccessor,ContactTransferScale?: number): {Accessor: ConstraintInstanceAccessor};
	static SetDisableCollision(Accessor?: ConstraintInstanceAccessor,bDisableCollision?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetLinearBreakable(Accessor?: ConstraintInstanceAccessor,bLinearBreakable?: boolean,LinearBreakThreshold?: number): {Accessor: ConstraintInstanceAccessor};
	static SetLinearDriveParams(Accessor?: ConstraintInstanceAccessor,PositionStrength?: number,VelocityStrength?: number,InForceLimit?: number): {Accessor: ConstraintInstanceAccessor};
	static SetLinearLimits(Accessor?: ConstraintInstanceAccessor,XMotion?: ELinearConstraintMotion,YMotion?: ELinearConstraintMotion,ZMotion?: ELinearConstraintMotion,Limit?: number): {Accessor: ConstraintInstanceAccessor};
	static SetLinearPlasticity(Accessor?: ConstraintInstanceAccessor,bLinearPlasticity?: boolean,LinearPlasticityThreshold?: number,PlasticityType?: EConstraintPlasticityType): {Accessor: ConstraintInstanceAccessor};
	static SetLinearPositionDrive(Accessor?: ConstraintInstanceAccessor,bEnableDriveX?: boolean,bEnableDriveY?: boolean,bEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetLinearPositionTarget(Accessor?: ConstraintInstanceAccessor,InPosTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	static SetLinearSoftLimitParams(Accessor?: ConstraintInstanceAccessor,bSoftLinearLimit?: boolean,LinearLimitStiffness?: number,LinearLimitDamping?: number,LinearLimitRestitution?: number,LinearLimitContactDistance?: number): {Accessor: ConstraintInstanceAccessor};
	static SetLinearVelocityDrive(Accessor?: ConstraintInstanceAccessor,bEnableDriveX?: boolean,bEnableDriveY?: boolean,bEnableDriveZ?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetLinearVelocityTarget(Accessor?: ConstraintInstanceAccessor,InVelTarget?: Vector): {Accessor: ConstraintInstanceAccessor};
	static SetOrientationDriveSLERP(Accessor?: ConstraintInstanceAccessor,bEnableSLERP?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetOrientationDriveTwistAndSwing(Accessor?: ConstraintInstanceAccessor,bEnableTwistDrive?: boolean,bEnableSwingDrive?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetParentDominates(Accessor?: ConstraintInstanceAccessor,bParentDominates?: boolean): {Accessor: ConstraintInstanceAccessor};
	static SetProjectionParams(Accessor?: ConstraintInstanceAccessor,bEnableProjection?: boolean,ProjectionLinearAlpha?: number,ProjectionAngularAlpha?: number): {Accessor: ConstraintInstanceAccessor};
}

declare class PhysicsAsset extends UObject { 
	DefaultSkelMesh: SkeletalMesh;
	PreviewSkeletalMesh: SkeletalMesh;
	PhysicalAnimationProfiles: string[];
	ConstraintProfiles: string[];
	CurrentPhysicalAnimationProfileName: string;
	CurrentConstraintProfileName: string;
	BoundsBodies: number[];
	SkeletalBodySetups: SkeletalBodySetup[];
	ConstraintSetup: PhysicsConstraintTemplate[];
	SolverSettings: PhysicsAssetSolverSettings;
	SolverIterations: SolverIterations;
	SolverType: EPhysicsAssetSolverType;
	bNotForDedicatedServer: boolean;
	ThumbnailInfo: ThumbnailInfo;
	BodySetup: BodySetup[];
	static Load(ResourceName: string): PhysicsAsset;
	static Find(Outer: UObject, ResourceName: string): PhysicsAsset;
	static GetDefaultObject(): PhysicsAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicsAsset;
	GetConstraints(bIncludesTerminated: boolean,OutConstraints?: ConstraintInstanceAccessor[]): {OutConstraints: ConstraintInstanceAccessor[]};
	GetConstraintByName(ConstraintName: string): ConstraintInstanceAccessor;
	GetConstraintByBoneNames(Bone1Name: string,Bone2Name: string): ConstraintInstanceAccessor;
	static C(Other: UObject | any): PhysicsAsset;
}

declare class NodeItem { 
	ParentName: string;
	Transform: Transform;
	clone() : NodeItem;
	static C(Other: UObject | any): NodeItem;
}

declare class NodeMappingContainer extends UObject { 
	SourceItems: Map<string, NodeItem>;
	TargetItems: Map<string, NodeItem>;
	SourceToTarget: Map<string, string>;
	SourceAsset: UObject;
	TargetAsset: UObject;
	static Load(ResourceName: string): NodeMappingContainer;
	static Find(Outer: UObject, ResourceName: string): NodeMappingContainer;
	static GetDefaultObject(): NodeMappingContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NodeMappingContainer;
	static C(Other: UObject | any): NodeMappingContainer;
}

declare type EClothLODBiasMode = 'MappingsToSameLOD' | 'MappingsToMinLOD' | 'MappingsToAnyLOD' | 'EClothLODBiasMode_MAX';
declare var EClothLODBiasMode : { MappingsToSameLOD:'MappingsToSameLOD',MappingsToMinLOD:'MappingsToMinLOD',MappingsToAnyLOD:'MappingsToAnyLOD',EClothLODBiasMode_MAX:'EClothLODBiasMode_MAX', };
declare class MorphTarget extends UObject { 
	BaseSkelMesh: SkeletalMesh;
	static Load(ResourceName: string): MorphTarget;
	static Find(Outer: UObject, ResourceName: string): MorphTarget;
	static GetDefaultObject(): MorphTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MorphTarget;
	static C(Other: UObject | any): MorphTarget;
}

declare class ClothPhysicsProperties_Legacy { 
	VerticalResistance: number;
	HorizontalResistance: number;
	BendResistance: number;
	ShearResistance: number;
	Friction: number;
	Damping: number;
	TetherStiffness: number;
	TetherLimit: number;
	Drag: number;
	StiffnessFrequency: number;
	GravityScale: number;
	MassScale: number;
	InertiaBlend: number;
	SelfCollisionThickness: number;
	SelfCollisionSquashScale: number;
	SelfCollisionStiffness: number;
	SolverFrequency: number;
	FiberCompression: number;
	FiberExpansion: number;
	FiberResistance: number;
	clone() : ClothPhysicsProperties_Legacy;
	static C(Other: UObject | any): ClothPhysicsProperties_Legacy;
}

declare class ClothingAssetData_Legacy { 
	AssetName: string;
	ApexFileName: string;
	bClothPropertiesChanged: boolean;
	PhysicsProperties: ClothPhysicsProperties_Legacy;
	clone() : ClothingAssetData_Legacy;
	static C(Other: UObject | any): ClothingAssetData_Legacy;
}

declare class ClothingAssetBase extends UObject { 
	ImportedFilePath: string;
	AssetGuid: Guid;
	static Load(ResourceName: string): ClothingAssetBase;
	static Find(Outer: UObject, ResourceName: string): ClothingAssetBase;
	static GetDefaultObject(): ClothingAssetBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ClothingAssetBase;
	static C(Other: UObject | any): ClothingAssetBase;
}

declare class SkeletalMeshSamplingRegionMaterialFilter { 
	MaterialName: string;
	clone() : SkeletalMeshSamplingRegionMaterialFilter;
	static C(Other: UObject | any): SkeletalMeshSamplingRegionMaterialFilter;
}

declare class SkeletalMeshSamplingRegionBoneFilter { 
	BoneName: string;
	bIncludeOrExclude: boolean;
	bApplyToChildren: boolean;
	clone() : SkeletalMeshSamplingRegionBoneFilter;
	static C(Other: UObject | any): SkeletalMeshSamplingRegionBoneFilter;
}

declare class SkeletalMeshSamplingRegion { 
	Name: string;
	LODIndex: number;
	bSupportUniformlyDistributedSampling: boolean;
	MaterialFilters: SkeletalMeshSamplingRegionMaterialFilter[];
	BoneFilters: SkeletalMeshSamplingRegionBoneFilter[];
	clone() : SkeletalMeshSamplingRegion;
	static C(Other: UObject | any): SkeletalMeshSamplingRegion;
}

declare class SkeletalMeshSamplingLODBuiltData { 
	clone() : SkeletalMeshSamplingLODBuiltData;
	static C(Other: UObject | any): SkeletalMeshSamplingLODBuiltData;
}

declare class SkeletalMeshSamplingRegionBuiltData { 
	clone() : SkeletalMeshSamplingRegionBuiltData;
	static C(Other: UObject | any): SkeletalMeshSamplingRegionBuiltData;
}

declare class SkeletalMeshSamplingBuiltData { 
	WholeMeshBuiltData: SkeletalMeshSamplingLODBuiltData[];
	RegionBuiltData: SkeletalMeshSamplingRegionBuiltData[];
	clone() : SkeletalMeshSamplingBuiltData;
	static C(Other: UObject | any): SkeletalMeshSamplingBuiltData;
}

declare class SkeletalMeshSamplingInfo { 
	Regions: SkeletalMeshSamplingRegion[];
	BuiltData: SkeletalMeshSamplingBuiltData;
	clone() : SkeletalMeshSamplingInfo;
	static C(Other: UObject | any): SkeletalMeshSamplingInfo;
}

declare class SkinWeightProfileInfo { 
	Name: string;
	DefaultProfile: PerPlatformBool;
	DefaultProfileFromLODIndex: PerPlatformInt;
	PerLODSourceFiles: Map<number, string>;
	clone() : SkinWeightProfileInfo;
	static C(Other: UObject | any): SkinWeightProfileInfo;
}

declare class MeshDeformer extends UObject { 
	static Load(ResourceName: string): MeshDeformer;
	static Find(Outer: UObject, ResourceName: string): MeshDeformer;
	static GetDefaultObject(): MeshDeformer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshDeformer;
	static C(Other: UObject | any): MeshDeformer;
}

declare type EPerQualityLevels = 'Low' | 'Medium' | 'High' | 'Epic' | 'Cinematic' | 'Num' | 'EPerQualityLevels_MAX';
declare var EPerQualityLevels : { Low:'Low',Medium:'Medium',High:'High',Epic:'Epic',Cinematic:'Cinematic',Num:'Num',EPerQualityLevels_MAX:'EPerQualityLevels_MAX', };
declare class SkeletalMesh extends SkinnedAsset { 
	MeshEditorDataObject: SkeletalMeshEditorData;
	Skeleton: Skeleton;
	ImportedBounds: BoxSphereBounds;
	ExtendedBounds: BoxSphereBounds;
	PositiveBoundsExtension: Vector;
	NegativeBoundsExtension: Vector;
	Materials: SkeletalMaterial[];
	SkelMirrorTable: BoneMirrorInfo[];
	LODInfo: SkeletalMeshLODInfo[];
	MinQualityLevelLOD: PerQualityLevelInt;
	MinLOD: PerPlatformInt;
	DisableBelowMinLodStripping: PerPlatformBool;
	bOverrideLODStreamingSettings: boolean;
	bSupportLODStreaming: PerPlatformBool;
	MaxNumStreamedLODs: PerPlatformInt;
	MaxNumOptionalLODs: PerPlatformInt;
	LODSettings: SkeletalMeshLODSettings;
	DefaultAnimatingRig: UObject;
	SkelMirrorAxis: EAxis;
	SkelMirrorFlipAxis: EAxis;
	bUseFullPrecisionUVs: boolean;
	bUseHighPrecisionTangentBasis: boolean;
	bHasBeenSimplified: boolean;
	bHasVertexColors: boolean;
	bEnablePerPolyCollision: boolean;
	VertexColorGuid: Guid;
	BodySetup: BodySetup;
	PhysicsAsset: PhysicsAsset;
	ShadowPhysicsAsset: PhysicsAsset;
	NodeMappingData: NodeMappingContainer[];
	AssetImportData: AssetImportData;
	SourceFilePath: string;
	SourceFileTimestamp: string;
	ThumbnailInfo: ThumbnailInfo;
	bHasCustomDefaultEditorCamera: boolean;
	DefaultEditorCameraLocation: Vector;
	DefaultEditorCameraRotation: Rotator;
	DefaultEditorCameraLookAt: Vector;
	DefaultEditorCameraOrthoZoom: number;
	PreviewAttachedAssetContainer: PreviewAssetAttachContainer;
	bSupportRayTracing: boolean;
	RayTracingMinLOD: number;
	ClothLODBiasMode: EClothLODBiasMode;
	MorphTargets: MorphTarget[];
	FloorOffset: number;
	RetargetBasePose: Transform[];
	ClothingAssets: ClothingAssetData_Legacy[];
	PostProcessAnimBlueprint: UnrealEngineClass;
	MeshClothingAssets: ClothingAssetBase[];
	SamplingInfo: SkeletalMeshSamplingInfo;
	AssetUserData: AssetUserData[];
	Sockets: SkeletalMeshSocket[];
	SkinWeightProfiles: SkinWeightProfileInfo[];
	DefaultMeshDeformer: MeshDeformer;
	static Load(ResourceName: string): SkeletalMesh;
	static Find(Outer: UObject, ResourceName: string): SkeletalMesh;
	static GetDefaultObject(): SkeletalMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMesh;
	SetSkeleton(InSkeleton: Skeleton): void;
	SetMorphTargets(InMorphTargets: MorphTarget[]): void;
	SetMinLODForQualityLevels(QualityLevelMinimumLODs: Map<EPerQualityLevels, number>,Default: number): void;
	SetMeshClothingAssets(InMeshClothingAssets: ClothingAssetBase[]): void;
	SetMaterials(InMaterials: SkeletalMaterial[]): void;
	SetLODSettings(InLODSettings: SkeletalMeshLODSettings): void;
	SetDefaultAnimatingRig(InAnimatingRig: UObject): void;
	NumSockets(): number;
	K2_GetAllMorphTargetNames(): string[];
	IsSectionUsingCloth(InSectionIndex: number,bCheckCorrespondingSections: boolean): boolean;
	GetSocketByIndex(Index: number): SkeletalMeshSocket;
	GetSkeleton(): Skeleton;
	GetShadowPhysicsAsset(): PhysicsAsset;
	GetPhysicsAsset(): PhysicsAsset;
	GetNodeMappingData(): NodeMappingContainer[];
	GetNodeMappingContainer(SourceAsset: Blueprint): NodeMappingContainer;
	GetMorphTargetsPtrConv(): MorphTarget[];
	GetMinLODForQualityLevels(QualityLevelMinimumLODs?: Map<EPerQualityLevels, number>,Default?: number): {QualityLevelMinimumLODs: Map<EPerQualityLevels, number>, Default: number};
	GetMeshClothingAssets(): ClothingAssetBase[];
	GetMaterials(): SkeletalMaterial[];
	GetLODSettings(): SkeletalMeshLODSettings;
	GetImportedBounds(): BoxSphereBounds;
	GetDefaultAnimatingRig(): UObject;
	GetBounds(): BoxSphereBounds;
	FindSocketAndIndex(InSocketName: string,OutIndex?: number): {OutIndex: number, $: SkeletalMeshSocket};
	AddSocket(InSocket: SkeletalMeshSocket,bAddToSkeleton: boolean): void;
	static C(Other: UObject | any): SkeletalMesh;
	GetPhysicsBodySetupFromMesh(InName: string): BodySetup;
	CreatePhysicsAsset(): PhysicsAsset;
	GetLodBuildSettings(LODIndex: number,OutBuildOptions?: SkeletalMeshBuildSettings): {OutBuildOptions: SkeletalMeshBuildSettings};
	GetLODCount(): number;
	GetNumVerts(LODIndex: number): number;
	ImportLOD(LODIndex: number,SourceFilename: string): number;
	RegenerateLOD(NewLODCount: number,bRegenerateEvenIfImported: boolean,bGenerateBaseLOD: boolean): boolean;
	ReimportAllCustomLODs(): boolean;
	RemoveLODs(ToRemoveLODs: number[]): boolean;
	RenameSocket(OldName: string,NewName: string): boolean;
	SetLodBuildSettings(LODIndex: number,BuildOptions: SkeletalMeshBuildSettings): void;
	StripLODGeometry(LODIndex: number,TextureMask: Texture2D,Threshold: number): boolean;
	static GetPhysicsBodySetupFromMesh(InSkeletalMesh: SkeletalMesh,InName: string): BodySetup;
	static CreatePhysicsAsset(SkeletalMesh: SkeletalMesh): PhysicsAsset;
	static GetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,OutBuildOptions?: SkeletalMeshBuildSettings): {OutBuildOptions: SkeletalMeshBuildSettings};
	static GetLODCount(SkeletalMesh: SkeletalMesh): number;
	static GetNumVerts(SkeletalMesh: SkeletalMesh,LODIndex: number): number;
	static ImportLOD(BaseMesh: SkeletalMesh,LODIndex: number,SourceFilename: string): number;
	static RegenerateLOD(SkeletalMesh: SkeletalMesh,NewLODCount: number,bRegenerateEvenIfImported: boolean,bGenerateBaseLOD: boolean): boolean;
	static ReimportAllCustomLODs(SkeletalMesh: SkeletalMesh): boolean;
	static RemoveLODs(SkeletalMesh: SkeletalMesh,ToRemoveLODs: number[]): boolean;
	static RenameSocket(SkeletalMesh: SkeletalMesh,OldName: string,NewName: string): boolean;
	static SetLodBuildSettings(SkeletalMesh: SkeletalMesh,LODIndex: number,BuildOptions: SkeletalMeshBuildSettings): void;
	static StripLODGeometry(SkeletalMesh: SkeletalMesh,LODIndex: number,TextureMask: Texture2D,Threshold: number): boolean;
}

declare class MeshDeformerInstanceSettings extends UObject { 
	static Load(ResourceName: string): MeshDeformerInstanceSettings;
	static Find(Outer: UObject, ResourceName: string): MeshDeformerInstanceSettings;
	static GetDefaultObject(): MeshDeformerInstanceSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshDeformerInstanceSettings;
	static C(Other: UObject | any): MeshDeformerInstanceSettings;
}

declare class MeshDeformerInstance extends UObject { 
	static Load(ResourceName: string): MeshDeformerInstance;
	static Find(Outer: UObject, ResourceName: string): MeshDeformerInstance;
	static GetDefaultObject(): MeshDeformerInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshDeformerInstance;
	static C(Other: UObject | any): MeshDeformerInstance;
}

declare class SkelMeshComponentLODInfo { 
	HiddenMaterials: boolean[];
	clone() : SkelMeshComponentLODInfo;
	static C(Other: UObject | any): SkelMeshComponentLODInfo;
}

declare type EVisibilityBasedAnimTickOption = 'AlwaysTickPoseAndRefreshBones' | 'AlwaysTickPose' | 'OnlyTickMontagesWhenNotRendered' | 'OnlyTickPoseWhenRendered' | 'EVisibilityBasedAnimTickOption_MAX';
declare var EVisibilityBasedAnimTickOption : { AlwaysTickPoseAndRefreshBones:'AlwaysTickPoseAndRefreshBones',AlwaysTickPose:'AlwaysTickPose',OnlyTickMontagesWhenNotRendered:'OnlyTickMontagesWhenNotRendered',OnlyTickPoseWhenRendered:'OnlyTickPoseWhenRendered',EVisibilityBasedAnimTickOption_MAX:'EVisibilityBasedAnimTickOption_MAX', };
declare class SkelMeshSkinWeightInfo { 
	Bones: number;
	Weights: number;
	clone() : SkelMeshSkinWeightInfo;
	static C(Other: UObject | any): SkelMeshSkinWeightInfo;
	BreakSkinWeightInfo(Bone0?: number,Weight0?: number,Bone1?: number,Weight1?: number,Bone2?: number,Weight2?: number,Bone3?: number,Weight3?: number): {Bone0: number, Weight0: number, Bone1: number, Weight1: number, Bone2: number, Weight2: number, Bone3: number, Weight3: number};
	static BreakSkinWeightInfo(InWeight: SkelMeshSkinWeightInfo,Bone0?: number,Weight0?: number,Bone1?: number,Weight1?: number,Bone2?: number,Weight2?: number,Bone3?: number,Weight3?: number): {Bone0: number, Weight0: number, Bone1: number, Weight1: number, Bone2: number, Weight2: number, Bone3: number, Weight3: number};
	static MakeSkinWeightInfo(Bone0: number,Weight0: number,Bone1: number,Weight1: number,Bone2: number,Weight2: number,Bone3: number,Weight3: number): SkelMeshSkinWeightInfo;
}

declare type EPhysBodyOp = 'PBO_None' | 'PBO_Term' | 'PBO_MAX';
declare var EPhysBodyOp : { PBO_None:'PBO_None',PBO_Term:'PBO_Term',PBO_MAX:'PBO_MAX', };
declare class SkinnedMeshComponent extends MeshComponent { 
	SkeletalMesh: SkeletalMesh;
	SkinnedAsset: SkinnedAsset;
	LeaderPoseComponent: SkinnedMeshComponent;
	SkinCacheUsage: ESkinCacheUsage[];
	bSetMeshDeformer: boolean;
	MeshDeformer: MeshDeformer;
	MeshDeformerInstanceSettings: MeshDeformerInstanceSettings;
	MeshDeformerInstance: MeshDeformerInstance;
	WireframeColor: Color;
	PhysicsAssetOverride: PhysicsAsset;
	ForcedLodModel: number;
	MinLodModel: number;
	StreamingDistanceMultiplier: number;
	LODInfo: SkelMeshComponentLODInfo[];
	VisibilityBasedAnimTickOption: EVisibilityBasedAnimTickOption;
	bOverrideMinLOD: boolean;
	bUseBoundsFromLeaderPoseComponent: boolean;
	bForceWireframe: boolean;
	bDisplayBones: boolean;
	bDisableMorphTarget: boolean;
	bHideSkin: boolean;
	bPerBoneMotionBlur: boolean;
	bComponentUseFixedSkelBounds: boolean;
	bConsiderAllBodiesForBounds: boolean;
	bSyncAttachParentLOD: boolean;
	bCanHighlightSelectedSections: boolean;
	bRecentlyRendered: boolean;
	bCastCapsuleDirectShadow: boolean;
	bCastCapsuleIndirectShadow: boolean;
	bCPUSkinning: boolean;
	bEnableUpdateRateOptimizations: boolean;
	bDisplayDebugUpdateRateOptimizations: boolean;
	bRenderStatic: boolean;
	bIgnoreLeaderPoseComponentLOD: boolean;
	bCachedLocalBoundsUpToDate: boolean;
	bCachedWorldSpaceBoundsUpToDate: boolean;
	bForceMeshObjectUpdate: boolean;
	bFollowerShouldTickPose: boolean;
	CapsuleIndirectShadowMinVisibility: number;
	CachedWorldOrLocalSpaceBounds: BoxSphereBounds;
	CachedWorldToLocalTransform: Matrix;
	static Load(ResourceName: string): SkinnedMeshComponent;
	static Find(Outer: UObject, ResourceName: string): SkinnedMeshComponent;
	static GetDefaultObject(): SkinnedMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkinnedMeshComponent;
	UnloadSkinWeightProfile(InProfileName: string): void;
	UnHideBoneByName(BoneName: string): void;
	TransformToBoneSpace(BoneName: string,InPosition: Vector,InRotation: Rotator,OutPosition?: Vector,OutRotation?: Rotator): {OutPosition: Vector, OutRotation: Rotator};
	TransformFromBoneSpace(BoneName: string,InPosition: Vector,InRotation: Rotator,OutPosition?: Vector,OutRotation?: Rotator): {OutPosition: Vector, OutRotation: Rotator};
	ShowMaterialSection(MaterialID: number,SectionIndex: number,bShow: boolean,LODIndex: number): void;
	ShowAllMaterialSections(LODIndex: number): void;
	SetVertexOffsetUsage(LODIndex: number,Usage: number): void;
	SetVertexColorOverride_LinearColor(LODIndex: number,VertexColors: LinearColor[]): void;
	SetSkinWeightProfile(InProfileName: string): boolean;
	SetSkinWeightOverride(LODIndex: number,SkinWeights: SkelMeshSkinWeightInfo[]): void;
	SetSkinnedAssetAndUpdate(NewMesh: SkinnedAsset,bReinitPose: boolean): void;
	SetRenderStatic(bNewValue: boolean): void;
	SetPreSkinningOffsets(LODIndex: number,Offsets: Vector[]): void;
	SetPostSkinningOffsets(LODIndex: number,Offsets: Vector[]): void;
	SetPhysicsAsset(NewPhysicsAsset: PhysicsAsset,bForceReInit: boolean): void;
	SetMinLOD(InNewMinLOD: number): void;
	SetMeshDeformer(InMeshDeformer: MeshDeformer): void;
	SetLeaderPoseComponent(NewLeaderBoneComponent: SkinnedMeshComponent,bForceUpdate: boolean,bInFollowerShouldTickPose: boolean): void;
	SetForcedLOD(InNewForcedLOD: number): void;
	SetCastCapsuleIndirectShadow(bNewValue: boolean): void;
	SetCastCapsuleDirectShadow(bNewValue: boolean): void;
	SetCapsuleIndirectShadowMinVisibility(NewValue: number): void;
	IsUsingSkinWeightProfile(): boolean;
	IsMaterialSectionShown(MaterialID: number,LODIndex: number): boolean;
	IsBoneHiddenByName(BoneName: string): boolean;
	HideBoneByName(BoneName: string,PhysBodyOption: EPhysBodyOp): void;
	GetVertexOffsetUsage(LODIndex: number): number;
	GetTwistAndSwingAngleOfDeltaRotationFromRefPose(BoneName: string,OutTwistAngle?: number,OutSwingAngle?: number): {OutTwistAngle: number, OutSwingAngle: number, $: boolean};
	GetSocketBoneName(InSocketName: string): string;
	GetSkinnedAsset(): SkinnedAsset;
	GetSkeletalMesh_DEPRECATED(): SkeletalMesh;
	GetRefPoseTransform(BoneIndex: number): Transform;
	GetRefPosePosition(BoneIndex: number): Vector;
	GetPredictedLODLevel(): number;
	GetParentBone(BoneName: string): string;
	GetNumLODs(): number;
	GetNumBones(): number;
	GetForcedLOD(): number;
	GetDeltaTransformFromRefPose(BoneName: string,BaseName: string): Transform;
	GetCurrentSkinWeightProfileName(): string;
	GetBoneName(BoneIndex: number): string;
	GetBoneIndex(BoneName: string): number;
	FindClosestBone_K2(TestLocation: Vector,BoneLocation?: Vector,IgnoreScale?: number,bRequirePhysicsAsset?: boolean): {BoneLocation: Vector, $: string};
	ClearVertexColorOverride(LODIndex: number): void;
	ClearSkinWeightProfile(): void;
	ClearSkinWeightOverride(LODIndex: number): void;
	BoneIsChildOf(BoneName: string,ParentBoneName: string): boolean;
	static C(Other: UObject | any): SkinnedMeshComponent;
}

declare class SingleAnimationPlayData { 
	AnimToPlay: AnimationAsset;
	bSavedLooping: boolean;
	bSavedPlaying: boolean;
	SavedPosition: number;
	SavedPlayRate: number;
	clone() : SingleAnimationPlayData;
	static C(Other: UObject | any): SingleAnimationPlayData;
}

declare type EKinematicBonesUpdateToPhysics = 'SkipSimulatingBones' | 'SkipAllBones' | 'EKinematicBonesUpdateToPhysics_MAX';
declare var EKinematicBonesUpdateToPhysics : { SkipSimulatingBones:'SkipSimulatingBones',SkipAllBones:'SkipAllBones',EKinematicBonesUpdateToPhysics_MAX:'EKinematicBonesUpdateToPhysics_MAX', };
declare type EPhysicsTransformUpdateMode = 'SimulationUpatesComponentTransform' | 'ComponentTransformIsKinematic' | 'EPhysicsTransformUpdateMode_MAX';
declare var EPhysicsTransformUpdateMode : { SimulationUpatesComponentTransform:'SimulationUpatesComponentTransform',ComponentTransformIsKinematic:'ComponentTransformIsKinematic',EPhysicsTransformUpdateMode_MAX:'EPhysicsTransformUpdateMode_MAX', };
declare type EAnimationMode = 'AnimationBlueprint' | 'AnimationSingleNode' | 'AnimationCustomMode' | 'EAnimationMode_MAX';
declare var EAnimationMode : { AnimationBlueprint:'AnimationBlueprint',AnimationSingleNode:'AnimationSingleNode',AnimationCustomMode:'AnimationCustomMode',EAnimationMode_MAX:'EAnimationMode_MAX', };
declare class ClothingSimulationFactory extends UObject { 
	static Load(ResourceName: string): ClothingSimulationFactory;
	static Find(Outer: UObject, ResourceName: string): ClothingSimulationFactory;
	static GetDefaultObject(): ClothingSimulationFactory;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ClothingSimulationFactory;
	static C(Other: UObject | any): ClothingSimulationFactory;
}

declare class ClothingInteractor extends UObject { 
	static Load(ResourceName: string): ClothingInteractor;
	static Find(Outer: UObject, ResourceName: string): ClothingInteractor;
	static GetDefaultObject(): ClothingInteractor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ClothingInteractor;
	static C(Other: UObject | any): ClothingInteractor;
}

declare class ClothingSimulationInteractor extends UObject { 
	ClothingInteractors: Map<string, ClothingInteractor>;
	static Load(ResourceName: string): ClothingSimulationInteractor;
	static Find(Outer: UObject, ResourceName: string): ClothingSimulationInteractor;
	static GetDefaultObject(): ClothingSimulationInteractor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ClothingSimulationInteractor;
	SetNumSubsteps(NumSubsteps: number): void;
	SetNumIterations(NumIterations: number): void;
	SetMaxNumIterations(MaxNumIterations: number): void;
	SetAnimDriveSpringStiffness(InStiffness: number): void;
	PhysicsAssetUpdated(): void;
	GetSimulationTime(): number;
	GetNumSubsteps(): number;
	GetNumKinematicParticles(): number;
	GetNumIterations(): number;
	GetNumDynamicParticles(): number;
	GetNumCloths(): number;
	GetClothingInteractor(ClothingAssetName: string): ClothingInteractor;
	EnableGravityOverride(InVector: Vector): void;
	DisableGravityOverride(): void;
	ClothConfigUpdated(): void;
	static C(Other: UObject | any): ClothingSimulationInteractor;
}

declare type ECustomBoneAttributeLookup = 'BoneOnly' | 'ImmediateParent' | 'ParentHierarchy' | 'ECustomBoneAttributeLookup_MAX';
declare var ECustomBoneAttributeLookup : { BoneOnly:'BoneOnly',ImmediateParent:'ImmediateParent',ParentHierarchy:'ParentHierarchy',ECustomBoneAttributeLookup_MAX:'ECustomBoneAttributeLookup_MAX', };
declare type ERelativeTransformSpace = 'RTS_World' | 'RTS_Actor' | 'RTS_Component' | 'RTS_ParentBoneSpace' | 'RTS_MAX';
declare var ERelativeTransformSpace : { RTS_World:'RTS_World',RTS_Actor:'RTS_Actor',RTS_Component:'RTS_Component',RTS_ParentBoneSpace:'RTS_ParentBoneSpace',RTS_MAX:'RTS_MAX', };
declare class SkeletalMeshComponent extends SkinnedMeshComponent { 
	SkeletalMeshAsset: SkeletalMesh;
	AnimationBlueprint: AnimBlueprint;
	AnimBlueprintGeneratedClass: UnrealEngineClass;
	AnimClass: UnrealEngineClass;
	AnimScriptInstance: AnimInstance;
	SubInstances: AnimInstance[];
	PostProcessAnimInstance: AnimInstance;
	AnimationData: SingleAnimationPlayData;
	RootBoneTranslation: Vector;
	LineCheckBoundsScale: Vector;
	LinkedInstances: AnimInstance[];
	CachedBoneSpaceTransforms: Transform[];
	CachedComponentSpaceTransforms: Transform[];
	GlobalAnimRateScale: number;
	KinematicBonesUpdateType: EKinematicBonesUpdateToPhysics;
	PhysicsTransformUpdateMode: EPhysicsTransformUpdateMode;
	AnimationMode: EAnimationMode;
	bDisablePostProcessBlueprint: boolean;
	bUpdateOverlapsOnAnimationFinalize: boolean;
	bHasValidBodies: boolean;
	bBlendPhysics: boolean;
	bEnablePhysicsOnDedicatedServer: boolean;
	bUpdateMeshWhenKinematic: boolean;
	bUpdateJointsFromAnimation: boolean;
	bAllowClothActors: boolean;
	bDisableClothSimulation: boolean;
	bDisableRigidBodyAnimNode: boolean;
	bAllowAnimCurveEvaluation: boolean;
	bDisableAnimCurves: boolean;
	bCollideWithEnvironment: boolean;
	bCollideWithAttachedChildren: boolean;
	bForceCollisionUpdate: boolean;
	bLocalSpaceSimulation: boolean;
	bResetAfterTeleport: boolean;
	bDeferKinematicBoneUpdate: boolean;
	bNoSkeletonUpdate: boolean;
	bPauseAnims: boolean;
	bUseRefPoseOnInitAnim: boolean;
	bEnablePerPolyCollision: boolean;
	bForceRefpose: boolean;
	bOnlyAllowAutonomousTickPose: boolean;
	bIsAutonomousTickPose: boolean;
	bOldForceRefPose: boolean;
	bShowPrePhysBones: boolean;
	bRequiredBonesUpToDate: boolean;
	bAnimTreeInitialised: boolean;
	bIncludeComponentLocationIntoBounds: boolean;
	bEnableLineCheckWithBounds: boolean;
	bPropagateCurvesToFollowers: boolean;
	bSkipKinematicUpdateWhenInterpolating: boolean;
	bSkipBoundsUpdateWhenInterpolating: boolean;
	bUpdateAnimationInEditor: boolean;
	bUpdateClothInEditor: boolean;
	bOverrideDefaultAnimatingRig: boolean;
	bNeedsQueuedAnimEventsDispatched: boolean;
	CachedAnimCurveUidVersion: number;
	ClothBlendWeight: number;
	bWaitForParallelClothTask: boolean;
	DisallowedAnimCurves: string[];
	BodySetup: BodySetup;
	ClothMaxDistanceScale: number;
	OnConstraintBroken: UnrealEngineMulticastDelegate<(ConstraintIndex: number) => void>;
	OnPlasticDeformation: UnrealEngineMulticastDelegate<(ConstraintIndex: number) => void>;
	ClothingSimulationFactory: UnrealEngineClass;
	TeleportDistanceThreshold: number;
	TeleportRotationThreshold: number;
	LastPoseTickFrame: number;
	ClothingInteractor: ClothingSimulationInteractor;
	OnAnimInitialized: UnrealEngineMulticastDelegate<() => void>;
	SequenceToPlay: AnimSequence;
	AnimToPlay: AnimationAsset;
	bDefaultLooping: boolean;
	bDefaultPlaying: boolean;
	DefaultPosition: number;
	DefaultPlayRate: number;
	DefaultAnimatingRigOverride: UObject;
	static Load(ResourceName: string): SkeletalMeshComponent;
	static Find(Outer: UObject, ResourceName: string): SkeletalMeshComponent;
	static GetDefaultObject(): SkeletalMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SkeletalMeshComponent;
	UnlinkAnimClassLayers(InClass: UnrealEngineClass): void;
	UnbindClothFromLeaderPoseComponent(bRestoreSimulationSpace: boolean): void;
	ToggleDisablePostProcessBlueprint(): void;
	TermBodiesBelow(ParentBoneName: string): void;
	SuspendClothingSimulation(): void;
	Stop(): void;
	SnapshotPose(Snapshot?: PoseSnapshot): {Snapshot: PoseSnapshot};
	SetUpdateClothInEditor(NewUpdateState: boolean): void;
	SetUpdateAnimationInEditor(NewUpdateState: boolean): void;
	SetTeleportRotationThreshold(Threshold: number): void;
	SetTeleportDistanceThreshold(Threshold: number): void;
	SetSkeletalMeshAsset(NewMesh: SkeletalMesh): void;
	SetPosition(InPos: number,bFireNotifies: boolean): void;
	SetPlayRate(Rate: number): void;
	SetPhysicsBlendWeight(PhysicsBlendWeight: number): void;
	SetNotifyRigidBodyCollisionBelow(bNewNotifyRigidBodyCollision: boolean,BoneName: string,bIncludeSelf: boolean): void;
	SetMorphTarget(MorphTargetName: string,Value: number,bRemoveZeroWeight: boolean): void;
	SetEnablePhysicsBlending(bNewBlendPhysics: boolean): void;
	SetEnableGravityOnAllBodiesBelow(bEnableGravity: boolean,BoneName: string,bIncludeSelf: boolean): void;
	SetEnableBodyGravity(bEnableGravity: boolean,BoneName: string): void;
	SetDisablePostProcessBlueprint(bInDisablePostProcess: boolean): void;
	SetDisableAnimCurves(bInDisableAnimCurves: boolean): void;
	SetDefaultAnimatingRigOverride(InAnimatingRig: UObject): void;
	SetConstraintProfileForAll(ProfileName: string,bDefaultIfNotFound: boolean): void;
	SetConstraintProfile(JointName: string,ProfileName: string,bDefaultIfNotFound: boolean): void;
	SetClothMaxDistanceScale(Scale: number): void;
	SetBodyNotifyRigidBodyCollision(bNewNotifyRigidBodyCollision: boolean,BoneName: string): void;
	SetAnimClass(NewClass: UnrealEngineClass): void;
	SetAnimationMode(InAnimationMode: EAnimationMode): void;
	SetAnimation(NewAnimToPlay: AnimationAsset): void;
	SetAngularLimits(InBoneName: string,Swing1LimitAngle: number,TwistLimitAngle: number,Swing2LimitAngle: number): void;
	SetAllowRigidBodyAnimNode(bInAllow: boolean,bReinitAnim: boolean): void;
	SetAllowedAnimCurvesEvaluation(List: string[],bAllow: boolean): void;
	SetAllowClothActors(bInAllow: boolean): void;
	SetAllowAnimCurveEvaluation(bInAllow: boolean): void;
	SetAllMotorsAngularVelocityDrive(bEnableSwingDrive: boolean,bEnableTwistDrive: boolean,bSkipCustomPhysicsType: boolean): void;
	SetAllMotorsAngularPositionDrive(bEnableSwingDrive: boolean,bEnableTwistDrive: boolean,bSkipCustomPhysicsType: boolean): void;
	SetAllMotorsAngularDriveParams(InSpring: number,InDamping: number,InForceLimit: number,bSkipCustomPhysicsType: boolean): void;
	SetAllBodiesSimulatePhysics(bNewSimulate: boolean): void;
	SetAllBodiesPhysicsBlendWeight(PhysicsBlendWeight: number,bSkipCustomPhysicsType: boolean): void;
	SetAllBodiesBelowSimulatePhysics(InBoneName: string,bNewSimulate: boolean,bIncludeSelf: boolean): void;
	SetAllBodiesBelowPhysicsDisabled(InBoneName: string,bDisabled: boolean,bIncludeSelf: boolean): void;
	SetAllBodiesBelowPhysicsBlendWeight(InBoneName: string,PhysicsBlendWeight: number,bSkipCustomPhysicsType: boolean,bIncludeSelf: boolean): void;
	SetAllBodiesBelowLinearVelocity(InBoneName: string,LinearVelocity: Vector,bIncludeSelf: boolean): void;
	ResumeClothingSimulation(): void;
	ResetClothTeleportMode(): void;
	ResetAnimInstanceDynamics(InTeleportType: ETeleportType): void;
	ResetAllowedAnimCurveEvaluation(): void;
	ResetAllBodiesSimulatePhysics(): void;
	PlayAnimation(NewAnimToPlay: AnimationAsset,bLooping: boolean): void;
	Play(bLooping: boolean): void;
	OverrideAnimationData(InAnimToPlay: AnimationAsset,bIsLooping: boolean,bIsPlaying: boolean,Position: number,PlayRate: number): void;
	LinkAnimGraphByTag(InTag: string,InClass: UnrealEngineClass): void;
	LinkAnimClassLayers(InClass: UnrealEngineClass): void;
	K2_GetClosestPointOnPhysicsAsset(WorldPosition: Vector,ClosestWorldPosition?: Vector,Normal?: Vector,BoneName?: string,Distance?: number): {ClosestWorldPosition: Vector, Normal: Vector, BoneName: string, Distance: number, $: boolean};
	IsPlaying(): boolean;
	IsClothingSimulationSuspended(): boolean;
	IsBodyGravityEnabled(BoneName: string): boolean;
	HasValidAnimationInstance(): boolean;
	GetTransformAttribute_Ref(BoneName: string,AttributeName: string,OutValue?: Transform,LookupType?: ECustomBoneAttributeLookup): {OutValue: Transform, $: boolean};
	GetTransformAttribute(BoneName: string,AttributeName: string,DefaultValue: Transform,OutValue?: Transform,LookupType?: ECustomBoneAttributeLookup): {OutValue: Transform, $: boolean};
	GetTeleportRotationThreshold(): number;
	GetTeleportDistanceThreshold(): number;
	GetStringAttribute_Ref(BoneName: string,AttributeName: string,OutValue?: string,LookupType?: ECustomBoneAttributeLookup): {OutValue: string, $: boolean};
	GetStringAttribute(BoneName: string,AttributeName: string,DefaultValue: string,OutValue?: string,LookupType?: ECustomBoneAttributeLookup): {OutValue: string, $: boolean};
	GetSkeletalMeshAsset(): SkeletalMesh;
	GetSkeletalCenterOfMass(): Vector;
	GetPostProcessInstance(): AnimInstance;
	GetPosition(): number;
	GetPlayRate(): number;
	GetMorphTarget(MorphTargetName: string): number;
	GetLinkedAnimLayerInstanceByGroup(InGroup: string): AnimInstance;
	GetLinkedAnimLayerInstanceByClass(InClass: UnrealEngineClass): AnimInstance;
	GetLinkedAnimGraphInstancesByTag(InTag: string,OutLinkedInstances?: AnimInstance[]): {OutLinkedInstances: AnimInstance[]};
	GetLinkedAnimGraphInstanceByTag(InTag: string): AnimInstance;
	GetIntegerAttribute_Ref(BoneName: string,AttributeName: string,OutValue?: number,LookupType?: ECustomBoneAttributeLookup): {OutValue: number, $: boolean};
	GetIntegerAttribute(BoneName: string,AttributeName: string,DefaultValue: number,OutValue?: number,LookupType?: ECustomBoneAttributeLookup): {OutValue: number, $: boolean};
	GetFloatAttribute_Ref(BoneName: string,AttributeName: string,OutValue?: number,LookupType?: ECustomBoneAttributeLookup): {OutValue: number, $: boolean};
	GetFloatAttribute(BoneName: string,AttributeName: string,DefaultValue: number,OutValue?: number,LookupType?: ECustomBoneAttributeLookup): {OutValue: number, $: boolean};
	GetDisablePostProcessBlueprint(): boolean;
	GetDisableAnimCurves(): boolean;
	GetDefaultAnimatingRigOverride(): UObject;
	GetDefaultAnimatingRig(): UObject;
	GetCurrentJointAngles(InBoneName: string,Swing1Angle?: number,TwistAngle?: number,Swing2Angle?: number): {Swing1Angle: number, TwistAngle: number, Swing2Angle: number};
	GetConstraintsFromBody(BodyName: string,bParentConstraints: boolean,bChildConstraints: boolean,bIncludesTerminated: boolean,OutConstraints?: ConstraintInstanceAccessor[]): {OutConstraints: ConstraintInstanceAccessor[]};
	GetConstraints(bIncludesTerminated: boolean,OutConstraints?: ConstraintInstanceAccessor[]): {OutConstraints: ConstraintInstanceAccessor[]};
	GetConstraintByName(ConstraintName: string,bIncludesTerminated: boolean): ConstraintInstanceAccessor;
	GetClothMaxDistanceScale(): number;
	GetClothingSimulationInteractor(): ClothingSimulationInteractor;
	GetBoneMass(BoneName: string,bScaleMass: boolean): number;
	GetBoneLinearVelocity(InBoneName: string): Vector;
	GetAnimInstance(): AnimInstance;
	GetAnimClass(): UnrealEngineClass;
	GetAnimationMode(): EAnimationMode;
	GetAllowRigidBodyAnimNode(): boolean;
	GetAllowedAnimCurveEvaluate(): boolean;
	GetAllowClothActors(): boolean;
	ForceClothNextUpdateTeleportAndReset(): void;
	ForceClothNextUpdateTeleport(): void;
	FindConstraintBoneName(ConstraintIndex: number): string;
	ClearMorphTargets(): void;
	BreakConstraint(Impulse: Vector,HitLocation: Vector,InBoneName: string): void;
	BindClothToLeaderPoseComponent(): void;
	AllowAnimCurveEvaluation(NameOfCurve: string,bAllow: boolean): void;
	AddImpulseToAllBodiesBelow(Impulse: Vector,BoneName: string,bVelChange: boolean,bIncludeSelf: boolean): void;
	AddForceToAllBodiesBelow(Force: Vector,BoneName: string,bAccelChange: boolean,bIncludeSelf: boolean): void;
	AccumulateAllBodiesBelowPhysicsBlendWeight(InBoneName: string,AddPhysicsBlendWeight: number,bSkipCustomPhysicsType: boolean): void;
	static C(Other: UObject | any): SkeletalMeshComponent;
	GetPhysicsBodySetup(InName: string): BodySetup;
	K2_DirectionBetweenSockets(SocketOrBoneNameFrom: string,SocketOrBoneNameTo: string): Vector;
	K2_DistanceBetweenTwoSocketsAndMapRange(SocketOrBoneNameA: string,SocketSpaceA: ERelativeTransformSpace,SocketOrBoneNameB: string,SocketSpaceB: ERelativeTransformSpace,bRemapRange: boolean,InRangeMin: number,InRangeMax: number,OutRangeMin: number,OutRangeMax: number): number;
	static GetPhysicsBodySetup(InSkeletalMeshComp: SkeletalMeshComponent,InName: string): BodySetup;
	static K2_DirectionBetweenSockets(Component: SkeletalMeshComponent,SocketOrBoneNameFrom: string,SocketOrBoneNameTo: string): Vector;
	static K2_DistanceBetweenTwoSocketsAndMapRange(Component: SkeletalMeshComponent,SocketOrBoneNameA: string,SocketSpaceA: ERelativeTransformSpace,SocketOrBoneNameB: string,SocketSpaceB: ERelativeTransformSpace,bRemapRange: boolean,InRangeMin: number,InRangeMax: number,OutRangeMin: number,OutRangeMax: number): number;
}

declare type EMovementMode = 'MOVE_None' | 'MOVE_Walking' | 'MOVE_NavWalking' | 'MOVE_Falling' | 'MOVE_Swimming' | 'MOVE_Flying' | 'MOVE_Custom' | 'MOVE_MAX';
declare var EMovementMode : { MOVE_None:'MOVE_None',MOVE_Walking:'MOVE_Walking',MOVE_NavWalking:'MOVE_NavWalking',MOVE_Falling:'MOVE_Falling',MOVE_Swimming:'MOVE_Swimming',MOVE_Flying:'MOVE_Flying',MOVE_Custom:'MOVE_Custom',MOVE_MAX:'MOVE_MAX', };
declare type ENetworkSmoothingMode = 'Disabled' | 'Linear' | 'Exponential' | 'ENetworkSmoothingMode_MAX';
declare var ENetworkSmoothingMode : { Disabled:'Disabled',Linear:'Linear',Exponential:'Exponential',ENetworkSmoothingMode_MAX:'ENetworkSmoothingMode_MAX', };
declare class FindFloorResult { 
	bBlockingHit: boolean;
	bWalkableFloor: boolean;
	bLineTrace: boolean;
	FloorDist: number;
	LineDist: number;
	HitResult: HitResult;
	clone() : FindFloorResult;
	static C(Other: UObject | any): FindFloorResult;
}

declare class NavAvoidanceMask { 
	bGroup0: boolean;
	bGroup1: boolean;
	bGroup2: boolean;
	bGroup3: boolean;
	bGroup4: boolean;
	bGroup5: boolean;
	bGroup6: boolean;
	bGroup7: boolean;
	bGroup8: boolean;
	bGroup9: boolean;
	bGroup10: boolean;
	bGroup11: boolean;
	bGroup12: boolean;
	bGroup13: boolean;
	bGroup14: boolean;
	bGroup15: boolean;
	bGroup16: boolean;
	bGroup17: boolean;
	bGroup18: boolean;
	bGroup19: boolean;
	bGroup20: boolean;
	bGroup21: boolean;
	bGroup22: boolean;
	bGroup23: boolean;
	bGroup24: boolean;
	bGroup25: boolean;
	bGroup26: boolean;
	bGroup27: boolean;
	bGroup28: boolean;
	bGroup29: boolean;
	bGroup30: boolean;
	bGroup31: boolean;
	clone() : NavAvoidanceMask;
	static C(Other: UObject | any): NavAvoidanceMask;
}

declare class CharacterMovementComponentPostPhysicsTickFunction extends TickFunction { 
	clone() : CharacterMovementComponentPostPhysicsTickFunction;
	static C(Other: UObject | any): CharacterMovementComponentPostPhysicsTickFunction;
}

declare class RootMotionSourceSettings { 
	Flags: number;
	clone() : RootMotionSourceSettings;
	static C(Other: UObject | any): RootMotionSourceSettings;
}

declare class Vector_NetQuantize10 extends Vector { 
	clone() : Vector_NetQuantize10;
	static C(Other: UObject | any): Vector_NetQuantize10;
	BreakVector_NetQuantize10(X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static BreakVector_NetQuantize10(InVec: Vector_NetQuantize10,X?: number,Y?: number,Z?: number): {X: number, Y: number, Z: number};
	static MakeVector_NetQuantize10(X: number,Y: number,Z: number): Vector_NetQuantize10;
}

declare class RootMotionSourceGroup { 
	bHasAdditiveSources: boolean;
	bHasOverrideSources: boolean;
	bHasOverrideSourcesWithIgnoreZAccumulate: boolean;
	bIsAdditiveVelocityApplied: boolean;
	LastAccumulatedSettings: RootMotionSourceSettings;
	LastPreAdditiveVelocity: Vector_NetQuantize10;
	clone() : RootMotionSourceGroup;
	static C(Other: UObject | any): RootMotionSourceGroup;
}

declare class RootMotionMovementParams { 
	bHasRootMotion: boolean;
	BlendWeight: number;
	RootMotionTransform: Transform;
	clone() : RootMotionMovementParams;
	static C(Other: UObject | any): RootMotionMovementParams;
}

declare class CharacterMovementComponent extends PawnMovementComponent { 
	CharacterOwner: Character;
	GravityScale: number;
	MaxStepHeight: number;
	JumpZVelocity: number;
	JumpOffJumpZFactor: number;
	WalkableFloorAngle: number;
	WalkableFloorZ: number;
	MovementMode: EMovementMode;
	CustomMovementMode: number;
	NetworkSmoothingMode: ENetworkSmoothingMode;
	GroundFriction: number;
	MaxWalkSpeed: number;
	MaxWalkSpeedCrouched: number;
	MaxSwimSpeed: number;
	MaxFlySpeed: number;
	MaxCustomMovementSpeed: number;
	MaxAcceleration: number;
	MinAnalogWalkSpeed: number;
	BrakingFrictionFactor: number;
	BrakingFriction: number;
	BrakingSubStepTime: number;
	BrakingDecelerationWalking: number;
	BrakingDecelerationFalling: number;
	BrakingDecelerationSwimming: number;
	BrakingDecelerationFlying: number;
	AirControl: number;
	AirControlBoostMultiplier: number;
	AirControlBoostVelocityThreshold: number;
	FallingLateralFriction: number;
	CrouchedHalfHeight: number;
	Buoyancy: number;
	PerchRadiusThreshold: number;
	PerchAdditionalHeight: number;
	RotationRate: Rotator;
	bUseSeparateBrakingFriction: boolean;
	bApplyGravityWhileJumping: boolean;
	bUseControllerDesiredRotation: boolean;
	bOrientRotationToMovement: boolean;
	bSweepWhileNavWalking: boolean;
	bMovementInProgress: boolean;
	bEnableScopedMovementUpdates: boolean;
	bEnableServerDualMoveScopedMovementUpdates: boolean;
	bForceMaxAccel: boolean;
	bRunPhysicsWithNoController: boolean;
	bForceNextFloorCheck: boolean;
	bShrinkProxyCapsule: boolean;
	bCanWalkOffLedges: boolean;
	bCanWalkOffLedgesWhenCrouching: boolean;
	bNetworkSkipProxyPredictionOnNetUpdate: boolean;
	bNetworkAlwaysReplicateTransformUpdateTimestamp: boolean;
	bDeferUpdateMoveComponent: boolean;
	bEnablePhysicsInteraction: boolean;
	bTouchForceScaledToMass: boolean;
	bPushForceScaledToMass: boolean;
	bPushForceUsingZOffset: boolean;
	bScalePushForceToVelocity: boolean;
	DeferredUpdatedMoveComponent: SceneComponent;
	MaxOutOfWaterStepHeight: number;
	OutofWaterZ: number;
	Mass: number;
	StandingDownwardForceScale: number;
	InitialPushForceFactor: number;
	PushForceFactor: number;
	PushForcePointZOffsetFactor: number;
	TouchForceFactor: number;
	MinTouchForce: number;
	MaxTouchForce: number;
	RepulsionForce: number;
	bForceBraking: boolean;
	CrouchedSpeedMultiplier: number;
	UpperImpactNormalScale: number;
	Acceleration: Vector;
	LastUpdateRotation: Quat;
	LastUpdateLocation: Vector;
	LastUpdateVelocity: Vector;
	ServerLastTransformUpdateTimeStamp: number;
	ServerLastClientGoodMoveAckTime: number;
	ServerLastClientAdjustmentTime: number;
	PendingImpulseToApply: Vector;
	PendingForceToApply: Vector;
	AnalogInputModifier: number;
	MaxSimulationTimeStep: number;
	MaxSimulationIterations: number;
	MaxJumpApexAttemptsPerSimulation: number;
	MaxDepenetrationWithGeometry: number;
	MaxDepenetrationWithGeometryAsProxy: number;
	MaxDepenetrationWithPawn: number;
	MaxDepenetrationWithPawnAsProxy: number;
	NetworkSimulatedSmoothLocationTime: number;
	NetworkSimulatedSmoothRotationTime: number;
	ListenServerNetworkSimulatedSmoothLocationTime: number;
	ListenServerNetworkSimulatedSmoothRotationTime: number;
	NetProxyShrinkRadius: number;
	NetProxyShrinkHalfHeight: number;
	NetworkMaxSmoothUpdateDistance: number;
	NetworkNoSmoothUpdateDistance: number;
	NetworkMinTimeBetweenClientAckGoodMoves: number;
	NetworkMinTimeBetweenClientAdjustments: number;
	NetworkMinTimeBetweenClientAdjustmentsLargeCorrection: number;
	NetworkLargeClientCorrectionDistance: number;
	LedgeCheckThreshold: number;
	JumpOutOfWaterPitch: number;
	CurrentFloor: FindFloorResult;
	DefaultLandMovementMode: EMovementMode;
	DefaultWaterMovementMode: EMovementMode;
	GroundMovementMode: EMovementMode;
	bMaintainHorizontalGroundVelocity: boolean;
	bImpartBaseVelocityX: boolean;
	bImpartBaseVelocityY: boolean;
	bImpartBaseVelocityZ: boolean;
	bImpartBaseAngularVelocity: boolean;
	bJustTeleported: boolean;
	bNetworkUpdateReceived: boolean;
	bNetworkMovementModeChanged: boolean;
	bIgnoreClientMovementErrorChecksAndCorrection: boolean;
	bServerAcceptClientAuthoritativePosition: boolean;
	bNotifyApex: boolean;
	bCheatFlying: boolean;
	bWantsToCrouch: boolean;
	bCrouchMaintainsBaseLocation: boolean;
	bIgnoreBaseRotation: boolean;
	bFastAttachedMove: boolean;
	bAlwaysCheckFloor: boolean;
	bUseFlatBaseForFloorChecks: boolean;
	bPerformingJumpOff: boolean;
	bWantsToLeaveNavWalking: boolean;
	bUseRVOAvoidance: boolean;
	bRequestedMoveUseAcceleration: boolean;
	bWasSimulatingRootMotion: boolean;
	bAllowPhysicsRotationDuringAnimRootMotion: boolean;
	FormerBaseVelocityDecayHalfLife: number;
	bHasRequestedVelocity: boolean;
	bRequestedMoveWithMaxSpeed: boolean;
	bWasAvoidanceUpdated: boolean;
	bProjectNavMeshWalking: boolean;
	bProjectNavMeshOnBothWorldChannels: boolean;
	AvoidanceConsiderationRadius: number;
	RequestedVelocity: Vector;
	LastUpdateRequestedVelocity: Vector;
	AvoidanceUID: number;
	AvoidanceGroup: NavAvoidanceMask;
	GroupsToAvoid: NavAvoidanceMask;
	GroupsToIgnore: NavAvoidanceMask;
	AvoidanceWeight: number;
	PendingLaunchVelocity: Vector;
	NavMeshProjectionInterval: number;
	NavMeshProjectionTimer: number;
	NavMeshProjectionInterpSpeed: number;
	NavMeshProjectionHeightScaleUp: number;
	NavMeshProjectionHeightScaleDown: number;
	NavWalkingFloorDistTolerance: number;
	PostPhysicsTickFunction: CharacterMovementComponentPostPhysicsTickFunction;
	MinTimeBetweenTimeStampResets: number;
	CurrentRootMotion: RootMotionSourceGroup;
	ServerCorrectionRootMotion: RootMotionSourceGroup;
	RootMotionParams: RootMotionMovementParams;
	AnimRootMotionVelocity: Vector;
	static Load(ResourceName: string): CharacterMovementComponent;
	static Find(Outer: UObject, ResourceName: string): CharacterMovementComponent;
	static GetDefaultObject(): CharacterMovementComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CharacterMovementComponent;
	SetWalkableFloorZ(InWalkableFloorZ: number): void;
	SetWalkableFloorAngle(InWalkableFloorAngle: number): void;
	SetMovementMode(NewMovementMode: EMovementMode,NewCustomMode: number): void;
	SetGroupsToIgnoreMask(GroupMask: NavAvoidanceMask): void;
	SetGroupsToIgnore(GroupFlags: number): void;
	SetGroupsToAvoidMask(GroupMask: NavAvoidanceMask): void;
	SetGroupsToAvoid(GroupFlags: number): void;
	SetCrouchedHalfHeight(NewValue: number): void;
	SetAvoidanceGroupMask(GroupMask: NavAvoidanceMask): void;
	SetAvoidanceGroup(GroupFlags: number): void;
	SetAvoidanceEnabled(bEnable: boolean): void;
	K2_GetWalkableFloorZ(): number;
	K2_GetWalkableFloorAngle(): number;
	K2_FindFloor(CapsuleLocation: Vector,FloorResult?: FindFloorResult): {FloorResult: FindFloorResult};
	K2_ComputeFloorDist(CapsuleLocation: Vector,LineDistance: number,SweepDistance: number,SweepRadius: number,FloorResult?: FindFloorResult): {FloorResult: FindFloorResult};
	IsWalking(): boolean;
	IsWalkable(Hit: HitResult): boolean;
	GetValidPerchRadius(): number;
	GetPerchRadiusThreshold(): number;
	GetMovementBase(): PrimitiveComponent;
	GetMinAnalogSpeed(): number;
	GetMaxJumpHeightWithJumpTime(): number;
	GetMaxJumpHeight(): number;
	GetMaxBrakingDeceleration(): number;
	GetMaxAcceleration(): number;
	GetLastUpdateVelocity(): Vector;
	GetLastUpdateRotation(): Rotator;
	GetLastUpdateRequestedVelocity(): Vector;
	GetLastUpdateLocation(): Vector;
	GetImpartedMovementBaseVelocity(): Vector;
	GetCurrentAcceleration(): Vector;
	GetCrouchedHalfHeight(): number;
	GetCharacterOwner(): Character;
	GetAnalogInputModifier(): number;
	DisableMovement(): void;
	ClearAccumulatedForces(): void;
	CapsuleTouched(OverlappedComp: PrimitiveComponent,Other: Actor,OtherComp: PrimitiveComponent,OtherBodyIndex: number,bFromSweep: boolean,SweepResult: HitResult): void;
	CalcVelocity(DeltaTime: number,Friction: number,bFluid: boolean,BrakingDeceleration: number): void;
	AddImpulse(Impulse: Vector,bVelocityChange: boolean): void;
	AddForce(Force: Vector): void;
	static C(Other: UObject | any): CharacterMovementComponent;
}

declare class ArrowComponent extends PrimitiveComponent { 
	ArrowColor: Color;
	ArrowSize: number;
	ArrowLength: number;
	ScreenSize: number;
	bIsScreenSizeScaled: boolean;
	bTreatAsASprite: boolean;
	SpriteCategoryName: string;
	SpriteInfo: SpriteCategoryInfo;
	bLightAttachment: boolean;
	bUseInEditorScaling: boolean;
	static Load(ResourceName: string): ArrowComponent;
	static Find(Outer: UObject, ResourceName: string): ArrowComponent;
	static GetDefaultObject(): ArrowComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ArrowComponent;
	SetArrowColor(NewColor: LinearColor): void;
	static C(Other: UObject | any): ArrowComponent;
}

declare class BasedMovementInfo { 
	MovementBase: PrimitiveComponent;
	BoneName: string;
	Location: Vector_NetQuantize100;
	Rotation: Rotator;
	bServerHasBaseComponent: boolean;
	bRelativeRotation: boolean;
	bServerHasVelocity: boolean;
	clone() : BasedMovementInfo;
	static C(Other: UObject | any): BasedMovementInfo;
}

declare class RepRootMotionMontage { 
	bIsActive: boolean;
	AnimMontage: AnimMontage;
	Position: number;
	Location: Vector_NetQuantize100;
	Rotation: Rotator;
	MovementBase: PrimitiveComponent;
	MovementBaseBoneName: string;
	bRelativePosition: boolean;
	bRelativeRotation: boolean;
	AuthoritativeRootMotion: RootMotionSourceGroup;
	Acceleration: Vector_NetQuantize10;
	LinearVelocity: Vector_NetQuantize10;
	clone() : RepRootMotionMontage;
	static C(Other: UObject | any): RepRootMotionMontage;
}

declare class SimulatedRootMotionReplicatedMove { 
	Time: number;
	RootMotion: RepRootMotionMontage;
	clone() : SimulatedRootMotionReplicatedMove;
	static C(Other: UObject | any): SimulatedRootMotionReplicatedMove;
}

declare class CharacterNetworkSerializationPackedBits { 
	clone() : CharacterNetworkSerializationPackedBits;
	static C(Other: UObject | any): CharacterNetworkSerializationPackedBits;
}

declare class CharacterServerMovePackedBits extends CharacterNetworkSerializationPackedBits { 
	clone() : CharacterServerMovePackedBits;
	static C(Other: UObject | any): CharacterServerMovePackedBits;
}

declare class CharacterMoveResponsePackedBits extends CharacterNetworkSerializationPackedBits { 
	clone() : CharacterMoveResponsePackedBits;
	static C(Other: UObject | any): CharacterMoveResponsePackedBits;
}

declare class Character extends Pawn { 
	Mesh: SkeletalMeshComponent;
	CharacterMovement: CharacterMovementComponent;
	CapsuleComponent: CapsuleComponent;
	ArrowComponent: ArrowComponent;
	BasedMovement: BasedMovementInfo;
	ReplicatedBasedMovement: BasedMovementInfo;
	AnimRootMotionTranslationScale: number;
	BaseTranslationOffset: Vector;
	BaseRotationOffset: Quat;
	ReplicatedServerLastTransformUpdateTimeStamp: number;
	ReplayLastTransformUpdateTimeStamp: number;
	ReplicatedMovementMode: number;
	bInBaseReplication: boolean;
	CrouchedEyeHeight: number;
	bIsCrouched: boolean;
	bProxyIsJumpForceApplied: boolean;
	bPressedJump: boolean;
	bClientUpdating: boolean;
	bClientWasFalling: boolean;
	bClientResimulateRootMotion: boolean;
	bClientResimulateRootMotionSources: boolean;
	bSimGravityDisabled: boolean;
	bClientCheckEncroachmentOnNetUpdate: boolean;
	bServerMoveIgnoreRootMotion: boolean;
	bWasJumping: boolean;
	JumpKeyHoldTime: number;
	JumpForceTimeRemaining: number;
	ProxyJumpForceStartedTime: number;
	JumpMaxHoldTime: number;
	JumpMaxCount: number;
	JumpCurrentCount: number;
	JumpCurrentCountPreJump: number;
	OnReachedJumpApex: UnrealEngineMulticastDelegate<() => void>;
	LandedDelegate: UnrealEngineMulticastDelegate<(Hit: HitResult) => void>;
	MovementModeChangedDelegate: UnrealEngineMulticastDelegate<(Character: Character, PrevMovementMode: EMovementMode, PreviousCustomMode: number) => void>;
	OnCharacterMovementUpdated: UnrealEngineMulticastDelegate<(DeltaSeconds: number, OldLocation: Vector, OldVelocity: Vector) => void>;
	SavedRootMotion: RootMotionSourceGroup;
	ClientRootMotionParams: RootMotionMovementParams;
	RootMotionRepMoves: SimulatedRootMotionReplicatedMove[];
	RepRootMotion: RepRootMotionMontage;
	static GetDefaultObject(): Character;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Character;
	UnCrouch(bClientSimulation: boolean): void;
	StopJumping(): void;
	StopAnimMontage(AnimMontage: AnimMontage): void;
	ServerMovePacked(PackedBits: CharacterServerMovePackedBits): void;
	ServerMoveOld(OldTimeStamp: number,OldAccel: Vector_NetQuantize10,OldMoveFlags: number): void;
	ServerMoveNoBase(Timestamp: number,InAccel: Vector_NetQuantize10,ClientLoc: Vector_NetQuantize100,CompressedMoveFlags: number,ClientRoll: number,View: number,ClientMovementMode: number): void;
	ServerMoveDualNoBase(TimeStamp0: number,InAccel0: Vector_NetQuantize10,PendingFlags: number,View0: number,Timestamp: number,InAccel: Vector_NetQuantize10,ClientLoc: Vector_NetQuantize100,NewFlags: number,ClientRoll: number,View: number,ClientMovementMode: number): void;
	ServerMoveDualHybridRootMotion(TimeStamp0: number,InAccel0: Vector_NetQuantize10,PendingFlags: number,View0: number,Timestamp: number,InAccel: Vector_NetQuantize10,ClientLoc: Vector_NetQuantize100,NewFlags: number,ClientRoll: number,View: number,ClientMovementBase: PrimitiveComponent,ClientBaseBoneName: string,ClientMovementMode: number): void;
	ServerMoveDual(TimeStamp0: number,InAccel0: Vector_NetQuantize10,PendingFlags: number,View0: number,Timestamp: number,InAccel: Vector_NetQuantize10,ClientLoc: Vector_NetQuantize100,NewFlags: number,ClientRoll: number,View: number,ClientMovementBase: PrimitiveComponent,ClientBaseBoneName: string,ClientMovementMode: number): void;
	ServerMove(Timestamp: number,InAccel: Vector_NetQuantize10,ClientLoc: Vector_NetQuantize100,CompressedMoveFlags: number,ClientRoll: number,View: number,ClientMovementBase: PrimitiveComponent,ClientBaseBoneName: string,ClientMovementMode: number): void;
	RootMotionDebugClientPrintOnScreen(InString: string): void;
	PlayAnimMontage(AnimMontage: AnimMontage,InPlayRate: number,StartSectionName: string): number;
	OnWalkingOffLedge(PreviousFloorImpactNormal: Vector,PreviousFloorContactNormal: Vector,PreviousLocation: Vector,TimeDelta: number): void;
	OnRep_RootMotion(): void;
	OnRep_ReplicatedBasedMovement(): void;
	OnRep_ReplayLastTransformUpdateTimeStamp(): void;
	OnRep_IsCrouched(): void;
	OnLaunched(LaunchVelocity: Vector,bXYOverride: boolean,bZOverride: boolean): void;
	OnLanded(Hit: HitResult): void;
	OnJumped(): void;
	LaunchCharacter(LaunchVelocity: Vector,bXYOverride: boolean,bZOverride: boolean): void;
	K2_UpdateCustomMovement(DeltaTime: number): void;
	K2_OnStartCrouch(HalfHeightAdjust: number,ScaledHalfHeightAdjust: number): void;
	K2_OnMovementModeChanged(PrevMovementMode: EMovementMode,NewMovementMode: EMovementMode,PrevCustomMode: number,NewCustomMode: number): void;
	K2_OnEndCrouch(HalfHeightAdjust: number,ScaledHalfHeightAdjust: number): void;
	Jump(): void;
	IsPlayingRootMotion(): boolean;
	IsPlayingNetworkedRootMotionMontage(): boolean;
	IsJumpProvidingForce(): boolean;
	HasAnyRootMotion(): boolean;
	GetCurrentMontage(): AnimMontage;
	GetBaseTranslationOffset(): Vector;
	GetBaseRotationOffsetRotator(): Rotator;
	GetAnimRootMotionTranslationScale(): number;
	Crouch(bClientSimulation: boolean): void;
	ClientVeryShortAdjustPosition(Timestamp: number,NewLoc: Vector,NewBase: PrimitiveComponent,NewBaseBoneName: string,bHasBase: boolean,bBaseRelativePosition: boolean,ServerMovementMode: number): void;
	ClientMoveResponsePacked(PackedBits: CharacterMoveResponsePackedBits): void;
	ClientCheatWalk(): void;
	ClientCheatGhost(): void;
	ClientCheatFly(): void;
	ClientAdjustRootMotionSourcePosition(Timestamp: number,ServerRootMotion: RootMotionSourceGroup,bHasAnimRootMotion: boolean,ServerMontageTrackPosition: number,ServerLoc: Vector,ServerRotation: Vector_NetQuantizeNormal,ServerVelZ: number,ServerBase: PrimitiveComponent,ServerBoneName: string,bHasBase: boolean,bBaseRelativePosition: boolean,ServerMovementMode: number): void;
	ClientAdjustRootMotionPosition(Timestamp: number,ServerMontageTrackPosition: number,ServerLoc: Vector,ServerRotation: Vector_NetQuantizeNormal,ServerVelZ: number,ServerBase: PrimitiveComponent,ServerBoneName: string,bHasBase: boolean,bBaseRelativePosition: boolean,ServerMovementMode: number): void;
	ClientAdjustPosition(Timestamp: number,NewLoc: Vector,NewVel: Vector,NewBase: PrimitiveComponent,NewBaseBoneName: string,bHasBase: boolean,bBaseRelativePosition: boolean,ServerMovementMode: number): void;
	ClientAckGoodMove(Timestamp: number): void;
	CanJumpInternal(): boolean;
	CanJump(): boolean;
	CanCrouch(): boolean;
	CacheInitialMeshOffset(MeshRelativeLocation: Vector,MeshRelativeRotation: Rotator): void;
	static C(Other: UObject | any): Character;
}

declare type ENavPathEvent = 'Cleared' | 'NewPath' | 'UpdatedDueToGoalMoved' | 'UpdatedDueToNavigationChanged' | 'Invalidated' | 'RePathFailed' | 'MetaPathUpdate' | 'Custom' | 'ENavPathEvent_MAX';
declare var ENavPathEvent : { Cleared:'Cleared',NewPath:'NewPath',UpdatedDueToGoalMoved:'UpdatedDueToGoalMoved',UpdatedDueToNavigationChanged:'UpdatedDueToNavigationChanged',Invalidated:'Invalidated',RePathFailed:'RePathFailed',MetaPathUpdate:'MetaPathUpdate',Custom:'Custom',ENavPathEvent_MAX:'ENavPathEvent_MAX', };
declare type ENavigationOptionFlag = 'Default' | 'Enable' | 'Disable' | 'MAX';
declare var ENavigationOptionFlag : { Default:'Default',Enable:'Enable',Disable:'Disable',MAX:'MAX', };
declare class NavigationPath extends UObject { 
	PathUpdatedNotifier: UnrealEngineMulticastDelegate<(AffectedPath: NavigationPath, PathEvent: ENavPathEvent) => void>;
	PathPoints: Vector[];
	RecalculateOnInvalidation: ENavigationOptionFlag;
	static Load(ResourceName: string): NavigationPath;
	static Find(Outer: UObject, ResourceName: string): NavigationPath;
	static GetDefaultObject(): NavigationPath;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationPath;
	IsValid(): boolean;
	IsStringPulled(): boolean;
	IsPartial(): boolean;
	GetPathLength(): number;
	GetPathCost(): number;
	GetDebugString(): string;
	EnableRecalculationOnInvalidation(DoRecalculation: ENavigationOptionFlag): void;
	EnableDebugDrawing(bShouldDrawDebugData: boolean,PathColor: LinearColor): void;
	static C(Other: UObject | any): NavigationPath;
}

declare class Controller extends Actor { 
	PlayerState: PlayerState;
	OnInstigatedAnyDamage: UnrealEngineMulticastDelegate<(Damage: number, DamageType: DamageType, DamagedActor: Actor, DamageCauser: Actor) => void>;
	OnPossessedPawnChanged: UnrealEngineMulticastDelegate<(OldPawn: Pawn, NewPawn: Pawn) => void>;
	StateName: string;
	Pawn: Pawn;
	Character: Character;
	TransformComponent: SceneComponent;
	ControlRotation: Rotator;
	bAttachToPawn: boolean;
	static GetDefaultObject(): Controller;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Controller;
	UnPossess(): void;
	StopMovement(): void;
	SetInitialLocationAndRotation(NewLocation: Vector,NewRotation: Rotator): void;
	SetIgnoreMoveInput(bNewMoveInput: boolean): void;
	SetIgnoreLookInput(bNewLookInput: boolean): void;
	SetControlRotation(NewRotation: Rotator): void;
	ResetIgnoreMoveInput(): void;
	ResetIgnoreLookInput(): void;
	ResetIgnoreInputFlags(): void;
	ReceiveUnPossess(UnpossessedPawn: Pawn): void;
	ReceivePossess(PossessedPawn: Pawn): void;
	ReceiveInstigatedAnyDamage(Damage: number,DamageType: DamageType,DamagedActor: Actor,DamageCauser: Actor): void;
	Possess(InPawn: Pawn): void;
	OnRep_PlayerState(): void;
	OnRep_Pawn(): void;
	LineOfSightTo(Other: Actor,ViewPoint: Vector,bAlternateChecks: boolean): boolean;
	K2_GetPawn(): Pawn;
	IsPlayerController(): boolean;
	IsMoveInputIgnored(): boolean;
	IsLookInputIgnored(): boolean;
	IsLocalPlayerController(): boolean;
	IsLocalController(): boolean;
	GetViewTarget(): Actor;
	GetPlayerViewPoint(Location?: Vector,Rotation?: Rotator): {Location: Vector, Rotation: Rotator};
	GetDesiredRotation(): Rotator;
	GetControlRotation(): Rotator;
	ClientSetRotation(NewRotation: Rotator,bResetCamera: boolean): void;
	ClientSetLocation(NewLocation: Vector,NewRotation: Rotator): void;
	static C(Other: UObject | any): Controller;
	GetCurrentPath(): NavigationPath;
	GetCurrentPathIndex(): number;
	GetCurrentPathPoints(): Vector[];
	GetNextNavLinkIndex(): number;
	SimpleMoveToActor(Goal: Actor): void;
	SimpleMoveToLocation(Goal: Vector): void;
	static GetCurrentPath(Controller: Controller): NavigationPath;
	static GetCurrentPathIndex(Controller: Controller): number;
	static GetCurrentPathPoints(Controller: Controller): Vector[];
	static GetNextNavLinkIndex(Controller: Controller): number;
	static SimpleMoveToActor(Controller: Controller,Goal: Actor): void;
	static SimpleMoveToLocation(Controller: Controller,Goal: Vector): void;
}

declare class Player extends UObject { 
	PlayerController: PlayerController;
	CurrentNetSpeed: number;
	ConfiguredInternetSpeed: number;
	ConfiguredLanSpeed: number;
	static Load(ResourceName: string): Player;
	static Find(Outer: UObject, ResourceName: string): Player;
	static GetDefaultObject(): Player;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Player;
	static C(Other: UObject | any): Player;
}

declare class ReporterBase extends UObject { 
	static Load(ResourceName: string): ReporterBase;
	static Find(Outer: UObject, ResourceName: string): ReporterBase;
	static GetDefaultObject(): ReporterBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReporterBase;
	static C(Other: UObject | any): ReporterBase;
}

declare class ReporterGraph extends ReporterBase { 
	static Load(ResourceName: string): ReporterGraph;
	static Find(Outer: UObject, ResourceName: string): ReporterGraph;
	static GetDefaultObject(): ReporterGraph;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReporterGraph;
	static C(Other: UObject | any): ReporterGraph;
}

declare class CanvasUVTri { 
	V0_Pos: Vector2D;
	V0_UV: Vector2D;
	V0_Color: LinearColor;
	V1_Pos: Vector2D;
	V1_UV: Vector2D;
	V1_Color: LinearColor;
	V2_Pos: Vector2D;
	V2_UV: Vector2D;
	V2_Color: LinearColor;
	clone() : CanvasUVTri;
	static C(Other: UObject | any): CanvasUVTri;
}

declare class Canvas extends UObject { 
	OrgX: number;
	OrgY: number;
	ClipX: number;
	ClipY: number;
	DrawColor: Color;
	bCenterX: boolean;
	bCenterY: boolean;
	bNoSmooth: boolean;
	SizeX: number;
	SizeY: number;
	ColorModulate: Plane;
	DefaultTexture: Texture2D;
	GradientTexture0: Texture2D;
	ReporterGraph: ReporterGraph;
	static Load(ResourceName: string): Canvas;
	static Find(Outer: UObject, ResourceName: string): Canvas;
	static GetDefaultObject(): Canvas;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Canvas;
	K2_TextSize(RenderFont: Font,RenderText: string,Scale: Vector2D): Vector2D;
	K2_StrLen(RenderFont: Font,RenderText: string): Vector2D;
	K2_Project(WorldLocation: Vector): Vector;
	K2_DrawTriangle(RenderTexture: Texture,Triangles: CanvasUVTri[]): void;
	K2_DrawTexture(RenderTexture: Texture,ScreenPosition: Vector2D,ScreenSize: Vector2D,CoordinatePosition: Vector2D,CoordinateSize: Vector2D,RenderColor: LinearColor,BlendMode: EBlendMode,Rotation: number,PivotPoint: Vector2D): void;
	K2_DrawText(RenderFont: Font,RenderText: string,ScreenPosition: Vector2D,Scale: Vector2D,RenderColor: LinearColor,Kerning: number,ShadowColor: LinearColor,ShadowOffset: Vector2D,bCentreX: boolean,bCentreY: boolean,bOutlined: boolean,OutlineColor: LinearColor): void;
	K2_DrawPolygon(RenderTexture: Texture,ScreenPosition: Vector2D,Radius: Vector2D,NumberOfSides: number,RenderColor: LinearColor): void;
	K2_DrawMaterialTriangle(RenderMaterial: MaterialInterface,Triangles: CanvasUVTri[]): void;
	K2_DrawMaterial(RenderMaterial: MaterialInterface,ScreenPosition: Vector2D,ScreenSize: Vector2D,CoordinatePosition: Vector2D,CoordinateSize: Vector2D,Rotation: number,PivotPoint: Vector2D): void;
	K2_DrawLine(ScreenPositionA: Vector2D,ScreenPositionB: Vector2D,Thickness: number,RenderColor: LinearColor): void;
	K2_DrawBox(ScreenPosition: Vector2D,ScreenSize: Vector2D,Thickness: number,RenderColor: LinearColor): void;
	K2_DrawBorder(BorderTexture: Texture,BackgroundTexture: Texture,LeftBorderTexture: Texture,RightBorderTexture: Texture,TopBorderTexture: Texture,BottomBorderTexture: Texture,ScreenPosition: Vector2D,ScreenSize: Vector2D,CoordinatePosition: Vector2D,CoordinateSize: Vector2D,RenderColor: LinearColor,BorderScale: Vector2D,BackgroundScale: Vector2D,Rotation: number,PivotPoint: Vector2D,CornerSize: Vector2D): void;
	K2_Deproject(ScreenPosition: Vector2D,WorldOrigin?: Vector,WorldDirection?: Vector): {WorldOrigin: Vector, WorldDirection: Vector};
	static C(Other: UObject | any): Canvas;
}

declare class DebugTextInfo { 
	SrcActor: Actor;
	SrcActorOffset: Vector;
	SrcActorDesiredOffset: Vector;
	DebugText: string;
	TimeRemaining: number;
	Duration: number;
	TextColor: Color;
	bAbsoluteLocation: boolean;
	bKeepAttachedToActor: boolean;
	bDrawShadow: boolean;
	OrigActorLocation: Vector;
	Font: Font;
	FontScale: number;
	clone() : DebugTextInfo;
	static C(Other: UObject | any): DebugTextInfo;
}

declare class HUD extends Actor { 
	PlayerOwner: PlayerController;
	bLostFocusPaused: boolean;
	bShowHUD: boolean;
	bShowDebugInfo: boolean;
	CurrentTargetIndex: number;
	bShowHitBoxDebugInfo: boolean;
	bShowOverlays: boolean;
	bEnableDebugTextShadow: boolean;
	PostRenderedActors: Actor[];
	DebugDisplay: string[];
	ToggledDebugCategories: string[];
	Canvas: Canvas;
	DebugCanvas: Canvas;
	DebugTextList: DebugTextInfo[];
	ShowDebugTargetDesiredClass: UnrealEngineClass;
	ShowDebugTargetActor: Actor;
	static GetDefaultObject(): HUD;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HUD;
	ShowHUD(): void;
	ShowDebugToggleSubCategory(Category: string): void;
	ShowDebugForReticleTargetToggle(DesiredClass: UnrealEngineClass): void;
	ShowDebug(DebugType: string): void;
	RemoveDebugText(SrcActor: Actor,bLeaveDurationText: boolean): void;
	RemoveAllDebugStrings(): void;
	ReceiveHitBoxRelease(BoxName: string): void;
	ReceiveHitBoxEndCursorOver(BoxName: string): void;
	ReceiveHitBoxClick(BoxName: string): void;
	ReceiveHitBoxBeginCursorOver(BoxName: string): void;
	ReceiveDrawHUD(SizeX: number,SizeY: number): void;
	Project(Location: Vector,bClampToZeroPlane: boolean): Vector;
	PreviousDebugTarget(): void;
	NextDebugTarget(): void;
	GetTextSize(Text: string,OutWidth?: number,OutHeight?: number,Font?: Font,Scale?: number): {OutWidth: number, OutHeight: number};
	GetOwningPlayerController(): PlayerController;
	GetOwningPawn(): Pawn;
	GetActorsInSelectionRectangle(ClassFilter: UnrealEngineClass,FirstPoint: Vector2D,SecondPoint: Vector2D,OutActors?: Actor[],bIncludeNonCollidingComponents?: boolean,bActorMustBeFullyEnclosed?: boolean): {OutActors: Actor[]};
	DrawTextureSimple(Texture: Texture,ScreenX: number,ScreenY: number,Scale: number,bScalePosition: boolean): void;
	DrawTexture(Texture: Texture,ScreenX: number,ScreenY: number,ScreenW: number,ScreenH: number,TextureU: number,TextureV: number,TextureUWidth: number,TextureVHeight: number,TintColor: LinearColor,BlendMode: EBlendMode,Scale: number,bScalePosition: boolean,Rotation: number,RotPivot: Vector2D): void;
	DrawText(Text: string,TextColor: LinearColor,ScreenX: number,ScreenY: number,Font: Font,Scale: number,bScalePosition: boolean): void;
	DrawRect(RectColor: LinearColor,ScreenX: number,ScreenY: number,ScreenW: number,ScreenH: number): void;
	DrawMaterialTriangle(Material: MaterialInterface,V0_Pos: Vector2D,V1_Pos: Vector2D,V2_Pos: Vector2D,V0_UV: Vector2D,V1_UV: Vector2D,V2_UV: Vector2D,V0_Color: LinearColor,V1_Color: LinearColor,V2_Color: LinearColor): void;
	DrawMaterialSimple(Material: MaterialInterface,ScreenX: number,ScreenY: number,ScreenW: number,ScreenH: number,Scale: number,bScalePosition: boolean): void;
	DrawMaterial(Material: MaterialInterface,ScreenX: number,ScreenY: number,ScreenW: number,ScreenH: number,MaterialU: number,MaterialV: number,MaterialUWidth: number,MaterialVHeight: number,Scale: number,bScalePosition: boolean,Rotation: number,RotPivot: Vector2D): void;
	DrawLine(StartScreenX: number,StartScreenY: number,EndScreenX: number,EndScreenY: number,LineColor: LinearColor,LineThickness: number): void;
	Deproject(ScreenX: number,ScreenY: number,WorldPosition?: Vector,WorldDirection?: Vector): {WorldPosition: Vector, WorldDirection: Vector};
	AddHitBox(Position: Vector2D,Size: Vector2D,InName: string,bConsumesInput: boolean,Priority: number): void;
	AddDebugText(DebugText: string,SrcActor: Actor,Duration: number,Offset: Vector,DesiredOffset: Vector,TextColor: Color,bSkipOverwriteCheck: boolean,bAbsoluteLocation: boolean,bKeepAttachedToActor: boolean,InFont: Font,FontScale: number,bDrawShadow: boolean): void;
	static C(Other: UObject | any): HUD;
}

declare type ECameraProjectionMode = 'Perspective' | 'Orthographic' | 'ECameraProjectionMode_MAX';
declare var ECameraProjectionMode : { Perspective:'Perspective',Orthographic:'Orthographic',ECameraProjectionMode_MAX:'ECameraProjectionMode_MAX', };
declare type EBloomMethod = 'BM_SOG' | 'BM_FFT' | 'BM_MAX';
declare var EBloomMethod : { BM_SOG:'BM_SOG',BM_FFT:'BM_FFT',BM_MAX:'BM_MAX', };
declare type EAutoExposureMethod = 'AEM_Histogram' | 'AEM_Basic' | 'AEM_Manual' | 'AEM_MAX';
declare var EAutoExposureMethod : { AEM_Histogram:'AEM_Histogram',AEM_Basic:'AEM_Basic',AEM_Manual:'AEM_Manual',AEM_MAX:'AEM_MAX', };
declare type EDepthOfFieldMethod = 'DOFM_BokehDOF' | 'DOFM_Gaussian' | 'DOFM_CircleDOF' | 'DOFM_MAX';
declare var EDepthOfFieldMethod : { DOFM_BokehDOF:'DOFM_BokehDOF',DOFM_Gaussian:'DOFM_Gaussian',DOFM_CircleDOF:'DOFM_CircleDOF',DOFM_MAX:'DOFM_MAX', };
declare type ETemperatureMethod = 'TEMP_WhiteBalance' | 'TEMP_ColorTemperature' | 'TEMP_MAX';
declare var ETemperatureMethod : { TEMP_WhiteBalance:'TEMP_WhiteBalance',TEMP_ColorTemperature:'TEMP_ColorTemperature',TEMP_MAX:'TEMP_MAX', };
declare type EDynamicGlobalIlluminationMethod = 'None' | 'Lumen' | 'ScreenSpace' | 'RayTraced' | 'Plugin' | 'EDynamicGlobalIlluminationMethod_MAX';
declare var EDynamicGlobalIlluminationMethod : { None:'None',Lumen:'Lumen',ScreenSpace:'ScreenSpace',RayTraced:'RayTraced',Plugin:'Plugin',EDynamicGlobalIlluminationMethod_MAX:'EDynamicGlobalIlluminationMethod_MAX', };
declare type ERayTracingGlobalIlluminationType = 'Disabled' | 'BruteForce' | 'FinalGather' | 'ERayTracingGlobalIlluminationType_MAX';
declare var ERayTracingGlobalIlluminationType : { Disabled:'Disabled',BruteForce:'BruteForce',FinalGather:'FinalGather',ERayTracingGlobalIlluminationType_MAX:'ERayTracingGlobalIlluminationType_MAX', };
declare type EReflectionMethod = 'None' | 'Lumen' | 'ScreenSpace' | 'RayTraced' | 'EReflectionMethod_MAX';
declare var EReflectionMethod : { None:'None',Lumen:'Lumen',ScreenSpace:'ScreenSpace',RayTraced:'RayTraced',EReflectionMethod_MAX:'EReflectionMethod_MAX', };
declare type EReflectionsType = 'ScreenSpace' | 'RayTracing' | 'EReflectionsType_MAX';
declare var EReflectionsType : { ScreenSpace:'ScreenSpace',RayTracing:'RayTracing',EReflectionsType_MAX:'EReflectionsType_MAX', };
declare type ELumenRayLightingModeOverride = 'Default' | 'SurfaceCache' | 'HitLighting' | 'ELumenRayLightingModeOverride_MAX';
declare var ELumenRayLightingModeOverride : { Default:'Default',SurfaceCache:'SurfaceCache',HitLighting:'HitLighting',ELumenRayLightingModeOverride_MAX:'ELumenRayLightingModeOverride_MAX', };
declare type EReflectedAndRefractedRayTracedShadows = 'Disabled' | 'Hard_shadows' | 'Area_shadows' | 'EReflectedAndRefractedRayTracedShadows_MAX';
declare var EReflectedAndRefractedRayTracedShadows : { Disabled:'Disabled',Hard_shadows:'Hard_shadows',Area_shadows:'Area_shadows',EReflectedAndRefractedRayTracedShadows_MAX:'EReflectedAndRefractedRayTracedShadows_MAX', };
declare class TextureCube extends Texture { 
	static Load(ResourceName: string): TextureCube;
	static Find(Outer: UObject, ResourceName: string): TextureCube;
	static GetDefaultObject(): TextureCube;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureCube;
	static C(Other: UObject | any): TextureCube;
}

declare type ETranslucencyType = 'Raster' | 'RayTracing' | 'ETranslucencyType_MAX';
declare var ETranslucencyType : { Raster:'Raster',RayTracing:'RayTracing',ETranslucencyType_MAX:'ETranslucencyType_MAX', };
declare class WeightedBlendable { 
	Weight: number;
	UObject: UObject;
	clone() : WeightedBlendable;
	static C(Other: UObject | any): WeightedBlendable;
}

declare class WeightedBlendables { 
	Array: WeightedBlendable[];
	clone() : WeightedBlendables;
	static C(Other: UObject | any): WeightedBlendables;
}

declare class PostProcessSettings { 
	bOverride_TemperatureType: boolean;
	bOverride_WhiteTemp: boolean;
	bOverride_WhiteTint: boolean;
	bOverride_ColorSaturation: boolean;
	bOverride_ColorContrast: boolean;
	bOverride_ColorGamma: boolean;
	bOverride_ColorGain: boolean;
	bOverride_ColorOffset: boolean;
	bOverride_ColorSaturationShadows: boolean;
	bOverride_ColorContrastShadows: boolean;
	bOverride_ColorGammaShadows: boolean;
	bOverride_ColorGainShadows: boolean;
	bOverride_ColorOffsetShadows: boolean;
	bOverride_ColorSaturationMidtones: boolean;
	bOverride_ColorContrastMidtones: boolean;
	bOverride_ColorGammaMidtones: boolean;
	bOverride_ColorGainMidtones: boolean;
	bOverride_ColorOffsetMidtones: boolean;
	bOverride_ColorSaturationHighlights: boolean;
	bOverride_ColorContrastHighlights: boolean;
	bOverride_ColorGammaHighlights: boolean;
	bOverride_ColorGainHighlights: boolean;
	bOverride_ColorOffsetHighlights: boolean;
	bOverride_ColorCorrectionShadowsMax: boolean;
	bOverride_ColorCorrectionHighlightsMin: boolean;
	bOverride_ColorCorrectionHighlightsMax: boolean;
	bOverride_BlueCorrection: boolean;
	bOverride_ExpandGamut: boolean;
	bOverride_ToneCurveAmount: boolean;
	bOverride_FilmSlope: boolean;
	bOverride_FilmToe: boolean;
	bOverride_FilmShoulder: boolean;
	bOverride_FilmBlackClip: boolean;
	bOverride_FilmWhiteClip: boolean;
	bOverride_SceneColorTint: boolean;
	bOverride_SceneFringeIntensity: boolean;
	bOverride_ChromaticAberrationStartOffset: boolean;
	bOverride_AmbientCubemapTint: boolean;
	bOverride_AmbientCubemapIntensity: boolean;
	bOverride_BloomMethod: boolean;
	bOverride_BloomIntensity: boolean;
	bOverride_BloomThreshold: boolean;
	bOverride_Bloom1Tint: boolean;
	bOverride_Bloom1Size: boolean;
	bOverride_Bloom2Size: boolean;
	bOverride_Bloom2Tint: boolean;
	bOverride_Bloom3Tint: boolean;
	bOverride_Bloom3Size: boolean;
	bOverride_Bloom4Tint: boolean;
	bOverride_Bloom4Size: boolean;
	bOverride_Bloom5Tint: boolean;
	bOverride_Bloom5Size: boolean;
	bOverride_Bloom6Tint: boolean;
	bOverride_Bloom6Size: boolean;
	bOverride_BloomSizeScale: boolean;
	bOverride_BloomConvolutionTexture: boolean;
	bOverride_BloomConvolutionScatterDispersion: boolean;
	bOverride_BloomConvolutionSize: boolean;
	bOverride_BloomConvolutionCenterUV: boolean;
	bOverride_BloomConvolutionPreFilter: boolean;
	bOverride_BloomConvolutionPreFilterMin: boolean;
	bOverride_BloomConvolutionPreFilterMax: boolean;
	bOverride_BloomConvolutionPreFilterMult: boolean;
	bOverride_BloomConvolutionBufferScale: boolean;
	bOverride_BloomDirtMaskIntensity: boolean;
	bOverride_BloomDirtMaskTint: boolean;
	bOverride_BloomDirtMask: boolean;
	bOverride_CameraShutterSpeed: boolean;
	bOverride_CameraISO: boolean;
	bOverride_AutoExposureMethod: boolean;
	bOverride_AutoExposureLowPercent: boolean;
	bOverride_AutoExposureHighPercent: boolean;
	bOverride_AutoExposureMinBrightness: boolean;
	bOverride_AutoExposureMaxBrightness: boolean;
	bOverride_AutoExposureCalibrationConstant: boolean;
	bOverride_AutoExposureSpeedUp: boolean;
	bOverride_AutoExposureSpeedDown: boolean;
	bOverride_AutoExposureBias: boolean;
	bOverride_AutoExposureBiasCurve: boolean;
	bOverride_AutoExposureMeterMask: boolean;
	bOverride_AutoExposureApplyPhysicalCameraExposure: boolean;
	bOverride_HistogramLogMin: boolean;
	bOverride_HistogramLogMax: boolean;
	bOverride_LocalExposureContrastScale: boolean;
	bOverride_LocalExposureHighlightContrastScale: boolean;
	bOverride_LocalExposureShadowContrastScale: boolean;
	bOverride_LocalExposureDetailStrength: boolean;
	bOverride_LocalExposureBlurredLuminanceBlend: boolean;
	bOverride_LocalExposureBlurredLuminanceKernelSizePercent: boolean;
	bOverride_LocalExposureMiddleGreyBias: boolean;
	bOverride_LensFlareIntensity: boolean;
	bOverride_LensFlareTint: boolean;
	bOverride_LensFlareTints: boolean;
	bOverride_LensFlareBokehSize: boolean;
	bOverride_LensFlareBokehShape: boolean;
	bOverride_LensFlareThreshold: boolean;
	bOverride_VignetteIntensity: boolean;
	bOverride_GrainIntensity: boolean;
	bOverride_GrainJitter: boolean;
	bOverride_FilmGrainIntensity: boolean;
	bOverride_FilmGrainIntensityShadows: boolean;
	bOverride_FilmGrainIntensityMidtones: boolean;
	bOverride_FilmGrainIntensityHighlights: boolean;
	bOverride_FilmGrainShadowsMax: boolean;
	bOverride_FilmGrainHighlightsMin: boolean;
	bOverride_FilmGrainHighlightsMax: boolean;
	bOverride_FilmGrainTexelSize: boolean;
	bOverride_FilmGrainTexture: boolean;
	bOverride_AmbientOcclusionIntensity: boolean;
	bOverride_AmbientOcclusionStaticFraction: boolean;
	bOverride_AmbientOcclusionRadius: boolean;
	bOverride_AmbientOcclusionFadeDistance: boolean;
	bOverride_AmbientOcclusionFadeRadius: boolean;
	bOverride_AmbientOcclusionDistance: boolean;
	bOverride_AmbientOcclusionRadiusInWS: boolean;
	bOverride_AmbientOcclusionPower: boolean;
	bOverride_AmbientOcclusionBias: boolean;
	bOverride_AmbientOcclusionQuality: boolean;
	bOverride_AmbientOcclusionMipBlend: boolean;
	bOverride_AmbientOcclusionMipScale: boolean;
	bOverride_AmbientOcclusionMipThreshold: boolean;
	bOverride_AmbientOcclusionTemporalBlendWeight: boolean;
	bOverride_RayTracingAO: boolean;
	bOverride_RayTracingAOSamplesPerPixel: boolean;
	bOverride_RayTracingAOIntensity: boolean;
	bOverride_RayTracingAORadius: boolean;
	bOverride_LPVIntensity: boolean;
	bOverride_LPVDirectionalOcclusionIntensity: boolean;
	bOverride_LPVDirectionalOcclusionRadius: boolean;
	bOverride_LPVDiffuseOcclusionExponent: boolean;
	bOverride_LPVSpecularOcclusionExponent: boolean;
	bOverride_LPVDiffuseOcclusionIntensity: boolean;
	bOverride_LPVSpecularOcclusionIntensity: boolean;
	bOverride_LPVSize: boolean;
	bOverride_LPVSecondaryOcclusionIntensity: boolean;
	bOverride_LPVSecondaryBounceIntensity: boolean;
	bOverride_LPVGeometryVolumeBias: boolean;
	bOverride_LPVVplInjectionBias: boolean;
	bOverride_LPVEmissiveInjectionIntensity: boolean;
	bOverride_LPVFadeRange: boolean;
	bOverride_LPVDirectionalOcclusionFadeRange: boolean;
	bOverride_IndirectLightingColor: boolean;
	bOverride_IndirectLightingIntensity: boolean;
	bOverride_ColorGradingIntensity: boolean;
	bOverride_ColorGradingLUT: boolean;
	bOverride_DepthOfFieldFocalDistance: boolean;
	bOverride_DepthOfFieldFstop: boolean;
	bOverride_DepthOfFieldMinFstop: boolean;
	bOverride_DepthOfFieldBladeCount: boolean;
	bOverride_DepthOfFieldSensorWidth: boolean;
	bOverride_DepthOfFieldSqueezeFactor: boolean;
	bOverride_DepthOfFieldDepthBlurRadius: boolean;
	bOverride_DepthOfFieldDepthBlurAmount: boolean;
	bOverride_DepthOfFieldFocalRegion: boolean;
	bOverride_DepthOfFieldNearTransitionRegion: boolean;
	bOverride_DepthOfFieldFarTransitionRegion: boolean;
	bOverride_DepthOfFieldScale: boolean;
	bOverride_DepthOfFieldNearBlurSize: boolean;
	bOverride_DepthOfFieldFarBlurSize: boolean;
	bOverride_MobileHQGaussian: boolean;
	bOverride_DepthOfFieldOcclusion: boolean;
	bOverride_DepthOfFieldSkyFocusDistance: boolean;
	bOverride_DepthOfFieldVignetteSize: boolean;
	bOverride_MotionBlurAmount: boolean;
	bOverride_MotionBlurMax: boolean;
	bOverride_MotionBlurTargetFPS: boolean;
	bOverride_MotionBlurPerObjectSize: boolean;
	bOverride_ScreenPercentage: boolean;
	bOverride_ReflectionMethod: boolean;
	bOverride_LumenReflectionQuality: boolean;
	bOverride_ScreenSpaceReflectionIntensity: boolean;
	bOverride_ScreenSpaceReflectionQuality: boolean;
	bOverride_ScreenSpaceReflectionMaxRoughness: boolean;
	bOverride_ScreenSpaceReflectionRoughnessScale: boolean;
	bOverride_ReflectionsType: boolean;
	bOverride_RayTracingReflectionsMaxRoughness: boolean;
	bOverride_RayTracingReflectionsMaxBounces: boolean;
	bOverride_RayTracingReflectionsSamplesPerPixel: boolean;
	bOverride_RayTracingReflectionsShadows: boolean;
	bOverride_RayTracingReflectionsTranslucency: boolean;
	bOverride_TranslucencyType: boolean;
	bOverride_RayTracingTranslucencyMaxRoughness: boolean;
	bOverride_RayTracingTranslucencyRefractionRays: boolean;
	bOverride_RayTracingTranslucencySamplesPerPixel: boolean;
	bOverride_RayTracingTranslucencyShadows: boolean;
	bOverride_RayTracingTranslucencyRefraction: boolean;
	bOverride_DynamicGlobalIlluminationMethod: boolean;
	bOverride_LumenSceneLightingQuality: boolean;
	bOverride_LumenSceneDetail: boolean;
	bOverride_LumenSceneViewDistance: boolean;
	bOverride_LumenSceneLightingUpdateSpeed: boolean;
	bOverride_LumenFinalGatherQuality: boolean;
	bOverride_LumenFinalGatherLightingUpdateSpeed: boolean;
	bOverride_LumenMaxTraceDistance: boolean;
	bOverride_LumenDiffuseColorBoost: boolean;
	bOverride_LumenSkylightLeaking: boolean;
	bOverride_LumenFullSkylightLeakingDistance: boolean;
	bOverride_LumenRayLightingMode: boolean;
	bOverride_LumenFrontLayerTranslucencyReflections: boolean;
	bOverride_LumenSurfaceCacheResolution: boolean;
	bOverride_RayTracingGI: boolean;
	bOverride_RayTracingGIMaxBounces: boolean;
	bOverride_RayTracingGISamplesPerPixel: boolean;
	bOverride_PathTracingMaxBounces: boolean;
	bOverride_PathTracingSamplesPerPixel: boolean;
	bOverride_PathTracingFilterWidth: boolean;
	bOverride_PathTracingEnableEmissive: boolean;
	bOverride_PathTracingMaxPathExposure: boolean;
	bOverride_PathTracingEnableReferenceDOF: boolean;
	bOverride_PathTracingEnableReferenceAtmosphere: boolean;
	bOverride_PathTracingEnableDenoiser: boolean;
	bMobileHQGaussian: boolean;
	BloomMethod: EBloomMethod;
	AutoExposureMethod: EAutoExposureMethod;
	DepthOfFieldMethod: EDepthOfFieldMethod;
	TemperatureType: ETemperatureMethod;
	WhiteTemp: number;
	WhiteTint: number;
	ColorSaturation: Vector4;
	ColorContrast: Vector4;
	ColorGamma: Vector4;
	ColorGain: Vector4;
	ColorOffset: Vector4;
	ColorSaturationShadows: Vector4;
	ColorContrastShadows: Vector4;
	ColorGammaShadows: Vector4;
	ColorGainShadows: Vector4;
	ColorOffsetShadows: Vector4;
	ColorSaturationMidtones: Vector4;
	ColorContrastMidtones: Vector4;
	ColorGammaMidtones: Vector4;
	ColorGainMidtones: Vector4;
	ColorOffsetMidtones: Vector4;
	ColorSaturationHighlights: Vector4;
	ColorContrastHighlights: Vector4;
	ColorGammaHighlights: Vector4;
	ColorGainHighlights: Vector4;
	ColorOffsetHighlights: Vector4;
	ColorCorrectionHighlightsMin: number;
	ColorCorrectionHighlightsMax: number;
	ColorCorrectionShadowsMax: number;
	BlueCorrection: number;
	ExpandGamut: number;
	ToneCurveAmount: number;
	FilmSlope: number;
	FilmToe: number;
	FilmShoulder: number;
	FilmBlackClip: number;
	FilmWhiteClip: number;
	SceneColorTint: LinearColor;
	SceneFringeIntensity: number;
	ChromaticAberrationStartOffset: number;
	BloomIntensity: number;
	BloomThreshold: number;
	BloomSizeScale: number;
	Bloom1Size: number;
	Bloom2Size: number;
	Bloom3Size: number;
	Bloom4Size: number;
	Bloom5Size: number;
	Bloom6Size: number;
	Bloom1Tint: LinearColor;
	Bloom2Tint: LinearColor;
	Bloom3Tint: LinearColor;
	Bloom4Tint: LinearColor;
	Bloom5Tint: LinearColor;
	Bloom6Tint: LinearColor;
	BloomConvolutionScatterDispersion: number;
	BloomConvolutionSize: number;
	BloomConvolutionTexture: Texture2D;
	BloomConvolutionCenterUV: Vector2D;
	BloomConvolutionPreFilter: Vector3f;
	BloomConvolutionPreFilterMin: number;
	BloomConvolutionPreFilterMax: number;
	BloomConvolutionPreFilterMult: number;
	BloomConvolutionBufferScale: number;
	BloomDirtMask: Texture;
	BloomDirtMaskIntensity: number;
	BloomDirtMaskTint: LinearColor;
	DynamicGlobalIlluminationMethod: EDynamicGlobalIlluminationMethod;
	IndirectLightingColor: LinearColor;
	IndirectLightingIntensity: number;
	RayTracingGI: boolean;
	LumenSceneLightingQuality: number;
	LumenSceneDetail: number;
	LumenSceneViewDistance: number;
	LumenSceneLightingUpdateSpeed: number;
	LumenFinalGatherQuality: number;
	LumenFinalGatherLightingUpdateSpeed: number;
	LumenMaxTraceDistance: number;
	LumenDiffuseColorBoost: number;
	LumenSkylightLeaking: number;
	LumenFullSkylightLeakingDistance: number;
	LumenSurfaceCacheResolution: number;
	RayTracingGIType: ERayTracingGlobalIlluminationType;
	RayTracingGIMaxBounces: number;
	RayTracingGISamplesPerPixel: number;
	ReflectionMethod: EReflectionMethod;
	ReflectionsType: EReflectionsType;
	LumenReflectionQuality: number;
	LumenRayLightingMode: ELumenRayLightingModeOverride;
	LumenFrontLayerTranslucencyReflections: boolean;
	ScreenSpaceReflectionIntensity: number;
	ScreenSpaceReflectionQuality: number;
	ScreenSpaceReflectionMaxRoughness: number;
	RayTracingReflectionsMaxRoughness: number;
	RayTracingReflectionsMaxBounces: number;
	RayTracingReflectionsSamplesPerPixel: number;
	RayTracingReflectionsShadows: EReflectedAndRefractedRayTracedShadows;
	RayTracingReflectionsTranslucency: boolean;
	AmbientCubemapTint: LinearColor;
	AmbientCubemapIntensity: number;
	AmbientCubemap: TextureCube;
	CameraShutterSpeed: number;
	CameraISO: number;
	DepthOfFieldFstop: number;
	DepthOfFieldMinFstop: number;
	DepthOfFieldBladeCount: number;
	AutoExposureBias: number;
	AutoExposureBiasBackup: number;
	bOverride_AutoExposureBiasBackup: boolean;
	AutoExposureApplyPhysicalCameraExposure: boolean;
	AutoExposureBiasCurve: CurveFloat;
	AutoExposureMeterMask: Texture;
	AutoExposureLowPercent: number;
	AutoExposureHighPercent: number;
	AutoExposureMinBrightness: number;
	AutoExposureMaxBrightness: number;
	AutoExposureSpeedUp: number;
	AutoExposureSpeedDown: number;
	HistogramLogMin: number;
	HistogramLogMax: number;
	AutoExposureCalibrationConstant: number;
	LocalExposureContrastScale: number;
	LocalExposureHighlightContrastScale: number;
	LocalExposureShadowContrastScale: number;
	LocalExposureDetailStrength: number;
	LocalExposureBlurredLuminanceBlend: number;
	LocalExposureBlurredLuminanceKernelSizePercent: number;
	LocalExposureMiddleGreyBias: number;
	LensFlareIntensity: number;
	LensFlareTint: LinearColor;
	LensFlareBokehSize: number;
	LensFlareThreshold: number;
	LensFlareBokehShape: Texture;
	LensFlareTints: LinearColor;
	VignetteIntensity: number;
	GrainJitter: number;
	GrainIntensity: number;
	FilmGrainIntensity: number;
	FilmGrainIntensityShadows: number;
	FilmGrainIntensityMidtones: number;
	FilmGrainIntensityHighlights: number;
	FilmGrainShadowsMax: number;
	FilmGrainHighlightsMin: number;
	FilmGrainHighlightsMax: number;
	FilmGrainTexelSize: number;
	FilmGrainTexture: Texture2D;
	AmbientOcclusionIntensity: number;
	AmbientOcclusionStaticFraction: number;
	AmbientOcclusionRadius: number;
	AmbientOcclusionRadiusInWS: boolean;
	AmbientOcclusionFadeDistance: number;
	AmbientOcclusionFadeRadius: number;
	AmbientOcclusionDistance: number;
	AmbientOcclusionPower: number;
	AmbientOcclusionBias: number;
	AmbientOcclusionQuality: number;
	AmbientOcclusionMipBlend: number;
	AmbientOcclusionMipScale: number;
	AmbientOcclusionMipThreshold: number;
	AmbientOcclusionTemporalBlendWeight: number;
	RayTracingAO: boolean;
	RayTracingAOSamplesPerPixel: number;
	RayTracingAOIntensity: number;
	RayTracingAORadius: number;
	ColorGradingIntensity: number;
	ColorGradingLUT: Texture;
	DepthOfFieldSensorWidth: number;
	DepthOfFieldSqueezeFactor: number;
	DepthOfFieldFocalDistance: number;
	DepthOfFieldDepthBlurAmount: number;
	DepthOfFieldDepthBlurRadius: number;
	DepthOfFieldFocalRegion: number;
	DepthOfFieldNearTransitionRegion: number;
	DepthOfFieldFarTransitionRegion: number;
	DepthOfFieldScale: number;
	DepthOfFieldNearBlurSize: number;
	DepthOfFieldFarBlurSize: number;
	DepthOfFieldOcclusion: number;
	DepthOfFieldSkyFocusDistance: number;
	DepthOfFieldVignetteSize: number;
	MotionBlurAmount: number;
	MotionBlurMax: number;
	MotionBlurTargetFPS: number;
	MotionBlurPerObjectSize: number;
	LPVIntensity: number;
	LPVVplInjectionBias: number;
	LPVSize: number;
	LPVSecondaryOcclusionIntensity: number;
	LPVSecondaryBounceIntensity: number;
	LPVGeometryVolumeBias: number;
	LPVEmissiveInjectionIntensity: number;
	LPVDirectionalOcclusionIntensity: number;
	LPVDirectionalOcclusionRadius: number;
	LPVDiffuseOcclusionExponent: number;
	LPVSpecularOcclusionExponent: number;
	LPVDiffuseOcclusionIntensity: number;
	LPVSpecularOcclusionIntensity: number;
	TranslucencyType: ETranslucencyType;
	RayTracingTranslucencyMaxRoughness: number;
	RayTracingTranslucencyRefractionRays: number;
	RayTracingTranslucencySamplesPerPixel: number;
	RayTracingTranslucencyShadows: EReflectedAndRefractedRayTracedShadows;
	RayTracingTranslucencyRefraction: boolean;
	PathTracingMaxBounces: number;
	PathTracingSamplesPerPixel: number;
	PathTracingFilterWidth: number;
	PathTracingEnableEmissive: boolean;
	PathTracingMaxPathExposure: number;
	PathTracingEnableReferenceDOF: boolean;
	PathTracingEnableReferenceAtmosphere: boolean;
	PathTracingEnableDenoiser: boolean;
	LPVFadeRange: number;
	LPVDirectionalOcclusionFadeRange: number;
	ScreenPercentage: number;
	WeightedBlendables: WeightedBlendables;
	Blendables: UObject[];
	clone() : PostProcessSettings;
	static C(Other: UObject | any): PostProcessSettings;
}

declare class MinimalViewInfo { 
	Location: Vector;
	Rotation: Rotator;
	FOV: number;
	DesiredFOV: number;
	OrthoWidth: number;
	OrthoNearClipPlane: number;
	OrthoFarClipPlane: number;
	PerspectiveNearClipPlane: number;
	AspectRatio: number;
	bConstrainAspectRatio: boolean;
	bUseFieldOfViewForLOD: boolean;
	ProjectionMode: ECameraProjectionMode;
	PostProcessBlendWeight: number;
	PostProcessSettings: PostProcessSettings;
	OffCenterProjectionOffset: Vector2D;
	clone() : MinimalViewInfo;
	static C(Other: UObject | any): MinimalViewInfo;
	CalculateProjectionMatrix(): Matrix;
	GetViewProjectionMatrix(ViewMatrix?: Matrix,ProjectionMatrix?: Matrix,ViewProjectionMatrix?: Matrix): {ViewMatrix: Matrix, ProjectionMatrix: Matrix, ViewProjectionMatrix: Matrix};
	static CalculateProjectionMatrix(MinimalViewInfo: MinimalViewInfo): Matrix;
	static GetViewProjectionMatrix(DesiredView: MinimalViewInfo,ViewMatrix?: Matrix,ProjectionMatrix?: Matrix,ViewProjectionMatrix?: Matrix): {ViewMatrix: Matrix, ProjectionMatrix: Matrix, ViewProjectionMatrix: Matrix};
}

declare class CameraCacheEntry { 
	Timestamp: number;
	POV: MinimalViewInfo;
	clone() : CameraCacheEntry;
	static C(Other: UObject | any): CameraCacheEntry;
}

declare class TViewTarget { 
	Target: Actor;
	POV: MinimalViewInfo;
	PlayerState: PlayerState;
	clone() : TViewTarget;
	static C(Other: UObject | any): TViewTarget;
}

declare class CameraModifier extends UObject { 
	bDebug: boolean;
	bExclusive: boolean;
	Priority: number;
	CameraOwner: PlayerCameraManager;
	AlphaInTime: number;
	AlphaOutTime: number;
	Alpha: number;
	static Load(ResourceName: string): CameraModifier;
	static Find(Outer: UObject, ResourceName: string): CameraModifier;
	static GetDefaultObject(): CameraModifier;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraModifier;
	OnCameraOwnerDestroyed(InOwner: Actor): void;
	IsDisabled(): boolean;
	GetViewTarget(): Actor;
	EnableModifier(): void;
	DisableModifier(bImmediate: boolean): void;
	BlueprintModifyPostProcess(DeltaTime: number,PostProcessBlendWeight?: number,PostProcessSettings?: PostProcessSettings): {PostProcessBlendWeight: number, PostProcessSettings: PostProcessSettings};
	BlueprintModifyCamera(DeltaTime: number,ViewLocation: Vector,ViewRotation: Rotator,FOV: number,NewViewLocation?: Vector,NewViewRotation?: Rotator,NewFOV?: number): {NewViewLocation: Vector, NewViewRotation: Rotator, NewFOV: number};
	static C(Other: UObject | any): CameraModifier;
}

declare type EAttachmentRule = 'KeepRelative' | 'KeepWorld' | 'SnapToTarget' | 'EAttachmentRule_MAX';
declare var EAttachmentRule : { KeepRelative:'KeepRelative',KeepWorld:'KeepWorld',SnapToTarget:'SnapToTarget',EAttachmentRule_MAX:'EAttachmentRule_MAX', };
declare class FXSystemAsset extends UObject { 
	MaxPoolSize: number;
	PoolPrimeSize: number;
	static Load(ResourceName: string): FXSystemAsset;
	static Find(Outer: UObject, ResourceName: string): FXSystemAsset;
	static GetDefaultObject(): FXSystemAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FXSystemAsset;
	static C(Other: UObject | any): FXSystemAsset;
}

declare class FXSystemComponent extends PrimitiveComponent { 
	static Load(ResourceName: string): FXSystemComponent;
	static Find(Outer: UObject, ResourceName: string): FXSystemComponent;
	static GetDefaultObject(): FXSystemComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): FXSystemComponent;
	SetVectorParameter(ParameterName: string,Param: Vector): void;
	SetUseAutoManageAttachment(bAutoManage: boolean): void;
	SetIntParameter(ParameterName: string,Param: number): void;
	SetFloatParameter(ParameterName: string,Param: number): void;
	SetEmitterEnable(EmitterName: string,bNewEnableState: boolean): void;
	SetColorParameter(ParameterName: string,Param: LinearColor): void;
	SetBoolParameter(ParameterName: string,Param: boolean): void;
	SetAutoAttachmentParameters(Parent: SceneComponent,SocketName: string,LocationRule: EAttachmentRule,RotationRule: EAttachmentRule,ScaleRule: EAttachmentRule): void;
	SetActorParameter(ParameterName: string,Param: Actor): void;
	ReleaseToPool(): void;
	GetFXSystemAsset(): FXSystemAsset;
	static C(Other: UObject | any): FXSystemComponent;
}

declare class CameraLensEffectInterface extends Interface { 
	static Load(ResourceName: string): CameraLensEffectInterface;
	static Find(Outer: UObject, ResourceName: string): CameraLensEffectInterface;
	static GetDefaultObject(): CameraLensEffectInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraLensEffectInterface;
	GetPrimaryParticleComponent(): FXSystemComponent;
	GetParticleComponents(): FXSystemComponent[];
	static C(Other: UObject | any): CameraLensEffectInterface;
}

declare class CameraShakePattern extends UObject { 
	static Load(ResourceName: string): CameraShakePattern;
	static Find(Outer: UObject, ResourceName: string): CameraShakePattern;
	static GetDefaultObject(): CameraShakePattern;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraShakePattern;
	static C(Other: UObject | any): CameraShakePattern;
}

declare type EInitialOscillatorOffset = 'EOO_OffsetRandom' | 'EOO_OffsetZero' | 'EOO_MAX';
declare var EInitialOscillatorOffset : { EOO_OffsetRandom:'EOO_OffsetRandom',EOO_OffsetZero:'EOO_OffsetZero',EOO_MAX:'EOO_MAX', };
declare type EOscillatorWaveform = 'SineWave' | 'PerlinNoise' | 'EOscillatorWaveform_MAX';
declare var EOscillatorWaveform : { SineWave:'SineWave',PerlinNoise:'PerlinNoise',EOscillatorWaveform_MAX:'EOscillatorWaveform_MAX', };
declare class FOscillator { 
	Amplitude: number;
	Frequency: number;
	InitialOffset: EInitialOscillatorOffset;
	Waveform: EOscillatorWaveform;
	clone() : FOscillator;
	static C(Other: UObject | any): FOscillator;
}

declare class ROscillator { 
	Pitch: FOscillator;
	Yaw: FOscillator;
	Roll: FOscillator;
	clone() : ROscillator;
	static C(Other: UObject | any): ROscillator;
}

declare class VOscillator { 
	X: FOscillator;
	Y: FOscillator;
	Z: FOscillator;
	clone() : VOscillator;
	static C(Other: UObject | any): VOscillator;
}

declare class MovieSceneSignedObject extends UObject { 
	Signature: Guid;
	static Load(ResourceName: string): MovieSceneSignedObject;
	static Find(Outer: UObject, ResourceName: string): MovieSceneSignedObject;
	static GetDefaultObject(): MovieSceneSignedObject;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneSignedObject;
	static C(Other: UObject | any): MovieSceneSignedObject;
}

declare class MovieSceneTrackIdentifier { 
	Value: number;
	clone() : MovieSceneTrackIdentifier;
	static C(Other: UObject | any): MovieSceneTrackIdentifier;
}

declare type EEvaluationMethod = 'Static' | 'Swept' | 'EEvaluationMethod_MAX';
declare var EEvaluationMethod : { Static:'Static',Swept:'Swept',EEvaluationMethod_MAX:'EEvaluationMethod_MAX', };
declare class MovieSceneTrackEvalOptions { 
	bCanEvaluateNearestSection: boolean;
	bEvalNearestSection: boolean;
	bEvaluateInPreroll: boolean;
	bEvaluateInPostroll: boolean;
	bEvaluateNearestSection: boolean;
	clone() : MovieSceneTrackEvalOptions;
	static C(Other: UObject | any): MovieSceneTrackEvalOptions;
}

declare class MovieSceneTrackDisplayOptions { 
	bShowVerticalFrames: boolean;
	clone() : MovieSceneTrackDisplayOptions;
	static C(Other: UObject | any): MovieSceneTrackDisplayOptions;
}

declare type EMovieSceneCompletionMode = 'KeepState' | 'RestoreState' | 'ProjectDefault' | 'EMovieSceneCompletionMode_MAX';
declare var EMovieSceneCompletionMode : { KeepState:'KeepState',RestoreState:'RestoreState',ProjectDefault:'ProjectDefault',EMovieSceneCompletionMode_MAX:'EMovieSceneCompletionMode_MAX', };
declare class MovieSceneSectionEvalOptions { 
	bCanEditCompletionMode: boolean;
	CompletionMode: EMovieSceneCompletionMode;
	clone() : MovieSceneSectionEvalOptions;
	static C(Other: UObject | any): MovieSceneSectionEvalOptions;
}

declare class MovieSceneEasingFunction extends Interface { 
	static Load(ResourceName: string): MovieSceneEasingFunction;
	static Find(Outer: UObject, ResourceName: string): MovieSceneEasingFunction;
	static GetDefaultObject(): MovieSceneEasingFunction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneEasingFunction;
	OnEvaluate(Interp: number): number;
	static C(Other: UObject | any): MovieSceneEasingFunction;
}

declare class MovieSceneEasingSettings { 
	AutoEaseInDuration: number;
	AutoEaseOutDuration: number;
	EaseIn: MovieSceneEasingFunction;
	bManualEaseIn: boolean;
	ManualEaseInDuration: number;
	EaseOut: MovieSceneEasingFunction;
	bManualEaseOut: boolean;
	ManualEaseOutDuration: number;
	AutoEaseInTime: number;
	AutoEaseOutTime: number;
	ManualEaseInTime: number;
	ManualEaseOutTime: number;
	clone() : MovieSceneEasingSettings;
	static C(Other: UObject | any): MovieSceneEasingSettings;
}

declare class MovieSceneFrameRange { 
	clone() : MovieSceneFrameRange;
	static C(Other: UObject | any): MovieSceneFrameRange;
}

declare class Timecode { 
	Hours: number;
	Minutes: number;
	Seconds: number;
	Frames: number;
	bDropFrameFormat: boolean;
	clone() : Timecode;
	static C(Other: UObject | any): Timecode;
	Conv_TimecodeToString(bForceSignDisplay: boolean): string;
	static Conv_TimecodeToString(InTimecode: Timecode,bForceSignDisplay: boolean): string;
	static GetTimecode(): Timecode;
}

declare class MovieSceneTimecodeSource { 
	Timecode: Timecode;
	clone() : MovieSceneTimecodeSource;
	static C(Other: UObject | any): MovieSceneTimecodeSource;
}

declare type EMovieSceneBlendType = 'Invalid' | 'Absolute' | 'Additive' | 'Relative' | 'AdditiveFromBase' | 'EMovieSceneBlendType_MAX';
declare var EMovieSceneBlendType : { Invalid:'Invalid',Absolute:'Absolute',Additive:'Additive',Relative:'Relative',AdditiveFromBase:'AdditiveFromBase',EMovieSceneBlendType_MAX:'EMovieSceneBlendType_MAX', };
declare class OptionalMovieSceneBlendType { 
	BlendType: EMovieSceneBlendType;
	bIsValid: boolean;
	clone() : OptionalMovieSceneBlendType;
	static C(Other: UObject | any): OptionalMovieSceneBlendType;
}

declare type ESequenceTimeUnit = 'DisplayRate' | 'TickResolution' | 'ESequenceTimeUnit_MAX';
declare var ESequenceTimeUnit : { DisplayRate:'DisplayRate',TickResolution:'TickResolution',ESequenceTimeUnit_MAX:'ESequenceTimeUnit_MAX', };
declare class MovieSceneScriptingChannel extends UObject { 
	ChannelName: string;
	static Load(ResourceName: string): MovieSceneScriptingChannel;
	static Find(Outer: UObject, ResourceName: string): MovieSceneScriptingChannel;
	static GetDefaultObject(): MovieSceneScriptingChannel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneScriptingChannel;
	static C(Other: UObject | any): MovieSceneScriptingChannel;
}

declare class MovieSceneSection extends MovieSceneSignedObject { 
	EvalOptions: MovieSceneSectionEvalOptions;
	Easing: MovieSceneEasingSettings;
	SectionRange: MovieSceneFrameRange;
	TimecodeSource: MovieSceneTimecodeSource;
	PreRollFrames: FrameNumber;
	PostRollFrames: FrameNumber;
	RowIndex: number;
	OverlapPriority: number;
	bIsActive: boolean;
	bIsLocked: boolean;
	StartTime: number;
	EndTime: number;
	PrerollTime: number;
	PostrollTime: number;
	bIsInfinite: boolean;
	bSupportsInfiniteRange: boolean;
	BlendType: OptionalMovieSceneBlendType;
	static Load(ResourceName: string): MovieSceneSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneSection;
	static GetDefaultObject(): MovieSceneSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneSection;
	SetRowIndex(NewRowIndex: number): void;
	SetPreRollFrames(InPreRollFrames: number): void;
	SetPostRollFrames(InPostRollFrames: number): void;
	SetOverlapPriority(NewPriority: number): void;
	SetIsLocked(bInIsLocked: boolean): void;
	SetIsActive(bInIsActive: boolean): void;
	SetCompletionMode(InCompletionMode: EMovieSceneCompletionMode): void;
	SetBlendType(InBlendType: EMovieSceneBlendType): void;
	IsLocked(): boolean;
	IsActive(): boolean;
	GetRowIndex(): number;
	GetPreRollFrames(): number;
	GetPostRollFrames(): number;
	GetOverlapPriority(): number;
	GetCompletionMode(): EMovieSceneCompletionMode;
	GetBlendType(): OptionalMovieSceneBlendType;
	static C(Other: UObject | any): MovieSceneSection;
	GetControlsMask(ControlName: string): boolean;
	HideAllControls(): void;
	LoadAnimSequenceIntoControlRigSection(AnimSequence: AnimSequence,SkelMeshComp: SkeletalMeshComponent,InStartFrame: FrameNumber,TimeUnit: ESequenceTimeUnit,bKeyReduce: boolean,Tolerance: number): boolean;
	SetControlsMask(ControlNames: string[],bVisible: boolean): void;
	ShowAllControls(): void;
	FindChannelsByType(ChannelType: UnrealEngineClass): MovieSceneScriptingChannel[];
	GetAllChannels(): MovieSceneScriptingChannel[];
	GetAutoSizeEndFrame(): number;
	GetAutoSizeEndFrameSeconds(): number;
	GetAutoSizeHasEndFrame(): boolean;
	GetAutoSizeHasStartFrame(): boolean;
	GetAutoSizeStartFrame(): number;
	GetAutoSizeStartFrameSeconds(): number;
	GetChannels(): MovieSceneScriptingChannel[];
	GetChannelsByType(ChannelType: UnrealEngineClass): MovieSceneScriptingChannel[];
	GetEndFrame(): number;
	GetEndFrameSeconds(): number;
	GetStartFrame(): number;
	GetStartFrameSeconds(): number;
	HasEndFrame(): boolean;
	HasStartFrame(): boolean;
	SetEndFrame(EndFrame: number): void;
	SetEndFrameBounded(bIsBounded: boolean): void;
	SetEndFrameSeconds(EndTime: number): void;
	SetRange(StartFrame: number,EndFrame: number): void;
	SetRangeSeconds(StartTime: number,EndTime: number): void;
	SetStartFrame(StartFrame: number): void;
	SetStartFrameBounded(bIsBounded: boolean): void;
	SetStartFrameSeconds(StartTime: number): void;
	static GetControlsMask(InSection: MovieSceneSection,ControlName: string): boolean;
	static HideAllControls(InSection: MovieSceneSection): void;
	static LoadAnimSequenceIntoControlRigSection(MovieSceneSection: MovieSceneSection,AnimSequence: AnimSequence,SkelMeshComp: SkeletalMeshComponent,InStartFrame: FrameNumber,TimeUnit: ESequenceTimeUnit,bKeyReduce: boolean,Tolerance: number): boolean;
	static SetControlsMask(InSection: MovieSceneSection,ControlNames: string[],bVisible: boolean): void;
	static ShowAllControls(InSection: MovieSceneSection): void;
	static FindChannelsByType(Section: MovieSceneSection,ChannelType: UnrealEngineClass): MovieSceneScriptingChannel[];
	static GetAllChannels(Section: MovieSceneSection): MovieSceneScriptingChannel[];
	static GetAutoSizeEndFrame(Section: MovieSceneSection): number;
	static GetAutoSizeEndFrameSeconds(Section: MovieSceneSection): number;
	static GetAutoSizeHasEndFrame(Section: MovieSceneSection): boolean;
	static GetAutoSizeHasStartFrame(Section: MovieSceneSection): boolean;
	static GetAutoSizeStartFrame(Section: MovieSceneSection): number;
	static GetAutoSizeStartFrameSeconds(Section: MovieSceneSection): number;
	static GetChannels(Section: MovieSceneSection): MovieSceneScriptingChannel[];
	static GetChannelsByType(Section: MovieSceneSection,ChannelType: UnrealEngineClass): MovieSceneScriptingChannel[];
	static GetEndFrame(Section: MovieSceneSection): number;
	static GetEndFrameSeconds(Section: MovieSceneSection): number;
	static GetStartFrame(Section: MovieSceneSection): number;
	static GetStartFrameSeconds(Section: MovieSceneSection): number;
	static HasEndFrame(Section: MovieSceneSection): boolean;
	static HasStartFrame(Section: MovieSceneSection): boolean;
	static SetEndFrame(Section: MovieSceneSection,EndFrame: number): void;
	static SetEndFrameBounded(Section: MovieSceneSection,bIsBounded: boolean): void;
	static SetEndFrameSeconds(Section: MovieSceneSection,EndTime: number): void;
	static SetRange(Section: MovieSceneSection,StartFrame: number,EndFrame: number): void;
	static SetRangeSeconds(Section: MovieSceneSection,StartTime: number,EndTime: number): void;
	static SetStartFrame(Section: MovieSceneSection,StartFrame: number): void;
	static SetStartFrameBounded(Section: MovieSceneSection,bIsBounded: boolean): void;
	static SetStartFrameSeconds(Section: MovieSceneSection,StartTime: number): void;
}

declare class FrameNumberRangeBound { 
	Type: ERangeBoundTypes;
	Value: FrameNumber;
	clone() : FrameNumberRangeBound;
	static C(Other: UObject | any): FrameNumberRangeBound;
}

declare class FrameNumberRange { 
	LowerBound: FrameNumberRangeBound;
	UpperBound: FrameNumberRangeBound;
	clone() : FrameNumberRange;
	static C(Other: UObject | any): FrameNumberRange;
}

declare type ESectionEvaluationFlags = 'None' | 'PreRoll' | 'PostRoll' | 'ESectionEvaluationFlags_MAX';
declare var ESectionEvaluationFlags : { None:'None',PreRoll:'PreRoll',PostRoll:'PostRoll',ESectionEvaluationFlags_MAX:'ESectionEvaluationFlags_MAX', };
declare class MovieSceneTrackEvaluationFieldEntry { 
	Section: MovieSceneSection;
	Range: FrameNumberRange;
	ForcedTime: FrameNumber;
	Flags: ESectionEvaluationFlags;
	LegacySortOrder: number;
	clone() : MovieSceneTrackEvaluationFieldEntry;
	static C(Other: UObject | any): MovieSceneTrackEvaluationFieldEntry;
}

declare class MovieSceneTrackEvaluationField { 
	Entries: MovieSceneTrackEvaluationFieldEntry[];
	clone() : MovieSceneTrackEvaluationField;
	static C(Other: UObject | any): MovieSceneTrackEvaluationField;
}

declare class MovieSceneTrack extends MovieSceneSignedObject { 
	EvalOptions: MovieSceneTrackEvalOptions;
	DisplayOptions: MovieSceneTrackDisplayOptions;
	bIsEvalDisabled: boolean;
	RowsDisabled: number[];
	EvaluationFieldGuid: Guid;
	EvaluationFieldVersion: number;
	EvaluationField: MovieSceneTrackEvaluationField;
	ObjectBindingID: Guid;
	TrackTint: Color;
	SortingOrder: number;
	bSupportsDefaultSections: boolean;
	static Load(ResourceName: string): MovieSceneTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneTrack;
	static GetDefaultObject(): MovieSceneTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneTrack;
	static C(Other: UObject | any): MovieSceneTrack;
	AddSection(): MovieSceneSection;
	GetColorTint(): Color;
	GetDisplayName(): string;
	GetSections(): MovieSceneSection[];
	GetSectionToKey(): MovieSceneSection;
	GetSortingOrder(): number;
	GetTrackRowDisplayName(RowIndex: number): string;
	RemoveSection(Section: MovieSceneSection): void;
	SetColorTint(ColorTint: Color): void;
	SetDisplayName(InName: string): void;
	SetSectionToKey(Section: MovieSceneSection): void;
	SetSortingOrder(SortingOrder: number): void;
	SetTrackRowDisplayName(InName: string,RowIndex: number): void;
	static AddSection(Track: MovieSceneTrack): MovieSceneSection;
	static GetColorTint(Track: MovieSceneTrack): Color;
	static GetDisplayName(Track: MovieSceneTrack): string;
	static GetSections(Track: MovieSceneTrack): MovieSceneSection[];
	static GetSectionToKey(Track: MovieSceneTrack): MovieSceneSection;
	static GetSortingOrder(Track: MovieSceneTrack): number;
	static GetTrackRowDisplayName(Track: MovieSceneTrack,RowIndex: number): string;
	static RemoveSection(Track: MovieSceneTrack,Section: MovieSceneSection): void;
	static SetColorTint(Track: MovieSceneTrack,ColorTint: Color): void;
	static SetDisplayName(Track: MovieSceneTrack,InName: string): void;
	static SetSectionToKey(Track: MovieSceneTrack,Section: MovieSceneSection): void;
	static SetSortingOrder(Track: MovieSceneTrack,SortingOrder: number): void;
	static SetTrackRowDisplayName(Track: MovieSceneTrack,InName: string,RowIndex: number): void;
}

declare class MovieSceneEvalTemplatePtr { 
	clone() : MovieSceneEvalTemplatePtr;
	static C(Other: UObject | any): MovieSceneEvalTemplatePtr;
}

declare class MovieSceneTrackImplementationPtr { 
	clone() : MovieSceneTrackImplementationPtr;
	static C(Other: UObject | any): MovieSceneTrackImplementationPtr;
}

declare class MovieSceneEvaluationTrack { 
	ObjectBindingID: Guid;
	EvaluationPriority: number;
	EvaluationMethod: EEvaluationMethod;
	SourceTrack: MovieSceneTrack;
	ChildTemplates: MovieSceneEvalTemplatePtr[];
	TrackTemplate: MovieSceneTrackImplementationPtr;
	EvaluationGroup: string;
	bEvaluateInPreroll: boolean;
	bEvaluateInPostroll: boolean;
	bTearDownPriority: boolean;
	clone() : MovieSceneEvaluationTrack;
	static C(Other: UObject | any): MovieSceneEvaluationTrack;
}

declare class MovieSceneEvaluationTemplateSerialNumber { 
	Value: number;
	clone() : MovieSceneEvaluationTemplateSerialNumber;
	static C(Other: UObject | any): MovieSceneEvaluationTemplateSerialNumber;
}

declare class MovieSceneTemplateGenerationLedger { 
	LastTrackIdentifier: MovieSceneTrackIdentifier;
	TrackSignatureToTrackIdentifier: Map<Guid, MovieSceneTrackIdentifier>;
	SubSectionRanges: Map<Guid, MovieSceneFrameRange>;
	clone() : MovieSceneTemplateGenerationLedger;
	static C(Other: UObject | any): MovieSceneTemplateGenerationLedger;
}

declare class MovieSceneEvaluationTemplate { 
	Tracks: Map<MovieSceneTrackIdentifier, MovieSceneEvaluationTrack>;
	SequenceSignature: Guid;
	TemplateSerialNumber: MovieSceneEvaluationTemplateSerialNumber;
	TemplateLedger: MovieSceneTemplateGenerationLedger;
	clone() : MovieSceneEvaluationTemplate;
	static C(Other: UObject | any): MovieSceneEvaluationTemplate;
}

declare class MovieSceneSequenceID { 
	Value: number;
	clone() : MovieSceneSequenceID;
	static C(Other: UObject | any): MovieSceneSequenceID;
}

declare class MovieSceneSequenceHierarchyNode { 
	ParentID: MovieSceneSequenceID;
	Children: MovieSceneSequenceID[];
	clone() : MovieSceneSequenceHierarchyNode;
	static C(Other: UObject | any): MovieSceneSequenceHierarchyNode;
}

declare class MovieSceneSubSequenceTree { 
	clone() : MovieSceneSubSequenceTree;
	static C(Other: UObject | any): MovieSceneSubSequenceTree;
}

declare class MovieSceneTimeTransform { 
	TimeScale: number;
	Offset: FrameTime;
	clone() : MovieSceneTimeTransform;
	static C(Other: UObject | any): MovieSceneTimeTransform;
}

declare class MovieSceneTimeWarping { 
	Start: FrameNumber;
	End: FrameNumber;
	clone() : MovieSceneTimeWarping;
	static C(Other: UObject | any): MovieSceneTimeWarping;
}

declare class MovieSceneNestedSequenceTransform { 
	LinearTransform: MovieSceneTimeTransform;
	Warping: MovieSceneTimeWarping;
	clone() : MovieSceneNestedSequenceTransform;
	static C(Other: UObject | any): MovieSceneNestedSequenceTransform;
}

declare class MovieSceneSequenceTransform { 
	LinearTransform: MovieSceneTimeTransform;
	NestedTransforms: MovieSceneNestedSequenceTransform[];
	clone() : MovieSceneSequenceTransform;
	static C(Other: UObject | any): MovieSceneSequenceTransform;
}

declare class MovieSceneSequenceInstanceDataPtr { 
	clone() : MovieSceneSequenceInstanceDataPtr;
	static C(Other: UObject | any): MovieSceneSequenceInstanceDataPtr;
}

declare class MovieSceneSubSequenceData { 
	Sequence: SoftObjectPath;
	OuterToInnerTransform: MovieSceneSequenceTransform;
	RootToSequenceTransform: MovieSceneSequenceTransform;
	TickResolution: FrameRate;
	DeterministicSequenceID: MovieSceneSequenceID;
	ParentPlayRange: MovieSceneFrameRange;
	ParentStartFrameOffset: FrameNumber;
	ParentEndFrameOffset: FrameNumber;
	ParentFirstLoopStartFrameOffset: FrameNumber;
	bCanLoop: boolean;
	PlayRange: MovieSceneFrameRange;
	FullPlayRange: MovieSceneFrameRange;
	UnwarpedPlayRange: MovieSceneFrameRange;
	PreRollRange: MovieSceneFrameRange;
	PostRollRange: MovieSceneFrameRange;
	HierarchicalBias: number;
	bHasHierarchicalEasing: boolean;
	InstanceData: MovieSceneSequenceInstanceDataPtr;
	SectionPath: string;
	SubSectionSignature: Guid;
	clone() : MovieSceneSubSequenceData;
	static C(Other: UObject | any): MovieSceneSubSequenceData;
}

declare class MovieSceneSequenceHierarchy { 
	RootNode: MovieSceneSequenceHierarchyNode;
	Tree: MovieSceneSubSequenceTree;
	SubSequences: Map<MovieSceneSequenceID, MovieSceneSubSequenceData>;
	Hierarchy: Map<MovieSceneSequenceID, MovieSceneSequenceHierarchyNode>;
	clone() : MovieSceneSequenceHierarchy;
	static C(Other: UObject | any): MovieSceneSequenceHierarchy;
}

declare class MovieSceneEvaluationFieldEntityTree { 
	clone() : MovieSceneEvaluationFieldEntityTree;
	static C(Other: UObject | any): MovieSceneEvaluationFieldEntityTree;
}

declare class MovieSceneEvaluationFieldEntityKey { 
	EntityOwner: UObject;
	EntityID: number;
	clone() : MovieSceneEvaluationFieldEntityKey;
	static C(Other: UObject | any): MovieSceneEvaluationFieldEntityKey;
}

declare class MovieSceneEvaluationFieldEntity { 
	Key: MovieSceneEvaluationFieldEntityKey;
	SharedMetaDataIndex: number;
	clone() : MovieSceneEvaluationFieldEntity;
	static C(Other: UObject | any): MovieSceneEvaluationFieldEntity;
}

declare class MovieSceneEvaluationFieldEntityMetaData { 
	OverrideBoundPropertyPath: string;
	ForcedTime: FrameNumber;
	Flags: ESectionEvaluationFlags;
	bEvaluateInSequencePreRoll: boolean;
	bEvaluateInSequencePostRoll: boolean;
	clone() : MovieSceneEvaluationFieldEntityMetaData;
	static C(Other: UObject | any): MovieSceneEvaluationFieldEntityMetaData;
}

declare class MovieSceneEvaluationFieldSharedEntityMetaData { 
	ObjectBindingID: Guid;
	clone() : MovieSceneEvaluationFieldSharedEntityMetaData;
	static C(Other: UObject | any): MovieSceneEvaluationFieldSharedEntityMetaData;
}

declare class MovieSceneEntityComponentField { 
	PersistentEntityTree: MovieSceneEvaluationFieldEntityTree;
	OneShotEntityTree: MovieSceneEvaluationFieldEntityTree;
	Entities: MovieSceneEvaluationFieldEntity[];
	EntityMetaData: MovieSceneEvaluationFieldEntityMetaData[];
	SharedMetaData: MovieSceneEvaluationFieldSharedEntityMetaData[];
	clone() : MovieSceneEntityComponentField;
	static C(Other: UObject | any): MovieSceneEntityComponentField;
}

declare class MovieSceneEvaluationGroupLUTIndex { 
	NumInitPtrs: number;
	NumEvalPtrs: number;
	clone() : MovieSceneEvaluationGroupLUTIndex;
	static C(Other: UObject | any): MovieSceneEvaluationGroupLUTIndex;
}

declare class MovieSceneEvaluationFieldTrackPtr { 
	SequenceID: MovieSceneSequenceID;
	TrackIdentifier: MovieSceneTrackIdentifier;
	clone() : MovieSceneEvaluationFieldTrackPtr;
	static C(Other: UObject | any): MovieSceneEvaluationFieldTrackPtr;
}

declare class MovieSceneFieldEntry_EvaluationTrack { 
	TrackPtr: MovieSceneEvaluationFieldTrackPtr;
	NumChildren: number;
	clone() : MovieSceneFieldEntry_EvaluationTrack;
	static C(Other: UObject | any): MovieSceneFieldEntry_EvaluationTrack;
}

declare class MovieSceneFieldEntry_ChildTemplate { 
	ChildIndex: number;
	Flags: ESectionEvaluationFlags;
	ForcedTime: FrameNumber;
	clone() : MovieSceneFieldEntry_ChildTemplate;
	static C(Other: UObject | any): MovieSceneFieldEntry_ChildTemplate;
}

declare class MovieSceneEvaluationGroup { 
	LUTIndices: MovieSceneEvaluationGroupLUTIndex[];
	TrackLUT: MovieSceneFieldEntry_EvaluationTrack[];
	SectionLUT: MovieSceneFieldEntry_ChildTemplate[];
	clone() : MovieSceneEvaluationGroup;
	static C(Other: UObject | any): MovieSceneEvaluationGroup;
}

declare class MovieSceneEvaluationKey { 
	SequenceID: MovieSceneSequenceID;
	TrackIdentifier: MovieSceneTrackIdentifier;
	SectionIndex: number;
	clone() : MovieSceneEvaluationKey;
	static C(Other: UObject | any): MovieSceneEvaluationKey;
}

declare class MovieSceneOrderedEvaluationKey { 
	Key: MovieSceneEvaluationKey;
	SetupIndex: number;
	TearDownIndex: number;
	clone() : MovieSceneOrderedEvaluationKey;
	static C(Other: UObject | any): MovieSceneOrderedEvaluationKey;
}

declare class MovieSceneEvaluationMetaData { 
	ActiveSequences: MovieSceneSequenceID[];
	ActiveEntities: MovieSceneOrderedEvaluationKey[];
	clone() : MovieSceneEvaluationMetaData;
	static C(Other: UObject | any): MovieSceneEvaluationMetaData;
}

declare class MovieSceneEvaluationField { 
	Signature: Guid;
	Ranges: MovieSceneFrameRange[];
	Groups: MovieSceneEvaluationGroup[];
	MetaData: MovieSceneEvaluationMetaData[];
	clone() : MovieSceneEvaluationField;
	static C(Other: UObject | any): MovieSceneEvaluationField;
}

declare class MovieSceneSequenceCompilerMaskStruct { 
	bHierarchy: boolean;
	bEvaluationTemplate: boolean;
	bEvaluationTemplateField: boolean;
	bEntityComponentField: boolean;
	clone() : MovieSceneSequenceCompilerMaskStruct;
	static C(Other: UObject | any): MovieSceneSequenceCompilerMaskStruct;
}

declare type EMovieSceneSequenceFlags = 'None' | 'Volatile' | 'BlockingEvaluation' | 'InheritedFlags' | 'EMovieSceneSequenceFlags_MAX';
declare var EMovieSceneSequenceFlags : { None:'None',Volatile:'Volatile',BlockingEvaluation:'BlockingEvaluation',InheritedFlags:'InheritedFlags',EMovieSceneSequenceFlags_MAX:'EMovieSceneSequenceFlags_MAX', };
declare class MovieSceneCompiledData extends UObject { 
	EvaluationTemplate: MovieSceneEvaluationTemplate;
	Hierarchy: MovieSceneSequenceHierarchy;
	EntityComponentField: MovieSceneEntityComponentField;
	TrackTemplateField: MovieSceneEvaluationField;
	DeterminismFences: FrameTime[];
	CompiledSignature: Guid;
	CompilerVersion: Guid;
	AccumulatedMask: MovieSceneSequenceCompilerMaskStruct;
	AllocatedMask: MovieSceneSequenceCompilerMaskStruct;
	AccumulatedFlags: EMovieSceneSequenceFlags;
	static Load(ResourceName: string): MovieSceneCompiledData;
	static Find(Outer: UObject, ResourceName: string): MovieSceneCompiledData;
	static GetDefaultObject(): MovieSceneCompiledData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneCompiledData;
	static C(Other: UObject | any): MovieSceneCompiledData;
}

declare type EMovieSceneObjectBindingSpace = 'Local' | 'Root' | 'Unused' | 'EMovieSceneObjectBindingSpace_MAX';
declare var EMovieSceneObjectBindingSpace : { Local:'Local',Root:'Root',Unused:'Unused',EMovieSceneObjectBindingSpace_MAX:'EMovieSceneObjectBindingSpace_MAX', };
declare class MovieSceneObjectBindingID { 
	Guid: Guid;
	SequenceID: number;
	ResolveParentIndex: number;
	Space: EMovieSceneObjectBindingSpace;
	clone() : MovieSceneObjectBindingID;
	static C(Other: UObject | any): MovieSceneObjectBindingID;
	GetBoundObjects(): UObject[];
	static GetBoundObjects(ObjectBinding: MovieSceneObjectBindingID): UObject[];
}

declare class MovieSceneEventSectionBase extends MovieSceneSection { 
	static Load(ResourceName: string): MovieSceneEventSectionBase;
	static Find(Outer: UObject, ResourceName: string): MovieSceneEventSectionBase;
	static GetDefaultObject(): MovieSceneEventSectionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneEventSectionBase;
	static C(Other: UObject | any): MovieSceneEventSectionBase;
}

declare class K2Node_EditablePinBase extends K2Node { 
	bIsEditable: boolean;
	static Load(ResourceName: string): K2Node_EditablePinBase;
	static Find(Outer: UObject, ResourceName: string): K2Node_EditablePinBase;
	static GetDefaultObject(): K2Node_EditablePinBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_EditablePinBase;
	static C(Other: UObject | any): K2Node_EditablePinBase;
}

declare class K2Node_Event extends K2Node_EditablePinBase { 
	EventSignatureName: string;
	EventSignatureClass: UnrealEngineClass;
	EventReference: MemberReference;
	bOverrideFunction: boolean;
	bInternalEvent: boolean;
	CustomFunctionName: string;
	FunctionFlags: number;
	static Load(ResourceName: string): K2Node_Event;
	static Find(Outer: UObject, ResourceName: string): K2Node_Event;
	static GetDefaultObject(): K2Node_Event;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_Event;
	static C(Other: UObject | any): K2Node_Event;
}

declare class KismetUserDeclaredFunctionMetadata { 
	Tooltip: string;
	Category: string;
	Keywords: string;
	CompactNodeTitle: string;
	InstanceTitleColor: LinearColor;
	DeprecationMessage: string;
	bIsDeprecated: boolean;
	bCallInEditor: boolean;
	bThreadSafe: boolean;
	HasLatentFunctions: number;
	MetaDataMap: Map<string, string>;
	clone() : KismetUserDeclaredFunctionMetadata;
	static C(Other: UObject | any): KismetUserDeclaredFunctionMetadata;
}

declare class K2Node_CustomEvent extends K2Node_Event { 
	DeprecationMessage: string;
	bIsDeprecated: boolean;
	bCallInEditor: boolean;
	MetaData: KismetUserDeclaredFunctionMetadata;
	static Load(ResourceName: string): K2Node_CustomEvent;
	static Find(Outer: UObject, ResourceName: string): K2Node_CustomEvent;
	static GetDefaultObject(): K2Node_CustomEvent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): K2Node_CustomEvent;
	static C(Other: UObject | any): K2Node_CustomEvent;
}

declare class SequencerQuickBindingResult { 
	EventEndpoint: K2Node_CustomEvent;
	PayloadNames: string[];
	clone() : SequencerQuickBindingResult;
	static C(Other: UObject | any): SequencerQuickBindingResult;
	IsEventEndpointValid(): boolean;
	static IsEventEndpointValid(InEndpoint: SequencerQuickBindingResult): boolean;
}

declare class MovieSceneEventPtrs { 
	UFunction: UFunction;
	BoundObjectProperty: any;
	clone() : MovieSceneEventPtrs;
	static C(Other: UObject | any): MovieSceneEventPtrs;
}

declare class MovieSceneEventPayloadVariable { 
	Value: string;
	clone() : MovieSceneEventPayloadVariable;
	static C(Other: UObject | any): MovieSceneEventPayloadVariable;
}

declare class MovieSceneEvent { 
	Ptrs: MovieSceneEventPtrs;
	PayloadVariables: Map<string, MovieSceneEventPayloadVariable>;
	CompiledFunctionName: string;
	BoundObjectPinName: string;
	WeakEndpoint: UObject;
	GraphGuid: Guid;
	NodeGuid: Guid;
	FunctionEntry: UObject;
	clone() : MovieSceneEvent;
	static C(Other: UObject | any): MovieSceneEvent;
	GetBoundObjectPropertyClass(): UnrealEngineClass;
	static GetBoundObjectPropertyClass(EventKey: MovieSceneEvent): UnrealEngineClass;
}

declare class MovieSceneMarkedFrame { 
	FrameNumber: FrameNumber;
	Label: string;
	Color: LinearColor;
	bIsDeterminismFence: boolean;
	clone() : MovieSceneMarkedFrame;
	static C(Other: UObject | any): MovieSceneMarkedFrame;
}

declare class MovieSceneBindingProxy { 
	BindingID: Guid;
	Sequence: MovieSceneSequence;
	clone() : MovieSceneBindingProxy;
	static C(Other: UObject | any): MovieSceneBindingProxy;
	GetBindingID(): MovieSceneObjectBindingID;
	AddTrack(TrackType: UnrealEngineClass): MovieSceneTrack;
	FindTracksByExactType(TrackType: UnrealEngineClass): MovieSceneTrack[];
	FindTracksByType(TrackType: UnrealEngineClass): MovieSceneTrack[];
	GetChildPossessables(): MovieSceneBindingProxy[];
	GetDisplayName(): string;
	GetId(): Guid;
	GetName(): string;
	GetObjectTemplate(): UObject;
	GetParent(): MovieSceneBindingProxy;
	GetPossessedObjectClass(): UnrealEngineClass;
	GetTracks(): MovieSceneTrack[];
	IsValid(): boolean;
	MoveBindingContents(DestinationBindingId: MovieSceneBindingProxy): void;
	Remove(): void;
	RemoveTrack(TrackToRemove: MovieSceneTrack): void;
	SetDisplayName(InDisplayName: string): void;
	SetName(InName: string): void;
	SetParent(InParentBinding: MovieSceneBindingProxy): void;
	static GetBindingID(InBinding: MovieSceneBindingProxy): MovieSceneObjectBindingID;
	static AddTrack(InBinding: MovieSceneBindingProxy,TrackType: UnrealEngineClass): MovieSceneTrack;
	static FindTracksByExactType(InBinding: MovieSceneBindingProxy,TrackType: UnrealEngineClass): MovieSceneTrack[];
	static FindTracksByType(InBinding: MovieSceneBindingProxy,TrackType: UnrealEngineClass): MovieSceneTrack[];
	static GetChildPossessables(InBinding: MovieSceneBindingProxy): MovieSceneBindingProxy[];
	static GetDisplayName(InBinding: MovieSceneBindingProxy): string;
	static GetId(InBinding: MovieSceneBindingProxy): Guid;
	static GetName(InBinding: MovieSceneBindingProxy): string;
	static GetObjectTemplate(InBinding: MovieSceneBindingProxy): UObject;
	static GetParent(InBinding: MovieSceneBindingProxy): MovieSceneBindingProxy;
	static GetPossessedObjectClass(InBinding: MovieSceneBindingProxy): UnrealEngineClass;
	static GetTracks(InBinding: MovieSceneBindingProxy): MovieSceneTrack[];
	static IsValid(InBinding: MovieSceneBindingProxy): boolean;
	static MoveBindingContents(SourceBindingId: MovieSceneBindingProxy,DestinationBindingId: MovieSceneBindingProxy): void;
	static Remove(InBinding: MovieSceneBindingProxy): void;
	static RemoveTrack(InBinding: MovieSceneBindingProxy,TrackToRemove: MovieSceneTrack): void;
	static SetDisplayName(InBinding: MovieSceneBindingProxy,InDisplayName: string): void;
	static SetName(InBinding: MovieSceneBindingProxy,InName: string): void;
	static SetParent(InBinding: MovieSceneBindingProxy,InParentBinding: MovieSceneBindingProxy): void;
}

declare class MovieSceneFolder extends UObject { 
	FolderName: string;
	ChildFolders: MovieSceneFolder[];
	ChildMasterTracks: MovieSceneTrack[];
	ChildObjectBindingStrings: string[];
	FolderColor: Color;
	SortingOrder: number;
	static Load(ResourceName: string): MovieSceneFolder;
	static Find(Outer: UObject, ResourceName: string): MovieSceneFolder;
	static GetDefaultObject(): MovieSceneFolder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneFolder;
	static C(Other: UObject | any): MovieSceneFolder;
	AddChildFolder(FolderToAdd: MovieSceneFolder): boolean;
	AddChildMasterTrack(InMasterTrack: MovieSceneTrack): boolean;
	AddChildObjectBinding(InObjectBinding: MovieSceneBindingProxy): boolean;
	GetChildFolders(): MovieSceneFolder[];
	GetChildMasterTracks(): MovieSceneTrack[];
	GetChildObjectBindings(): MovieSceneBindingProxy[];
	GetFolderColor(): Color;
	GetFolderName(): string;
	RemoveChildFolder(FolderToRemove: MovieSceneFolder): boolean;
	RemoveChildMasterTrack(InMasterTrack: MovieSceneTrack): boolean;
	RemoveChildObjectBinding(InObjectBinding: MovieSceneBindingProxy): boolean;
	SetFolderColor(InFolderColor: Color): boolean;
	SetFolderName(InFolderName: string): boolean;
	static AddChildFolder(TargetFolder: MovieSceneFolder,FolderToAdd: MovieSceneFolder): boolean;
	static AddChildMasterTrack(Folder: MovieSceneFolder,InMasterTrack: MovieSceneTrack): boolean;
	static AddChildObjectBinding(Folder: MovieSceneFolder,InObjectBinding: MovieSceneBindingProxy): boolean;
	static GetChildFolders(Folder: MovieSceneFolder): MovieSceneFolder[];
	static GetChildMasterTracks(Folder: MovieSceneFolder): MovieSceneTrack[];
	static GetChildObjectBindings(Folder: MovieSceneFolder): MovieSceneBindingProxy[];
	static GetFolderColor(Folder: MovieSceneFolder): Color;
	static GetFolderName(Folder: MovieSceneFolder): string;
	static RemoveChildFolder(TargetFolder: MovieSceneFolder,FolderToRemove: MovieSceneFolder): boolean;
	static RemoveChildMasterTrack(Folder: MovieSceneFolder,InMasterTrack: MovieSceneTrack): boolean;
	static RemoveChildObjectBinding(Folder: MovieSceneFolder,InObjectBinding: MovieSceneBindingProxy): boolean;
	static SetFolderColor(Folder: MovieSceneFolder,InFolderColor: Color): boolean;
	static SetFolderName(Folder: MovieSceneFolder,InFolderName: string): boolean;
}

declare type EUpdateClockSource = 'Tick' | 'Platform' | 'Audio' | 'RelativeTimecode' | 'Timecode' | 'PlayEveryFrame' | 'Custom' | 'EUpdateClockSource_MAX';
declare var EUpdateClockSource : { Tick:'Tick',Platform:'Platform',Audio:'Audio',RelativeTimecode:'RelativeTimecode',Timecode:'Timecode',PlayEveryFrame:'PlayEveryFrame',Custom:'Custom',EUpdateClockSource_MAX:'EUpdateClockSource_MAX', };
declare type EMovieSceneEvaluationType = 'FrameLocked' | 'WithSubFrames' | 'EMovieSceneEvaluationType_MAX';
declare var EMovieSceneEvaluationType : { FrameLocked:'FrameLocked',WithSubFrames:'WithSubFrames',EMovieSceneEvaluationType_MAX:'EMovieSceneEvaluationType_MAX', };
declare type ESpawnOwnership = 'InnerSequence' | 'MasterSequence' | 'External' | 'ESpawnOwnership_MAX';
declare var ESpawnOwnership : { InnerSequence:'InnerSequence',MasterSequence:'MasterSequence',External:'External',ESpawnOwnership_MAX:'ESpawnOwnership_MAX', };
declare class MovieSceneSpawnable { 
	SpawnTransform: Transform;
	Tags: string[];
	bContinuouslyRespawn: boolean;
	bNetAddressableName: boolean;
	bEvaluateTracksWhenNotSpawned: boolean;
	Guid: Guid;
	Name: string;
	ObjectTemplate: UObject;
	ChildPossessables: Guid[];
	Ownership: ESpawnOwnership;
	GeneratedClass: UnrealEngineClass;
	LevelName: string;
	clone() : MovieSceneSpawnable;
	static C(Other: UObject | any): MovieSceneSpawnable;
}

declare class MovieScenePossessable { 
	Tags: string[];
	Guid: Guid;
	Name: string;
	PossessedObjectClass: Class;
	ParentGuid: Guid;
	SpawnableObjectBindingID: MovieSceneObjectBindingID;
	clone() : MovieScenePossessable;
	static C(Other: UObject | any): MovieScenePossessable;
}

declare class MovieSceneBinding { 
	ObjectGuid: Guid;
	BindingName: string;
	Tracks: MovieSceneTrack[];
	SortingOrder: number;
	clone() : MovieSceneBinding;
	static C(Other: UObject | any): MovieSceneBinding;
}

declare class MovieSceneObjectBindingIDs { 
	IDs: MovieSceneObjectBindingID[];
	clone() : MovieSceneObjectBindingIDs;
	static C(Other: UObject | any): MovieSceneObjectBindingIDs;
}

declare class MovieSceneTrackLabels { 
	Strings: string[];
	clone() : MovieSceneTrackLabels;
	static C(Other: UObject | any): MovieSceneTrackLabels;
}

declare class MovieSceneExpansionState { 
	bExpanded: boolean;
	clone() : MovieSceneExpansionState;
	static C(Other: UObject | any): MovieSceneExpansionState;
}

declare class FloatRangeBound { 
	Type: ERangeBoundTypes;
	Value: number;
	clone() : FloatRangeBound;
	static C(Other: UObject | any): FloatRangeBound;
}

declare class FloatRange { 
	LowerBound: FloatRangeBound;
	UpperBound: FloatRangeBound;
	clone() : FloatRange;
	static C(Other: UObject | any): FloatRange;
}

declare class MovieSceneEditorData { 
	ExpansionStates: Map<string, MovieSceneExpansionState>;
	PinnedNodes: string[];
	ViewStart: number;
	ViewEnd: number;
	WorkStart: number;
	WorkEnd: number;
	MarkedFrames: Set<FrameNumber>;
	WorkingRange: FloatRange;
	ViewRange: FloatRange;
	clone() : MovieSceneEditorData;
	static C(Other: UObject | any): MovieSceneEditorData;
}

declare class MovieSceneSectionGroup { 
	Sections: MovieSceneSection[];
	clone() : MovieSceneSectionGroup;
	static C(Other: UObject | any): MovieSceneSectionGroup;
}

declare class MovieSceneNodeGroup extends UObject { 
	Name: string;
	Nodes: string[];
	static Load(ResourceName: string): MovieSceneNodeGroup;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNodeGroup;
	static GetDefaultObject(): MovieSceneNodeGroup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNodeGroup;
	static C(Other: UObject | any): MovieSceneNodeGroup;
}

declare class MovieSceneNodeGroupCollection extends UObject { 
	NodeGroups: MovieSceneNodeGroup[];
	static Load(ResourceName: string): MovieSceneNodeGroupCollection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNodeGroupCollection;
	static GetDefaultObject(): MovieSceneNodeGroupCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNodeGroupCollection;
	static C(Other: UObject | any): MovieSceneNodeGroupCollection;
}

declare class MovieScene extends MovieSceneSignedObject { 
	Spawnables: MovieSceneSpawnable[];
	Possessables: MovieScenePossessable[];
	ObjectBindings: MovieSceneBinding[];
	BindingGroups: Map<string, MovieSceneObjectBindingIDs>;
	MasterTracks: MovieSceneTrack[];
	CameraCutTrack: MovieSceneTrack;
	SelectionRange: MovieSceneFrameRange;
	PlaybackRange: MovieSceneFrameRange;
	TickResolution: FrameRate;
	DisplayRate: FrameRate;
	EvaluationType: EMovieSceneEvaluationType;
	ClockSource: EUpdateClockSource;
	CustomClockSourcePath: SoftObjectPath;
	MarkedFrames: MovieSceneMarkedFrame[];
	bReadOnly: boolean;
	bPlaybackRangeLocked: boolean;
	ObjectsToDisplayNames: Map<string, string>;
	ObjectsToLabels: Map<string, MovieSceneTrackLabels>;
	EditorData: MovieSceneEditorData;
	RootFolders: MovieSceneFolder[];
	SoloNodes: string[];
	MuteNodes: string[];
	SectionGroups: MovieSceneSectionGroup[];
	NodeGroupCollection: MovieSceneNodeGroupCollection;
	InTime: number;
	OutTime: number;
	StartTime: number;
	EndTime: number;
	bForceFixedFrameIntervalPlayback: boolean;
	FixedFrameInterval: number;
	static Load(ResourceName: string): MovieScene;
	static Find(Outer: UObject, ResourceName: string): MovieScene;
	static GetDefaultObject(): MovieScene;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieScene;
	static C(Other: UObject | any): MovieScene;
}

declare class SequencerScriptingRange { 
	bHasStart: boolean;
	bHasEnd: boolean;
	InclusiveStart: number;
	ExclusiveEnd: number;
	InternalRate: FrameRate;
	clone() : SequencerScriptingRange;
	static C(Other: UObject | any): SequencerScriptingRange;
	GetEndFrame(): number;
	GetEndSeconds(): number;
	GetStartFrame(): number;
	GetStartSeconds(): number;
	HasEnd(): boolean;
	HasStart(): boolean;
	RemoveEnd(): {Range: SequencerScriptingRange};
	RemoveStart(): {Range: SequencerScriptingRange};
	SetEndFrame(End?: number): {Range: SequencerScriptingRange};
	SetEndSeconds(End?: number): {Range: SequencerScriptingRange};
	SetStartFrame(Start?: number): {Range: SequencerScriptingRange};
	SetStartSeconds(Start?: number): {Range: SequencerScriptingRange};
	static GetEndFrame(Range: SequencerScriptingRange): number;
	static GetEndSeconds(Range: SequencerScriptingRange): number;
	static GetStartFrame(Range: SequencerScriptingRange): number;
	static GetStartSeconds(Range: SequencerScriptingRange): number;
	static HasEnd(Range: SequencerScriptingRange): boolean;
	static HasStart(Range: SequencerScriptingRange): boolean;
	static RemoveEnd(Range?: SequencerScriptingRange): {Range: SequencerScriptingRange};
	static RemoveStart(Range?: SequencerScriptingRange): {Range: SequencerScriptingRange};
	static SetEndFrame(Range?: SequencerScriptingRange,End?: number): {Range: SequencerScriptingRange};
	static SetEndSeconds(Range?: SequencerScriptingRange,End?: number): {Range: SequencerScriptingRange};
	static SetStartFrame(Range?: SequencerScriptingRange,Start?: number): {Range: SequencerScriptingRange};
	static SetStartSeconds(Range?: SequencerScriptingRange,Start?: number): {Range: SequencerScriptingRange};
}

declare class MovieSceneSequence extends MovieSceneSignedObject { 
	CompiledData: MovieSceneCompiledData;
	DefaultCompletionMode: EMovieSceneCompletionMode;
	bParentContextsAreSignificant: boolean;
	bPlayableDirectly: boolean;
	SequenceFlags: EMovieSceneSequenceFlags;
	static Load(ResourceName: string): MovieSceneSequence;
	static Find(Outer: UObject, ResourceName: string): MovieSceneSequence;
	static GetDefaultObject(): MovieSceneSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneSequence;
	GetEarliestTimecodeSource(): MovieSceneTimecodeSource;
	FindBindingsByTag(InBindingName: string): MovieSceneObjectBindingID[];
	FindBindingByTag(InBindingName: string): MovieSceneObjectBindingID;
	static C(Other: UObject | any): MovieSceneSequence;
	CreateEvent(InSection: MovieSceneEventSectionBase,InEndpoint: SequencerQuickBindingResult,InPayload: string[]): MovieSceneEvent;
	CreateQuickBinding(InObject: UObject,InFunctionName: string,bCallInEditor: boolean): SequencerQuickBindingResult;
	AddMarkedFrame(InMarkedFrame: MovieSceneMarkedFrame): number;
	AddMasterTrack(TrackType: UnrealEngineClass): MovieSceneTrack;
	AddPossessable(ObjectToPossess: UObject): MovieSceneBindingProxy;
	AddRootFolderToSequence(NewFolderName: string): MovieSceneFolder;
	AddSpawnableFromClass(ClassToSpawn: UnrealEngineClass): MovieSceneBindingProxy;
	AddSpawnableFromInstance(ObjectToSpawn: UObject): MovieSceneBindingProxy;
	DeleteMarkedFrame(DeleteIndex: number): void;
	DeleteMarkedFrames(): void;
	FindBindingById(BindingID: Guid): MovieSceneBindingProxy;
	FindBindingByName(Name: string): MovieSceneBindingProxy;
	FindMarkedFrameByFrameNumber(InFrameNumber: FrameNumber): number;
	FindMarkedFrameByLabel(InLabel: string): number;
	FindMasterTracksByExactType(TrackType: UnrealEngineClass): MovieSceneTrack[];
	FindMasterTracksByType(TrackType: UnrealEngineClass): MovieSceneTrack[];
	FindNextMarkedFrame(InFrameNumber: FrameNumber,bForward: boolean): number;
	GetBindings(): MovieSceneBindingProxy[];
	GetClockSource(): EUpdateClockSource;
	GetDisplayRate(): FrameRate;
	GetEvaluationType(): EMovieSceneEvaluationType;
	GetMarkedFrames(): MovieSceneMarkedFrame[];
	GetMasterTracks(): MovieSceneTrack[];
	GetMovieScene(): MovieScene;
	GetPlaybackEnd(): number;
	GetPlaybackEndSeconds(): number;
	GetPlaybackRange(): SequencerScriptingRange;
	GetPlaybackStart(): number;
	GetPlaybackStartSeconds(): number;
	GetPortableBindingID(DestinationSequence: MovieSceneSequence,InBinding: MovieSceneBindingProxy): MovieSceneObjectBindingID;
	GetPossessables(): MovieSceneBindingProxy[];
	GetRootFoldersInSequence(): MovieSceneFolder[];
	GetSpawnables(): MovieSceneBindingProxy[];
	GetTickResolution(): FrameRate;
	GetTimecodeSource(): Timecode;
	GetViewRangeEnd(): number;
	GetViewRangeStart(): number;
	GetWorkRangeEnd(): number;
	GetWorkRangeStart(): number;
	IsReadOnly(): boolean;
	LocateBoundObjects(InBinding: MovieSceneBindingProxy,Context: UObject): UObject[];
	MakeBindingID(InBinding: MovieSceneBindingProxy,Space: EMovieSceneObjectBindingSpace): MovieSceneObjectBindingID;
	MakeRange(StartFrame: number,Duration: number): SequencerScriptingRange;
	MakeRangeSeconds(StartTime: number,Duration: number): SequencerScriptingRange;
	RemoveMasterTrack(MasterTrack: MovieSceneTrack): boolean;
	RemoveRootFolderFromSequence(Folder: MovieSceneFolder): void;
	ResolveBindingID(InObjectBindingID: MovieSceneObjectBindingID): MovieSceneBindingProxy;
	SetClockSource(InClockSource: EUpdateClockSource): void;
	SetDisplayRate(DisplayRate: FrameRate): void;
	SetEvaluationType(InEvaluationType: EMovieSceneEvaluationType): void;
	SetMarkedFrame(InMarkIndex: number,InFrameNumber: FrameNumber): void;
	SetPlaybackEnd(EndFrame: number): void;
	SetPlaybackEndSeconds(EndTime: number): void;
	SetPlaybackStart(StartFrame: number): void;
	SetPlaybackStartSeconds(StartTime: number): void;
	SetReadOnly(bInReadOnly: boolean): void;
	SetTickResolution(TickResolution: FrameRate): void;
	SetTickResolutionDirectly(TickResolution: FrameRate): void;
	SetViewRangeEnd(EndTimeInSeconds: number): void;
	SetViewRangeStart(StartTimeInSeconds: number): void;
	SetWorkRangeEnd(EndTimeInSeconds: number): void;
	SetWorkRangeStart(StartTimeInSeconds: number): void;
	SortMarkedFrames(): void;
	static CreateEvent(InSequence: MovieSceneSequence,InSection: MovieSceneEventSectionBase,InEndpoint: SequencerQuickBindingResult,InPayload: string[]): MovieSceneEvent;
	static CreateQuickBinding(InSequence: MovieSceneSequence,InObject: UObject,InFunctionName: string,bCallInEditor: boolean): SequencerQuickBindingResult;
	static AddMarkedFrame(Sequence: MovieSceneSequence,InMarkedFrame: MovieSceneMarkedFrame): number;
	static AddMasterTrack(Sequence: MovieSceneSequence,TrackType: UnrealEngineClass): MovieSceneTrack;
	static AddPossessable(Sequence: MovieSceneSequence,ObjectToPossess: UObject): MovieSceneBindingProxy;
	static AddRootFolderToSequence(Sequence: MovieSceneSequence,NewFolderName: string): MovieSceneFolder;
	static AddSpawnableFromClass(Sequence: MovieSceneSequence,ClassToSpawn: UnrealEngineClass): MovieSceneBindingProxy;
	static AddSpawnableFromInstance(Sequence: MovieSceneSequence,ObjectToSpawn: UObject): MovieSceneBindingProxy;
	static DeleteMarkedFrame(Sequence: MovieSceneSequence,DeleteIndex: number): void;
	static DeleteMarkedFrames(Sequence: MovieSceneSequence): void;
	static FindBindingById(Sequence: MovieSceneSequence,BindingID: Guid): MovieSceneBindingProxy;
	static FindBindingByName(Sequence: MovieSceneSequence,Name: string): MovieSceneBindingProxy;
	static FindMarkedFrameByFrameNumber(Sequence: MovieSceneSequence,InFrameNumber: FrameNumber): number;
	static FindMarkedFrameByLabel(Sequence: MovieSceneSequence,InLabel: string): number;
	static FindMasterTracksByExactType(Sequence: MovieSceneSequence,TrackType: UnrealEngineClass): MovieSceneTrack[];
	static FindMasterTracksByType(Sequence: MovieSceneSequence,TrackType: UnrealEngineClass): MovieSceneTrack[];
	static FindNextMarkedFrame(Sequence: MovieSceneSequence,InFrameNumber: FrameNumber,bForward: boolean): number;
	static GetBindings(Sequence: MovieSceneSequence): MovieSceneBindingProxy[];
	static GetClockSource(InSequence: MovieSceneSequence): EUpdateClockSource;
	static GetDisplayRate(Sequence: MovieSceneSequence): FrameRate;
	static GetEvaluationType(InSequence: MovieSceneSequence): EMovieSceneEvaluationType;
	static GetMarkedFrames(Sequence: MovieSceneSequence): MovieSceneMarkedFrame[];
	static GetMasterTracks(Sequence: MovieSceneSequence): MovieSceneTrack[];
	static GetMovieScene(Sequence: MovieSceneSequence): MovieScene;
	static GetPlaybackEnd(Sequence: MovieSceneSequence): number;
	static GetPlaybackEndSeconds(Sequence: MovieSceneSequence): number;
	static GetPlaybackRange(Sequence: MovieSceneSequence): SequencerScriptingRange;
	static GetPlaybackStart(Sequence: MovieSceneSequence): number;
	static GetPlaybackStartSeconds(Sequence: MovieSceneSequence): number;
	static GetPortableBindingID(MasterSequence: MovieSceneSequence,DestinationSequence: MovieSceneSequence,InBinding: MovieSceneBindingProxy): MovieSceneObjectBindingID;
	static GetPossessables(Sequence: MovieSceneSequence): MovieSceneBindingProxy[];
	static GetRootFoldersInSequence(Sequence: MovieSceneSequence): MovieSceneFolder[];
	static GetSpawnables(Sequence: MovieSceneSequence): MovieSceneBindingProxy[];
	static GetTickResolution(Sequence: MovieSceneSequence): FrameRate;
	static GetTimecodeSource(Sequence: MovieSceneSequence): Timecode;
	static GetViewRangeEnd(InSequence: MovieSceneSequence): number;
	static GetViewRangeStart(InSequence: MovieSceneSequence): number;
	static GetWorkRangeEnd(InSequence: MovieSceneSequence): number;
	static GetWorkRangeStart(InSequence: MovieSceneSequence): number;
	static IsReadOnly(Sequence: MovieSceneSequence): boolean;
	static LocateBoundObjects(Sequence: MovieSceneSequence,InBinding: MovieSceneBindingProxy,Context: UObject): UObject[];
	static MakeBindingID(MasterSequence: MovieSceneSequence,InBinding: MovieSceneBindingProxy,Space: EMovieSceneObjectBindingSpace): MovieSceneObjectBindingID;
	static MakeRange(Sequence: MovieSceneSequence,StartFrame: number,Duration: number): SequencerScriptingRange;
	static MakeRangeSeconds(Sequence: MovieSceneSequence,StartTime: number,Duration: number): SequencerScriptingRange;
	static RemoveMasterTrack(Sequence: MovieSceneSequence,MasterTrack: MovieSceneTrack): boolean;
	static RemoveRootFolderFromSequence(Sequence: MovieSceneSequence,Folder: MovieSceneFolder): void;
	static ResolveBindingID(MasterSequence: MovieSceneSequence,InObjectBindingID: MovieSceneObjectBindingID): MovieSceneBindingProxy;
	static SetClockSource(InSequence: MovieSceneSequence,InClockSource: EUpdateClockSource): void;
	static SetDisplayRate(Sequence: MovieSceneSequence,DisplayRate: FrameRate): void;
	static SetEvaluationType(InSequence: MovieSceneSequence,InEvaluationType: EMovieSceneEvaluationType): void;
	static SetMarkedFrame(Sequence: MovieSceneSequence,InMarkIndex: number,InFrameNumber: FrameNumber): void;
	static SetPlaybackEnd(Sequence: MovieSceneSequence,EndFrame: number): void;
	static SetPlaybackEndSeconds(Sequence: MovieSceneSequence,EndTime: number): void;
	static SetPlaybackStart(Sequence: MovieSceneSequence,StartFrame: number): void;
	static SetPlaybackStartSeconds(Sequence: MovieSceneSequence,StartTime: number): void;
	static SetReadOnly(Sequence: MovieSceneSequence,bInReadOnly: boolean): void;
	static SetTickResolution(Sequence: MovieSceneSequence,TickResolution: FrameRate): void;
	static SetTickResolutionDirectly(Sequence: MovieSceneSequence,TickResolution: FrameRate): void;
	static SetViewRangeEnd(InSequence: MovieSceneSequence,EndTimeInSeconds: number): void;
	static SetViewRangeStart(InSequence: MovieSceneSequence,StartTimeInSeconds: number): void;
	static SetWorkRangeEnd(InSequence: MovieSceneSequence,EndTimeInSeconds: number): void;
	static SetWorkRangeStart(InSequence: MovieSceneSequence,StartTimeInSeconds: number): void;
	static SortMarkedFrames(Sequence: MovieSceneSequence): void;
}

declare class TemplateSequence extends MovieSceneSequence { 
	MovieScene: MovieScene;
	BoundActorClass: Class;
	BoundPreviewActor: Actor;
	BoundActorComponents: Map<Guid, string>;
	static Load(ResourceName: string): TemplateSequence;
	static Find(Outer: UObject, ResourceName: string): TemplateSequence;
	static GetDefaultObject(): TemplateSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TemplateSequence;
	static C(Other: UObject | any): TemplateSequence;
}

declare class CameraAnimationSequence extends TemplateSequence { 
	static Load(ResourceName: string): CameraAnimationSequence;
	static Find(Outer: UObject, ResourceName: string): CameraAnimationSequence;
	static GetDefaultObject(): CameraAnimationSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraAnimationSequence;
	static C(Other: UObject | any): CameraAnimationSequence;
}

declare class MovieSceneCompiledDataManager extends UObject { 
	Hierarchies: Map<number, MovieSceneSequenceHierarchy>;
	TrackTemplates: Map<number, MovieSceneEvaluationTemplate>;
	TrackTemplateFields: Map<number, MovieSceneEvaluationField>;
	EntityComponentFields: Map<number, MovieSceneEntityComponentField>;
	static Load(ResourceName: string): MovieSceneCompiledDataManager;
	static Find(Outer: UObject, ResourceName: string): MovieSceneCompiledDataManager;
	static GetDefaultObject(): MovieSceneCompiledDataManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneCompiledDataManager;
	static C(Other: UObject | any): MovieSceneCompiledDataManager;
}

declare class MovieSceneEntitySystemGraphNodes { 
	clone() : MovieSceneEntitySystemGraphNodes;
	static C(Other: UObject | any): MovieSceneEntitySystemGraphNodes;
}

declare class MovieSceneEntitySystemGraph { 
	Nodes: MovieSceneEntitySystemGraphNodes;
	clone() : MovieSceneEntitySystemGraph;
	static C(Other: UObject | any): MovieSceneEntitySystemGraph;
}

declare class MovieSceneEntitySystemLinker extends UObject { 
	SystemGraph: MovieSceneEntitySystemGraph;
	static Load(ResourceName: string): MovieSceneEntitySystemLinker;
	static Find(Outer: UObject, ResourceName: string): MovieSceneEntitySystemLinker;
	static GetDefaultObject(): MovieSceneEntitySystemLinker;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneEntitySystemLinker;
	static C(Other: UObject | any): MovieSceneEntitySystemLinker;
}

declare class MovieSceneRootEvaluationTemplateInstance { 
	WeakRootSequence: MovieSceneSequence;
	CompiledDataManager: MovieSceneCompiledDataManager;
	EntitySystemLinker: MovieSceneEntitySystemLinker;
	DirectorInstances: Map<MovieSceneSequenceID, UObject>;
	clone() : MovieSceneRootEvaluationTemplateInstance;
	static C(Other: UObject | any): MovieSceneRootEvaluationTemplateInstance;
}

declare class CameraAnimationSequencePlayer extends UObject { 
	BoundObjectOverride: UObject;
	Sequence: MovieSceneSequence;
	RootTemplateInstance: MovieSceneRootEvaluationTemplateInstance;
	static Load(ResourceName: string): CameraAnimationSequencePlayer;
	static Find(Outer: UObject, ResourceName: string): CameraAnimationSequencePlayer;
	static GetDefaultObject(): CameraAnimationSequencePlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraAnimationSequencePlayer;
	static C(Other: UObject | any): CameraAnimationSequencePlayer;
}

declare class CameraFilmbackSettings { 
	SensorWidth: number;
	SensorHeight: number;
	SensorAspectRatio: number;
	clone() : CameraFilmbackSettings;
	static C(Other: UObject | any): CameraFilmbackSettings;
}

declare class CameraLensSettings { 
	MinFocalLength: number;
	MaxFocalLength: number;
	MinFStop: number;
	MaxFStop: number;
	MinimumFocusDistance: number;
	SqueezeFactor: number;
	DiaphragmBladeCount: number;
	clone() : CameraLensSettings;
	static C(Other: UObject | any): CameraLensSettings;
}

declare type ECameraFocusMethod = 'DoNotOverride' | 'Manual' | 'Tracking' | 'Disable' | 'MAX';
declare var ECameraFocusMethod : { DoNotOverride:'DoNotOverride',Manual:'Manual',Tracking:'Tracking',Disable:'Disable',MAX:'MAX', };
declare class CameraTrackingFocusSettings { 
	ActorToTrack: Actor;
	RelativeOffset: Vector;
	bDrawDebugTrackingFocusPoint: boolean;
	clone() : CameraTrackingFocusSettings;
	static C(Other: UObject | any): CameraTrackingFocusSettings;
}

declare class CameraFocusSettings { 
	FocusMethod: ECameraFocusMethod;
	ManualFocusDistance: number;
	TrackingFocusSettings: CameraTrackingFocusSettings;
	bDrawDebugFocusPlane: boolean;
	DebugFocusPlaneColor: Color;
	bSmoothFocusChanges: boolean;
	FocusSmoothingInterpSpeed: number;
	FocusOffset: number;
	clone() : CameraFocusSettings;
	static C(Other: UObject | any): CameraFocusSettings;
}

declare class CameraAnimationSequenceCameraStandIn extends UObject { 
	FieldOfView: number;
	bConstrainAspectRatio: boolean;
	AspectRatio: number;
	PostProcessSettings: PostProcessSettings;
	PostProcessBlendWeight: number;
	Filmback: CameraFilmbackSettings;
	LensSettings: CameraLensSettings;
	FocusSettings: CameraFocusSettings;
	CurrentFocalLength: number;
	CurrentAperture: number;
	CurrentFocusDistance: number;
	static Load(ResourceName: string): CameraAnimationSequenceCameraStandIn;
	static Find(Outer: UObject, ResourceName: string): CameraAnimationSequenceCameraStandIn;
	static GetDefaultObject(): CameraAnimationSequenceCameraStandIn;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraAnimationSequenceCameraStandIn;
	static C(Other: UObject | any): CameraAnimationSequenceCameraStandIn;
}

declare class SequenceCameraShakePattern extends CameraShakePattern { 
	Sequence: CameraAnimationSequence;
	PlayRate: number;
	Scale: number;
	BlendInTime: number;
	BlendOutTime: number;
	RandomSegmentDuration: number;
	bRandomSegment: boolean;
	Player: CameraAnimationSequencePlayer;
	CameraStandIn: CameraAnimationSequenceCameraStandIn;
	static Load(ResourceName: string): SequenceCameraShakePattern;
	static Find(Outer: UObject, ResourceName: string): SequenceCameraShakePattern;
	static GetDefaultObject(): SequenceCameraShakePattern;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SequenceCameraShakePattern;
	static C(Other: UObject | any): SequenceCameraShakePattern;
}

declare type ECameraShakeAttenuation = 'Linear' | 'Quadratic' | 'ECameraShakeAttenuation_MAX';
declare var ECameraShakeAttenuation : { Linear:'Linear',Quadratic:'Quadratic',ECameraShakeAttenuation_MAX:'ECameraShakeAttenuation_MAX', };
declare type ECameraShakePlaySpace = 'CameraLocal' | 'World' | 'UserDefined' | 'ECameraShakePlaySpace_MAX';
declare var ECameraShakePlaySpace : { CameraLocal:'CameraLocal',World:'World',UserDefined:'UserDefined',ECameraShakePlaySpace_MAX:'ECameraShakePlaySpace_MAX', };
declare class CameraShakeSourceComponent extends SceneComponent { 
	Attenuation: ECameraShakeAttenuation;
	InnerAttenuationRadius: number;
	OuterAttenuationRadius: number;
	CameraShake: UnrealEngineClass;
	bAutoStart: boolean;
	EditorSpriteTexture: Texture2D;
	EditorSpriteTextureScale: number;
	static Load(ResourceName: string): CameraShakeSourceComponent;
	static Find(Outer: UObject, ResourceName: string): CameraShakeSourceComponent;
	static GetDefaultObject(): CameraShakeSourceComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraShakeSourceComponent;
	StopAllCameraShakesOfType(InCameraShake: UnrealEngineClass,bImmediately: boolean): void;
	StopAllCameraShakes(bImmediately: boolean): void;
	StartCameraShake(InCameraShake: UnrealEngineClass,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): void;
	Start(): void;
	GetAttenuationFactor(Location: Vector): number;
	static C(Other: UObject | any): CameraShakeSourceComponent;
}

declare class LegacyCameraShake extends CameraShakeBase { 
	OscillationDuration: number;
	OscillationBlendInTime: number;
	OscillationBlendOutTime: number;
	RotOscillation: ROscillator;
	LocOscillation: VOscillator;
	FOVOscillation: FOscillator;
	AnimPlayRate: number;
	AnimScale: number;
	AnimBlendInTime: number;
	AnimBlendOutTime: number;
	RandomAnimSegmentDuration: number;
	AnimSequence: CameraAnimationSequence;
	bRandomAnimSegment: boolean;
	OscillatorTimeRemaining: number;
	SequenceShakePattern: SequenceCameraShakePattern;
	static Load(ResourceName: string): LegacyCameraShake;
	static Find(Outer: UObject, ResourceName: string): LegacyCameraShake;
	static GetDefaultObject(): LegacyCameraShake;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LegacyCameraShake;
	static StartLegacyCameraShakeFromSource(PlayerCameraManager: PlayerCameraManager,ShakeClass: UnrealEngineClass,SourceComponent: CameraShakeSourceComponent,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): LegacyCameraShake;
	static StartLegacyCameraShake(PlayerCameraManager: PlayerCameraManager,ShakeClass: UnrealEngineClass,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): LegacyCameraShake;
	ReceiveStopShake(bImmediately: boolean): void;
	ReceivePlayShake(Scale: number): void;
	ReceiveIsFinished(): boolean;
	BlueprintUpdateCameraShake(DeltaTime: number,Alpha: number,POV: MinimalViewInfo,ModifiedPOV?: MinimalViewInfo): {ModifiedPOV: MinimalViewInfo};
	static C(Other: UObject | any): LegacyCameraShake;
}

declare class CameraShakeBase extends UObject { 
	bSingleInstance: boolean;
	ShakeScale: number;
	RootShakePattern: CameraShakePattern;
	CameraManager: PlayerCameraManager;
	static Load(ResourceName: string): CameraShakeBase;
	static Find(Outer: UObject, ResourceName: string): CameraShakeBase;
	static GetDefaultObject(): CameraShakeBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraShakeBase;
	SetRootShakePattern(InPattern: CameraShakePattern): void;
	GetRootShakePattern(): CameraShakePattern;
	static C(Other: UObject | any): CameraShakeBase;
	Conv_LegacyCameraShake(): LegacyCameraShake;
	static Conv_LegacyCameraShake(CameraShake: CameraShakeBase): LegacyCameraShake;
}

declare class ActiveCameraShakeInfo { 
	ShakeInstance: CameraShakeBase;
	ShakeSource: CameraShakeSourceComponent;
	bIsCustomInitialized: boolean;
	clone() : ActiveCameraShakeInfo;
	static C(Other: UObject | any): ActiveCameraShakeInfo;
}

declare class PooledCameraShakes { 
	PooledShakes: CameraShakeBase[];
	clone() : PooledCameraShakes;
	static C(Other: UObject | any): PooledCameraShakes;
}

declare class CameraModifier_CameraShake extends CameraModifier { 
	ActiveShakes: ActiveCameraShakeInfo[];
	ExpiredPooledShakesMap: Map<UnrealEngineClass, PooledCameraShakes>;
	SplitScreenShakeScale: number;
	static Load(ResourceName: string): CameraModifier_CameraShake;
	static Find(Outer: UObject, ResourceName: string): CameraModifier_CameraShake;
	static GetDefaultObject(): CameraModifier_CameraShake;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraModifier_CameraShake;
	static C(Other: UObject | any): CameraModifier_CameraShake;
}

declare class ElementID { 
	IDValue: number;
	clone() : ElementID;
	static C(Other: UObject | any): ElementID;
}

declare class VertexID extends ElementID { 
	clone() : VertexID;
	static C(Other: UObject | any): VertexID;
}

declare class PolygonID extends ElementID { 
	clone() : PolygonID;
	static C(Other: UObject | any): PolygonID;
}

declare class VertexInstanceID extends ElementID { 
	clone() : VertexInstanceID;
	static C(Other: UObject | any): VertexInstanceID;
}

declare class PolygonGroupID extends ElementID { 
	clone() : PolygonGroupID;
	static C(Other: UObject | any): PolygonGroupID;
}

declare class TriangleID extends ElementID { 
	clone() : TriangleID;
	static C(Other: UObject | any): TriangleID;
}

declare class EdgeID extends ElementID { 
	clone() : EdgeID;
	static C(Other: UObject | any): EdgeID;
}

declare class MeshDescriptionBase extends UObject { 
	static Load(ResourceName: string): MeshDescriptionBase;
	static Find(Outer: UObject, ResourceName: string): MeshDescriptionBase;
	static GetDefaultObject(): MeshDescriptionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshDescriptionBase;
	SetVertexPosition(VertexID: VertexID,Position: Vector): void;
	SetPolygonVertexInstances(PolygonID: PolygonID,VertexInstanceIDs: VertexInstanceID[]): void;
	SetPolygonPolygonGroup(PolygonID: PolygonID,PolygonGroupID: PolygonGroupID): void;
	ReversePolygonFacing(PolygonID: PolygonID): void;
	ReserveNewVertices(NumberOfNewVertices: number): void;
	ReserveNewVertexInstances(NumberOfNewVertexInstances: number): void;
	ReserveNewTriangles(NumberOfNewTriangles: number): void;
	ReserveNewPolygons(NumberOfNewPolygons: number): void;
	ReserveNewPolygonGroups(NumberOfNewPolygonGroups: number): void;
	ReserveNewEdges(NumberOfNewEdges: number): void;
	IsVertexValid(VertexID: VertexID): boolean;
	IsVertexOrphaned(VertexID: VertexID): boolean;
	IsVertexInstanceValid(VertexInstanceID: VertexInstanceID): boolean;
	IsTriangleValid(TriangleID: TriangleID): boolean;
	IsTrianglePartOfNgon(TriangleID: TriangleID): boolean;
	IsPolygonValid(PolygonID: PolygonID): boolean;
	IsPolygonGroupValid(PolygonGroupID: PolygonGroupID): boolean;
	IsEmpty(): boolean;
	IsEdgeValid(EdgeID: EdgeID): boolean;
	IsEdgeInternalToPolygon(EdgeID: EdgeID,PolygonID: PolygonID): boolean;
	IsEdgeInternal(EdgeID: EdgeID): boolean;
	GetVertexVertexInstances(VertexID: VertexID,OutVertexInstanceIDs?: VertexInstanceID[]): {OutVertexInstanceIDs: VertexInstanceID[]};
	GetVertexPosition(VertexID: VertexID): Vector;
	GetVertexPairEdge(VertexID0: VertexID,VertexID1: VertexID): EdgeID;
	GetVertexInstanceVertex(VertexInstanceID: VertexInstanceID): VertexID;
	GetVertexInstancePairEdge(VertexInstanceID0: VertexInstanceID,VertexInstanceID1: VertexInstanceID): EdgeID;
	GetVertexInstanceForTriangleVertex(TriangleID: TriangleID,VertexID: VertexID): VertexInstanceID;
	GetVertexInstanceForPolygonVertex(PolygonID: PolygonID,VertexID: VertexID): VertexInstanceID;
	GetVertexInstanceCount(): number;
	GetVertexInstanceConnectedTriangles(VertexInstanceID: VertexInstanceID,OutConnectedTriangleIDs?: TriangleID[]): {OutConnectedTriangleIDs: TriangleID[]};
	GetVertexInstanceConnectedPolygons(VertexInstanceID: VertexInstanceID,OutConnectedPolygonIDs?: PolygonID[]): {OutConnectedPolygonIDs: PolygonID[]};
	GetVertexCount(): number;
	GetVertexConnectedTriangles(VertexID: VertexID,OutConnectedTriangleIDs?: TriangleID[]): {OutConnectedTriangleIDs: TriangleID[]};
	GetVertexConnectedPolygons(VertexID: VertexID,OutConnectedPolygonIDs?: PolygonID[]): {OutConnectedPolygonIDs: PolygonID[]};
	GetVertexConnectedEdges(VertexID: VertexID,OutEdgeIDs?: EdgeID[]): {OutEdgeIDs: EdgeID[]};
	GetVertexAdjacentVertices(VertexID: VertexID,OutAdjacentVertexIDs?: VertexID[]): {OutAdjacentVertexIDs: VertexID[]};
	GetTriangleVertices(TriangleID: TriangleID,OutVertexIDs?: VertexID[]): {OutVertexIDs: VertexID[]};
	GetTriangleVertexInstances(TriangleID: TriangleID,OutVertexInstanceIDs?: VertexInstanceID[]): {OutVertexInstanceIDs: VertexInstanceID[]};
	GetTriangleVertexInstance(TriangleID: TriangleID,Index: number): VertexInstanceID;
	GetTrianglePolygonGroup(TriangleID: TriangleID): PolygonGroupID;
	GetTrianglePolygon(TriangleID: TriangleID): PolygonID;
	GetTriangleEdges(TriangleID: TriangleID,OutEdgeIDs?: EdgeID[]): {OutEdgeIDs: EdgeID[]};
	GetTriangleCount(): number;
	GetTriangleAdjacentTriangles(TriangleID: TriangleID,OutTriangleIDs?: TriangleID[]): {OutTriangleIDs: TriangleID[]};
	GetPolygonVertices(PolygonID: PolygonID,OutVertexIDs?: VertexID[]): {OutVertexIDs: VertexID[]};
	GetPolygonVertexInstances(PolygonID: PolygonID,OutVertexInstanceIDs?: VertexInstanceID[]): {OutVertexInstanceIDs: VertexInstanceID[]};
	GetPolygonTriangles(PolygonID: PolygonID,OutTriangleIDs?: TriangleID[]): {OutTriangleIDs: TriangleID[]};
	GetPolygonPolygonGroup(PolygonID: PolygonID): PolygonGroupID;
	GetPolygonPerimeterEdges(PolygonID: PolygonID,OutEdgeIDs?: EdgeID[]): {OutEdgeIDs: EdgeID[]};
	GetPolygonInternalEdges(PolygonID: PolygonID,OutEdgeIDs?: EdgeID[]): {OutEdgeIDs: EdgeID[]};
	GetPolygonGroupPolygons(PolygonGroupID: PolygonGroupID,OutPolygonIDs?: PolygonID[]): {OutPolygonIDs: PolygonID[]};
	GetPolygonGroupCount(): number;
	GetPolygonCount(): number;
	GetPolygonAdjacentPolygons(PolygonID: PolygonID,OutPolygonIDs?: PolygonID[]): {OutPolygonIDs: PolygonID[]};
	GetNumVertexVertexInstances(VertexID: VertexID): number;
	GetNumVertexInstanceConnectedTriangles(VertexInstanceID: VertexInstanceID): number;
	GetNumVertexInstanceConnectedPolygons(VertexInstanceID: VertexInstanceID): number;
	GetNumVertexConnectedTriangles(VertexID: VertexID): number;
	GetNumVertexConnectedPolygons(VertexID: VertexID): number;
	GetNumVertexConnectedEdges(VertexID: VertexID): number;
	GetNumPolygonVertices(PolygonID: PolygonID): number;
	GetNumPolygonTriangles(PolygonID: PolygonID): number;
	GetNumPolygonInternalEdges(PolygonID: PolygonID): number;
	GetNumPolygonGroupPolygons(PolygonGroupID: PolygonGroupID): number;
	GetNumEdgeConnectedTriangles(EdgeID: EdgeID): number;
	GetNumEdgeConnectedPolygons(EdgeID: EdgeID): number;
	GetEdgeVertices(EdgeID: EdgeID,OutVertexIDs?: VertexID[]): {OutVertexIDs: VertexID[]};
	GetEdgeVertex(EdgeID: EdgeID,VertexNumber: number): VertexID;
	GetEdgeCount(): number;
	GetEdgeConnectedTriangles(EdgeID: EdgeID,OutConnectedTriangleIDs?: TriangleID[]): {OutConnectedTriangleIDs: TriangleID[]};
	GetEdgeConnectedPolygons(EdgeID: EdgeID,OutConnectedPolygonIDs?: PolygonID[]): {OutConnectedPolygonIDs: PolygonID[]};
	Empty(): void;
	DeleteVertexInstance(VertexInstanceID: VertexInstanceID,OrphanedVertices?: VertexID[]): {OrphanedVertices: VertexID[]};
	DeleteVertex(VertexID: VertexID): void;
	DeleteTriangle(TriangleID: TriangleID,OrphanedEdges?: EdgeID[],OrphanedVertexInstances?: VertexInstanceID[],OrphanedPolygonGroupsPtr?: PolygonGroupID[]): {OrphanedEdges: EdgeID[], OrphanedVertexInstances: VertexInstanceID[], OrphanedPolygonGroupsPtr: PolygonGroupID[]};
	DeletePolygonGroup(PolygonGroupID: PolygonGroupID): void;
	DeletePolygon(PolygonID: PolygonID,OrphanedEdges?: EdgeID[],OrphanedVertexInstances?: VertexInstanceID[],OrphanedPolygonGroups?: PolygonGroupID[]): {OrphanedEdges: EdgeID[], OrphanedVertexInstances: VertexInstanceID[], OrphanedPolygonGroups: PolygonGroupID[]};
	DeleteEdge(EdgeID: EdgeID,OrphanedVertices?: VertexID[]): {OrphanedVertices: VertexID[]};
	CreateVertexWithID(VertexID: VertexID): void;
	CreateVertexInstanceWithID(VertexInstanceID: VertexInstanceID,VertexID: VertexID): void;
	CreateVertexInstance(VertexID: VertexID): VertexInstanceID;
	CreateVertex(): VertexID;
	CreateTriangleWithID(TriangleID: TriangleID,PolygonGroupID: PolygonGroupID,VertexInstanceIDs: VertexInstanceID[],NewEdgeIDs?: EdgeID[]): {NewEdgeIDs: EdgeID[]};
	CreateTriangle(PolygonGroupID: PolygonGroupID,VertexInstanceIDs: VertexInstanceID[],NewEdgeIDs?: EdgeID[]): {NewEdgeIDs: EdgeID[], $: TriangleID};
	CreatePolygonWithID(PolygonID: PolygonID,PolygonGroupID: PolygonGroupID,VertexInstanceIDs?: VertexInstanceID[],NewEdgeIDs?: EdgeID[]): {VertexInstanceIDs: VertexInstanceID[], NewEdgeIDs: EdgeID[]};
	CreatePolygonGroupWithID(PolygonGroupID: PolygonGroupID): void;
	CreatePolygonGroup(): PolygonGroupID;
	CreatePolygon(PolygonGroupID: PolygonGroupID,VertexInstanceIDs?: VertexInstanceID[],NewEdgeIDs?: EdgeID[]): {VertexInstanceIDs: VertexInstanceID[], NewEdgeIDs: EdgeID[], $: PolygonID};
	CreateEdgeWithID(EdgeID: EdgeID,VertexID0: VertexID,VertexID1: VertexID): void;
	CreateEdge(VertexID0: VertexID,VertexID1: VertexID): EdgeID;
	ComputePolygonTriangulation(PolygonID: PolygonID): void;
	static C(Other: UObject | any): MeshDescriptionBase;
}

declare class MeshDescriptionBaseBulkData extends UObject { 
	PreallocatedMeshDescription: MeshDescriptionBase;
	MeshDescription: MeshDescriptionBase;
	static Load(ResourceName: string): MeshDescriptionBaseBulkData;
	static Find(Outer: UObject, ResourceName: string): MeshDescriptionBaseBulkData;
	static GetDefaultObject(): MeshDescriptionBaseBulkData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MeshDescriptionBaseBulkData;
	static C(Other: UObject | any): MeshDescriptionBaseBulkData;
}

declare class StaticMeshDescriptionBulkData extends MeshDescriptionBaseBulkData { 
	static Load(ResourceName: string): StaticMeshDescriptionBulkData;
	static Find(Outer: UObject, ResourceName: string): StaticMeshDescriptionBulkData;
	static GetDefaultObject(): StaticMeshDescriptionBulkData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshDescriptionBulkData;
	static C(Other: UObject | any): StaticMeshDescriptionBulkData;
}

declare class MeshBuildSettings { 
	bUseMikkTSpace: boolean;
	bRecomputeNormals: boolean;
	bRecomputeTangents: boolean;
	bComputeWeightedNormals: boolean;
	bRemoveDegenerates: boolean;
	bBuildReversedIndexBuffer: boolean;
	bUseHighPrecisionTangentBasis: boolean;
	bUseFullPrecisionUVs: boolean;
	bUseBackwardsCompatibleF16TruncUVs: boolean;
	bGenerateLightmapUVs: boolean;
	bGenerateDistanceFieldAsIfTwoSided: boolean;
	bSupportFaceRemap: boolean;
	MinLightmapResolution: number;
	SrcLightmapIndex: number;
	DstLightmapIndex: number;
	BuildScale: number;
	BuildScale3D: Vector;
	DistanceFieldResolutionScale: number;
	DistanceFieldBias: number;
	DistanceFieldReplacementMesh: StaticMesh;
	MaxLumenMeshCards: number;
	clone() : MeshBuildSettings;
	static C(Other: UObject | any): MeshBuildSettings;
}

declare type EMeshFeatureImportance = 'Off' | 'Lowest' | 'Low' | 'Normal' | 'High' | 'Highest' | 'EMeshFeatureImportance_MAX';
declare var EMeshFeatureImportance : { Off:'Off',Lowest:'Lowest',Low:'Low',Normal:'Normal',High:'High',Highest:'Highest',EMeshFeatureImportance_MAX:'EMeshFeatureImportance_MAX', };
declare type EStaticMeshReductionTerimationCriterion = 'Triangles' | 'Vertices' | 'Any' | 'EStaticMeshReductionTerimationCriterion_MAX';
declare var EStaticMeshReductionTerimationCriterion : { Triangles:'Triangles',Vertices:'Vertices',Any:'Any',EStaticMeshReductionTerimationCriterion_MAX:'EStaticMeshReductionTerimationCriterion_MAX', };
declare class MeshReductionSettings { 
	PercentTriangles: number;
	PercentVertices: number;
	MaxDeviation: number;
	PixelError: number;
	WeldingThreshold: number;
	HardAngleThreshold: number;
	BaseLODModel: number;
	SilhouetteImportance: EMeshFeatureImportance;
	TextureImportance: EMeshFeatureImportance;
	ShadingImportance: EMeshFeatureImportance;
	bRecalculateNormals: boolean;
	bGenerateUniqueLightmapUVs: boolean;
	bKeepSymmetry: boolean;
	bVisibilityAided: boolean;
	bCullOccluded: boolean;
	TerminationCriterion: EStaticMeshReductionTerimationCriterion;
	VisibilityAggressiveness: EMeshFeatureImportance;
	VertexColorImportance: EMeshFeatureImportance;
	clone() : MeshReductionSettings;
	static C(Other: UObject | any): MeshReductionSettings;
}

declare class StaticMeshSourceModel { 
	StaticMeshDescriptionBulkData: StaticMeshDescriptionBulkData;
	BuildSettings: MeshBuildSettings;
	ReductionSettings: MeshReductionSettings;
	LODDistance: number;
	ScreenSize: PerPlatformFloat;
	SourceImportFilename: string;
	bImportWithBaseMesh: boolean;
	clone() : StaticMeshSourceModel;
	static C(Other: UObject | any): StaticMeshSourceModel;
}

declare class MeshSectionInfo { 
	MaterialIndex: number;
	bEnableCollision: boolean;
	bCastShadow: boolean;
	bVisibleInRayTracing: boolean;
	bAffectDistanceFieldLighting: boolean;
	bForceOpaque: boolean;
	clone() : MeshSectionInfo;
	static C(Other: UObject | any): MeshSectionInfo;
}

declare class MeshSectionInfoMap { 
	Map: Map<number, MeshSectionInfo>;
	clone() : MeshSectionInfoMap;
	static C(Other: UObject | any): MeshSectionInfoMap;
}

declare class MaterialRemapIndex { 
	ImportVersionKey: number;
	MaterialRemap: number[];
	clone() : MaterialRemapIndex;
	static C(Other: UObject | any): MaterialRemapIndex;
}

declare class MeshNaniteSettings { 
	bEnabled: boolean;
	bPreserveArea: boolean;
	PositionPrecision: number;
	TargetMinimumResidencyInKB: number;
	KeepPercentTriangles: number;
	TrimRelativeError: number;
	FallbackPercentTriangles: number;
	FallbackRelativeError: number;
	clone() : MeshNaniteSettings;
	static C(Other: UObject | any): MeshNaniteSettings;
}

declare class StaticMaterial { 
	MaterialInterface: MaterialInterface;
	MaterialSlotName: string;
	ImportedMaterialSlotName: string;
	UVChannelData: MeshUVChannelInfo;
	clone() : StaticMaterial;
	static C(Other: UObject | any): StaticMaterial;
}

declare class AssetEditorOrbitCameraPosition { 
	bIsSet: boolean;
	CamOrbitPoint: Vector;
	CamOrbitZoom: Vector;
	CamOrbitRotation: Rotator;
	clone() : AssetEditorOrbitCameraPosition;
	static C(Other: UObject | any): AssetEditorOrbitCameraPosition;
}

declare class StaticMeshSocket extends UObject { 
	SocketName: string;
	RelativeLocation: Vector;
	RelativeRotation: Rotator;
	RelativeScale: Vector;
	Tag: string;
	PreviewStaticMesh: StaticMesh;
	bSocketCreatedAtImport: boolean;
	static Load(ResourceName: string): StaticMeshSocket;
	static Find(Outer: UObject, ResourceName: string): StaticMeshSocket;
	static GetDefaultObject(): StaticMeshSocket;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshSocket;
	static C(Other: UObject | any): StaticMeshSocket;
}

declare class NavCollisionBase extends UObject { 
	bIsDynamicObstacle: boolean;
	static Load(ResourceName: string): NavCollisionBase;
	static Find(Outer: UObject, ResourceName: string): NavCollisionBase;
	static GetDefaultObject(): NavCollisionBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavCollisionBase;
	static C(Other: UObject | any): NavCollisionBase;
}

declare class StaticMeshDescription extends MeshDescriptionBase { 
	static Load(ResourceName: string): StaticMeshDescription;
	static Find(Outer: UObject, ResourceName: string): StaticMeshDescription;
	static GetDefaultObject(): StaticMeshDescription;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshDescription;
	SetVertexInstanceUV(VertexInstanceID: VertexInstanceID,UV: Vector2D,UVIndex: number): void;
	SetPolygonGroupMaterialSlotName(PolygonGroupID: PolygonGroupID,SlotName: string): void;
	GetVertexInstanceUV(VertexInstanceID: VertexInstanceID,UVIndex: number): Vector2D;
	CreateCube(Center: Vector,HalfExtents: Vector,PolygonGroup: PolygonGroupID,PolygonID_PlusX?: PolygonID,PolygonID_MinusX?: PolygonID,PolygonID_PlusY?: PolygonID,PolygonID_MinusY?: PolygonID,PolygonID_PlusZ?: PolygonID,PolygonID_MinusZ?: PolygonID): {PolygonID_PlusX: PolygonID, PolygonID_MinusX: PolygonID, PolygonID_PlusY: PolygonID, PolygonID_MinusY: PolygonID, PolygonID_PlusZ: PolygonID, PolygonID_MinusZ: PolygonID};
	static C(Other: UObject | any): StaticMeshDescription;
}

declare class JavascriptRawMesh { 
	FaceMaterialIndices: number[];
	FaceSmoothingMasks: number[];
	VertexPositions: Vector[];
	WedgeIndices: number[];
	WedgeTangentX: Vector[];
	WedgeTangentY: Vector[];
	WedgeTangentZ: Vector[];
	WedgeTexCoords_0: Vector2D[];
	WedgeTexCoords_1: Vector2D[];
	WedgeTexCoords_2: Vector2D[];
	WedgeTexCoords_3: Vector2D[];
	WedgeTexCoords_4: Vector2D[];
	WedgeTexCoords_5: Vector2D[];
	WedgeTexCoords_6: Vector2D[];
	WedgeTexCoords_7: Vector2D[];
	WedgeColors: Color[];
	MaterialIndexToImportIndex: number[];
	clone() : JavascriptRawMesh;
	static C(Other: UObject | any): JavascriptRawMesh;
	CompactMaterialIndices(): {RawMesh: JavascriptRawMesh};
	Empty(): {RawMesh: JavascriptRawMesh};
	GetWedgePosition(WedgeIndex: number): Vector;
	IsValid(): boolean;
	IsValidOrFixable(): boolean;
	static CompactMaterialIndices(RawMesh?: JavascriptRawMesh): {RawMesh: JavascriptRawMesh};
	static Empty(RawMesh?: JavascriptRawMesh): {RawMesh: JavascriptRawMesh};
	static GetWedgePosition(RawMesh: JavascriptRawMesh,WedgeIndex: number): Vector;
	static IsValid(RawMesh: JavascriptRawMesh): boolean;
	static IsValidOrFixable(RawMesh: JavascriptRawMesh): boolean;
}

declare type EScriptCollisionShapeType = 'Box' | 'Sphere' | 'Capsule' | 'NDOP10_X' | 'NDOP10_Y' | 'NDOP10_Z' | 'NDOP18' | 'NDOP26' | 'EScriptCollisionShapeType_MAX';
declare var EScriptCollisionShapeType : { Box:'Box',Sphere:'Sphere',Capsule:'Capsule',NDOP10_X:'NDOP10_X',NDOP10_Y:'NDOP10_Y',NDOP10_Z:'NDOP10_Z',NDOP18:'NDOP18',NDOP26:'NDOP26',EScriptCollisionShapeType_MAX:'EScriptCollisionShapeType_MAX', };
declare class StaticMeshReductionSettings { 
	PercentTriangles: number;
	ScreenSize: number;
	clone() : StaticMeshReductionSettings;
	static C(Other: UObject | any): StaticMeshReductionSettings;
}

declare class StaticMeshReductionOptions { 
	bAutoComputeLODScreenSize: boolean;
	ReductionSettings: StaticMeshReductionSettings[];
	clone() : StaticMeshReductionOptions;
	static C(Other: UObject | any): StaticMeshReductionOptions;
}

declare class ProcMeshTangent { 
	TangentX: Vector;
	bFlipTangentY: boolean;
	clone() : ProcMeshTangent;
	static C(Other: UObject | any): ProcMeshTangent;
}

declare class StaticMesh extends StreamableRenderAsset { 
	SourceModels: StaticMeshSourceModel[];
	HiResSourceModel: StaticMeshSourceModel;
	SectionInfoMap: MeshSectionInfoMap;
	OriginalSectionInfoMap: MeshSectionInfoMap;
	LODGroup: string;
	NumStreamedLODs: PerPlatformInt;
	ImportVersion: number;
	MaterialRemapIndexPerImportVersion: MaterialRemapIndex[];
	LightmapUVVersion: number;
	bAutoComputeLODScreenSize: boolean;
	Materials: MaterialInterface[];
	NaniteSettings: MeshNaniteSettings;
	MinQualityLevelLOD: PerQualityLevelInt;
	MinLOD: PerPlatformInt;
	StaticMaterials: StaticMaterial[];
	LightmapUVDensity: number;
	LightMapResolution: number;
	LightMapCoordinateIndex: number;
	DistanceFieldSelfShadowBias: number;
	BodySetup: BodySetup;
	LODForCollision: number;
	bGenerateMeshDistanceField: boolean;
	bStripComplexCollisionForConsole: boolean;
	bHasNavigationData: boolean;
	bSupportUniformlyDistributedSampling: boolean;
	bSupportPhysicalMaterialMasks: boolean;
	bSupportRayTracing: boolean;
	bDoFastBuild: boolean;
	bIsBuiltAtRuntime: boolean;
	bAllowCPUAccess: boolean;
	bSupportGpuUniformlyDistributedSampling: boolean;
	AssetImportData: AssetImportData;
	SourceFilePath: string;
	SourceFileTimestamp: string;
	ThumbnailInfo: ThumbnailInfo;
	EditorCameraPosition: AssetEditorOrbitCameraPosition;
	bCustomizedCollision: boolean;
	Sockets: StaticMeshSocket[];
	PositiveBoundsExtension: Vector;
	NegativeBoundsExtension: Vector;
	ExtendedBounds: BoxSphereBounds;
	ElementToIgnoreForTexFactor: number;
	AssetUserData: AssetUserData[];
	EditableMesh: UObject;
	ComplexCollisionMesh: StaticMesh;
	NavCollision: NavCollisionBase;
	static Load(ResourceName: string): StaticMesh;
	static Find(Outer: UObject, ResourceName: string): StaticMesh;
	static GetDefaultObject(): StaticMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMesh;
	SetStaticMaterials(InStaticMaterials: StaticMaterial[]): void;
	SetNumSourceModels(Num: number): void;
	SetMinLODForQualityLevels(QualityLevelMinimumLODs: Map<EPerQualityLevels, number>,Default: number): void;
	SetMinimumLODForPlatforms(PlatformMinimumLODs: Map<string, number>): void;
	SetMinimumLODForPlatform(PlatformName: string,InMinLOD: number): void;
	SetMaterial(MaterialIndex: number,NewMaterial: MaterialInterface): void;
	RemoveSocket(Socket: StaticMeshSocket): void;
	IsLODScreenSizeAutoComputed(): boolean;
	GetStaticMeshDescription(LODIndex: number): StaticMeshDescription;
	GetStaticMaterials(): StaticMaterial[];
	GetSocketsByTag(InSocketTag: string): StaticMeshSocket[];
	GetNumTriangles(LODIndex: number): number;
	GetNumSections(InLOD: number): number;
	GetNumLODs(): number;
	GetMinLODForQualityLevels(QualityLevelMinimumLODs?: Map<EPerQualityLevels, number>,Default?: number): {QualityLevelMinimumLODs: Map<EPerQualityLevels, number>, Default: number};
	GetMinimumLODForQualityLevels(QualityLevelMinimumLODs?: Map<string, number>): {QualityLevelMinimumLODs: Map<string, number>};
	GetMinimumLODForQualityLevel(QualityLevel: string): number;
	GetMinimumLODForPlatforms(PlatformMinimumLODs?: Map<string, number>): {PlatformMinimumLODs: Map<string, number>};
	GetMinimumLODForPlatform(PlatformName: string): number;
	GetMaterialIndex(MaterialSlotName: string): number;
	GetMaterial(MaterialIndex: number): MaterialInterface;
	GetBounds(): BoxSphereBounds;
	GetBoundingBox(): Box;
	FindSocket(InSocketName: string): StaticMeshSocket;
	static CreateStaticMeshDescription(Outer: UObject): StaticMeshDescription;
	BuildFromStaticMeshDescriptions(StaticMeshDescriptions: StaticMeshDescription[],bBuildSimpleCollision: boolean,bFastBuild: boolean): void;
	AddSocket(Socket: StaticMeshSocket): void;
	AddMaterial(Material: MaterialInterface): string;
	static C(Other: UObject | any): StaticMesh;
	Build(): void;
	GetPhysicsBodySetupFromStaticMesh(): BodySetup;
	GetSectionInfo(LODIndex: number,SectionIndex: number): MeshSectionInfo;
	LoadRawMesh(SourceModelIndex: number,OutMesh?: JavascriptRawMesh): {OutMesh: JavascriptRawMesh};
	SaveRawMesh(SourceModelIndex: number,InMesh?: JavascriptRawMesh): {InMesh: JavascriptRawMesh};
	SetSectionInfo(LODIndex: number,SectionIndex: number,Info: MeshSectionInfo): void;
	AddSimpleCollisions(ShapeType: EScriptCollisionShapeType): number;
	AddSimpleCollisionsWithNotification(ShapeType: EScriptCollisionShapeType,bApplyChanges: boolean): number;
	AddUVChannel(LODIndex: number): boolean;
	EnableSectionCastShadow(bCastShadow: boolean,LODIndex: number,SectionIndex: number): void;
	EnableSectionCollision(bCollisionEnabled: boolean,LODIndex: number,SectionIndex: number): void;
	GenerateBoxUVChannel(LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Size: Vector): boolean;
	GenerateCylindricalUVChannel(LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	GeneratePlanarUVChannel(LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	GetCollisionComplexity(): ECollisionTraceFlag;
	GetConvexCollisionCount(): number;
	GetLodBuildSettings(LODIndex: number,OutBuildOptions?: MeshBuildSettings): {OutBuildOptions: MeshBuildSettings};
	GetLodCount(): number;
	GetLodReductionSettings(LODIndex: number,OutReductionOptions?: MeshReductionSettings): {OutReductionOptions: MeshReductionSettings};
	GetLodScreenSizes(): number[];
	GetNumberMaterials(): number;
	GetNumberVerts(LODIndex: number): number;
	GetNumUVChannels(LODIndex: number): number;
	GetSimpleCollisionCount(): number;
	HasVertexColors(): boolean;
	ImportLOD(LODIndex: number,SourceFilename: string): number;
	InsertUVChannel(LODIndex: number,UVChannelIndex: number): boolean;
	IsSectionCollisionEnabled(LODIndex: number,SectionIndex: number): boolean;
	ReimportAllCustomLODs(): boolean;
	RemoveCollisions(): boolean;
	RemoveCollisionsWithNotification(bApplyChanges: boolean): boolean;
	RemoveLods(): boolean;
	RemoveUVChannel(LODIndex: number,UVChannelIndex: number): boolean;
	SetAllowCPUAccess(bAllowCPUAccess: boolean): void;
	SetConvexDecompositionCollisions(HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	SetConvexDecompositionCollisionsWithNotification(HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	SetGenerateLightmapUVs(bGenerateLightmapUVs: boolean): boolean;
	SetLodBuildSettings(LODIndex: number,BuildOptions: MeshBuildSettings): void;
	SetLodFromStaticMesh(DestinationLodIndex: number,SourceStaticMesh: StaticMesh,SourceLodIndex: number,bReuseExistingMaterialSlots: boolean): number;
	SetLodReductionSettings(LODIndex: number,ReductionOptions: MeshReductionSettings): void;
	SetLods(ReductionOptions: StaticMeshReductionOptions): number;
	SetLodsWithNotification(ReductionOptions: StaticMeshReductionOptions,bApplyChanges: boolean): number;
	GetSectionFromStaticMesh(LODIndex: number,SectionIndex: number,Vertices?: Vector[],Triangles?: number[],Normals?: Vector[],UVs?: Vector2D[],Tangents?: ProcMeshTangent[]): {Vertices: Vector[], Triangles: number[], Normals: Vector[], UVs: Vector2D[], Tangents: ProcMeshTangent[]};
	static Build(StaticMesh: StaticMesh): void;
	static GetPhysicsBodySetupFromStaticMesh(InStaticMesh: StaticMesh): BodySetup;
	static GetSectionInfo(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number): MeshSectionInfo;
	static LoadRawMesh(StaticMesh: StaticMesh,SourceModelIndex: number,OutMesh?: JavascriptRawMesh): {OutMesh: JavascriptRawMesh};
	static SaveRawMesh(StaticMesh: StaticMesh,SourceModelIndex: number,InMesh?: JavascriptRawMesh): {InMesh: JavascriptRawMesh};
	static SetSectionInfo(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number,Info: MeshSectionInfo): void;
	static AddSimpleCollisions(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType): number;
	static AddSimpleCollisionsWithNotification(StaticMesh: StaticMesh,ShapeType: EScriptCollisionShapeType,bApplyChanges: boolean): number;
	static AddUVChannel(StaticMesh: StaticMesh,LODIndex: number): boolean;
	static EnableSectionCastShadow(StaticMesh: StaticMesh,bCastShadow: boolean,LODIndex: number,SectionIndex: number): void;
	static EnableSectionCollision(StaticMesh: StaticMesh,bCollisionEnabled: boolean,LODIndex: number,SectionIndex: number): void;
	static GenerateBoxUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Size: Vector): boolean;
	static GenerateCylindricalUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	static GeneratePlanarUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number,Position: Vector,Orientation: Rotator,Tiling: Vector2D): boolean;
	static GetCollisionComplexity(StaticMesh: StaticMesh): ECollisionTraceFlag;
	static GetConvexCollisionCount(StaticMesh: StaticMesh): number;
	static GetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,OutBuildOptions?: MeshBuildSettings): {OutBuildOptions: MeshBuildSettings};
	static GetLodCount(StaticMesh: StaticMesh): number;
	static GetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,OutReductionOptions?: MeshReductionSettings): {OutReductionOptions: MeshReductionSettings};
	static GetLodScreenSizes(StaticMesh: StaticMesh): number[];
	static GetNumberMaterials(StaticMesh: StaticMesh): number;
	static GetNumberVerts(StaticMesh: StaticMesh,LODIndex: number): number;
	static GetNumUVChannels(StaticMesh: StaticMesh,LODIndex: number): number;
	static GetSimpleCollisionCount(StaticMesh: StaticMesh): number;
	static HasVertexColors(StaticMesh: StaticMesh): boolean;
	static ImportLOD(BaseStaticMesh: StaticMesh,LODIndex: number,SourceFilename: string): number;
	static InsertUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	static IsSectionCollisionEnabled(StaticMesh: StaticMesh,LODIndex: number,SectionIndex: number): boolean;
	static ReimportAllCustomLODs(StaticMesh: StaticMesh): boolean;
	static RemoveCollisions(StaticMesh: StaticMesh): boolean;
	static RemoveCollisionsWithNotification(StaticMesh: StaticMesh,bApplyChanges: boolean): boolean;
	static RemoveLods(StaticMesh: StaticMesh): boolean;
	static RemoveUVChannel(StaticMesh: StaticMesh,LODIndex: number,UVChannelIndex: number): boolean;
	static SetAllowCPUAccess(StaticMesh: StaticMesh,bAllowCPUAccess: boolean): void;
	static SetConvexDecompositionCollisions(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number): boolean;
	static SetConvexDecompositionCollisionsWithNotification(StaticMesh: StaticMesh,HullCount: number,MaxHullVerts: number,HullPrecision: number,bApplyChanges: boolean): boolean;
	static SetGenerateLightmapUVs(StaticMesh: StaticMesh,bGenerateLightmapUVs: boolean): boolean;
	static SetLodBuildSettings(StaticMesh: StaticMesh,LODIndex: number,BuildOptions: MeshBuildSettings): void;
	static SetLodFromStaticMesh(DestinationStaticMesh: StaticMesh,DestinationLodIndex: number,SourceStaticMesh: StaticMesh,SourceLodIndex: number,bReuseExistingMaterialSlots: boolean): number;
	static SetLodReductionSettings(StaticMesh: StaticMesh,LODIndex: number,ReductionOptions: MeshReductionSettings): void;
	static SetLods(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions): number;
	static SetLodsWithNotification(StaticMesh: StaticMesh,ReductionOptions: StaticMeshReductionOptions,bApplyChanges: boolean): number;
	static GetSectionFromStaticMesh(InMesh: StaticMesh,LODIndex: number,SectionIndex: number,Vertices?: Vector[],Triangles?: number[],Normals?: Vector[],UVs?: Vector2D[],Tangents?: ProcMeshTangent[]): {Vertices: Vector[], Triangles: number[], Normals: Vector[], UVs: Vector2D[], Tangents: ProcMeshTangent[]};
}

declare class CameraComponent extends SceneComponent { 
	FieldOfView: number;
	OrthoWidth: number;
	OrthoNearClipPlane: number;
	OrthoFarClipPlane: number;
	AspectRatio: number;
	bConstrainAspectRatio: boolean;
	bUseFieldOfViewForLOD: boolean;
	bDrawFrustumAllowed: boolean;
	bCameraMeshHiddenInGame: boolean;
	bLockToHmd: boolean;
	bUsePawnControlRotation: boolean;
	ProjectionMode: ECameraProjectionMode;
	CameraMesh: StaticMesh;
	PostProcessBlendWeight: number;
	PostProcessSettings: PostProcessSettings;
	bUseControllerViewRotation: boolean;
	static Load(ResourceName: string): CameraComponent;
	static Find(Outer: UObject, ResourceName: string): CameraComponent;
	static GetDefaultObject(): CameraComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraComponent;
	SetUseFieldOfViewForLOD(bInUseFieldOfViewForLOD: boolean): void;
	SetProjectionMode(InProjectionMode: ECameraProjectionMode): void;
	SetPostProcessBlendWeight(InPostProcessBlendWeight: number): void;
	SetOrthoWidth(InOrthoWidth: number): void;
	SetOrthoNearClipPlane(InOrthoNearClipPlane: number): void;
	SetOrthoFarClipPlane(InOrthoFarClipPlane: number): void;
	SetFieldOfView(InFieldOfView: number): void;
	SetConstraintAspectRatio(bInConstrainAspectRatio: boolean): void;
	SetAspectRatio(InAspectRatio: number): void;
	OnCameraMeshHiddenChanged(): void;
	GetFilmbackText(): string;
	GetCameraView(DeltaTime: number,DesiredView?: MinimalViewInfo): {DesiredView: MinimalViewInfo};
	static C(Other: UObject | any): CameraComponent;
}

declare class CameraActor extends Actor { 
	AutoActivateForPlayer: EAutoReceiveInput;
	CameraComponent: CameraComponent;
	SceneComponent: SceneComponent;
	bConstrainAspectRatio: boolean;
	AspectRatio: number;
	FOVAngle: number;
	PostProcessBlendWeight: number;
	PostProcessSettings: PostProcessSettings;
	static GetDefaultObject(): CameraActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraActor;
	GetAutoActivatePlayerIndex(): number;
	static C(Other: UObject | any): CameraActor;
	DrawDebugCamera(CameraColor: LinearColor,Duration: number): void;
	static DrawDebugCamera(CameraActor: CameraActor,CameraColor: LinearColor,Duration: number): void;
}

declare type EEmitterRenderMode = 'ERM_Normal' | 'ERM_Point' | 'ERM_Cross' | 'ERM_LightsOnly' | 'ERM_None' | 'ERM_MAX';
declare var EEmitterRenderMode : { ERM_Normal:'ERM_Normal',ERM_Point:'ERM_Point',ERM_Cross:'ERM_Cross',ERM_LightsOnly:'ERM_LightsOnly',ERM_None:'ERM_None',ERM_MAX:'ERM_MAX', };
declare type EParticleSignificanceLevel = 'Low' | 'Medium' | 'High' | 'Critical' | 'Num' | 'EParticleSignificanceLevel_MAX';
declare var EParticleSignificanceLevel : { Low:'Low',Medium:'Medium',High:'High',Critical:'Critical',Num:'Num',EParticleSignificanceLevel_MAX:'EParticleSignificanceLevel_MAX', };
declare type EDetailMode = 'DM_Low' | 'DM_Medium' | 'DM_High' | 'DM_MAX';
declare var EDetailMode : { DM_Low:'DM_Low',DM_Medium:'DM_Medium',DM_High:'DM_High',DM_MAX:'DM_MAX', };
declare class ParticleModule extends UObject { 
	bSpawnModule: boolean;
	bUpdateModule: boolean;
	bFinalUpdateModule: boolean;
	bUpdateForGPUEmitter: boolean;
	bCurvesAsColor: boolean;
	b3DDrawMode: boolean;
	bSupported3DDrawMode: boolean;
	bEnabled: boolean;
	bEditable: boolean;
	LODDuplicate: boolean;
	bSupportsRandomSeed: boolean;
	bRequiresLoopingNotification: boolean;
	LODValidity: number;
	ModuleEditorColor: Color;
	static Load(ResourceName: string): ParticleModule;
	static Find(Outer: UObject, ResourceName: string): ParticleModule;
	static GetDefaultObject(): ParticleModule;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModule;
	static C(Other: UObject | any): ParticleModule;
}

declare type EParticleScreenAlignment = 'PSA_FacingCameraPosition' | 'PSA_Square' | 'PSA_Rectangle' | 'PSA_Velocity' | 'PSA_AwayFromCenter' | 'PSA_TypeSpecific' | 'PSA_FacingCameraDistanceBlend' | 'PSA_MAX';
declare var EParticleScreenAlignment : { PSA_FacingCameraPosition:'PSA_FacingCameraPosition',PSA_Square:'PSA_Square',PSA_Rectangle:'PSA_Rectangle',PSA_Velocity:'PSA_Velocity',PSA_AwayFromCenter:'PSA_AwayFromCenter',PSA_TypeSpecific:'PSA_TypeSpecific',PSA_FacingCameraDistanceBlend:'PSA_FacingCameraDistanceBlend',PSA_MAX:'PSA_MAX', };
declare type EParticleSortMode = 'PSORTMODE_None' | 'PSORTMODE_ViewProjDepth' | 'PSORTMODE_DistanceToView' | 'PSORTMODE_Age_OldestFirst' | 'PSORTMODE_Age_NewestFirst' | 'PSORTMODE_MAX';
declare var EParticleSortMode : { PSORTMODE_None:'PSORTMODE_None',PSORTMODE_ViewProjDepth:'PSORTMODE_ViewProjDepth',PSORTMODE_DistanceToView:'PSORTMODE_DistanceToView',PSORTMODE_Age_OldestFirst:'PSORTMODE_Age_OldestFirst',PSORTMODE_Age_NewestFirst:'PSORTMODE_Age_NewestFirst',PSORTMODE_MAX:'PSORTMODE_MAX', };
declare class DistributionLookupTable { 
	TimeScale: number;
	TimeBias: number;
	Values: number[];
	Op: number;
	EntryCount: number;
	EntryStride: number;
	SubEntryStride: number;
	LockFlag: number;
	clone() : DistributionLookupTable;
	static C(Other: UObject | any): DistributionLookupTable;
}

declare class RawDistribution { 
	Table: DistributionLookupTable;
	clone() : RawDistribution;
	static C(Other: UObject | any): RawDistribution;
}

declare class Distribution extends UObject { 
	static Load(ResourceName: string): Distribution;
	static Find(Outer: UObject, ResourceName: string): Distribution;
	static GetDefaultObject(): Distribution;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Distribution;
	static C(Other: UObject | any): Distribution;
}

declare class DistributionFloat extends Distribution { 
	bCanBeBaked: boolean;
	bBakedDataSuccesfully: boolean;
	static Load(ResourceName: string): DistributionFloat;
	static Find(Outer: UObject, ResourceName: string): DistributionFloat;
	static GetDefaultObject(): DistributionFloat;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DistributionFloat;
	static C(Other: UObject | any): DistributionFloat;
}

declare class RawDistributionFloat extends RawDistribution { 
	MinValue: number;
	MaxValue: number;
	Distribution: DistributionFloat;
	clone() : RawDistributionFloat;
	static C(Other: UObject | any): RawDistributionFloat;
}

declare class ParticleBurst { 
	Count: number;
	CountLow: number;
	Time: number;
	clone() : ParticleBurst;
	static C(Other: UObject | any): ParticleBurst;
}

declare type EParticleSubUVInterpMethod = 'PSUVIM_None' | 'PSUVIM_Linear' | 'PSUVIM_Linear_Blend' | 'PSUVIM_Random' | 'PSUVIM_Random_Blend' | 'PSUVIM_MAX';
declare var EParticleSubUVInterpMethod : { PSUVIM_None:'PSUVIM_None',PSUVIM_Linear:'PSUVIM_Linear',PSUVIM_Linear_Blend:'PSUVIM_Linear_Blend',PSUVIM_Random:'PSUVIM_Random',PSUVIM_Random_Blend:'PSUVIM_Random_Blend',PSUVIM_MAX:'PSUVIM_MAX', };
declare type EParticleBurstMethod = 'EPBM_Instant' | 'EPBM_Interpolated' | 'EPBM_MAX';
declare var EParticleBurstMethod : { EPBM_Instant:'EPBM_Instant',EPBM_Interpolated:'EPBM_Interpolated',EPBM_MAX:'EPBM_MAX', };
declare type EOpacitySourceMode = 'OSM_Alpha' | 'OSM_ColorBrightness' | 'OSM_RedChannel' | 'OSM_GreenChannel' | 'OSM_BlueChannel' | 'OSM_MAX';
declare var EOpacitySourceMode : { OSM_Alpha:'OSM_Alpha',OSM_ColorBrightness:'OSM_ColorBrightness',OSM_RedChannel:'OSM_RedChannel',OSM_GreenChannel:'OSM_GreenChannel',OSM_BlueChannel:'OSM_BlueChannel',OSM_MAX:'OSM_MAX', };
declare type EEmitterNormalsMode = 'ENM_CameraFacing' | 'ENM_Spherical' | 'ENM_Cylindrical' | 'ENM_MAX';
declare var EEmitterNormalsMode : { ENM_CameraFacing:'ENM_CameraFacing',ENM_Spherical:'ENM_Spherical',ENM_Cylindrical:'ENM_Cylindrical',ENM_MAX:'ENM_MAX', };
declare type EParticleUVFlipMode = 'None' | 'FlipUV' | 'FlipUOnly' | 'FlipVOnly' | 'RandomFlipUV' | 'RandomFlipUOnly' | 'RandomFlipVOnly' | 'RandomFlipUVIndependent' | 'EParticleUVFlipMode_MAX';
declare var EParticleUVFlipMode : { None:'None',FlipUV:'FlipUV',FlipUOnly:'FlipUOnly',FlipVOnly:'FlipVOnly',RandomFlipUV:'RandomFlipUV',RandomFlipUOnly:'RandomFlipUOnly',RandomFlipVOnly:'RandomFlipVOnly',RandomFlipUVIndependent:'RandomFlipUVIndependent',EParticleUVFlipMode_MAX:'EParticleUVFlipMode_MAX', };
declare type ESubUVBoundingVertexCount = 'BVC_FourVertices' | 'BVC_EightVertices' | 'BVC_MAX';
declare var ESubUVBoundingVertexCount : { BVC_FourVertices:'BVC_FourVertices',BVC_EightVertices:'BVC_EightVertices',BVC_MAX:'BVC_MAX', };
declare class ParticleModuleRequired extends ParticleModule { 
	Material: MaterialInterface;
	MinFacingCameraBlendDistance: number;
	MaxFacingCameraBlendDistance: number;
	EmitterOrigin: Vector;
	EmitterRotation: Rotator;
	ScreenAlignment: EParticleScreenAlignment;
	bUseLocalSpace: boolean;
	bKillOnDeactivate: boolean;
	bKillOnCompleted: boolean;
	SortMode: EParticleSortMode;
	bUseLegacyEmitterTime: boolean;
	bRemoveHMDRoll: boolean;
	bSupportLargeWorldCoordinates: boolean;
	bEmitterDurationUseRange: boolean;
	EmitterDuration: number;
	SpawnRate: RawDistributionFloat;
	BurstList: ParticleBurst[];
	EmitterDelay: number;
	EmitterDelayLow: number;
	bDelayFirstLoopOnly: boolean;
	InterpolationMethod: EParticleSubUVInterpMethod;
	bScaleUV: boolean;
	bEmitterDelayUseRange: boolean;
	ParticleBurstMethod: EParticleBurstMethod;
	bOverrideSystemMacroUV: boolean;
	bUseMaxDrawCount: boolean;
	OpacitySourceMode: EOpacitySourceMode;
	EmitterNormalsMode: EEmitterNormalsMode;
	bOrbitModuleAffectsVelocityAlignment: boolean;
	SubImages_Horizontal: number;
	SubImages_Vertical: number;
	RandomImageTime: number;
	RandomImageChanges: number;
	MacroUVPosition: Vector;
	MacroUVRadius: number;
	UVFlippingMode: EParticleUVFlipMode;
	BoundingMode: ESubUVBoundingVertexCount;
	bDurationRecalcEachLoop: boolean;
	NormalsSphereCenter: Vector;
	AlphaThreshold: number;
	EmitterLoops: number;
	CutoutTexture: Texture2D;
	MaxDrawCount: number;
	EmitterDurationLow: number;
	NormalsCylinderDirection: Vector;
	NamedMaterialOverrides: string[];
	static Load(ResourceName: string): ParticleModuleRequired;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleRequired;
	static GetDefaultObject(): ParticleModuleRequired;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleRequired;
	static C(Other: UObject | any): ParticleModuleRequired;
}

declare class ParticleModuleTypeDataBase extends ParticleModule { 
	static Load(ResourceName: string): ParticleModuleTypeDataBase;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleTypeDataBase;
	static GetDefaultObject(): ParticleModuleTypeDataBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleTypeDataBase;
	static C(Other: UObject | any): ParticleModuleTypeDataBase;
}

declare class ParticleModuleSpawnBase extends ParticleModule { 
	bProcessSpawnRate: boolean;
	bProcessBurstList: boolean;
	static Load(ResourceName: string): ParticleModuleSpawnBase;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleSpawnBase;
	static GetDefaultObject(): ParticleModuleSpawnBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleSpawnBase;
	static C(Other: UObject | any): ParticleModuleSpawnBase;
}

declare class ParticleModuleSpawn extends ParticleModuleSpawnBase { 
	Rate: RawDistributionFloat;
	RateScale: RawDistributionFloat;
	BurstList: ParticleBurst[];
	BurstScale: RawDistributionFloat;
	ParticleBurstMethod: EParticleBurstMethod;
	bApplyGlobalSpawnRateScale: boolean;
	static Load(ResourceName: string): ParticleModuleSpawn;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleSpawn;
	static GetDefaultObject(): ParticleModuleSpawn;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleSpawn;
	static C(Other: UObject | any): ParticleModuleSpawn;
}

declare class ParticleModuleEventBase extends ParticleModule { 
	static Load(ResourceName: string): ParticleModuleEventBase;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleEventBase;
	static GetDefaultObject(): ParticleModuleEventBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleEventBase;
	static C(Other: UObject | any): ParticleModuleEventBase;
}

declare type EParticleEventType = 'EPET_Any' | 'EPET_Spawn' | 'EPET_Death' | 'EPET_Collision' | 'EPET_Burst' | 'EPET_Blueprint' | 'EPET_MAX';
declare var EParticleEventType : { EPET_Any:'EPET_Any',EPET_Spawn:'EPET_Spawn',EPET_Death:'EPET_Death',EPET_Collision:'EPET_Collision',EPET_Burst:'EPET_Burst',EPET_Blueprint:'EPET_Blueprint',EPET_MAX:'EPET_MAX', };
declare class ParticleModuleEventSendToGame extends UObject { 
	static Load(ResourceName: string): ParticleModuleEventSendToGame;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleEventSendToGame;
	static GetDefaultObject(): ParticleModuleEventSendToGame;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleEventSendToGame;
	static C(Other: UObject | any): ParticleModuleEventSendToGame;
}

declare class ParticleEvent_GenerateInfo { 
	Type: EParticleEventType;
	Frequency: number;
	ParticleFrequency: number;
	FirstTimeOnly: boolean;
	LastTimeOnly: boolean;
	UseReflectedImpactVector: boolean;
	bUseOrbitOffset: boolean;
	CustomName: string;
	ParticleModuleEventsToSendToGame: ParticleModuleEventSendToGame[];
	clone() : ParticleEvent_GenerateInfo;
	static C(Other: UObject | any): ParticleEvent_GenerateInfo;
}

declare class ParticleModuleEventGenerator extends ParticleModuleEventBase { 
	Events: ParticleEvent_GenerateInfo[];
	static Load(ResourceName: string): ParticleModuleEventGenerator;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleEventGenerator;
	static GetDefaultObject(): ParticleModuleEventGenerator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleEventGenerator;
	static C(Other: UObject | any): ParticleModuleEventGenerator;
}

declare class ParticleModuleOrbitBase extends ParticleModule { 
	bUseEmitterTime: boolean;
	static Load(ResourceName: string): ParticleModuleOrbitBase;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleOrbitBase;
	static GetDefaultObject(): ParticleModuleOrbitBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleOrbitBase;
	static C(Other: UObject | any): ParticleModuleOrbitBase;
}

declare type EOrbitChainMode = 'EOChainMode_Add' | 'EOChainMode_Scale' | 'EOChainMode_Link' | 'EOChainMode_MAX';
declare var EOrbitChainMode : { EOChainMode_Add:'EOChainMode_Add',EOChainMode_Scale:'EOChainMode_Scale',EOChainMode_Link:'EOChainMode_Link',EOChainMode_MAX:'EOChainMode_MAX', };
declare class DistributionVector extends Distribution { 
	bCanBeBaked: boolean;
	bIsDirty: boolean;
	bBakedDataSuccesfully: boolean;
	static Load(ResourceName: string): DistributionVector;
	static Find(Outer: UObject, ResourceName: string): DistributionVector;
	static GetDefaultObject(): DistributionVector;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DistributionVector;
	static C(Other: UObject | any): DistributionVector;
}

declare class RawDistributionVector extends RawDistribution { 
	MinValue: number;
	MaxValue: number;
	MinValueVec: Vector;
	MaxValueVec: Vector;
	Distribution: DistributionVector;
	clone() : RawDistributionVector;
	static C(Other: UObject | any): RawDistributionVector;
}

declare class OrbitOptions { 
	bProcessDuringSpawn: boolean;
	bProcessDuringUpdate: boolean;
	bUseEmitterTime: boolean;
	clone() : OrbitOptions;
	static C(Other: UObject | any): OrbitOptions;
}

declare class ParticleModuleOrbit extends ParticleModuleOrbitBase { 
	ChainMode: EOrbitChainMode;
	OffsetAmount: RawDistributionVector;
	OffsetOptions: OrbitOptions;
	RotationAmount: RawDistributionVector;
	RotationOptions: OrbitOptions;
	RotationRateAmount: RawDistributionVector;
	RotationRateOptions: OrbitOptions;
	static Load(ResourceName: string): ParticleModuleOrbit;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleOrbit;
	static GetDefaultObject(): ParticleModuleOrbit;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleOrbit;
	static C(Other: UObject | any): ParticleModuleOrbit;
}

declare class ParticleModuleEventReceiverBase extends ParticleModuleEventBase { 
	EventGeneratorType: EParticleEventType;
	EventName: string;
	static Load(ResourceName: string): ParticleModuleEventReceiverBase;
	static Find(Outer: UObject, ResourceName: string): ParticleModuleEventReceiverBase;
	static GetDefaultObject(): ParticleModuleEventReceiverBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleModuleEventReceiverBase;
	static C(Other: UObject | any): ParticleModuleEventReceiverBase;
}

declare class ParticleLODLevel extends UObject { 
	Level: number;
	bEnabled: boolean;
	RequiredModule: ParticleModuleRequired;
	Modules: ParticleModule[];
	TypeDataModule: ParticleModuleTypeDataBase;
	SpawnModule: ParticleModuleSpawn;
	EventGenerator: ParticleModuleEventGenerator;
	SpawningModules: ParticleModuleSpawnBase[];
	SpawnModules: ParticleModule[];
	UpdateModules: ParticleModule[];
	OrbitModules: ParticleModuleOrbit[];
	EventReceiverModules: ParticleModuleEventReceiverBase[];
	ConvertedModules: boolean;
	PeakActiveParticles: number;
	static Load(ResourceName: string): ParticleLODLevel;
	static Find(Outer: UObject, ResourceName: string): ParticleLODLevel;
	static GetDefaultObject(): ParticleLODLevel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleLODLevel;
	static C(Other: UObject | any): ParticleLODLevel;
}

declare class ParticleEmitter extends UObject { 
	EmitterName: string;
	SubUVDataOffset: number;
	EmitterRenderMode: EEmitterRenderMode;
	SignificanceLevel: EParticleSignificanceLevel;
	bUseLegacySpawningBehavior: boolean;
	ConvertedModules: boolean;
	bIsSoloing: boolean;
	bCookedOut: boolean;
	bDisabledLODsKeepEmitterAlive: boolean;
	bDisableWhenInsignficant: boolean;
	bCollapsed: boolean;
	DetailMode: EDetailMode;
	EmitterEditorColor: Color;
	LODLevels: ParticleLODLevel[];
	PeakActiveParticles: number;
	InitialAllocationCount: number;
	QualityLevelSpawnRateScale: number;
	DetailModeBitmask: number;
	DetailModeDisplay: string;
	static Load(ResourceName: string): ParticleEmitter;
	static Find(Outer: UObject, ResourceName: string): ParticleEmitter;
	static GetDefaultObject(): ParticleEmitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleEmitter;
	static C(Other: UObject | any): ParticleEmitter;
}

declare class CurveEdEntry { 
	CurveObject: UObject;
	CurveColor: Color;
	CurveName: string;
	bHideCurve: number;
	bColorCurve: number;
	bFloatingPointColorCurve: number;
	bClamp: number;
	ClampLow: number;
	ClampHigh: number;
	clone() : CurveEdEntry;
	static C(Other: UObject | any): CurveEdEntry;
}

declare class CurveEdTab { 
	TabName: string;
	Curves: CurveEdEntry[];
	ViewStartInput: number;
	ViewEndInput: number;
	ViewStartOutput: number;
	ViewEndOutput: number;
	clone() : CurveEdTab;
	static C(Other: UObject | any): CurveEdTab;
}

declare class InterpCurveEdSetup extends UObject { 
	Tabs: CurveEdTab[];
	ActiveTab: number;
	static Load(ResourceName: string): InterpCurveEdSetup;
	static Find(Outer: UObject, ResourceName: string): InterpCurveEdSetup;
	static GetDefaultObject(): InterpCurveEdSetup;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InterpCurveEdSetup;
	static C(Other: UObject | any): InterpCurveEdSetup;
}

declare class ParticleSystemLOD { 
	clone() : ParticleSystemLOD;
	static C(Other: UObject | any): ParticleSystemLOD;
}

declare type EParticleSystemUpdateMode = 'EPSUM_RealTime' | 'EPSUM_FixedTime' | 'EPSUM_MAX';
declare var EParticleSystemUpdateMode : { EPSUM_RealTime:'EPSUM_RealTime',EPSUM_FixedTime:'EPSUM_FixedTime',EPSUM_MAX:'EPSUM_MAX', };
declare type ParticleSystemLODMethod = 'PARTICLESYSTEMLODMETHOD_Automatic' | 'PARTICLESYSTEMLODMETHOD_DirectSet' | 'PARTICLESYSTEMLODMETHOD_ActivateAutomatic' | 'PARTICLESYSTEMLODMETHOD_MAX';
declare var ParticleSystemLODMethod : { PARTICLESYSTEMLODMETHOD_Automatic:'PARTICLESYSTEMLODMETHOD_Automatic',PARTICLESYSTEMLODMETHOD_DirectSet:'PARTICLESYSTEMLODMETHOD_DirectSet',PARTICLESYSTEMLODMETHOD_ActivateAutomatic:'PARTICLESYSTEMLODMETHOD_ActivateAutomatic',PARTICLESYSTEMLODMETHOD_MAX:'PARTICLESYSTEMLODMETHOD_MAX', };
declare type EParticleSystemInsignificanceReaction = 'Auto' | 'Complete' | 'DisableTick' | 'DisableTickAndKill' | 'Num' | 'EParticleSystemInsignificanceReaction_MAX';
declare var EParticleSystemInsignificanceReaction : { Auto:'Auto',Complete:'Complete',DisableTick:'DisableTick',DisableTickAndKill:'DisableTickAndKill',Num:'Num',EParticleSystemInsignificanceReaction_MAX:'EParticleSystemInsignificanceReaction_MAX', };
declare type EParticleSystemOcclusionBoundsMethod = 'EPSOBM_None' | 'EPSOBM_ParticleBounds' | 'EPSOBM_CustomBounds' | 'EPSOBM_MAX';
declare var EParticleSystemOcclusionBoundsMethod : { EPSOBM_None:'EPSOBM_None',EPSOBM_ParticleBounds:'EPSOBM_ParticleBounds',EPSOBM_CustomBounds:'EPSOBM_CustomBounds',EPSOBM_MAX:'EPSOBM_MAX', };
declare class LODSoloTrack { 
	SoloEnableSetting: number[];
	clone() : LODSoloTrack;
	static C(Other: UObject | any): LODSoloTrack;
}

declare class NamedEmitterMaterial { 
	Name: string;
	Material: MaterialInterface;
	clone() : NamedEmitterMaterial;
	static C(Other: UObject | any): NamedEmitterMaterial;
}

declare type EPSCPoolMethod = 'None' | 'AutoRelease' | 'ManualRelease' | 'ManualRelease_OnComplete' | 'FreeInPool' | 'EPSCPoolMethod_MAX';
declare var EPSCPoolMethod : { None:'None',AutoRelease:'AutoRelease',ManualRelease:'ManualRelease',ManualRelease_OnComplete:'ManualRelease_OnComplete',FreeInPool:'FreeInPool',EPSCPoolMethod_MAX:'EPSCPoolMethod_MAX', };
declare class ParticleSystem extends FXSystemAsset { 
	UpdateTime_FPS: number;
	UpdateTime_Delta: number;
	WarmupTime: number;
	WarmupTickRate: number;
	Emitters: ParticleEmitter[];
	PreviewComponent: ParticleSystemComponent;
	ThumbnailAngle: Rotator;
	ThumbnailDistance: number;
	ThumbnailWarmup: number;
	CurveEdSetup: InterpCurveEdSetup;
	LODDistanceCheckTime: number;
	MacroUVRadius: number;
	LODDistances: number[];
	EditorLODSetting: number;
	LODSettings: ParticleSystemLOD[];
	FixedRelativeBoundingBox: Box;
	SecondsBeforeInactive: number;
	FloorMesh: string;
	FloorPosition: Vector;
	FloorRotation: Rotator;
	FloorScale: number;
	FloorScale3D: Vector;
	BackgroundColor: Color;
	Delay: number;
	DelayLow: number;
	bOrientZAxisTowardCamera: boolean;
	bUseFixedRelativeBoundingBox: boolean;
	bShouldResetPeakCounts: boolean;
	bHasPhysics: boolean;
	bUseRealtimeThumbnail: boolean;
	ThumbnailImageOutOfDate: boolean;
	ThumbnailImage: Texture2D;
	bUseDelayRange: boolean;
	bAllowManagedTicking: boolean;
	bAutoDeactivate: boolean;
	bRegenerateLODDuplicate: boolean;
	SystemUpdateMode: EParticleSystemUpdateMode;
	LODMethod: ParticleSystemLODMethod;
	InsignificantReaction: EParticleSystemInsignificanceReaction;
	OcclusionBoundsMethod: EParticleSystemOcclusionBoundsMethod;
	MaxSignificanceLevel: EParticleSignificanceLevel;
	MinTimeBetweenTicks: number;
	InsignificanceDelay: number;
	MacroUVPosition: Vector;
	CustomOcclusionBounds: Box;
	SoloTracking: LODSoloTrack[];
	NamedMaterialSlots: NamedEmitterMaterial[];
	static Load(ResourceName: string): ParticleSystem;
	static Find(Outer: UObject, ResourceName: string): ParticleSystem;
	static GetDefaultObject(): ParticleSystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleSystem;
	ContainsEmitterType(TypeData: UnrealEngineClass): boolean;
	static C(Other: UObject | any): ParticleSystem;
	SpawnEmitterAttached(AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,Scale: Vector,LocationType: EAttachLocation,bAutoDestroy: boolean,PoolingMethod: EPSCPoolMethod,bAutoActivate: boolean): ParticleSystemComponent;
	static SpawnEmitterAttached(EmitterTemplate: ParticleSystem,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,Scale: Vector,LocationType: EAttachLocation,bAutoDestroy: boolean,PoolingMethod: EPSCPoolMethod,bAutoActivate: boolean): ParticleSystemComponent;
}

declare type EParticleSysParamType = 'PSPT_None' | 'PSPT_Scalar' | 'PSPT_ScalarRand' | 'PSPT_Vector' | 'PSPT_VectorRand' | 'PSPT_Color' | 'PSPT_Actor' | 'PSPT_Material' | 'PSPT_VectorUnitRand' | 'PSPT_MAX';
declare var EParticleSysParamType : { PSPT_None:'PSPT_None',PSPT_Scalar:'PSPT_Scalar',PSPT_ScalarRand:'PSPT_ScalarRand',PSPT_Vector:'PSPT_Vector',PSPT_VectorRand:'PSPT_VectorRand',PSPT_Color:'PSPT_Color',PSPT_Actor:'PSPT_Actor',PSPT_Material:'PSPT_Material',PSPT_VectorUnitRand:'PSPT_VectorUnitRand',PSPT_MAX:'PSPT_MAX', };
declare class ParticleSysParam { 
	Name: string;
	ParamType: EParticleSysParamType;
	Scalar: number;
	Scalar_Low: number;
	Vector: Vector;
	Vector_Low: Vector;
	Color: Color;
	Actor: Actor;
	Material: MaterialInterface;
	clone() : ParticleSysParam;
	static C(Other: UObject | any): ParticleSysParam;
}

declare class ParticleSystemReplay extends UObject { 
	ClipIDNumber: number;
	static Load(ResourceName: string): ParticleSystemReplay;
	static Find(Outer: UObject, ResourceName: string): ParticleSystemReplay;
	static GetDefaultObject(): ParticleSystemReplay;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleSystemReplay;
	static C(Other: UObject | any): ParticleSystemReplay;
}

declare type ETrailWidthMode = 'ETrailWidthMode_FromCentre' | 'ETrailWidthMode_FromFirst' | 'ETrailWidthMode_FromSecond' | 'ETrailWidthMode_MAX';
declare var ETrailWidthMode : { ETrailWidthMode_FromCentre:'ETrailWidthMode_FromCentre',ETrailWidthMode_FromFirst:'ETrailWidthMode_FromFirst',ETrailWidthMode_FromSecond:'ETrailWidthMode_FromSecond',ETrailWidthMode_MAX:'ETrailWidthMode_MAX', };
declare class ParticleSystemComponent extends FXSystemComponent { 
	Template: ParticleSystem;
	EmitterMaterials: MaterialInterface[];
	SkelMeshComponents: SkeletalMeshComponent[];
	bResetOnDetach: boolean;
	bUpdateOnDedicatedServer: boolean;
	bAllowRecycling: boolean;
	bAutoManageAttachment: boolean;
	bAutoAttachWeldSimulatedBodies: boolean;
	bWarmingUp: boolean;
	bOverrideLODMethod: boolean;
	bSkipUpdateDynamicDataDuringTick: boolean;
	LODMethod: ParticleSystemLODMethod;
	RequiredSignificance: EParticleSignificanceLevel;
	InstanceParameters: ParticleSysParam[];
	OnParticleSpawn: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, Location: Vector, Velocity: Vector) => void>;
	OnParticleBurst: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleCount: number) => void>;
	OnParticleDeath: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleTime: number, Location: Vector, Velocity: Vector, Direction: Vector) => void>;
	OnParticleCollide: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleTime: number, Location: Vector, Velocity: Vector, Direction: Vector, Normal: Vector, BoneName: string, PhysMat: PhysicalMaterial) => void>;
	bOldPositionValid: boolean;
	OldPosition: Vector;
	PartSysVelocity: Vector;
	WarmupTime: number;
	WarmupTickRate: number;
	SecondsBeforeInactive: number;
	MaxTimeBeforeForceUpdateTransform: number;
	EditorLODLevel: number;
	EditorDetailMode: number;
	ReplayClips: ParticleSystemReplay[];
	CustomTimeDilation: number;
	AutoAttachParent: SceneComponent;
	AutoAttachSocketName: string;
	AutoAttachLocationType: EAttachLocation;
	AutoAttachLocationRule: EAttachmentRule;
	AutoAttachRotationRule: EAttachmentRule;
	AutoAttachScaleRule: EAttachmentRule;
	OnSystemFinished: UnrealEngineMulticastDelegate<(PSystem: ParticleSystemComponent) => void>;
	static Load(ResourceName: string): ParticleSystemComponent;
	static Find(Outer: UObject, ResourceName: string): ParticleSystemComponent;
	static GetDefaultObject(): ParticleSystemComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleSystemComponent;
	SetTrailSourceData(InFirstSocketName: string,InSecondSocketName: string,InWidthMode: ETrailWidthMode,InWidth: number): void;
	SetTemplate(NewTemplate: ParticleSystem): void;
	SetMaterialParameter(ParameterName: string,Param: MaterialInterface): void;
	SetBeamTargetTangent(EmitterIndex: number,NewTangentPoint: Vector,TargetIndex: number): void;
	SetBeamTargetStrength(EmitterIndex: number,NewTargetStrength: number,TargetIndex: number): void;
	SetBeamTargetPoint(EmitterIndex: number,NewTargetPoint: Vector,TargetIndex: number): void;
	SetBeamSourceTangent(EmitterIndex: number,NewTangentPoint: Vector,SourceIndex: number): void;
	SetBeamSourceStrength(EmitterIndex: number,NewSourceStrength: number,SourceIndex: number): void;
	SetBeamSourcePoint(EmitterIndex: number,NewSourcePoint: Vector,SourceIndex: number): void;
	SetBeamEndPoint(EmitterIndex: number,NewEndPoint: Vector): void;
	SetAutoAttachParams(Parent: SceneComponent,SocketName: string,LocationType: EAttachLocation): void;
	GetNumActiveParticles(): number;
	GetNamedMaterial(InName: string): MaterialInterface;
	GetBeamTargetTangent(EmitterIndex: number,TargetIndex: number,OutTangentPoint?: Vector): {OutTangentPoint: Vector, $: boolean};
	GetBeamTargetStrength(EmitterIndex: number,TargetIndex: number,OutTargetStrength?: number): {OutTargetStrength: number, $: boolean};
	GetBeamTargetPoint(EmitterIndex: number,TargetIndex: number,OutTargetPoint?: Vector): {OutTargetPoint: Vector, $: boolean};
	GetBeamSourceTangent(EmitterIndex: number,SourceIndex: number,OutTangentPoint?: Vector): {OutTangentPoint: Vector, $: boolean};
	GetBeamSourceStrength(EmitterIndex: number,SourceIndex: number,OutSourceStrength?: number): {OutSourceStrength: number, $: boolean};
	GetBeamSourcePoint(EmitterIndex: number,SourceIndex: number,OutSourcePoint?: Vector): {OutSourcePoint: Vector, $: boolean};
	GetBeamEndPoint(EmitterIndex: number,OutEndPoint?: Vector): {OutEndPoint: Vector, $: boolean};
	GenerateParticleEvent(InEventName: string,InEmitterTime: number,InLocation: Vector,InDirection: Vector,InVelocity: Vector): void;
	EndTrails(): void;
	CreateNamedDynamicMaterialInstance(InName: string,SourceMaterial: MaterialInterface): MaterialInstanceDynamic;
	BeginTrails(InFirstSocketName: string,InSecondSocketName: string,InWidthMode: ETrailWidthMode,InWidth: number): void;
	static C(Other: UObject | any): ParticleSystemComponent;
}

declare class Emitter extends Actor { 
	ParticleSystemComponent: ParticleSystemComponent;
	bDestroyOnSystemFinish: boolean;
	bPostUpdateTickGroup: boolean;
	bCurrentlyActive: boolean;
	OnParticleSpawn: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, Location: Vector, Velocity: Vector) => void>;
	OnParticleBurst: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleCount: number) => void>;
	OnParticleDeath: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleTime: number, Location: Vector, Velocity: Vector, Direction: Vector) => void>;
	OnParticleCollide: UnrealEngineMulticastDelegate<(EventName: string, EmitterTime: number, ParticleTime: number, Location: Vector, Velocity: Vector, Direction: Vector, Normal: Vector, BoneName: string, PhysMat: PhysicalMaterial) => void>;
	SpriteComponent: BillboardComponent;
	ArrowComponent: ArrowComponent;
	static GetDefaultObject(): Emitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Emitter;
	ToggleActive(): void;
	SetVectorParameter(ParameterName: string,Param: Vector): void;
	SetTemplate(NewTemplate: ParticleSystem): void;
	SetMaterialParameter(ParameterName: string,Param: MaterialInterface): void;
	SetFloatParameter(ParameterName: string,Param: number): void;
	SetColorParameter(ParameterName: string,Param: LinearColor): void;
	SetActorParameter(ParameterName: string,Param: Actor): void;
	OnRep_bCurrentlyActive(): void;
	OnParticleSystemFinished(FinishedComponent: ParticleSystemComponent): void;
	IsActive(): boolean;
	Deactivate(): void;
	Activate(): void;
	static C(Other: UObject | any): Emitter;
}

declare class EmitterCameraLensEffectBase extends Emitter { 
	PS_CameraEffect: ParticleSystem;
	BaseCamera: PlayerCameraManager;
	RelativeTransform: Transform;
	BaseFOV: number;
	bAllowMultipleInstances: boolean;
	bResetWhenRetriggered: boolean;
	EmittersToTreatAsSame: UnrealEngineClass[];
	DistFromCamera: number;
	static GetDefaultObject(): EmitterCameraLensEffectBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EmitterCameraLensEffectBase;
	static C(Other: UObject | any): EmitterCameraLensEffectBase;
}

declare type ECameraAnimationEasingType = 'Linear' | 'Sinusoidal' | 'Quadratic' | 'Cubic' | 'Quartic' | 'Quintic' | 'Exponential' | 'Circular' | 'ECameraAnimationEasingType_MAX';
declare var ECameraAnimationEasingType : { Linear:'Linear',Sinusoidal:'Sinusoidal',Quadratic:'Quadratic',Cubic:'Cubic',Quartic:'Quartic',Quintic:'Quintic',Exponential:'Exponential',Circular:'Circular',ECameraAnimationEasingType_MAX:'ECameraAnimationEasingType_MAX', };
declare type ECameraAnimationPlaySpace = 'CameraLocal' | 'World' | 'UserDefined' | 'ECameraAnimationPlaySpace_MAX';
declare var ECameraAnimationPlaySpace : { CameraLocal:'CameraLocal',World:'World',UserDefined:'UserDefined',ECameraAnimationPlaySpace_MAX:'ECameraAnimationPlaySpace_MAX', };
declare class CameraAnimationParams { 
	PlayRate: number;
	Scale: number;
	EaseInType: ECameraAnimationEasingType;
	EaseInDuration: number;
	EaseOutType: ECameraAnimationEasingType;
	EaseOutDuration: number;
	bLoop: boolean;
	bRandomStartTime: boolean;
	DurationOverride: number;
	PlaySpace: ECameraAnimationPlaySpace;
	UserPlaySpaceRot: Rotator;
	clone() : CameraAnimationParams;
	static C(Other: UObject | any): CameraAnimationParams;
}

declare class CameraAnimationHandle { 
	clone() : CameraAnimationHandle;
	static C(Other: UObject | any): CameraAnimationHandle;
}

declare class ActiveCameraAnimationInfo { 
	Sequence: CameraAnimationSequence;
	Params: CameraAnimationParams;
	Handle: CameraAnimationHandle;
	Player: CameraAnimationSequencePlayer;
	CameraStandIn: CameraAnimationSequenceCameraStandIn;
	EaseInCurrentTime: number;
	EaseOutCurrentTime: number;
	bIsEasingIn: boolean;
	bIsEasingOut: boolean;
	clone() : ActiveCameraAnimationInfo;
	static C(Other: UObject | any): ActiveCameraAnimationInfo;
}

declare class CameraAnimationCameraModifier extends CameraModifier { 
	ActiveAnimations: ActiveCameraAnimationInfo[];
	NextInstanceSerialNumber: number;
	static Load(ResourceName: string): CameraAnimationCameraModifier;
	static Find(Outer: UObject, ResourceName: string): CameraAnimationCameraModifier;
	static GetDefaultObject(): CameraAnimationCameraModifier;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CameraAnimationCameraModifier;
	StopCameraAnimation(Handle: CameraAnimationHandle,bImmediate: boolean): void;
	StopAllCameraAnimationsOf(Sequence: CameraAnimationSequence,bImmediate: boolean): void;
	StopAllCameraAnimations(bImmediate: boolean): void;
	PlayCameraAnimation(Sequence: CameraAnimationSequence,Params: CameraAnimationParams): CameraAnimationHandle;
	IsCameraAnimationActive(Handle: CameraAnimationHandle): boolean;
	static GetCameraAnimationCameraModifierFromPlayerController(PlayerController: PlayerController): CameraAnimationCameraModifier;
	static GetCameraAnimationCameraModifierFromID(WorldContextObject: UObject,ControllerId: number): CameraAnimationCameraModifier;
	static GetCameraAnimationCameraModifier(WorldContextObject: UObject,PlayerIndex: number): CameraAnimationCameraModifier;
	static C(Other: UObject | any): CameraAnimationCameraModifier;
}

declare class PlayerCameraManager extends Actor { 
	PCOwner: PlayerController;
	TransformComponent: SceneComponent;
	DefaultFOV: number;
	DefaultOrthoWidth: number;
	DefaultAspectRatio: number;
	CameraCache: CameraCacheEntry;
	LastFrameCameraCache: CameraCacheEntry;
	ViewTarget: TViewTarget;
	PendingViewTarget: TViewTarget;
	CameraCachePrivate: CameraCacheEntry;
	LastFrameCameraCachePrivate: CameraCacheEntry;
	ModifierList: CameraModifier[];
	DefaultModifiers: UnrealEngineClass[];
	FreeCamDistance: number;
	FreeCamOffset: Vector;
	ViewTargetOffset: Vector;
	OnAudioFadeChangeEvent: UnrealEngineMulticastDelegate<(bFadeOut: boolean, FadeTime: number) => void>;
	CameraLensEffects: CameraLensEffectInterface[];
	CachedCameraShakeMod: CameraModifier_CameraShake;
	PostProcessBlendCache: PostProcessSettings[];
	AnimCameraActor: CameraActor;
	bIsOrthographic: boolean;
	bDefaultConstrainAspectRatio: boolean;
	bClientSimulatingViewTarget: boolean;
	bUseClientSideCameraUpdates: boolean;
	bGameCameraCutThisFrame: boolean;
	ViewPitchMin: number;
	ViewPitchMax: number;
	ViewYawMin: number;
	ViewYawMax: number;
	ViewRollMin: number;
	ViewRollMax: number;
	ServerUpdateCameraTimeout: number;
	static GetDefaultObject(): PlayerCameraManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayerCameraManager;
	SwapPendingViewTargetWhenUsingClientSideCameraUpdates(): void;
	StopCameraShake(ShakeInstance: CameraShakeBase,bImmediately: boolean): void;
	StopCameraFade(): void;
	StopAllInstancesOfCameraShakeFromSource(Shake: UnrealEngineClass,SourceComponent: CameraShakeSourceComponent,bImmediately: boolean): void;
	StopAllInstancesOfCameraShake(Shake: UnrealEngineClass,bImmediately: boolean): void;
	StopAllCameraShakesFromSource(SourceComponent: CameraShakeSourceComponent,bImmediately: boolean): void;
	StopAllCameraShakes(bImmediately: boolean): void;
	StartCameraShakeFromSource(ShakeClass: UnrealEngineClass,SourceComponent: CameraShakeSourceComponent,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): CameraShakeBase;
	StartCameraShake(ShakeClass: UnrealEngineClass,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): CameraShakeBase;
	StartCameraFade(FromAlpha: number,ToAlpha: number,Duration: number,Color: LinearColor,bShouldFadeAudio: boolean,bHoldWhenFinished: boolean): void;
	SetManualCameraFade(InFadeAmount: number,Color: LinearColor,bInFadeAudio: boolean): void;
	SetGameCameraCutThisFrame(): void;
	RemoveCameraModifier(ModifierToRemove: CameraModifier): boolean;
	RemoveCameraLensEffect(Emitter: EmitterCameraLensEffectBase): void;
	PhotographyCameraModify(NewCameraLocation: Vector,PreviousCameraLocation: Vector,OriginalCameraLocation: Vector,ResultCameraLocation?: Vector): {ResultCameraLocation: Vector};
	OnPhotographySessionStart(): void;
	OnPhotographySessionEnd(): void;
	OnPhotographyMultiPartCaptureStart(): void;
	OnPhotographyMultiPartCaptureEnd(): void;
	GetOwningPlayerController(): PlayerController;
	GetFOVAngle(): number;
	GetCameraRotation(): Rotator;
	GetCameraLocation(): Vector;
	FindCameraModifierByClass(ModifierClass: UnrealEngineClass): CameraModifier;
	ClearCameraLensEffects(): void;
	BlueprintUpdateCamera(CameraTarget: Actor,NewCameraLocation?: Vector,NewCameraRotation?: Rotator,NewCameraFOV?: number): {NewCameraLocation: Vector, NewCameraRotation: Rotator, NewCameraFOV: number, $: boolean};
	AddNewCameraModifier(ModifierClass: UnrealEngineClass): CameraModifier;
	AddCameraLensEffect(LensEffectEmitterClass: UnrealEngineClass): EmitterCameraLensEffectBase;
	static C(Other: UObject | any): PlayerCameraManager;
	Conv_CameraAnimationCameraModifier(): CameraAnimationCameraModifier;
	static Conv_CameraAnimationCameraModifier(PlayerCameraManager: PlayerCameraManager): CameraAnimationCameraModifier;
}

declare class DrawFrustumComponent extends PrimitiveComponent { 
	bFrustumEnabled: boolean;
	FrustumColor: Color;
	FrustumAngle: number;
	FrustumAspectRatio: number;
	FrustumStartDist: number;
	FrustumEndDist: number;
	Texture: Texture;
	static Load(ResourceName: string): DrawFrustumComponent;
	static Find(Outer: UObject, ResourceName: string): DrawFrustumComponent;
	static GetDefaultObject(): DrawFrustumComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DrawFrustumComponent;
	static C(Other: UObject | any): DrawFrustumComponent;
}

declare class DebugCameraController extends PlayerController { 
	bShowSelectedInfo: boolean;
	bIsFrozenRendering: boolean;
	bIsOrbitingSelectedActor: boolean;
	bOrbitPivotUseCenter: boolean;
	bEnableBufferVisualization: boolean;
	bEnableBufferVisualizationFullMode: boolean;
	bIsBufferVisualizationInputSetup: boolean;
	bLastDisplayEnabled: boolean;
	DrawFrustum: DrawFrustumComponent;
	SelectedActor: Actor;
	SelectedComponent: PrimitiveComponent;
	SelectedHitPoint: HitResult;
	OriginalControllerRef: PlayerController;
	OriginalPlayer: Player;
	SpeedScale: number;
	InitialMaxSpeed: number;
	InitialAccel: number;
	InitialDecel: number;
	static GetDefaultObject(): DebugCameraController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DebugCameraController;
	ToggleDisplay(): void;
	ShowDebugSelectedInfo(): void;
	SetPawnMovementSpeedScale(NewSpeedScale: number): void;
	ReceiveOnDeactivate(RestoredPC: PlayerController): void;
	ReceiveOnActorSelected(NewSelectedActor: Actor,SelectHitLocation: Vector,SelectHitNormal: Vector,Hit: HitResult): void;
	ReceiveOnActivate(OriginalPC: PlayerController): void;
	GetSelectedActor(): Actor;
	static C(Other: UObject | any): DebugCameraController;
}

declare class CheatManagerExtension extends UObject { 
	static Load(ResourceName: string): CheatManagerExtension;
	static Find(Outer: UObject, ResourceName: string): CheatManagerExtension;
	static GetDefaultObject(): CheatManagerExtension;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CheatManagerExtension;
	RemovedFromCheatManager(): void;
	GetPlayerController(): PlayerController;
	AddedToCheatManager(): void;
	static C(Other: UObject | any): CheatManagerExtension;
}

declare class CheatManager extends UObject { 
	DebugCameraControllerRef: DebugCameraController;
	DebugCameraControllerClass: UnrealEngineClass;
	CheatManagerExtensions: CheatManagerExtension[];
	static Load(ResourceName: string): CheatManager;
	static Find(Outer: UObject, ResourceName: string): CheatManager;
	static GetDefaultObject(): CheatManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CheatManager;
	Walk(): void;
	ViewSelf(): void;
	ViewPlayer(S: string): void;
	ViewClass(DesiredClass: UnrealEngineClass): void;
	ViewActor(ActorName: string): void;
	UpdateSafeArea(): void;
	ToggleServerStatReplicatorUpdateStatNet(): void;
	ToggleServerStatReplicatorClientOverwrite(): void;
	ToggleDebugCamera(): void;
	ToggleAILogging(): void;
	TestCollisionDistance(): void;
	Teleport(): void;
	Summon(ClassName: string): void;
	StreamLevelOut(PackageName: string): void;
	StreamLevelIn(PackageName: string): void;
	SpawnServerStatReplicator(): void;
	Slomo(NewTimeDilation: number): void;
	SetWorldOrigin(): void;
	SetMouseSensitivityToDefault(): void;
	ServerToggleAILogging(): void;
	ReceiveInitCheatManager(): void;
	ReceiveEndPlay(): void;
	PlayersOnly(): void;
	OnPlayerEndPlayed(Player: Actor,EndPlayReason: EEndPlayReason): void;
	OnlyLoadLevel(PackageName: string): void;
	LogLoc(): void;
	InvertMouse(): void;
	God(): void;
	Ghost(): void;
	GetPlayerController(): PlayerController;
	FreezeFrame(Delay: number): void;
	Fly(): void;
	FlushLog(): void;
	EnableDebugCamera(): void;
	DumpVoiceMutingState(): void;
	DumpPartyState(): void;
	DumpOnlineSessionState(): void;
	DumpChatState(): void;
	DisableDebugCamera(): void;
	DestroyTarget(): void;
	DestroyServerStatReplicator(): void;
	DestroyPawns(aClass: UnrealEngineClass): void;
	DestroyAllPawnsExceptTarget(): void;
	DestroyAll(aClass: UnrealEngineClass): void;
	DebugCapsuleSweepSize(HalfHeight: number,Radius: number): void;
	DebugCapsuleSweepPawn(): void;
	DebugCapsuleSweepComplex(bTraceComplex: boolean): void;
	DebugCapsuleSweepClear(): void;
	DebugCapsuleSweepChannel(Channel: ECollisionChannel): void;
	DebugCapsuleSweepCapture(): void;
	DebugCapsuleSweep(): void;
	DamageTarget(DamageAmount: number): void;
	CheatScript(ScriptName: string): void;
	ChangeSize(F: number): void;
	BugItStringCreator(ViewLocation: Vector,ViewRotation: Rotator,GoString?: string,LocString?: string): {GoString: string, LocString: string};
	BugItGo(X: number,Y: number,Z: number,Pitch: number,Yaw: number,Roll: number): void;
	BugIt(ScreenShotDescription: string): void;
	static C(Other: UObject | any): CheatManager;
}

declare class RuntimeFloatCurve { 
	EditorCurveData: RichCurve;
	ExternalCurve: CurveFloat;
	clone() : RuntimeFloatCurve;
	static C(Other: UObject | any): RuntimeFloatCurve;
}

declare class ForceFeedbackChannelDetails { 
	bAffectsLeftLarge: boolean;
	bAffectsLeftSmall: boolean;
	bAffectsRightLarge: boolean;
	bAffectsRightSmall: boolean;
	Curve: RuntimeFloatCurve;
	clone() : ForceFeedbackChannelDetails;
	static C(Other: UObject | any): ForceFeedbackChannelDetails;
}

declare type EAttenuationDistanceModel = 'Linear' | 'Logarithmic' | 'Inverse' | 'LogReverse' | 'NaturalSound' | 'Custom' | 'EAttenuationDistanceModel_MAX';
declare var EAttenuationDistanceModel : { Linear:'Linear',Logarithmic:'Logarithmic',Inverse:'Inverse',LogReverse:'LogReverse',NaturalSound:'NaturalSound',Custom:'Custom',EAttenuationDistanceModel_MAX:'EAttenuationDistanceModel_MAX', };
declare type EAttenuationShape = 'Sphere' | 'Capsule' | 'Box' | 'Cone' | 'EAttenuationShape_MAX';
declare var EAttenuationShape : { Sphere:'Sphere',Capsule:'Capsule',Box:'Box',Cone:'Cone',EAttenuationShape_MAX:'EAttenuationShape_MAX', };
declare type ENaturalSoundFalloffMode = 'Continues' | 'Silent' | 'Hold' | 'ENaturalSoundFalloffMode_MAX';
declare var ENaturalSoundFalloffMode : { Continues:'Continues',Silent:'Silent',Hold:'Hold',ENaturalSoundFalloffMode_MAX:'ENaturalSoundFalloffMode_MAX', };
declare class BaseAttenuationSettings { 
	DistanceAlgorithm: EAttenuationDistanceModel;
	AttenuationShape: EAttenuationShape;
	FalloffMode: ENaturalSoundFalloffMode;
	dBAttenuationAtMax: number;
	AttenuationShapeExtents: Vector;
	ConeOffset: number;
	FalloffDistance: number;
	ConeSphereRadius: number;
	ConeSphereFalloffDistance: number;
	CustomAttenuationCurve: RuntimeFloatCurve;
	clone() : BaseAttenuationSettings;
	static C(Other: UObject | any): BaseAttenuationSettings;
}

declare class ForceFeedbackAttenuationSettings extends BaseAttenuationSettings { 
	clone() : ForceFeedbackAttenuationSettings;
	static C(Other: UObject | any): ForceFeedbackAttenuationSettings;
}

declare class ForceFeedbackAttenuation extends UObject { 
	Attenuation: ForceFeedbackAttenuationSettings;
	static Load(ResourceName: string): ForceFeedbackAttenuation;
	static Find(Outer: UObject, ResourceName: string): ForceFeedbackAttenuation;
	static GetDefaultObject(): ForceFeedbackAttenuation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ForceFeedbackAttenuation;
	static C(Other: UObject | any): ForceFeedbackAttenuation;
}

declare class ForceFeedbackComponent extends SceneComponent { 
	ForceFeedbackEffect: ForceFeedbackEffect;
	bAutoDestroy: boolean;
	bStopWhenOwnerDestroyed: boolean;
	bLooping: boolean;
	bIgnoreTimeDilation: boolean;
	bOverrideAttenuation: boolean;
	IntensityMultiplier: number;
	AttenuationSettings: ForceFeedbackAttenuation;
	AttenuationOverrides: ForceFeedbackAttenuationSettings;
	OnForceFeedbackFinished: UnrealEngineMulticastDelegate<(ForceFeedbackComponent: ForceFeedbackComponent) => void>;
	static Load(ResourceName: string): ForceFeedbackComponent;
	static Find(Outer: UObject, ResourceName: string): ForceFeedbackComponent;
	static GetDefaultObject(): ForceFeedbackComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ForceFeedbackComponent;
	Stop(): void;
	SetIntensityMultiplier(NewIntensityMultiplier: number): void;
	SetForceFeedbackEffect(NewForceFeedbackEffect: ForceFeedbackEffect): void;
	Play(StartTime: number): void;
	BP_GetAttenuationSettingsToApply(OutAttenuationSettings?: ForceFeedbackAttenuationSettings): {OutAttenuationSettings: ForceFeedbackAttenuationSettings, $: boolean};
	AdjustAttenuation(InAttenuationSettings: ForceFeedbackAttenuationSettings): void;
	static C(Other: UObject | any): ForceFeedbackComponent;
}

declare class ForceFeedbackEffect extends UObject { 
	ChannelDetails: ForceFeedbackChannelDetails[];
	Duration: number;
	static Load(ResourceName: string): ForceFeedbackEffect;
	static Find(Outer: UObject, ResourceName: string): ForceFeedbackEffect;
	static GetDefaultObject(): ForceFeedbackEffect;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ForceFeedbackEffect;
	static C(Other: UObject | any): ForceFeedbackEffect;
	SpawnForceFeedbackAttached(AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,bLooping: boolean,IntensityMultiplier: number,StartTime: number,AttenuationSettings: ForceFeedbackAttenuation,bAutoDestroy: boolean): ForceFeedbackComponent;
	static SpawnForceFeedbackAttached(ForceFeedbackEffect: ForceFeedbackEffect,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,bLooping: boolean,IntensityMultiplier: number,StartTime: number,AttenuationSettings: ForceFeedbackAttenuation,bAutoDestroy: boolean): ForceFeedbackComponent;
}

declare class ActiveForceFeedbackEffect { 
	ForceFeedbackEffect: ForceFeedbackEffect;
	clone() : ActiveForceFeedbackEffect;
	static C(Other: UObject | any): ActiveForceFeedbackEffect;
}

declare class AsyncPhysicsData extends UObject { 
	ServerFrame: number;
	ReplicationRedundancy: number;
	static Load(ResourceName: string): AsyncPhysicsData;
	static Find(Outer: UObject, ResourceName: string): AsyncPhysicsData;
	static GetDefaultObject(): AsyncPhysicsData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncPhysicsData;
	static C(Other: UObject | any): AsyncPhysicsData;
}

declare class AsyncPhysicsInputComponent extends ActorComponent { 
	DataClass: UnrealEngineClass;
	BufferedData: AsyncPhysicsData[];
	DataToConsume: AsyncPhysicsData;
	DataToWrite: AsyncPhysicsData;
	static Load(ResourceName: string): AsyncPhysicsInputComponent;
	static Find(Outer: UObject, ResourceName: string): AsyncPhysicsInputComponent;
	static GetDefaultObject(): AsyncPhysicsInputComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AsyncPhysicsInputComponent;
	ServerRPCBufferInput(AsyncPhysicsData: AsyncPhysicsData): void;
	GetDataToWrite(): AsyncPhysicsData;
	GetDataToConsume(): AsyncPhysicsData;
	static C(Other: UObject | any): AsyncPhysicsInputComponent;
}

declare class ChildConnection extends NetConnection { 
	Parent: NetConnection;
	static Load(ResourceName: string): ChildConnection;
	static Find(Outer: UObject, ResourceName: string): ChildConnection;
	static GetDefaultObject(): ChildConnection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ChildConnection;
	static C(Other: UObject | any): ChildConnection;
}

declare class Package extends UObject { 
	static Load(ResourceName: string): Package;
	static Find(Outer: UObject, ResourceName: string): Package;
	static GetDefaultObject(): Package;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Package;
	static C(Other: UObject | any): Package;
	DeletePackage(): boolean;
	FindWorldInPackage(): World;
	SavePackage(Filename: string): boolean;
	GetLongPackagePath(): string;
	HasAnyPackageFlags(Flags: number): boolean;
	LoadPackage(PackageName: string): Package;
	static DeletePackage(Package: Package): boolean;
	static FindWorldInPackage(Package: Package): World;
	static SavePackage(Package: Package,Filename: string): boolean;
	static GetLongPackagePath(InPackage: Package): string;
	static HasAnyPackageFlags(Package: Package,Flags: number): boolean;
	static LoadPackage(InOuter: Package,PackageName: string): Package;
}

declare class ChannelDefinition { 
	ChannelName: string;
	ClassName: string;
	ChannelClass: UnrealEngineClass;
	StaticChannelIndex: number;
	bTickOnCreate: boolean;
	bServerOpen: boolean;
	bClientOpen: boolean;
	bInitialServer: boolean;
	bInitialClient: boolean;
	clone() : ChannelDefinition;
	static C(Other: UObject | any): ChannelDefinition;
}

declare class Channel extends UObject { 
	Connection: NetConnection;
	static Load(ResourceName: string): Channel;
	static Find(Outer: UObject, ResourceName: string): Channel;
	static GetDefaultObject(): Channel;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Channel;
	static C(Other: UObject | any): Channel;
}

declare class ReplicationDriver extends UObject { 
	static Load(ResourceName: string): ReplicationDriver;
	static Find(Outer: UObject, ResourceName: string): ReplicationDriver;
	static GetDefaultObject(): ReplicationDriver;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReplicationDriver;
	static C(Other: UObject | any): ReplicationDriver;
}

declare class NetDriver extends UObject { 
	NetConnectionClassName: string;
	ReplicationDriverClassName: string;
	ReplicationBridgeClassName: string;
	MaxDownloadSize: number;
	bClampListenServerTickRate: boolean;
	NetServerMaxTickRate: number;
	MaxNetTickRate: number;
	MaxInternetClientRate: number;
	MaxClientRate: number;
	ServerTravelPause: number;
	SpawnPrioritySeconds: number;
	RelevantTimeout: number;
	KeepAliveTime: number;
	InitialConnectTimeout: number;
	ConnectionTimeout: number;
	TimeoutMultiplierForUnoptimizedBuilds: number;
	ServerConnection: NetConnection;
	ClientConnections: NetConnection[];
	RecentlyDisconnectedTrackingTime: number;
	World: World;
	WorldPackage: Package;
	NetConnectionClass: UnrealEngineClass;
	ReplicationDriverClass: UnrealEngineClass;
	ReplicationBridgeClass: UnrealEngineClass;
	NetDriverName: string;
	ChannelDefinitions: ChannelDefinition[];
	ChannelDefinitionMap: Map<string, ChannelDefinition>;
	ActorChannelPool: Channel[];
	bNoTimeouts: boolean;
	bNeverApplyNetworkEmulationSettings: boolean;
	ReplicationDriver: ReplicationDriver;
	static Load(ResourceName: string): NetDriver;
	static Find(Outer: UObject, ResourceName: string): NetDriver;
	static GetDefaultObject(): NetDriver;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NetDriver;
	static C(Other: UObject | any): NetDriver;
}

declare class PackageMap extends UObject { 
	static Load(ResourceName: string): PackageMap;
	static Find(Outer: UObject, ResourceName: string): PackageMap;
	static GetDefaultObject(): PackageMap;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PackageMap;
	static C(Other: UObject | any): PackageMap;
}

declare class NetConnection extends Player { 
	Children: ChildConnection[];
	Driver: NetDriver;
	PackageMapClass: UnrealEngineClass;
	PackageMap: PackageMap;
	OpenChannels: Channel[];
	SentTemporaries: Actor[];
	ViewTarget: Actor;
	OwningActor: Actor;
	MaxPacket: number;
	InternalAck: boolean;
	PlayerId: UniqueNetIdRepl;
	LastReceiveTime: number;
	DefaultMaxChannelSize: number;
	ChannelsToTick: Channel[];
	static Load(ResourceName: string): NetConnection;
	static Find(Outer: UObject, ResourceName: string): NetConnection;
	static GetDefaultObject(): NetConnection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NetConnection;
	static C(Other: UObject | any): NetConnection;
}

declare type EStreamingSourcePriority = 'Highest' | 'High' | 'Normal' | 'Low' | 'Lowest' | 'Default' | 'EStreamingSourcePriority_MAX';
declare var EStreamingSourcePriority : { Highest:'Highest',High:'High',Normal:'Normal',Low:'Low',Lowest:'Lowest',Default:'Default',EStreamingSourcePriority_MAX:'EStreamingSourcePriority_MAX', };
declare class StreamingSourceShape { 
	bUseGridLoadingRange: boolean;
	Radius: number;
	bIsSector: boolean;
	SectorAngle: number;
	Location: Vector;
	Rotation: Rotator;
	clone() : StreamingSourceShape;
	static C(Other: UObject | any): StreamingSourceShape;
}

declare class TouchInputControl { 
	Image1: Texture2D;
	Image2: Texture2D;
	Center: Vector2D;
	VisualSize: Vector2D;
	ThumbSize: Vector2D;
	InteractionSize: Vector2D;
	InputScale: Vector2D;
	MainInputKey: Key;
	AltInputKey: Key;
	clone() : TouchInputControl;
	static C(Other: UObject | any): TouchInputControl;
}

declare class TouchInterface extends UObject { 
	Controls: TouchInputControl[];
	ActiveOpacity: number;
	InactiveOpacity: number;
	TimeUntilDeactive: number;
	TimeUntilReset: number;
	ActivationDelay: number;
	bPreventRecenter: boolean;
	StartupDelay: number;
	static Load(ResourceName: string): TouchInterface;
	static Find(Outer: UObject, ResourceName: string): TouchInterface;
	static GetDefaultObject(): TouchInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TouchInterface;
	static C(Other: UObject | any): TouchInterface;
}

declare class SphereComponent extends ShapeComponent { 
	SphereRadius: number;
	static Load(ResourceName: string): SphereComponent;
	static Find(Outer: UObject, ResourceName: string): SphereComponent;
	static GetDefaultObject(): SphereComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SphereComponent;
	SetSphereRadius(InSphereRadius: number,bUpdateOverlaps: boolean): void;
	GetUnscaledSphereRadius(): number;
	GetShapeScale(): number;
	GetScaledSphereRadius(): number;
	static C(Other: UObject | any): SphereComponent;
}

declare class StaticMeshComponentLODInfo { 
	clone() : StaticMeshComponentLODInfo;
	static C(Other: UObject | any): StaticMeshComponentLODInfo;
}

declare class StreamingTextureBuildInfo { 
	PackedRelativeBox: number;
	TextureLevelIndex: number;
	TexelFactor: number;
	clone() : StreamingTextureBuildInfo;
	static C(Other: UObject | any): StreamingTextureBuildInfo;
}

declare class LightmassPrimitiveSettings { 
	bUseTwoSidedLighting: boolean;
	bShadowIndirectOnly: boolean;
	bUseEmissiveForStaticLighting: boolean;
	bUseVertexNormalForHemisphereGather: boolean;
	EmissiveLightFalloffExponent: number;
	EmissiveLightExplicitInfluenceRadius: number;
	EmissiveBoost: number;
	DiffuseBoost: number;
	FullyOccludedSamplesFraction: number;
	clone() : LightmassPrimitiveSettings;
	static C(Other: UObject | any): LightmassPrimitiveSettings;
}

declare class ProcMeshVertex { 
	Position: Vector;
	Normal: Vector;
	Tangent: ProcMeshTangent;
	Color: Color;
	UV0: Vector2D;
	UV1: Vector2D;
	UV2: Vector2D;
	UV3: Vector2D;
	clone() : ProcMeshVertex;
	static C(Other: UObject | any): ProcMeshVertex;
}

declare class ProcMeshSection { 
	ProcVertexBuffer: ProcMeshVertex[];
	ProcIndexBuffer: number[];
	SectionLocalBox: Box;
	bEnableCollision: boolean;
	bSectionVisible: boolean;
	clone() : ProcMeshSection;
	static C(Other: UObject | any): ProcMeshSection;
}

declare type EProcMeshSliceCapOption = 'NoCap' | 'CreateNewSectionForCap' | 'UseLastSectionForCap' | 'EProcMeshSliceCapOption_MAX';
declare var EProcMeshSliceCapOption : { NoCap:'NoCap',CreateNewSectionForCap:'CreateNewSectionForCap',UseLastSectionForCap:'UseLastSectionForCap',EProcMeshSliceCapOption_MAX:'EProcMeshSliceCapOption_MAX', };
declare class ProceduralMeshComponent extends MeshComponent { 
	bUseComplexAsSimpleCollision: boolean;
	bUseAsyncCooking: boolean;
	ProcMeshBodySetup: BodySetup;
	ProcMeshSections: ProcMeshSection[];
	CollisionConvexElems: KConvexElem[];
	LocalBounds: BoxSphereBounds;
	AsyncBodySetupQueue: BodySetup[];
	static Load(ResourceName: string): ProceduralMeshComponent;
	static Find(Outer: UObject, ResourceName: string): ProceduralMeshComponent;
	static GetDefaultObject(): ProceduralMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ProceduralMeshComponent;
	UpdateMeshSection_LinearColor(SectionIndex: number,Vertices: Vector[],Normals: Vector[],UV0: Vector2D[],UV1: Vector2D[],UV2: Vector2D[],UV3: Vector2D[],VertexColors: LinearColor[],Tangents: ProcMeshTangent[],bSRGBConversion: boolean): void;
	UpdateMeshSection(SectionIndex: number,Vertices: Vector[],Normals: Vector[],UV0: Vector2D[],VertexColors: Color[],Tangents: ProcMeshTangent[]): void;
	SetMeshSectionVisible(SectionIndex: number,bNewVisibility: boolean): void;
	IsMeshSectionVisible(SectionIndex: number): boolean;
	GetNumSections(): number;
	CreateMeshSection_LinearColor(SectionIndex: number,Vertices: Vector[],Triangles: number[],Normals: Vector[],UV0: Vector2D[],UV1: Vector2D[],UV2: Vector2D[],UV3: Vector2D[],VertexColors: LinearColor[],Tangents: ProcMeshTangent[],bCreateCollision: boolean,bSRGBConversion: boolean): void;
	CreateMeshSection(SectionIndex: number,Vertices: Vector[],Triangles: number[],Normals: Vector[],UV0: Vector2D[],VertexColors: Color[],Tangents: ProcMeshTangent[],bCreateCollision: boolean): void;
	ClearMeshSection(SectionIndex: number): void;
	ClearCollisionConvexMeshes(): void;
	ClearAllMeshSections(): void;
	AddCollisionConvexMesh(ConvexVerts: Vector[]): void;
	static C(Other: UObject | any): ProceduralMeshComponent;
	GetSectionFromProceduralMesh(SectionIndex: number,Vertices?: Vector[],Triangles?: number[],Normals?: Vector[],UVs?: Vector2D[],Tangents?: ProcMeshTangent[]): {Vertices: Vector[], Triangles: number[], Normals: Vector[], UVs: Vector2D[], Tangents: ProcMeshTangent[]};
	SliceProceduralMesh(PlanePosition: Vector,PlaneNormal: Vector,bCreateOtherHalf: boolean,OutOtherHalfProcMesh?: ProceduralMeshComponent,CapOption?: EProcMeshSliceCapOption,CapMaterial?: MaterialInterface): {OutOtherHalfProcMesh: ProceduralMeshComponent};
	static GetSectionFromProceduralMesh(InProcMesh: ProceduralMeshComponent,SectionIndex: number,Vertices?: Vector[],Triangles?: number[],Normals?: Vector[],UVs?: Vector2D[],Tangents?: ProcMeshTangent[]): {Vertices: Vector[], Triangles: number[], Normals: Vector[], UVs: Vector2D[], Tangents: ProcMeshTangent[]};
	static SliceProceduralMesh(InProcMesh: ProceduralMeshComponent,PlanePosition: Vector,PlaneNormal: Vector,bCreateOtherHalf: boolean,OutOtherHalfProcMesh?: ProceduralMeshComponent,CapOption?: EProcMeshSliceCapOption,CapMaterial?: MaterialInterface): {OutOtherHalfProcMesh: ProceduralMeshComponent};
}

declare type EVertexPaintAxis = 'X' | 'Y' | 'Z' | 'EVertexPaintAxis_MAX';
declare var EVertexPaintAxis : { X:'X',Y:'Y',Z:'Z',EVertexPaintAxis_MAX:'EVertexPaintAxis_MAX', };
declare class StaticMeshComponent extends MeshComponent { 
	ForcedLodModel: number;
	PreviousLODLevel: number;
	MinLOD: number;
	SubDivisionStepSize: number;
	StaticMesh: StaticMesh;
	WireframeColorOverride: Color;
	bDisallowNanite: boolean;
	bEvaluateWorldPositionOffset: boolean;
	bEvaluateWorldPositionOffsetInRayTracing: boolean;
	WorldPositionOffsetDisableDistance: number;
	SelectedEditorSection: number;
	SelectedEditorMaterial: number;
	SectionIndexPreview: number;
	MaterialIndexPreview: number;
	StaticMeshImportVersion: number;
	bOverrideWireframeColor: boolean;
	bOverrideMinLOD: boolean;
	bOverrideNavigationExport: boolean;
	bForceNavigationObstacle: boolean;
	bDisallowMeshPaintPerInstance: boolean;
	bIgnoreInstanceForTextureStreaming: boolean;
	bOverrideLightMapRes: boolean;
	bCastDistanceFieldIndirectShadow: boolean;
	bOverrideDistanceFieldSelfShadowBias: boolean;
	bUseSubDivisions: boolean;
	bUseDefaultCollision: boolean;
	bCustomOverrideVertexColorPerLOD: boolean;
	bDisplayVertexColors: boolean;
	bDisplayPhysicalMaterialMasks: boolean;
	bDisplayNaniteFallbackMesh: boolean;
	bSortTriangles: boolean;
	bReverseCulling: boolean;
	OverriddenLightMapRes: number;
	DistanceFieldIndirectShadowMinVisibility: number;
	DistanceFieldSelfShadowBias: number;
	StreamingDistanceMultiplier: number;
	IrrelevantLights: Guid[];
	LODData: StaticMeshComponentLODInfo[];
	StreamingTextureData: StreamingTextureBuildInfo[];
	StaticMeshDerivedDataKey: string;
	MaterialStreamingRelativeBoxes: number[];
	LightmassSettings: LightmassPrimitiveSettings;
	static Load(ResourceName: string): StaticMeshComponent;
	static Find(Outer: UObject, ResourceName: string): StaticMeshComponent;
	static GetDefaultObject(): StaticMeshComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): StaticMeshComponent;
	SetStaticMesh(NewMesh: StaticMesh): boolean;
	SetReverseCulling(ReverseCulling: boolean): void;
	SetForcedLodModel(NewForcedLodModel: number): void;
	SetEvaluateWorldPositionOffsetInRayTracing(NewValue: boolean): void;
	SetEvaluateWorldPositionOffset(NewValue: boolean): void;
	SetDistanceFieldSelfShadowBias(NewValue: number): void;
	OnRep_StaticMesh(OldStaticMesh: StaticMesh): void;
	GetLocalBounds(Min?: Vector,Max?: Vector): {Min: Vector, Max: Vector};
	GetInitialEvaluateWorldPositionOffset(): boolean;
	static C(Other: UObject | any): StaticMeshComponent;
	GetPhysicsBodySetupFromStaticMeshComponent(): BodySetup;
	HasInstanceVertexColors(): boolean;
	CopyProceduralMeshFromStaticMeshComponent(LODIndex: number,ProcMeshComponent: ProceduralMeshComponent,bCreateCollision: boolean): void;
	PaintVerticesLerpAlongAxis(StartColor: LinearColor,EndColor: LinearColor,Axis: EVertexPaintAxis,bConvertToSRGB: boolean): void;
	PaintVerticesSingleColor(FillColor: LinearColor,bConvertToSRGB: boolean): void;
	RemovePaintedVertices(): void;
	static GetPhysicsBodySetupFromStaticMeshComponent(InStaticMeshComp: StaticMeshComponent): BodySetup;
	static HasInstanceVertexColors(StaticMeshComponent: StaticMeshComponent): boolean;
	static CopyProceduralMeshFromStaticMeshComponent(StaticMeshComponent: StaticMeshComponent,LODIndex: number,ProcMeshComponent: ProceduralMeshComponent,bCreateCollision: boolean): void;
	static PaintVerticesLerpAlongAxis(StaticMeshComponent: StaticMeshComponent,StartColor: LinearColor,EndColor: LinearColor,Axis: EVertexPaintAxis,bConvertToSRGB: boolean): void;
	static PaintVerticesSingleColor(StaticMeshComponent: StaticMeshComponent,FillColor: LinearColor,bConvertToSRGB: boolean): void;
	static RemovePaintedVertices(StaticMeshComponent: StaticMeshComponent): void;
}

declare class DefaultPawn extends Pawn { 
	BaseTurnRate: number;
	BaseLookUpRate: number;
	MovementComponent: PawnMovementComponent;
	CollisionComponent: SphereComponent;
	MeshComponent: StaticMeshComponent;
	bAddDefaultMovementBindings: boolean;
	static GetDefaultObject(): DefaultPawn;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DefaultPawn;
	TurnAtRate(Rate: number): void;
	MoveUp_World(Val: number): void;
	MoveRight(Val: number): void;
	MoveForward(Val: number): void;
	LookUpAtRate(Rate: number): void;
	static C(Other: UObject | any): DefaultPawn;
}

declare class SpectatorPawn extends DefaultPawn { 
	static GetDefaultObject(): SpectatorPawn;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpectatorPawn;
	static C(Other: UObject | any): SpectatorPawn;
}

declare type EViewTargetBlendFunction = 'VTBlend_Linear' | 'VTBlend_Cubic' | 'VTBlend_EaseIn' | 'VTBlend_EaseOut' | 'VTBlend_EaseInOut' | 'VTBlend_PreBlended' | 'VTBlend_MAX';
declare var EViewTargetBlendFunction : { VTBlend_Linear:'VTBlend_Linear',VTBlend_Cubic:'VTBlend_Cubic',VTBlend_EaseIn:'VTBlend_EaseIn',VTBlend_EaseOut:'VTBlend_EaseOut',VTBlend_EaseInOut:'VTBlend_EaseInOut',VTBlend_PreBlended:'VTBlend_PreBlended',VTBlend_MAX:'VTBlend_MAX', };
declare class WidgetAnimationBinding { 
	WidgetName: string;
	SlotWidgetName: string;
	AnimationGuid: Guid;
	bIsRootWidget: boolean;
	clone() : WidgetAnimationBinding;
	static C(Other: UObject | any): WidgetAnimationBinding;
}

declare class WidgetAnimation extends MovieSceneSequence { 
	MovieScene: MovieScene;
	AnimationBindings: WidgetAnimationBinding[];
	bLegacyFinishOnStop: boolean;
	DisplayLabel: string;
	static Load(ResourceName: string): WidgetAnimation;
	static Find(Outer: UObject, ResourceName: string): WidgetAnimation;
	static GetDefaultObject(): WidgetAnimation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetAnimation;
	UnbindAllFromAnimationStarted(Widget: UserWidget): void;
	UnbindAllFromAnimationFinished(Widget: UserWidget): void;
	GetStartTime(): number;
	GetEndTime(): number;
	static C(Other: UObject | any): WidgetAnimation;
}

declare class UMGSequencePlayer extends UObject { 
	Animation: WidgetAnimation;
	RootTemplateInstance: MovieSceneRootEvaluationTemplateInstance;
	static Load(ResourceName: string): UMGSequencePlayer;
	static Find(Outer: UObject, ResourceName: string): UMGSequencePlayer;
	static GetDefaultObject(): UMGSequencePlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UMGSequencePlayer;
	SetUserTag(InUserTag: string): void;
	GetUserTag(): string;
	static C(Other: UObject | any): UMGSequencePlayer;
}

declare class SequenceTickManagerWidgetData { 
	clone() : SequenceTickManagerWidgetData;
	static C(Other: UObject | any): SequenceTickManagerWidgetData;
}

declare class UMGSequenceTickManager extends UObject { 
	WeakUserWidgetData: Map<UserWidget, SequenceTickManagerWidgetData>;
	Linker: MovieSceneEntitySystemLinker;
	static Load(ResourceName: string): UMGSequenceTickManager;
	static Find(Outer: UObject, ResourceName: string): UMGSequenceTickManager;
	static GetDefaultObject(): UMGSequenceTickManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UMGSequenceTickManager;
	static C(Other: UObject | any): UMGSequenceTickManager;
}

declare class NamedSlotBinding { 
	Name: string;
	Content: Widget;
	clone() : NamedSlotBinding;
	static C(Other: UObject | any): NamedSlotBinding;
}

declare class UserWidgetExtension extends UObject { 
	static Load(ResourceName: string): UserWidgetExtension;
	static Find(Outer: UObject, ResourceName: string): UserWidgetExtension;
	static GetDefaultObject(): UserWidgetExtension;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UserWidgetExtension;
	static C(Other: UObject | any): UserWidgetExtension;
}

declare class WidgetTree extends UObject { 
	RootWidget: Widget;
	NamedSlotBindings: Map<string, Widget>;
	AllWidgets: Widget[];
	static Load(ResourceName: string): WidgetTree;
	static Find(Outer: UObject, ResourceName: string): WidgetTree;
	static GetDefaultObject(): WidgetTree;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetTree;
	static C(Other: UObject | any): WidgetTree;
}

declare type EDesignPreviewSizeMode = 'FillScreen' | 'Custom' | 'CustomOnScreen' | 'Desired' | 'DesiredOnScreen' | 'EDesignPreviewSizeMode_MAX';
declare var EDesignPreviewSizeMode : { FillScreen:'FillScreen',Custom:'Custom',CustomOnScreen:'CustomOnScreen',Desired:'Desired',DesiredOnScreen:'DesiredOnScreen',EDesignPreviewSizeMode_MAX:'EDesignPreviewSizeMode_MAX', };
declare type EWidgetTickFrequency = 'Never' | 'Auto' | 'EWidgetTickFrequency_MAX';
declare var EWidgetTickFrequency : { Never:'Never',Auto:'Auto',EWidgetTickFrequency_MAX:'EWidgetTickFrequency_MAX', };
declare type EWidgetAnimationEvent = 'Started' | 'Finished' | 'EWidgetAnimationEvent_MAX';
declare var EWidgetAnimationEvent : { Started:'Started',Finished:'Finished',EWidgetAnimationEvent_MAX:'EWidgetAnimationEvent_MAX', };
declare class AnimationEventBinding { 
	Animation: WidgetAnimation;
	delegate: UnrealEngineDelegate<() => void>;
	AnimationEvent: EWidgetAnimationEvent;
	UserTag: string;
	clone() : AnimationEventBinding;
	static C(Other: UObject | any): AnimationEventBinding;
}

declare class Geometry { 
	clone() : Geometry;
	static C(Other: UObject | any): Geometry;
	CenterOf(): Vector2D;
	FindClosestPointOnGeom(TestPoint: Vector2D): Vector2D;
	AbsoluteToLocal(AbsoluteCoordinate: Vector2D): Vector2D;
	GetAbsoluteSize(): Vector2D;
	GetLocalSize(): Vector2D;
	GetLocalTopLeft(): Vector2D;
	IsUnderLocation(AbsoluteCoordinate: Vector2D): boolean;
	LocalToAbsolute(LocalCoordinate: Vector2D): Vector2D;
	TransformScalarAbsoluteToLocal(AbsoluteScalar: number): number;
	TransformScalarLocalToAbsolute(LocalScalar: number): number;
	TransformVectorAbsoluteToLocal(AbsoluteVector: Vector2D): Vector2D;
	TransformVectorLocalToAbsolute(LocalVector: Vector2D): Vector2D;
	static CenterOf(Geom: Geometry): Vector2D;
	static FindClosestPointOnGeom(Geom: Geometry,TestPoint: Vector2D): Vector2D;
	static AbsoluteToLocal(Geometry: Geometry,AbsoluteCoordinate: Vector2D): Vector2D;
	static GetAbsoluteSize(Geometry: Geometry): Vector2D;
	static GetLocalSize(Geometry: Geometry): Vector2D;
	static GetLocalTopLeft(Geometry: Geometry): Vector2D;
	static IsUnderLocation(Geometry: Geometry,AbsoluteCoordinate: Vector2D): boolean;
	static LocalToAbsolute(Geometry: Geometry,LocalCoordinate: Vector2D): Vector2D;
	static TransformScalarAbsoluteToLocal(Geometry: Geometry,AbsoluteScalar: number): number;
	static TransformScalarLocalToAbsolute(Geometry: Geometry,LocalScalar: number): number;
	static TransformVectorAbsoluteToLocal(Geometry: Geometry,AbsoluteVector: Vector2D): Vector2D;
	static TransformVectorLocalToAbsolute(Geometry: Geometry,LocalVector: Vector2D): Vector2D;
}

declare type EInputEvent = 'IE_Pressed' | 'IE_Released' | 'IE_Repeat' | 'IE_DoubleClick' | 'IE_Axis' | 'IE_MAX';
declare var EInputEvent : { IE_Pressed:'IE_Pressed',IE_Released:'IE_Released',IE_Repeat:'IE_Repeat',IE_DoubleClick:'IE_DoubleClick',IE_Axis:'IE_Axis',IE_MAX:'IE_MAX', };
declare class Anchors { 
	Minimum: Vector2D;
	Maximum: Vector2D;
	clone() : Anchors;
	static C(Other: UObject | any): Anchors;
}

declare class SoundModulatorBase extends UObject { 
	static Load(ResourceName: string): SoundModulatorBase;
	static Find(Outer: UObject, ResourceName: string): SoundModulatorBase;
	static GetDefaultObject(): SoundModulatorBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundModulatorBase;
	static C(Other: UObject | any): SoundModulatorBase;
}

declare class SoundModulationDestinationSettings { 
	Value: number;
	bEnableModulation: boolean;
	Modulator: SoundModulatorBase;
	Modulators: Set<SoundModulatorBase>;
	clone() : SoundModulationDestinationSettings;
	static C(Other: UObject | any): SoundModulationDestinationSettings;
}

declare class SoundModulationDefaultSettings { 
	VolumeModulationDestination: SoundModulationDestinationSettings;
	PitchModulationDestination: SoundModulationDestinationSettings;
	HighpassModulationDestination: SoundModulationDestinationSettings;
	LowpassModulationDestination: SoundModulationDestinationSettings;
	clone() : SoundModulationDefaultSettings;
	static C(Other: UObject | any): SoundModulationDefaultSettings;
}

declare type EAudioOutputTarget = 'Speaker' | 'Controller' | 'ControllerFallbackToSpeaker' | 'EAudioOutputTarget_MAX';
declare var EAudioOutputTarget : { Speaker:'Speaker',Controller:'Controller',ControllerFallbackToSpeaker:'ControllerFallbackToSpeaker',EAudioOutputTarget_MAX:'EAudioOutputTarget_MAX', };
declare type ESoundWaveLoadingBehavior = 'Inherited' | 'RetainOnLoad' | 'PrimeOnLoad' | 'LoadOnDemand' | 'ForceInline' | 'Uninitialized' | 'ESoundWaveLoadingBehavior_MAX';
declare var ESoundWaveLoadingBehavior : { Inherited:'Inherited',RetainOnLoad:'RetainOnLoad',PrimeOnLoad:'PrimeOnLoad',LoadOnDemand:'LoadOnDemand',ForceInline:'ForceInline',Uninitialized:'Uninitialized',ESoundWaveLoadingBehavior_MAX:'ESoundWaveLoadingBehavior_MAX', };
declare class SoundSubmixBase extends UObject { 
	bAutoDisable: boolean;
	AutoDisableTime: number;
	ChildSubmixes: SoundSubmixBase[];
	static Load(ResourceName: string): SoundSubmixBase;
	static Find(Outer: UObject, ResourceName: string): SoundSubmixBase;
	static GetDefaultObject(): SoundSubmixBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundSubmixBase;
	static C(Other: UObject | any): SoundSubmixBase;
}

declare class SoundSubmixWithParentBase extends SoundSubmixBase { 
	ParentSubmix: SoundSubmixBase;
	static Load(ResourceName: string): SoundSubmixWithParentBase;
	static Find(Outer: UObject, ResourceName: string): SoundSubmixWithParentBase;
	static GetDefaultObject(): SoundSubmixWithParentBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundSubmixWithParentBase;
	static C(Other: UObject | any): SoundSubmixWithParentBase;
}

declare class SoundEffectPreset extends UObject { 
	static Load(ResourceName: string): SoundEffectPreset;
	static Find(Outer: UObject, ResourceName: string): SoundEffectPreset;
	static GetDefaultObject(): SoundEffectPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundEffectPreset;
	static C(Other: UObject | any): SoundEffectPreset;
}

declare class SoundEffectSubmixPreset extends SoundEffectPreset { 
	static Load(ResourceName: string): SoundEffectSubmixPreset;
	static Find(Outer: UObject, ResourceName: string): SoundEffectSubmixPreset;
	static GetDefaultObject(): SoundEffectSubmixPreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundEffectSubmixPreset;
	static C(Other: UObject | any): SoundEffectSubmixPreset;
}

declare class SoundfieldEncodingSettingsBase extends UObject { 
	static Load(ResourceName: string): SoundfieldEncodingSettingsBase;
	static Find(Outer: UObject, ResourceName: string): SoundfieldEncodingSettingsBase;
	static GetDefaultObject(): SoundfieldEncodingSettingsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundfieldEncodingSettingsBase;
	static C(Other: UObject | any): SoundfieldEncodingSettingsBase;
}

declare class AudioLinkSettingsAbstract extends UObject { 
	static Load(ResourceName: string): AudioLinkSettingsAbstract;
	static Find(Outer: UObject, ResourceName: string): AudioLinkSettingsAbstract;
	static GetDefaultObject(): AudioLinkSettingsAbstract;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioLinkSettingsAbstract;
	static C(Other: UObject | any): AudioLinkSettingsAbstract;
}

declare type ESoundwaveSampleRateSettings = 'Max' | 'High' | 'Medium' | 'Low' | 'Min' | 'MatchDevice_DEPRECATED' | 'ESoundwaveSampleRateSettings_MAX';
declare var ESoundwaveSampleRateSettings : { Max:'Max',High:'High',Medium:'Medium',Low:'Low',Min:'Min',MatchDevice_DEPRECATED:'MatchDevice_DEPRECATED',ESoundwaveSampleRateSettings_MAX:'ESoundwaveSampleRateSettings_MAX', };
declare type ESoundGroup = 'SOUNDGROUP_Default' | 'SOUNDGROUP_Effects' | 'SOUNDGROUP_UI' | 'SOUNDGROUP_Music' | 'SOUNDGROUP_Voice' | 'SOUNDGROUP_GameSoundGroup1' | 'SOUNDGROUP_GameSoundGroup2' | 'SOUNDGROUP_GameSoundGroup3' | 'SOUNDGROUP_GameSoundGroup4' | 'SOUNDGROUP_GameSoundGroup5' | 'SOUNDGROUP_GameSoundGroup6' | 'SOUNDGROUP_GameSoundGroup7' | 'SOUNDGROUP_GameSoundGroup8' | 'SOUNDGROUP_GameSoundGroup9' | 'SOUNDGROUP_GameSoundGroup10' | 'SOUNDGROUP_GameSoundGroup11' | 'SOUNDGROUP_GameSoundGroup12' | 'SOUNDGROUP_GameSoundGroup13' | 'SOUNDGROUP_GameSoundGroup14' | 'SOUNDGROUP_GameSoundGroup15' | 'SOUNDGROUP_GameSoundGroup16' | 'SOUNDGROUP_GameSoundGroup17' | 'SOUNDGROUP_GameSoundGroup18' | 'SOUNDGROUP_GameSoundGroup19' | 'SOUNDGROUP_GameSoundGroup20' | 'SOUNDGROUP_MAX';
declare var ESoundGroup : { SOUNDGROUP_Default:'SOUNDGROUP_Default',SOUNDGROUP_Effects:'SOUNDGROUP_Effects',SOUNDGROUP_UI:'SOUNDGROUP_UI',SOUNDGROUP_Music:'SOUNDGROUP_Music',SOUNDGROUP_Voice:'SOUNDGROUP_Voice',SOUNDGROUP_GameSoundGroup1:'SOUNDGROUP_GameSoundGroup1',SOUNDGROUP_GameSoundGroup2:'SOUNDGROUP_GameSoundGroup2',SOUNDGROUP_GameSoundGroup3:'SOUNDGROUP_GameSoundGroup3',SOUNDGROUP_GameSoundGroup4:'SOUNDGROUP_GameSoundGroup4',SOUNDGROUP_GameSoundGroup5:'SOUNDGROUP_GameSoundGroup5',SOUNDGROUP_GameSoundGroup6:'SOUNDGROUP_GameSoundGroup6',SOUNDGROUP_GameSoundGroup7:'SOUNDGROUP_GameSoundGroup7',SOUNDGROUP_GameSoundGroup8:'SOUNDGROUP_GameSoundGroup8',SOUNDGROUP_GameSoundGroup9:'SOUNDGROUP_GameSoundGroup9',SOUNDGROUP_GameSoundGroup10:'SOUNDGROUP_GameSoundGroup10',SOUNDGROUP_GameSoundGroup11:'SOUNDGROUP_GameSoundGroup11',SOUNDGROUP_GameSoundGroup12:'SOUNDGROUP_GameSoundGroup12',SOUNDGROUP_GameSoundGroup13:'SOUNDGROUP_GameSoundGroup13',SOUNDGROUP_GameSoundGroup14:'SOUNDGROUP_GameSoundGroup14',SOUNDGROUP_GameSoundGroup15:'SOUNDGROUP_GameSoundGroup15',SOUNDGROUP_GameSoundGroup16:'SOUNDGROUP_GameSoundGroup16',SOUNDGROUP_GameSoundGroup17:'SOUNDGROUP_GameSoundGroup17',SOUNDGROUP_GameSoundGroup18:'SOUNDGROUP_GameSoundGroup18',SOUNDGROUP_GameSoundGroup19:'SOUNDGROUP_GameSoundGroup19',SOUNDGROUP_GameSoundGroup20:'SOUNDGROUP_GameSoundGroup20',SOUNDGROUP_MAX:'SOUNDGROUP_MAX', };
declare type ESoundAssetCompressionType = 'BinkAudio' | 'ADPCM' | 'PCM' | 'PlatformSpecific' | 'ProjectDefined' | 'ESoundAssetCompressionType_MAX';
declare var ESoundAssetCompressionType : { BinkAudio:'BinkAudio',ADPCM:'ADPCM',PCM:'PCM',PlatformSpecific:'PlatformSpecific',ProjectDefined:'ProjectDefined',ESoundAssetCompressionType_MAX:'ESoundAssetCompressionType_MAX', };
declare type ESoundWaveFFTSize = 'VerySmall_64' | 'Small_256' | 'Medium_512' | 'Large_1024' | 'VeryLarge_2048' | 'ESoundWaveFFTSize_MAX';
declare var ESoundWaveFFTSize : { VerySmall_64:'VerySmall_64',Small_256:'Small_256',Medium_512:'Medium_512',Large_1024:'Large_1024',VeryLarge_2048:'VeryLarge_2048',ESoundWaveFFTSize_MAX:'ESoundWaveFFTSize_MAX', };
declare type EModulationRouting = 'Disable' | 'Inherit' | 'Override' | 'Union' | 'EModulationRouting_MAX';
declare var EModulationRouting : { Disable:'Disable',Inherit:'Inherit',Override:'Override',Union:'Union',EModulationRouting_MAX:'EModulationRouting_MAX', };
declare class SoundModulationDefaultRoutingSettings extends SoundModulationDefaultSettings { 
	VolumeRouting: EModulationRouting;
	PitchRouting: EModulationRouting;
	HighpassRouting: EModulationRouting;
	LowpassRouting: EModulationRouting;
	clone() : SoundModulationDefaultRoutingSettings;
	static C(Other: UObject | any): SoundModulationDefaultRoutingSettings;
}

declare class SoundWaveSpectralDataEntry { 
	Magnitude: number;
	NormalizedMagnitude: number;
	clone() : SoundWaveSpectralDataEntry;
	static C(Other: UObject | any): SoundWaveSpectralDataEntry;
}

declare class SoundWaveSpectralTimeData { 
	Data: SoundWaveSpectralDataEntry[];
	TimeSec: number;
	clone() : SoundWaveSpectralTimeData;
	static C(Other: UObject | any): SoundWaveSpectralTimeData;
}

declare class SoundWaveEnvelopeTimeData { 
	Amplitude: number;
	TimeSec: number;
	clone() : SoundWaveEnvelopeTimeData;
	static C(Other: UObject | any): SoundWaveEnvelopeTimeData;
}

declare class SoundWaveCuePoint { 
	CuePointID: number;
	Label: string;
	FramePosition: number;
	FrameLength: number;
	clone() : SoundWaveCuePoint;
	static C(Other: UObject | any): SoundWaveCuePoint;
}

declare class SubtitleCue { 
	Text: string;
	Time: number;
	clone() : SubtitleCue;
	static C(Other: UObject | any): SubtitleCue;
}

declare class SoundWaveTimecodeInfo { 
	NumSamplesSinceMidnight: number;
	NumSamplesPerSecond: number;
	Description: string;
	OriginatorTime: string;
	OriginatorDate: string;
	OriginatorDescription: string;
	OriginatorReference: string;
	TimecodeRate: FrameRate;
	bTimecodeIsDropFrame: boolean;
	clone() : SoundWaveTimecodeInfo;
	static C(Other: UObject | any): SoundWaveTimecodeInfo;
}

declare type EEvaluateCurveTableResult = 'RowFound' | 'RowNotFound' | 'EEvaluateCurveTableResult_MAX';
declare var EEvaluateCurveTableResult : { RowFound:'RowFound',RowNotFound:'RowNotFound',EEvaluateCurveTableResult_MAX:'EEvaluateCurveTableResult_MAX', };
declare class CurveTable extends UObject { 
	AssetImportData: AssetImportData;
	ImportPath: string;
	static Load(ResourceName: string): CurveTable;
	static Find(Outer: UObject, ResourceName: string): CurveTable;
	static GetDefaultObject(): CurveTable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CurveTable;
	static C(Other: UObject | any): CurveTable;
	AddRichCurve(Key: string,InCurve: RichCurve): void;
	FindRichCurve(Key: string,OutCurve?: RichCurve): {OutCurve: RichCurve, $: boolean};
	NotifyUpdateCurveTable(): void;
	EvaluateCurveTableRow(RowName: string,InXY: number,OutResult?: EEvaluateCurveTableResult,OutXY?: number,ContextString?: string): {OutResult: EEvaluateCurveTableResult, OutXY: number};
	static AddRichCurve(InCurveTable: CurveTable,Key: string,InCurve: RichCurve): void;
	static FindRichCurve(InCurveTable: CurveTable,Key: string,OutCurve?: RichCurve): {OutCurve: RichCurve, $: boolean};
	static NotifyUpdateCurveTable(InCurveTable: CurveTable): void;
	static EvaluateCurveTableRow(CurveTable: CurveTable,RowName: string,InXY: number,OutResult?: EEvaluateCurveTableResult,OutXY?: number,ContextString?: string): {OutResult: EEvaluateCurveTableResult, OutXY: number};
}

declare class WaveformTransformationBase extends UObject { 
	static Load(ResourceName: string): WaveformTransformationBase;
	static Find(Outer: UObject, ResourceName: string): WaveformTransformationBase;
	static GetDefaultObject(): WaveformTransformationBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WaveformTransformationBase;
	static C(Other: UObject | any): WaveformTransformationBase;
}

declare class SoundWave extends SoundBase { 
	CompressionQuality: number;
	StreamingPriority: number;
	SampleRateQuality: ESoundwaveSampleRateSettings;
	SoundGroup: ESoundGroup;
	bLooping: boolean;
	bStreaming: boolean;
	SoundAssetCompressionType: ESoundAssetCompressionType;
	bSeekableStreaming: boolean;
	bUseBinkAudio: boolean;
	OverrideSoundToUseForAnalysis: SoundWave;
	TreatFileAsLoopingForAnalysis: boolean;
	bEnableBakedFFTAnalysis: boolean;
	bEnableAmplitudeEnvelopeAnalysis: boolean;
	FFTSize: ESoundWaveFFTSize;
	FFTAnalysisFrameSize: number;
	FFTAnalysisAttackTime: number;
	FFTAnalysisReleaseTime: number;
	EnvelopeFollowerFrameSize: number;
	EnvelopeFollowerAttackTime: number;
	EnvelopeFollowerReleaseTime: number;
	ModulationSettings: SoundModulationDefaultRoutingSettings;
	FrequenciesToAnalyze: number[];
	CookedSpectralTimeData: SoundWaveSpectralTimeData[];
	CookedEnvelopeTimeData: SoundWaveEnvelopeTimeData[];
	InitialChunkSize: number;
	bMature: boolean;
	bManualWordWrap: boolean;
	bSingleLine: boolean;
	bVirtualizeWhenSilent: boolean;
	bIsAmbisonics: boolean;
	LoadingBehavior: ESoundWaveLoadingBehavior;
	SpokenText: string;
	SubtitlePriority: number;
	Volume: number;
	Pitch: number;
	NumChannels: number;
	CuePoints: SoundWaveCuePoint[];
	ChannelOffsets: number[];
	ChannelSizes: number[];
	SampleRate: number;
	ImportedSampleRate: number;
	Subtitles: SubtitleCue[];
	Comment: string;
	TimecodeInfo: SoundWaveTimecodeInfo;
	SourceFilePath: string;
	SourceFileTimestamp: string;
	AssetImportData: AssetImportData;
	Curves: CurveTable;
	InternalCurves: CurveTable;
	Transformations: WaveformTransformationBase[];
	static Load(ResourceName: string): SoundWave;
	static Find(Outer: UObject, ResourceName: string): SoundWave;
	static GetDefaultObject(): SoundWave;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundWave;
	SetSoundAssetCompressionType(InSoundAssetCompressionType: ESoundAssetCompressionType,bMarkDirty: boolean): void;
	GetSoundAssetCompressionType(): ESoundAssetCompressionType;
	static C(Other: UObject | any): SoundWave;
	PrimeSoundForPlayback(OnLoadCompletion: UnrealEngineDelegate<(LoadedSoundWave: SoundWave, WasCancelled: boolean) => void>): void;
	static PrimeSoundForPlayback(SoundWave: SoundWave,OnLoadCompletion: UnrealEngineDelegate<(LoadedSoundWave: SoundWave, WasCancelled: boolean) => void>): void;
}

declare type EAudioRecordingExportType = 'SoundWave' | 'WavFile' | 'EAudioRecordingExportType_MAX';
declare var EAudioRecordingExportType : { SoundWave:'SoundWave',WavFile:'WavFile',EAudioRecordingExportType_MAX:'EAudioRecordingExportType_MAX', };
declare type EFFTSize = 'DefaultSize' | 'Min' | 'Small' | 'Medium' | 'Large' | 'VeryLarge' | 'Max' | 'EFFTSize_MAX';
declare var EFFTSize : { DefaultSize:'DefaultSize',Min:'Min',Small:'Small',Medium:'Medium',Large:'Large',VeryLarge:'VeryLarge',Max:'Max',EFFTSize_MAX:'EFFTSize_MAX', };
declare type EFFTPeakInterpolationMethod = 'NearestNeighbor' | 'Linear' | 'Quadratic' | 'ConstantQ' | 'EFFTPeakInterpolationMethod_MAX';
declare var EFFTPeakInterpolationMethod : { NearestNeighbor:'NearestNeighbor',Linear:'Linear',Quadratic:'Quadratic',ConstantQ:'ConstantQ',EFFTPeakInterpolationMethod_MAX:'EFFTPeakInterpolationMethod_MAX', };
declare type EFFTWindowType = 'None' | 'Hamming' | 'Hann' | 'Blackman' | 'EFFTWindowType_MAX';
declare var EFFTWindowType : { None:'None',Hamming:'Hamming',Hann:'Hann',Blackman:'Blackman',EFFTWindowType_MAX:'EFFTWindowType_MAX', };
declare type EAudioSpectrumType = 'MagnitudeSpectrum' | 'PowerSpectrum' | 'Decibel' | 'EAudioSpectrumType_MAX';
declare var EAudioSpectrumType : { MagnitudeSpectrum:'MagnitudeSpectrum',PowerSpectrum:'PowerSpectrum',Decibel:'Decibel',EAudioSpectrumType_MAX:'EAudioSpectrumType_MAX', };
declare class SoundSubmix extends SoundSubmixWithParentBase { 
	bMuteWhenBackgrounded: boolean;
	SubmixEffectChain: SoundEffectSubmixPreset[];
	AmbisonicsPluginSettings: SoundfieldEncodingSettingsBase;
	EnvelopeFollowerAttackTime: number;
	EnvelopeFollowerReleaseTime: number;
	OutputVolume: number;
	WetLevel: number;
	DryLevel: number;
	OutputVolumeModulation: SoundModulationDestinationSettings;
	WetLevelModulation: SoundModulationDestinationSettings;
	DryLevelModulation: SoundModulationDestinationSettings;
	bSendToAudioLink: boolean;
	AudioLinkSettings: AudioLinkSettingsAbstract;
	OnSubmixRecordedFileDone: UnrealEngineMulticastDelegate<(ResultingSoundWave: SoundWave) => void>;
	static Load(ResourceName: string): SoundSubmix;
	static Find(Outer: UObject, ResourceName: string): SoundSubmix;
	static GetDefaultObject(): SoundSubmix;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundSubmix;
	StopSpectralAnalysis(WorldContextObject: UObject): void;
	StopRecordingOutput(WorldContextObject: UObject,ExportType: EAudioRecordingExportType,Name: string,Path: string,ExistingSoundWaveToOverwrite: SoundWave): void;
	StopEnvelopeFollowing(WorldContextObject: UObject): void;
	StartSpectralAnalysis(WorldContextObject: UObject,FFTSize: EFFTSize,InterpolationMethod: EFFTPeakInterpolationMethod,WindowType: EFFTWindowType,HopSize: number,SpectrumType: EAudioSpectrumType): void;
	StartRecordingOutput(WorldContextObject: UObject,ExpectedDuration: number): void;
	StartEnvelopeFollowing(WorldContextObject: UObject): void;
	SetSubmixWetLevel(WorldContextObject: UObject,InWetLevel: number): void;
	SetSubmixOutputVolume(WorldContextObject: UObject,InOutputVolume: number): void;
	SetSubmixDryLevel(WorldContextObject: UObject,InDryLevel: number): void;
	static C(Other: UObject | any): SoundSubmix;
}

declare class SoundClassProperties { 
	Volume: number;
	Pitch: number;
	LowPassFilterFrequency: number;
	AttenuationDistanceScale: number;
	LFEBleed: number;
	VoiceCenterChannelVolume: number;
	RadioFilterVolume: number;
	RadioFilterVolumeThreshold: number;
	bApplyEffects: boolean;
	bAlwaysPlay: boolean;
	bIsUISound: boolean;
	bIsMusic: boolean;
	bCenterChannelOnly: boolean;
	bApplyAmbientVolumes: boolean;
	bReverb: boolean;
	Default2DReverbSendAmount: number;
	ModulationSettings: SoundModulationDefaultSettings;
	OutputTarget: EAudioOutputTarget;
	LoadingBehavior: ESoundWaveLoadingBehavior;
	DefaultSubmix: SoundSubmix;
	clone() : SoundClassProperties;
	static C(Other: UObject | any): SoundClassProperties;
}

declare class AudioEffectParameters { 
	clone() : AudioEffectParameters;
	static C(Other: UObject | any): AudioEffectParameters;
}

declare class AudioEQEffect extends AudioEffectParameters { 
	FrequencyCenter0: number;
	Gain0: number;
	Bandwidth0: number;
	FrequencyCenter1: number;
	Gain1: number;
	Bandwidth1: number;
	FrequencyCenter2: number;
	Gain2: number;
	Bandwidth2: number;
	FrequencyCenter3: number;
	Gain3: number;
	Bandwidth3: number;
	clone() : AudioEQEffect;
	static C(Other: UObject | any): AudioEQEffect;
}

declare class SoundClassAdjuster { 
	SoundClassObject: SoundClass;
	VolumeAdjuster: number;
	PitchAdjuster: number;
	LowPassFilterFrequency: number;
	bApplyToChildren: boolean;
	VoiceCenterChannelVolumeAdjuster: number;
	clone() : SoundClassAdjuster;
	static C(Other: UObject | any): SoundClassAdjuster;
}

declare class SoundMix extends UObject { 
	bApplyEQ: boolean;
	EQPriority: number;
	EQSettings: AudioEQEffect;
	SoundClassEffects: SoundClassAdjuster[];
	InitialDelay: number;
	FadeInTime: number;
	Duration: number;
	FadeOutTime: number;
	bChanged: boolean;
	static Load(ResourceName: string): SoundMix;
	static Find(Outer: UObject, ResourceName: string): SoundMix;
	static GetDefaultObject(): SoundMix;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundMix;
	static C(Other: UObject | any): SoundMix;
}

declare class PassiveSoundMixModifier { 
	SoundMix: SoundMix;
	MinVolumeThreshold: number;
	MaxVolumeThreshold: number;
	clone() : PassiveSoundMixModifier;
	static C(Other: UObject | any): PassiveSoundMixModifier;
}

declare class SoundClass extends UObject { 
	Properties: SoundClassProperties;
	ChildClasses: SoundClass[];
	PassiveSoundMixModifiers: PassiveSoundMixModifier[];
	ParentClass: SoundClass;
	static Load(ResourceName: string): SoundClass;
	static Find(Outer: UObject, ResourceName: string): SoundClass;
	static GetDefaultObject(): SoundClass;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundClass;
	static C(Other: UObject | any): SoundClass;
	PrimeAllSoundsInSoundClass(): void;
	UnRetainAllSoundsInSoundClass(): void;
	static PrimeAllSoundsInSoundClass(InSoundClass: SoundClass): void;
	static UnRetainAllSoundsInSoundClass(InSoundClass: SoundClass): void;
}

declare type EVirtualizationMode = 'Disabled' | 'PlayWhenSilent' | 'Restart' | 'EVirtualizationMode_MAX';
declare var EVirtualizationMode : { Disabled:'Disabled',PlayWhenSilent:'PlayWhenSilent',Restart:'Restart',EVirtualizationMode_MAX:'EVirtualizationMode_MAX', };
declare type EMaxConcurrentResolutionRule = 'PreventNew' | 'StopOldest' | 'StopFarthestThenPreventNew' | 'StopFarthestThenOldest' | 'StopLowestPriority' | 'StopQuietest' | 'StopLowestPriorityThenPreventNew' | 'Count' | 'EMaxConcurrentResolutionRule_MAX';
declare var EMaxConcurrentResolutionRule : { PreventNew:'PreventNew',StopOldest:'StopOldest',StopFarthestThenPreventNew:'StopFarthestThenPreventNew',StopFarthestThenOldest:'StopFarthestThenOldest',StopLowestPriority:'StopLowestPriority',StopQuietest:'StopQuietest',StopLowestPriorityThenPreventNew:'StopLowestPriorityThenPreventNew',Count:'Count',EMaxConcurrentResolutionRule_MAX:'EMaxConcurrentResolutionRule_MAX', };
declare type EConcurrencyVolumeScaleMode = 'Default' | 'Distance' | 'Priority' | 'EConcurrencyVolumeScaleMode_MAX';
declare var EConcurrencyVolumeScaleMode : { Default:'Default',Distance:'Distance',Priority:'Priority',EConcurrencyVolumeScaleMode_MAX:'EConcurrencyVolumeScaleMode_MAX', };
declare class SoundConcurrencySettings { 
	MaxCount: number;
	bLimitToOwner: boolean;
	bVolumeScaleCanRelease: boolean;
	ResolutionRule: EMaxConcurrentResolutionRule;
	RetriggerTime: number;
	VolumeScale: number;
	VolumeScaleMode: EConcurrencyVolumeScaleMode;
	VolumeScaleAttackTime: number;
	VolumeScaleReleaseTime: number;
	VoiceStealReleaseTime: number;
	clone() : SoundConcurrencySettings;
	static C(Other: UObject | any): SoundConcurrencySettings;
}

declare class SoundConcurrency extends UObject { 
	Concurrency: SoundConcurrencySettings;
	static Load(ResourceName: string): SoundConcurrency;
	static Find(Outer: UObject, ResourceName: string): SoundConcurrency;
	static GetDefaultObject(): SoundConcurrency;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundConcurrency;
	static C(Other: UObject | any): SoundConcurrency;
}

declare type ESoundSpatializationAlgorithm = 'SPATIALIZATION_Default' | 'SPATIALIZATION_HRTF' | 'SPATIALIZATION_MAX';
declare var ESoundSpatializationAlgorithm : { SPATIALIZATION_Default:'SPATIALIZATION_Default',SPATIALIZATION_HRTF:'SPATIALIZATION_HRTF',SPATIALIZATION_MAX:'SPATIALIZATION_MAX', };
declare type EAirAbsorptionMethod = 'Linear' | 'CustomCurve' | 'EAirAbsorptionMethod_MAX';
declare var EAirAbsorptionMethod : { Linear:'Linear',CustomCurve:'CustomCurve',EAirAbsorptionMethod_MAX:'EAirAbsorptionMethod_MAX', };
declare type EReverbSendMethod = 'Linear' | 'CustomCurve' | 'Manual' | 'EReverbSendMethod_MAX';
declare var EReverbSendMethod : { Linear:'Linear',CustomCurve:'CustomCurve',Manual:'Manual',EReverbSendMethod_MAX:'EReverbSendMethod_MAX', };
declare type EPriorityAttenuationMethod = 'Linear' | 'CustomCurve' | 'Manual' | 'EPriorityAttenuationMethod_MAX';
declare var EPriorityAttenuationMethod : { Linear:'Linear',CustomCurve:'CustomCurve',Manual:'Manual',EPriorityAttenuationMethod_MAX:'EPriorityAttenuationMethod_MAX', };
declare type ESoundDistanceCalc = 'SOUNDDISTANCE_Normal' | 'SOUNDDISTANCE_InfiniteXYPlane' | 'SOUNDDISTANCE_InfiniteXZPlane' | 'SOUNDDISTANCE_InfiniteYZPlane' | 'SOUNDDISTANCE_MAX';
declare var ESoundDistanceCalc : { SOUNDDISTANCE_Normal:'SOUNDDISTANCE_Normal',SOUNDDISTANCE_InfiniteXYPlane:'SOUNDDISTANCE_InfiniteXYPlane',SOUNDDISTANCE_InfiniteXZPlane:'SOUNDDISTANCE_InfiniteXZPlane',SOUNDDISTANCE_InfiniteYZPlane:'SOUNDDISTANCE_InfiniteYZPlane',SOUNDDISTANCE_MAX:'SOUNDDISTANCE_MAX', };
declare class SpatializationPluginSourceSettingsBase extends UObject { 
	static Load(ResourceName: string): SpatializationPluginSourceSettingsBase;
	static Find(Outer: UObject, ResourceName: string): SpatializationPluginSourceSettingsBase;
	static GetDefaultObject(): SpatializationPluginSourceSettingsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SpatializationPluginSourceSettingsBase;
	static C(Other: UObject | any): SpatializationPluginSourceSettingsBase;
}

declare class OcclusionPluginSourceSettingsBase extends UObject { 
	static Load(ResourceName: string): OcclusionPluginSourceSettingsBase;
	static Find(Outer: UObject, ResourceName: string): OcclusionPluginSourceSettingsBase;
	static GetDefaultObject(): OcclusionPluginSourceSettingsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OcclusionPluginSourceSettingsBase;
	static C(Other: UObject | any): OcclusionPluginSourceSettingsBase;
}

declare class ReverbPluginSourceSettingsBase extends UObject { 
	static Load(ResourceName: string): ReverbPluginSourceSettingsBase;
	static Find(Outer: UObject, ResourceName: string): ReverbPluginSourceSettingsBase;
	static GetDefaultObject(): ReverbPluginSourceSettingsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReverbPluginSourceSettingsBase;
	static C(Other: UObject | any): ReverbPluginSourceSettingsBase;
}

declare type ESubmixSendMethod = 'Linear' | 'CustomCurve' | 'Manual' | 'ESubmixSendMethod_MAX';
declare var ESubmixSendMethod : { Linear:'Linear',CustomCurve:'CustomCurve',Manual:'Manual',ESubmixSendMethod_MAX:'ESubmixSendMethod_MAX', };
declare class AttenuationSubmixSendSettings { 
	Submix: SoundSubmixBase;
	SubmixSendMethod: ESubmixSendMethod;
	SubmixSendLevelMin: number;
	SubmixSendLevelMax: number;
	SubmixSendDistanceMin: number;
	SubmixSendDistanceMax: number;
	ManualSubmixSendLevel: number;
	CustomSubmixSendCurve: RuntimeFloatCurve;
	clone() : AttenuationSubmixSendSettings;
	static C(Other: UObject | any): AttenuationSubmixSendSettings;
}

declare class SourceDataOverridePluginSourceSettingsBase extends UObject { 
	static Load(ResourceName: string): SourceDataOverridePluginSourceSettingsBase;
	static Find(Outer: UObject, ResourceName: string): SourceDataOverridePluginSourceSettingsBase;
	static GetDefaultObject(): SourceDataOverridePluginSourceSettingsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SourceDataOverridePluginSourceSettingsBase;
	static C(Other: UObject | any): SourceDataOverridePluginSourceSettingsBase;
}

declare class SoundAttenuationPluginSettings { 
	SpatializationPluginSettingsArray: SpatializationPluginSourceSettingsBase[];
	OcclusionPluginSettingsArray: OcclusionPluginSourceSettingsBase[];
	ReverbPluginSettingsArray: ReverbPluginSourceSettingsBase[];
	SourceDataOverridePluginSettingsArray: SourceDataOverridePluginSourceSettingsBase[];
	clone() : SoundAttenuationPluginSettings;
	static C(Other: UObject | any): SoundAttenuationPluginSettings;
}

declare class SoundAttenuationSettings extends BaseAttenuationSettings { 
	bAttenuate: boolean;
	bSpatialize: boolean;
	bAttenuateWithLPF: boolean;
	bEnableListenerFocus: boolean;
	bEnableFocusInterpolation: boolean;
	bEnableOcclusion: boolean;
	bUseComplexCollisionForOcclusion: boolean;
	bEnableReverbSend: boolean;
	bEnablePriorityAttenuation: boolean;
	bApplyNormalizationToStereoSounds: boolean;
	bEnableLogFrequencyScaling: boolean;
	bEnableSubmixSends: boolean;
	bEnableSourceDataOverride: boolean;
	bEnableSendToAudioLink: boolean;
	SpatializationAlgorithm: ESoundSpatializationAlgorithm;
	AudioLinkSettingsOverride: AudioLinkSettingsAbstract;
	BinauralRadius: number;
	CustomLowpassAirAbsorptionCurve: RuntimeFloatCurve;
	CustomHighpassAirAbsorptionCurve: RuntimeFloatCurve;
	AbsorptionMethod: EAirAbsorptionMethod;
	OcclusionTraceChannel: ECollisionChannel;
	ReverbSendMethod: EReverbSendMethod;
	PriorityAttenuationMethod: EPriorityAttenuationMethod;
	DistanceType: ESoundDistanceCalc;
	OmniRadius: number;
	StereoSpread: number;
	SpatializationPluginSettings: SpatializationPluginSourceSettingsBase;
	RadiusMin: number;
	RadiusMax: number;
	LPFRadiusMin: number;
	LPFRadiusMax: number;
	LPFFrequencyAtMin: number;
	LPFFrequencyAtMax: number;
	HPFFrequencyAtMin: number;
	HPFFrequencyAtMax: number;
	FocusAzimuth: number;
	NonFocusAzimuth: number;
	FocusDistanceScale: number;
	NonFocusDistanceScale: number;
	FocusPriorityScale: number;
	NonFocusPriorityScale: number;
	FocusVolumeAttenuation: number;
	NonFocusVolumeAttenuation: number;
	FocusAttackInterpSpeed: number;
	FocusReleaseInterpSpeed: number;
	OcclusionLowPassFilterFrequency: number;
	OcclusionVolumeAttenuation: number;
	OcclusionInterpolationTime: number;
	OcclusionPluginSettings: OcclusionPluginSourceSettingsBase;
	ReverbPluginSettings: ReverbPluginSourceSettingsBase;
	ReverbWetLevelMin: number;
	ReverbWetLevelMax: number;
	ReverbDistanceMin: number;
	ReverbDistanceMax: number;
	ManualReverbSendLevel: number;
	PriorityAttenuationMin: number;
	PriorityAttenuationMax: number;
	PriorityAttenuationDistanceMin: number;
	PriorityAttenuationDistanceMax: number;
	ManualPriorityAttenuation: number;
	CustomReverbSendCurve: RuntimeFloatCurve;
	SubmixSendSettings: AttenuationSubmixSendSettings[];
	CustomPriorityAttenuationCurve: RuntimeFloatCurve;
	PluginSettings: SoundAttenuationPluginSettings;
	clone() : SoundAttenuationSettings;
	static C(Other: UObject | any): SoundAttenuationSettings;
}

declare class SoundAttenuation extends UObject { 
	Attenuation: SoundAttenuationSettings;
	static Load(ResourceName: string): SoundAttenuation;
	static Find(Outer: UObject, ResourceName: string): SoundAttenuation;
	static GetDefaultObject(): SoundAttenuation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundAttenuation;
	static C(Other: UObject | any): SoundAttenuation;
}

declare type ESendLevelControlMethod = 'Linear' | 'CustomCurve' | 'Manual' | 'ESendLevelControlMethod_MAX';
declare var ESendLevelControlMethod : { Linear:'Linear',CustomCurve:'CustomCurve',Manual:'Manual',ESendLevelControlMethod_MAX:'ESendLevelControlMethod_MAX', };
declare type ESubmixSendStage = 'PostDistanceAttenuation' | 'PreDistanceAttenuation' | 'ESubmixSendStage_MAX';
declare var ESubmixSendStage : { PostDistanceAttenuation:'PostDistanceAttenuation',PreDistanceAttenuation:'PreDistanceAttenuation',ESubmixSendStage_MAX:'ESubmixSendStage_MAX', };
declare class SoundSubmixSendInfo { 
	SendLevelControlMethod: ESendLevelControlMethod;
	SendStage: ESubmixSendStage;
	SoundSubmix: SoundSubmixBase;
	SendLevel: number;
	DisableManualSendClamp: boolean;
	MinSendLevel: number;
	MaxSendLevel: number;
	MinSendDistance: number;
	MaxSendDistance: number;
	CustomSendLevelCurve: RuntimeFloatCurve;
	clone() : SoundSubmixSendInfo;
	static C(Other: UObject | any): SoundSubmixSendInfo;
}

declare class SoundEffectSourcePreset extends SoundEffectPreset { 
	static Load(ResourceName: string): SoundEffectSourcePreset;
	static Find(Outer: UObject, ResourceName: string): SoundEffectSourcePreset;
	static GetDefaultObject(): SoundEffectSourcePreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundEffectSourcePreset;
	static C(Other: UObject | any): SoundEffectSourcePreset;
}

declare class SourceEffectChainEntry { 
	Preset: SoundEffectSourcePreset;
	bBypass: boolean;
	clone() : SourceEffectChainEntry;
	static C(Other: UObject | any): SourceEffectChainEntry;
}

declare class SoundEffectSourcePresetChain extends UObject { 
	Chain: SourceEffectChainEntry[];
	bPlayEffectChainTails: boolean;
	static Load(ResourceName: string): SoundEffectSourcePresetChain;
	static Find(Outer: UObject, ResourceName: string): SoundEffectSourcePresetChain;
	static GetDefaultObject(): SoundEffectSourcePresetChain;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundEffectSourcePresetChain;
	static C(Other: UObject | any): SoundEffectSourcePresetChain;
}

declare type ESourceBusSendLevelControlMethod = 'Linear' | 'CustomCurve' | 'Manual' | 'ESourceBusSendLevelControlMethod_MAX';
declare var ESourceBusSendLevelControlMethod : { Linear:'Linear',CustomCurve:'CustomCurve',Manual:'Manual',ESourceBusSendLevelControlMethod_MAX:'ESourceBusSendLevelControlMethod_MAX', };
declare type ESourceBusChannels = 'Mono' | 'Stereo' | 'ESourceBusChannels_MAX';
declare var ESourceBusChannels : { Mono:'Mono',Stereo:'Stereo',ESourceBusChannels_MAX:'ESourceBusChannels_MAX', };
declare type EAudioBusChannels = 'Mono' | 'Stereo' | 'Quad' | 'FivePointOne' | 'SevenPointOne' | 'EAudioBusChannels_MAX';
declare var EAudioBusChannels : { Mono:'Mono',Stereo:'Stereo',Quad:'Quad',FivePointOne:'FivePointOne',SevenPointOne:'SevenPointOne',EAudioBusChannels_MAX:'EAudioBusChannels_MAX', };
declare class AudioBus extends UObject { 
	AudioBusChannels: EAudioBusChannels;
	static Load(ResourceName: string): AudioBus;
	static Find(Outer: UObject, ResourceName: string): AudioBus;
	static GetDefaultObject(): AudioBus;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioBus;
	static C(Other: UObject | any): AudioBus;
}

declare class SoundSourceBus extends SoundWave { 
	SourceBusChannels: ESourceBusChannels;
	SourceBusDuration: number;
	AudioBus: AudioBus;
	bAutoDeactivateWhenSilent: boolean;
	static Load(ResourceName: string): SoundSourceBus;
	static Find(Outer: UObject, ResourceName: string): SoundSourceBus;
	static GetDefaultObject(): SoundSourceBus;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundSourceBus;
	static C(Other: UObject | any): SoundSourceBus;
}

declare class SoundSourceBusSendInfo { 
	SourceBusSendLevelControlMethod: ESourceBusSendLevelControlMethod;
	SoundSourceBus: SoundSourceBus;
	AudioBus: AudioBus;
	SendLevel: number;
	MinSendLevel: number;
	MaxSendLevel: number;
	MinSendDistance: number;
	MaxSendDistance: number;
	CustomSendLevelCurve: RuntimeFloatCurve;
	clone() : SoundSourceBusSendInfo;
	static C(Other: UObject | any): SoundSourceBusSendInfo;
}

declare class SoundTimecodeOffset { 
	NumOfSecondsSinceMidnight: number;
	clone() : SoundTimecodeOffset;
	static C(Other: UObject | any): SoundTimecodeOffset;
}

declare type EAudioParameterType = 'None' | 'Boolean' | 'Integer' | 'Float' | 'String' | 'Object' | 'NoneArray' | 'BooleanArray' | 'IntegerArray' | 'FloatArray' | 'StringArray' | 'ObjectArray' | 'COUNT' | 'EAudioParameterType_MAX';
declare var EAudioParameterType : { None:'None',Boolean:'Boolean',Integer:'Integer',Float:'Float',String:'String',Object:'Object',NoneArray:'NoneArray',BooleanArray:'BooleanArray',IntegerArray:'IntegerArray',FloatArray:'FloatArray',StringArray:'StringArray',ObjectArray:'ObjectArray',COUNT:'COUNT',EAudioParameterType_MAX:'EAudioParameterType_MAX', };
declare class AudioParameter { 
	ParamName: string;
	FloatParam: number;
	BoolParam: boolean;
	IntParam: number;
	ObjectParam: UObject;
	StringParam: string;
	ArrayFloatParam: number[];
	ArrayBoolParam: boolean[];
	ArrayIntParam: number[];
	ArrayObjectParam: UObject[];
	ArrayStringParam: string[];
	ParamType: EAudioParameterType;
	TypeName: string;
	clone() : AudioParameter;
	static C(Other: UObject | any): AudioParameter;
	static BooleanArrayToAudioParameter(Name: string,Bools: boolean[]): AudioParameter;
	static BooleanToAudioParameter(Name: string,bool: boolean): AudioParameter;
	static FloatArrayToAudioParameter(Name: string,Floats: number[]): AudioParameter;
	static FloatToAudioParameter(Name: string,float: number): AudioParameter;
	static IntegerArrayToAudioParameter(Name: string,Integers: number[]): AudioParameter;
	static IntegerToAudioParameter(Name: string,Integer: number): AudioParameter;
	static ObjectArrayToAudioParameter(Name: string,Objects: UObject[]): AudioParameter;
	static ObjectToAudioParameter(Name: string,UObject: UObject): AudioParameter;
	static StringArrayToAudioParameter(Name: string,Strings: string[]): AudioParameter;
	static StringToAudioParameter(Name: string,string: string): AudioParameter;
}

declare type EAudioComponentPlayState = 'Playing' | 'Stopped' | 'Paused' | 'FadingIn' | 'FadingOut' | 'Count' | 'EAudioComponentPlayState_MAX';
declare var EAudioComponentPlayState : { Playing:'Playing',Stopped:'Stopped',Paused:'Paused',FadingIn:'FadingIn',FadingOut:'FadingOut',Count:'Count',EAudioComponentPlayState_MAX:'EAudioComponentPlayState_MAX', };
declare class SoundWaveSpectralData { 
	FrequencyHz: number;
	Magnitude: number;
	NormalizedMagnitude: number;
	clone() : SoundWaveSpectralData;
	static C(Other: UObject | any): SoundWaveSpectralData;
}

declare class SoundWaveSpectralDataPerSound { 
	SpectralData: SoundWaveSpectralData[];
	PlaybackTime: number;
	SoundWave: SoundWave;
	clone() : SoundWaveSpectralDataPerSound;
	static C(Other: UObject | any): SoundWaveSpectralDataPerSound;
}

declare class SoundWaveEnvelopeDataPerSound { 
	Envelope: number;
	PlaybackTime: number;
	SoundWave: SoundWave;
	clone() : SoundWaveEnvelopeDataPerSound;
	static C(Other: UObject | any): SoundWaveEnvelopeDataPerSound;
}

declare type EAudioFaderCurve = 'Linear' | 'Logarithmic' | 'SCurve' | 'Sin' | 'Count' | 'EAudioFaderCurve_MAX';
declare var EAudioFaderCurve : { Linear:'Linear',Logarithmic:'Logarithmic',SCurve:'SCurve',Sin:'Sin',Count:'Count',EAudioFaderCurve_MAX:'EAudioFaderCurve_MAX', };
declare class AudioComponent extends SceneComponent { 
	Sound: SoundBase;
	DefaultParameters: AudioParameter[];
	InstanceParameters: AudioParameter[];
	SoundClassOverride: SoundClass;
	bAutoDestroy: boolean;
	bStopWhenOwnerDestroyed: boolean;
	bShouldRemainActiveIfDropped: boolean;
	bAllowSpatialization: boolean;
	bOverrideAttenuation: boolean;
	bOverrideSubtitlePriority: boolean;
	bIsUISound: boolean;
	bEnableLowPassFilter: boolean;
	bOverridePriority: boolean;
	bSuppressSubtitles: boolean;
	bCanPlayMultipleInstances: boolean;
	bDisableParameterUpdatesWhilePlaying: boolean;
	bAutoManageAttachment: boolean;
	AudioComponentUserID: string;
	PitchModulationMin: number;
	PitchModulationMax: number;
	VolumeModulationMin: number;
	VolumeModulationMax: number;
	VolumeMultiplier: number;
	EnvelopeFollowerAttackTime: number;
	EnvelopeFollowerReleaseTime: number;
	Priority: number;
	SubtitlePriority: number;
	SourceEffectChain: SoundEffectSourcePresetChain;
	VolumeWeightedPriorityScale: number;
	HighFrequencyGainMultiplier: number;
	PitchMultiplier: number;
	LowPassFilterFrequency: number;
	AttenuationSettings: SoundAttenuation;
	AttenuationOverrides: SoundAttenuationSettings;
	ConcurrencySettings: SoundConcurrency;
	ConcurrencySet: Set<SoundConcurrency>;
	AutoAttachLocationRule: EAttachmentRule;
	AutoAttachRotationRule: EAttachmentRule;
	AutoAttachScaleRule: EAttachmentRule;
	ModulationRouting: SoundModulationDefaultRoutingSettings;
	OnAudioPlayStateChanged: UnrealEngineMulticastDelegate<(PlayState: EAudioComponentPlayState) => void>;
	OnAudioVirtualizationChanged: UnrealEngineMulticastDelegate<(bIsVirtualized: boolean) => void>;
	OnAudioFinished: UnrealEngineMulticastDelegate<() => void>;
	OnAudioPlaybackPercent: UnrealEngineMulticastDelegate<(PlayingSoundWave: SoundWave, PlaybackPercent: number) => void>;
	OnAudioSingleEnvelopeValue: UnrealEngineMulticastDelegate<(PlayingSoundWave: SoundWave, EnvelopeValue: number) => void>;
	OnAudioMultiEnvelopeValue: UnrealEngineMulticastDelegate<(AverageEnvelopeValue: number, MaxEnvelope: number, NumWaveInstances: number) => void>;
	OnQueueSubtitles: UnrealEngineDelegate<(Subtitles: SubtitleCue[], CueDuration: number) => void>;
	AutoAttachParent: SceneComponent;
	AutoAttachSocketName: string;
	static Load(ResourceName: string): AudioComponent;
	static Find(Outer: UObject, ResourceName: string): AudioComponent;
	static GetDefaultObject(): AudioComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AudioComponent;
	StopDelayed(DelayTime: number): void;
	Stop(): void;
	SetWaveParameter(InName: string,InWave: SoundWave): void;
	SetVolumeMultiplier(NewVolumeMultiplier: number): void;
	SetUISound(bInUISound: boolean): void;
	SetSubmixSend(Submix: SoundSubmixBase,SendLevel: number): void;
	SetSourceBusSendPreEffect(SoundSourceBus: SoundSourceBus,SourceBusSendLevel: number): void;
	SetSourceBusSendPostEffect(SoundSourceBus: SoundSourceBus,SourceBusSendLevel: number): void;
	SetSound(NewSound: SoundBase): void;
	SetPitchMultiplier(NewPitchMultiplier: number): void;
	SetPaused(bPause: boolean): void;
	SetOutputToBusOnly(bInOutputToBusOnly: boolean): void;
	SetLowPassFilterFrequency(InLowPassFilterFrequency: number): void;
	SetLowPassFilterEnabled(InLowPassFilterEnabled: boolean): void;
	SetIntParameter(InName: string,inInt: number): void;
	SetFloatParameter(InName: string,InFloat: number): void;
	SetBoolParameter(InName: string,InBool: boolean): void;
	SetAudioBusSendPreEffect(AudioBus: AudioBus,AudioBusSendLevel: number): void;
	SetAudioBusSendPostEffect(AudioBus: AudioBus,AudioBusSendLevel: number): void;
	Play(StartTime: number): void;
	IsVirtualized(): boolean;
	IsPlaying(): boolean;
	HasCookedFFTData(): boolean;
	HasCookedAmplitudeEnvelopeData(): boolean;
	GetPlayState(): EAudioComponentPlayState;
	GetCookedFFTDataForAllPlayingSounds(OutSoundWaveSpectralData?: SoundWaveSpectralDataPerSound[]): {OutSoundWaveSpectralData: SoundWaveSpectralDataPerSound[], $: boolean};
	GetCookedFFTData(FrequenciesToGet: number[],OutSoundWaveSpectralData?: SoundWaveSpectralData[]): {OutSoundWaveSpectralData: SoundWaveSpectralData[], $: boolean};
	GetCookedEnvelopeDataForAllPlayingSounds(OutEnvelopeData?: SoundWaveEnvelopeDataPerSound[]): {OutEnvelopeData: SoundWaveEnvelopeDataPerSound[], $: boolean};
	GetCookedEnvelopeData(OutEnvelopeData?: number): {OutEnvelopeData: number, $: boolean};
	FadeOut(FadeOutDuration: number,FadeVolumeLevel: number,FadeCurve: EAudioFaderCurve): void;
	FadeIn(FadeInDuration: number,FadeVolumeLevel: number,StartTime: number,FadeCurve: EAudioFaderCurve): void;
	BP_GetAttenuationSettingsToApply(OutAttenuationSettings?: SoundAttenuationSettings): {OutAttenuationSettings: SoundAttenuationSettings, $: boolean};
	AdjustVolume(AdjustVolumeDuration: number,AdjustVolumeLevel: number,FadeCurve: EAudioFaderCurve): void;
	AdjustAttenuation(InAttenuationSettings: SoundAttenuationSettings): void;
	static C(Other: UObject | any): AudioComponent;
}

declare class SoundBase extends UObject { 
	SoundClassObject: SoundClass;
	bDebug: boolean;
	bOverrideConcurrency: boolean;
	bOutputToBusOnly: boolean;
	bEnableBusSends: boolean;
	bEnableBaseSubmix: boolean;
	bEnableSubmixSends: boolean;
	bHasDelayNode: boolean;
	bHasConcatenatorNode: boolean;
	bHasVirtualizeWhenSilent: boolean;
	bBypassVolumeScaleForPriority: boolean;
	VirtualizationMode: EVirtualizationMode;
	MaxConcurrentResolutionRule: EMaxConcurrentResolutionRule;
	SoundConcurrencySettings: SoundConcurrency;
	ConcurrencySet: Set<SoundConcurrency>;
	ConcurrencyOverrides: SoundConcurrencySettings;
	MaxConcurrentPlayCount: number;
	Duration: number;
	MaxDistance: number;
	TotalSamples: number;
	Priority: number;
	AttenuationSettings: SoundAttenuation;
	SoundSubmixObject: SoundSubmixBase;
	SoundSubmixSends: SoundSubmixSendInfo[];
	SourceEffectChain: SoundEffectSourcePresetChain;
	BusSends: SoundSourceBusSendInfo[];
	PreEffectBusSends: SoundSourceBusSendInfo[];
	AssetUserData: AssetUserData[];
	TimecodeOffset: SoundTimecodeOffset;
	static Load(ResourceName: string): SoundBase;
	static Find(Outer: UObject, ResourceName: string): SoundBase;
	static GetDefaultObject(): SoundBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SoundBase;
	static C(Other: UObject | any): SoundBase;
	PrimeSound(): void;
	SpawnSoundAttached(AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,VolumeMultiplier: number,PitchMultiplier: number,StartTime: number,AttenuationSettings: SoundAttenuation,ConcurrencySettings: SoundConcurrency,bAutoDestroy: boolean): AudioComponent;
	static PrimeSound(InSound: SoundBase): void;
	static SpawnSoundAttached(Sound: SoundBase,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,VolumeMultiplier: number,PitchMultiplier: number,StartTime: number,AttenuationSettings: SoundAttenuation,ConcurrencySettings: SoundConcurrency,bAutoDestroy: boolean): AudioComponent;
}

declare type EUMGSequencePlayMode = 'Forward' | 'Reverse' | 'PingPong' | 'EUMGSequencePlayMode_MAX';
declare var EUMGSequencePlayMode : { Forward:'Forward',Reverse:'Reverse',PingPong:'PingPong',EUMGSequencePlayMode_MAX:'EUMGSequencePlayMode_MAX', };
declare class InputEvent { 
	clone() : InputEvent;
	static C(Other: UObject | any): InputEvent;
	InputEvent_IsAltDown(): boolean;
	InputEvent_IsCommandDown(): boolean;
	InputEvent_IsControlDown(): boolean;
	InputEvent_IsLeftAltDown(): boolean;
	InputEvent_IsLeftCommandDown(): boolean;
	InputEvent_IsLeftControlDown(): boolean;
	InputEvent_IsLeftShiftDown(): boolean;
	InputEvent_IsRepeat(): boolean;
	InputEvent_IsRightAltDown(): boolean;
	InputEvent_IsRightCommandDown(): boolean;
	InputEvent_IsRightControlDown(): boolean;
	InputEvent_IsRightShiftDown(): boolean;
	InputEvent_IsShiftDown(): boolean;
	static InputEvent_IsAltDown(Input: InputEvent): boolean;
	static InputEvent_IsCommandDown(Input: InputEvent): boolean;
	static InputEvent_IsControlDown(Input: InputEvent): boolean;
	static InputEvent_IsLeftAltDown(Input: InputEvent): boolean;
	static InputEvent_IsLeftCommandDown(Input: InputEvent): boolean;
	static InputEvent_IsLeftControlDown(Input: InputEvent): boolean;
	static InputEvent_IsLeftShiftDown(Input: InputEvent): boolean;
	static InputEvent_IsRepeat(Input: InputEvent): boolean;
	static InputEvent_IsRightAltDown(Input: InputEvent): boolean;
	static InputEvent_IsRightCommandDown(Input: InputEvent): boolean;
	static InputEvent_IsRightControlDown(Input: InputEvent): boolean;
	static InputEvent_IsRightShiftDown(Input: InputEvent): boolean;
	static InputEvent_IsShiftDown(Input: InputEvent): boolean;
}

declare type ESlateGesture = 'None' | 'Scroll' | 'Magnify' | 'Swipe' | 'Rotate' | 'LongPress' | 'ESlateGesture_MAX';
declare var ESlateGesture : { None:'None',Scroll:'Scroll',Magnify:'Magnify',Swipe:'Swipe',Rotate:'Rotate',LongPress:'LongPress',ESlateGesture_MAX:'ESlateGesture_MAX', };
declare class EventReply { 
	clone() : EventReply;
	static C(Other: UObject | any): EventReply;
	CaptureJoystick(CapturingWidget?: Widget,bInAllJoysticks?: boolean): {Reply: EventReply, $: EventReply};
	CaptureMouse(CapturingWidget?: Widget): {Reply: EventReply, $: EventReply};
	ClearUserFocus(bInAllUsers?: boolean): {Reply: EventReply, $: EventReply};
	DetectDrag(WidgetDetectingDrag?: Widget,DragKey?: Key): {Reply: EventReply, $: EventReply};
	EndDragDrop(): {Reply: EventReply, $: EventReply};
	LockMouse(CapturingWidget?: Widget): {Reply: EventReply, $: EventReply};
	ReleaseJoystickCapture(bInAllJoysticks?: boolean): {Reply: EventReply, $: EventReply};
	ReleaseMouseCapture(): {Reply: EventReply, $: EventReply};
	SetMousePosition(NewMousePosition?: Vector2D): {Reply: EventReply, $: EventReply};
	SetUserFocus(FocusWidget?: Widget,bInAllUsers?: boolean): {Reply: EventReply, $: EventReply};
	UnlockMouse(): {Reply: EventReply, $: EventReply};
	static CaptureJoystick(Reply?: EventReply,CapturingWidget?: Widget,bInAllJoysticks?: boolean): {Reply: EventReply, $: EventReply};
	static CaptureMouse(Reply?: EventReply,CapturingWidget?: Widget): {Reply: EventReply, $: EventReply};
	static ClearUserFocus(Reply?: EventReply,bInAllUsers?: boolean): {Reply: EventReply, $: EventReply};
	static DetectDrag(Reply?: EventReply,WidgetDetectingDrag?: Widget,DragKey?: Key): {Reply: EventReply, $: EventReply};
	static EndDragDrop(Reply?: EventReply): {Reply: EventReply, $: EventReply};
	static LockMouse(Reply?: EventReply,CapturingWidget?: Widget): {Reply: EventReply, $: EventReply};
	static ReleaseJoystickCapture(Reply?: EventReply,bInAllJoysticks?: boolean): {Reply: EventReply, $: EventReply};
	static ReleaseMouseCapture(Reply?: EventReply): {Reply: EventReply, $: EventReply};
	static SetMousePosition(Reply?: EventReply,NewMousePosition?: Vector2D): {Reply: EventReply, $: EventReply};
	static SetUserFocus(Reply?: EventReply,FocusWidget?: Widget,bInAllUsers?: boolean): {Reply: EventReply, $: EventReply};
	static UnlockMouse(Reply?: EventReply): {Reply: EventReply, $: EventReply};
	static Handled(): EventReply;
	static Unhandled(): EventReply;
}

declare class UPointerEvent extends InputEvent { 
	clone() : UPointerEvent;
	static C(Other: UObject | any): UPointerEvent;
	PointerEvent_GetCursorDelta(): Vector2D;
	PointerEvent_GetEffectingButton(): Key;
	PointerEvent_GetGestureDelta(): Vector2D;
	PointerEvent_GetGestureType(): ESlateGesture;
	PointerEvent_GetLastScreenSpacePosition(): Vector2D;
	PointerEvent_GetPointerIndex(): number;
	PointerEvent_GetScreenSpacePosition(): Vector2D;
	PointerEvent_GetTouchpadIndex(): number;
	PointerEvent_GetUserIndex(): number;
	PointerEvent_GetWheelDelta(): number;
	PointerEvent_IsMouseButtonDown(MouseButton: Key): boolean;
	PointerEvent_IsTouchEvent(): boolean;
	DetectDragIfPressed(WidgetDetectingDrag: Widget,DragKey: Key): EventReply;
	GetInputEventFromPointerEvent(): InputEvent;
	static PointerEvent_GetCursorDelta(Input: UPointerEvent): Vector2D;
	static PointerEvent_GetEffectingButton(Input: UPointerEvent): Key;
	static PointerEvent_GetGestureDelta(Input: UPointerEvent): Vector2D;
	static PointerEvent_GetGestureType(Input: UPointerEvent): ESlateGesture;
	static PointerEvent_GetLastScreenSpacePosition(Input: UPointerEvent): Vector2D;
	static PointerEvent_GetPointerIndex(Input: UPointerEvent): number;
	static PointerEvent_GetScreenSpacePosition(Input: UPointerEvent): Vector2D;
	static PointerEvent_GetTouchpadIndex(Input: UPointerEvent): number;
	static PointerEvent_GetUserIndex(Input: UPointerEvent): number;
	static PointerEvent_GetWheelDelta(Input: UPointerEvent): number;
	static PointerEvent_IsMouseButtonDown(Input: UPointerEvent,MouseButton: Key): boolean;
	static PointerEvent_IsTouchEvent(Input: UPointerEvent): boolean;
	static DetectDragIfPressed(UPointerEvent: UPointerEvent,WidgetDetectingDrag: Widget,DragKey: Key): EventReply;
	static GetInputEventFromPointerEvent(Event: UPointerEvent): InputEvent;
}

declare class UFocusEvent { 
	clone() : UFocusEvent;
	static C(Other: UObject | any): UFocusEvent;
}

declare class KeyEvent extends InputEvent { 
	clone() : KeyEvent;
	static C(Other: UObject | any): KeyEvent;
	GetIsAltDownByKeyEvent(): boolean;
	GetIsControlDownByKeyEvent(): boolean;
	GetIsShiftDownByKeyEvent(): boolean;
	GetKeyNameByKeyEvent(): string;
	GetKey(): Key;
	GetUserIndex(): number;
	Key_GetNavigationActionFromKey(): EUINavigationAction;
	Key_GetNavigationDirectionFromKey(): EUINavigation;
	GetInputEventFromKeyEvent(): InputEvent;
	static GetIsAltDownByKeyEvent(Event: KeyEvent): boolean;
	static GetIsControlDownByKeyEvent(Event: KeyEvent): boolean;
	static GetIsShiftDownByKeyEvent(Event: KeyEvent): boolean;
	static GetKeyNameByKeyEvent(Event: KeyEvent): string;
	static GetKey(Input: KeyEvent): Key;
	static GetUserIndex(Input: KeyEvent): number;
	static Key_GetNavigationActionFromKey(InKeyEvent: KeyEvent): EUINavigationAction;
	static Key_GetNavigationDirectionFromKey(InKeyEvent: KeyEvent): EUINavigation;
	static GetInputEventFromKeyEvent(Event: KeyEvent): InputEvent;
}

declare class SlateBrushAsset extends UObject { 
	Brush: SlateBrush;
	static Load(ResourceName: string): SlateBrushAsset;
	static Find(Outer: UObject, ResourceName: string): SlateBrushAsset;
	static GetDefaultObject(): SlateBrushAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SlateBrushAsset;
	static C(Other: UObject | any): SlateBrushAsset;
	MakeBrushFromAsset(): SlateBrush;
	static MakeBrushFromAsset(BrushAsset: SlateBrushAsset): SlateBrush;
}

declare class PaintContext { 
	clone() : PaintContext;
	static C(Other: UObject | any): PaintContext;
	DrawSpaceSpline(InStart?: Vector2D,InStartDir?: Vector2D,InEnd?: Vector2D,InEndDir?: Vector2D,InThickness?: number,InTint?: LinearColor): {Context: PaintContext};
	DrawBox(Position?: Vector2D,Size?: Vector2D,Brush?: SlateBrushAsset,Tint?: LinearColor): {Context: PaintContext};
	DrawLine(PositionA?: Vector2D,PositionB?: Vector2D,Tint?: LinearColor,bAntiAlias?: boolean,Thickness?: number): {Context: PaintContext};
	DrawLines(Points?: Vector2D[],Tint?: LinearColor,bAntiAlias?: boolean,Thickness?: number): {Context: PaintContext};
	DrawSpline(Start?: Vector2D,StartDir?: Vector2D,End?: Vector2D,EndDir?: Vector2D,Tint?: LinearColor,Thickness?: number): {Context: PaintContext};
	DrawText(InString?: string,Position?: Vector2D,Tint?: LinearColor): {Context: PaintContext};
	DrawTextFormatted(Text?: string,Position?: Vector2D,Font?: Font,FontSize?: number,FontTypeFace?: string,Tint?: LinearColor): {Context: PaintContext};
	static DrawSpaceSpline(Context?: PaintContext,InStart?: Vector2D,InStartDir?: Vector2D,InEnd?: Vector2D,InEndDir?: Vector2D,InThickness?: number,InTint?: LinearColor): {Context: PaintContext};
	static DrawBox(Context?: PaintContext,Position?: Vector2D,Size?: Vector2D,Brush?: SlateBrushAsset,Tint?: LinearColor): {Context: PaintContext};
	static DrawLine(Context?: PaintContext,PositionA?: Vector2D,PositionB?: Vector2D,Tint?: LinearColor,bAntiAlias?: boolean,Thickness?: number): {Context: PaintContext};
	static DrawLines(Context?: PaintContext,Points?: Vector2D[],Tint?: LinearColor,bAntiAlias?: boolean,Thickness?: number): {Context: PaintContext};
	static DrawSpline(Context?: PaintContext,Start?: Vector2D,StartDir?: Vector2D,End?: Vector2D,EndDir?: Vector2D,Tint?: LinearColor,Thickness?: number): {Context: PaintContext};
	static DrawText(Context?: PaintContext,InString?: string,Position?: Vector2D,Tint?: LinearColor): {Context: PaintContext};
	static DrawTextFormatted(Context?: PaintContext,Text?: string,Position?: Vector2D,Font?: Font,FontSize?: number,FontTypeFace?: string,Tint?: LinearColor): {Context: PaintContext};
}

declare class MotionEvent extends InputEvent { 
	clone() : MotionEvent;
	static C(Other: UObject | any): MotionEvent;
}

declare class CharacterEvent extends InputEvent { 
	clone() : CharacterEvent;
	static C(Other: UObject | any): CharacterEvent;
	GetInputEventFromCharacterEvent(): InputEvent;
	static GetInputEventFromCharacterEvent(Event: CharacterEvent): InputEvent;
}

declare class AnalogInputEvent extends KeyEvent { 
	clone() : AnalogInputEvent;
	static C(Other: UObject | any): AnalogInputEvent;
	GetAnalogValue(): number;
	Key_GetNavigationDirectionFromAnalog(): EUINavigation;
	GetKeyEventFromAnalogInputEvent(): KeyEvent;
	static GetAnalogValue(Input: AnalogInputEvent): number;
	static Key_GetNavigationDirectionFromAnalog(InAnalogEvent: AnalogInputEvent): EUINavigation;
	static GetKeyEventFromAnalogInputEvent(Event: AnalogInputEvent): KeyEvent;
}

declare class UserWidget extends Widget { 
	ColorAndOpacity: LinearColor;
	ColorAndOpacityDelegate: UnrealEngineDelegate<() => LinearColor>;
	ForegroundColor: SlateColor;
	ForegroundColorDelegate: UnrealEngineDelegate<() => SlateColor>;
	OnVisibilityChanged: UnrealEngineMulticastDelegate<(InVisibility: ESlateVisibility) => void>;
	Padding: Margin;
	ActiveSequencePlayers: UMGSequencePlayer[];
	AnimationTickManager: UMGSequenceTickManager;
	StoppedSequencePlayers: UMGSequencePlayer[];
	NamedSlotBindings: NamedSlotBinding[];
	Extensions: UserWidgetExtension[];
	WidgetTree: WidgetTree;
	DesignTimeSize: Vector2D;
	DesignSizeMode: EDesignPreviewSizeMode;
	PaletteCategory: string;
	PreviewBackground: Texture2D;
	Priority: number;
	bIsFocusable: boolean;
	bStopAction: boolean;
	bHasScriptImplementedTick: boolean;
	bHasScriptImplementedPaint: boolean;
	TickFrequency: EWidgetTickFrequency;
	InputComponent: InputComponent;
	AnimationCallbacks: AnimationEventBinding[];
	static Load(ResourceName: string): UserWidget;
	static Find(Outer: UObject, ResourceName: string): UserWidget;
	static GetDefaultObject(): UserWidget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UserWidget;
	UnregisterInputComponent(): void;
	UnbindAllFromAnimationStarted(Animation: WidgetAnimation): void;
	UnbindAllFromAnimationFinished(Animation: WidgetAnimation): void;
	Tick(MyGeometry: Geometry,InDeltaTime: number): void;
	StopListeningForInputAction(ActionName: string,EventType: EInputEvent): void;
	StopListeningForAllInputActions(): void;
	StopAnimationsAndLatentActions(): void;
	StopAnimation(InAnimation: WidgetAnimation): void;
	StopAllAnimations(): void;
	SetPositionInViewport(Position: Vector2D,bRemoveDPIScale: boolean): void;
	SetPlaybackSpeed(InAnimation: WidgetAnimation,PlaybackSpeed: number): void;
	SetPadding(InPadding: Margin): void;
	SetOwningPlayer(LocalPlayerController: PlayerController): void;
	SetNumLoopsToPlay(InAnimation: WidgetAnimation,NumLoopsToPlay: number): void;
	SetInputActionPriority(NewPriority: number): void;
	SetInputActionBlocking(bShouldBlock: boolean): void;
	SetForegroundColor(InForegroundColor: SlateColor): void;
	SetDesiredSizeInViewport(Size: Vector2D): void;
	SetColorAndOpacity(InColorAndOpacity: LinearColor): void;
	SetAnimationCurrentTime(InAnimation: WidgetAnimation,InTime: number): void;
	SetAnchorsInViewport(Anchors: Anchors): void;
	SetAlignmentInViewport(Alignment: Vector2D): void;
	ReverseAnimation(InAnimation: WidgetAnimation): void;
	RemoveFromViewport(): void;
	RemoveExtensions(InExtensionType: UnrealEngineClass): void;
	RemoveExtension(InExtension: UserWidgetExtension): void;
	RegisterInputComponent(): void;
	PreConstruct(IsDesignTime: boolean): void;
	PlaySound(SoundToPlay: SoundBase): void;
	PlayAnimationTimeRange(InAnimation: WidgetAnimation,StartAtTime: number,EndAtTime: number,NumLoopsToPlay: number,PlayMode: EUMGSequencePlayMode,PlaybackSpeed: number,bRestoreState: boolean): UMGSequencePlayer;
	PlayAnimationReverse(InAnimation: WidgetAnimation,PlaybackSpeed: number,bRestoreState: boolean): UMGSequencePlayer;
	PlayAnimationForward(InAnimation: WidgetAnimation,PlaybackSpeed: number,bRestoreState: boolean): UMGSequencePlayer;
	PlayAnimation(InAnimation: WidgetAnimation,StartAtTime: number,NumLoopsToPlay: number,PlayMode: EUMGSequencePlayMode,PlaybackSpeed: number,bRestoreState: boolean): UMGSequencePlayer;
	PauseAnimation(InAnimation: WidgetAnimation): number;
	OnTouchStarted(MyGeometry: Geometry,InTouchEvent: UPointerEvent): EventReply;
	OnTouchMoved(MyGeometry: Geometry,InTouchEvent: UPointerEvent): EventReply;
	OnTouchGesture(MyGeometry: Geometry,GestureEvent: UPointerEvent): EventReply;
	OnTouchForceChanged(MyGeometry: Geometry,InTouchEvent: UPointerEvent): EventReply;
	OnTouchEnded(MyGeometry: Geometry,InTouchEvent: UPointerEvent): EventReply;
	OnRemovedFromFocusPath(InFocusEvent: UFocusEvent): void;
	OnPreviewMouseButtonDown(MyGeometry: Geometry,MouseEvent: UPointerEvent): EventReply;
	OnPreviewKeyDown(MyGeometry: Geometry,InKeyEvent: KeyEvent): EventReply;
	OnPaint(Context?: PaintContext): {Context: PaintContext};
	OnMouseWheel(MyGeometry: Geometry,MouseEvent: UPointerEvent): EventReply;
	OnMouseMove(MyGeometry: Geometry,MouseEvent: UPointerEvent): EventReply;
	OnMouseLeave(MouseEvent: UPointerEvent): void;
	OnMouseEnter(MyGeometry: Geometry,MouseEvent: UPointerEvent): void;
	OnMouseCaptureLost(): void;
	OnMouseButtonUp(MyGeometry: Geometry,MouseEvent: UPointerEvent): EventReply;
	OnMouseButtonDown(MyGeometry: Geometry,MouseEvent: UPointerEvent): EventReply;
	OnMouseButtonDoubleClick(InMyGeometry: Geometry,InMouseEvent: UPointerEvent): EventReply;
	OnMotionDetected(MyGeometry: Geometry,InMotionEvent: MotionEvent): EventReply;
	OnKeyUp(MyGeometry: Geometry,InKeyEvent: KeyEvent): EventReply;
	OnKeyDown(MyGeometry: Geometry,InKeyEvent: KeyEvent): EventReply;
	OnKeyChar(MyGeometry: Geometry,InCharacterEvent: CharacterEvent): EventReply;
	OnInitialized(): void;
	OnFocusReceived(MyGeometry: Geometry,InFocusEvent: UFocusEvent): EventReply;
	OnFocusLost(InFocusEvent: UFocusEvent): void;
	OnDrop(MyGeometry: Geometry,UPointerEvent: UPointerEvent,Operation: DragDropOperation): boolean;
	OnDragOver(MyGeometry: Geometry,UPointerEvent: UPointerEvent,Operation: DragDropOperation): boolean;
	OnDragLeave(UPointerEvent: UPointerEvent,Operation: DragDropOperation): void;
	OnDragEnter(MyGeometry: Geometry,UPointerEvent: UPointerEvent,Operation: DragDropOperation): void;
	OnDragDetected(MyGeometry: Geometry,UPointerEvent: UPointerEvent,Operation?: DragDropOperation): {Operation: DragDropOperation};
	OnDragCancelled(UPointerEvent: UPointerEvent,Operation: DragDropOperation): void;
	OnAnimationStarted(Animation: WidgetAnimation): void;
	OnAnimationFinished(Animation: WidgetAnimation): void;
	OnAnalogValueChanged(MyGeometry: Geometry,InAnalogInputEvent: AnalogInputEvent): EventReply;
	OnAddedToFocusPath(InFocusEvent: UFocusEvent): void;
	IsPlayingAnimation(): boolean;
	IsListeningForInputAction(ActionName: string): boolean;
	IsInteractable(): boolean;
	IsAnyAnimationPlaying(): boolean;
	IsAnimationPlayingForward(InAnimation: WidgetAnimation): boolean;
	IsAnimationPlaying(InAnimation: WidgetAnimation): boolean;
	GetOwningPlayerPawn(): Pawn;
	GetOwningPlayerCameraManager(): PlayerCameraManager;
	GetIsVisible(): boolean;
	GetExtensions(ExtensionType: UnrealEngineClass): UserWidgetExtension[];
	GetExtension(ExtensionType: UnrealEngineClass): UserWidgetExtension;
	GetAnimationCurrentTime(InAnimation: WidgetAnimation): number;
	GetAnchorsInViewport(): Anchors;
	GetAlignmentInViewport(): Vector2D;
	FlushAnimations(): void;
	Destruct(): void;
	Construct(): void;
	CancelLatentActions(): void;
	AddToViewport(ZOrder: number): void;
	AddToPlayerScreen(ZOrder: number): boolean;
	AddExtension(InExtensionType: UnrealEngineClass): UserWidgetExtension;
	static C(Other: UObject | any): UserWidget;
}

declare class ViewTargetTransitionParams { 
	BlendTime: number;
	BlendFunction: EViewTargetBlendFunction;
	BlendExp: number;
	bLockOutgoing: boolean;
	clone() : ViewTargetTransitionParams;
	static C(Other: UObject | any): ViewTargetTransitionParams;
}

declare class NetLevelVisibilityTransactionId { 
	Data: number;
	clone() : NetLevelVisibilityTransactionId;
	static C(Other: UObject | any): NetLevelVisibilityTransactionId;
}

declare class UpdateLevelVisibilityLevelInfo { 
	PackageName: string;
	Filename: string;
	VisibilityRequestId: NetLevelVisibilityTransactionId;
	bIsVisible: boolean;
	bTryMakeVisible: boolean;
	clone() : UpdateLevelVisibilityLevelInfo;
	static C(Other: UObject | any): UpdateLevelVisibilityLevelInfo;
}

declare class AsyncPhysicsTimestamp { 
	ServerFrame: number;
	LocalFrame: number;
	clone() : AsyncPhysicsTimestamp;
	static C(Other: UObject | any): AsyncPhysicsTimestamp;
}

declare class HapticFeedbackEffect_Base extends UObject { 
	static Load(ResourceName: string): HapticFeedbackEffect_Base;
	static Find(Outer: UObject, ResourceName: string): HapticFeedbackEffect_Base;
	static GetDefaultObject(): HapticFeedbackEffect_Base;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HapticFeedbackEffect_Base;
	static C(Other: UObject | any): HapticFeedbackEffect_Base;
}

declare type EDynamicForceFeedbackAction = 'Start' | 'Update' | 'Stop' | 'EDynamicForceFeedbackAction_MAX';
declare var EDynamicForceFeedbackAction : { Start:'Start',Update:'Update',Stop:'Stop',EDynamicForceFeedbackAction_MAX:'EDynamicForceFeedbackAction_MAX', };
declare class LatentActionInfo { 
	Linkage: number;
	UUID: number;
	ExecutionFunction: string;
	CallbackTarget: UObject;
	clone() : LatentActionInfo;
	static C(Other: UObject | any): LatentActionInfo;
}

declare type EInputDeviceConnectionState = 'Invalid' | 'Unknown' | 'Disconnected' | 'Connected' | 'EInputDeviceConnectionState_MAX';
declare var EInputDeviceConnectionState : { Invalid:'Invalid',Unknown:'Unknown',Disconnected:'Disconnected',Connected:'Connected',EInputDeviceConnectionState_MAX:'EInputDeviceConnectionState_MAX', };
declare class InputDeviceId { 
	InternalId: number;
	clone() : InputDeviceId;
	static C(Other: UObject | any): InputDeviceId;
	EqualEqual_InputDeviceId(B: InputDeviceId): boolean;
	GetInputDeviceConnectionState(): EInputDeviceConnectionState;
	GetUserForInputDevice(): PlatformUserId;
	IsInputDeviceMappedToUnpairedUser(): boolean;
	IsValidInputDevice(): boolean;
	NotEqual_InputDeviceId(B: InputDeviceId): boolean;
	Conv_InputDeviceIdToString(): string;
	static EqualEqual_InputDeviceId(A: InputDeviceId,B: InputDeviceId): boolean;
	static GetInputDeviceConnectionState(DeviceID: InputDeviceId): EInputDeviceConnectionState;
	static GetUserForInputDevice(DeviceID: InputDeviceId): PlatformUserId;
	static IsInputDeviceMappedToUnpairedUser(InputDevice: InputDeviceId): boolean;
	static IsValidInputDevice(DeviceID: InputDeviceId): boolean;
	static NotEqual_InputDeviceId(A: InputDeviceId,B: InputDeviceId): boolean;
	static Conv_InputDeviceIdToString(InDeviceId: InputDeviceId): string;
	static GetDefaultInputDevice(): InputDeviceId;
	static InputDeviceId_None(): InputDeviceId;
}

declare class PlatformUserId { 
	InternalId: number;
	clone() : PlatformUserId;
	static C(Other: UObject | any): PlatformUserId;
	EqualEqual_PlatformUserId(B: PlatformUserId): boolean;
	GetAllInputDevicesForUser(OutInputDevices?: InputDeviceId[]): {OutInputDevices: InputDeviceId[], $: number};
	GetPrimaryInputDeviceForUser(): InputDeviceId;
	IsUnpairedUserId(): boolean;
	IsValidPlatformId(): boolean;
	NotEqual_PlatformUserId(B: PlatformUserId): boolean;
	Conv_PlatformUserIdToString(): string;
	static EqualEqual_PlatformUserId(A: PlatformUserId,B: PlatformUserId): boolean;
	static GetAllInputDevicesForUser(UserId: PlatformUserId,OutInputDevices?: InputDeviceId[]): {OutInputDevices: InputDeviceId[], $: number};
	static GetPrimaryInputDeviceForUser(UserId: PlatformUserId): InputDeviceId;
	static IsUnpairedUserId(PlatformId: PlatformUserId): boolean;
	static IsValidPlatformId(UserId: PlatformUserId): boolean;
	static NotEqual_PlatformUserId(A: PlatformUserId,B: PlatformUserId): boolean;
	static Conv_PlatformUserIdToString(InPlatformUserId: PlatformUserId): string;
	static GetUserForUnpairedInputDevices(): PlatformUserId;
	static PlatformUserId_None(): PlatformUserId;
}

declare type ETouchIndex = 'Touch1' | 'Touch2' | 'Touch3' | 'Touch4' | 'Touch5' | 'Touch6' | 'Touch7' | 'Touch8' | 'Touch9' | 'Touch10' | 'CursorPointerIndex' | 'MAX_TOUCHES' | 'ETouchIndex_MAX';
declare var ETouchIndex : { Touch1:'Touch1',Touch2:'Touch2',Touch3:'Touch3',Touch4:'Touch4',Touch5:'Touch5',Touch6:'Touch6',Touch7:'Touch7',Touch8:'Touch8',Touch9:'Touch9',Touch10:'Touch10',CursorPointerIndex:'CursorPointerIndex',MAX_TOUCHES:'MAX_TOUCHES',ETouchIndex_MAX:'ETouchIndex_MAX', };
declare type EObjectTypeQuery = 'ObjectTypeQuery1' | 'ObjectTypeQuery2' | 'ObjectTypeQuery3' | 'ObjectTypeQuery4' | 'ObjectTypeQuery5' | 'ObjectTypeQuery6' | 'ObjectTypeQuery7' | 'ObjectTypeQuery8' | 'ObjectTypeQuery9' | 'ObjectTypeQuery10' | 'ObjectTypeQuery11' | 'ObjectTypeQuery12' | 'ObjectTypeQuery13' | 'ObjectTypeQuery14' | 'ObjectTypeQuery15' | 'ObjectTypeQuery16' | 'ObjectTypeQuery17' | 'ObjectTypeQuery18' | 'ObjectTypeQuery19' | 'ObjectTypeQuery20' | 'ObjectTypeQuery21' | 'ObjectTypeQuery22' | 'ObjectTypeQuery23' | 'ObjectTypeQuery24' | 'ObjectTypeQuery25' | 'ObjectTypeQuery26' | 'ObjectTypeQuery27' | 'ObjectTypeQuery28' | 'ObjectTypeQuery29' | 'ObjectTypeQuery30' | 'ObjectTypeQuery31' | 'ObjectTypeQuery32' | 'ObjectTypeQuery_MAX' | 'EObjectTypeQuery_MAX';
declare var EObjectTypeQuery : { ObjectTypeQuery1:'ObjectTypeQuery1',ObjectTypeQuery2:'ObjectTypeQuery2',ObjectTypeQuery3:'ObjectTypeQuery3',ObjectTypeQuery4:'ObjectTypeQuery4',ObjectTypeQuery5:'ObjectTypeQuery5',ObjectTypeQuery6:'ObjectTypeQuery6',ObjectTypeQuery7:'ObjectTypeQuery7',ObjectTypeQuery8:'ObjectTypeQuery8',ObjectTypeQuery9:'ObjectTypeQuery9',ObjectTypeQuery10:'ObjectTypeQuery10',ObjectTypeQuery11:'ObjectTypeQuery11',ObjectTypeQuery12:'ObjectTypeQuery12',ObjectTypeQuery13:'ObjectTypeQuery13',ObjectTypeQuery14:'ObjectTypeQuery14',ObjectTypeQuery15:'ObjectTypeQuery15',ObjectTypeQuery16:'ObjectTypeQuery16',ObjectTypeQuery17:'ObjectTypeQuery17',ObjectTypeQuery18:'ObjectTypeQuery18',ObjectTypeQuery19:'ObjectTypeQuery19',ObjectTypeQuery20:'ObjectTypeQuery20',ObjectTypeQuery21:'ObjectTypeQuery21',ObjectTypeQuery22:'ObjectTypeQuery22',ObjectTypeQuery23:'ObjectTypeQuery23',ObjectTypeQuery24:'ObjectTypeQuery24',ObjectTypeQuery25:'ObjectTypeQuery25',ObjectTypeQuery26:'ObjectTypeQuery26',ObjectTypeQuery27:'ObjectTypeQuery27',ObjectTypeQuery28:'ObjectTypeQuery28',ObjectTypeQuery29:'ObjectTypeQuery29',ObjectTypeQuery30:'ObjectTypeQuery30',ObjectTypeQuery31:'ObjectTypeQuery31',ObjectTypeQuery32:'ObjectTypeQuery32',ObjectTypeQuery_MAX:'ObjectTypeQuery_MAX',EObjectTypeQuery_MAX:'EObjectTypeQuery_MAX', };
declare type ETraceTypeQuery = 'TraceTypeQuery1' | 'TraceTypeQuery2' | 'TraceTypeQuery3' | 'TraceTypeQuery4' | 'TraceTypeQuery5' | 'TraceTypeQuery6' | 'TraceTypeQuery7' | 'TraceTypeQuery8' | 'TraceTypeQuery9' | 'TraceTypeQuery10' | 'TraceTypeQuery11' | 'TraceTypeQuery12' | 'TraceTypeQuery13' | 'TraceTypeQuery14' | 'TraceTypeQuery15' | 'TraceTypeQuery16' | 'TraceTypeQuery17' | 'TraceTypeQuery18' | 'TraceTypeQuery19' | 'TraceTypeQuery20' | 'TraceTypeQuery21' | 'TraceTypeQuery22' | 'TraceTypeQuery23' | 'TraceTypeQuery24' | 'TraceTypeQuery25' | 'TraceTypeQuery26' | 'TraceTypeQuery27' | 'TraceTypeQuery28' | 'TraceTypeQuery29' | 'TraceTypeQuery30' | 'TraceTypeQuery31' | 'TraceTypeQuery32' | 'TraceTypeQuery_MAX' | 'ETraceTypeQuery_MAX';
declare var ETraceTypeQuery : { TraceTypeQuery1:'TraceTypeQuery1',TraceTypeQuery2:'TraceTypeQuery2',TraceTypeQuery3:'TraceTypeQuery3',TraceTypeQuery4:'TraceTypeQuery4',TraceTypeQuery5:'TraceTypeQuery5',TraceTypeQuery6:'TraceTypeQuery6',TraceTypeQuery7:'TraceTypeQuery7',TraceTypeQuery8:'TraceTypeQuery8',TraceTypeQuery9:'TraceTypeQuery9',TraceTypeQuery10:'TraceTypeQuery10',TraceTypeQuery11:'TraceTypeQuery11',TraceTypeQuery12:'TraceTypeQuery12',TraceTypeQuery13:'TraceTypeQuery13',TraceTypeQuery14:'TraceTypeQuery14',TraceTypeQuery15:'TraceTypeQuery15',TraceTypeQuery16:'TraceTypeQuery16',TraceTypeQuery17:'TraceTypeQuery17',TraceTypeQuery18:'TraceTypeQuery18',TraceTypeQuery19:'TraceTypeQuery19',TraceTypeQuery20:'TraceTypeQuery20',TraceTypeQuery21:'TraceTypeQuery21',TraceTypeQuery22:'TraceTypeQuery22',TraceTypeQuery23:'TraceTypeQuery23',TraceTypeQuery24:'TraceTypeQuery24',TraceTypeQuery25:'TraceTypeQuery25',TraceTypeQuery26:'TraceTypeQuery26',TraceTypeQuery27:'TraceTypeQuery27',TraceTypeQuery28:'TraceTypeQuery28',TraceTypeQuery29:'TraceTypeQuery29',TraceTypeQuery30:'TraceTypeQuery30',TraceTypeQuery31:'TraceTypeQuery31',TraceTypeQuery32:'TraceTypeQuery32',TraceTypeQuery_MAX:'TraceTypeQuery_MAX',ETraceTypeQuery_MAX:'ETraceTypeQuery_MAX', };
declare class UpdateLevelStreamingLevelStatus { 
	PackageName: string;
	LODIndex: number;
	bNewShouldBeLoaded: boolean;
	bNewShouldBeVisible: boolean;
	bNewShouldBlockOnLoad: boolean;
	clone() : UpdateLevelStreamingLevelStatus;
	static C(Other: UObject | any): UpdateLevelStreamingLevelStatus;
}

declare type ETravelType = 'TRAVEL_Absolute' | 'TRAVEL_Partial' | 'TRAVEL_Relative' | 'TRAVEL_MAX';
declare var ETravelType : { TRAVEL_Absolute:'TRAVEL_Absolute',TRAVEL_Partial:'TRAVEL_Partial',TRAVEL_Relative:'TRAVEL_Relative',TRAVEL_MAX:'TRAVEL_MAX', };
declare class ForceFeedbackParameters { 
	Tag: string;
	bLooping: boolean;
	bIgnoreTimeDilation: boolean;
	bPlayWhilePaused: boolean;
	clone() : ForceFeedbackParameters;
	static C(Other: UObject | any): ForceFeedbackParameters;
}

declare class LocalPlayerSubsystem extends Subsystem { 
	static Load(ResourceName: string): LocalPlayerSubsystem;
	static Find(Outer: UObject, ResourceName: string): LocalPlayerSubsystem;
	static GetDefaultObject(): LocalPlayerSubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LocalPlayerSubsystem;
	static C(Other: UObject | any): LocalPlayerSubsystem;
}

declare type EMouseLockMode = 'DoNotLock' | 'LockOnCapture' | 'LockAlways' | 'LockInFullscreen' | 'EMouseLockMode_MAX';
declare var EMouseLockMode : { DoNotLock:'DoNotLock',LockOnCapture:'LockOnCapture',LockAlways:'LockAlways',LockInFullscreen:'LockInFullscreen',EMouseLockMode_MAX:'EMouseLockMode_MAX', };
declare class PlayerController extends Controller { 
	Player: Player;
	AcknowledgedPawn: Pawn;
	MyHUD: HUD;
	PlayerCameraManager: PlayerCameraManager;
	PlayerCameraManagerClass: UnrealEngineClass;
	bAutoManageActiveCameraTarget: boolean;
	TargetViewRotation: Rotator;
	SmoothTargetViewRotationSpeed: number;
	HiddenActors: Actor[];
	HiddenPrimitiveComponents: PrimitiveComponent[];
	LastSpectatorStateSynchTime: number;
	LastSpectatorSyncLocation: Vector;
	LastSpectatorSyncRotation: Rotator;
	ClientCap: number;
	CheatManager: CheatManager;
	CheatClass: UnrealEngineClass;
	PlayerInput: PlayerInput;
	ActiveForceFeedbackEffects: ActiveForceFeedbackEffect[];
	AsyncPhysicsDataClass: UnrealEngineClass;
	AsyncPhysicsDataComponent: AsyncPhysicsInputComponent;
	bPlayerIsWaiting: boolean;
	NetPlayerIndex: number;
	PendingSwapConnection: NetConnection;
	NetConnection: NetConnection;
	InputYawScale: number;
	InputPitchScale: number;
	InputRollScale: number;
	bShowMouseCursor: boolean;
	bEnableClickEvents: boolean;
	bEnableTouchEvents: boolean;
	bEnableMouseOverEvents: boolean;
	bEnableTouchOverEvents: boolean;
	bForceFeedbackEnabled: boolean;
	bEnableMotionControls: boolean;
	bEnableStreamingSource: boolean;
	bStreamingSourceShouldActivate: boolean;
	bStreamingSourceShouldBlockOnSlowStreaming: boolean;
	StreamingSourcePriority: EStreamingSourcePriority;
	StreamingSourceDebugColor: Color;
	StreamingSourceShapes: StreamingSourceShape[];
	ForceFeedbackScale: number;
	ClickEventKeys: Key[];
	DefaultMouseCursor: EMouseCursor;
	CurrentMouseCursor: EMouseCursor;
	DefaultClickTraceChannel: ECollisionChannel;
	CurrentClickTraceChannel: ECollisionChannel;
	HitResultTraceDistance: number;
	SeamlessTravelCount: number;
	LastCompletedSeamlessTravelCount: number;
	InactiveStateInputComponent: InputComponent;
	bShouldPerformFullTickWhenPaused: boolean;
	CurrentTouchInterface: TouchInterface;
	OverridePlayerInputClass: UnrealEngineClass;
	SpectatorPawn: SpectatorPawn;
	bIsLocalPlayerController: boolean;
	SpawnLocation: Vector;
	static GetDefaultObject(): PlayerController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PlayerController;
	WasInputKeyJustReleased(Key: Key): boolean;
	WasInputKeyJustPressed(Key: Key): boolean;
	ToggleSpeaking(bInSpeaking: boolean): void;
	TestServerLevelVisibilityChange(PackageName: string,Filename: string): void;
	SwitchLevel(URL: string): void;
	StreamingSourceShouldBlockOnSlowStreaming(): boolean;
	StreamingSourceShouldActivate(): boolean;
	StopHapticEffect(Hand: EControllerHand): void;
	StartFire(FireModeNum: number): void;
	SetVirtualJoystickVisibility(bVisible: boolean): void;
	SetViewTargetWithBlend(NewViewTarget: Actor,BlendTime: number,BlendFunc: EViewTargetBlendFunction,BlendExp: number,bLockOutgoing: boolean): void;
	SetName(S: string): void;
	SetMouseLocation(X: number,Y: number): void;
	SetMouseCursorWidget(Cursor: EMouseCursor,CursorWidget: UserWidget): void;
	SetMotionControlsEnabled(bEnabled: boolean): void;
	SetHapticsByValue(Frequency: number,Amplitude: number,Hand: EControllerHand): void;
	SetDisableHaptics(bNewDisabled: boolean): void;
	SetDeprecatedInputYawScale(NewValue: number): void;
	SetDeprecatedInputRollScale(NewValue: number): void;
	SetDeprecatedInputPitchScale(NewValue: number): void;
	SetControllerLightColor(Color: Color): void;
	SetCinematicMode(bInCinematicMode: boolean,bHidePlayer: boolean,bAffectsHUD: boolean,bAffectsMovement: boolean,bAffectsTurning: boolean): void;
	SetAudioListenerOverride(AttachToComponent: SceneComponent,Location: Vector,Rotation: Rotator): void;
	SetAudioListenerAttenuationOverride(AttachToComponent: SceneComponent,AttenuationLocationOVerride: Vector): void;
	ServerViewSelf(TransitionParams: ViewTargetTransitionParams): void;
	ServerViewPrevPlayer(): void;
	ServerViewNextPlayer(): void;
	ServerVerifyViewTarget(): void;
	ServerUpdateMultipleLevelsVisibility(LevelVisibilities: UpdateLevelVisibilityLevelInfo[]): void;
	ServerUpdateLevelVisibility(LevelVisibility: UpdateLevelVisibilityLevelInfo): void;
	ServerUpdateCamera(CamLoc: Vector_NetQuantize,CamPitchAndYaw: number): void;
	ServerUnmutePlayer(PlayerId: UniqueNetIdRepl): void;
	ServerUnblockPlayer(PlayerId: UniqueNetIdRepl): void;
	ServerToggleAILogging(): void;
	ServerShortTimeout(): void;
	ServerSetSpectatorWaiting(bWaiting: boolean): void;
	ServerSetSpectatorLocation(NewLoc: Vector,NewRot: Rotator): void;
	ServerSendLatestAsyncPhysicsTimestamp(Timestamp: AsyncPhysicsTimestamp): void;
	ServerRestartPlayer(): void;
	ServerRecvClientInputFrame(RecvClientInputFrame: number,Data: number[]): void;
	ServerPause(): void;
	ServerNotifyLoadedWorld(WorldPackageName: string): void;
	ServerMutePlayer(PlayerId: UniqueNetIdRepl): void;
	ServerExecRPC(Msg: string): void;
	ServerExec(Msg: string): void;
	ServerCheckClientPossessionReliable(): void;
	ServerCheckClientPossession(): void;
	ServerChangeName(S: string): void;
	ServerCamera(NewMode: string): void;
	ServerBlockPlayer(PlayerId: UniqueNetIdRepl): void;
	ServerAcknowledgePossession(P: Pawn): void;
	SendToConsole(Command: string): void;
	RestartLevel(): void;
	ResetControllerLightColor(): void;
	ProjectWorldLocationToScreen(WorldLocation: Vector,ScreenLocation?: Vector2D,bPlayerViewportRelative?: boolean): {ScreenLocation: Vector2D, $: boolean};
	PlayHapticEffect(HapticEffect: HapticFeedbackEffect_Base,Hand: EControllerHand,Scale: number,bLoop: boolean): void;
	PlayDynamicForceFeedback(Intensity: number,Duration: number,bAffectsLeftLarge: boolean,bAffectsLeftSmall: boolean,bAffectsRightLarge: boolean,bAffectsRightSmall: boolean,Action: EDynamicForceFeedbackAction,LatentInfo: LatentActionInfo): void;
	Pause(): void;
	OnServerStartedVisualLogger(bIsLogging: boolean): void;
	OnRep_AsyncPhysicsDataComponent(): void;
	LocalTravel(URL: string): void;
	K2_ClientPlayForceFeedback(ForceFeedbackEffect: ForceFeedbackEffect,Tag: string,bLooping: boolean,bIgnoreTimeDilation: boolean,bPlayWhilePaused: boolean): void;
	IsStreamingSourceEnabled(): boolean;
	IsInputKeyDown(Key: Key): boolean;
	GetViewportSize(SizeX?: number,SizeY?: number): {SizeX: number, SizeY: number};
	GetStreamingSourceShapes(OutShapes?: StreamingSourceShape[]): {OutShapes: StreamingSourceShape[]};
	GetStreamingSourcePriority(): EStreamingSourcePriority;
	GetStreamingSourceLocationAndRotation(OutLocation?: Vector,OutRotation?: Rotator): {OutLocation: Vector, OutRotation: Rotator};
	GetSpectatorPawn(): SpectatorPawn;
	GetPlatformUserId(): PlatformUserId;
	GetOverridePlayerInputClass(): UnrealEngineClass;
	GetMousePosition(LocationX?: number,LocationY?: number): {LocationX: number, LocationY: number, $: boolean};
	GetInputVectorKeyState(Key: Key): Vector;
	GetInputTouchState(FingerIndex: ETouchIndex,LocationX?: number,LocationY?: number,bIsCurrentlyPressed?: boolean): {LocationX: number, LocationY: number, bIsCurrentlyPressed: boolean};
	GetInputMouseDelta(DeltaX?: number,DeltaY?: number): {DeltaX: number, DeltaY: number};
	GetInputMotionState(Tilt?: Vector,RotationRate?: Vector,Gravity?: Vector,Acceleration?: Vector): {Tilt: Vector, RotationRate: Vector, Gravity: Vector, Acceleration: Vector};
	GetInputKeyTimeDown(Key: Key): number;
	GetInputAnalogStickState(WhichStick: EControllerAnalogStick,StickX?: number,StickY?: number): {StickX: number, StickY: number};
	GetInputAnalogKeyState(Key: Key): number;
	GetHUD(): HUD;
	GetHitResultUnderFingerForObjects(FingerIndex: ETouchIndex,ObjectTypes: EObjectTypeQuery[],bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetHitResultUnderFingerByChannel(FingerIndex: ETouchIndex,TraceChannel: ETraceTypeQuery,bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetHitResultUnderFinger(FingerIndex: ETouchIndex,TraceChannel: ECollisionChannel,bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetHitResultUnderCursorForObjects(ObjectTypes: EObjectTypeQuery[],bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetHitResultUnderCursorByChannel(TraceChannel: ETraceTypeQuery,bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetHitResultUnderCursor(TraceChannel: ECollisionChannel,bTraceComplex: boolean,HitResult?: HitResult): {HitResult: HitResult, $: boolean};
	GetFocalLocation(): Vector;
	GetDeprecatedInputYawScale(): number;
	GetDeprecatedInputRollScale(): number;
	GetDeprecatedInputPitchScale(): number;
	GetAsyncPhysicsDataToWrite(): AsyncPhysicsData;
	GetAsyncPhysicsDataToConsume(): AsyncPhysicsData;
	FOV(NewFOV: number): void;
	EnableCheats(): void;
	DeprojectScreenPositionToWorld(ScreenX: number,ScreenY: number,WorldLocation?: Vector,WorldDirection?: Vector): {WorldLocation: Vector, WorldDirection: Vector, $: boolean};
	DeprojectMousePositionToWorld(WorldLocation?: Vector,WorldDirection?: Vector): {WorldLocation: Vector, WorldDirection: Vector, $: boolean};
	ConsoleKey(Key: Key): void;
	ClientWasKicked(KickReason: string): void;
	ClientVoiceHandshakeComplete(): void;
	ClientUpdateMultipleLevelsStreamingStatus(LevelStatuses: UpdateLevelStreamingLevelStatus[]): void;
	ClientUpdateLevelStreamingStatus(PackageName: string,bNewShouldBeLoaded: boolean,bNewShouldBeVisible: boolean,bNewShouldBlockOnLoad: boolean,LODIndex: number,TransactionId: NetLevelVisibilityTransactionId): void;
	ClientUnmutePlayers(PlayerIds: UniqueNetIdRepl[]): void;
	ClientUnmutePlayer(PlayerId: UniqueNetIdRepl): void;
	ClientTravelInternal(URL: string,TravelType: ETravelType,bSeamless: boolean,MapPackageGuid: Guid): void;
	ClientTravel(URL: string,TravelType: ETravelType,bSeamless: boolean,MapPackageGuid: Guid): void;
	ClientTeamMessage(SenderPlayerState: PlayerState,S: string,Type: string,MsgLifeTime: number): void;
	ClientStopForceFeedback(ForceFeedbackEffect: ForceFeedbackEffect,Tag: string): void;
	ClientStopCameraShakesFromSource(SourceComponent: CameraShakeSourceComponent,bImmediately: boolean): void;
	ClientStopCameraShake(Shake: UnrealEngineClass,bImmediately: boolean): void;
	ClientStartOnlineSession(): void;
	ClientStartCameraShakeFromSource(Shake: UnrealEngineClass,SourceComponent: CameraShakeSourceComponent): void;
	ClientStartCameraShake(Shake: UnrealEngineClass,Scale: number,PlaySpace: ECameraShakePlaySpace,UserPlaySpaceRot: Rotator): void;
	ClientSpawnGenericCameraLensEffect(LensEffectEmitterClass: UnrealEngineClass): void;
	ClientSpawnCameraLensEffect(LensEffectEmitterClass: UnrealEngineClass): void;
	ClientSetViewTarget(A: Actor,TransitionParams: ViewTargetTransitionParams): void;
	ClientSetSpectatorWaiting(bWaiting: boolean): void;
	ClientSetHUD(NewHUDClass: UnrealEngineClass): void;
	ClientSetForceMipLevelsToBeResident(Material: MaterialInterface,ForceDuration: number,CinematicTextureGroups: number): void;
	ClientSetCinematicMode(bInCinematicMode: boolean,bAffectsMovement: boolean,bAffectsTurning: boolean,bAffectsHUD: boolean): void;
	ClientSetCameraMode(NewCamMode: string): void;
	ClientSetCameraFade(bEnableFading: boolean,FadeColor: Color,FadeAlpha: Vector2D,FadeTime: number,bFadeAudio: boolean,bHoldWhenFinished: boolean): void;
	ClientSetBlockOnAsyncLoading(): void;
	ClientReturnToMainMenuWithTextReason(ReturnReason: string): void;
	ClientReturnToMainMenu(ReturnReason: string): void;
	ClientRetryClientRestart(NewPawn: Pawn): void;
	ClientRestart(NewPawn: Pawn): void;
	ClientReset(): void;
	ClientRepObjRef(UObject: UObject): void;
	ClientRecvServerAckFrameDebug(NumBuffered: number,TargetNumBufferedCmds: number): void;
	ClientRecvServerAckFrame(LastProcessedInputFrame: number,RecvServerFrameNumber: number,TimeDilation: number): void;
	ClientReceiveLocalizedMessage(Message: UnrealEngineClass,SWITCH: number,RelatedPlayerState_1: PlayerState,RelatedPlayerState_2: PlayerState,OptionalObject: UObject): void;
	ClientPrestreamTextures(ForcedActor: Actor,ForceDuration: number,bEnableStreaming: boolean,CinematicTextureGroups: number): void;
	ClientPrepareMapChange(LevelName: string,bFirst: boolean,bLast: boolean): void;
	ClientPlaySoundAtLocation(Sound: SoundBase,Location: Vector,VolumeMultiplier: number,PitchMultiplier: number): void;
	ClientPlaySound(Sound: SoundBase,VolumeMultiplier: number,PitchMultiplier: number): void;
	ClientPlayForceFeedback_Internal(ForceFeedbackEffect: ForceFeedbackEffect,Params: ForceFeedbackParameters): void;
	ClientMutePlayer(PlayerId: UniqueNetIdRepl): void;
	ClientMessage(S: string,Type: string,MsgLifeTime: number): void;
	ClientIgnoreMoveInput(bIgnore: boolean): void;
	ClientIgnoreLookInput(bIgnore: boolean): void;
	ClientGotoState(NewState: string): void;
	ClientGameEnded(EndGameFocus: Actor,bIsWinner: boolean): void;
	ClientForceGarbageCollection(): void;
	ClientFlushLevelStreaming(): void;
	ClientEndOnlineSession(): void;
	ClientEnableNetworkVoice(bEnable: boolean): void;
	ClientCorrectionAsyncPhysicsTimestamp(Timestamp: AsyncPhysicsTimestamp): void;
	ClientCommitMapChange(): void;
	ClientClearCameraLensEffects(): void;
	ClientCapBandwidth(Cap: number): void;
	ClientCancelPendingMapChange(): void;
	ClientAddTextureStreamingLoc(InLoc: Vector,Duration: number,bOverrideLocation: boolean): void;
	ClientAckUpdateLevelVisibility(PackageName: string,TransactionId: NetLevelVisibilityTransactionId,bClientAckCanMakeVisible: boolean): void;
	ClientAckTimeDilation(TimeDilation: number,ServerStep: number): void;
	ClearAudioListenerOverride(): void;
	ClearAudioListenerAttenuationOverride(): void;
	CanRestartPlayer(): boolean;
	Camera(NewMode: string): void;
	AddYawInput(Val: number): void;
	AddRollInput(Val: number): void;
	AddPitchInput(Val: number): void;
	ActivateTouchInterface(NewTouchInterface: TouchInterface): void;
	static C(Other: UObject | any): PlayerController;
	GetCameraCachePOV(): MinimalViewInfo;
	GetLastFrameCameraCachePOV(): MinimalViewInfo;
	GetPostProcessBlendCache(PPIndex: number,OutPPSettings?: PostProcessSettings,OutPPBlendWeight?: number): {OutPPSettings: PostProcessSettings, OutPPBlendWeight: number, $: boolean};
	WriteLeaderboardInteger(StatName: string,StatValue: number): boolean;
	GetLocalPlayerSubSystemFromPlayerController(Class: UnrealEngineClass): LocalPlayerSubsystem;
	IsLoggedIn(): boolean;
	ShowPlatformSpecificAchievementsScreen(): void;
	DeprojectScreenToWorld(ScreenPosition: Vector2D,WorldPosition?: Vector,WorldDirection?: Vector): {WorldPosition: Vector, WorldDirection: Vector, $: boolean};
	GetPlayerControllerID(): number;
	ProjectWorldToScreen(WorldPosition: Vector,ScreenPosition?: Vector2D,bPlayerViewportRelative?: boolean): {ScreenPosition: Vector2D, $: boolean};
	RemovePlayer(bDestroyPawn: boolean): void;
	SetPlayerControllerID(ControllerId: number): void;
	SetPlayerPlatformUserId(UserId: PlatformUserId): void;
	GetMousePositionScaledByDPI(LocationX?: number,LocationY?: number): {LocationX: number, LocationY: number, $: boolean};
	GetPlayerScreenWidgetGeometry(): Geometry;
	ProjectWorldLocationToWidgetPosition(WorldLocation: Vector,ScreenPosition?: Vector2D,bPlayerViewportRelative?: boolean): {ScreenPosition: Vector2D, $: boolean};
	SetInputMode_GameAndUIEx(InWidgetToFocus: Widget,InMouseLockMode: EMouseLockMode,bHideCursorDuringCapture: boolean,bFlushInput: boolean): void;
	SetInputMode_GameOnly(bFlushInput: boolean): void;
	SetInputMode_UIOnlyEx(InWidgetToFocus: Widget,InMouseLockMode: EMouseLockMode,bFlushInput: boolean): void;
	static GetCameraCachePOV(PlayerController: PlayerController): MinimalViewInfo;
	static GetLastFrameCameraCachePOV(PlayerController: PlayerController): MinimalViewInfo;
	static GetPostProcessBlendCache(PlayerController: PlayerController,PPIndex: number,OutPPSettings?: PostProcessSettings,OutPPBlendWeight?: number): {OutPPSettings: PostProcessSettings, OutPPBlendWeight: number, $: boolean};
	static WriteLeaderboardInteger(PlayerController: PlayerController,StatName: string,StatValue: number): boolean;
	static GetLocalPlayerSubSystemFromPlayerController(PlayerController: PlayerController,Class: UnrealEngineClass): LocalPlayerSubsystem;
	static IsLoggedIn(SpecificPlayer: PlayerController): boolean;
	static ShowPlatformSpecificAchievementsScreen(SpecificPlayer: PlayerController): void;
	static DeprojectScreenToWorld(Player: PlayerController,ScreenPosition: Vector2D,WorldPosition?: Vector,WorldDirection?: Vector): {WorldPosition: Vector, WorldDirection: Vector, $: boolean};
	static GetPlayerControllerID(Player: PlayerController): number;
	static ProjectWorldToScreen(Player: PlayerController,WorldPosition: Vector,ScreenPosition?: Vector2D,bPlayerViewportRelative?: boolean): {ScreenPosition: Vector2D, $: boolean};
	static RemovePlayer(Player: PlayerController,bDestroyPawn: boolean): void;
	static SetPlayerControllerID(Player: PlayerController,ControllerId: number): void;
	static SetPlayerPlatformUserId(PlayerController: PlayerController,UserId: PlatformUserId): void;
	static GetMousePositionScaledByDPI(Player: PlayerController,LocationX?: number,LocationY?: number): {LocationX: number, LocationY: number, $: boolean};
	static GetPlayerScreenWidgetGeometry(PlayerController: PlayerController): Geometry;
	static ProjectWorldLocationToWidgetPosition(PlayerController: PlayerController,WorldLocation: Vector,ScreenPosition?: Vector2D,bPlayerViewportRelative?: boolean): {ScreenPosition: Vector2D, $: boolean};
	static SetInputMode_GameAndUIEx(PlayerController: PlayerController,InWidgetToFocus: Widget,InMouseLockMode: EMouseLockMode,bHideCursorDuringCapture: boolean,bFlushInput: boolean): void;
	static SetInputMode_GameOnly(PlayerController: PlayerController,bFlushInput: boolean): void;
	static SetInputMode_UIOnlyEx(PlayerController: PlayerController,InWidgetToFocus: Widget,InMouseLockMode: EMouseLockMode,bFlushInput: boolean): void;
}

declare class FieldNotificationId { 
	FieldName: string;
	clone() : FieldNotificationId;
	static C(Other: UObject | any): FieldNotificationId;
}

declare class ScriptViewportClient extends UObject { 
	static Load(ResourceName: string): ScriptViewportClient;
	static Find(Outer: UObject, ResourceName: string): ScriptViewportClient;
	static GetDefaultObject(): ScriptViewportClient;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ScriptViewportClient;
	static C(Other: UObject | any): ScriptViewportClient;
}

declare class Console extends UObject { 
	ConsoleTargetPlayer: LocalPlayer;
	DefaultTexture_Black: Texture2D;
	DefaultTexture_White: Texture2D;
	HistoryBuffer: string[];
	static Load(ResourceName: string): Console;
	static Find(Outer: UObject, ResourceName: string): Console;
	static GetDefaultObject(): Console;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Console;
	static C(Other: UObject | any): Console;
}

declare class DebugDisplayProperty { 
	Obj: UObject;
	WithinClass: UnrealEngineClass;
	clone() : DebugDisplayProperty;
	static C(Other: UObject | any): DebugDisplayProperty;
}

declare class OnlineSession extends UObject { 
	static Load(ResourceName: string): OnlineSession;
	static Find(Outer: UObject, ResourceName: string): OnlineSession;
	static GetDefaultObject(): OnlineSession;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OnlineSession;
	static C(Other: UObject | any): OnlineSession;
}

declare type ETravelFailure = 'NoLevel' | 'LoadMapFailure' | 'InvalidURL' | 'PackageMissing' | 'PackageVersion' | 'NoDownload' | 'TravelFailure' | 'CheatCommands' | 'PendingNetGameCreateFailure' | 'CloudSaveFailure' | 'ServerTravelFailure' | 'ClientTravelFailure' | 'ETravelFailure_MAX';
declare var ETravelFailure : { NoLevel:'NoLevel',LoadMapFailure:'LoadMapFailure',InvalidURL:'InvalidURL',PackageMissing:'PackageMissing',PackageVersion:'PackageVersion',NoDownload:'NoDownload',TravelFailure:'TravelFailure',CheatCommands:'CheatCommands',PendingNetGameCreateFailure:'PendingNetGameCreateFailure',CloudSaveFailure:'CloudSaveFailure',ServerTravelFailure:'ServerTravelFailure',ClientTravelFailure:'ClientTravelFailure',ETravelFailure_MAX:'ETravelFailure_MAX', };
declare type ENetworkFailure = 'NetDriverAlreadyExists' | 'NetDriverCreateFailure' | 'NetDriverListenFailure' | 'ConnectionLost' | 'ConnectionTimeout' | 'FailureReceived' | 'OutdatedClient' | 'OutdatedServer' | 'PendingConnectionFailure' | 'NetGuidMismatch' | 'NetChecksumMismatch' | 'ENetworkFailure_MAX';
declare var ENetworkFailure : { NetDriverAlreadyExists:'NetDriverAlreadyExists',NetDriverCreateFailure:'NetDriverCreateFailure',NetDriverListenFailure:'NetDriverListenFailure',ConnectionLost:'ConnectionLost',ConnectionTimeout:'ConnectionTimeout',FailureReceived:'FailureReceived',OutdatedClient:'OutdatedClient',OutdatedServer:'OutdatedServer',PendingConnectionFailure:'PendingConnectionFailure',NetGuidMismatch:'NetGuidMismatch',NetChecksumMismatch:'NetChecksumMismatch',ENetworkFailure_MAX:'ENetworkFailure_MAX', };
declare class GameInstance extends UObject { 
	LocalPlayers: LocalPlayer[];
	OnlineSession: OnlineSession;
	ReferencedObjects: UObject[];
	OnPawnControllerChangedDelegates: UnrealEngineMulticastDelegate<(Pawn: Pawn, Controller: Controller) => void>;
	OnInputDeviceConnectionChange: UnrealEngineMulticastDelegate<(NewConnectionState: EInputDeviceConnectionState, PlatformUserId: PlatformUserId, InputDeviceId: InputDeviceId) => void>;
	OnUserInputDevicePairingChange: UnrealEngineMulticastDelegate<(InputDeviceId: InputDeviceId, NewUserPlatformId: PlatformUserId, OldUserPlatformId: PlatformUserId) => void>;
	static Load(ResourceName: string): GameInstance;
	static Find(Outer: UObject, ResourceName: string): GameInstance;
	static GetDefaultObject(): GameInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameInstance;
	ReceiveShutdown(): void;
	ReceiveInit(): void;
	HandleTravelError(FailureType: ETravelFailure): void;
	HandleNetworkError(FailureType: ENetworkFailure,bIsServer: boolean): void;
	DebugRemovePlayer(ControllerId: number): void;
	DebugCreatePlayer(ControllerId: number): void;
	static C(Other: UObject | any): GameInstance;
}

declare class GameViewportClient extends ScriptViewportClient { 
	ViewportConsole: Console;
	DebugProperties: DebugDisplayProperty[];
	MaxSplitscreenPlayers: number;
	World: World;
	GameInstance: GameInstance;
	static Load(ResourceName: string): GameViewportClient;
	static Find(Outer: UObject, ResourceName: string): GameViewportClient;
	static GetDefaultObject(): GameViewportClient;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameViewportClient;
	SSSwapControllers(): void;
	ShowTitleSafeArea(): void;
	SetConsoleTarget(PlayerIndex: number): void;
	static C(Other: UObject | any): GameViewportClient;
}

declare type EAspectRatioAxisConstraint = 'AspectRatio_MaintainYFOV' | 'AspectRatio_MaintainXFOV' | 'AspectRatio_MajorAxisFOV' | 'AspectRatio_MAX';
declare var EAspectRatioAxisConstraint : { AspectRatio_MaintainYFOV:'AspectRatio_MaintainYFOV',AspectRatio_MaintainXFOV:'AspectRatio_MaintainXFOV',AspectRatio_MajorAxisFOV:'AspectRatio_MajorAxisFOV',AspectRatio_MAX:'AspectRatio_MAX', };
declare class LocalPlayer extends Player { 
	ViewportClient: GameViewportClient;
	AspectRatioAxisConstraint: EAspectRatioAxisConstraint;
	PendingLevelPlayerControllerClass: UnrealEngineClass;
	bSentSplitJoin: boolean;
	ControllerId: number;
	static Load(ResourceName: string): LocalPlayer;
	static Find(Outer: UObject, ResourceName: string): LocalPlayer;
	static GetDefaultObject(): LocalPlayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LocalPlayer;
	static C(Other: UObject | any): LocalPlayer;
}

declare class JavascriptSlateWidget { 
	clone() : JavascriptSlateWidget;
	static C(Other: UObject | any): JavascriptSlateWidget;
	EditorAddModalWindow(): void;
	AddWindow(bShowImmediately: boolean): void;
	AddWindowAsNativeChild(RootWindow: JavascriptSlateWidget): void;
	ShowWindow(): void;
	static EditorAddModalWindow(Widget: JavascriptSlateWidget): void;
	static AddWindow(NewWindow: JavascriptSlateWidget,bShowImmediately: boolean): void;
	static AddWindowAsNativeChild(NewWindow: JavascriptSlateWidget,RootWindow: JavascriptSlateWidget): void;
	static ShowWindow(NewWindow: JavascriptSlateWidget): void;
	static CreateLogListingWidget(InLogName: string): JavascriptSlateWidget;
	static GetRootWindow(): JavascriptSlateWidget;
	static GetRootWindow(): JavascriptSlateWidget;
}

declare type EHorizontalAlignment = 'HAlign_Fill' | 'HAlign_Left' | 'HAlign_Center' | 'HAlign_Right' | 'HAlign_MAX';
declare var EHorizontalAlignment : { HAlign_Fill:'HAlign_Fill',HAlign_Left:'HAlign_Left',HAlign_Center:'HAlign_Center',HAlign_Right:'HAlign_Right',HAlign_MAX:'HAlign_MAX', };
declare type EVerticalAlignment = 'VAlign_Fill' | 'VAlign_Top' | 'VAlign_Center' | 'VAlign_Bottom' | 'VAlign_MAX';
declare var EVerticalAlignment : { VAlign_Fill:'VAlign_Fill',VAlign_Top:'VAlign_Top',VAlign_Center:'VAlign_Center',VAlign_Bottom:'VAlign_Bottom',VAlign_MAX:'VAlign_MAX', };
declare class BorderSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): BorderSlot;
	static Find(Outer: UObject, ResourceName: string): BorderSlot;
	static GetDefaultObject(): BorderSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BorderSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): BorderSlot;
}

declare class AnchorData { 
	Offsets: Margin;
	Anchors: Anchors;
	Alignment: Vector2D;
	clone() : AnchorData;
	static C(Other: UObject | any): AnchorData;
}

declare class CanvasPanelSlot extends PanelSlot { 
	LayoutData: AnchorData;
	bAutoSize: boolean;
	ZOrder: number;
	static Load(ResourceName: string): CanvasPanelSlot;
	static Find(Outer: UObject, ResourceName: string): CanvasPanelSlot;
	static GetDefaultObject(): CanvasPanelSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): CanvasPanelSlot;
	SetZOrder(InZOrder: number): void;
	SetSize(InSize: Vector2D): void;
	SetPosition(InPosition: Vector2D): void;
	SetOffsets(InOffset: Margin): void;
	SetMinimum(InMinimumAnchors: Vector2D): void;
	SetMaximum(InMaximumAnchors: Vector2D): void;
	SetLayout(InLayoutData: AnchorData): void;
	SetAutoSize(InbAutoSize: boolean): void;
	SetAnchors(InAnchors: Anchors): void;
	SetAlignment(InAlignment: Vector2D): void;
	GetZOrder(): number;
	GetSize(): Vector2D;
	GetPosition(): Vector2D;
	GetOffsets(): Margin;
	GetLayout(): AnchorData;
	GetAutoSize(): boolean;
	GetAnchors(): Anchors;
	GetAlignment(): Vector2D;
	static C(Other: UObject | any): CanvasPanelSlot;
}

declare class GridSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	Row: number;
	RowSpan: number;
	Column: number;
	ColumnSpan: number;
	Layer: number;
	Nudge: Vector2D;
	static Load(ResourceName: string): GridSlot;
	static Find(Outer: UObject, ResourceName: string): GridSlot;
	static GetDefaultObject(): GridSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GridSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetRowSpan(InRowSpan: number): void;
	SetRow(InRow: number): void;
	SetPadding(InPadding: Margin): void;
	SetNudge(InNudge: Vector2D): void;
	SetLayer(InLayer: number): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	SetColumnSpan(InColumnSpan: number): void;
	SetColumn(InColumn: number): void;
	static C(Other: UObject | any): GridSlot;
}

declare type ESlateSizeRule = 'Automatic' | 'Fill' | 'ESlateSizeRule_MAX';
declare var ESlateSizeRule : { Automatic:'Automatic',Fill:'Fill',ESlateSizeRule_MAX:'ESlateSizeRule_MAX', };
declare class SlateChildSize { 
	Value: number;
	SizeRule: ESlateSizeRule;
	clone() : SlateChildSize;
	static C(Other: UObject | any): SlateChildSize;
}

declare class HorizontalBoxSlot extends PanelSlot { 
	Size: SlateChildSize;
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): HorizontalBoxSlot;
	static Find(Outer: UObject, ResourceName: string): HorizontalBoxSlot;
	static GetDefaultObject(): HorizontalBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HorizontalBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetSize(InSize: SlateChildSize): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): HorizontalBoxSlot;
}

declare class OverlaySlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): OverlaySlot;
	static Find(Outer: UObject, ResourceName: string): OverlaySlot;
	static GetDefaultObject(): OverlaySlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): OverlaySlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): OverlaySlot;
}

declare class SafeZoneSlot extends PanelSlot { 
	bIsTitleSafe: boolean;
	SafeAreaScale: Margin;
	HAlign: EHorizontalAlignment;
	VAlign: EVerticalAlignment;
	Padding: Margin;
	static Load(ResourceName: string): SafeZoneSlot;
	static Find(Outer: UObject, ResourceName: string): SafeZoneSlot;
	static GetDefaultObject(): SafeZoneSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SafeZoneSlot;
	static C(Other: UObject | any): SafeZoneSlot;
}

declare class ScaleBoxSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): ScaleBoxSlot;
	static Find(Outer: UObject, ResourceName: string): ScaleBoxSlot;
	static GetDefaultObject(): ScaleBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ScaleBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): ScaleBoxSlot;
}

declare class ScrollBoxSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): ScrollBoxSlot;
	static Find(Outer: UObject, ResourceName: string): ScrollBoxSlot;
	static GetDefaultObject(): ScrollBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ScrollBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): ScrollBoxSlot;
}

declare class SizeBoxSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): SizeBoxSlot;
	static Find(Outer: UObject, ResourceName: string): SizeBoxSlot;
	static GetDefaultObject(): SizeBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): SizeBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): SizeBoxSlot;
}

declare class UniformGridSlot extends PanelSlot { 
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	Row: number;
	Column: number;
	static Load(ResourceName: string): UniformGridSlot;
	static Find(Outer: UObject, ResourceName: string): UniformGridSlot;
	static GetDefaultObject(): UniformGridSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): UniformGridSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetRow(InRow: number): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	SetColumn(InColumn: number): void;
	static C(Other: UObject | any): UniformGridSlot;
}

declare class VerticalBoxSlot extends PanelSlot { 
	Size: SlateChildSize;
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): VerticalBoxSlot;
	static Find(Outer: UObject, ResourceName: string): VerticalBoxSlot;
	static GetDefaultObject(): VerticalBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VerticalBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetSize(InSize: SlateChildSize): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): VerticalBoxSlot;
}

declare class WidgetSwitcherSlot extends PanelSlot { 
	Padding: Margin;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	static Load(ResourceName: string): WidgetSwitcherSlot;
	static Find(Outer: UObject, ResourceName: string): WidgetSwitcherSlot;
	static GetDefaultObject(): WidgetSwitcherSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WidgetSwitcherSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	static C(Other: UObject | any): WidgetSwitcherSlot;
}

declare class WrapBoxSlot extends PanelSlot { 
	Padding: Margin;
	FillSpanWhenLessThan: number;
	HorizontalAlignment: EHorizontalAlignment;
	VerticalAlignment: EVerticalAlignment;
	bFillEmptySpace: boolean;
	bForceNewLine: boolean;
	static Load(ResourceName: string): WrapBoxSlot;
	static Find(Outer: UObject, ResourceName: string): WrapBoxSlot;
	static GetDefaultObject(): WrapBoxSlot;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WrapBoxSlot;
	SetVerticalAlignment(InVerticalAlignment: EVerticalAlignment): void;
	SetPadding(InPadding: Margin): void;
	SetNewLine(InForceNewLine: boolean): void;
	SetHorizontalAlignment(InHorizontalAlignment: EHorizontalAlignment): void;
	SetFillSpanWhenLessThan(InFillSpanWhenLessThan: number): void;
	SetFillEmptySpace(InbFillEmptySpace: boolean): void;
	static C(Other: UObject | any): WrapBoxSlot;
}

declare type EWindowTitleBarMode = 'Overlay' | 'VerticalBox' | 'EWindowTitleBarMode_MAX';
declare var EWindowTitleBarMode : { Overlay:'Overlay',VerticalBox:'VerticalBox',EWindowTitleBarMode_MAX:'EWindowTitleBarMode_MAX', };
declare class Widget extends Visual { 
	Slot: PanelSlot;
	bIsEnabledDelegate: UnrealEngineDelegate<() => boolean>;
	ToolTipText: string;
	ToolTipTextDelegate: UnrealEngineDelegate<() => string>;
	ToolTipWidget: Widget;
	ToolTipWidgetDelegate: UnrealEngineDelegate<() => Widget>;
	VisibilityDelegate: UnrealEngineDelegate<() => ESlateVisibility>;
	RenderTransform: WidgetTransform;
	RenderTransformPivot: Vector2D;
	FlowDirectionPreference: EFlowDirectionPreference;
	bIsVariable: boolean;
	bCreatedByConstructionScript: boolean;
	bIsEnabled: boolean;
	bOverride_Cursor: boolean;
	bOverrideAccessibleDefaults: boolean;
	bCanChildrenBeAccessible: boolean;
	AccessibleBehavior: ESlateAccessibleBehavior;
	AccessibleSummaryBehavior: ESlateAccessibleBehavior;
	AccessibleText: string;
	AccessibleTextDelegate: UnrealEngineDelegate<() => string>;
	AccessibleSummaryText: string;
	AccessibleSummaryTextDelegate: UnrealEngineDelegate<() => string>;
	bIsVolatile: boolean;
	bHiddenInDesigner: boolean;
	bExpandedInDesigner: boolean;
	bLockedInDesigner: boolean;
	Cursor: EMouseCursor;
	Clipping: EWidgetClipping;
	Visibility: ESlateVisibility;
	RenderOpacity: number;
	AccessibleWidgetData: SlateAccessibleWidgetData;
	Navigation: WidgetNavigation;
	NativeBindings: PropertyBinding[];
	DesignerFlags: number;
	DisplayLabel: string;
	CategoryName: string;
	static Load(ResourceName: string): Widget;
	static Find(Outer: UObject, ResourceName: string): Widget;
	static GetDefaultObject(): Widget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Widget;
	SetVisibility(InVisibility: ESlateVisibility): void;
	SetUserFocus(PlayerController: PlayerController): void;
	SetToolTipText(InToolTipText: string): void;
	SetToolTip(Widget: Widget): void;
	SetRenderTranslation(Translation: Vector2D): void;
	SetRenderTransformPivot(Pivot: Vector2D): void;
	SetRenderTransformAngle(Angle: number): void;
	SetRenderTransform(InTransform: WidgetTransform): void;
	SetRenderShear(Shear: Vector2D): void;
	SetRenderScale(Scale: Vector2D): void;
	SetRenderOpacity(InOpacity: number): void;
	SetNavigationRuleExplicit(Direction: EUINavigation,InWidget: Widget): void;
	SetNavigationRuleBase(Direction: EUINavigation,Rule: EUINavigationRule): void;
	SetNavigationRule(Direction: EUINavigation,Rule: EUINavigationRule,WidgetToFocus: string): void;
	SetKeyboardFocus(): void;
	SetIsEnabled(bInIsEnabled: boolean): void;
	SetFocus(): void;
	SetCursor(InCursor: EMouseCursor): void;
	SetClipping(InClipping: EWidgetClipping): void;
	SetAllNavigationRules(Rule: EUINavigationRule,WidgetToFocus: string): void;
	ResetCursor(): void;
	RemoveFromParent(): void;
	K2_BroadcastFieldValueChanged(FieldId: FieldNotificationId): void;
	IsVisible(): boolean;
	IsRendered(): boolean;
	IsInViewport(): boolean;
	IsHovered(): boolean;
	InvalidateLayoutAndVolatility(): void;
	HasUserFocusedDescendants(PlayerController: PlayerController): boolean;
	HasUserFocus(PlayerController: PlayerController): boolean;
	HasMouseCaptureByUser(UserIndex: number,PointerIndex: number): boolean;
	HasMouseCapture(): boolean;
	HasKeyboardFocus(): boolean;
	HasFocusedDescendants(): boolean;
	HasAnyUserFocus(): boolean;
	GetVisibility(): ESlateVisibility;
	GetTickSpaceGeometry(): Geometry;
	GetRenderTransformAngle(): number;
	GetRenderOpacity(): number;
	GetParent(): PanelWidget;
	GetPaintSpaceGeometry(): Geometry;
	GetOwningPlayer(): PlayerController;
	GetOwningLocalPlayer(): LocalPlayer;
	GetIsEnabled(): boolean;
	GetGameInstance(): GameInstance;
	GetDesiredSize(): Vector2D;
	GetClipping(): EWidgetClipping;
	GetCachedGeometry(): Geometry;
	GetAccessibleText(): string;
	GetAccessibleSummaryText(): string;
	ForceVolatile(bForce: boolean): void;
	ForceLayoutPrepass(): void;
	static C(Other: UObject | any): Widget;
	GetUIGeometry(): Geometry;
	TakeWidget(): JavascriptSlateWidget;
	SlotAsBorderSlot(): BorderSlot;
	SlotAsCanvasSlot(): CanvasPanelSlot;
	SlotAsGridSlot(): GridSlot;
	SlotAsHorizontalBoxSlot(): HorizontalBoxSlot;
	SlotAsOverlaySlot(): OverlaySlot;
	SlotAsSafeBoxSlot(): SafeZoneSlot;
	SlotAsScaleBoxSlot(): ScaleBoxSlot;
	SlotAsScrollBoxSlot(): ScrollBoxSlot;
	SlotAsSizeBoxSlot(): SizeBoxSlot;
	SlotAsUniformGridSlot(): UniformGridSlot;
	SlotAsVerticalBoxSlot(): VerticalBoxSlot;
	SlotAsWidgetSwitcherSlot(): WidgetSwitcherSlot;
	SlotAsWrapBoxSlot(): WrapBoxSlot;
	SetWindowTitleBarState(Mode: EWindowTitleBarMode,bTitleBarDragEnabled: boolean,bWindowButtonsVisible: boolean,bTitleBarVisible: boolean): void;
	static GetUIGeometry(Widget: Widget): Geometry;
	static TakeWidget(Widget: Widget): JavascriptSlateWidget;
	static SlotAsBorderSlot(Widget: Widget): BorderSlot;
	static SlotAsCanvasSlot(Widget: Widget): CanvasPanelSlot;
	static SlotAsGridSlot(Widget: Widget): GridSlot;
	static SlotAsHorizontalBoxSlot(Widget: Widget): HorizontalBoxSlot;
	static SlotAsOverlaySlot(Widget: Widget): OverlaySlot;
	static SlotAsSafeBoxSlot(Widget: Widget): SafeZoneSlot;
	static SlotAsScaleBoxSlot(Widget: Widget): ScaleBoxSlot;
	static SlotAsScrollBoxSlot(Widget: Widget): ScrollBoxSlot;
	static SlotAsSizeBoxSlot(Widget: Widget): SizeBoxSlot;
	static SlotAsUniformGridSlot(Widget: Widget): UniformGridSlot;
	static SlotAsVerticalBoxSlot(Widget: Widget): VerticalBoxSlot;
	static SlotAsWidgetSwitcherSlot(Widget: Widget): WidgetSwitcherSlot;
	static SlotAsWrapBoxSlot(Widget: Widget): WrapBoxSlot;
	static SetWindowTitleBarState(TitleBarContent: Widget,Mode: EWindowTitleBarMode,bTitleBarDragEnabled: boolean,bWindowButtonsVisible: boolean,bTitleBarVisible: boolean): void;
}

declare type EDragPivot = 'MouseDown' | 'TopLeft' | 'TopCenter' | 'TopRight' | 'CenterLeft' | 'CenterCenter' | 'CenterRight' | 'BottomLeft' | 'BottomCenter' | 'BottomRight' | 'EDragPivot_MAX';
declare var EDragPivot : { MouseDown:'MouseDown',TopLeft:'TopLeft',TopCenter:'TopCenter',TopRight:'TopRight',CenterLeft:'CenterLeft',CenterCenter:'CenterCenter',CenterRight:'CenterRight',BottomLeft:'BottomLeft',BottomCenter:'BottomCenter',BottomRight:'BottomRight',EDragPivot_MAX:'EDragPivot_MAX', };
declare class DragDropOperation extends UObject { 
	Tag: string;
	Payload: UObject;
	DefaultDragVisual: Widget;
	Pivot: EDragPivot;
	Offset: Vector2D;
	OnDrop: UnrealEngineMulticastDelegate<(Operation: DragDropOperation) => void>;
	OnDragCancelled: UnrealEngineMulticastDelegate<(Operation: DragDropOperation) => void>;
	OnDragged: UnrealEngineMulticastDelegate<(Operation: DragDropOperation) => void>;
	static Load(ResourceName: string): DragDropOperation;
	static Find(Outer: UObject, ResourceName: string): DragDropOperation;
	static GetDefaultObject(): DragDropOperation;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DragDropOperation;
	Drop(UPointerEvent: UPointerEvent): void;
	Dragged(UPointerEvent: UPointerEvent): void;
	DragCancelled(UPointerEvent: UPointerEvent): void;
	static C(Other: UObject | any): DragDropOperation;
}

declare class Class extends Struct { 
	static Load(ResourceName: string): Class;
	static Find(Outer: UObject, ResourceName: string): Class;
	static GetDefaultObject(): Class;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Class;
	static C(Other: UObject | any): Class;
	DeleteColorForChannels(Identifier?: string): {Identifier: string};
	GetCustomColorForChannel(Identifier: string): LinearColor;
	HasCustomColorForChannel(Identifier: string): boolean;
	SetCustomColorForChannel(Identifier: string,NewColor: LinearColor): void;
	SetCustomColorForChannels(Identifiers: string[],NewColors: LinearColor[]): void;
	SetRandomColorForChannels(Identifiers: string[]): void;
	SpawnActorFromClass(Location: Vector,Rotation: Rotator,bTransient: boolean): Actor;
	AddDynamicBinding(BindingObject: DynamicBlueprintBinding): void;
	GetClassPathName(): string;
	GetDerivedClasses(Results?: UnrealEngineClass[],bRecursive?: boolean): {Results: UnrealEngineClass[]};
	GetDynamicBinding(BindingObjectClass: UnrealEngineClass): DynamicBlueprintBinding;
	GetObjectsOfClass(Results?: UObject[],bIncludeDerivedClasses?: boolean,ExcludeFlags?: number,ExclusionInternalFlags?: number): {Results: UObject[]};
	GetSuperClasses(): UnrealEngineClass[];
	IsGeneratedByBlueprint(): boolean;
	GetAllDatasmithUserData(OutUserData?: DatasmithAssetUserData[]): {OutUserData: DatasmithAssetUserData[]};
	GetEngineSubsystem(): EngineSubsystem;
	CreateNewLightWeightInstance(Transform: Transform,Layer: DataLayerInstance,World: World): ActorInstanceHandle;
	Conv_ClassToSoftClassReference(): Class;
	Conv_SoftClassReferenceToClass(): UnrealEngineClass;
	Conv_SoftClassReferenceToString(): string;
	Conv_SoftObjRefToSoftClassPath(): SoftClassPath;
	EqualEqual_SoftClassReference(B: Class): boolean;
	GetClassDisplayName(): string;
	GetPrimaryAssetIdFromClass(): PrimaryAssetId;
	GetPrimaryAssetIdFromSoftClassReference(): PrimaryAssetId;
	GetSoftClassPath(): SoftClassPath;
	IsValidClass(): boolean;
	IsValidSoftClassReference(): boolean;
	LoadClassAsset_Blocking(): UnrealEngineClass;
	NotEqual_SoftClassReference(B: Class): boolean;
	ClassIsChildOf(ParentClass: UnrealEngineClass): boolean;
	EqualEqual_ClassClass(B: UnrealEngineClass): boolean;
	NotEqual_ClassClass(B: UnrealEngineClass): boolean;
	SelectClass(B: UnrealEngineClass,bSelectA: boolean): UnrealEngineClass;
	CreateSaveGameObject(): SaveGame;
	SpawnObject(Outer: UObject): UObject;
	SetInterfaceClass(Var?: CameraLensInterfaceClassSupport,Result?: EInterfaceValidResult): {Var: CameraLensInterfaceClassSupport, Result: EInterfaceValidResult};
	GetEditorSubsystem(): EditorSubsystem;
	CreateDragDropOperation(): DragDropOperation;
	GetAllGeometriesByClass(): ARTrackedGeometry[];
	static DeleteColorForChannels(Class: UnrealEngineClass,Identifier?: string): {Identifier: string};
	static GetCustomColorForChannel(Class: UnrealEngineClass,Identifier: string): LinearColor;
	static HasCustomColorForChannel(Class: UnrealEngineClass,Identifier: string): boolean;
	static SetCustomColorForChannel(Class: UnrealEngineClass,Identifier: string,NewColor: LinearColor): void;
	static SetCustomColorForChannels(Class: UnrealEngineClass,Identifiers: string[],NewColors: LinearColor[]): void;
	static SetRandomColorForChannels(Class: UnrealEngineClass,Identifiers: string[]): void;
	static SpawnActorFromClass(ActorClass: UnrealEngineClass,Location: Vector,Rotation: Rotator,bTransient: boolean): Actor;
	static AddDynamicBinding(Outer: UnrealEngineClass,BindingObject: DynamicBlueprintBinding): void;
	static GetClassPathName(Class: UnrealEngineClass): string;
	static GetDerivedClasses(ClassToLookFor: UnrealEngineClass,Results?: UnrealEngineClass[],bRecursive?: boolean): {Results: UnrealEngineClass[]};
	static GetDynamicBinding(Outer: UnrealEngineClass,BindingObjectClass: UnrealEngineClass): DynamicBlueprintBinding;
	static GetObjectsOfClass(ClassToLookFor: UnrealEngineClass,Results?: UObject[],bIncludeDerivedClasses?: boolean,ExcludeFlags?: number,ExclusionInternalFlags?: number): {Results: UObject[]};
	static GetSuperClasses(InClass: UnrealEngineClass): UnrealEngineClass[];
	static IsGeneratedByBlueprint(InClass: UnrealEngineClass): boolean;
	static GetAllDatasmithUserData(ObjectClass: UnrealEngineClass,OutUserData?: DatasmithAssetUserData[]): {OutUserData: DatasmithAssetUserData[]};
	static GetEngineSubsystem(Class: UnrealEngineClass): EngineSubsystem;
	static CreateNewLightWeightInstance(ActorClass: UnrealEngineClass,Transform: Transform,Layer: DataLayerInstance,World: World): ActorInstanceHandle;
	static Conv_ClassToSoftClassReference(Class: UnrealEngineClass): Class;
	static Conv_SoftClassReferenceToClass(softclass: Class): UnrealEngineClass;
	static Conv_SoftClassReferenceToString(SoftClassReference: Class): string;
	static Conv_SoftObjRefToSoftClassPath(SoftClassReference: Class): SoftClassPath;
	static EqualEqual_SoftClassReference(A: Class,B: Class): boolean;
	static GetClassDisplayName(Class: UnrealEngineClass): string;
	static GetPrimaryAssetIdFromClass(Class: UnrealEngineClass): PrimaryAssetId;
	static GetPrimaryAssetIdFromSoftClassReference(SoftClassReference: Class): PrimaryAssetId;
	static GetSoftClassPath(Class: UnrealEngineClass): SoftClassPath;
	static IsValidClass(Class: UnrealEngineClass): boolean;
	static IsValidSoftClassReference(SoftClassReference: Class): boolean;
	static LoadClassAsset_Blocking(AssetClass: Class): UnrealEngineClass;
	static NotEqual_SoftClassReference(A: Class,B: Class): boolean;
	static ClassIsChildOf(TestClass: UnrealEngineClass,ParentClass: UnrealEngineClass): boolean;
	static EqualEqual_ClassClass(A: UnrealEngineClass,B: UnrealEngineClass): boolean;
	static NotEqual_ClassClass(A: UnrealEngineClass,B: UnrealEngineClass): boolean;
	static SelectClass(A: UnrealEngineClass,B: UnrealEngineClass,bSelectA: boolean): UnrealEngineClass;
	static CreateSaveGameObject(SaveGameClass: UnrealEngineClass): SaveGame;
	static SpawnObject(ObjectClass: UnrealEngineClass,Outer: UObject): UObject;
	static SetInterfaceClass(Class: UnrealEngineClass,Var?: CameraLensInterfaceClassSupport,Result?: EInterfaceValidResult): {Var: CameraLensInterfaceClassSupport, Result: EInterfaceValidResult};
	static GetEditorSubsystem(Class: UnrealEngineClass): EditorSubsystem;
	static CreateDragDropOperation(OperationClass: UnrealEngineClass): DragDropOperation;
	static GetAllGeometriesByClass(GeometryClass: UnrealEngineClass): ARTrackedGeometry[];
}

declare class NavAgentSelector { 
	bSupportsAgent0: boolean;
	bSupportsAgent1: boolean;
	bSupportsAgent2: boolean;
	bSupportsAgent3: boolean;
	bSupportsAgent4: boolean;
	bSupportsAgent5: boolean;
	bSupportsAgent6: boolean;
	bSupportsAgent7: boolean;
	bSupportsAgent8: boolean;
	bSupportsAgent9: boolean;
	bSupportsAgent10: boolean;
	bSupportsAgent11: boolean;
	bSupportsAgent12: boolean;
	bSupportsAgent13: boolean;
	bSupportsAgent14: boolean;
	bSupportsAgent15: boolean;
	clone() : NavAgentSelector;
	static C(Other: UObject | any): NavAgentSelector;
}

declare class NavigationSystemConfig extends UObject { 
	NavigationSystemClass: SoftClassPath;
	SupportedAgentsMask: NavAgentSelector;
	DefaultAgentName: string;
	bIsOverriden: boolean;
	static Load(ResourceName: string): NavigationSystemConfig;
	static Find(Outer: UObject, ResourceName: string): NavigationSystemConfig;
	static GetDefaultObject(): NavigationSystemConfig;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationSystemConfig;
	static C(Other: UObject | any): NavigationSystemConfig;
}

declare class WorldPartitionEditorHash extends UObject { 
	static Load(ResourceName: string): WorldPartitionEditorHash;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionEditorHash;
	static GetDefaultObject(): WorldPartitionEditorHash;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionEditorHash;
	static C(Other: UObject | any): WorldPartitionEditorHash;
}

declare class WorldPartitionStreamingPolicy extends UObject { 
	static Load(ResourceName: string): WorldPartitionStreamingPolicy;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionStreamingPolicy;
	static GetDefaultObject(): WorldPartitionStreamingPolicy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionStreamingPolicy;
	static C(Other: UObject | any): WorldPartitionStreamingPolicy;
}

declare class ActorDescContainer extends UObject { 
	World: World;
	static Load(ResourceName: string): ActorDescContainer;
	static Find(Outer: UObject, ResourceName: string): ActorDescContainer;
	static GetDefaultObject(): ActorDescContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorDescContainer;
	static C(Other: UObject | any): ActorDescContainer;
}

declare class WorldPartitionRuntimeHash extends UObject { 
	static Load(ResourceName: string): WorldPartitionRuntimeHash;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionRuntimeHash;
	static GetDefaultObject(): WorldPartitionRuntimeHash;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionRuntimeHash;
	static C(Other: UObject | any): WorldPartitionRuntimeHash;
}

declare type EHLODLayerType = 'Instancing' | 'MeshMerge' | 'MeshSimplify' | 'MeshApproximate' | 'Custom' | 'EHLODLayerType_MAX';
declare var EHLODLayerType : { Instancing:'Instancing',MeshMerge:'MeshMerge',MeshSimplify:'MeshSimplify',MeshApproximate:'MeshApproximate',Custom:'Custom',EHLODLayerType_MAX:'EHLODLayerType_MAX', };
declare class HLODBuilderSettings extends UObject { 
	static Load(ResourceName: string): HLODBuilderSettings;
	static Find(Outer: UObject, ResourceName: string): HLODBuilderSettings;
	static GetDefaultObject(): HLODBuilderSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HLODBuilderSettings;
	static C(Other: UObject | any): HLODBuilderSettings;
}

declare class HLODBuilder extends UObject { 
	HLODBuilderSettings: HLODBuilderSettings;
	static Load(ResourceName: string): HLODBuilder;
	static Find(Outer: UObject, ResourceName: string): HLODBuilder;
	static GetDefaultObject(): HLODBuilder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HLODBuilder;
	static C(Other: UObject | any): HLODBuilder;
}

declare type EUVOutput = 'DoNotOutputChannel' | 'OutputChannel' | 'EUVOutput_MAX';
declare var EUVOutput : { DoNotOutputChannel:'DoNotOutputChannel',OutputChannel:'OutputChannel',EUVOutput_MAX:'EUVOutput_MAX', };
declare type EMeshLODSelectionType = 'AllLODs' | 'SpecificLOD' | 'CalculateLOD' | 'LowestDetailLOD' | 'EMeshLODSelectionType_MAX';
declare var EMeshLODSelectionType : { AllLODs:'AllLODs',SpecificLOD:'SpecificLOD',CalculateLOD:'CalculateLOD',LowestDetailLOD:'LowestDetailLOD',EMeshLODSelectionType_MAX:'EMeshLODSelectionType_MAX', };
declare class MeshMergingSettings { 
	TargetLightMapResolution: number;
	OutputUVs: EUVOutput;
	MaterialSettings: MaterialProxySettings;
	GutterSize: number;
	LODSelectionType: EMeshLODSelectionType;
	SpecificLOD: number;
	bGenerateLightMapUV: boolean;
	bComputedLightMapResolution: boolean;
	bPivotPointAtZero: boolean;
	bMergePhysicsData: boolean;
	bMergeMaterials: boolean;
	bCreateMergedMaterial: boolean;
	bBakeVertexDataToMesh: boolean;
	bUseVertexDataForBakingMaterial: boolean;
	bUseTextureBinning: boolean;
	bReuseMeshLightmapUVs: boolean;
	bMergeEquivalentMaterials: boolean;
	bUseLandscapeCulling: boolean;
	bIncludeImposters: boolean;
	bSupportRayTracing: boolean;
	bAllowDistanceField: boolean;
	NaniteSettings: MeshNaniteSettings;
	bImportVertexColors: boolean;
	bCalculateCorrectLODModel: boolean;
	bExportNormalMap: boolean;
	bExportMetallicMap: boolean;
	bExportRoughnessMap: boolean;
	bExportSpecularMap: boolean;
	MergedMaterialAtlasResolution: number;
	ExportSpecificLOD: number;
	bGenerateNaniteEnabledMesh: boolean;
	NaniteFallbackTrianglePercent: number;
	clone() : MeshMergingSettings;
	static C(Other: UObject | any): MeshMergingSettings;
}

declare type EProxyNormalComputationMethod = 'AngleWeighted' | 'AreaWeighted' | 'EqualWeighted' | 'EProxyNormalComputationMethod_MAX';
declare var EProxyNormalComputationMethod : { AngleWeighted:'AngleWeighted',AreaWeighted:'AreaWeighted',EqualWeighted:'EqualWeighted',EProxyNormalComputationMethod_MAX:'EProxyNormalComputationMethod_MAX', };
declare type ELandscapeCullingPrecision = 'High' | 'Medium' | 'Low' | 'ELandscapeCullingPrecision_MAX';
declare var ELandscapeCullingPrecision : { High:'High',Medium:'Medium',Low:'Low',ELandscapeCullingPrecision_MAX:'ELandscapeCullingPrecision_MAX', };
declare class MeshProxySettings { 
	ScreenSize: number;
	VoxelSize: number;
	MaterialSettings: MaterialProxySettings;
	TextureWidth: number;
	TextureHeight: number;
	bExportNormalMap: boolean;
	bExportMetallicMap: boolean;
	bExportRoughnessMap: boolean;
	bExportSpecularMap: boolean;
	bBakeVertexData: boolean;
	bGenerateNaniteEnabledMesh: boolean;
	NaniteProxyTrianglePercent: number;
	MergeDistance: number;
	UnresolvedGeometryColor: Color;
	MaxRayCastDist: number;
	HardAngleThreshold: number;
	LightMapResolution: number;
	NormalCalculationMethod: EProxyNormalComputationMethod;
	LandscapeCullingPrecision: ELandscapeCullingPrecision;
	bCalculateCorrectLODModel: boolean;
	bOverrideVoxelSize: boolean;
	bOverrideTransferDistance: boolean;
	bUseHardAngleThreshold: boolean;
	bComputeLightMapResolution: boolean;
	bRecalculateNormals: boolean;
	bUseLandscapeCulling: boolean;
	bSupportRayTracing: boolean;
	bAllowDistanceField: boolean;
	bReuseMeshLightmapUVs: boolean;
	bGroupIdenticalMeshesForBaking: boolean;
	bCreateCollision: boolean;
	bAllowVertexColors: boolean;
	bGenerateLightmapUVs: boolean;
	NaniteSettings: MeshNaniteSettings;
	clone() : MeshProxySettings;
	static C(Other: UObject | any): MeshProxySettings;
}

declare type EMeshApproximationType = 'MeshAndMaterials' | 'MeshShapeOnly' | 'EMeshApproximationType_MAX';
declare var EMeshApproximationType : { MeshAndMaterials:'MeshAndMaterials',MeshShapeOnly:'MeshShapeOnly',EMeshApproximationType_MAX:'EMeshApproximationType_MAX', };
declare type EMeshApproximationBaseCappingType = 'NoBaseCapping' | 'ConvexPolygon' | 'ConvexSolid' | 'EMeshApproximationBaseCappingType_MAX';
declare var EMeshApproximationBaseCappingType : { NoBaseCapping:'NoBaseCapping',ConvexPolygon:'ConvexPolygon',ConvexSolid:'ConvexSolid',EMeshApproximationBaseCappingType_MAX:'EMeshApproximationBaseCappingType_MAX', };
declare type EOccludedGeometryFilteringPolicy = 'NoOcclusionFiltering' | 'VisibilityBasedFiltering' | 'EOccludedGeometryFilteringPolicy_MAX';
declare var EOccludedGeometryFilteringPolicy : { NoOcclusionFiltering:'NoOcclusionFiltering',VisibilityBasedFiltering:'VisibilityBasedFiltering',EOccludedGeometryFilteringPolicy_MAX:'EOccludedGeometryFilteringPolicy_MAX', };
declare type EMeshApproximationSimplificationPolicy = 'FixedTriangleCount' | 'TrianglesPerArea' | 'GeometricTolerance' | 'EMeshApproximationSimplificationPolicy_MAX';
declare var EMeshApproximationSimplificationPolicy : { FixedTriangleCount:'FixedTriangleCount',TrianglesPerArea:'TrianglesPerArea',GeometricTolerance:'GeometricTolerance',EMeshApproximationSimplificationPolicy_MAX:'EMeshApproximationSimplificationPolicy_MAX', };
declare type EMeshApproximationGroundPlaneClippingPolicy = 'NoGroundClipping' | 'DiscardWithZPlane' | 'CutWithZPlane' | 'CutAndFillWithZPlane' | 'EMeshApproximationGroundPlaneClippingPolicy_MAX';
declare var EMeshApproximationGroundPlaneClippingPolicy : { NoGroundClipping:'NoGroundClipping',DiscardWithZPlane:'DiscardWithZPlane',CutWithZPlane:'CutWithZPlane',CutAndFillWithZPlane:'CutAndFillWithZPlane',EMeshApproximationGroundPlaneClippingPolicy_MAX:'EMeshApproximationGroundPlaneClippingPolicy_MAX', };
declare type EMeshApproximationUVGenerationPolicy = 'PreferUVAtlas' | 'PreferXAtlas' | 'PreferPatchBuilder' | 'EMeshApproximationUVGenerationPolicy_MAX';
declare var EMeshApproximationUVGenerationPolicy : { PreferUVAtlas:'PreferUVAtlas',PreferXAtlas:'PreferXAtlas',PreferPatchBuilder:'PreferPatchBuilder',EMeshApproximationUVGenerationPolicy_MAX:'EMeshApproximationUVGenerationPolicy_MAX', };
declare class MeshApproximationSettings { 
	OutputType: EMeshApproximationType;
	ApproximationAccuracy: number;
	ClampVoxelDimension: number;
	bAttemptAutoThickening: boolean;
	TargetMinThicknessMultiplier: number;
	bIgnoreTinyParts: boolean;
	TinyPartSizeMultiplier: number;
	BaseCapping: EMeshApproximationBaseCappingType;
	WindingThreshold: number;
	bFillGaps: boolean;
	GapDistance: number;
	OcclusionMethod: EOccludedGeometryFilteringPolicy;
	bOccludeFromBottom: boolean;
	SimplifyMethod: EMeshApproximationSimplificationPolicy;
	TargetTriCount: number;
	TrianglesPerM: number;
	GeometricDeviation: number;
	GroundClipping: EMeshApproximationGroundPlaneClippingPolicy;
	GroundClippingZHeight: number;
	bEstimateHardNormals: boolean;
	HardNormalAngle: number;
	UVGenerationMethod: EMeshApproximationUVGenerationPolicy;
	InitialPatchCount: number;
	CurvatureAlignment: number;
	MergingThreshold: number;
	MaxAngleDeviation: number;
	bGenerateNaniteEnabledMesh: boolean;
	NaniteProxyTrianglePercent: number;
	bSupportRayTracing: boolean;
	bAllowDistanceField: boolean;
	MultiSamplingAA: number;
	RenderCaptureResolution: number;
	MaterialSettings: MaterialProxySettings;
	CaptureFieldOfView: number;
	NearPlaneDist: number;
	bUseRenderLODMeshes: boolean;
	bEnableSimplifyPrePass: boolean;
	bEnableParallelBaking: boolean;
	bPrintDebugMessages: boolean;
	bEmitFullDebugMesh: boolean;
	clone() : MeshApproximationSettings;
	static C(Other: UObject | any): MeshApproximationSettings;
}

declare class HLODLayer extends UObject { 
	LayerType: EHLODLayerType;
	HLODBuilderClass: UnrealEngineClass;
	HLODBuilderSettings: HLODBuilderSettings;
	bIsSpatiallyLoaded: boolean;
	CellSize: number;
	LoadingRange: number;
	ParentLayer: HLODLayer;
	MeshMergeSettings: MeshMergingSettings;
	MeshSimplifySettings: MeshProxySettings;
	MeshApproximationSettings: MeshApproximationSettings;
	HLODMaterial: MaterialInterface;
	bAlwaysLoaded: boolean;
	static Load(ResourceName: string): HLODLayer;
	static Find(Outer: UObject, ResourceName: string): HLODLayer;
	static GetDefaultObject(): HLODLayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): HLODLayer;
	static C(Other: UObject | any): HLODLayer;
}

declare class WorldPartitionEditorLoaderAdapter extends UObject { 
	static Load(ResourceName: string): WorldPartitionEditorLoaderAdapter;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionEditorLoaderAdapter;
	static GetDefaultObject(): WorldPartitionEditorLoaderAdapter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionEditorLoaderAdapter;
	static C(Other: UObject | any): WorldPartitionEditorLoaderAdapter;
}

declare class WorldPartition extends UObject { 
	EditorHash: WorldPartitionEditorHash;
	WorldPartitionStreamingPolicyClass: UnrealEngineClass;
	bStreamingWasEnabled: boolean;
	bCanBeUsedByLevelInstance: boolean;
	ActorDescContainer: ActorDescContainer;
	RuntimeHash: WorldPartitionRuntimeHash;
	World: World;
	bEnableStreaming: boolean;
	DefaultHLODLayer: HLODLayer;
	StreamingPolicy: WorldPartitionStreamingPolicy;
	RegisteredEditorLoaderAdapters: Set<WorldPartitionEditorLoaderAdapter>;
	static Load(ResourceName: string): WorldPartition;
	static Find(Outer: UObject, ResourceName: string): WorldPartition;
	static GetDefaultObject(): WorldPartition;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartition;
	static C(Other: UObject | any): WorldPartition;
}

declare class DataLayerAsset extends UObject { 
	DataLayerType: EDataLayerType;
	DebugColor: Color;
	static Load(ResourceName: string): DataLayerAsset;
	static Find(Outer: UObject, ResourceName: string): DataLayerAsset;
	static GetDefaultObject(): DataLayerAsset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataLayerAsset;
	IsRuntime(): boolean;
	GetType(): EDataLayerType;
	GetDebugColor(): Color;
	static C(Other: UObject | any): DataLayerAsset;
}

declare class DefaultPhysicsVolume extends PhysicsVolume { 
	static GetDefaultObject(): DefaultPhysicsVolume;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DefaultPhysicsVolume;
	static C(Other: UObject | any): DefaultPhysicsVolume;
}

declare class PhysicsCollisionHandler extends UObject { 
	ImpactThreshold: number;
	ImpactReFireDelay: number;
	DefaultImpactSound: SoundBase;
	LastImpactSoundTime: number;
	static Load(ResourceName: string): PhysicsCollisionHandler;
	static Find(Outer: UObject, ResourceName: string): PhysicsCollisionHandler;
	static GetDefaultObject(): PhysicsCollisionHandler;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicsCollisionHandler;
	static C(Other: UObject | any): PhysicsCollisionHandler;
}

declare class GameSession extends Info { 
	MaxSpectators: number;
	MaxPlayers: number;
	MaxPartySize: number;
	MaxSplitscreensPerConnection: number;
	bRequiresPushToTalk: boolean;
	SessionName: string;
	static GetDefaultObject(): GameSession;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameSession;
	static C(Other: UObject | any): GameSession;
}

declare class GameStateBase extends Info { 
	GameModeClass: UnrealEngineClass;
	AuthorityGameMode: GameModeBase;
	SpectatorClass: UnrealEngineClass;
	PlayerArray: PlayerState[];
	bReplicatedHasBegunPlay: boolean;
	ReplicatedWorldTimeSeconds: number;
	ServerWorldTimeSecondsDelta: number;
	ServerWorldTimeSecondsUpdateFrequency: number;
	static GetDefaultObject(): GameStateBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameStateBase;
	OnRep_SpectatorClass(): void;
	OnRep_ReplicatedWorldTimeSeconds(): void;
	OnRep_ReplicatedHasBegunPlay(): void;
	OnRep_GameModeClass(): void;
	HasMatchStarted(): boolean;
	HasMatchEnded(): boolean;
	HasBegunPlay(): boolean;
	GetServerWorldTimeSeconds(): number;
	GetPlayerStartTime(Controller: Controller): number;
	GetPlayerRespawnDelay(Controller: Controller): number;
	static C(Other: UObject | any): GameStateBase;
}

declare class ServerStatReplicator extends Info { 
	bUpdateStatNet: boolean;
	bOverwriteClientStats: boolean;
	Channels: number;
	InRate: number;
	OutRate: number;
	MaxPacketOverhead: number;
	InRateClientMax: number;
	InRateClientMin: number;
	InRateClientAvg: number;
	InPacketsClientMax: number;
	InPacketsClientMin: number;
	InPacketsClientAvg: number;
	OutRateClientMax: number;
	OutRateClientMin: number;
	OutRateClientAvg: number;
	OutPacketsClientMax: number;
	OutPacketsClientMin: number;
	OutPacketsClientAvg: number;
	NetNumClients: number;
	InPackets: number;
	OutPackets: number;
	InBunches: number;
	OutBunches: number;
	OutLoss: number;
	InLoss: number;
	VoiceBytesSent: number;
	VoiceBytesRecv: number;
	VoicePacketsSent: number;
	VoicePacketsRecv: number;
	PercentInVoice: number;
	PercentOutVoice: number;
	NumActorChannels: number;
	NumConsideredActors: number;
	PrioritizedActors: number;
	NumRelevantActors: number;
	NumRelevantDeletedActors: number;
	NumReplicatedActorAttempts: number;
	NumReplicatedActors: number;
	NumActors: number;
	NumNetActors: number;
	NumDormantActors: number;
	NumInitiallyDormantActors: number;
	NumNetGUIDsAckd: number;
	NumNetGUIDsPending: number;
	NumNetGUIDsUnAckd: number;
	ObjPathBytes: number;
	NetGUIDOutRate: number;
	NetGUIDInRate: number;
	NetSaturated: number;
	static GetDefaultObject(): ServerStatReplicator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ServerStatReplicator;
	static C(Other: UObject | any): ServerStatReplicator;
}

declare class GameModeBase extends Info { 
	OptionsString: string;
	GameSessionClass: UnrealEngineClass;
	GameStateClass: UnrealEngineClass;
	PlayerControllerClass: UnrealEngineClass;
	PlayerStateClass: UnrealEngineClass;
	HUDClass: UnrealEngineClass;
	DefaultPawnClass: UnrealEngineClass;
	SpectatorClass: UnrealEngineClass;
	ReplaySpectatorPlayerControllerClass: UnrealEngineClass;
	ServerStatReplicatorClass: UnrealEngineClass;
	GameSession: GameSession;
	GameState: GameStateBase;
	ServerStatReplicator: ServerStatReplicator;
	DefaultPlayerName: string;
	bUseSeamlessTravel: boolean;
	bStartPlayersAsSpectators: boolean;
	bPauseable: boolean;
	static GetDefaultObject(): GameModeBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameModeBase;
	StartPlay(): void;
	SpawnDefaultPawnFor(NewPlayer: Controller,StartSpot: Actor): Pawn;
	SpawnDefaultPawnAtTransform(NewPlayer: Controller,SpawnTransform: Transform): Pawn;
	ShouldReset(ActorToReset: Actor): boolean;
	ReturnToMainMenuHost(): void;
	RestartPlayerAtTransform(NewPlayer: Controller,SpawnTransform: Transform): void;
	RestartPlayerAtPlayerStart(NewPlayer: Controller,StartSpot: Actor): void;
	RestartPlayer(NewPlayer: Controller): void;
	ResetLevel(): void;
	PlayerCanRestart(Player: PlayerController): boolean;
	MustSpectate(NewPlayerController: PlayerController): boolean;
	K2_PostLogin(NewPlayer: PlayerController): void;
	K2_OnSwapPlayerControllers(OldPC: PlayerController,NewPC: PlayerController): void;
	K2_OnRestartPlayer(NewPlayer: Controller): void;
	K2_OnLogout(ExitingController: Controller): void;
	K2_OnChangeName(Other: Controller,NewName: string,bNameChange: boolean): void;
	K2_FindPlayerStart(Player: Controller,IncomingName: string): Actor;
	InitStartSpot(StartSpot: Actor,NewPlayer: Controller): void;
	InitializeHUDForPlayer(NewPlayer: PlayerController): void;
	HasMatchStarted(): boolean;
	HasMatchEnded(): boolean;
	HandleStartingNewPlayer(NewPlayer: PlayerController): void;
	GetNumSpectators(): number;
	GetNumPlayers(): number;
	GetDefaultPawnClassForController(InController: Controller): UnrealEngineClass;
	FindPlayerStart(Player: Controller,IncomingName: string): Actor;
	ChoosePlayerStart(Player: Controller): Actor;
	ChangeName(Controller: Controller,NewName: string,bNameChange: boolean): void;
	CanSpectate(Viewer: PlayerController,ViewTarget: PlayerState): boolean;
	static C(Other: UObject | any): GameModeBase;
	HandleSeamlessTravelPlayer(C?: Controller): {C: Controller};
	static HandleSeamlessTravelPlayer(GameMode: GameModeBase,C?: Controller): {C: Controller};
}

declare class GameNetworkManager extends Info { 
	BadPacketLossThreshold: number;
	SeverePacketLossThreshold: number;
	BadPingThreshold: number;
	SeverePingThreshold: number;
	AdjustedNetSpeed: number;
	LastNetSpeedUpdateTime: number;
	TotalNetBandwidth: number;
	MinDynamicBandwidth: number;
	MaxDynamicBandwidth: number;
	bIsStandbyCheckingEnabled: boolean;
	bHasStandbyCheatTriggered: boolean;
	StandbyRxCheatTime: number;
	StandbyTxCheatTime: number;
	PercentMissingForRxStandby: number;
	PercentMissingForTxStandby: number;
	PercentForBadPing: number;
	JoinInProgressStandbyWaitTime: number;
	MoveRepSize: number;
	MAXPOSITIONERRORSQUARED: number;
	MAXNEARZEROVELOCITYSQUARED: number;
	CLIENTADJUSTUPDATECOST: number;
	MAXCLIENTUPDATEINTERVAL: number;
	MaxClientForcedUpdateDuration: number;
	ServerForcedUpdateHitchThreshold: number;
	ServerForcedUpdateHitchCooldown: number;
	MaxMoveDeltaTime: number;
	MaxClientSmoothingDeltaTime: number;
	ClientNetSendMoveDeltaTime: number;
	ClientNetSendMoveDeltaTimeThrottled: number;
	ClientNetSendMoveDeltaTimeStationary: number;
	ClientNetSendMoveThrottleAtNetSpeed: number;
	ClientNetSendMoveThrottleOverPlayerCount: number;
	ClientErrorUpdateRateLimit: number;
	ClientNetCamUpdateDeltaTime: number;
	ClientNetCamUpdatePositionLimit: number;
	ClientAuthorativePosition: boolean;
	bMovementTimeDiscrepancyDetection: boolean;
	bMovementTimeDiscrepancyResolution: boolean;
	MovementTimeDiscrepancyMaxTimeMargin: number;
	MovementTimeDiscrepancyMinTimeMargin: number;
	MovementTimeDiscrepancyResolutionRate: number;
	MovementTimeDiscrepancyDriftAllowance: number;
	bMovementTimeDiscrepancyForceCorrectionsDuringResolution: boolean;
	bUseDistanceBasedRelevancy: boolean;
	static GetDefaultObject(): GameNetworkManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameNetworkManager;
	static C(Other: UObject | any): GameNetworkManager;
}

declare type EVolumeLightingMethod = 'VLM_VolumetricLightmap' | 'VLM_SparseVolumeLightingSamples' | 'VLM_MAX';
declare var EVolumeLightingMethod : { VLM_VolumetricLightmap:'VLM_VolumetricLightmap',VLM_SparseVolumeLightingSamples:'VLM_SparseVolumeLightingSamples',VLM_MAX:'VLM_MAX', };
declare class LightmassWorldInfoSettings { 
	StaticLightingLevelScale: number;
	NumIndirectLightingBounces: number;
	NumSkyLightingBounces: number;
	IndirectLightingQuality: number;
	IndirectLightingSmoothness: number;
	EnvironmentColor: Color;
	EnvironmentIntensity: number;
	EmissiveBoost: number;
	DiffuseBoost: number;
	VolumeLightingMethod: EVolumeLightingMethod;
	bUseAmbientOcclusion: boolean;
	bGenerateAmbientOcclusionMaterialMask: boolean;
	bVisualizeMaterialDiffuse: boolean;
	bVisualizeAmbientOcclusion: boolean;
	bCompressLightmaps: boolean;
	VolumetricLightmapDetailCellSize: number;
	VolumetricLightmapMaximumBrickMemoryMb: number;
	VolumetricLightmapSphericalHarmonicSmoothing: number;
	VolumeLightSamplePlacementScale: number;
	DirectIlluminationOcclusionFraction: number;
	IndirectIlluminationOcclusionFraction: number;
	OcclusionExponent: number;
	FullyOccludedSamplesFraction: number;
	MaxOcclusionDistance: number;
	clone() : LightmassWorldInfoSettings;
	static C(Other: UObject | any): LightmassWorldInfoSettings;
}

declare type ReverbPreset = 'REVERB_Default' | 'REVERB_Bathroom' | 'REVERB_StoneRoom' | 'REVERB_Auditorium' | 'REVERB_ConcertHall' | 'REVERB_Cave' | 'REVERB_Hallway' | 'REVERB_StoneCorridor' | 'REVERB_Alley' | 'REVERB_Forest' | 'REVERB_City' | 'REVERB_Mountains' | 'REVERB_Quarry' | 'REVERB_Plain' | 'REVERB_ParkingLot' | 'REVERB_SewerPipe' | 'REVERB_Underwater' | 'REVERB_SmallRoom' | 'REVERB_MediumRoom' | 'REVERB_LargeRoom' | 'REVERB_MediumHall' | 'REVERB_LargeHall' | 'REVERB_Plate' | 'REVERB_MAX';
declare var ReverbPreset : { REVERB_Default:'REVERB_Default',REVERB_Bathroom:'REVERB_Bathroom',REVERB_StoneRoom:'REVERB_StoneRoom',REVERB_Auditorium:'REVERB_Auditorium',REVERB_ConcertHall:'REVERB_ConcertHall',REVERB_Cave:'REVERB_Cave',REVERB_Hallway:'REVERB_Hallway',REVERB_StoneCorridor:'REVERB_StoneCorridor',REVERB_Alley:'REVERB_Alley',REVERB_Forest:'REVERB_Forest',REVERB_City:'REVERB_City',REVERB_Mountains:'REVERB_Mountains',REVERB_Quarry:'REVERB_Quarry',REVERB_Plain:'REVERB_Plain',REVERB_ParkingLot:'REVERB_ParkingLot',REVERB_SewerPipe:'REVERB_SewerPipe',REVERB_Underwater:'REVERB_Underwater',REVERB_SmallRoom:'REVERB_SmallRoom',REVERB_MediumRoom:'REVERB_MediumRoom',REVERB_LargeRoom:'REVERB_LargeRoom',REVERB_MediumHall:'REVERB_MediumHall',REVERB_LargeHall:'REVERB_LargeHall',REVERB_Plate:'REVERB_Plate',REVERB_MAX:'REVERB_MAX', };
declare class ReverbEffect extends UObject { 
	bBypassEarlyReflections: boolean;
	ReflectionsDelay: number;
	GainHF: number;
	ReflectionsGain: number;
	bBypassLateReflections: boolean;
	LateDelay: number;
	DecayTime: number;
	Density: number;
	Diffusion: number;
	AirAbsorptionGainHF: number;
	DecayHFRatio: number;
	LateGain: number;
	Gain: number;
	RoomRolloffFactor: number;
	bChanged: boolean;
	static Load(ResourceName: string): ReverbEffect;
	static Find(Outer: UObject, ResourceName: string): ReverbEffect;
	static GetDefaultObject(): ReverbEffect;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ReverbEffect;
	static C(Other: UObject | any): ReverbEffect;
}

declare class ReverbSettings { 
	bApplyReverb: boolean;
	ReverbType: ReverbPreset;
	ReverbEffect: ReverbEffect;
	ReverbPluginEffect: SoundEffectSubmixPreset;
	Volume: number;
	FadeTime: number;
	clone() : ReverbSettings;
	static C(Other: UObject | any): ReverbSettings;
}

declare class InteriorSettings { 
	bIsWorldSettings: boolean;
	ExteriorVolume: number;
	ExteriorTime: number;
	ExteriorLPF: number;
	ExteriorLPFTime: number;
	InteriorVolume: number;
	InteriorTime: number;
	InteriorLPF: number;
	InteriorLPFTime: number;
	clone() : InteriorSettings;
	static C(Other: UObject | any): InteriorSettings;
}

declare type EHierarchicalSimplificationMethod = 'None' | 'Merge' | 'Simplify' | 'Approximate' | 'EHierarchicalSimplificationMethod_MAX';
declare var EHierarchicalSimplificationMethod : { None:'None',Merge:'Merge',Simplify:'Simplify',Approximate:'Approximate',EHierarchicalSimplificationMethod_MAX:'EHierarchicalSimplificationMethod_MAX', };
declare class HierarchicalSimplification { 
	TransitionScreenSize: number;
	OverrideDrawDistance: number;
	bUseOverrideDrawDistance: boolean;
	bAllowSpecificExclusion: boolean;
	bOnlyGenerateClustersForVolumes: boolean;
	bReusePreviousLevelClusters: boolean;
	SimplificationMethod: EHierarchicalSimplificationMethod;
	ProxySetting: MeshProxySettings;
	MergeSetting: MeshMergingSettings;
	ApproximateSettings: MeshApproximationSettings;
	DesiredBoundRadius: number;
	DesiredFillingPercentage: number;
	MinNumberOfActorsToBuild: number;
	bSimplifyMesh: boolean;
	clone() : HierarchicalSimplification;
	static C(Other: UObject | any): HierarchicalSimplification;
}

declare class BookmarkBase extends UObject { 
	static Load(ResourceName: string): BookmarkBase;
	static Find(Outer: UObject, ResourceName: string): BookmarkBase;
	static GetDefaultObject(): BookmarkBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BookmarkBase;
	static C(Other: UObject | any): BookmarkBase;
}

declare class BookMark extends BookmarkBase { 
	Location: Vector;
	Rotation: Rotator;
	HiddenLevels: string[];
	static Load(ResourceName: string): BookMark;
	static Find(Outer: UObject, ResourceName: string): BookMark;
	static GetDefaultObject(): BookMark;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BookMark;
	static C(Other: UObject | any): BookMark;
}

declare class BroadphaseSettings { 
	bUseMBPOnClient: boolean;
	bUseMBPOnServer: boolean;
	bUseMBPOuterBounds: boolean;
	MBPBounds: Box;
	MBPOuterBounds: Box;
	MBPNumSubdivs: number;
	clone() : BroadphaseSettings;
	static C(Other: UObject | any): BroadphaseSettings;
}

declare class NetViewer { 
	Connection: NetConnection;
	InViewer: Actor;
	ViewTarget: Actor;
	ViewLocation: Vector;
	ViewDir: Vector;
	clone() : NetViewer;
	static C(Other: UObject | any): NetViewer;
}

declare class WorldPartitionPerWorldSettings { 
	LoadedEditorRegions: Box[];
	LoadedEditorLocationVolumes: string[];
	NotLoadedDataLayers: string[];
	LoadedDataLayers: string[];
	clone() : WorldPartitionPerWorldSettings;
	static C(Other: UObject | any): WorldPartitionPerWorldSettings;
}

declare class WorldSettings extends Info { 
	VisibilityCellSize: number;
	VisibilityAggressiveness: EVisibilityAggressiveness;
	bPrecomputeVisibility: boolean;
	bPlaceCellsOnlyAlongCameraTracks: boolean;
	bEnableWorldBoundsChecks: boolean;
	bEnableNavigationSystem: boolean;
	bEnableAISystem: boolean;
	bEnableWorldComposition: boolean;
	bUseClientSideLevelStreamingVolumes: boolean;
	bEnableWorldOriginRebasing: boolean;
	bWorldGravitySet: boolean;
	bGlobalGravitySet: boolean;
	bMinimizeBSPSections: boolean;
	bForceNoPrecomputedLighting: boolean;
	bHighPriorityLoading: boolean;
	bHighPriorityLoadingLocal: boolean;
	bOverrideDefaultBroadphaseSettings: boolean;
	bGenerateSingleClusterForLevel: boolean;
	bIncludeGridSizeInNameForFoliageActors: boolean;
	bIncludeGridSizeInNameForPartitionedActors: boolean;
	AISystemClass: Class;
	LevelInstancePivotOffset: Vector;
	NavigationSystemConfig: NavigationSystemConfig;
	NavigationSystemConfigOverride: NavigationSystemConfig;
	WorldPartition: WorldPartition;
	InstancedFoliageGridSize: number;
	LandscapeSplineMeshesGridSize: number;
	NavigationDataChunkGridSize: number;
	NavigationDataBuilderLoadingCellSize: number;
	DefaultPlacementGridSize: number;
	BaseNavmeshDataLayers: DataLayerAsset[];
	WorldToMeters: number;
	KillZ: number;
	KillZDamageType: UnrealEngineClass;
	WorldGravityZ: number;
	GlobalGravityZ: number;
	DefaultPhysicsVolumeClass: UnrealEngineClass;
	PhysicsCollisionHandlerClass: UnrealEngineClass;
	DefaultGameMode: UnrealEngineClass;
	GameNetworkManagerClass: UnrealEngineClass;
	PackedLightAndShadowMapTextureSize: number;
	DefaultColorScale: Vector;
	DefaultMaxDistanceFieldOcclusionDistance: number;
	GlobalDistanceFieldViewDistance: number;
	DynamicIndirectShadowsSelfShadowingIntensity: number;
	LightmassSettings: LightmassWorldInfoSettings;
	DefaultReverbSettings: ReverbSettings;
	DefaultAmbientZoneSettings: InteriorSettings;
	DefaultBaseSoundMix: SoundMix;
	HLODSetupAsset: Class;
	OverrideBaseMaterial: MaterialInterface;
	HierarchicalLODSetup: HierarchicalSimplification[];
	NumHLODLevels: number;
	HLODBakingTransform: Transform;
	Bookmarks: BookMark;
	TimeDilation: number;
	CinematicTimeDilation: number;
	DemoPlayTimeDilation: number;
	MinGlobalTimeDilation: number;
	MaxGlobalTimeDilation: number;
	MinUndilatedFrameTime: number;
	MaxUndilatedFrameTime: number;
	BroadphaseSettings: BroadphaseSettings;
	ReplicationViewers: NetViewer[];
	AssetUserData: AssetUserData[];
	PauserPlayerState: PlayerState;
	DefaultWorldPartitionSettings: WorldPartitionPerWorldSettings;
	MaxNumberOfBookmarks: number;
	DefaultBookmarkClass: UnrealEngineClass;
	BookmarkArray: BookmarkBase[];
	LastBookmarkClass: UnrealEngineClass;
	bEnableHierarchicalLODSystem: boolean;
	bEnableLargeWorlds: boolean;
	static GetDefaultObject(): WorldSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldSettings;
	OnRep_WorldGravityZ(): void;
	static C(Other: UObject | any): WorldSettings;
}

declare class ActorPlacementDataLayers { 
	DataLayerInstanceNames: string[];
	ContextId: number;
	clone() : ActorPlacementDataLayers;
	static C(Other: UObject | any): ActorPlacementDataLayers;
}

declare type EDataLayerState = 'Unloaded' | 'Loaded' | 'Activated' | 'EDataLayerState_MAX';
declare var EDataLayerState : { Unloaded:'Unloaded',Loaded:'Loaded',Activated:'Activated',EDataLayerState_MAX:'EDataLayerState_MAX', };
declare class ActorDataLayer { 
	Name: string;
	clone() : ActorDataLayer;
	static C(Other: UObject | any): ActorDataLayer;
}

declare class DataLayer extends UObject { 
	bIsInitiallyActive: boolean;
	bIsVisible: boolean;
	bIsInitiallyVisible: boolean;
	bIsInitiallyLoadedInEditor: boolean;
	bIsLoadedInEditor: boolean;
	bIsLoadedInEditorChangedByUserOperation: boolean;
	bIsLocked: boolean;
	DataLayerLabel: string;
	bIsRuntime: boolean;
	InitialRuntimeState: EDataLayerRuntimeState;
	DebugColor: Color;
	Parent: DataLayer;
	Children: DataLayer[];
	static Load(ResourceName: string): DataLayer;
	static Find(Outer: UObject, ResourceName: string): DataLayer;
	static GetDefaultObject(): DataLayer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DataLayer;
	IsVisible(): boolean;
	IsRuntime(): boolean;
	IsInitiallyVisible(): boolean;
	IsInitiallyActive(): boolean;
	IsEffectiveVisible(): boolean;
	IsDynamicallyLoaded(): boolean;
	GetInitialState(): EDataLayerState;
	GetInitialRuntimeState(): EDataLayerRuntimeState;
	GetDebugColor(): Color;
	GetDataLayerLabel(): string;
	Equals(ActorDataLayer: ActorDataLayer): boolean;
	static C(Other: UObject | any): DataLayer;
}

declare class WorldDataLayers extends Info { 
	bAllowRuntimeDataLayerEditing: boolean;
	CurrentDataLayers: ActorPlacementDataLayers;
	DataLayerInstances: Set<DataLayerInstance>;
	DeprecatedDataLayerNameToDataLayerInstance: Map<string, DataLayerInstance>;
	WorldDataLayers: Set<DataLayer>;
	RepActiveDataLayerNames: string[];
	RepLoadedDataLayerNames: string[];
	RepEffectiveActiveDataLayerNames: string[];
	RepEffectiveLoadedDataLayerNames: string[];
	static GetDefaultObject(): WorldDataLayers;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldDataLayers;
	OnRep_LoadedDataLayerNames(): void;
	OnRep_EffectiveLoadedDataLayerNames(): void;
	OnRep_EffectiveActiveDataLayerNames(): void;
	OnRep_ActiveDataLayerNames(): void;
	OnDataLayerRuntimeStateChanged(InDataLayer: DataLayerInstance,InState: EDataLayerRuntimeState): void;
	static C(Other: UObject | any): WorldDataLayers;
}

declare class WorldPartitionRuntimeCellDebugInfo { 
	Name: string;
	GridName: string;
	CoordX: number;
	CoordY: number;
	CoordZ: number;
	clone() : WorldPartitionRuntimeCellDebugInfo;
	static C(Other: UObject | any): WorldPartitionRuntimeCellDebugInfo;
}

declare class WorldPartitionRuntimeCell extends UObject { 
	bIsAlwaysLoaded: boolean;
	DataLayers: string[];
	ContentBounds: Box;
	DebugInfo: WorldPartitionRuntimeCellDebugInfo;
	Priority: number;
	bClientOnlyVisible: boolean;
	bIsHLOD: boolean;
	bBlockOnSlowLoading: boolean;
	ContentBundleID: Guid;
	static Load(ResourceName: string): WorldPartitionRuntimeCell;
	static Find(Outer: UObject, ResourceName: string): WorldPartitionRuntimeCell;
	static GetDefaultObject(): WorldPartitionRuntimeCell;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldPartitionRuntimeCell;
	static C(Other: UObject | any): WorldPartitionRuntimeCell;
}

declare class ReplicatedStaticActorDestructionInfo { 
	ObjClass: UnrealEngineClass;
	clone() : ReplicatedStaticActorDestructionInfo;
	static C(Other: UObject | any): ReplicatedStaticActorDestructionInfo;
}

declare class LevelPartitionInterface extends Interface { 
	static Load(ResourceName: string): LevelPartitionInterface;
	static Find(Outer: UObject, ResourceName: string): LevelPartitionInterface;
	static GetDefaultObject(): LevelPartitionInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelPartitionInterface;
	static C(Other: UObject | any): LevelPartitionInterface;
}

declare class ActorFolder extends UObject { 
	ParentFolderGuid: Guid;
	FolderGuid: Guid;
	FolderLabel: string;
	bFolderInitiallyExpanded: boolean;
	bIsDeleted: boolean;
	static Load(ResourceName: string): ActorFolder;
	static Find(Outer: UObject, ResourceName: string): ActorFolder;
	static GetDefaultObject(): ActorFolder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ActorFolder;
	static C(Other: UObject | any): ActorFolder;
}

declare class ActorFolderSet { 
	ActorFolders: Set<ActorFolder>;
	clone() : ActorFolderSet;
	static C(Other: UObject | any): ActorFolderSet;
}

declare class Level extends UObject { 
	ActorsModifiedForPIE: Map<string, Actor>;
	bUseExternalActors: boolean;
	OwningWorld: World;
	Model: Model;
	ModelComponents: ModelComponent[];
	ActorCluster: LevelActorContainer;
	LevelScriptBlueprint: LevelScriptBlueprint;
	TextureStreamingResourceGuids: Guid[];
	NumTextureStreamingUnbuiltComponents: number;
	NumTextureStreamingDirtyResources: number;
	LevelScriptActor: LevelScriptActor;
	NavListStart: NavigationObjectBase;
	NavListEnd: NavigationObjectBase;
	NavDataChunks: NavigationDataChunk[];
	LightmapTotalSize: number;
	ShadowmapTotalSize: number;
	StaticNavigableGeometry: Vector[];
	StreamingTextureGuids: Guid[];
	StreamingTextures: string[];
	PackedTextureStreamingQualityLevelFeatureLevel: number;
	LevelBuildDataId: Guid;
	MapBuildData: MapBuildDataRegistry;
	LightBuildLevelOffset: IntVector;
	bIsLightingScenario: boolean;
	bTextureStreamingRotationChanged: boolean;
	bStaticComponentsRegisteredInStreamingManager: boolean;
	bIsVisible: boolean;
	bLocked: boolean;
	bIsPartitioned: boolean;
	LevelSimplification: LevelSimplificationDetails;
	LevelColor: LinearColor;
	bPromptWhenAddingToLevelBeforeCheckout: boolean;
	bPromptWhenAddingToLevelOutsideBounds: boolean;
	ActorPackagingScheme: EActorPackagingScheme;
	WorldSettings: WorldSettings;
	WorldDataLayers: WorldDataLayers;
	WorldPartitionRuntimeCell: WorldPartitionRuntimeCell;
	AssetUserData: AssetUserData[];
	DestroyedReplicatedStaticActors: ReplicatedStaticActorDestructionInfo[];
	LevelPartition: LevelPartitionInterface;
	OwnerLevelPartition: UObject;
	bUseActorFolders: boolean;
	ActorFolders: Map<Guid, ActorFolder>;
	FolderLabelToActorFolders: Map<string, ActorFolderSet>;
	LoadedExternalActorFolders: ActorFolder[];
	static Load(ResourceName: string): Level;
	static Find(Outer: UObject, ResourceName: string): Level;
	static GetDefaultObject(): Level;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Level;
	static C(Other: UObject | any): Level;
	UpdateModelComponents(): void;
	static UpdateModelComponents(Level: Level): void;
}

declare class LineBatchComponent extends PrimitiveComponent { 
	static Load(ResourceName: string): LineBatchComponent;
	static Find(Outer: UObject, ResourceName: string): LineBatchComponent;
	static GetDefaultObject(): LineBatchComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LineBatchComponent;
	static C(Other: UObject | any): LineBatchComponent;
}

declare type EStreamingVolumeUsage = 'SVB_Loading' | 'SVB_LoadingAndVisibility' | 'SVB_VisibilityBlockingOnLoad' | 'SVB_BlockingOnLoad' | 'SVB_LoadingNotVisible' | 'SVB_MAX';
declare var EStreamingVolumeUsage : { SVB_Loading:'SVB_Loading',SVB_LoadingAndVisibility:'SVB_LoadingAndVisibility',SVB_VisibilityBlockingOnLoad:'SVB_VisibilityBlockingOnLoad',SVB_BlockingOnLoad:'SVB_BlockingOnLoad',SVB_LoadingNotVisible:'SVB_LoadingNotVisible',SVB_MAX:'SVB_MAX', };
declare class LevelStreamingVolume extends Volume { 
	StreamingLevelNames: string[];
	bEditorPreVisOnly: boolean;
	bDisabled: boolean;
	StreamingUsage: EStreamingVolumeUsage;
	static GetDefaultObject(): LevelStreamingVolume;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelStreamingVolume;
	static C(Other: UObject | any): LevelStreamingVolume;
}

declare class LevelStreaming extends UObject { 
	PackageName: string;
	WorldAsset: World;
	StreamingPriority: number;
	PackageNameToLoad: string;
	LODPackageNames: string[];
	LevelTransform: Transform;
	bClientOnlyVisible: boolean;
	LevelLODIndex: number;
	bShouldBeVisibleInEditor: boolean;
	bShouldBeVisible: boolean;
	bShouldBeLoaded: boolean;
	bLocked: boolean;
	bIsStatic: boolean;
	bShouldBlockOnLoad: boolean;
	bShouldBlockOnUnload: boolean;
	bDisableDistanceStreaming: boolean;
	bDrawOnLevelStatusMap: boolean;
	DrawColor: Color;
	LevelColor: LinearColor;
	EditorStreamingVolumes: LevelStreamingVolume[];
	MinTimeBetweenVolumeUnloadRequests: number;
	Keywords: string[];
	OnLevelLoaded: UnrealEngineMulticastDelegate<() => void>;
	OnLevelUnloaded: UnrealEngineMulticastDelegate<() => void>;
	OnLevelShown: UnrealEngineMulticastDelegate<() => void>;
	OnLevelHidden: UnrealEngineMulticastDelegate<() => void>;
	LoadedLevel: Level;
	PendingUnloadLevel: Level;
	FolderPath: string;
	static Load(ResourceName: string): LevelStreaming;
	static Find(Outer: UObject, ResourceName: string): LevelStreaming;
	static GetDefaultObject(): LevelStreaming;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelStreaming;
	ShouldBeLoaded(): boolean;
	SetShouldBeVisible(bInShouldBeVisible: boolean): void;
	SetShouldBeLoaded(bInShouldBeLoaded: boolean): void;
	SetPriority(NewPriority: number): void;
	SetLevelLODIndex(LODIndex: number): void;
	SetIsRequestingUnloadAndRemoval(bInIsRequestingUnloadAndRemoval: boolean): void;
	IsStreamingStatePending(): boolean;
	IsLevelVisible(): boolean;
	IsLevelLoaded(): boolean;
	GetWorldAssetPackageFName(): string;
	GetLoadedLevel(): Level;
	GetLevelScriptActor(): LevelScriptActor;
	GetIsRequestingUnloadAndRemoval(): boolean;
	CreateInstance(UniqueInstanceName: string): LevelStreaming;
	static C(Other: UObject | any): LevelStreaming;
}

declare class StreamingLevelsToConsider { 
	StreamingLevels: LevelStreaming[];
	clone() : StreamingLevelsToConsider;
	static C(Other: UObject | any): StreamingLevelsToConsider;
}

declare class ServerStreamingLevelsVisibility extends Actor { 
	static GetDefaultObject(): ServerStreamingLevelsVisibility;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ServerStreamingLevelsVisibility;
	static C(Other: UObject | any): ServerStreamingLevelsVisibility;
}

declare class RollbackNetStartupActorInfo { 
	Archetype: UObject;
	ObjReferences: UObject[];
	clone() : RollbackNetStartupActorInfo;
	static C(Other: UObject | any): RollbackNetStartupActorInfo;
}

declare class MulticastRecordOptions { 
	FuncPathName: string;
	bServerSkip: boolean;
	bClientSkip: boolean;
	clone() : MulticastRecordOptions;
	static C(Other: UObject | any): MulticastRecordOptions;
}

declare class DemoNetDriver extends NetDriver { 
	RollbackNetStartupActors: Map<string, RollbackNetStartupActorInfo>;
	CheckpointSaveMaxMSPerFrame: number;
	MulticastRecordOptions: MulticastRecordOptions[];
	SpectatorControllers: PlayerController[];
	static Load(ResourceName: string): DemoNetDriver;
	static Find(Outer: UObject, ResourceName: string): DemoNetDriver;
	static GetDefaultObject(): DemoNetDriver;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DemoNetDriver;
	static C(Other: UObject | any): DemoNetDriver;
}

declare class ParticleEventManager extends Actor { 
	static GetDefaultObject(): ParticleEventManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ParticleEventManager;
	static C(Other: UObject | any): ParticleEventManager;
}

declare class NavigationSystemBase extends UObject { 
	static Load(ResourceName: string): NavigationSystemBase;
	static Find(Outer: UObject, ResourceName: string): NavigationSystemBase;
	static GetDefaultObject(): NavigationSystemBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationSystemBase;
	static C(Other: UObject | any): NavigationSystemBase;
}

declare class AISystemBase extends UObject { 
	AISystemClassName: SoftClassPath;
	AISystemModuleName: string;
	bInstantiateAISystemOnClient: boolean;
	static Load(ResourceName: string): AISystemBase;
	static Find(Outer: UObject, ResourceName: string): AISystemBase;
	static GetDefaultObject(): AISystemBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISystemBase;
	static C(Other: UObject | any): AISystemBase;
}

declare class AvoidanceManager extends UObject { 
	DefaultTimeToLive: number;
	LockTimeAfterAvoid: number;
	LockTimeAfterClean: number;
	DeltaTimeToPredict: number;
	ArtificialRadiusExpansion: number;
	TestHeightDifference: number;
	HeightCheckMargin: number;
	static Load(ResourceName: string): AvoidanceManager;
	static Find(Outer: UObject, ResourceName: string): AvoidanceManager;
	static GetDefaultObject(): AvoidanceManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AvoidanceManager;
	RegisterMovementComponent(MovementComp: MovementComponent,AvoidanceWeight: number): boolean;
	GetObjectCount(): number;
	GetNewAvoidanceUID(): number;
	GetAvoidanceVelocityForComponent(MovementComp: MovementComponent): Vector;
	static C(Other: UObject | any): AvoidanceManager;
}

declare class LevelCollection { 
	GameState: GameStateBase;
	NetDriver: NetDriver;
	DemoNetDriver: DemoNetDriver;
	PersistentLevel: Level;
	Levels: Set<Level>;
	clone() : LevelCollection;
	static C(Other: UObject | any): LevelCollection;
}

declare class CollectionParameterBase { 
	ParameterName: string;
	ID: Guid;
	clone() : CollectionParameterBase;
	static C(Other: UObject | any): CollectionParameterBase;
}

declare class CollectionScalarParameter extends CollectionParameterBase { 
	DefaultValue: number;
	clone() : CollectionScalarParameter;
	static C(Other: UObject | any): CollectionScalarParameter;
}

declare class CollectionVectorParameter extends CollectionParameterBase { 
	DefaultValue: LinearColor;
	clone() : CollectionVectorParameter;
	static C(Other: UObject | any): CollectionVectorParameter;
}

declare class MaterialParameterCollection extends UObject { 
	StateId: Guid;
	ScalarParameters: CollectionScalarParameter[];
	VectorParameters: CollectionVectorParameter[];
	static Load(ResourceName: string): MaterialParameterCollection;
	static Find(Outer: UObject, ResourceName: string): MaterialParameterCollection;
	static GetDefaultObject(): MaterialParameterCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialParameterCollection;
	GetVectorParameterNames(): string[];
	GetVectorParameterDefaultValue(ParameterName: string,bParameterFound?: boolean): {bParameterFound: boolean, $: LinearColor};
	GetScalarParameterNames(): string[];
	GetScalarParameterDefaultValue(ParameterName: string,bParameterFound?: boolean): {bParameterFound: boolean, $: number};
	static C(Other: UObject | any): MaterialParameterCollection;
}

declare class MaterialParameterCollectionInstance extends UObject { 
	Collection: MaterialParameterCollection;
	static Load(ResourceName: string): MaterialParameterCollectionInstance;
	static Find(Outer: UObject, ResourceName: string): MaterialParameterCollectionInstance;
	static GetDefaultObject(): MaterialParameterCollectionInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MaterialParameterCollectionInstance;
	static C(Other: UObject | any): MaterialParameterCollectionInstance;
}

declare class LevelViewportInfo { 
	CamPosition: Vector;
	CamRotation: Rotator;
	CamOrthoZoom: number;
	CamUpdated: boolean;
	clone() : LevelViewportInfo;
	static C(Other: UObject | any): LevelViewportInfo;
}

declare class PhysicsFieldComponent extends SceneComponent { 
	static Load(ResourceName: string): PhysicsFieldComponent;
	static Find(Outer: UObject, ResourceName: string): PhysicsFieldComponent;
	static GetDefaultObject(): PhysicsFieldComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PhysicsFieldComponent;
	static C(Other: UObject | any): PhysicsFieldComponent;
}

declare class WorldComposition extends UObject { 
	TilesStreaming: LevelStreaming[];
	TilesStreamingTimeThreshold: number;
	bLoadAllTilesDuringCinematic: boolean;
	bRebaseOriginIn3DSpace: boolean;
	bLockTilesLocation: boolean;
	RebaseOriginDistance: number;
	static Load(ResourceName: string): WorldComposition;
	static Find(Outer: UObject, ResourceName: string): WorldComposition;
	static GetDefaultObject(): WorldComposition;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): WorldComposition;
	static C(Other: UObject | any): WorldComposition;
}

declare class RuntimeHashExternalStreamingObjectBase extends UObject { 
	OwningWorld: World;
	OuterWorld: World;
	static Load(ResourceName: string): RuntimeHashExternalStreamingObjectBase;
	static Find(Outer: UObject, ResourceName: string): RuntimeHashExternalStreamingObjectBase;
	static GetDefaultObject(): RuntimeHashExternalStreamingObjectBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RuntimeHashExternalStreamingObjectBase;
	static C(Other: UObject | any): RuntimeHashExternalStreamingObjectBase;
}

declare class ContentBundleDuplicateForPIEHelper extends UObject { 
	StreamingObjects: Map<Guid, RuntimeHashExternalStreamingObjectBase>;
	static Load(ResourceName: string): ContentBundleDuplicateForPIEHelper;
	static Find(Outer: UObject, ResourceName: string): ContentBundleDuplicateForPIEHelper;
	static GetDefaultObject(): ContentBundleDuplicateForPIEHelper;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ContentBundleDuplicateForPIEHelper;
	static C(Other: UObject | any): ContentBundleDuplicateForPIEHelper;
}

declare class ContentBundleManager extends UObject { 
	PIEDuplicateHelper: ContentBundleDuplicateForPIEHelper;
	static Load(ResourceName: string): ContentBundleManager;
	static Find(Outer: UObject, ResourceName: string): ContentBundleManager;
	static GetDefaultObject(): ContentBundleManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ContentBundleManager;
	static C(Other: UObject | any): ContentBundleManager;
}

declare class PSCPoolElem { 
	PSC: ParticleSystemComponent;
	clone() : PSCPoolElem;
	static C(Other: UObject | any): PSCPoolElem;
}

declare class PSCPool { 
	FreeElements: PSCPoolElem[];
	clone() : PSCPool;
	static C(Other: UObject | any): PSCPool;
}

declare class WorldPSCPool { 
	WorldParticleSystemPools: Map<ParticleSystem, PSCPool>;
	clone() : WorldPSCPool;
	static C(Other: UObject | any): WorldPSCPool;
}

declare class ConstraintTickFunction extends TickFunction { 
	clone() : ConstraintTickFunction;
	static C(Other: UObject | any): ConstraintTickFunction;
}

declare class TickableConstraint extends UObject { 
	ConstraintTick: ConstraintTickFunction;
	Active: boolean;
	static Load(ResourceName: string): TickableConstraint;
	static Find(Outer: UObject, ResourceName: string): TickableConstraint;
	static GetDefaultObject(): TickableConstraint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TickableConstraint;
	static C(Other: UObject | any): TickableConstraint;
}

declare class LevelSequenceObjectReferenceMap { 
	clone() : LevelSequenceObjectReferenceMap;
	static C(Other: UObject | any): LevelSequenceObjectReferenceMap;
}

declare class LevelSequenceBindingReference { 
	PackageName: string;
	ExternalObjectPath: SoftObjectPath;
	ObjectPath: string;
	clone() : LevelSequenceBindingReference;
	static C(Other: UObject | any): LevelSequenceBindingReference;
}

declare class LevelSequenceBindingReferenceArray { 
	References: LevelSequenceBindingReference[];
	clone() : LevelSequenceBindingReferenceArray;
	static C(Other: UObject | any): LevelSequenceBindingReferenceArray;
}

declare class LevelSequenceBindingReferences { 
	BindingIdToReferences: Map<Guid, LevelSequenceBindingReferenceArray>;
	AnimSequenceInstances: Set<Guid>;
	PostProcessInstances: Set<Guid>;
	clone() : LevelSequenceBindingReferences;
	static C(Other: UObject | any): LevelSequenceBindingReferences;
}

declare class LevelSequenceObject { 
	ObjectOrOwner: UObject;
	ComponentName: string;
	CachedComponent: UObject;
	clone() : LevelSequenceObject;
	static C(Other: UObject | any): LevelSequenceObject;
}

declare type ERigExecutionType = 'Runtime' | 'Editing' | 'Max' | 'ERigExecutionType_MAX';
declare var ERigExecutionType : { Runtime:'Runtime',Editing:'Editing',Max:'Max',ERigExecutionType_MAX:'ERigExecutionType_MAX', };
declare class RigHierarchySettings { 
	ProceduralElementLimit: number;
	clone() : RigHierarchySettings;
	static C(Other: UObject | any): RigHierarchySettings;
}

declare class RigVMRuntimeSettings { 
	MaximumArraySize: number;
	bEnableProfiling: boolean;
	clone() : RigVMRuntimeSettings;
	static C(Other: UObject | any): RigVMRuntimeSettings;
}

declare type ERigElementType = 'None' | 'Bone' | 'Null' | 'Space' | 'Control' | 'Curve' | 'RigidBody' | 'Reference' | 'Last' | 'All' | 'ToResetAfterConstructionEvent' | 'ERigElementType_MAX';
declare var ERigElementType : { None:'None',Bone:'Bone',Null:'Null',Space:'Space',Control:'Control',Curve:'Curve',RigidBody:'RigidBody',Reference:'Reference',Last:'Last',All:'All',ToResetAfterConstructionEvent:'ToResetAfterConstructionEvent',ERigElementType_MAX:'ERigElementType_MAX', };
declare class RigElementKey { 
	Type: ERigElementType;
	Name: string;
	clone() : RigElementKey;
	static C(Other: UObject | any): RigElementKey;
	static GetDefaultParentKey(): RigElementKey;
	static GetWorldSpaceReferenceKey(): RigElementKey;
}

declare class RigControlElementCustomization { 
	AvailableSpaces: RigElementKey[];
	RemovedSpaces: RigElementKey[];
	clone() : RigControlElementCustomization;
	static C(Other: UObject | any): RigControlElementCustomization;
}

declare class RigVMMemoryStorage extends UObject { 
	static Load(ResourceName: string): RigVMMemoryStorage;
	static Find(Outer: UObject, ResourceName: string): RigVMMemoryStorage;
	static GetDefaultObject(): RigVMMemoryStorage;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigVMMemoryStorage;
	static C(Other: UObject | any): RigVMMemoryStorage;
}

declare class RigVMByteCodeEntry { 
	Name: string;
	InstructionIndex: number;
	clone() : RigVMByteCodeEntry;
	static C(Other: UObject | any): RigVMByteCodeEntry;
}

declare class RigVMByteCode { 
	ByteCode: number[];
	NumInstructions: number;
	Entries: RigVMByteCodeEntry[];
	clone() : RigVMByteCode;
	static C(Other: UObject | any): RigVMByteCode;
}

declare type ERigVMOpCode = 'Execute_0_Operands' | 'Execute_1_Operands' | 'Execute_2_Operands' | 'Execute_3_Operands' | 'Execute_4_Operands' | 'Execute_5_Operands' | 'Execute_6_Operands' | 'Execute_7_Operands' | 'Execute_8_Operands' | 'Execute_9_Operands' | 'Execute_10_Operands' | 'Execute_11_Operands' | 'Execute_12_Operands' | 'Execute_13_Operands' | 'Execute_14_Operands' | 'Execute_15_Operands' | 'Execute_16_Operands' | 'Execute_17_Operands' | 'Execute_18_Operands' | 'Execute_19_Operands' | 'Execute_20_Operands' | 'Execute_21_Operands' | 'Execute_22_Operands' | 'Execute_23_Operands' | 'Execute_24_Operands' | 'Execute_25_Operands' | 'Execute_26_Operands' | 'Execute_27_Operands' | 'Execute_28_Operands' | 'Execute_29_Operands' | 'Execute_30_Operands' | 'Execute_31_Operands' | 'Execute_32_Operands' | 'Execute_33_Operands' | 'Execute_34_Operands' | 'Execute_35_Operands' | 'Execute_36_Operands' | 'Execute_37_Operands' | 'Execute_38_Operands' | 'Execute_39_Operands' | 'Execute_40_Operands' | 'Execute_41_Operands' | 'Execute_42_Operands' | 'Execute_43_Operands' | 'Execute_44_Operands' | 'Execute_45_Operands' | 'Execute_46_Operands' | 'Execute_47_Operands' | 'Execute_48_Operands' | 'Execute_49_Operands' | 'Execute_50_Operands' | 'Execute_51_Operands' | 'Execute_52_Operands' | 'Execute_53_Operands' | 'Execute_54_Operands' | 'Execute_55_Operands' | 'Execute_56_Operands' | 'Execute_57_Operands' | 'Execute_58_Operands' | 'Execute_59_Operands' | 'Execute_60_Operands' | 'Execute_61_Operands' | 'Execute_62_Operands' | 'Execute_63_Operands' | 'Execute_64_Operands' | 'Zero' | 'BoolFalse' | 'BoolTrue' | 'Copy' | 'Increment' | 'Decrement' | 'Equals' | 'NotEquals' | 'JumpAbsolute' | 'JumpForward' | 'JumpBackward' | 'JumpAbsoluteIf' | 'JumpForwardIf' | 'JumpBackwardIf' | 'ChangeType' | 'Exit' | 'BeginBlock' | 'EndBlock' | 'ArrayReset' | 'ArrayGetNum' | 'ArraySetNum' | 'ArrayGetAtIndex' | 'ArraySetAtIndex' | 'ArrayAdd' | 'ArrayInsert' | 'ArrayRemove' | 'ArrayFind' | 'ArrayAppend' | 'ArrayClone' | 'ArrayIterator' | 'ArrayUnion' | 'ArrayDifference' | 'ArrayIntersection' | 'ArrayReverse' | 'InvokeEntry' | 'Invalid' | 'FirstArrayOpCode' | 'LastArrayOpCode' | 'ERigVMOpCode_MAX';
declare var ERigVMOpCode : { Execute_0_Operands:'Execute_0_Operands',Execute_1_Operands:'Execute_1_Operands',Execute_2_Operands:'Execute_2_Operands',Execute_3_Operands:'Execute_3_Operands',Execute_4_Operands:'Execute_4_Operands',Execute_5_Operands:'Execute_5_Operands',Execute_6_Operands:'Execute_6_Operands',Execute_7_Operands:'Execute_7_Operands',Execute_8_Operands:'Execute_8_Operands',Execute_9_Operands:'Execute_9_Operands',Execute_10_Operands:'Execute_10_Operands',Execute_11_Operands:'Execute_11_Operands',Execute_12_Operands:'Execute_12_Operands',Execute_13_Operands:'Execute_13_Operands',Execute_14_Operands:'Execute_14_Operands',Execute_15_Operands:'Execute_15_Operands',Execute_16_Operands:'Execute_16_Operands',Execute_17_Operands:'Execute_17_Operands',Execute_18_Operands:'Execute_18_Operands',Execute_19_Operands:'Execute_19_Operands',Execute_20_Operands:'Execute_20_Operands',Execute_21_Operands:'Execute_21_Operands',Execute_22_Operands:'Execute_22_Operands',Execute_23_Operands:'Execute_23_Operands',Execute_24_Operands:'Execute_24_Operands',Execute_25_Operands:'Execute_25_Operands',Execute_26_Operands:'Execute_26_Operands',Execute_27_Operands:'Execute_27_Operands',Execute_28_Operands:'Execute_28_Operands',Execute_29_Operands:'Execute_29_Operands',Execute_30_Operands:'Execute_30_Operands',Execute_31_Operands:'Execute_31_Operands',Execute_32_Operands:'Execute_32_Operands',Execute_33_Operands:'Execute_33_Operands',Execute_34_Operands:'Execute_34_Operands',Execute_35_Operands:'Execute_35_Operands',Execute_36_Operands:'Execute_36_Operands',Execute_37_Operands:'Execute_37_Operands',Execute_38_Operands:'Execute_38_Operands',Execute_39_Operands:'Execute_39_Operands',Execute_40_Operands:'Execute_40_Operands',Execute_41_Operands:'Execute_41_Operands',Execute_42_Operands:'Execute_42_Operands',Execute_43_Operands:'Execute_43_Operands',Execute_44_Operands:'Execute_44_Operands',Execute_45_Operands:'Execute_45_Operands',Execute_46_Operands:'Execute_46_Operands',Execute_47_Operands:'Execute_47_Operands',Execute_48_Operands:'Execute_48_Operands',Execute_49_Operands:'Execute_49_Operands',Execute_50_Operands:'Execute_50_Operands',Execute_51_Operands:'Execute_51_Operands',Execute_52_Operands:'Execute_52_Operands',Execute_53_Operands:'Execute_53_Operands',Execute_54_Operands:'Execute_54_Operands',Execute_55_Operands:'Execute_55_Operands',Execute_56_Operands:'Execute_56_Operands',Execute_57_Operands:'Execute_57_Operands',Execute_58_Operands:'Execute_58_Operands',Execute_59_Operands:'Execute_59_Operands',Execute_60_Operands:'Execute_60_Operands',Execute_61_Operands:'Execute_61_Operands',Execute_62_Operands:'Execute_62_Operands',Execute_63_Operands:'Execute_63_Operands',Execute_64_Operands:'Execute_64_Operands',Zero:'Zero',BoolFalse:'BoolFalse',BoolTrue:'BoolTrue',Copy:'Copy',Increment:'Increment',Decrement:'Decrement',Equals:'Equals',NotEquals:'NotEquals',JumpAbsolute:'JumpAbsolute',JumpForward:'JumpForward',JumpBackward:'JumpBackward',JumpAbsoluteIf:'JumpAbsoluteIf',JumpForwardIf:'JumpForwardIf',JumpBackwardIf:'JumpBackwardIf',ChangeType:'ChangeType',Exit:'Exit',BeginBlock:'BeginBlock',EndBlock:'EndBlock',ArrayReset:'ArrayReset',ArrayGetNum:'ArrayGetNum',ArraySetNum:'ArraySetNum',ArrayGetAtIndex:'ArrayGetAtIndex',ArraySetAtIndex:'ArraySetAtIndex',ArrayAdd:'ArrayAdd',ArrayInsert:'ArrayInsert',ArrayRemove:'ArrayRemove',ArrayFind:'ArrayFind',ArrayAppend:'ArrayAppend',ArrayClone:'ArrayClone',ArrayIterator:'ArrayIterator',ArrayUnion:'ArrayUnion',ArrayDifference:'ArrayDifference',ArrayIntersection:'ArrayIntersection',ArrayReverse:'ArrayReverse',InvokeEntry:'InvokeEntry',Invalid:'Invalid',FirstArrayOpCode:'FirstArrayOpCode',LastArrayOpCode:'LastArrayOpCode',ERigVMOpCode_MAX:'ERigVMOpCode_MAX', };
declare class RigVMInstruction { 
	ByteCodeIndex: number;
	OpCode: ERigVMOpCode;
	OperandAlignment: number;
	clone() : RigVMInstruction;
	static C(Other: UObject | any): RigVMInstruction;
}

declare class RigVMInstructionArray { 
	Instructions: RigVMInstruction[];
	clone() : RigVMInstructionArray;
	static C(Other: UObject | any): RigVMInstructionArray;
}

declare class RigVMExtendedExecuteContext { 
	clone() : RigVMExtendedExecuteContext;
	static C(Other: UObject | any): RigVMExtendedExecuteContext;
}

declare type ERigVMParameterType = 'Input' | 'Output' | 'Invalid' | 'ERigVMParameterType_MAX';
declare var ERigVMParameterType : { Input:'Input',Output:'Output',Invalid:'Invalid',ERigVMParameterType_MAX:'ERigVMParameterType_MAX', };
declare class RigVMParameter { 
	Type: ERigVMParameterType;
	Name: string;
	RegisterIndex: number;
	CPPType: string;
	ScriptStruct: ScriptStruct;
	ScriptStructPath: string;
	clone() : RigVMParameter;
	static C(Other: UObject | any): RigVMParameter;
}

declare class RigVMMemoryStatistics { 
	RegisterCount: number;
	DataBytes: number;
	TotalBytes: number;
	clone() : RigVMMemoryStatistics;
	static C(Other: UObject | any): RigVMMemoryStatistics;
}

declare class RigVMByteCodeStatistics { 
	InstructionCount: number;
	DataBytes: number;
	clone() : RigVMByteCodeStatistics;
	static C(Other: UObject | any): RigVMByteCodeStatistics;
}

declare class RigVMStatistics { 
	BytesForCDO: number;
	BytesPerInstance: number;
	LiteralMemory: RigVMMemoryStatistics;
	WorkMemory: RigVMMemoryStatistics;
	DebugMemory: RigVMMemoryStatistics;
	BytesForCaching: number;
	ByteCode: RigVMByteCodeStatistics;
	clone() : RigVMStatistics;
	static C(Other: UObject | any): RigVMStatistics;
}

declare class RigVM extends UObject { 
	WorkMemoryStorageObject: RigVMMemoryStorage;
	LiteralMemoryStorageObject: RigVMMemoryStorage;
	DebugMemoryStorageObject: RigVMMemoryStorage;
	ByteCodeStorage: RigVMByteCode;
	Instructions: RigVMInstructionArray;
	Context: RigVMExtendedExecuteContext;
	NumExecutions: number;
	FunctionNamesStorage: string[];
	Parameters: RigVMParameter[];
	ParametersNameMap: Map<string, number>;
	DeferredVMToCopy: RigVM;
	static Load(ResourceName: string): RigVM;
	static Find(Outer: UObject, ResourceName: string): RigVM;
	static GetDefaultObject(): RigVM;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigVM;
	SetParameterValueVector2D(InParameterName: string,InValue: Vector2D,InArrayIndex: number): void;
	SetParameterValueVector(InParameterName: string,InValue: Vector,InArrayIndex: number): void;
	SetParameterValueTransform(InParameterName: string,InValue: Transform,InArrayIndex: number): void;
	SetParameterValueString(InParameterName: string,InValue: string,InArrayIndex: number): void;
	SetParameterValueQuat(InParameterName: string,InValue: Quat,InArrayIndex: number): void;
	SetParameterValueName(InParameterName: string,InValue: string,InArrayIndex: number): void;
	SetParameterValueInt(InParameterName: string,InValue: number,InArrayIndex: number): void;
	SetParameterValueFloat(InParameterName: string,InValue: number,InArrayIndex: number): void;
	SetParameterValueDouble(InParameterName: string,InValue: number,InArrayIndex: number): void;
	SetParameterValueBool(InParameterName: string,InValue: boolean,InArrayIndex: number): void;
	GetStatistics(): RigVMStatistics;
	GetRigVMFunctionName(InFunctionIndex: number): string;
	GetParameterValueVector2D(InParameterName: string,InArrayIndex: number): Vector2D;
	GetParameterValueVector(InParameterName: string,InArrayIndex: number): Vector;
	GetParameterValueTransform(InParameterName: string,InArrayIndex: number): Transform;
	GetParameterValueString(InParameterName: string,InArrayIndex: number): string;
	GetParameterValueQuat(InParameterName: string,InArrayIndex: number): Quat;
	GetParameterValueName(InParameterName: string,InArrayIndex: number): string;
	GetParameterValueInt(InParameterName: string,InArrayIndex: number): number;
	GetParameterValueFloat(InParameterName: string,InArrayIndex: number): number;
	GetParameterValueDouble(InParameterName: string,InArrayIndex: number): number;
	GetParameterValueBool(InParameterName: string,InArrayIndex: number): boolean;
	Execute(InEntryName: string): boolean;
	AddRigVMFunction(InRigVMStruct: ScriptStruct,InMethodName: string): number;
	static C(Other: UObject | any): RigVM;
}

declare type ERigControlAnimationType = 'AnimationControl' | 'AnimationChannel' | 'ProxyControl' | 'VisualCue' | 'ERigControlAnimationType_MAX';
declare var ERigControlAnimationType : { AnimationControl:'AnimationControl',AnimationChannel:'AnimationChannel',ProxyControl:'ProxyControl',VisualCue:'VisualCue',ERigControlAnimationType_MAX:'ERigControlAnimationType_MAX', };
declare type ERigControlType = 'Bool' | 'Float' | 'Integer' | 'Vector2D' | 'Position' | 'Scale' | 'Rotator' | 'Transform' | 'TransformNoScale' | 'EulerTransform' | 'ERigControlType_MAX';
declare var ERigControlType : { Bool:'Bool',Float:'Float',Integer:'Integer',Vector2D:'Vector2D',Position:'Position',Scale:'Scale',Rotator:'Rotator',Transform:'Transform',TransformNoScale:'TransformNoScale',EulerTransform:'EulerTransform',ERigControlType_MAX:'ERigControlType_MAX', };
declare type ERigControlAxis = 'X' | 'Y' | 'Z' | 'ERigControlAxis_MAX';
declare var ERigControlAxis : { X:'X',Y:'Y',Z:'Z',ERigControlAxis_MAX:'ERigControlAxis_MAX', };
declare class RigControlLimitEnabled { 
	bMinimum: boolean;
	bMaximum: boolean;
	clone() : RigControlLimitEnabled;
	static C(Other: UObject | any): RigControlLimitEnabled;
}

declare class RigControlValueStorage { 
	Float00: number;
	Float01: number;
	Float02: number;
	Float03: number;
	Float10: number;
	Float11: number;
	Float12: number;
	Float13: number;
	Float20: number;
	Float21: number;
	Float22: number;
	Float23: number;
	Float30: number;
	Float31: number;
	Float32: number;
	Float33: number;
	Float00_2: number;
	Float01_2: number;
	Float02_2: number;
	Float03_2: number;
	Float10_2: number;
	Float11_2: number;
	Float12_2: number;
	Float13_2: number;
	Float20_2: number;
	Float21_2: number;
	Float22_2: number;
	Float23_2: number;
	Float30_2: number;
	Float31_2: number;
	Float32_2: number;
	Float33_2: number;
	bValid: boolean;
	clone() : RigControlValueStorage;
	static C(Other: UObject | any): RigControlValueStorage;
}

declare class RigControlValue { 
	FloatStorage: RigControlValueStorage;
	Storage: Transform;
	clone() : RigControlValue;
	static C(Other: UObject | any): RigControlValue;
}

declare type ERigControlVisibility = 'UserDefined' | 'BasedOnSelection' | 'ERigControlVisibility_MAX';
declare var ERigControlVisibility : { UserDefined:'UserDefined',BasedOnSelection:'BasedOnSelection',ERigControlVisibility_MAX:'ERigControlVisibility_MAX', };
declare class Enum extends Field { 
	static Load(ResourceName: string): Enum;
	static Find(Outer: UObject, ResourceName: string): Enum;
	static GetDefaultObject(): Enum;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Enum;
	static C(Other: UObject | any): Enum;
	GetEnumeratorName(EnumeratorValue: number): string;
	GetEnumeratorUserFriendlyName(EnumeratorValue: number): string;
	GetEnumeratorValueFromIndex(EnumeratorIndex: number): number;
	GetValidValue(EnumeratorValue: number): number;
	static GetEnumeratorName(Enum: Enum,EnumeratorValue: number): string;
	static GetEnumeratorUserFriendlyName(Enum: Enum,EnumeratorValue: number): string;
	static GetEnumeratorValueFromIndex(Enum: Enum,EnumeratorIndex: number): number;
	static GetValidValue(Enum: Enum,EnumeratorValue: number): number;
}

declare class RigControlSettings { 
	AnimationType: ERigControlAnimationType;
	ControlType: ERigControlType;
	DisplayName: string;
	PrimaryAxis: ERigControlAxis;
	bIsCurve: boolean;
	LimitEnabled: RigControlLimitEnabled[];
	bDrawLimits: boolean;
	MinimumValue: RigControlValue;
	MaximumValue: RigControlValue;
	bShapeVisible: boolean;
	ShapeVisibility: ERigControlVisibility;
	ShapeName: string;
	ShapeColor: LinearColor;
	bIsTransientControl: boolean;
	ControlEnum: Enum;
	Customization: RigControlElementCustomization;
	DrivenControls: RigElementKey[];
	bGroupWithParentControl: boolean;
	bAnimatable: boolean;
	bShapeEnabled: boolean;
	clone() : RigControlSettings;
	static C(Other: UObject | any): RigControlSettings;
}

declare class RigMirrorSettings { 
	MirrorAxis: EAxis;
	AxisToFlip: EAxis;
	SearchString: string;
	ReplaceString: string;
	clone() : RigMirrorSettings;
	static C(Other: UObject | any): RigMirrorSettings;
}

declare class RigRigidBodySettings { 
	Mass: number;
	clone() : RigRigidBodySettings;
	static C(Other: UObject | any): RigRigidBodySettings;
}

declare type ERigBoneType = 'Imported' | 'User' | 'ERigBoneType_MAX';
declare var ERigBoneType : { Imported:'Imported',User:'User',ERigBoneType_MAX:'ERigBoneType_MAX', };
declare class RigHierarchyController extends UObject { 
	bReportWarningsAndErrors: boolean;
	Hierarchy: RigHierarchy;
	static Load(ResourceName: string): RigHierarchyController;
	static Find(Outer: UObject, ResourceName: string): RigHierarchyController;
	static GetDefaultObject(): RigHierarchyController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigHierarchyController;
	SetSelection(InKeys: RigElementKey[],bPrintPythonCommand: boolean): boolean;
	SetParent(InChild: RigElementKey,InParent: RigElementKey,bMaintainGlobalTransform: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): boolean;
	SetHierarchy(InHierarchy: RigHierarchy): void;
	SetDisplayName(InControl: RigElementKey,InDisplayName: string,bRenameElement: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): string;
	SetControlSettings(InKey: RigElementKey,InSettings: RigControlSettings,bSetupUndo: boolean): boolean;
	SelectElement(InKey: RigElementKey,bSelect: boolean,bClearSelection: boolean): boolean;
	RenameElement(InElement: RigElementKey,InName: string,bSetupUndo: boolean,bPrintPythonCommand: boolean,bClearSelection: boolean): RigElementKey;
	RemoveParent(InChild: RigElementKey,InParent: RigElementKey,bMaintainGlobalTransform: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): boolean;
	RemoveElement(InElement: RigElementKey,bSetupUndo: boolean,bPrintPythonCommand: boolean): boolean;
	RemoveAllParents(InChild: RigElementKey,bMaintainGlobalTransform: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): boolean;
	MirrorElements(InKeys: RigElementKey[],InSettings: RigMirrorSettings,bSelectNewElements: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): RigElementKey[];
	ImportFromText(InContent: string,bReplaceExistingElements: boolean,bSelectNewElements: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): RigElementKey[];
	ImportCurvesFromAsset(InAssetPath: string,InNameSpace: string,bSelectCurves: boolean,bSetupUndo: boolean): RigElementKey[];
	ImportCurves(InSkeleton: Skeleton,InNameSpace: string,bSelectCurves: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey[];
	ImportBonesFromAsset(InAssetPath: string,InNameSpace: string,bReplaceExistingBones: boolean,bRemoveObsoleteBones: boolean,bSelectBones: boolean,bSetupUndo: boolean): RigElementKey[];
	ImportBones(InSkeleton: Skeleton,InNameSpace: string,bReplaceExistingBones: boolean,bRemoveObsoleteBones: boolean,bSelectBones: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey[];
	GetHierarchy(): RigHierarchy;
	GetControlSettings(InKey: RigElementKey): RigControlSettings;
	GeneratePythonCommands(): string[];
	ExportToText(InKeys: RigElementKey[]): string;
	ExportSelectionToText(): string;
	DuplicateElements(InKeys: RigElementKey[],bSelectNewElements: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): RigElementKey[];
	DeselectElement(InKey: RigElementKey): boolean;
	ClearSelection(): boolean;
	AddRigidBody(InName: string,InParent: RigElementKey,InSettings: RigRigidBodySettings,InLocalTransform: Transform,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	AddParent(InChild: RigElementKey,InParent: RigElementKey,InWeight: number,bMaintainGlobalTransform: boolean,bSetupUndo: boolean): boolean;
	AddNull(InName: string,InParent: RigElementKey,InTransform: Transform,bTransformInGlobal: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	AddCurve(InName: string,InValue: number,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	AddControl_ForBlueprint(InName: string,InParent: RigElementKey,InSettings: RigControlSettings,InValue: RigControlValue,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	AddBone(InName: string,InParent: RigElementKey,InTransform: Transform,bTransformInGlobal: boolean,InBoneType: ERigBoneType,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	AddAnimationChannel_ForBlueprint(InName: string,InParentControl: RigElementKey,InSettings: RigControlSettings,bSetupUndo: boolean,bPrintPythonCommand: boolean): RigElementKey;
	static C(Other: UObject | any): RigHierarchyController;
}

declare class CachedRigElement { 
	Key: RigElementKey;
	Index: number;
	ContainerVersion: number;
	clone() : CachedRigElement;
	static C(Other: UObject | any): CachedRigElement;
}

declare class RigPoseElement { 
	Index: CachedRigElement;
	GlobalTransform: Transform;
	LocalTransform: Transform;
	CurveValue: number;
	clone() : RigPoseElement;
	static C(Other: UObject | any): RigPoseElement;
}

declare class RigPose { 
	Elements: RigPoseElement[];
	HierarchyTopologyVersion: number;
	PoseHash: number;
	clone() : RigPose;
	static C(Other: UObject | any): RigPose;
}

declare class RigElementWeight { 
	Location: number;
	Rotation: number;
	Scale: number;
	clone() : RigElementWeight;
	static C(Other: UObject | any): RigElementWeight;
}

declare type ERigControlValueType = 'Initial' | 'Current' | 'Minimum' | 'Maximum' | 'ERigControlValueType_MAX';
declare var ERigControlValueType : { Initial:'Initial',Current:'Current',Minimum:'Minimum',Maximum:'Maximum',ERigControlValueType_MAX:'ERigControlValueType_MAX', };
declare class TransformNoScale { 
	Location: Vector;
	Rotation: Quat;
	clone() : TransformNoScale;
	static C(Other: UObject | any): TransformNoScale;
}

declare class EulerTransform { 
	Location: Vector;
	Rotation: Rotator;
	Scale: Vector;
	clone() : EulerTransform;
	static C(Other: UObject | any): EulerTransform;
}

declare type ERigMetadataType = 'Bool' | 'BoolArray' | 'Float' | 'FloatArray' | 'Int32' | 'Int32Array' | 'Name' | 'NameArray' | 'Vector' | 'VectorArray' | 'Rotator' | 'RotatorArray' | 'Quat' | 'QuatArray' | 'Transform' | 'TransformArray' | 'LinearColor' | 'LinearColorArray' | 'RigElementKey' | 'RigElementKeyArray' | 'Invalid' | 'ERigMetadataType_MAX';
declare var ERigMetadataType : { Bool:'Bool',BoolArray:'BoolArray',Float:'Float',FloatArray:'FloatArray',Int32:'Int32',Int32Array:'Int32Array',Name:'Name',NameArray:'NameArray',Vector:'Vector',VectorArray:'VectorArray',Rotator:'Rotator',RotatorArray:'RotatorArray',Quat:'Quat',QuatArray:'QuatArray',Transform:'Transform',TransformArray:'TransformArray',LinearColor:'LinearColor',LinearColorArray:'LinearColorArray',RigElementKey:'RigElementKey',RigElementKeyArray:'RigElementKeyArray',Invalid:'Invalid',ERigMetadataType_MAX:'ERigMetadataType_MAX', };
declare class RigBaseElement { 
	Key: RigElementKey;
	NameString: string;
	Index: number;
	SubIndex: number;
	bSelected: boolean;
	CreatedAtInstructionIndex: number;
	clone() : RigBaseElement;
	static C(Other: UObject | any): RigBaseElement;
}

declare class RigComputedTransform { 
	Transform: Transform;
	clone() : RigComputedTransform;
	static C(Other: UObject | any): RigComputedTransform;
}

declare class RigLocalAndGlobalTransform { 
	Local: RigComputedTransform;
	Global: RigComputedTransform;
	clone() : RigLocalAndGlobalTransform;
	static C(Other: UObject | any): RigLocalAndGlobalTransform;
}

declare class RigCurrentAndInitialTransform { 
	Current: RigLocalAndGlobalTransform;
	Initial: RigLocalAndGlobalTransform;
	clone() : RigCurrentAndInitialTransform;
	static C(Other: UObject | any): RigCurrentAndInitialTransform;
}

declare class RigTransformElement extends RigBaseElement { 
	Pose: RigCurrentAndInitialTransform;
	clone() : RigTransformElement;
	static C(Other: UObject | any): RigTransformElement;
}

declare class RigMultiParentElement extends RigTransformElement { 
	clone() : RigMultiParentElement;
	static C(Other: UObject | any): RigMultiParentElement;
}

declare class RigNullElement extends RigMultiParentElement { 
	clone() : RigNullElement;
	static C(Other: UObject | any): RigNullElement;
}

declare type EEulerRotationOrder = 'XYZ' | 'XZY' | 'YXZ' | 'YZX' | 'ZXY' | 'ZYX' | 'EEulerRotationOrder_MAX';
declare var EEulerRotationOrder : { XYZ:'XYZ',XZY:'XZY',YXZ:'YXZ',YZX:'YZX',ZXY:'ZXY',ZYX:'ZYX',EEulerRotationOrder_MAX:'EEulerRotationOrder_MAX', };
declare class RigPreferredEulerAngles { 
	RotationOrder: EEulerRotationOrder;
	Current: Vector;
	Initial: Vector;
	clone() : RigPreferredEulerAngles;
	static C(Other: UObject | any): RigPreferredEulerAngles;
}

declare class RigControlElement extends RigMultiParentElement { 
	Settings: RigControlSettings;
	Offset: RigCurrentAndInitialTransform;
	Shape: RigCurrentAndInitialTransform;
	PreferredEulerAngles: RigPreferredEulerAngles;
	clone() : RigControlElement;
	static C(Other: UObject | any): RigControlElement;
}

declare class RigSingleParentElement extends RigTransformElement { 
	clone() : RigSingleParentElement;
	static C(Other: UObject | any): RigSingleParentElement;
}

declare class RigBoneElement extends RigSingleParentElement { 
	BoneType: ERigBoneType;
	clone() : RigBoneElement;
	static C(Other: UObject | any): RigBoneElement;
}

declare class RigHierarchy extends UObject { 
	TopologyVersion: number;
	MetadataVersion: number;
	MetadataTagVersion: number;
	bEnableDirtyPropagation: boolean;
	TransformStackIndex: number;
	HierarchyController: RigHierarchyController;
	PreviousNameMap: Map<RigElementKey, RigElementKey>;
	HierarchyForCacheValidation: RigHierarchy;
	static Load(ResourceName: string): RigHierarchy;
	static Find(Outer: UObject, ResourceName: string): RigHierarchy;
	static GetDefaultObject(): RigHierarchy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RigHierarchy;
	UnsetCurveValueByIndex(InElementIndex: number,bSetupUndo: boolean): void;
	UnsetCurveValue(InKey: RigElementKey,bSetupUndo: boolean): void;
	SwitchToWorldSpace(InChild: RigElementKey,bInitial: boolean,bAffectChildren: boolean): boolean;
	SwitchToParent(InChild: RigElementKey,InParent: RigElementKey,bInitial: boolean,bAffectChildren: boolean): boolean;
	SwitchToDefaultParent(InChild: RigElementKey,bInitial: boolean,bAffectChildren: boolean): boolean;
	SortKeys(InKeys: RigElementKey[]): RigElementKey[];
	SetVectorMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Vector): boolean;
	SetVectorArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Vector[]): boolean;
	SetTransformMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Transform): boolean;
	SetTransformArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Transform[]): boolean;
	SetTag(InItem: RigElementKey,InTag: string): boolean;
	SetRotatorMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Rotator): boolean;
	SetRotatorArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Rotator[]): boolean;
	SetRigElementKeyMetadata(InItem: RigElementKey,InMetadataName: string,InValue: RigElementKey): boolean;
	SetRigElementKeyArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: RigElementKey[]): boolean;
	SetQuatMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Quat): boolean;
	SetQuatArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: Quat[]): boolean;
	SetPose_ForBlueprint(InPose: RigPose): void;
	SetParentWeightArray(InChild: RigElementKey,InWeights: RigElementWeight[],bInitial: boolean,bAffectChildren: boolean): boolean;
	SetParentWeight(InChild: RigElementKey,InParent: RigElementKey,InWeight: RigElementWeight,bInitial: boolean,bAffectChildren: boolean): boolean;
	SetNameMetadata(InItem: RigElementKey,InMetadataName: string,InValue: string): boolean;
	SetNameArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: string[]): boolean;
	SetLocalTransformByIndex(InElementIndex: number,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetLocalTransform(InKey: RigElementKey,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetLinearColorMetadata(InItem: RigElementKey,InMetadataName: string,InValue: LinearColor): boolean;
	SetLinearColorArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: LinearColor[]): boolean;
	SetInt32Metadata(InItem: RigElementKey,InMetadataName: string,InValue: number): boolean;
	SetInt32ArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: number[]): boolean;
	SetGlobalTransformByIndex(InElementIndex: number,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): void;
	SetGlobalTransform(InKey: RigElementKey,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommand: boolean): void;
	SetFloatMetadata(InItem: RigElementKey,InMetadataName: string,InValue: number): boolean;
	SetFloatArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: number[]): boolean;
	SetCurveValueByIndex(InElementIndex: number,InValue: number,bSetupUndo: boolean): void;
	SetCurveValue(InKey: RigElementKey,InValue: number,bSetupUndo: boolean): void;
	SetControlVisibilityByIndex(InElementIndex: number,bVisibility: boolean): void;
	SetControlVisibility(InKey: RigElementKey,bVisibility: boolean): void;
	SetControlValueByIndex(InElementIndex: number,InValue: RigControlValue,InValueType: ERigControlValueType,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetControlValue(InKey: RigElementKey,InValue: RigControlValue,InValueType: ERigControlValueType,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetControlShapeTransformByIndex(InElementIndex: number,InTransform: Transform,bInitial: boolean,bSetupUndo: boolean): void;
	SetControlShapeTransform(InKey: RigElementKey,InTransform: Transform,bInitial: boolean,bSetupUndo: boolean): void;
	SetControlSettingsByIndex(InElementIndex: number,InSettings: RigControlSettings,bSetupUndo: boolean,bForce: boolean,bPrintPythonCommands: boolean): void;
	SetControlSettings(InKey: RigElementKey,InSettings: RigControlSettings,bSetupUndo: boolean,bForce: boolean,bPrintPythonCommands: boolean): void;
	SetControlPreferredRotatorByIndex(InElementIndex: number,InValue: Rotator,bInitial: boolean,bFixEulerFlips: boolean): void;
	SetControlPreferredRotator(InKey: RigElementKey,InValue: Rotator,bInitial: boolean,bFixEulerFlips: boolean): void;
	SetControlOffsetTransformByIndex(InElementIndex: number,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetControlOffsetTransform(InKey: RigElementKey,InTransform: Transform,bInitial: boolean,bAffectChildren: boolean,bSetupUndo: boolean,bPrintPythonCommands: boolean): void;
	SetBoolMetadata(InItem: RigElementKey,InMetadataName: string,InValue: boolean): boolean;
	SetBoolArrayMetadata(InItem: RigElementKey,InMetadataName: string,InValue: boolean[]): boolean;
	SendAutoKeyEvent(InElement: RigElementKey,InOffsetInSeconds: number,bAsynchronous: boolean): void;
	ResetToDefault(): void;
	ResetPoseToInitial(InTypeFilter: ERigElementType): void;
	ResetCurveValues(): void;
	Reset(): void;
	RemoveMetadata(InItem: RigElementKey,InMetadataName: string): boolean;
	RemoveAllMetadata(InItem: RigElementKey): boolean;
	Num(): number;
	static MakeControlValueFromVector2D(InValue: Vector2D): RigControlValue;
	static MakeControlValueFromVector(InValue: Vector): RigControlValue;
	static MakeControlValueFromTransformNoScale(InValue: TransformNoScale): RigControlValue;
	static MakeControlValueFromTransform(InValue: Transform): RigControlValue;
	static MakeControlValueFromRotator(InValue: Rotator): RigControlValue;
	static MakeControlValueFromInt(InValue: number): RigControlValue;
	static MakeControlValueFromFloat(InValue: number): RigControlValue;
	static MakeControlValueFromEulerTransform(InValue: EulerTransform): RigControlValue;
	static MakeControlValueFromBool(InValue: boolean): RigControlValue;
	IsValidIndex(InElementIndex: number): boolean;
	IsSelectedByIndex(InIndex: number): boolean;
	IsSelected(InKey: RigElementKey): boolean;
	IsProcedural(InKey: RigElementKey): boolean;
	IsParentedTo(InChild: RigElementKey,InParent: RigElementKey): boolean;
	IsCurveValueSetByIndex(InElementIndex: number): boolean;
	IsCurveValueSet(InKey: RigElementKey): boolean;
	IsControllerAvailable(): boolean;
	HasTag(InItem: RigElementKey,InTag: string): boolean;
	GetVectorMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: Vector): Vector;
	static GetVectorFromControlValue(InValue: RigControlValue): Vector;
	GetVectorArrayMetadata(InItem: RigElementKey,InMetadataName: string): Vector[];
	static GetVector2DFromControlValue(InValue: RigControlValue): Vector2D;
	static GetTransformNoScaleFromControlValue(InValue: RigControlValue): TransformNoScale;
	GetTransformMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: Transform): Transform;
	static GetTransformFromControlValue(InValue: RigControlValue): Transform;
	GetTransformArrayMetadata(InItem: RigElementKey,InMetadataName: string): Transform[];
	GetTags(InItem: RigElementKey): string[];
	GetSelectedKeys(InTypeFilter: ERigElementType): RigElementKey[];
	GetRotatorMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: Rotator): Rotator;
	static GetRotatorFromControlValue(InValue: RigControlValue): Rotator;
	GetRotatorArrayMetadata(InItem: RigElementKey,InMetadataName: string): Rotator[];
	GetRigidBodyKeys(bTraverse: boolean): RigElementKey[];
	GetRigElementKeyMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: RigElementKey): RigElementKey;
	GetRigElementKeyArrayMetadata(InItem: RigElementKey,InMetadataName: string): RigElementKey[];
	GetReferenceKeys(bTraverse: boolean): RigElementKey[];
	GetQuatMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: Quat): Quat;
	GetQuatArrayMetadata(InItem: RigElementKey,InMetadataName: string): Quat[];
	GetPreviousParent(InKey: RigElementKey): RigElementKey;
	GetPreviousName(InKey: RigElementKey): string;
	GetPose(bInitial: boolean): RigPose;
	GetParentWeightArray(InChild: RigElementKey,bInitial: boolean): RigElementWeight[];
	GetParentWeight(InChild: RigElementKey,InParent: RigElementKey,bInitial: boolean): RigElementWeight;
	GetParentTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetParentTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetParents(InKey: RigElementKey,bRecursive: boolean): RigElementKey[];
	GetNumberOfParents(InKey: RigElementKey): number;
	GetNullKeys(bTraverse: boolean): RigElementKey[];
	GetNameMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: string): string;
	GetNameArrayMetadata(InItem: RigElementKey,InMetadataName: string): string[];
	GetMetadataType(InItem: RigElementKey,InMetadataName: string): ERigMetadataType;
	GetMetadataNames(InItem: RigElementKey): string[];
	GetLocalTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetLocalTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetLocalControlShapeTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetLocalControlShapeTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetLinearColorMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: LinearColor): LinearColor;
	GetLinearColorArrayMetadata(InItem: RigElementKey,InMetadataName: string): LinearColor[];
	GetKeys(InElementIndices: number[]): RigElementKey[];
	GetKey(InElementIndex: number): RigElementKey;
	static GetIntFromControlValue(InValue: RigControlValue): number;
	GetInt32Metadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: number): number;
	GetInt32ArrayMetadata(InItem: RigElementKey,InMetadataName: string): number[];
	GetIndex_ForBlueprint(InKey: RigElementKey): number;
	GetGlobalTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetGlobalTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetGlobalControlShapeTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetGlobalControlShapeTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetGlobalControlOffsetTransformByIndex(InElementIndex: number,bInitial: boolean): Transform;
	GetGlobalControlOffsetTransform(InKey: RigElementKey,bInitial: boolean): Transform;
	GetFloatMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: number): number;
	static GetFloatFromControlValue(InValue: RigControlValue): number;
	GetFloatArrayMetadata(InItem: RigElementKey,InMetadataName: string): number[];
	GetFirstParent(InKey: RigElementKey): RigElementKey;
	static GetEulerTransformFromControlValue(InValue: RigControlValue): EulerTransform;
	GetDefaultParent(InKey: RigElementKey): RigElementKey;
	GetCurveValueByIndex(InElementIndex: number): number;
	GetCurveValue(InKey: RigElementKey): number;
	GetCurveKeys(): RigElementKey[];
	GetControlValueByIndex(InElementIndex: number,InValueType: ERigControlValueType): RigControlValue;
	GetControlValue(InKey: RigElementKey,InValueType: ERigControlValueType): RigControlValue;
	GetControlPreferredRotatorByIndex(InElementIndex: number,bInitial: boolean): Rotator;
	GetControlPreferredRotator(InKey: RigElementKey,bInitial: boolean): Rotator;
	GetController(bCreateIfNeeded: boolean): RigHierarchyController;
	GetControlKeys(bTraverse: boolean): RigElementKey[];
	GetChildren(InKey: RigElementKey,bRecursive: boolean): RigElementKey[];
	GetBoolMetadata(InItem: RigElementKey,InMetadataName: string,DefaultValue: boolean): boolean;
	GetBoolArrayMetadata(InItem: RigElementKey,InMetadataName: string): boolean[];
	GetBoneKeys(bTraverse: boolean): RigElementKey[];
	GetAllKeys_ForBlueprint(bTraverse: boolean): RigElementKey[];
	FindNull_ForBlueprintOnly(InKey: RigElementKey): RigNullElement;
	FindControl_ForBlueprintOnly(InKey: RigElementKey): RigControlElement;
	FindBone_ForBlueprintOnly(InKey: RigElementKey): RigBoneElement;
	CopyPose(InHierarchy: RigHierarchy,bCurrent: boolean,bInitial: boolean,bWeights: boolean,bMatchPoseInGlobalIfNeeded: boolean): void;
	CopyHierarchy(InHierarchy: RigHierarchy): void;
	Contains_ForBlueprint(InKey: RigElementKey): boolean;
	static C(Other: UObject | any): RigHierarchy;
}

declare class ControlRigShapeDefinition { 
	ShapeName: string;
	StaticMesh: StaticMesh;
	Transform: Transform;
	clone() : ControlRigShapeDefinition;
	static C(Other: UObject | any): ControlRigShapeDefinition;
}

declare class ControlRigShapeLibrary extends UObject { 
	DefaultShape: ControlRigShapeDefinition;
	DefaultMaterial: Material;
	XRayMaterial: Material;
	MaterialColorParameter: string;
	Shapes: ControlRigShapeDefinition[];
	static Load(ResourceName: string): ControlRigShapeLibrary;
	static Find(Outer: UObject, ResourceName: string): ControlRigShapeLibrary;
	static GetDefaultObject(): ControlRigShapeLibrary;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControlRigShapeLibrary;
	static C(Other: UObject | any): ControlRigShapeLibrary;
}

declare type EControlRigDrawSettings = 'Points' | 'Lines' | 'LineStrip' | 'DynamicMesh' | 'EControlRigDrawSettings_MAX';
declare var EControlRigDrawSettings : { Points:'Points',Lines:'Lines',LineStrip:'LineStrip',DynamicMesh:'DynamicMesh',EControlRigDrawSettings_MAX:'EControlRigDrawSettings_MAX', };
declare class ControlRigDrawInstruction { 
	Name: string;
	PrimitiveType: EControlRigDrawSettings;
	Positions: Vector[];
	Color: LinearColor;
	Thickness: number;
	Transform: Transform;
	clone() : ControlRigDrawInstruction;
	static C(Other: UObject | any): ControlRigDrawInstruction;
}

declare class ControlRigDrawContainer { 
	Instructions: ControlRigDrawInstruction[];
	clone() : ControlRigDrawContainer;
	static C(Other: UObject | any): ControlRigDrawContainer;
}

declare class AnimationDataSourceRegistry extends UObject { 
	DataSources: Map<string, UObject>;
	static Load(ResourceName: string): AnimationDataSourceRegistry;
	static Find(Outer: UObject, ResourceName: string): AnimationDataSourceRegistry;
	static GetDefaultObject(): AnimationDataSourceRegistry;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimationDataSourceRegistry;
	static C(Other: UObject | any): AnimationDataSourceRegistry;
}

declare class RigInfluenceEntry { 
	Source: RigElementKey;
	AffectedList: RigElementKey[];
	clone() : RigInfluenceEntry;
	static C(Other: UObject | any): RigInfluenceEntry;
}

declare class RigInfluenceMap { 
	EventName: string;
	Entries: RigInfluenceEntry[];
	KeyToIndex: Map<RigElementKey, number>;
	clone() : RigInfluenceMap;
	static C(Other: UObject | any): RigInfluenceMap;
}

declare class RigInfluenceMapPerEvent { 
	Maps: RigInfluenceMap[];
	EventToIndex: Map<string, number>;
	clone() : RigInfluenceMapPerEvent;
	static C(Other: UObject | any): RigInfluenceMapPerEvent;
}

declare type EControlRigState = 'Init' | 'Update' | 'Invalid' | 'EControlRigState_MAX';
declare var EControlRigState : { Init:'Init',Update:'Update',Invalid:'Invalid',EControlRigState_MAX:'EControlRigState_MAX', };
declare class TransformableHandle extends UObject { 
	ConstraintBindingID: MovieSceneObjectBindingID;
	static Load(ResourceName: string): TransformableHandle;
	static Find(Outer: UObject, ResourceName: string): TransformableHandle;
	static GetDefaultObject(): TransformableHandle;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TransformableHandle;
	static C(Other: UObject | any): TransformableHandle;
}

declare class TransformableControlHandle extends TransformableHandle { 
	ControlRig: ControlRig;
	ControlName: string;
	static Load(ResourceName: string): TransformableControlHandle;
	static Find(Outer: UObject, ResourceName: string): TransformableControlHandle;
	static GetDefaultObject(): TransformableControlHandle;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TransformableControlHandle;
	static C(Other: UObject | any): TransformableControlHandle;
}

declare class ControlRig extends UObject { 
	ExecutionType: ERigExecutionType;
	HierarchySettings: RigHierarchySettings;
	VMRuntimeSettings: RigVMRuntimeSettings;
	ControlCustomizations: Map<RigElementKey, RigControlElementCustomization>;
	VM: RigVM;
	InitializedVMSnapshots: Map<number, RigVM>;
	DynamicHierarchy: RigHierarchy;
	GizmoLibrary: ControlRigShapeLibrary;
	ShapeLibraries: ControlRigShapeLibrary[];
	InputProperties: Map<string, CachedPropertyPath>;
	OutputProperties: Map<string, CachedPropertyPath>;
	DrawContainer: ControlRigDrawContainer;
	DataSourceRegistry: AnimationDataSourceRegistry;
	EventQueue: string[];
	Influences: RigInfluenceMapPerEvent;
	InteractionRig: ControlRig;
	InteractionRigClass: UnrealEngineClass;
	AssetUserData: AssetUserData[];
	OnControlSelected_BP: UnrealEngineMulticastDelegate<(Rig: ControlRig, Control: RigControlElement, bSelected: boolean) => void>;
	VMSnapshotBeforeExecution: RigVM;
	bIsInDebugMode: boolean;
	bControlsVisible: boolean;
	static Load(ResourceName: string): ControlRig;
	static Find(Outer: UObject, ResourceName: string): ControlRig;
	static GetDefaultObject(): ControlRig;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControlRig;
	SupportsEvent(InEventName: string): boolean;
	SetVariableFromString(InVariableName: string,InValue: string): boolean;
	SetInteractionRigClass(InInteractionRigClass: UnrealEngineClass): void;
	SetInteractionRig(InInteractionRig: ControlRig): void;
	SetFramesPerSecond(InFramesPerSecond: number): void;
	SetDeltaTime(InDeltaTime: number): void;
	SetAbsoluteTime(InAbsoluteTime: number,InSetDeltaTimeZero: boolean): void;
	SetAbsoluteAndDeltaTime(InAbsoluteTime: number,InDeltaTime: number): void;
	SelectControl(InControlName: string,bSelect: boolean): void;
	RequestInit(): void;
	RequestConstruction(): void;
	IsControlSelected(InControlName: string): boolean;
	GetVM(): RigVM;
	GetVariableType(InVariableName: string): string;
	GetVariableAsString(InVariableName: string): string;
	GetSupportedEvents(): string[];
	GetScriptAccessibleVariables(): string[];
	GetInteractionRigClass(): UnrealEngineClass;
	GetInteractionRig(): ControlRig;
	GetHostingActor(): Actor;
	GetHierarchy(): RigHierarchy;
	GetEvents(): string[];
	GetCurrentFramesPerSecond(): number;
	GetAbsoluteTime(): number;
	static FindControlRigs(Outer: UObject,OptionalClass: UnrealEngineClass): ControlRig[];
	ExecuteEvent(InEventName: string): boolean;
	Execute(State: EControlRigState,InEventName: string): boolean;
	CurrentControlSelection(): string[];
	CreateTransformableControlHandle(Outer: UObject,ControlName: string): TransformableControlHandle;
	ContainsEvent(InEventName: string): boolean;
	ClearControlSelection(): boolean;
	CanExecute(): boolean;
	static C(Other: UObject | any): ControlRig;
}

declare class RigSpacePickerBakeSettings { 
	TargetSpace: RigElementKey;
	StartFrame: FrameNumber;
	EndFrame: FrameNumber;
	bReduceKeys: boolean;
	Tolerance: number;
	clone() : RigSpacePickerBakeSettings;
	static C(Other: UObject | any): RigSpacePickerBakeSettings;
}

declare class MovieSceneNameableTrack extends MovieSceneTrack { 
	DisplayName: string;
	TrackRowDisplayNames: string[];
	static Load(ResourceName: string): MovieSceneNameableTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneNameableTrack;
	static GetDefaultObject(): MovieSceneNameableTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneNameableTrack;
	static C(Other: UObject | any): MovieSceneNameableTrack;
}

declare class MovieSceneControlRigParameterTrack extends MovieSceneNameableTrack { 
	ControlRig: ControlRig;
	SectionToKey: MovieSceneSection;
	Sections: MovieSceneSection[];
	TrackName: string;
	static Load(ResourceName: string): MovieSceneControlRigParameterTrack;
	static Find(Outer: UObject, ResourceName: string): MovieSceneControlRigParameterTrack;
	static GetDefaultObject(): MovieSceneControlRigParameterTrack;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneControlRigParameterTrack;
	static C(Other: UObject | any): MovieSceneControlRigParameterTrack;
}

declare class ControlRigSequencerBindingProxy { 
	Proxy: MovieSceneBindingProxy;
	ControlRig: ControlRig;
	Track: MovieSceneControlRigParameterTrack;
	clone() : ControlRigSequencerBindingProxy;
	static C(Other: UObject | any): ControlRigSequencerBindingProxy;
}

declare class ActorForWorldTransforms { 
	Actor: Actor;
	Component: SceneComponent;
	SocketName: string;
	clone() : ActorForWorldTransforms;
	static C(Other: UObject | any): ActorForWorldTransforms;
}

declare class ControlRigForWorldTransforms { 
	ControlRig: ControlRig;
	ControlNames: string[];
	clone() : ControlRigForWorldTransforms;
	static C(Other: UObject | any): ControlRigForWorldTransforms;
}

declare class ControlRigSnapperSelection { 
	Actors: ActorForWorldTransforms[];
	ControlRigs: ControlRigForWorldTransforms[];
	clone() : ControlRigSnapperSelection;
	static C(Other: UObject | any): ControlRigSnapperSelection;
}

declare class ControlRigSnapSettings extends UObject { 
	bKeepOffset: boolean;
	bSnapPosition: boolean;
	bSnapRotation: boolean;
	bSnapScale: boolean;
	static Load(ResourceName: string): ControlRigSnapSettings;
	static Find(Outer: UObject, ResourceName: string): ControlRigSnapSettings;
	static GetDefaultObject(): ControlRigSnapSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ControlRigSnapSettings;
	static C(Other: UObject | any): ControlRigSnapSettings;
}

declare class LevelSequenceAnimSequenceLinkItem { 
	SkelTrackGuid: Guid;
	PathToAnimSequence: SoftObjectPath;
	bExportTransforms: boolean;
	bExportMorphTargets: boolean;
	bExportAttributeCurves: boolean;
	bExportMaterialCurves: boolean;
	Interpolation: EAnimInterpolationType;
	CurveInterpolation: ERichCurveInterpMode;
	bRecordInWorldSpace: boolean;
	bEvaluateAllSkeletalMeshComponents: boolean;
	clone() : LevelSequenceAnimSequenceLinkItem;
	static C(Other: UObject | any): LevelSequenceAnimSequenceLinkItem;
}

declare class LevelSequenceAnimSequenceLink extends AssetUserData { 
	AnimSequenceLinks: LevelSequenceAnimSequenceLinkItem[];
	static Load(ResourceName: string): LevelSequenceAnimSequenceLink;
	static Find(Outer: UObject, ResourceName: string): LevelSequenceAnimSequenceLink;
	static GetDefaultObject(): LevelSequenceAnimSequenceLink;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelSequenceAnimSequenceLink;
	static C(Other: UObject | any): LevelSequenceAnimSequenceLink;
}

declare class AnimSeqExportOption extends UObject { 
	bExportTransforms: boolean;
	bExportMorphTargets: boolean;
	bExportAttributeCurves: boolean;
	bExportMaterialCurves: boolean;
	bRecordInWorldSpace: boolean;
	bEvaluateAllSkeletalMeshComponents: boolean;
	Interpolation: EAnimInterpolationType;
	CurveInterpolation: ERichCurveInterpMode;
	WarmUpFrames: FrameNumber;
	DelayBeforeStart: FrameNumber;
	static Load(ResourceName: string): AnimSeqExportOption;
	static Find(Outer: UObject, ResourceName: string): AnimSeqExportOption;
	static GetDefaultObject(): AnimSeqExportOption;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AnimSeqExportOption;
	static C(Other: UObject | any): AnimSeqExportOption;
}

declare class TakeRecorderSource extends UObject { 
	bEnabled: boolean;
	TakeNumber: number;
	TrackTint: Color;
	static Load(ResourceName: string): TakeRecorderSource;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderSource;
	static GetDefaultObject(): TakeRecorderSource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderSource;
	static C(Other: UObject | any): TakeRecorderSource;
}

declare class MovieSceneSectionParameters { 
	StartFrameOffset: FrameNumber;
	bCanLoop: boolean;
	EndFrameOffset: FrameNumber;
	FirstLoopStartFrameOffset: FrameNumber;
	TimeScale: number;
	HierarchicalBias: number;
	StartOffset: number;
	PrerollTime: number;
	PostrollTime: number;
	clone() : MovieSceneSectionParameters;
	static C(Other: UObject | any): MovieSceneSectionParameters;
}

declare class MovieSceneSubSection extends MovieSceneSection { 
	Parameters: MovieSceneSectionParameters;
	StartOffset: number;
	TimeScale: number;
	PrerollTime: number;
	NetworkMask: number;
	SubSequence: MovieSceneSequence;
	static Load(ResourceName: string): MovieSceneSubSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneSubSection;
	static GetDefaultObject(): MovieSceneSubSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneSubSection;
	SetSequence(Sequence: MovieSceneSequence): void;
	GetSequence(): MovieSceneSequence;
	static C(Other: UObject | any): MovieSceneSubSection;
	FocusLevelSequence(): void;
	GetParentSequenceFrame(InFrame: number,ParentSequence: MovieSceneSequence): number;
	static FocusLevelSequence(SubSection: MovieSceneSubSection): void;
	static GetParentSequenceFrame(Section: MovieSceneSubSection,InFrame: number,ParentSequence: MovieSceneSequence): number;
}

declare class TakeRecorderSources extends UObject { 
	Sources: TakeRecorderSource[];
	SourceSubSequenceMap: Map<TakeRecorderSource, LevelSequence>;
	ActiveSubSections: MovieSceneSubSection[];
	static Load(ResourceName: string): TakeRecorderSources;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderSources;
	static GetDefaultObject(): TakeRecorderSources;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderSources;
	StartRecordingSource(InSources: TakeRecorderSource[],CurrentFrameTime: QualifiedFrameTime): void;
	RemoveSource(InSource: TakeRecorderSource): void;
	GetSourcesCopy(): TakeRecorderSource[];
	AddSource(InSourceType: UnrealEngineClass): TakeRecorderSource;
	static C(Other: UObject | any): TakeRecorderSources;
}

declare class Timespan { 
	clone() : Timespan;
	static C(Other: UObject | any): Timespan;
	Add_TimespanTimespan(B: Timespan): Timespan;
	BreakTimespan(Days?: number,Hours?: number,Minutes?: number,Seconds?: number,Milliseconds?: number): {Days: number, Hours: number, Minutes: number, Seconds: number, Milliseconds: number};
	BreakTimespan2(Days?: number,Hours?: number,Minutes?: number,Seconds?: number,FractionNano?: number): {Days: number, Hours: number, Minutes: number, Seconds: number, FractionNano: number};
	Divide_TimespanFloat(Scalar: number): Timespan;
	EqualEqual_TimespanTimespan(B: Timespan): boolean;
	GetDays(): number;
	GetDuration(): Timespan;
	GetHours(): number;
	GetMilliseconds(): number;
	GetMinutes(): number;
	GetSeconds(): number;
	GetTotalDays(): number;
	GetTotalHours(): number;
	GetTotalMilliseconds(): number;
	GetTotalMinutes(): number;
	GetTotalSeconds(): number;
	Greater_TimespanTimespan(B: Timespan): boolean;
	GreaterEqual_TimespanTimespan(B: Timespan): boolean;
	Less_TimespanTimespan(B: Timespan): boolean;
	LessEqual_TimespanTimespan(B: Timespan): boolean;
	Multiply_TimespanFloat(Scalar: number): Timespan;
	NotEqual_TimespanTimespan(B: Timespan): boolean;
	Subtract_TimespanTimespan(B: Timespan): Timespan;
	TimespanRatio(B: Timespan): number;
	AsTimespan_Timespan(): string;
	static Add_TimespanTimespan(A: Timespan,B: Timespan): Timespan;
	static BreakTimespan(InTimespan: Timespan,Days?: number,Hours?: number,Minutes?: number,Seconds?: number,Milliseconds?: number): {Days: number, Hours: number, Minutes: number, Seconds: number, Milliseconds: number};
	static BreakTimespan2(InTimespan: Timespan,Days?: number,Hours?: number,Minutes?: number,Seconds?: number,FractionNano?: number): {Days: number, Hours: number, Minutes: number, Seconds: number, FractionNano: number};
	static Divide_TimespanFloat(A: Timespan,Scalar: number): Timespan;
	static EqualEqual_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static GetDays(A: Timespan): number;
	static GetDuration(A: Timespan): Timespan;
	static GetHours(A: Timespan): number;
	static GetMilliseconds(A: Timespan): number;
	static GetMinutes(A: Timespan): number;
	static GetSeconds(A: Timespan): number;
	static GetTotalDays(A: Timespan): number;
	static GetTotalHours(A: Timespan): number;
	static GetTotalMilliseconds(A: Timespan): number;
	static GetTotalMinutes(A: Timespan): number;
	static GetTotalSeconds(A: Timespan): number;
	static Greater_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static GreaterEqual_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static Less_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static LessEqual_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static Multiply_TimespanFloat(A: Timespan,Scalar: number): Timespan;
	static NotEqual_TimespanTimespan(A: Timespan,B: Timespan): boolean;
	static Subtract_TimespanTimespan(A: Timespan,B: Timespan): Timespan;
	static TimespanRatio(A: Timespan,B: Timespan): number;
	static AsTimespan_Timespan(InTimespan: Timespan): string;
	static FromDays(Days: number): Timespan;
	static FromHours(Hours: number): Timespan;
	static FromMilliseconds(Milliseconds: number): Timespan;
	static FromMinutes(Minutes: number): Timespan;
	static FromSeconds(Seconds: number): Timespan;
	static MakeTimespan(Days: number,Hours: number,Minutes: number,Seconds: number,Milliseconds: number): Timespan;
	static MakeTimespan2(Days: number,Hours: number,Minutes: number,Seconds: number,FractionNano: number): Timespan;
	static TimespanMaxValue(): Timespan;
	static TimespanMinValue(): Timespan;
	static TimespanZeroValue(): Timespan;
}

declare class DateTime { 
	clone() : DateTime;
	static C(Other: UObject | any): DateTime;
	ScheduleLocalNotificationAtTime(LocalTime: boolean,Title: string,Body: string,Action: string,ActivationEvent: string): number;
	ScheduleLocalNotificationBadgeAtTime(LocalTime: boolean,ActivationEvent: string): number;
	Add_DateTimeDateTime(B: DateTime): DateTime;
	Add_DateTimeTimespan(B: Timespan): DateTime;
	BreakDateTime(Year?: number,Month?: number,Day?: number,Hour?: number,Minute?: number,Second?: number,Millisecond?: number): {Year: number, Month: number, Day: number, Hour: number, Minute: number, Second: number, Millisecond: number};
	EqualEqual_DateTimeDateTime(B: DateTime): boolean;
	GetDate(): DateTime;
	GetDay(): number;
	GetDayOfYear(): number;
	GetHour(): number;
	GetHour12(): number;
	GetMillisecond(): number;
	GetMinute(): number;
	GetMonth(): number;
	GetSecond(): number;
	GetTimeOfDay(): Timespan;
	GetYear(): number;
	Greater_DateTimeDateTime(B: DateTime): boolean;
	GreaterEqual_DateTimeDateTime(B: DateTime): boolean;
	IsAfternoon(): boolean;
	IsMorning(): boolean;
	Less_DateTimeDateTime(B: DateTime): boolean;
	LessEqual_DateTimeDateTime(B: DateTime): boolean;
	NotEqual_DateTimeDateTime(B: DateTime): boolean;
	Subtract_DateTimeDateTime(B: DateTime): Timespan;
	Subtract_DateTimeTimespan(B: Timespan): DateTime;
	AsDate_DateTime(): string;
	AsDateTime_DateTime(): string;
	AsTime_DateTime(): string;
	AsTimeZoneDate_DateTime(InTimeZone: string): string;
	AsTimeZoneDateTime_DateTime(InTimeZone: string): string;
	AsTimeZoneTime_DateTime(InTimeZone: string): string;
	static ScheduleLocalNotificationAtTime(FireDateTime: DateTime,LocalTime: boolean,Title: string,Body: string,Action: string,ActivationEvent: string): number;
	static ScheduleLocalNotificationBadgeAtTime(FireDateTime: DateTime,LocalTime: boolean,ActivationEvent: string): number;
	static Add_DateTimeDateTime(A: DateTime,B: DateTime): DateTime;
	static Add_DateTimeTimespan(A: DateTime,B: Timespan): DateTime;
	static BreakDateTime(InDateTime: DateTime,Year?: number,Month?: number,Day?: number,Hour?: number,Minute?: number,Second?: number,Millisecond?: number): {Year: number, Month: number, Day: number, Hour: number, Minute: number, Second: number, Millisecond: number};
	static EqualEqual_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static GetDate(A: DateTime): DateTime;
	static GetDay(A: DateTime): number;
	static GetDayOfYear(A: DateTime): number;
	static GetHour(A: DateTime): number;
	static GetHour12(A: DateTime): number;
	static GetMillisecond(A: DateTime): number;
	static GetMinute(A: DateTime): number;
	static GetMonth(A: DateTime): number;
	static GetSecond(A: DateTime): number;
	static GetTimeOfDay(A: DateTime): Timespan;
	static GetYear(A: DateTime): number;
	static Greater_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static GreaterEqual_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static IsAfternoon(A: DateTime): boolean;
	static IsMorning(A: DateTime): boolean;
	static Less_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static LessEqual_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static NotEqual_DateTimeDateTime(A: DateTime,B: DateTime): boolean;
	static Subtract_DateTimeDateTime(A: DateTime,B: DateTime): Timespan;
	static Subtract_DateTimeTimespan(A: DateTime,B: Timespan): DateTime;
	static AsDate_DateTime(InDateTime: DateTime): string;
	static AsDateTime_DateTime(In: DateTime): string;
	static AsTime_DateTime(In: DateTime): string;
	static AsTimeZoneDate_DateTime(InDateTime: DateTime,InTimeZone: string): string;
	static AsTimeZoneDateTime_DateTime(InDateTime: DateTime,InTimeZone: string): string;
	static AsTimeZoneTime_DateTime(InDateTime: DateTime,InTimeZone: string): string;
	static DateTimeMaxValue(): DateTime;
	static DateTimeMinValue(): DateTime;
	static MakeDateTime(Year: number,Month: number,Day: number,Hour: number,Minute: number,Second: number,Millisecond: number): DateTime;
	static Now(): DateTime;
	static Today(): DateTime;
	static UtcNow(): DateTime;
}

declare class TakePreset extends UObject { 
	LevelSequence: LevelSequence;
	static Load(ResourceName: string): TakePreset;
	static Find(Outer: UObject, ResourceName: string): TakePreset;
	static GetDefaultObject(): TakePreset;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakePreset;
	static C(Other: UObject | any): TakePreset;
}

declare class TakeMetaData extends UObject { 
	bIsLocked: boolean;
	Slate: string;
	TakeNumber: number;
	Timestamp: DateTime;
	TimecodeIn: Timecode;
	TimecodeOut: Timecode;
	Duration: FrameTime;
	FrameRate: FrameRate;
	Description: string;
	PresetOrigin: TakePreset;
	LevelOrigin: Level;
	bFrameRateFromTimecode: boolean;
	static Load(ResourceName: string): TakeMetaData;
	static Find(Outer: UObject, ResourceName: string): TakeMetaData;
	static GetDefaultObject(): TakeMetaData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeMetaData;
	Unlock(): void;
	SetTimestamp(InTimestamp: DateTime): void;
	SetTimecodeOut(InTimecodeOut: Timecode): void;
	SetTimecodeIn(InTimecodeIn: Timecode): void;
	SetTakeNumber(InTakeNumber: number,bEmitChanged: boolean): void;
	SetSlate(InSlate: string,bEmitChanged: boolean): void;
	SetPresetOrigin(InPresetOrigin: TakePreset): void;
	SetLevelOrigin(InLevelOrigin: Level): void;
	SetFrameRateFromTimecode(InFromTimecode: boolean): void;
	SetFrameRate(InFrameRate: FrameRate): void;
	SetDuration(InDuration: FrameTime): void;
	SetDescription(InDescription: string): void;
	Recorded(): boolean;
	Lock(): void;
	IsLocked(): boolean;
	GetTimestamp(): DateTime;
	GetTimecodeOut(): Timecode;
	GetTimecodeIn(): Timecode;
	GetTakeNumber(): number;
	GetSlate(): string;
	GetPresetOrigin(): TakePreset;
	GetLevelPath(): string;
	GetLevelOrigin(): Level;
	GetFrameRateFromTimecode(): boolean;
	GetFrameRate(): FrameRate;
	GetDuration(): FrameTime;
	GetDescription(): string;
	GenerateAssetPath(PathFormatString: string): string;
	static C(Other: UObject | any): TakeMetaData;
}

declare class TakeRecorderUserParameters { 
	bMaximizeViewport: boolean;
	CountdownSeconds: number;
	EngineTimeDilation: number;
	bResetPlayhead: boolean;
	bStopAtPlaybackEnd: boolean;
	bRemoveRedundantTracks: boolean;
	ReduceKeysTolerance: number;
	bSaveRecordedAssets: boolean;
	bAutoLock: boolean;
	bAutoSerialize: boolean;
	clone() : TakeRecorderUserParameters;
	static C(Other: UObject | any): TakeRecorderUserParameters;
}

declare class DirectoryPath { 
	Path: string;
	clone() : DirectoryPath;
	static C(Other: UObject | any): DirectoryPath;
}

declare class TakeRecorderPropertyTrackSettings { 
	ComponentPath: string;
	PropertyPath: string;
	clone() : TakeRecorderPropertyTrackSettings;
	static C(Other: UObject | any): TakeRecorderPropertyTrackSettings;
}

declare class TakeRecorderTrackSettings { 
	MatchingActorClass: SoftClassPath;
	DefaultPropertyTracks: TakeRecorderPropertyTrackSettings[];
	ExcludePropertyTracks: TakeRecorderPropertyTrackSettings[];
	clone() : TakeRecorderTrackSettings;
	static C(Other: UObject | any): TakeRecorderTrackSettings;
}

declare class TakeRecorderProjectParameters { 
	RootTakeSaveDir: DirectoryPath;
	TakeSaveDir: string;
	DefaultSlate: string;
	RecordingClockSource: EUpdateClockSource;
	bStartAtCurrentTimecode: boolean;
	bRecordTimecode: boolean;
	bRecordSourcesIntoSubSequences: boolean;
	bRecordToPossessable: boolean;
	DefaultTracks: TakeRecorderTrackSettings[];
	bShowNotifications: boolean;
	clone() : TakeRecorderProjectParameters;
	static C(Other: UObject | any): TakeRecorderProjectParameters;
}

declare type ETakeRecorderMode = 'RecordNewSequence' | 'RecordIntoSequence' | 'ETakeRecorderMode_MAX';
declare var ETakeRecorderMode : { RecordNewSequence:'RecordNewSequence',RecordIntoSequence:'RecordIntoSequence',ETakeRecorderMode_MAX:'ETakeRecorderMode_MAX', };
declare class TakeRecorderParameters { 
	User: TakeRecorderUserParameters;
	Project: TakeRecorderProjectParameters;
	TakeRecorderMode: ETakeRecorderMode;
	StartFrame: FrameNumber;
	bDisableRecordingAndSave: boolean;
	clone() : TakeRecorderParameters;
	static C(Other: UObject | any): TakeRecorderParameters;
	SetDefaultParameters(): void;
	static SetDefaultParameters(DefaultParameters: TakeRecorderParameters): void;
	static GetDefaultParameters(): TakeRecorderParameters;
}

declare class TakeRecorderOverlayWidget extends UserWidget { 
	Recorder: TakeRecorder;
	static Load(ResourceName: string): TakeRecorderOverlayWidget;
	static Find(Outer: UObject, ResourceName: string): TakeRecorderOverlayWidget;
	static GetDefaultObject(): TakeRecorderOverlayWidget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorderOverlayWidget;
	static C(Other: UObject | any): TakeRecorderOverlayWidget;
}

declare type ETakeRecorderState = 'CountingDown' | 'PreRecord' | 'TickingAfterPre' | 'Started' | 'Stopped' | 'Cancelled' | 'ETakeRecorderState_MAX';
declare var ETakeRecorderState : { CountingDown:'CountingDown',PreRecord:'PreRecord',TickingAfterPre:'TickingAfterPre',Started:'Started',Stopped:'Stopped',Cancelled:'Cancelled',ETakeRecorderState_MAX:'ETakeRecorderState_MAX', };
declare class TakeRecorder extends UObject { 
	SequenceAsset: LevelSequence;
	OverlayWidget: TakeRecorderOverlayWidget;
	WeakWorld: World;
	Parameters: TakeRecorderParameters;
	static Load(ResourceName: string): TakeRecorder;
	static Find(Outer: UObject, ResourceName: string): TakeRecorder;
	static GetDefaultObject(): TakeRecorder;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TakeRecorder;
	GetState(): ETakeRecorderState;
	GetSequence(): LevelSequence;
	GetCountdownSeconds(): number;
	static C(Other: UObject | any): TakeRecorder;
}

declare class LevelSequence extends MovieSceneSequence { 
	MovieScene: MovieScene;
	ObjectReferences: LevelSequenceObjectReferenceMap;
	BindingReferences: LevelSequenceBindingReferences;
	PossessedObjects: Map<string, LevelSequenceObject>;
	DirectorBlueprint: Blueprint;
	DirectorClass: UnrealEngineClass;
	MetaDataObjects: UObject[];
	AssetUserData: AssetUserData[];
	static Load(ResourceName: string): LevelSequence;
	static Find(Outer: UObject, ResourceName: string): LevelSequence;
	static GetDefaultObject(): LevelSequence;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): LevelSequence;
	RemoveMetaDataByClass(InClass: UnrealEngineClass): void;
	FindOrAddMetaDataByClass(InClass: UnrealEngineClass): UObject;
	FindMetaDataByClass(InClass: UnrealEngineClass): UObject;
	CopyMetaData(InMetaData: UObject): UObject;
	static C(Other: UObject | any): LevelSequence;
	BakeControlRigSpace(InControlRig: ControlRig,InControlNames: string[],InSettings: RigSpacePickerBakeSettings,TimeUnit: ESequenceTimeUnit): boolean;
	CollapseControlRigAnimLayers(InTrack: MovieSceneControlRigParameterTrack,bKeyReduce: boolean,Tolerance: number): boolean;
	DeleteControlRigSpace(InControlRig: ControlRig,InControlName: string,InTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	GetActorWorldTransform(Actor: Actor,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	GetActorWorldTransforms(Actor: Actor,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	GetControlRigs(): ControlRigSequencerBindingProxy[];
	GetControlRigWorldTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	GetControlRigWorldTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	GetLocalControlRigBool(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	GetLocalControlRigBools(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): boolean[];
	GetLocalControlRigEulerTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): EulerTransform;
	GetLocalControlRigEulerTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): EulerTransform[];
	GetLocalControlRigFloat(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): number;
	GetLocalControlRigFloats(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): number[];
	GetLocalControlRigInt(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): number;
	GetLocalControlRigInts(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): number[];
	GetLocalControlRigPosition(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector;
	GetLocalControlRigPositions(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector[];
	GetLocalControlRigRotator(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Rotator;
	GetLocalControlRigRotators(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Rotator[];
	GetLocalControlRigScale(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector;
	GetLocalControlRigScales(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector[];
	GetLocalControlRigTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	GetLocalControlRigTransformNoScale(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): TransformNoScale;
	GetLocalControlRigTransformNoScales(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): TransformNoScale[];
	GetLocalControlRigTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	GetLocalControlRigVector2D(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector2D;
	GetLocalControlRigVector2Ds(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector2D[];
	GetSkeletalMeshComponentWorldTransform(SkeletalMeshComponent: SkeletalMeshComponent,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit,ReferenceName: string): Transform;
	GetSkeletalMeshComponentWorldTransforms(SkeletalMeshComponent: SkeletalMeshComponent,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit,ReferenceName: string): Transform[];
	MoveControlRigSpace(InControlRig: ControlRig,InControlName: string,InTime: FrameNumber,InNewTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	SetControlRigSpace(InControlRig: ControlRig,InControlName: string,InSpaceKey: RigElementKey,InTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	SetControlRigWorldTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,WorldTransform: Transform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetControlRigWorldTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],WorldTransforms: Transform[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigBool(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: boolean,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigBools(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: boolean[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigEulerTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: EulerTransform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigEulerTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: EulerTransform[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigFloat(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: number,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigFloats(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: number[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigInt(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: number,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigInts(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: number[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigPosition(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigPositions(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigRotator(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Rotator,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigRotators(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Rotator[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigScale(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigScales(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigTransform(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Transform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigTransformNoScale(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: TransformNoScale,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigTransformNoScales(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: TransformNoScale[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigTransforms(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Transform[],TimeUnit: ESequenceTimeUnit): void;
	SetLocalControlRigVector2D(ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector2D,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	SetLocalControlRigVector2Ds(ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector2D[],TimeUnit: ESequenceTimeUnit): void;
	SnapControlRig(StartFrame: FrameNumber,EndFrame: FrameNumber,ChildrenToSnap: ControlRigSnapperSelection,ParentToSnap: ControlRigSnapperSelection,SnapSettings: ControlRigSnapSettings,TimeUnit: ESequenceTimeUnit): boolean;
	TweenControlRig(ControlRig: ControlRig,TweenValue: number): boolean;
	OpenLevelSequence(): boolean;
	ClearLinkedAnimSequences(): void;
	GetAnimSequenceLinkFromLevelSequence(): LevelSequenceAnimSequenceLink;
	LinkAnimSequence(AnimSequence: AnimSequence,ExportOptions: AnimSeqExportOption,Binding: MovieSceneBindingProxy): boolean;
	StartRecording(Sources: TakeRecorderSources,MetaData: TakeMetaData,Parameters: TakeRecorderParameters): TakeRecorder;
	static BakeControlRigSpace(InSequence: LevelSequence,InControlRig: ControlRig,InControlNames: string[],InSettings: RigSpacePickerBakeSettings,TimeUnit: ESequenceTimeUnit): boolean;
	static CollapseControlRigAnimLayers(InSequence: LevelSequence,InTrack: MovieSceneControlRigParameterTrack,bKeyReduce: boolean,Tolerance: number): boolean;
	static DeleteControlRigSpace(InSequence: LevelSequence,InControlRig: ControlRig,InControlName: string,InTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	static GetActorWorldTransform(LevelSequence: LevelSequence,Actor: Actor,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	static GetActorWorldTransforms(LevelSequence: LevelSequence,Actor: Actor,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	static GetControlRigs(LevelSequence: LevelSequence): ControlRigSequencerBindingProxy[];
	static GetControlRigWorldTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	static GetControlRigWorldTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	static GetLocalControlRigBool(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	static GetLocalControlRigBools(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): boolean[];
	static GetLocalControlRigEulerTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): EulerTransform;
	static GetLocalControlRigEulerTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): EulerTransform[];
	static GetLocalControlRigFloat(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): number;
	static GetLocalControlRigFloats(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): number[];
	static GetLocalControlRigInt(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): number;
	static GetLocalControlRigInts(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): number[];
	static GetLocalControlRigPosition(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector;
	static GetLocalControlRigPositions(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector[];
	static GetLocalControlRigRotator(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Rotator;
	static GetLocalControlRigRotators(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Rotator[];
	static GetLocalControlRigScale(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector;
	static GetLocalControlRigScales(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector[];
	static GetLocalControlRigTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Transform;
	static GetLocalControlRigTransformNoScale(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): TransformNoScale;
	static GetLocalControlRigTransformNoScales(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): TransformNoScale[];
	static GetLocalControlRigTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Transform[];
	static GetLocalControlRigVector2D(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit): Vector2D;
	static GetLocalControlRigVector2Ds(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit): Vector2D[];
	static GetSkeletalMeshComponentWorldTransform(LevelSequence: LevelSequence,SkeletalMeshComponent: SkeletalMeshComponent,Frame: FrameNumber,TimeUnit: ESequenceTimeUnit,ReferenceName: string): Transform;
	static GetSkeletalMeshComponentWorldTransforms(LevelSequence: LevelSequence,SkeletalMeshComponent: SkeletalMeshComponent,Frames: FrameNumber[],TimeUnit: ESequenceTimeUnit,ReferenceName: string): Transform[];
	static MoveControlRigSpace(InSequence: LevelSequence,InControlRig: ControlRig,InControlName: string,InTime: FrameNumber,InNewTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	static SetControlRigSpace(InSequence: LevelSequence,InControlRig: ControlRig,InControlName: string,InSpaceKey: RigElementKey,InTime: FrameNumber,TimeUnit: ESequenceTimeUnit): boolean;
	static SetControlRigWorldTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,WorldTransform: Transform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetControlRigWorldTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],WorldTransforms: Transform[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigBool(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: boolean,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigBools(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: boolean[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigEulerTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: EulerTransform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigEulerTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: EulerTransform[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigFloat(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: number,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigFloats(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: number[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigInt(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: number,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigInts(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: number[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigPosition(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigPositions(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigRotator(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Rotator,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigRotators(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Rotator[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigScale(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigScales(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigTransform(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Transform,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigTransformNoScale(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: TransformNoScale,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigTransformNoScales(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: TransformNoScale[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigTransforms(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Transform[],TimeUnit: ESequenceTimeUnit): void;
	static SetLocalControlRigVector2D(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frame: FrameNumber,Value: Vector2D,TimeUnit: ESequenceTimeUnit,bSetKey: boolean): void;
	static SetLocalControlRigVector2Ds(LevelSequence: LevelSequence,ControlRig: ControlRig,ControlName: string,Frames: FrameNumber[],Values: Vector2D[],TimeUnit: ESequenceTimeUnit): void;
	static SnapControlRig(LevelSequence: LevelSequence,StartFrame: FrameNumber,EndFrame: FrameNumber,ChildrenToSnap: ControlRigSnapperSelection,ParentToSnap: ControlRigSnapperSelection,SnapSettings: ControlRigSnapSettings,TimeUnit: ESequenceTimeUnit): boolean;
	static TweenControlRig(LevelSequence: LevelSequence,ControlRig: ControlRig,TweenValue: number): boolean;
	static OpenLevelSequence(LevelSequence: LevelSequence): boolean;
	static ClearLinkedAnimSequences(InLevelSequence: LevelSequence): void;
	static GetAnimSequenceLinkFromLevelSequence(InLevelSequence: LevelSequence): LevelSequenceAnimSequenceLink;
	static LinkAnimSequence(Sequence: LevelSequence,AnimSequence: AnimSequence,ExportOptions: AnimSeqExportOption,Binding: MovieSceneBindingProxy): boolean;
	static StartRecording(LevelSequence: LevelSequence,Sources: TakeRecorderSources,MetaData: TakeMetaData,Parameters: TakeRecorderParameters): TakeRecorder;
}

declare class MovieSceneChannel { 
	clone() : MovieSceneChannel;
	static C(Other: UObject | any): MovieSceneChannel;
}

declare class MovieSceneBoolChannel extends MovieSceneChannel { 
	Times: FrameNumber[];
	DefaultValue: boolean;
	bHasDefaultValue: boolean;
	Values: boolean[];
	clone() : MovieSceneBoolChannel;
	static C(Other: UObject | any): MovieSceneBoolChannel;
}

declare class BoolParameterNameAndCurve { 
	ParameterName: string;
	ParameterCurve: MovieSceneBoolChannel;
	clone() : BoolParameterNameAndCurve;
	static C(Other: UObject | any): BoolParameterNameAndCurve;
}

declare class MovieSceneTangentData { 
	ArriveTangent: number;
	LeaveTangent: number;
	ArriveTangentWeight: number;
	LeaveTangentWeight: number;
	TangentWeightMode: ERichCurveTangentWeightMode;
	clone() : MovieSceneTangentData;
	static C(Other: UObject | any): MovieSceneTangentData;
}

declare class MovieSceneFloatValue { 
	Value: number;
	Tangent: MovieSceneTangentData;
	InterpMode: ERichCurveInterpMode;
	TangentMode: ERichCurveTangentMode;
	PaddingByte: number;
	clone() : MovieSceneFloatValue;
	static C(Other: UObject | any): MovieSceneFloatValue;
}

declare class KeyHandleLookupTable { 
	clone() : KeyHandleLookupTable;
	static C(Other: UObject | any): KeyHandleLookupTable;
}

declare class MovieSceneKeyHandleMap extends KeyHandleLookupTable { 
	clone() : MovieSceneKeyHandleMap;
	static C(Other: UObject | any): MovieSceneKeyHandleMap;
}

declare class MovieSceneFloatChannel extends MovieSceneChannel { 
	PreInfinityExtrap: ERichCurveExtrapolation;
	PostInfinityExtrap: ERichCurveExtrapolation;
	Times: FrameNumber[];
	Values: MovieSceneFloatValue[];
	DefaultValue: number;
	bHasDefaultValue: boolean;
	KeyHandles: MovieSceneKeyHandleMap;
	TickResolution: FrameRate;
	bShowCurve: boolean;
	clone() : MovieSceneFloatChannel;
	static C(Other: UObject | any): MovieSceneFloatChannel;
}

declare class ScalarParameterNameAndCurve { 
	ParameterName: string;
	ParameterCurve: MovieSceneFloatChannel;
	clone() : ScalarParameterNameAndCurve;
	static C(Other: UObject | any): ScalarParameterNameAndCurve;
}

declare class Vector2DParameterNameAndCurves { 
	ParameterName: string;
	XCurve: MovieSceneFloatChannel;
	YCurve: MovieSceneFloatChannel;
	clone() : Vector2DParameterNameAndCurves;
	static C(Other: UObject | any): Vector2DParameterNameAndCurves;
}

declare class VectorParameterNameAndCurves { 
	ParameterName: string;
	XCurve: MovieSceneFloatChannel;
	YCurve: MovieSceneFloatChannel;
	ZCurve: MovieSceneFloatChannel;
	clone() : VectorParameterNameAndCurves;
	static C(Other: UObject | any): VectorParameterNameAndCurves;
}

declare class ColorParameterNameAndCurves { 
	ParameterName: string;
	RedCurve: MovieSceneFloatChannel;
	GreenCurve: MovieSceneFloatChannel;
	BlueCurve: MovieSceneFloatChannel;
	AlphaCurve: MovieSceneFloatChannel;
	clone() : ColorParameterNameAndCurves;
	static C(Other: UObject | any): ColorParameterNameAndCurves;
}

declare class TransformParameterNameAndCurves { 
	ParameterName: string;
	Translation: MovieSceneFloatChannel;
	Rotation: MovieSceneFloatChannel;
	Scale: MovieSceneFloatChannel;
	clone() : TransformParameterNameAndCurves;
	static C(Other: UObject | any): TransformParameterNameAndCurves;
}

declare class MovieSceneParameterSection extends MovieSceneSection { 
	BoolParameterNamesAndCurves: BoolParameterNameAndCurve[];
	ScalarParameterNamesAndCurves: ScalarParameterNameAndCurve[];
	Vector2DParameterNamesAndCurves: Vector2DParameterNameAndCurves[];
	VectorParameterNamesAndCurves: VectorParameterNameAndCurves[];
	ColorParameterNamesAndCurves: ColorParameterNameAndCurves[];
	TransformParameterNamesAndCurves: TransformParameterNameAndCurves[];
	static Load(ResourceName: string): MovieSceneParameterSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneParameterSection;
	static GetDefaultObject(): MovieSceneParameterSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneParameterSection;
	RemoveVectorParameter(InParameterName: string): boolean;
	RemoveVector2DParameter(InParameterName: string): boolean;
	RemoveTransformParameter(InParameterName: string): boolean;
	RemoveScalarParameter(InParameterName: string): boolean;
	RemoveColorParameter(InParameterName: string): boolean;
	RemoveBoolParameter(InParameterName: string): boolean;
	GetParameterNames(ParameterNames?: Set<string>): {ParameterNames: Set<string>};
	AddVectorParameterKey(InParameterName: string,InTime: FrameNumber,InValue: Vector): void;
	AddVector2DParameterKey(InParameterName: string,InTime: FrameNumber,InValue: Vector2D): void;
	AddTransformParameterKey(InParameterName: string,InTime: FrameNumber,InValue: Transform): void;
	AddScalarParameterKey(InParameterName: string,InTime: FrameNumber,InValue: number): void;
	AddColorParameterKey(InParameterName: string,InTime: FrameNumber,InValue: LinearColor): void;
	AddBoolParameterKey(InParameterName: string,InTime: FrameNumber,InValue: boolean): void;
	static C(Other: UObject | any): MovieSceneParameterSection;
}

declare class MovieSceneTransformMask { 
	mask: number;
	clone() : MovieSceneTransformMask;
	static C(Other: UObject | any): MovieSceneTransformMask;
}

declare class ChannelMapInfo { 
	ControlIndex: number;
	TotalChannelIndex: number;
	ChannelIndex: number;
	ParentControlIndex: number;
	ChannelTypeName: string;
	bDoesHaveSpace: boolean;
	SpaceChannelIndex: number;
	MaskIndex: number;
	CategoryIndex: number;
	ConstraintsIndex: number[];
	clone() : ChannelMapInfo;
	static C(Other: UObject | any): ChannelMapInfo;
}

declare class MovieSceneByteChannel extends MovieSceneChannel { 
	Times: FrameNumber[];
	DefaultValue: number;
	bHasDefaultValue: boolean;
	Values: number[];
	Enum: Enum;
	clone() : MovieSceneByteChannel;
	static C(Other: UObject | any): MovieSceneByteChannel;
}

declare class EnumParameterNameAndCurve { 
	ParameterName: string;
	ParameterCurve: MovieSceneByteChannel;
	clone() : EnumParameterNameAndCurve;
	static C(Other: UObject | any): EnumParameterNameAndCurve;
}

declare class MovieSceneIntegerChannel extends MovieSceneChannel { 
	Times: FrameNumber[];
	DefaultValue: number;
	bHasDefaultValue: boolean;
	Values: number[];
	clone() : MovieSceneIntegerChannel;
	static C(Other: UObject | any): MovieSceneIntegerChannel;
}

declare class IntegerParameterNameAndCurve { 
	ParameterName: string;
	ParameterCurve: MovieSceneIntegerChannel;
	clone() : IntegerParameterNameAndCurve;
	static C(Other: UObject | any): IntegerParameterNameAndCurve;
}

declare type EMovieSceneControlRigSpaceType = 'Parent' | 'World' | 'ControlRig' | 'EMovieSceneControlRigSpaceType_MAX';
declare var EMovieSceneControlRigSpaceType : { Parent:'Parent',World:'World',ControlRig:'ControlRig',EMovieSceneControlRigSpaceType_MAX:'EMovieSceneControlRigSpaceType_MAX', };
declare class MovieSceneControlRigSpaceBaseKey { 
	SpaceType: EMovieSceneControlRigSpaceType;
	ControlRigElement: RigElementKey;
	clone() : MovieSceneControlRigSpaceBaseKey;
	static C(Other: UObject | any): MovieSceneControlRigSpaceBaseKey;
}

declare class MovieSceneControlRigSpaceChannel extends MovieSceneChannel { 
	KeyTimes: FrameNumber[];
	KeyValues: MovieSceneControlRigSpaceBaseKey[];
	clone() : MovieSceneControlRigSpaceChannel;
	static C(Other: UObject | any): MovieSceneControlRigSpaceChannel;
}

declare class SpaceControlNameAndChannel { 
	ControlName: string;
	SpaceCurve: MovieSceneControlRigSpaceChannel;
	clone() : SpaceControlNameAndChannel;
	static C(Other: UObject | any): SpaceControlNameAndChannel;
}

declare class MovieSceneConstraintChannel extends MovieSceneBoolChannel { 
	clone() : MovieSceneConstraintChannel;
	static C(Other: UObject | any): MovieSceneConstraintChannel;
}

declare class ConstraintAndActiveChannel { 
	Constraint: TickableConstraint;
	ActiveChannel: MovieSceneConstraintChannel;
	ConstraintCopyToSpawn: TickableConstraint;
	clone() : ConstraintAndActiveChannel;
	static C(Other: UObject | any): ConstraintAndActiveChannel;
}

declare class MovieSceneControlRigParameterSection extends MovieSceneParameterSection { 
	ControlRig: ControlRig;
	ControlRigClass: UnrealEngineClass;
	ControlsMask: boolean[];
	TransformMask: MovieSceneTransformMask;
	Weight: MovieSceneFloatChannel;
	ControlChannelMap: Map<string, ChannelMapInfo>;
	EnumParameterNamesAndCurves: EnumParameterNameAndCurve[];
	IntegerParameterNamesAndCurves: IntegerParameterNameAndCurve[];
	SpaceChannels: SpaceControlNameAndChannel[];
	ConstraintsChannels: ConstraintAndActiveChannel[];
	static Load(ResourceName: string): MovieSceneControlRigParameterSection;
	static Find(Outer: UObject, ResourceName: string): MovieSceneControlRigParameterSection;
	static GetDefaultObject(): MovieSceneControlRigParameterSection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneControlRigParameterSection;
	static C(Other: UObject | any): MovieSceneControlRigParameterSection;
}

declare class ControlFindReplaceString { 
	Find: string;
	Replace: string;
	clone() : ControlFindReplaceString;
	static C(Other: UObject | any): ControlFindReplaceString;
}

declare type FControlRigChannelEnum = 'Bool' | 'Enum' | 'Integer' | 'Float' | 'Vector2DX' | 'Vector2DY' | 'PositionX' | 'PositionY' | 'PositionZ' | 'RotatorX' | 'RotatorY' | 'RotatorZ' | 'ScaleX' | 'ScaleY' | 'ScaleZ' | 'FControlRigChannelEnum_MAX';
declare var FControlRigChannelEnum : { Bool:'Bool',Enum:'Enum',Integer:'Integer',Float:'Float',Vector2DX:'Vector2DX',Vector2DY:'Vector2DY',PositionX:'PositionX',PositionY:'PositionY',PositionZ:'PositionZ',RotatorX:'RotatorX',RotatorY:'RotatorY',RotatorZ:'RotatorZ',ScaleX:'ScaleX',ScaleY:'ScaleY',ScaleZ:'ScaleZ',FControlRigChannelEnum_MAX:'FControlRigChannelEnum_MAX', };
declare type FTransformChannelEnum = 'TranslateX' | 'TranslateY' | 'TranslateZ' | 'RotateX' | 'RotateY' | 'RotateZ' | 'ScaleX' | 'ScaleY' | 'ScaleZ' | 'FTransformChannelEnum_MAX';
declare var FTransformChannelEnum : { TranslateX:'TranslateX',TranslateY:'TranslateY',TranslateZ:'TranslateZ',RotateX:'RotateX',RotateY:'RotateY',RotateZ:'RotateZ',ScaleX:'ScaleX',ScaleY:'ScaleY',ScaleZ:'ScaleZ',FTransformChannelEnum_MAX:'FTransformChannelEnum_MAX', };
declare class ControlToTransformMappings { 
	ControlChannel: FControlRigChannelEnum;
	FBXChannel: FTransformChannelEnum;
	bNegate: boolean;
	clone() : ControlToTransformMappings;
	static C(Other: UObject | any): ControlToTransformMappings;
}

declare class MovieSceneUserImportFBXControlRigSettings extends UObject { 
	ImportedFileName: string;
	ImportedStartTime: FrameNumber;
	ImportedEndTime: FrameNumber;
	ImportedNodeNames: string[];
	ImportedFrameRate: string;
	FindAndReplaceStrings: ControlFindReplaceString[];
	bForceFrontXAxis: boolean;
	bConvertSceneUnit: boolean;
	ImportUniformScale: number;
	bImportOntoSelectedControls: boolean;
	TimeToInsertOrReplaceAnimation: FrameNumber;
	bInsertAnimation: boolean;
	bSpecifyTimeRange: boolean;
	StartTimeRange: FrameNumber;
	EndTimeRange: FrameNumber;
	ControlChannelMappings: ControlToTransformMappings[];
	static Load(ResourceName: string): MovieSceneUserImportFBXControlRigSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneUserImportFBXControlRigSettings;
	static GetDefaultObject(): MovieSceneUserImportFBXControlRigSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneUserImportFBXControlRigSettings;
	static C(Other: UObject | any): MovieSceneUserImportFBXControlRigSettings;
}

declare class SequencerBoundObjects { 
	BindingProxy: MovieSceneBindingProxy;
	BoundObjects: UObject[];
	clone() : SequencerBoundObjects;
	static C(Other: UObject | any): SequencerBoundObjects;
}

declare class MovieSceneUserImportFBXSettings extends UObject { 
	bMatchByNameOnly: boolean;
	bForceFrontXAxis: boolean;
	bConvertSceneUnit: boolean;
	ImportUniformScale: number;
	bCreateCameras: boolean;
	bReplaceTransformTrack: boolean;
	bReduceKeys: boolean;
	ReduceKeysTolerance: number;
	static Load(ResourceName: string): MovieSceneUserImportFBXSettings;
	static Find(Outer: UObject, ResourceName: string): MovieSceneUserImportFBXSettings;
	static GetDefaultObject(): MovieSceneUserImportFBXSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): MovieSceneUserImportFBXSettings;
	static C(Other: UObject | any): MovieSceneUserImportFBXSettings;
}

declare class AudioInputDeviceInfo { 
	DeviceName: string;
	DeviceID: string;
	InputChannels: number;
	PreferredSampleRate: number;
	bSupportsHardwareAEC: boolean;
	clone() : AudioInputDeviceInfo;
	static C(Other: UObject | any): AudioInputDeviceInfo;
	Conv_AudioInputDeviceInfoToString(): string;
	static Conv_AudioInputDeviceInfoToString(Info: AudioInputDeviceInfo): string;
}

declare class ActorLayer { 
	Name: string;
	clone() : ActorLayer;
	static C(Other: UObject | any): ActorLayer;
}

declare class URL { 
	Protocol: string;
	Host: string;
	Port: number;
	Valid: number;
	Map: string;
	RedirectURL: string;
	Op: string[];
	Portal: string;
	clone() : URL;
	static C(Other: UObject | any): URL;
}

declare class NavDataConfig extends NavAgentProperties { 
	Name: string;
	Color: Color;
	DefaultQueryExtent: Vector;
	NavigationDataClass: UnrealEngineClass;
	NavDataClass: Class;
	clone() : NavDataConfig;
	static C(Other: UObject | any): NavDataConfig;
}

declare type ERuntimeGenerationType = 'Static' | 'DynamicModifiersOnly' | 'Dynamic' | 'LegacyGeneration' | 'ERuntimeGenerationType_MAX';
declare var ERuntimeGenerationType : { Static:'Static',DynamicModifiersOnly:'DynamicModifiersOnly',Dynamic:'Dynamic',LegacyGeneration:'LegacyGeneration',ERuntimeGenerationType_MAX:'ERuntimeGenerationType_MAX', };
declare class SupportedAreaData { 
	AreaClassName: string;
	AreaID: number;
	AreaClass: UnrealEngineClass;
	clone() : SupportedAreaData;
	static C(Other: UObject | any): SupportedAreaData;
}

declare class NavigationData extends Actor { 
	RenderingComp: PrimitiveComponent;
	NavDataConfig: NavDataConfig;
	bEnableDrawing: boolean;
	bForceRebuildOnLoad: boolean;
	bAutoDestroyWhenNoNavigation: boolean;
	bCanBeMainNavData: boolean;
	bCanSpawnOnRebuild: boolean;
	bRebuildAtRuntime: boolean;
	RuntimeGeneration: ERuntimeGenerationType;
	ObservedPathsTickInterval: number;
	DataVersion: number;
	SupportedAreas: SupportedAreaData[];
	static GetDefaultObject(): NavigationData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationData;
	static C(Other: UObject | any): NavigationData;
}

declare class RecastNavMeshTileGenerationDebug { 
	bEnabled: boolean;
	TileCoordinate: IntVector;
	bHeightfieldSolidFromRasterization: boolean;
	bHeightfieldSolidPostInclusionBoundsFiltering: boolean;
	bHeightfieldSolidPostHeightFiltering: boolean;
	bCompactHeightfield: boolean;
	bCompactHeightfieldEroded: boolean;
	bCompactHeightfieldRegions: boolean;
	bCompactHeightfieldDistances: boolean;
	bTileCacheLayerAreas: boolean;
	bTileCacheLayerRegions: boolean;
	bTileCacheContours: boolean;
	bTileCachePolyMesh: boolean;
	bTileCacheDetailMesh: boolean;
	clone() : RecastNavMeshTileGenerationDebug;
	static C(Other: UObject | any): RecastNavMeshTileGenerationDebug;
}

declare type ERecastPartitioning = 'Monotone' | 'Watershed' | 'ChunkyMonotone' | 'ERecastPartitioning_MAX';
declare var ERecastPartitioning : { Monotone:'Monotone',Watershed:'Watershed',ChunkyMonotone:'ChunkyMonotone',ERecastPartitioning_MAX:'ERecastPartitioning_MAX', };
declare class NavArea extends NavAreaBase { 
	DefaultCost: number;
	FixedAreaEnteringCost: number;
	DrawColor: Color;
	SupportedAgents: NavAgentSelector;
	bSupportsAgent0: boolean;
	bSupportsAgent1: boolean;
	bSupportsAgent2: boolean;
	bSupportsAgent3: boolean;
	bSupportsAgent4: boolean;
	bSupportsAgent5: boolean;
	bSupportsAgent6: boolean;
	bSupportsAgent7: boolean;
	bSupportsAgent8: boolean;
	bSupportsAgent9: boolean;
	bSupportsAgent10: boolean;
	bSupportsAgent11: boolean;
	bSupportsAgent12: boolean;
	bSupportsAgent13: boolean;
	bSupportsAgent14: boolean;
	bSupportsAgent15: boolean;
	static Load(ResourceName: string): NavArea;
	static Find(Outer: UObject, ResourceName: string): NavArea;
	static GetDefaultObject(): NavArea;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavArea;
	static C(Other: UObject | any): NavArea;
}

declare class RecastNavMesh extends NavigationData { 
	bDrawTriangleEdges: boolean;
	bDrawPolyEdges: boolean;
	bDrawFilledPolys: boolean;
	bDrawNavMeshEdges: boolean;
	bDrawTileBounds: boolean;
	bDrawPathCollidingGeometry: boolean;
	bDrawTileLabels: boolean;
	bDrawPolygonLabels: boolean;
	bDrawDefaultPolygonCost: boolean;
	bDrawPolygonFlags: boolean;
	bDrawLabelsOnPathNodes: boolean;
	bDrawNavLinks: boolean;
	bDrawFailedNavLinks: boolean;
	bDrawClusters: boolean;
	bDrawOctree: boolean;
	bDrawOctreeDetails: boolean;
	bDrawMarkedForbiddenPolys: boolean;
	bDistinctlyDrawTilesBeingBuilt: boolean;
	DrawOffset: number;
	TileGenerationDebug: RecastNavMeshTileGenerationDebug;
	bFixedTilePoolSize: boolean;
	TilePoolSize: number;
	TileSizeUU: number;
	CellSize: number;
	CellHeight: number;
	AgentRadius: number;
	AgentHeight: number;
	AgentMaxSlope: number;
	AgentMaxStepHeight: number;
	MinRegionArea: number;
	MergeRegionSize: number;
	MaxSimplificationError: number;
	MaxSimultaneousTileGenerationJobsCount: number;
	TileNumberHardLimit: number;
	PolyRefTileBits: number;
	PolyRefNavPolyBits: number;
	PolyRefSaltBits: number;
	NavMeshOriginOffset: Vector;
	DefaultDrawDistance: number;
	DefaultMaxSearchNodes: number;
	DefaultMaxHierarchicalSearchNodes: number;
	RegionPartitioning: ERecastPartitioning;
	LayerPartitioning: ERecastPartitioning;
	RegionChunkSplits: number;
	LayerChunkSplits: number;
	bSortNavigationAreasByCost: boolean;
	bIsWorldPartitioned: boolean;
	bPerformVoxelFiltering: boolean;
	bMarkLowHeightAreas: boolean;
	bUseExtraTopCellWhenMarkingAreas: boolean;
	bFilterLowSpanSequences: boolean;
	bFilterLowSpanFromTileCache: boolean;
	bDoFullyAsyncNavDataGathering: boolean;
	bUseBetterOffsetsFromCorners: boolean;
	bStoreEmptyTileLayers: boolean;
	bUseVirtualFilters: boolean;
	bUseVirtualGeometryFilteringAndDirtying: boolean;
	bAllowNavLinkAsPathEnd: boolean;
	TimeSliceFilterLedgeSpansMaxYProcess: number;
	TimeSliceLongDurationDebug: number;
	bAllowWorldPartitionedNavMesh: boolean;
	bUseVoxelCache: boolean;
	TileSetUpdateInterval: number;
	HeuristicScale: number;
	VerticalDeviationFromGroundCompensation: number;
	static GetDefaultObject(): RecastNavMesh;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): RecastNavMesh;
	K2_ReplaceAreaInTileBounds(Bounds: Box,OldArea: UnrealEngineClass,NewArea: UnrealEngineClass,ReplaceLinks: boolean): boolean;
	static C(Other: UObject | any): RecastNavMesh;
}

declare type ENiagaraScriptLibraryVisibility = 'Invalid' | 'Unexposed' | 'Library' | 'Hidden' | 'ENiagaraScriptLibraryVisibility_MAX';
declare var ENiagaraScriptLibraryVisibility : { Invalid:'Invalid',Unexposed:'Unexposed',Library:'Library',Hidden:'Hidden',ENiagaraScriptLibraryVisibility_MAX:'ENiagaraScriptLibraryVisibility_MAX', };
declare type ENiagaraScriptTemplateSpecification = 'None' | 'Template' | 'Behavior' | 'ENiagaraScriptTemplateSpecification_MAX';
declare var ENiagaraScriptTemplateSpecification : { None:'None',Template:'Template',Behavior:'Behavior',ENiagaraScriptTemplateSpecification_MAX:'ENiagaraScriptTemplateSpecification_MAX', };
declare class NiagaraScriptBase extends UObject { 
	static Load(ResourceName: string): NiagaraScriptBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraScriptBase;
	static GetDefaultObject(): NiagaraScriptBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScriptBase;
	static C(Other: UObject | any): NiagaraScriptBase;
}

declare class NiagaraValidationRule extends UObject { 
	static Load(ResourceName: string): NiagaraValidationRule;
	static Find(Outer: UObject, ResourceName: string): NiagaraValidationRule;
	static GetDefaultObject(): NiagaraValidationRule;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraValidationRule;
	static C(Other: UObject | any): NiagaraValidationRule;
}

declare type ENiagaraScriptUsage = 'Function' | 'Module' | 'DynamicInput' | 'ParticleSpawnScript' | 'ParticleSpawnScriptInterpolated' | 'ParticleUpdateScript' | 'ParticleEventScript' | 'ParticleSimulationStageScript' | 'ParticleGPUComputeScript' | 'EmitterSpawnScript' | 'EmitterUpdateScript' | 'SystemSpawnScript' | 'SystemUpdateScript' | 'ENiagaraScriptUsage_MAX';
declare var ENiagaraScriptUsage : { Function:'Function',Module:'Module',DynamicInput:'DynamicInput',ParticleSpawnScript:'ParticleSpawnScript',ParticleSpawnScriptInterpolated:'ParticleSpawnScriptInterpolated',ParticleUpdateScript:'ParticleUpdateScript',ParticleEventScript:'ParticleEventScript',ParticleSimulationStageScript:'ParticleSimulationStageScript',ParticleGPUComputeScript:'ParticleGPUComputeScript',EmitterSpawnScript:'EmitterSpawnScript',EmitterUpdateScript:'EmitterUpdateScript',SystemSpawnScript:'SystemSpawnScript',SystemUpdateScript:'SystemUpdateScript',ENiagaraScriptUsage_MAX:'ENiagaraScriptUsage_MAX', };
declare class NiagaraAssetVersion { 
	MajorVersion: number;
	MinorVersion: number;
	VersionGuid: Guid;
	bIsVisibleInVersionSelector: boolean;
	clone() : NiagaraAssetVersion;
	static C(Other: UObject | any): NiagaraAssetVersion;
}

declare type ENiagaraModuleDependencyType = 'PreDependency' | 'PostDependency' | 'ENiagaraModuleDependencyType_MAX';
declare var ENiagaraModuleDependencyType : { PreDependency:'PreDependency',PostDependency:'PostDependency',ENiagaraModuleDependencyType_MAX:'ENiagaraModuleDependencyType_MAX', };
declare type ENiagaraModuleDependencyScriptConstraint = 'SameScript' | 'AllScripts' | 'ENiagaraModuleDependencyScriptConstraint_MAX';
declare var ENiagaraModuleDependencyScriptConstraint : { SameScript:'SameScript',AllScripts:'AllScripts',ENiagaraModuleDependencyScriptConstraint_MAX:'ENiagaraModuleDependencyScriptConstraint_MAX', };
declare class NiagaraModuleDependency { 
	ID: string;
	Type: ENiagaraModuleDependencyType;
	ScriptConstraint: ENiagaraModuleDependencyScriptConstraint;
	RequiredVersion: string;
	OnlyEvaluateInScriptUsage: number;
	Description: string;
	clone() : NiagaraModuleDependency;
	static C(Other: UObject | any): NiagaraModuleDependency;
}

declare class NiagaraConvertInPlaceUtilityBase extends UObject { 
	static Load(ResourceName: string): NiagaraConvertInPlaceUtilityBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraConvertInPlaceUtilityBase;
	static GetDefaultObject(): NiagaraConvertInPlaceUtilityBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraConvertInPlaceUtilityBase;
	static C(Other: UObject | any): NiagaraConvertInPlaceUtilityBase;
}

declare type ENiagaraNumericOutputTypeSelectionMode = 'None' | 'Largest' | 'Smallest' | 'Scalar' | 'Custom' | 'ENiagaraNumericOutputTypeSelectionMode_MAX';
declare var ENiagaraNumericOutputTypeSelectionMode : { None:'None',Largest:'Largest',Smallest:'Smallest',Scalar:'Scalar',Custom:'Custom',ENiagaraNumericOutputTypeSelectionMode_MAX:'ENiagaraNumericOutputTypeSelectionMode_MAX', };
declare class NiagaraStackSection { 
	SectionIdentifier: string;
	SectionDisplayName: string;
	Categories: string[];
	bEnabled: boolean;
	clone() : NiagaraStackSection;
	static C(Other: UObject | any): NiagaraStackSection;
}

declare class NiagaraTypeDefinitionHandle { 
	RegisteredTypeIndex: number;
	clone() : NiagaraTypeDefinitionHandle;
	static C(Other: UObject | any): NiagaraTypeDefinitionHandle;
}

declare class NiagaraTypeDefinition { 
	ClassStructOrEnum: UObject;
	UnderlyingType: number;
	Flags: number;
	struct: Struct;
	Enum: Enum;
	clone() : NiagaraTypeDefinition;
	static C(Other: UObject | any): NiagaraTypeDefinition;
}

declare class NiagaraVariableBase { 
	Name: string;
	TypeDefHandle: NiagaraTypeDefinitionHandle;
	TypeDef: NiagaraTypeDefinition;
	clone() : NiagaraVariableBase;
	static C(Other: UObject | any): NiagaraVariableBase;
}

declare class NiagaraCompileHash { 
	DataHash: number[];
	clone() : NiagaraCompileHash;
	static C(Other: UObject | any): NiagaraCompileHash;
}

declare class NiagaraVMExecutableDataId { 
	CompilerVersionID: Guid;
	ScriptUsageType: ENiagaraScriptUsage;
	ScriptUsageTypeID: Guid;
	AdditionalDefines: string[];
	AdditionalVariables: NiagaraVariableBase[];
	bUsesRapidIterationParams: boolean;
	bDisableDebugSwitches: boolean;
	bInterpolatedSpawn: boolean;
	bRequiresPersistentIDs: boolean;
	BaseScriptID: Guid;
	BaseScriptCompileHash: NiagaraCompileHash;
	ReferencedCompileHashes: NiagaraCompileHash[];
	ScriptVersionID: Guid;
	clone() : NiagaraVMExecutableDataId;
	static C(Other: UObject | any): NiagaraVMExecutableDataId;
}

declare type ENiagaraPythonUpdateScriptReference = 'None' | 'ScriptAsset' | 'DirectTextEntry' | 'ENiagaraPythonUpdateScriptReference_MAX';
declare var ENiagaraPythonUpdateScriptReference : { None:'None',ScriptAsset:'ScriptAsset',DirectTextEntry:'DirectTextEntry',ENiagaraPythonUpdateScriptReference_MAX:'ENiagaraPythonUpdateScriptReference_MAX', };
declare class FilePath { 
	FilePath: string;
	clone() : FilePath;
	static C(Other: UObject | any): FilePath;
}

declare class NiagaraParameterDefinitionsBase extends UObject { 
	UniqueId: Guid;
	static Load(ResourceName: string): NiagaraParameterDefinitionsBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterDefinitionsBase;
	static GetDefaultObject(): NiagaraParameterDefinitionsBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterDefinitionsBase;
	static C(Other: UObject | any): NiagaraParameterDefinitionsBase;
}

declare class ParameterDefinitionsSubscription { 
	Definitions: NiagaraParameterDefinitionsBase;
	DefinitionsId: Guid;
	CachedChangeIdHash: number;
	clone() : ParameterDefinitionsSubscription;
	static C(Other: UObject | any): ParameterDefinitionsSubscription;
}

declare class NiagaraScriptSourceBase extends UObject { 
	static Load(ResourceName: string): NiagaraScriptSourceBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraScriptSourceBase;
	static GetDefaultObject(): NiagaraScriptSourceBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScriptSourceBase;
	static C(Other: UObject | any): NiagaraScriptSourceBase;
}

declare class VersionedNiagaraScriptData { 
	Version: NiagaraAssetVersion;
	VersionChangeDescription: string;
	ModuleUsageBitmask: number;
	Category: string;
	bSuggested: boolean;
	ProvidedDependencies: string[];
	RequiredDependencies: NiagaraModuleDependency[];
	bDeprecated: boolean;
	DeprecationMessage: string;
	DeprecationRecommendation: NiagaraScript;
	ConversionUtility: UnrealEngineClass;
	bExperimental: boolean;
	ExperimentalMessage: string;
	NoteMessage: string;
	LibraryVisibility: ENiagaraScriptLibraryVisibility;
	NumericOutputTypeSelectionMode: ENiagaraNumericOutputTypeSelectionMode;
	Description: string;
	Keywords: string;
	CollapsedViewFormat: string;
	bCanBeUsedForTypeConversions: boolean;
	ScriptMetaData: Map<string, string>;
	InputSections: NiagaraStackSection[];
	LastGeneratedVMId: NiagaraVMExecutableDataId;
	UpdateScriptExecution: ENiagaraPythonUpdateScriptReference;
	PythonUpdateScript: string;
	ScriptAsset: FilePath;
	ParameterDefinitionsSubscriptions: ParameterDefinitionsSubscription[];
	Source: NiagaraScriptSourceBase;
	clone() : VersionedNiagaraScriptData;
	static C(Other: UObject | any): VersionedNiagaraScriptData;
}

declare class NiagaraVariable extends NiagaraVariableBase { 
	VarData: number[];
	clone() : NiagaraVariable;
	static C(Other: UObject | any): NiagaraVariable;
}

declare type ENiagaraStructConversionType = 'CopyOnly' | 'DoubleToFloat' | 'Vector2' | 'Vector3' | 'Vector4' | 'Quat' | 'ENiagaraStructConversionType_MAX';
declare var ENiagaraStructConversionType : { CopyOnly:'CopyOnly',DoubleToFloat:'DoubleToFloat',Vector2:'Vector2',Vector3:'Vector3',Vector4:'Vector4',Quat:'Quat',ENiagaraStructConversionType_MAX:'ENiagaraStructConversionType_MAX', };
declare class NiagaraStructConversionStep { 
	SourceBytes: number;
	SourceOffset: number;
	SimulationBytes: number;
	SimulationOffset: number;
	ConversionType: ENiagaraStructConversionType;
	clone() : NiagaraStructConversionStep;
	static C(Other: UObject | any): NiagaraStructConversionStep;
}

declare class NiagaraLwcStructConverter { 
	ConversionSteps: NiagaraStructConversionStep[];
	clone() : NiagaraLwcStructConverter;
	static C(Other: UObject | any): NiagaraLwcStructConverter;
}

declare class NiagaraVariableWithOffset extends NiagaraVariableBase { 
	Offset: number;
	StructConverter: NiagaraLwcStructConverter;
	clone() : NiagaraVariableWithOffset;
	static C(Other: UObject | any): NiagaraVariableWithOffset;
}

declare class NiagaraMergeable extends UObject { 
	MergeId: Guid;
	static Load(ResourceName: string): NiagaraMergeable;
	static Find(Outer: UObject, ResourceName: string): NiagaraMergeable;
	static GetDefaultObject(): NiagaraMergeable;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraMergeable;
	static C(Other: UObject | any): NiagaraMergeable;
}

declare class NiagaraDataInterfaceBase extends NiagaraMergeable { 
	static Load(ResourceName: string): NiagaraDataInterfaceBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterfaceBase;
	static GetDefaultObject(): NiagaraDataInterfaceBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterfaceBase;
	static C(Other: UObject | any): NiagaraDataInterfaceBase;
}

declare class NiagaraDataInterface extends NiagaraDataInterfaceBase { 
	static Load(ResourceName: string): NiagaraDataInterface;
	static Find(Outer: UObject, ResourceName: string): NiagaraDataInterface;
	static GetDefaultObject(): NiagaraDataInterface;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraDataInterface;
	static C(Other: UObject | any): NiagaraDataInterface;
}

declare class NiagaraPositionSource { 
	Name: string;
	Value: Vector;
	clone() : NiagaraPositionSource;
	static C(Other: UObject | any): NiagaraPositionSource;
}

declare class NiagaraParameterStore { 
	Owner: UObject;
	ParameterOffsets: Map<NiagaraVariable, number>;
	SortedParameterOffsets: NiagaraVariableWithOffset[];
	ParameterData: number[];
	DataInterfaces: NiagaraDataInterface[];
	UObjects: UObject[];
	OriginalPositionData: NiagaraPositionSource[];
	DebugName: string;
	ParameterGuidMapping: Map<NiagaraVariable, Guid>;
	clone() : NiagaraParameterStore;
	static C(Other: UObject | any): NiagaraParameterStore;
}

declare class NiagaraScriptExecutionPaddingInfo { 
	SrcOffset: number;
	DestOffset: number;
	SrcSize: number;
	DestSize: number;
	clone() : NiagaraScriptExecutionPaddingInfo;
	static C(Other: UObject | any): NiagaraScriptExecutionPaddingInfo;
}

declare class NiagaraScriptExecutionParameterStore extends NiagaraParameterStore { 
	ParameterSize: number;
	PaddedParameterSize: number;
	PaddingInfo: NiagaraScriptExecutionPaddingInfo[];
	bInitialized: boolean;
	clone() : NiagaraScriptExecutionParameterStore;
	static C(Other: UObject | any): NiagaraScriptExecutionParameterStore;
}

declare class NiagaraBoundParameter { 
	Parameter: NiagaraVariable;
	SrcOffset: number;
	DestOffset: number;
	clone() : NiagaraBoundParameter;
	static C(Other: UObject | any): NiagaraBoundParameter;
}

declare class NiagaraVMExecutableByteCode { 
	Data: number[];
	UncompressedSize: number;
	clone() : NiagaraVMExecutableByteCode;
	static C(Other: UObject | any): NiagaraVMExecutableByteCode;
}

declare class NiagaraParameters { 
	Parameters: NiagaraVariable[];
	clone() : NiagaraParameters;
	static C(Other: UObject | any): NiagaraParameters;
}

declare class NiagaraCompileDependency { 
	LinkerErrorMessage: string;
	NodeGuid: Guid;
	PinGuid: Guid;
	StackGuids: Guid[];
	DependentVariable: NiagaraVariableBase;
	bDependentVariableFromCustomIterationNamespace: boolean;
	clone() : NiagaraCompileDependency;
	static C(Other: UObject | any): NiagaraCompileDependency;
}

declare class NiagaraCompilerTag { 
	Variable: NiagaraVariable;
	StringValue: string;
	clone() : NiagaraCompilerTag;
	static C(Other: UObject | any): NiagaraCompilerTag;
}

declare class NiagaraScriptDataUsageInfo { 
	bReadsAttributeData: boolean;
	clone() : NiagaraScriptDataUsageInfo;
	static C(Other: UObject | any): NiagaraScriptDataUsageInfo;
}

declare class NiagaraFunctionSignature { 
	Name: string;
	Inputs: NiagaraVariable[];
	Outputs: NiagaraVariable[];
	OwnerName: string;
	bRequiresContext: boolean;
	bRequiresExecPin: boolean;
	bMemberFunction: boolean;
	bExperimental: boolean;
	ExperimentalMessage: string;
	FunctionVersion: number;
	bSupportsCPU: boolean;
	bSupportsGPU: boolean;
	bWriteFunction: boolean;
	bReadFunction: boolean;
	bSoftDeprecatedFunction: boolean;
	bIsCompileTagGenerator: boolean;
	bHidden: boolean;
	ModuleUsageBitmask: number;
	ContextStageIndex: number;
	FunctionSpecifiers: Map<string, string>;
	Description: string;
	InputDescriptions: Map<NiagaraVariableBase, string>;
	OutputDescriptions: Map<NiagaraVariableBase, string>;
	clone() : NiagaraFunctionSignature;
	static C(Other: UObject | any): NiagaraFunctionSignature;
}

declare class NiagaraScriptDataInterfaceCompileInfo { 
	Name: string;
	UserPtrIdx: number;
	Type: NiagaraTypeDefinition;
	RegisteredFunctions: NiagaraFunctionSignature[];
	RegisteredParameterMapRead: string;
	RegisteredParameterMapWrite: string;
	bIsPlaceholder: boolean;
	clone() : NiagaraScriptDataInterfaceCompileInfo;
	static C(Other: UObject | any): NiagaraScriptDataInterfaceCompileInfo;
}

declare class VMFunctionSpecifier { 
	Key: string;
	Value: string;
	clone() : VMFunctionSpecifier;
	static C(Other: UObject | any): VMFunctionSpecifier;
}

declare class VMExternalFunctionBindingInfo { 
	Name: string;
	OwnerName: string;
	InputParamLocations: boolean[];
	NumOutputs: number;
	FunctionSpecifiers: VMFunctionSpecifier[];
	Specifiers: Map<string, string>;
	clone() : VMExternalFunctionBindingInfo;
	static C(Other: UObject | any): VMExternalFunctionBindingInfo;
}

declare type ENiagaraDataSetType = 'ParticleData' | 'Shared' | 'Event' | 'ENiagaraDataSetType_MAX';
declare var ENiagaraDataSetType : { ParticleData:'ParticleData',Shared:'Shared',Event:'Event',ENiagaraDataSetType_MAX:'ENiagaraDataSetType_MAX', };
declare class NiagaraDataSetID { 
	Name: string;
	Type: ENiagaraDataSetType;
	clone() : NiagaraDataSetID;
	static C(Other: UObject | any): NiagaraDataSetID;
}

declare class NiagaraDataSetProperties { 
	ID: NiagaraDataSetID;
	Variables: NiagaraVariable[];
	clone() : NiagaraDataSetProperties;
	static C(Other: UObject | any): NiagaraDataSetProperties;
}

declare class NiagaraStatScope { 
	FullName: string;
	FriendlyName: string;
	clone() : NiagaraStatScope;
	static C(Other: UObject | any): NiagaraStatScope;
}

declare class NiagaraDataInterfaceGeneratedFunction { 
	clone() : NiagaraDataInterfaceGeneratedFunction;
	static C(Other: UObject | any): NiagaraDataInterfaceGeneratedFunction;
}

declare class NiagaraDataInterfaceGPUParamInfo { 
	DataInterfaceHLSLSymbol: string;
	DIClassName: string;
	ShaderParametersOffset: number;
	GeneratedFunctions: NiagaraDataInterfaceGeneratedFunction[];
	clone() : NiagaraDataInterfaceGPUParamInfo;
	static C(Other: UObject | any): NiagaraDataInterfaceGPUParamInfo;
}

declare class NiagaraShaderScriptExternalConstant { 
	Type: string;
	Name: string;
	clone() : NiagaraShaderScriptExternalConstant;
	static C(Other: UObject | any): NiagaraShaderScriptExternalConstant;
}

declare class NiagaraShaderScriptParametersMetadata { 
	DataInterfaceParamInfo: NiagaraDataInterfaceGPUParamInfo[];
	LooseMetadataNames: string[];
	bExternalConstantsInterpolated: boolean;
	ExternalConstants: NiagaraShaderScriptExternalConstant[];
	clone() : NiagaraShaderScriptParametersMetadata;
	static C(Other: UObject | any): NiagaraShaderScriptParametersMetadata;
}

declare type ENiagaraScriptCompileStatus = 'NCS_Unknown' | 'NCS_Dirty' | 'NCS_Error' | 'NCS_UpToDate' | 'NCS_BeingCreated' | 'NCS_UpToDateWithWarnings' | 'NCS_ComputeUpToDateWithWarnings' | 'NCS_MAX';
declare var ENiagaraScriptCompileStatus : { NCS_Unknown:'NCS_Unknown',NCS_Dirty:'NCS_Dirty',NCS_Error:'NCS_Error',NCS_UpToDate:'NCS_UpToDate',NCS_BeingCreated:'NCS_BeingCreated',NCS_UpToDateWithWarnings:'NCS_UpToDateWithWarnings',NCS_ComputeUpToDateWithWarnings:'NCS_ComputeUpToDateWithWarnings',NCS_MAX:'NCS_MAX', };
declare type ENiagaraSimStageExecuteBehavior = 'Always' | 'OnSimulationReset' | 'NotOnSimulationReset' | 'ENiagaraSimStageExecuteBehavior_MAX';
declare var ENiagaraSimStageExecuteBehavior : { Always:'Always',OnSimulationReset:'OnSimulationReset',NotOnSimulationReset:'NotOnSimulationReset',ENiagaraSimStageExecuteBehavior_MAX:'ENiagaraSimStageExecuteBehavior_MAX', };
declare type ENiagaraGpuDispatchType = 'OneD' | 'TwoD' | 'ThreeD' | 'Custom' | 'ENiagaraGpuDispatchType_MAX';
declare var ENiagaraGpuDispatchType : { OneD:'OneD',TwoD:'TwoD',ThreeD:'ThreeD',Custom:'Custom',ENiagaraGpuDispatchType_MAX:'ENiagaraGpuDispatchType_MAX', };
declare class SimulationStageMetaData { 
	SimulationStageName: string;
	EnabledBinding: string;
	ElementCountXBinding: string;
	ElementCountYBinding: string;
	ElementCountZBinding: string;
	IterationSource: string;
	ExecuteBehavior: ENiagaraSimStageExecuteBehavior;
	bWritesParticles: boolean;
	bPartialParticleUpdate: boolean;
	bParticleIterationStateEnabled: boolean;
	bOverrideElementCount: boolean;
	ParticleIterationStateBinding: string;
	ParticleIterationStateRange: IntPoint;
	OutputDestinations: string[];
	InputDataInterfaces: string[];
	NumIterations: number;
	NumIterationsBinding: string;
	GpuDispatchType: ENiagaraGpuDispatchType;
	GpuDispatchNumThreads: IntVector;
	clone() : SimulationStageMetaData;
	static C(Other: UObject | any): SimulationStageMetaData;
}

declare type FNiagaraCompileEventSeverity = 'Log' | 'Display' | 'Warning' | 'Error' | 'FNiagaraCompileEventSeverity_MAX';
declare var FNiagaraCompileEventSeverity : { Log:'Log',Display:'Display',Warning:'Warning',Error:'Error',FNiagaraCompileEventSeverity_MAX:'FNiagaraCompileEventSeverity_MAX', };
declare type FNiagaraCompileEventSource = 'Unset' | 'ScriptDependency' | 'FNiagaraCompileEventSource_MAX';
declare var FNiagaraCompileEventSource : { Unset:'Unset',ScriptDependency:'ScriptDependency',FNiagaraCompileEventSource_MAX:'FNiagaraCompileEventSource_MAX', };
declare class NiagaraCompileEvent { 
	Severity: FNiagaraCompileEventSeverity;
	Message: string;
	ShortDescription: string;
	bDismissable: boolean;
	NodeGuid: Guid;
	PinGuid: Guid;
	StackGuids: Guid[];
	Source: FNiagaraCompileEventSource;
	clone() : NiagaraCompileEvent;
	static C(Other: UObject | any): NiagaraCompileEvent;
}

declare class NiagaraVMExecutableData { 
	ByteCode: NiagaraVMExecutableByteCode;
	OptimizedByteCode: NiagaraVMExecutableByteCode;
	NumTempRegisters: number;
	NumUserPtrs: number;
	Parameters: NiagaraParameters;
	InternalParameters: NiagaraParameters;
	ExternalDependencies: NiagaraCompileDependency[];
	CompileTags: NiagaraCompilerTag[];
	ScriptLiterals: number[];
	Attributes: NiagaraVariable[];
	DataUsage: NiagaraScriptDataUsageInfo;
	DataSetToParameters: Map<string, NiagaraParameters>;
	AdditionalExternalFunctions: NiagaraFunctionSignature[];
	DataInterfaceInfo: NiagaraScriptDataInterfaceCompileInfo[];
	CalledVMExternalFunctions: VMExternalFunctionBindingInfo[];
	ReadDataSets: NiagaraDataSetID[];
	WriteDataSets: NiagaraDataSetProperties[];
	StatScopes: NiagaraStatScope[];
	LastHlslTranslation: string;
	LastHlslTranslationGPU: string;
	LastAssemblyTranslation: string;
	LastOpCount: number;
	ShaderScriptParametersMetadata: NiagaraShaderScriptParametersMetadata;
	ParameterCollectionPaths: string[];
	LastCompileStatus: ENiagaraScriptCompileStatus;
	SimulationStageMetaData: SimulationStageMetaData[];
	bReadsAttributeData: boolean;
	AttributesWritten: NiagaraVariableBase[];
	StaticVariablesWritten: NiagaraVariable[];
	ErrorMsg: string;
	CompileTime: number;
	LastCompileEvents: NiagaraCompileEvent[];
	ExperimentalContextData: number[];
	bReadsSignificanceIndex: boolean;
	bNeedsGPUContextInit: boolean;
	clone() : NiagaraVMExecutableData;
	static C(Other: UObject | any): NiagaraVMExecutableData;
}

declare class NiagaraParameterCollectionInstance extends UObject { 
	Collection: NiagaraParameterCollection;
	OverridenParameters: NiagaraVariable[];
	ParameterStorage: NiagaraParameterStore;
	static Load(ResourceName: string): NiagaraParameterCollectionInstance;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterCollectionInstance;
	static GetDefaultObject(): NiagaraParameterCollectionInstance;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterCollectionInstance;
	SetVectorParameter(InVariableName: string,InValue: Vector): void;
	SetVector4Parameter(InVariableName: string,InValue: Vector4): void;
	SetVector2DParameter(InVariableName: string,InValue: Vector2D): void;
	SetQuatParameter(InVariableName: string,InValue: Quat): void;
	SetIntParameter(InVariableName: string,InValue: number): void;
	SetFloatParameter(InVariableName: string,InValue: number): void;
	SetColorParameter(InVariableName: string,InValue: LinearColor): void;
	SetBoolParameter(InVariableName: string,InValue: boolean): void;
	GetVectorParameter(InVariableName: string): Vector;
	GetVector4Parameter(InVariableName: string): Vector4;
	GetVector2DParameter(InVariableName: string): Vector2D;
	GetQuatParameter(InVariableName: string): Quat;
	GetIntParameter(InVariableName: string): number;
	GetFloatParameter(InVariableName: string): number;
	GetColorParameter(InVariableName: string): LinearColor;
	GetBoolParameter(InVariableName: string): boolean;
	static C(Other: UObject | any): NiagaraParameterCollectionInstance;
}

declare class NiagaraParameterCollection extends UObject { 
	Namespace: string;
	Parameters: NiagaraVariable[];
	SourceMaterialCollection: MaterialParameterCollection;
	DefaultInstance: NiagaraParameterCollectionInstance;
	CompileId: Guid;
	static Load(ResourceName: string): NiagaraParameterCollection;
	static Find(Outer: UObject, ResourceName: string): NiagaraParameterCollection;
	static GetDefaultObject(): NiagaraParameterCollection;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraParameterCollection;
	static C(Other: UObject | any): NiagaraParameterCollection;
}

declare class NiagaraScriptDataInterfaceInfo { 
	DataInterface: NiagaraDataInterface;
	Name: string;
	UserPtrIdx: number;
	Type: NiagaraTypeDefinition;
	RegisteredParameterMapRead: string;
	RegisteredParameterMapWrite: string;
	clone() : NiagaraScriptDataInterfaceInfo;
	static C(Other: UObject | any): NiagaraScriptDataInterfaceInfo;
}

declare class NiagaraScript extends NiagaraScriptBase { 
	ValidationRules: NiagaraValidationRule[];
	Usage: ENiagaraScriptUsage;
	UsageId: Guid;
	ExposedVersion: Guid;
	bVersioningEnabled: boolean;
	VersionData: VersionedNiagaraScriptData[];
	RapidIterationParameters: NiagaraParameterStore;
	RapidIterationParametersCookedEditorCache: NiagaraParameterStore;
	VersionToOpenInEditor: Guid;
	UsageIndex: number;
	ModuleUsageBitmask: number;
	Category: string;
	ProvidedDependencies: string[];
	RequiredDependencies: NiagaraModuleDependency[];
	bDeprecated: boolean;
	DeprecationMessage: string;
	DeprecationRecommendation: NiagaraScript;
	ConversionUtility: UnrealEngineClass;
	bExperimental: boolean;
	ExperimentalMessage: string;
	NoteMessage: string;
	bExposeToLibrary: boolean;
	LibraryVisibility: ENiagaraScriptLibraryVisibility;
	NumericOutputTypeSelectionMode: ENiagaraNumericOutputTypeSelectionMode;
	Description: string;
	Keywords: string;
	CollapsedViewFormat: string;
	ScriptMetaData: Map<string, string>;
	Source: NiagaraScriptSourceBase;
	ScriptExecutionParamStoreCPU: NiagaraScriptExecutionParameterStore;
	ScriptExecutionParamStoreGPU: NiagaraScriptExecutionParameterStore;
	ScriptExecutionParamStore: NiagaraScriptExecutionParameterStore;
	ScriptExecutionBoundParameters: NiagaraBoundParameter[];
	CachedScriptVMId: NiagaraVMExecutableDataId;
	ActiveCompileRoots: UObject[];
	CachedScriptVM: NiagaraVMExecutableData;
	CachedParameterCollectionReferences: NiagaraParameterCollection[];
	CachedDefaultDataInterfaces: NiagaraScriptDataInterfaceInfo[];
	static Load(ResourceName: string): NiagaraScript;
	static Find(Outer: UObject, ResourceName: string): NiagaraScript;
	static GetDefaultObject(): NiagaraScript;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScript;
	RaiseOnGPUCompilationComplete(): void;
	static C(Other: UObject | any): NiagaraScript;
}

declare type ENiagaraTickBehavior = 'UsePrereqs' | 'UseComponentTickGroup' | 'ForceTickFirst' | 'ForceTickLast' | 'ENiagaraTickBehavior_MAX';
declare var ENiagaraTickBehavior : { UsePrereqs:'UsePrereqs',UseComponentTickGroup:'UseComponentTickGroup',ForceTickFirst:'ForceTickFirst',ForceTickLast:'ForceTickLast',ENiagaraTickBehavior_MAX:'ENiagaraTickBehavior_MAX', };
declare class NiagaraUserRedirectionParameterStore extends NiagaraParameterStore { 
	UserParameterRedirects: Map<NiagaraVariable, NiagaraVariable>;
	clone() : NiagaraUserRedirectionParameterStore;
	static C(Other: UObject | any): NiagaraUserRedirectionParameterStore;
}

declare type ENiagaraVariantMode = 'None' | 'Object' | 'DataInterface' | 'Bytes' | 'ENiagaraVariantMode_MAX';
declare var ENiagaraVariantMode : { None:'None',Object:'Object',DataInterface:'DataInterface',Bytes:'Bytes',ENiagaraVariantMode_MAX:'ENiagaraVariantMode_MAX', };
declare class NiagaraVariant { 
	UObject: UObject;
	DataInterface: NiagaraDataInterface;
	Bytes: number[];
	CurrentMode: ENiagaraVariantMode;
	clone() : NiagaraVariant;
	static C(Other: UObject | any): NiagaraVariant;
}

declare class NiagaraCulledComponentInfo { 
	clone() : NiagaraCulledComponentInfo;
	static C(Other: UObject | any): NiagaraCulledComponentInfo;
}

declare class NiagaraCullProxyComponent extends NiagaraComponent { 
	Instances: NiagaraCulledComponentInfo[];
	static Load(ResourceName: string): NiagaraCullProxyComponent;
	static Find(Outer: UObject, ResourceName: string): NiagaraCullProxyComponent;
	static GetDefaultObject(): NiagaraCullProxyComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraCullProxyComponent;
	static C(Other: UObject | any): NiagaraCullProxyComponent;
}

declare class TextureRenderTarget extends Texture { 
	TargetGamma: number;
	static Load(ResourceName: string): TextureRenderTarget;
	static Find(Outer: UObject, ResourceName: string): TextureRenderTarget;
	static GetDefaultObject(): TextureRenderTarget;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureRenderTarget;
	static C(Other: UObject | any): TextureRenderTarget;
}

declare type ENiagaraAgeUpdateMode = 'TickDeltaTime' | 'DesiredAge' | 'DesiredAgeNoSeek' | 'ENiagaraAgeUpdateMode_MAX';
declare var ENiagaraAgeUpdateMode : { TickDeltaTime:'TickDeltaTime',DesiredAge:'DesiredAge',DesiredAgeNoSeek:'DesiredAgeNoSeek',ENiagaraAgeUpdateMode_MAX:'ENiagaraAgeUpdateMode_MAX', };
declare class Texture2DArray extends Texture { 
	AddressX: TextureAddress;
	AddressY: TextureAddress;
	AddressZ: TextureAddress;
	SourceTextures: Texture2D[];
	bSourceGeneratedFromSourceTexturesArray: boolean;
	static Load(ResourceName: string): Texture2DArray;
	static Find(Outer: UObject, ResourceName: string): Texture2DArray;
	static GetDefaultObject(): Texture2DArray;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): Texture2DArray;
	static C(Other: UObject | any): Texture2DArray;
}

declare class VolumeTexture extends Texture { 
	Source2DTexture: Texture2D;
	SourceLightingGuid: Guid;
	Source2DTileSizeX: number;
	Source2DTileSizeY: number;
	AddressMode: TextureAddress;
	static Load(ResourceName: string): VolumeTexture;
	static Find(Outer: UObject, ResourceName: string): VolumeTexture;
	static GetDefaultObject(): VolumeTexture;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): VolumeTexture;
	static C(Other: UObject | any): VolumeTexture;
}

declare class NiagaraComponent extends FXSystemComponent { 
	Asset: NiagaraSystem;
	TickBehavior: ENiagaraTickBehavior;
	RandomSeedOffset: number;
	OverrideParameters: NiagaraUserRedirectionParameterStore;
	EditorOverridesValue: Map<string, boolean>;
	TemplateParameterOverrides: Map<NiagaraVariableBase, NiagaraVariant>;
	InstanceParameterOverrides: Map<NiagaraVariableBase, NiagaraVariant>;
	bForceSolo: boolean;
	bEnableGpuComputeDebug: boolean;
	bAutoDestroy: boolean;
	bRenderingEnabled: boolean;
	bAutoManageAttachment: boolean;
	bAutoAttachWeldSimulatedBodies: boolean;
	MaxTimeBeforeForceUpdateTransform: number;
	OnSystemFinished: UnrealEngineMulticastDelegate<(PSystem: NiagaraComponent) => void>;
	AutoAttachParent: SceneComponent;
	AutoAttachSocketName: string;
	AutoAttachLocationRule: EAttachmentRule;
	AutoAttachRotationRule: EAttachmentRule;
	AutoAttachScaleRule: EAttachmentRule;
	bWaitForCompilationOnActivate: boolean;
	bAllowScalability: boolean;
	SimCache: NiagaraSimCache;
	CullProxy: NiagaraCullProxyComponent;
	static Load(ResourceName: string): NiagaraComponent;
	static Find(Outer: UObject, ResourceName: string): NiagaraComponent;
	static GetDefaultObject(): NiagaraComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraComponent;
	SetVariableVec4(InVariableName: string,InValue: Vector4): void;
	SetVariableVec3(InVariableName: string,InValue: Vector): void;
	SetVariableVec2(InVariableName: string,InValue: Vector2D): void;
	SetVariableTextureRenderTarget(InVariableName: string,TextureRenderTarget: TextureRenderTarget): void;
	SetVariableTexture(InVariableName: string,Texture: Texture): void;
	SetVariableStaticMesh(InVariableName: string,InValue: StaticMesh): void;
	SetVariableQuat(InVariableName: string,InValue: Quat): void;
	SetVariablePosition(InVariableName: string,InValue: Vector): void;
	SetVariableObject(InVariableName: string,UObject: UObject): void;
	SetVariableMatrix(InVariableName: string,InValue: Matrix): void;
	SetVariableMaterial(InVariableName: string,UObject: MaterialInterface): void;
	SetVariableLinearColor(InVariableName: string,InValue: LinearColor): void;
	SetVariableInt(InVariableName: string,InValue: number): void;
	SetVariableFloat(InVariableName: string,InValue: number): void;
	SetVariableBool(InVariableName: string,InValue: boolean): void;
	SetVariableActor(InVariableName: string,Actor: Actor): void;
	SetTickBehavior(NewTickBehavior: ENiagaraTickBehavior): void;
	SetSystemFixedBounds(LocalBounds: Box): void;
	SetSimCache(SimCache: NiagaraSimCache,bResetSystem: boolean): void;
	SetSeekDelta(InSeekDelta: number): void;
	SetRenderingEnabled(bInRenderingEnabled: boolean): void;
	SetRandomSeedOffset(NewRandomSeedOffset: number): void;
	SetPreviewLODDistance(bEnablePreviewLODDistance: boolean,PreviewLODDistance: number,PreviewMaxDistance: number): void;
	SetPaused(bInPaused: boolean): void;
	SetNiagaraVariableVec4(InVariableName: string,InValue: Vector4): void;
	SetNiagaraVariableVec3(InVariableName: string,InValue: Vector): void;
	SetNiagaraVariableVec2(InVariableName: string,InValue: Vector2D): void;
	SetNiagaraVariableQuat(InVariableName: string,InValue: Quat): void;
	SetNiagaraVariablePosition(InVariableName: string,InValue: Vector): void;
	SetNiagaraVariableObject(InVariableName: string,UObject: UObject): void;
	SetNiagaraVariableMatrix(InVariableName: string,InValue: Matrix): void;
	SetNiagaraVariableLinearColor(InVariableName: string,InValue: LinearColor): void;
	SetNiagaraVariableInt(InVariableName: string,InValue: number): void;
	SetNiagaraVariableFloat(InVariableName: string,InValue: number): void;
	SetNiagaraVariableBool(InVariableName: string,InValue: boolean): void;
	SetNiagaraVariableActor(InVariableName: string,Actor: Actor): void;
	SetMaxSimTime(InMaxTime: number): void;
	SetLockDesiredAgeDeltaTimeToSeekDelta(bLock: boolean): void;
	SetGpuComputeDebug(bEnableDebug: boolean): void;
	SetForceSolo(bInForceSolo: boolean): void;
	SetForceLocalPlayerEffect(bIsPlayerEffect: boolean): void;
	SetEmitterFixedBounds(EmitterName: string,LocalBounds: Box): void;
	SetDesiredAge(InDesiredAge: number): void;
	SetCustomTimeDilation(Dilation: number): void;
	SetCanRenderWhileSeeking(bInCanRenderWhileSeeking: boolean): void;
	SetAutoDestroy(bInAutoDestroy: boolean): void;
	SetAsset(InAsset: NiagaraSystem,bResetExistingOverrideParameters: boolean): void;
	SetAllowScalability(bAllow: boolean): void;
	SetAgeUpdateMode(InAgeUpdateMode: ENiagaraAgeUpdateMode): void;
	SeekToDesiredAge(InDesiredAge: number): void;
	ResetSystem(): void;
	ReinitializeSystem(): void;
	IsPaused(): boolean;
	InitForPerformanceBaseline(): void;
	GetTickBehavior(): ENiagaraTickBehavior;
	GetSystemFixedBounds(): Box;
	GetSimCache(): NiagaraSimCache;
	GetSeekDelta(): number;
	GetRandomSeedOffset(): number;
	GetPreviewLODDistanceEnabled(): boolean;
	GetPreviewLODDistance(): number;
	GetNiagaraParticleValueVec3_DebugOnly(InEmitterName: string,InValueName: string): Vector[];
	GetNiagaraParticleValues_DebugOnly(InEmitterName: string,InValueName: string): number[];
	GetNiagaraParticlePositions_DebugOnly(InEmitterName: string): Vector[];
	GetMaxSimTime(): number;
	GetLockDesiredAgeDeltaTimeToSeekDelta(): boolean;
	GetForceSolo(): boolean;
	GetForceLocalPlayerEffect(): boolean;
	GetEmitterFixedBounds(EmitterName: string): Box;
	GetDesiredAge(): number;
	GetDataInterface(Name: string): NiagaraDataInterface;
	GetCustomTimeDilation(): number;
	GetAsset(): NiagaraSystem;
	GetAllowScalability(): boolean;
	GetAgeUpdateMode(): ENiagaraAgeUpdateMode;
	ClearSystemFixedBounds(): void;
	ClearSimCache(bResetSystem: boolean): void;
	ClearEmitterFixedBounds(EmitterName: string): void;
	AdvanceSimulationByTime(SimulateTime: number,TickDeltaSeconds: number): void;
	AdvanceSimulation(TickCount: number,TickDeltaSeconds: number): void;
	static C(Other: UObject | any): NiagaraComponent;
	OverrideSystemUserVariableSkeletalMeshComponent(OverrideName: string,SkeletalMeshComponent: SkeletalMeshComponent): void;
	OverrideSystemUserVariableStaticMesh(OverrideName: string,StaticMesh: StaticMesh): void;
	OverrideSystemUserVariableStaticMeshComponent(OverrideName: string,StaticMeshComponent: StaticMeshComponent): void;
	SetSkeletalMeshDataInterfaceFilteredBones(OverrideName: string,FilteredBones: string[]): void;
	SetSkeletalMeshDataInterfaceFilteredSockets(OverrideName: string,FilteredSockets: string[]): void;
	SetSkeletalMeshDataInterfaceSamplingRegions(OverrideName: string,SamplingRegions: string[]): void;
	SetTexture2DArrayObject(OverrideName: string,Texture: Texture2DArray): void;
	SetTextureObject(OverrideName: string,Texture: Texture): void;
	SetVolumeTextureObject(OverrideName: string,Texture: VolumeTexture): void;
	SetSourceActors(OverrideName: string,SourceActors: Actor[]): void;
	GetNiagaraArrayBool(OverrideName: string): boolean[];
	GetNiagaraArrayBoolValue(OverrideName: string,Index: number): boolean;
	GetNiagaraArrayColor(OverrideName: string): LinearColor[];
	GetNiagaraArrayColorValue(OverrideName: string,Index: number): LinearColor;
	GetNiagaraArrayFloat(OverrideName: string): number[];
	GetNiagaraArrayFloatValue(OverrideName: string,Index: number): number;
	GetNiagaraArrayInt32(OverrideName: string): number[];
	GetNiagaraArrayInt32Value(OverrideName: string,Index: number): number;
	GetNiagaraArrayPosition(OverrideName: string): Vector[];
	GetNiagaraArrayPositionValue(OverrideName: string,Index: number): Vector;
	GetNiagaraArrayQuat(OverrideName: string): Quat[];
	GetNiagaraArrayQuatValue(OverrideName: string,Index: number): Quat;
	GetNiagaraArrayUInt8(OverrideName: string): number[];
	GetNiagaraArrayUInt8Value(OverrideName: string,Index: number): number;
	GetNiagaraArrayVector(OverrideName: string): Vector[];
	GetNiagaraArrayVector2D(OverrideName: string): Vector2D[];
	GetNiagaraArrayVector2DValue(OverrideName: string,Index: number): Vector2D;
	GetNiagaraArrayVector4(OverrideName: string): Vector4[];
	GetNiagaraArrayVector4Value(OverrideName: string,Index: number): Vector4;
	GetNiagaraArrayVectorValue(OverrideName: string,Index: number): Vector;
	SetNiagaraArrayBool(OverrideName: string,ArrayData: boolean[]): void;
	SetNiagaraArrayBoolValue(OverrideName: string,Index: number,Value: boolean,bSizeToFit: boolean): void;
	SetNiagaraArrayColor(OverrideName: string,ArrayData: LinearColor[]): void;
	SetNiagaraArrayColorValue(OverrideName: string,Index: number,Value: LinearColor,bSizeToFit: boolean): void;
	SetNiagaraArrayFloat(OverrideName: string,ArrayData: number[]): void;
	SetNiagaraArrayFloatValue(OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	SetNiagaraArrayInt32(OverrideName: string,ArrayData: number[]): void;
	SetNiagaraArrayInt32Value(OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	SetNiagaraArrayPosition(OverrideName: string,ArrayData: Vector[]): void;
	SetNiagaraArrayPositionValue(OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
	SetNiagaraArrayQuat(OverrideName: string,ArrayData: Quat[]): void;
	SetNiagaraArrayQuatValue(OverrideName: string,Index: number,Value: Quat,bSizeToFit: boolean): void;
	SetNiagaraArrayUInt8(OverrideName: string,ArrayData: number[]): void;
	SetNiagaraArrayUInt8Value(OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	SetNiagaraArrayVector(OverrideName: string,ArrayData: Vector[]): void;
	SetNiagaraArrayVector2D(OverrideName: string,ArrayData: Vector2D[]): void;
	SetNiagaraArrayVector2DValue(OverrideName: string,Index: number,Value: Vector2D,bSizeToFit: boolean): void;
	SetNiagaraArrayVector4(OverrideName: string,ArrayData: Vector4[]): void;
	SetNiagaraArrayVector4Value(OverrideName: string,Index: number,Value: Vector4,bSizeToFit: boolean): void;
	SetNiagaraArrayVectorValue(OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
	static OverrideSystemUserVariableSkeletalMeshComponent(NiagaraSystem: NiagaraComponent,OverrideName: string,SkeletalMeshComponent: SkeletalMeshComponent): void;
	static OverrideSystemUserVariableStaticMesh(NiagaraSystem: NiagaraComponent,OverrideName: string,StaticMesh: StaticMesh): void;
	static OverrideSystemUserVariableStaticMeshComponent(NiagaraSystem: NiagaraComponent,OverrideName: string,StaticMeshComponent: StaticMeshComponent): void;
	static SetSkeletalMeshDataInterfaceFilteredBones(NiagaraSystem: NiagaraComponent,OverrideName: string,FilteredBones: string[]): void;
	static SetSkeletalMeshDataInterfaceFilteredSockets(NiagaraSystem: NiagaraComponent,OverrideName: string,FilteredSockets: string[]): void;
	static SetSkeletalMeshDataInterfaceSamplingRegions(NiagaraSystem: NiagaraComponent,OverrideName: string,SamplingRegions: string[]): void;
	static SetTexture2DArrayObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: Texture2DArray): void;
	static SetTextureObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: Texture): void;
	static SetVolumeTextureObject(NiagaraSystem: NiagaraComponent,OverrideName: string,Texture: VolumeTexture): void;
	static SetSourceActors(NiagaraSystem: NiagaraComponent,OverrideName: string,SourceActors: Actor[]): void;
	static GetNiagaraArrayBool(NiagaraSystem: NiagaraComponent,OverrideName: string): boolean[];
	static GetNiagaraArrayBoolValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): boolean;
	static GetNiagaraArrayColor(NiagaraSystem: NiagaraComponent,OverrideName: string): LinearColor[];
	static GetNiagaraArrayColorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): LinearColor;
	static GetNiagaraArrayFloat(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayFloatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayInt32(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayInt32Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayPosition(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector[];
	static GetNiagaraArrayPositionValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector;
	static GetNiagaraArrayQuat(NiagaraSystem: NiagaraComponent,OverrideName: string): Quat[];
	static GetNiagaraArrayQuatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Quat;
	static GetNiagaraArrayUInt8(NiagaraSystem: NiagaraComponent,OverrideName: string): number[];
	static GetNiagaraArrayUInt8Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): number;
	static GetNiagaraArrayVector(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector[];
	static GetNiagaraArrayVector2D(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector2D[];
	static GetNiagaraArrayVector2DValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector2D;
	static GetNiagaraArrayVector4(NiagaraSystem: NiagaraComponent,OverrideName: string): Vector4[];
	static GetNiagaraArrayVector4Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector4;
	static GetNiagaraArrayVectorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number): Vector;
	static SetNiagaraArrayBool(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: boolean[]): void;
	static SetNiagaraArrayBoolValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: boolean,bSizeToFit: boolean): void;
	static SetNiagaraArrayColor(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: LinearColor[]): void;
	static SetNiagaraArrayColorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: LinearColor,bSizeToFit: boolean): void;
	static SetNiagaraArrayFloat(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayFloatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayInt32(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayInt32Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayPosition(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector[]): void;
	static SetNiagaraArrayPositionValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
	static SetNiagaraArrayQuat(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Quat[]): void;
	static SetNiagaraArrayQuatValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Quat,bSizeToFit: boolean): void;
	static SetNiagaraArrayUInt8(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: number[]): void;
	static SetNiagaraArrayUInt8Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: number,bSizeToFit: boolean): void;
	static SetNiagaraArrayVector(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector[]): void;
	static SetNiagaraArrayVector2D(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector2D[]): void;
	static SetNiagaraArrayVector2DValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector2D,bSizeToFit: boolean): void;
	static SetNiagaraArrayVector4(NiagaraSystem: NiagaraComponent,OverrideName: string,ArrayData: Vector4[]): void;
	static SetNiagaraArrayVector4Value(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector4,bSizeToFit: boolean): void;
	static SetNiagaraArrayVectorValue(NiagaraSystem: NiagaraComponent,OverrideName: string,Index: number,Value: Vector,bSizeToFit: boolean): void;
}

declare class NiagaraSystemUpdateContext { 
	ComponentsToReset: NiagaraComponent[];
	ComponentsToReInit: NiagaraComponent[];
	ComponentsToNotifySimDestroy: NiagaraComponent[];
	SystemSimsToDestroy: NiagaraSystem[];
	SystemSimsToRecache: NiagaraSystem[];
	clone() : NiagaraSystemUpdateContext;
	static C(Other: UObject | any): NiagaraSystemUpdateContext;
}

declare type ERendererStencilMask = 'ERSM_Default' | 'ERSM_255' | 'ERSM_1' | 'ERSM_2' | 'ERSM_4' | 'ERSM_8' | 'ERSM_16' | 'ERSM_32' | 'ERSM_64' | 'ERSM_128' | 'ERSM_MAX';
declare var ERendererStencilMask : { ERSM_Default:'ERSM_Default',ERSM_255:'ERSM_255',ERSM_1:'ERSM_1',ERSM_2:'ERSM_2',ERSM_4:'ERSM_4',ERSM_8:'ERSM_8',ERSM_16:'ERSM_16',ERSM_32:'ERSM_32',ERSM_64:'ERSM_64',ERSM_128:'ERSM_128',ERSM_MAX:'ERSM_MAX', };
declare type ENiagaraScalabilityUpdateFrequency = 'SpawnOnly' | 'Low' | 'Medium' | 'High' | 'Continuous' | 'ENiagaraScalabilityUpdateFrequency_MAX';
declare var ENiagaraScalabilityUpdateFrequency : { SpawnOnly:'SpawnOnly',Low:'Low',Medium:'Medium',High:'High',Continuous:'Continuous',ENiagaraScalabilityUpdateFrequency_MAX:'ENiagaraScalabilityUpdateFrequency_MAX', };
declare type ENiagaraCullReaction = 'Deactivate' | 'DeactivateImmediate' | 'DeactivateResume' | 'DeactivateImmediateResume' | 'ENiagaraCullReaction_MAX';
declare var ENiagaraCullReaction : { Deactivate:'Deactivate',DeactivateImmediate:'DeactivateImmediate',DeactivateResume:'DeactivateResume',DeactivateImmediateResume:'DeactivateImmediateResume',ENiagaraCullReaction_MAX:'ENiagaraCullReaction_MAX', };
declare class NiagaraSignificanceHandler extends UObject { 
	static Load(ResourceName: string): NiagaraSignificanceHandler;
	static Find(Outer: UObject, ResourceName: string): NiagaraSignificanceHandler;
	static GetDefaultObject(): NiagaraSignificanceHandler;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSignificanceHandler;
	static C(Other: UObject | any): NiagaraSignificanceHandler;
}

declare class NiagaraDeviceProfileStateEntry { 
	ProfileName: string;
	QualityLevelMask: number;
	SetQualityLevelMask: number;
	clone() : NiagaraDeviceProfileStateEntry;
	static C(Other: UObject | any): NiagaraDeviceProfileStateEntry;
}

declare type ENiagaraCVarConditionResponse = 'None' | 'Enable' | 'Disable' | 'ENiagaraCVarConditionResponse_MAX';
declare var ENiagaraCVarConditionResponse : { None:'None',Enable:'Enable',Disable:'Disable',ENiagaraCVarConditionResponse_MAX:'ENiagaraCVarConditionResponse_MAX', };
declare class NiagaraPlatformSetCVarCondition { 
	CVarName: string;
	PassResponse: ENiagaraCVarConditionResponse;
	FailResponse: ENiagaraCVarConditionResponse;
	Value: boolean;
	MinInt: number;
	MaxInt: number;
	MinFloat: number;
	MaxFloat: number;
	bUseMinInt: boolean;
	bUseMaxInt: boolean;
	bUseMinFloat: boolean;
	bUseMaxFloat: boolean;
	clone() : NiagaraPlatformSetCVarCondition;
	static C(Other: UObject | any): NiagaraPlatformSetCVarCondition;
}

declare class NiagaraPlatformSet { 
	QualityLevelMask: number;
	DeviceProfileStates: NiagaraDeviceProfileStateEntry[];
	CVarConditions: NiagaraPlatformSetCVarCondition[];
	clone() : NiagaraPlatformSet;
	static C(Other: UObject | any): NiagaraPlatformSet;
}

declare type ENiagaraCullProxyMode = 'None' | 'Instanced_Rendered' | 'ENiagaraCullProxyMode_MAX';
declare var ENiagaraCullProxyMode : { None:'None',Instanced_Rendered:'Instanced_Rendered',ENiagaraCullProxyMode_MAX:'ENiagaraCullProxyMode_MAX', };
declare class NiagaraSystemVisibilityCullingSettings { 
	bCullWhenNotRendered: boolean;
	bCullByViewFrustum: boolean;
	bAllowPreCullingByViewFrustum: boolean;
	MaxTimeOutsideViewFrustum: number;
	MaxTimeWithoutRender: number;
	clone() : NiagaraSystemVisibilityCullingSettings;
	static C(Other: UObject | any): NiagaraSystemVisibilityCullingSettings;
}

declare class NiagaraLinearRamp { 
	StartX: number;
	StartY: number;
	EndX: number;
	EndY: number;
	clone() : NiagaraLinearRamp;
	static C(Other: UObject | any): NiagaraLinearRamp;
}

declare class NiagaraGlobalBudgetScaling { 
	bCullByGlobalBudget: boolean;
	bScaleMaxDistanceByGlobalBudgetUse: boolean;
	bScaleMaxInstanceCountByGlobalBudgetUse: boolean;
	bScaleSystemInstanceCountByGlobalBudgetUse: boolean;
	MaxGlobalBudgetUsage: number;
	MaxDistanceScaleByGlobalBudgetUse: NiagaraLinearRamp;
	MaxInstanceCountScaleByGlobalBudgetUse: NiagaraLinearRamp;
	MaxSystemInstanceCountScaleByGlobalBudgetUse: NiagaraLinearRamp;
	clone() : NiagaraGlobalBudgetScaling;
	static C(Other: UObject | any): NiagaraGlobalBudgetScaling;
}

declare class NiagaraSystemScalabilitySettings { 
	Platforms: NiagaraPlatformSet;
	bCullByDistance: boolean;
	bCullMaxInstanceCount: boolean;
	bCullPerSystemMaxInstanceCount: boolean;
	MaxDistance: number;
	bCullByMaxTimeWithoutRender: boolean;
	MaxInstances: number;
	MaxSystemInstances: number;
	MaxTimeWithoutRender: number;
	CullProxyMode: ENiagaraCullProxyMode;
	MaxSystemProxies: number;
	VisibilityCulling: NiagaraSystemVisibilityCullingSettings;
	BudgetScaling: NiagaraGlobalBudgetScaling;
	clone() : NiagaraSystemScalabilitySettings;
	static C(Other: UObject | any): NiagaraSystemScalabilitySettings;
}

declare class NiagaraSystemScalabilitySettingsArray { 
	Settings: NiagaraSystemScalabilitySettings[];
	clone() : NiagaraSystemScalabilitySettingsArray;
	static C(Other: UObject | any): NiagaraSystemScalabilitySettingsArray;
}

declare class NiagaraEmitterScalabilitySettings { 
	Platforms: NiagaraPlatformSet;
	bScaleSpawnCount: boolean;
	SpawnCountScale: number;
	clone() : NiagaraEmitterScalabilitySettings;
	static C(Other: UObject | any): NiagaraEmitterScalabilitySettings;
}

declare class NiagaraEmitterScalabilitySettingsArray { 
	Settings: NiagaraEmitterScalabilitySettings[];
	clone() : NiagaraEmitterScalabilitySettingsArray;
	static C(Other: UObject | any): NiagaraEmitterScalabilitySettingsArray;
}

declare type EHorizTextAligment = 'EHTA_Left' | 'EHTA_Center' | 'EHTA_Right' | 'EHTA_MAX';
declare var EHorizTextAligment : { EHTA_Left:'EHTA_Left',EHTA_Center:'EHTA_Center',EHTA_Right:'EHTA_Right',EHTA_MAX:'EHTA_MAX', };
declare type EVerticalTextAligment = 'EVRTA_TextTop' | 'EVRTA_TextCenter' | 'EVRTA_TextBottom' | 'EVRTA_QuadTop' | 'EVRTA_MAX';
declare var EVerticalTextAligment : { EVRTA_TextTop:'EVRTA_TextTop',EVRTA_TextCenter:'EVRTA_TextCenter',EVRTA_TextBottom:'EVRTA_TextBottom',EVRTA_QuadTop:'EVRTA_QuadTop',EVRTA_MAX:'EVRTA_MAX', };
declare class TextRenderComponent extends PrimitiveComponent { 
	Text: string;
	TextMaterial: MaterialInterface;
	Font: Font;
	HorizontalAlignment: EHorizTextAligment;
	VerticalAlignment: EVerticalTextAligment;
	TextRenderColor: Color;
	XScale: number;
	YScale: number;
	WorldSize: number;
	InvDefaultSize: number;
	HorizSpacingAdjust: number;
	VertSpacingAdjust: number;
	bAlwaysRenderAsText: boolean;
	static Load(ResourceName: string): TextRenderComponent;
	static Find(Outer: UObject, ResourceName: string): TextRenderComponent;
	static GetDefaultObject(): TextRenderComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextRenderComponent;
	SetYScale(Value: number): void;
	SetXScale(Value: number): void;
	SetWorldSize(Value: number): void;
	SetVertSpacingAdjust(Value: number): void;
	SetVerticalAlignment(Value: EVerticalTextAligment): void;
	SetTextRenderColor(Value: Color): void;
	SetTextMaterial(Material: MaterialInterface): void;
	SetHorizSpacingAdjust(Value: number): void;
	SetHorizontalAlignment(Value: EHorizTextAligment): void;
	SetFont(Value: Font): void;
	K2_SetText(Value: string): void;
	GetTextWorldSize(): Vector;
	GetTextLocalSize(): Vector;
	static C(Other: UObject | any): TextRenderComponent;
}

declare class NiagaraPerfBaselineActor extends Actor { 
	Controller: NiagaraBaselineController;
	Label: TextRenderComponent;
	static GetDefaultObject(): NiagaraPerfBaselineActor;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraPerfBaselineActor;
	static C(Other: UObject | any): NiagaraPerfBaselineActor;
}

declare class NiagaraPerfBaselineStats { 
	PerInstanceAvg_GT: number;
	PerInstanceAvg_RT: number;
	PerInstanceMax_GT: number;
	PerInstanceMax_RT: number;
	clone() : NiagaraPerfBaselineStats;
	static C(Other: UObject | any): NiagaraPerfBaselineStats;
}

declare class NiagaraBaselineController extends UObject { 
	TestDuration: number;
	EffectType: NiagaraEffectType;
	Owner: NiagaraPerfBaselineActor;
	System: NiagaraSystem;
	static Load(ResourceName: string): NiagaraBaselineController;
	static Find(Outer: UObject, ResourceName: string): NiagaraBaselineController;
	static GetDefaultObject(): NiagaraBaselineController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBaselineController;
	OnTickTest(): boolean;
	OnOwnerTick(DeltaTime: number): void;
	OnEndTest(Stats: NiagaraPerfBaselineStats): void;
	OnBeginTest(): void;
	GetSystem(): NiagaraSystem;
	static C(Other: UObject | any): NiagaraBaselineController;
}

declare class NiagaraEffectType extends UObject { 
	bAllowCullingForLocalPlayers: boolean;
	UpdateFrequency: ENiagaraScalabilityUpdateFrequency;
	CullReaction: ENiagaraCullReaction;
	SignificanceHandler: NiagaraSignificanceHandler;
	DetailLevelScalabilitySettings: NiagaraSystemScalabilitySettings[];
	SystemScalabilitySettings: NiagaraSystemScalabilitySettingsArray;
	EmitterScalabilitySettings: NiagaraEmitterScalabilitySettingsArray;
	ValidationRules: NiagaraValidationRule[];
	PerformanceBaselineController: NiagaraBaselineController;
	PerfBaselineStats: NiagaraPerfBaselineStats;
	PerfBaselineVersion: Guid;
	static Load(ResourceName: string): NiagaraEffectType;
	static Find(Outer: UObject, ResourceName: string): NiagaraEffectType;
	static GetDefaultObject(): NiagaraEffectType;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEffectType;
	static C(Other: UObject | any): NiagaraEffectType;
}

declare class NiagaraSystemScalabilityOverride extends NiagaraSystemScalabilitySettings { 
	bOverrideDistanceSettings: boolean;
	bOverrideInstanceCountSettings: boolean;
	bOverridePerSystemInstanceCountSettings: boolean;
	bOverrideVisibilitySettings: boolean;
	bOverrideGlobalBudgetScalingSettings: boolean;
	bOverrideCullProxySettings: boolean;
	clone() : NiagaraSystemScalabilityOverride;
	static C(Other: UObject | any): NiagaraSystemScalabilityOverride;
}

declare class NiagaraSystemScalabilityOverrides { 
	Overrides: NiagaraSystemScalabilityOverride[];
	clone() : NiagaraSystemScalabilityOverrides;
	static C(Other: UObject | any): NiagaraSystemScalabilityOverrides;
}

declare type ENiagaraSimTarget = 'CPUSim' | 'GPUComputeSim' | 'ENiagaraSimTarget_MAX';
declare var ENiagaraSimTarget : { CPUSim:'CPUSim',GPUComputeSim:'GPUComputeSim',ENiagaraSimTarget_MAX:'ENiagaraSimTarget_MAX', };
declare type ENiagaraEmitterCalculateBoundMode = 'Dynamic' | 'Fixed' | 'Programmable' | 'ENiagaraEmitterCalculateBoundMode_MAX';
declare var ENiagaraEmitterCalculateBoundMode : { Dynamic:'Dynamic',Fixed:'Fixed',Programmable:'Programmable',ENiagaraEmitterCalculateBoundMode_MAX:'ENiagaraEmitterCalculateBoundMode_MAX', };
declare class NiagaraEventReceiverProperties { 
	Name: string;
	SourceEventGenerator: string;
	SourceEmitter: string;
	clone() : NiagaraEventReceiverProperties;
	static C(Other: UObject | any): NiagaraEventReceiverProperties;
}

declare class NiagaraTypeLayoutInfo { 
	FloatComponentByteOffsets: number[];
	FloatComponentRegisterOffsets: number[];
	Int32ComponentByteOffsets: number[];
	Int32ComponentRegisterOffsets: number[];
	HalfComponentByteOffsets: number[];
	HalfComponentRegisterOffsets: number[];
	clone() : NiagaraTypeLayoutInfo;
	static C(Other: UObject | any): NiagaraTypeLayoutInfo;
}

declare class NiagaraVariableLayoutInfo { 
	FloatComponentStart: number;
	Int32ComponentStart: number;
	HalfComponentStart: number;
	LayoutInfo: NiagaraTypeLayoutInfo;
	clone() : NiagaraVariableLayoutInfo;
	static C(Other: UObject | any): NiagaraVariableLayoutInfo;
}

declare class NiagaraDataSetCompiledData { 
	Variables: NiagaraVariable[];
	VariableLayouts: NiagaraVariableLayoutInfo[];
	ID: NiagaraDataSetID;
	TotalFloatComponents: number;
	TotalInt32Components: number;
	TotalHalfComponents: number;
	bRequiresPersistentIDs: boolean;
	SimTarget: ENiagaraSimTarget;
	clone() : NiagaraDataSetCompiledData;
	static C(Other: UObject | any): NiagaraDataSetCompiledData;
}

declare class NiagaraEventGeneratorProperties { 
	MaxEventsPerFrame: number;
	ID: string;
	DataSetCompiledData: NiagaraDataSetCompiledData;
	clone() : NiagaraEventGeneratorProperties;
	static C(Other: UObject | any): NiagaraEventGeneratorProperties;
}

declare class NiagaraEmitterScriptProperties { 
	Script: NiagaraScript;
	EventReceivers: NiagaraEventReceiverProperties[];
	EventGenerators: NiagaraEventGeneratorProperties[];
	clone() : NiagaraEmitterScriptProperties;
	static C(Other: UObject | any): NiagaraEmitterScriptProperties;
}

declare type EScriptExecutionMode = 'EveryParticle' | 'SpawnedParticles' | 'SingleParticle' | 'EScriptExecutionMode_MAX';
declare var EScriptExecutionMode : { EveryParticle:'EveryParticle',SpawnedParticles:'SpawnedParticles',SingleParticle:'SingleParticle',EScriptExecutionMode_MAX:'EScriptExecutionMode_MAX', };
declare class NiagaraEventScriptProperties extends NiagaraEmitterScriptProperties { 
	ExecutionMode: EScriptExecutionMode;
	SpawnNumber: number;
	MaxEventsPerFrame: number;
	SourceEmitterID: Guid;
	SourceEventName: string;
	bRandomSpawnNumber: boolean;
	MinSpawnNumber: number;
	UpdateAttributeInitialValues: boolean;
	clone() : NiagaraEventScriptProperties;
	static C(Other: UObject | any): NiagaraEventScriptProperties;
}

declare class NiagaraEmitterScalabilityOverride extends NiagaraEmitterScalabilitySettings { 
	bOverrideSpawnCountScale: boolean;
	clone() : NiagaraEmitterScalabilityOverride;
	static C(Other: UObject | any): NiagaraEmitterScalabilityOverride;
}

declare class NiagaraEmitterScalabilityOverrides { 
	Overrides: NiagaraEmitterScalabilityOverride[];
	clone() : NiagaraEmitterScalabilityOverrides;
	static C(Other: UObject | any): NiagaraEmitterScalabilityOverrides;
}

declare type EParticleAllocationMode = 'AutomaticEstimate' | 'ManualEstimate' | 'FixedCount' | 'EParticleAllocationMode_MAX';
declare var EParticleAllocationMode : { AutomaticEstimate:'AutomaticEstimate',ManualEstimate:'ManualEstimate',FixedCount:'FixedCount',EParticleAllocationMode_MAX:'EParticleAllocationMode_MAX', };
declare class NiagaraScratchPadContainer extends UObject { 
	Scripts: NiagaraScript[];
	static Load(ResourceName: string): NiagaraScratchPadContainer;
	static Find(Outer: UObject, ResourceName: string): NiagaraScratchPadContainer;
	static GetDefaultObject(): NiagaraScratchPadContainer;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraScratchPadContainer;
	static C(Other: UObject | any): NiagaraScratchPadContainer;
}

declare class VersionedNiagaraEmitter { 
	Emitter: NiagaraEmitter;
	Version: Guid;
	clone() : VersionedNiagaraEmitter;
	static C(Other: UObject | any): VersionedNiagaraEmitter;
}

declare type ENiagaraRendererMotionVectorSetting = 'AutoDetect' | 'Precise' | 'Approximate' | 'Disable' | 'ENiagaraRendererMotionVectorSetting_MAX';
declare var ENiagaraRendererMotionVectorSetting : { AutoDetect:'AutoDetect',Precise:'Precise',Approximate:'Approximate',Disable:'Disable',ENiagaraRendererMotionVectorSetting_MAX:'ENiagaraRendererMotionVectorSetting_MAX', };
declare type ENiagaraBindingSource = 'ImplicitFromSource' | 'ExplicitParticles' | 'ExplicitEmitter' | 'ExplicitSystem' | 'ExplicitUser' | 'MaxBindingSource' | 'ENiagaraBindingSource_MAX';
declare var ENiagaraBindingSource : { ImplicitFromSource:'ImplicitFromSource',ExplicitParticles:'ExplicitParticles',ExplicitEmitter:'ExplicitEmitter',ExplicitSystem:'ExplicitSystem',ExplicitUser:'ExplicitUser',MaxBindingSource:'MaxBindingSource',ENiagaraBindingSource_MAX:'ENiagaraBindingSource_MAX', };
declare class NiagaraVariableAttributeBinding { 
	ParamMapVariable: NiagaraVariableBase;
	DataSetVariable: NiagaraVariable;
	RootVariable: NiagaraVariable;
	BoundVariable: NiagaraVariable;
	CachedDisplayName: string;
	BindingSourceMode: ENiagaraBindingSource;
	bBindingExistsOnSource: boolean;
	bIsCachedParticleValue: boolean;
	clone() : NiagaraVariableAttributeBinding;
	static C(Other: UObject | any): NiagaraVariableAttributeBinding;
}

declare class NiagaraRendererProperties extends NiagaraMergeable { 
	Platforms: NiagaraPlatformSet;
	SortOrderHint: number;
	MotionVectorSetting: ENiagaraRendererMotionVectorSetting;
	RendererEnabledBinding: NiagaraVariableAttributeBinding;
	bIsEnabled: boolean;
	bAllowInCullProxies: boolean;
	OuterEmitterVersion: Guid;
	bMotionBlurEnabled: boolean;
	static Load(ResourceName: string): NiagaraRendererProperties;
	static Find(Outer: UObject, ResourceName: string): NiagaraRendererProperties;
	static GetDefaultObject(): NiagaraRendererProperties;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraRendererProperties;
	static C(Other: UObject | any): NiagaraRendererProperties;
}

declare class NiagaraSimulationStageBase extends NiagaraMergeable { 
	Script: NiagaraScript;
	SimulationStageName: string;
	bEnabled: boolean;
	OuterEmitterVersion: Guid;
	static Load(ResourceName: string): NiagaraSimulationStageBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraSimulationStageBase;
	static GetDefaultObject(): NiagaraSimulationStageBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSimulationStageBase;
	static C(Other: UObject | any): NiagaraSimulationStageBase;
}

declare class NiagaraEditorDataBase extends UObject { 
	static Load(ResourceName: string): NiagaraEditorDataBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraEditorDataBase;
	static GetDefaultObject(): NiagaraEditorDataBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEditorDataBase;
	static C(Other: UObject | any): NiagaraEditorDataBase;
}

declare class NiagaraEditorParametersAdapterBase extends UObject { 
	static Load(ResourceName: string): NiagaraEditorParametersAdapterBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraEditorParametersAdapterBase;
	static GetDefaultObject(): NiagaraEditorParametersAdapterBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEditorParametersAdapterBase;
	static C(Other: UObject | any): NiagaraEditorParametersAdapterBase;
}

declare class VersionedNiagaraEmitterData { 
	Version: NiagaraAssetVersion;
	VersionChangeDescription: string;
	UpdateScriptExecution: ENiagaraPythonUpdateScriptReference;
	PythonUpdateScript: string;
	ScriptAsset: FilePath;
	bDeprecated: boolean;
	DeprecationMessage: string;
	bLocalSpace: boolean;
	bDeterminism: boolean;
	RandomSeed: number;
	bInterpolatedSpawning: boolean;
	bGpuAlwaysRunParticleUpdateScript: boolean;
	SimTarget: ENiagaraSimTarget;
	CalculateBoundsMode: ENiagaraEmitterCalculateBoundMode;
	FixedBounds: Box;
	bRequiresPersistentIDs: boolean;
	bCombineEventSpawn: boolean;
	EventHandlerScriptProps: NiagaraEventScriptProperties[];
	Platforms: NiagaraPlatformSet;
	ScalabilityOverrides: NiagaraEmitterScalabilityOverrides;
	bLimitDeltaTime: boolean;
	MaxGPUParticlesSpawnPerFrame: number;
	MaxDeltaTimePerTick: number;
	AllocationMode: EParticleAllocationMode;
	PreAllocationCount: number;
	UpdateScriptProps: NiagaraEmitterScriptProperties;
	SpawnScriptProps: NiagaraEmitterScriptProperties;
	RendererBindings: NiagaraParameterStore;
	AttributesToPreserve: string[];
	EmitterSpawnScriptProps: NiagaraEmitterScriptProperties;
	EmitterUpdateScriptProps: NiagaraEmitterScriptProperties;
	GraphSource: NiagaraScriptSourceBase;
	ScratchPads: NiagaraScratchPadContainer;
	ParentScratchPads: NiagaraScratchPadContainer;
	VersionedParent: VersionedNiagaraEmitter;
	VersionedParentAtLastMerge: VersionedNiagaraEmitter;
	RendererProperties: NiagaraRendererProperties[];
	SimulationStages: NiagaraSimulationStageBase[];
	GPUComputeScript: NiagaraScript;
	SharedEventGeneratorIds: string[];
	CurrentScalabilitySettings: NiagaraEmitterScalabilitySettings;
	EditorData: NiagaraEditorDataBase;
	EditorParameters: NiagaraEditorParametersAdapterBase;
	clone() : VersionedNiagaraEmitterData;
	static C(Other: UObject | any): VersionedNiagaraEmitterData;
}

declare class NiagaraDetailsLevelScaleOverrides { 
	Low: number;
	Medium: number;
	High: number;
	Epic: number;
	Cine: number;
	clone() : NiagaraDetailsLevelScaleOverrides;
	static C(Other: UObject | any): NiagaraDetailsLevelScaleOverrides;
}

declare class NiagaraMessageDataBase extends UObject { 
	static Load(ResourceName: string): NiagaraMessageDataBase;
	static Find(Outer: UObject, ResourceName: string): NiagaraMessageDataBase;
	static GetDefaultObject(): NiagaraMessageDataBase;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraMessageDataBase;
	static C(Other: UObject | any): NiagaraMessageDataBase;
}

declare class NiagaraEmitter extends UObject { 
	ExposedVersion: Guid;
	bVersioningEnabled: boolean;
	VersionData: VersionedNiagaraEmitterData[];
	TemplateSpecification: ENiagaraScriptTemplateSpecification;
	TemplateAssetDescription: string;
	Category: string;
	ThumbnailImage: Texture2D;
	LibraryVisibility: ENiagaraScriptLibraryVisibility;
	VersionToOpenInEditor: Guid;
	bLocalSpace: boolean;
	bDeterminism: boolean;
	RandomSeed: number;
	AllocationMode: EParticleAllocationMode;
	PreAllocationCount: number;
	UpdateScriptProps: NiagaraEmitterScriptProperties;
	SpawnScriptProps: NiagaraEmitterScriptProperties;
	EmitterSpawnScriptProps: NiagaraEmitterScriptProperties;
	EmitterUpdateScriptProps: NiagaraEmitterScriptProperties;
	AttributesToPreserve: string[];
	ParentScratchPadScripts: NiagaraScript[];
	SimTarget: ENiagaraSimTarget;
	FixedBounds: Box;
	MinDetailLevel: number;
	MaxDetailLevel: number;
	GlobalSpawnCountScaleOverrides: NiagaraDetailsLevelScaleOverrides;
	Platforms: NiagaraPlatformSet;
	ScalabilityOverrides: NiagaraEmitterScalabilityOverrides;
	bInterpolatedSpawning: boolean;
	RendererBindings: NiagaraParameterStore;
	bFixedBounds: boolean;
	bUseMinDetailLevel: boolean;
	bUseMaxDetailLevel: boolean;
	bOverrideGlobalSpawnCountScale: boolean;
	bRequiresPersistentIDs: boolean;
	bCombineEventSpawn: boolean;
	MaxDeltaTimePerTick: number;
	bLimitDeltaTime: boolean;
	MaxGPUParticlesSpawnPerFrame: number;
	GraphSource: NiagaraScriptSourceBase;
	bExposeToLibrary: boolean;
	bIsTemplateAsset: boolean;
	ScratchPadScripts: NiagaraScript[];
	ChangeID: Guid;
	EditorData: NiagaraEditorDataBase;
	EditorParameters: NiagaraEditorParametersAdapterBase;
	UniqueEmitterName: string;
	RendererProperties: NiagaraRendererProperties[];
	EventHandlerScriptProps: NiagaraEventScriptProperties[];
	SimulationStages: NiagaraSimulationStageBase[];
	GPUComputeScript: NiagaraScript;
	SharedEventGeneratorIds: string[];
	Parent: NiagaraEmitter;
	ParentAtLastMerge: NiagaraEmitter;
	ParameterDefinitionsSubscriptions: ParameterDefinitionsSubscription[];
	MessageKeyToMessageMap: Map<Guid, NiagaraMessageDataBase>;
	static Load(ResourceName: string): NiagaraEmitter;
	static Find(Outer: UObject, ResourceName: string): NiagaraEmitter;
	static GetDefaultObject(): NiagaraEmitter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraEmitter;
	static C(Other: UObject | any): NiagaraEmitter;
}

declare class NiagaraEmitterHandle { 
	ID: Guid;
	IdName: string;
	bIsEnabled: boolean;
	Name: string;
	Source: NiagaraEmitter;
	LastMergedSource: NiagaraEmitter;
	bIsolated: boolean;
	Instance: NiagaraEmitter;
	VersionedInstance: VersionedNiagaraEmitter;
	clone() : NiagaraEmitterHandle;
	static C(Other: UObject | any): NiagaraEmitterHandle;
}

declare class NiagaraSystemCompileRequest { 
	RootObjects: UObject[];
	clone() : NiagaraSystemCompileRequest;
	static C(Other: UObject | any): NiagaraSystemCompileRequest;
}

declare class NiagaraParameterDataSetBinding { 
	ParameterOffset: number;
	DataSetComponentOffset: number;
	clone() : NiagaraParameterDataSetBinding;
	static C(Other: UObject | any): NiagaraParameterDataSetBinding;
}

declare class NiagaraParameterDataSetBindingCollection { 
	FloatOffsets: NiagaraParameterDataSetBinding[];
	Int32Offsets: NiagaraParameterDataSetBinding[];
	clone() : NiagaraParameterDataSetBindingCollection;
	static C(Other: UObject | any): NiagaraParameterDataSetBindingCollection;
}

declare class NiagaraSystemCompiledData { 
	InstanceParamStore: NiagaraParameterStore;
	DataSetCompiledData: NiagaraDataSetCompiledData;
	SpawnInstanceParamsDataSetCompiledData: NiagaraDataSetCompiledData;
	UpdateInstanceParamsDataSetCompiledData: NiagaraDataSetCompiledData;
	SpawnInstanceGlobalBinding: NiagaraParameterDataSetBindingCollection;
	SpawnInstanceSystemBinding: NiagaraParameterDataSetBindingCollection;
	SpawnInstanceOwnerBinding: NiagaraParameterDataSetBindingCollection;
	SpawnInstanceEmitterBindings: NiagaraParameterDataSetBindingCollection[];
	UpdateInstanceGlobalBinding: NiagaraParameterDataSetBindingCollection;
	UpdateInstanceSystemBinding: NiagaraParameterDataSetBindingCollection;
	UpdateInstanceOwnerBinding: NiagaraParameterDataSetBindingCollection;
	UpdateInstanceEmitterBindings: NiagaraParameterDataSetBindingCollection[];
	clone() : NiagaraSystemCompiledData;
	static C(Other: UObject | any): NiagaraSystemCompiledData;
}

declare class NiagaraBakerOutput extends UObject { 
	OutputName: string;
	static Load(ResourceName: string): NiagaraBakerOutput;
	static Find(Outer: UObject, ResourceName: string): NiagaraBakerOutput;
	static GetDefaultObject(): NiagaraBakerOutput;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBakerOutput;
	static C(Other: UObject | any): NiagaraBakerOutput;
}

declare type ENiagaraBakerViewMode = 'Perspective' | 'OrthoFront' | 'OrthoBack' | 'OrthoLeft' | 'OrthoRight' | 'OrthoTop' | 'OrthoBottom' | 'Num' | 'ENiagaraBakerViewMode_MAX';
declare var ENiagaraBakerViewMode : { Perspective:'Perspective',OrthoFront:'OrthoFront',OrthoBack:'OrthoBack',OrthoLeft:'OrthoLeft',OrthoRight:'OrthoRight',OrthoTop:'OrthoTop',OrthoBottom:'OrthoBottom',Num:'Num',ENiagaraBakerViewMode_MAX:'ENiagaraBakerViewMode_MAX', };
declare class NiagaraBakerCameraSettings { 
	ViewMode: ENiagaraBakerViewMode;
	ViewportLocation: Vector;
	ViewportRotation: Rotator;
	OrbitDistance: number;
	FOV: number;
	OrthoWidth: number;
	bUseAspectRatio: boolean;
	AspectRatio: number;
	clone() : NiagaraBakerCameraSettings;
	static C(Other: UObject | any): NiagaraBakerCameraSettings;
}

declare class NiagaraBakerTextureSource { 
	DisplayString: string;
	SourceName: string;
	clone() : NiagaraBakerTextureSource;
	static C(Other: UObject | any): NiagaraBakerTextureSource;
}

declare class NiagaraBakerTextureSettings { 
	OutputName: string;
	SourceBinding: NiagaraBakerTextureSource;
	bUseFrameSize: boolean;
	FrameSize: IntPoint;
	TextureSize: IntPoint;
	GeneratedTexture: Texture2D;
	clone() : NiagaraBakerTextureSettings;
	static C(Other: UObject | any): NiagaraBakerTextureSettings;
}

declare class NiagaraBakerSettings extends UObject { 
	StartSeconds: number;
	DurationSeconds: number;
	FramesPerSecond: number;
	bPreviewLooping: boolean;
	FramesPerDimension: IntPoint;
	Outputs: NiagaraBakerOutput[];
	CameraSettings: NiagaraBakerCameraSettings[];
	CurrentCameraIndex: number;
	BakeQualityLevel: string;
	bRenderComponentOnly: boolean;
	OutputTextures: NiagaraBakerTextureSettings[];
	CameraViewportMode: ENiagaraBakerViewMode;
	CameraViewportLocation: Vector;
	CameraViewportRotation: Rotator;
	CameraOrbitDistance: number;
	CameraFOV: number;
	CameraOrthoWidth: number;
	bUseCameraAspectRatio: boolean;
	CameraAspectRatio: number;
	static Load(ResourceName: string): NiagaraBakerSettings;
	static Find(Outer: UObject, ResourceName: string): NiagaraBakerSettings;
	static GetDefaultObject(): NiagaraBakerSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraBakerSettings;
	static C(Other: UObject | any): NiagaraBakerSettings;
}

declare type ENCPoolMethod = 'None' | 'AutoRelease' | 'ManualRelease' | 'ManualRelease_OnComplete' | 'FreeInPool' | 'ENCPoolMethod_MAX';
declare var ENCPoolMethod : { None:'None',AutoRelease:'AutoRelease',ManualRelease:'ManualRelease',ManualRelease_OnComplete:'ManualRelease_OnComplete',FreeInPool:'FreeInPool',ENCPoolMethod_MAX:'ENCPoolMethod_MAX', };
declare class NiagaraSystem extends FXSystemAsset { 
	ThumbnailImage: Texture2D;
	bExposeToLibrary: boolean;
	LibraryVisibility: ENiagaraScriptLibraryVisibility;
	bIsTemplateAsset: boolean;
	TemplateSpecification: ENiagaraScriptTemplateSpecification;
	TemplateAssetDescription: string;
	Category: string;
	ScratchPadScripts: NiagaraScript[];
	EditorOnlyAddedParameters: NiagaraParameterStore;
	UpdateContext: NiagaraSystemUpdateContext;
	bCompileForEdit: boolean;
	bBakeOutRapidIteration: boolean;
	bBakeOutRapidIterationOnCook: boolean;
	bCompressAttributes: boolean;
	bTrimAttributes: boolean;
	bTrimAttributesOnCook: boolean;
	bIgnoreParticleReadsForAttributeTrim: boolean;
	bDisableDebugSwitches: boolean;
	bDisableDebugSwitchesOnCook: boolean;
	ParameterDefinitionsSubscriptions: ParameterDefinitionsSubscription[];
	bSupportLargeWorldCoordinates: boolean;
	bOverrideCastShadow: boolean;
	bOverrideReceivesDecals: boolean;
	bOverrideRenderCustomDepth: boolean;
	bOverrideCustomDepthStencilValue: boolean;
	bOverrideCustomDepthStencilWriteMask: boolean;
	bOverrideTranslucencySortPriority: boolean;
	bOverrideTranslucencySortDistanceOffset: boolean;
	bCastShadow: boolean;
	bReceivesDecals: boolean;
	bRenderCustomDepth: boolean;
	bDisableExperimentalVM: boolean;
	CustomDepthStencilWriteMask: ERendererStencilMask;
	CustomDepthStencilValue: number;
	TranslucencySortPriority: number;
	TranslucencySortDistanceOffset: number;
	bDumpDebugSystemInfo: boolean;
	bDumpDebugEmitterInfo: boolean;
	bRequireCurrentFrameData: boolean;
	bFixedBounds: boolean;
	EffectType: NiagaraEffectType;
	bOverrideScalabilitySettings: boolean;
	bOverrideAllowCullingForLocalPlayers: boolean;
	bAllowCullingForLocalPlayersOverride: boolean;
	ScalabilityOverrides: NiagaraSystemScalabilityOverride[];
	SystemScalabilityOverrides: NiagaraSystemScalabilityOverrides;
	EmitterHandles: NiagaraEmitterHandle[];
	ParameterCollectionOverrides: NiagaraParameterCollectionInstance[];
	ActiveCompilations: NiagaraSystemCompileRequest[];
	SystemSpawnScript: NiagaraScript;
	SystemUpdateScript: NiagaraScript;
	SystemCompiledData: NiagaraSystemCompiledData;
	ExposedParameters: NiagaraUserRedirectionParameterStore;
	EditorData: NiagaraEditorDataBase;
	EditorParameters: NiagaraEditorParametersAdapterBase;
	FixedBounds: Box;
	bAutoDeactivate: boolean;
	bDeterminism: boolean;
	RandomSeed: number;
	WarmupTime: number;
	WarmupTickCount: number;
	WarmupTickDelta: number;
	bFixedTickDelta: boolean;
	FixedTickDeltaTime: number;
	BakerSettings: NiagaraBakerSettings;
	BakerGeneratedSettings: NiagaraBakerSettings;
	bHasSystemScriptDIsWithPerInstanceData: boolean;
	bNeedsGPUContextInitForDataInterfaces: boolean;
	UserDINamesReadInSystemScripts: string[];
	MessageKeyToMessageMap: Map<Guid, NiagaraMessageDataBase>;
	static Load(ResourceName: string): NiagaraSystem;
	static Find(Outer: UObject, ResourceName: string): NiagaraSystem;
	static GetDefaultObject(): NiagaraSystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSystem;
	static C(Other: UObject | any): NiagaraSystem;
	SpawnSystemAttached(AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bAutoDestroy: boolean,bAutoActivate: boolean,PoolingMethod: ENCPoolMethod,bPreCullCheck: boolean): NiagaraComponent;
	static SpawnSystemAttached(SystemTemplate: NiagaraSystem,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bAutoDestroy: boolean,bAutoActivate: boolean,PoolingMethod: ENCPoolMethod,bPreCullCheck: boolean): NiagaraComponent;
}

declare type ENiagaraSimCacheAttributeCaptureMode = 'All' | 'RenderingOnly' | 'ExplicitAttributes' | 'ENiagaraSimCacheAttributeCaptureMode_MAX';
declare var ENiagaraSimCacheAttributeCaptureMode : { All:'All',RenderingOnly:'RenderingOnly',ExplicitAttributes:'ExplicitAttributes',ENiagaraSimCacheAttributeCaptureMode_MAX:'ENiagaraSimCacheAttributeCaptureMode_MAX', };
declare class NiagaraSimCacheCreateParameters { 
	AttributeCaptureMode: ENiagaraSimCacheAttributeCaptureMode;
	bAllowRebasing: boolean;
	bAllowDataInterfaceCaching: boolean;
	RebaseIncludeAttributes: string[];
	RebaseExcludeAttributes: string[];
	ExplicitCaptureAttributes: string[];
	clone() : NiagaraSimCacheCreateParameters;
	static C(Other: UObject | any): NiagaraSimCacheCreateParameters;
}

declare class NiagaraSimCacheVariable { 
	Variable: NiagaraVariableBase;
	FloatOffset: number;
	FloatCount: number;
	HalfOffset: number;
	HalfCount: number;
	Int32Offset: number;
	Int32Count: number;
	clone() : NiagaraSimCacheVariable;
	static C(Other: UObject | any): NiagaraSimCacheVariable;
}

declare class NiagaraSimCacheDataBuffersLayout { 
	LayoutName: string;
	SimTarget: ENiagaraSimTarget;
	Variables: NiagaraSimCacheVariable[];
	FloatCount: number;
	HalfCount: number;
	Int32Count: number;
	bLocalSpace: boolean;
	RebaseVariableNames: string[];
	clone() : NiagaraSimCacheDataBuffersLayout;
	static C(Other: UObject | any): NiagaraSimCacheDataBuffersLayout;
}

declare class NiagaraSimCacheLayout { 
	SystemLayout: NiagaraSimCacheDataBuffersLayout;
	EmitterLayouts: NiagaraSimCacheDataBuffersLayout[];
	clone() : NiagaraSimCacheLayout;
	static C(Other: UObject | any): NiagaraSimCacheLayout;
}

declare class NiagaraSimCacheDataBuffers { 
	NumInstances: number;
	FloatData: number[];
	HalfData: number[];
	Int32Data: number[];
	IDToIndexTable: number[];
	IDAcquireTag: number;
	clone() : NiagaraSimCacheDataBuffers;
	static C(Other: UObject | any): NiagaraSimCacheDataBuffers;
}

declare class NiagaraSimCacheSystemFrame { 
	LocalBounds: Box;
	SystemDataBuffers: NiagaraSimCacheDataBuffers;
	clone() : NiagaraSimCacheSystemFrame;
	static C(Other: UObject | any): NiagaraSimCacheSystemFrame;
}

declare class NiagaraSimCacheEmitterFrame { 
	LocalBounds: Box;
	TotalSpawnedParticles: number;
	ParticleDataBuffers: NiagaraSimCacheDataBuffers;
	clone() : NiagaraSimCacheEmitterFrame;
	static C(Other: UObject | any): NiagaraSimCacheEmitterFrame;
}

declare class NiagaraSimCacheFrame { 
	LocalToWorld: Transform;
	LWCTile: Vector3f;
	SystemData: NiagaraSimCacheSystemFrame;
	EmitterData: NiagaraSimCacheEmitterFrame[];
	clone() : NiagaraSimCacheFrame;
	static C(Other: UObject | any): NiagaraSimCacheFrame;
}

declare class NiagaraSimCache extends UObject { 
	SoftNiagaraSystem: NiagaraSystem;
	StartSeconds: number;
	DurationSeconds: number;
	CreateParameters: NiagaraSimCacheCreateParameters;
	bNeedsReadComponentMappingRecache: boolean;
	CachedScriptVMIds: NiagaraVMExecutableDataId[];
	CacheLayout: NiagaraSimCacheLayout;
	CacheFrames: NiagaraSimCacheFrame[];
	DataInterfaceStorage: Map<NiagaraVariableBase, UObject>;
	static Load(ResourceName: string): NiagaraSimCache;
	static Find(Outer: UObject, ResourceName: string): NiagaraSimCache;
	static GetDefaultObject(): NiagaraSimCache;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NiagaraSimCache;
	ReadVectorAttribute(OutValues?: Vector[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: Vector[]};
	ReadVector4Attribute(OutValues?: Vector4[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: Vector4[]};
	ReadVector2Attribute(OutValues?: Vector2D[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: Vector2D[]};
	ReadQuatAttributeWithRebase(OutValues?: Quat[],Quat?: Quat,AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: Quat[]};
	ReadQuatAttribute(OutValues?: Quat[],AttributeName?: string,EmitterName?: string,bLocalSpaceToWorld?: boolean,FrameIndex?: number): {OutValues: Quat[]};
	ReadPositionAttributeWithRebase(OutValues?: Vector[],Transform?: Transform,AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: Vector[]};
	ReadPositionAttribute(OutValues?: Vector[],AttributeName?: string,EmitterName?: string,bLocalSpaceToWorld?: boolean,FrameIndex?: number): {OutValues: Vector[]};
	ReadIntAttribute(OutValues?: number[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: number[]};
	ReadFloatAttribute(OutValues?: number[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: number[]};
	ReadColorAttribute(OutValues?: LinearColor[],AttributeName?: string,EmitterName?: string,FrameIndex?: number): {OutValues: LinearColor[]};
	IsEmpty(): boolean;
	IsCacheValid(): boolean;
	GetStartSeconds(): number;
	GetNumFrames(): number;
	GetNumEmitters(): number;
	GetEmitterNames(): string[];
	GetEmitterName(EmitterIndex: number): string;
	GetAttributeCaptureMode(): ENiagaraSimCacheAttributeCaptureMode;
	static C(Other: UObject | any): NiagaraSimCache;
	CaptureNiagaraSimCacheImmediate(CreateParameters: NiagaraSimCacheCreateParameters,NiagaraComponent: NiagaraComponent,OutSimCache?: NiagaraSimCache,bAdvanceSimulation?: boolean,AdvanceDeltaTime?: number): {OutSimCache: NiagaraSimCache, $: boolean};
	static CaptureNiagaraSimCacheImmediate(SimCache: NiagaraSimCache,CreateParameters: NiagaraSimCacheCreateParameters,NiagaraComponent: NiagaraComponent,OutSimCache?: NiagaraSimCache,bAdvanceSimulation?: boolean,AdvanceDeltaTime?: number): {OutSimCache: NiagaraSimCache, $: boolean};
}

declare class TraceChannelTestBatchOptions { 
	bLineTrace: boolean;
	bSphereTrace: boolean;
	bCapsuleTrace: boolean;
	bBoxTrace: boolean;
	bChannelTrace: boolean;
	bObjectsTrace: boolean;
	bProfileTrace: boolean;
	clone() : TraceChannelTestBatchOptions;
	static C(Other: UObject | any): TraceChannelTestBatchOptions;
}

declare type EDrawDebugTrace = 'None' | 'ForOneFrame' | 'ForDuration' | 'Persistent' | 'EDrawDebugTrace_MAX';
declare var EDrawDebugTrace : { None:'None',ForOneFrame:'ForOneFrame',ForDuration:'ForDuration',Persistent:'Persistent',EDrawDebugTrace_MAX:'EDrawDebugTrace_MAX', };
declare class TraceQueryTestNames { 
	ComponentName: string;
	PhysicalMaterialName: string;
	ActorName: string;
	clone() : TraceQueryTestNames;
	static C(Other: UObject | any): TraceQueryTestNames;
}

declare class TraceQueryTestResultsInnerMost { 
	SingleHit: HitResult;
	SingleNames: TraceQueryTestNames;
	bSingleResult: boolean;
	MultiHits: HitResult[];
	MultiNames: TraceQueryTestNames[];
	bMultiResult: boolean;
	clone() : TraceQueryTestResultsInnerMost;
	static C(Other: UObject | any): TraceQueryTestResultsInnerMost;
}

declare class TraceQueryTestResultsInner { 
	LineResults: TraceQueryTestResultsInnerMost;
	SphereResults: TraceQueryTestResultsInnerMost;
	CapsuleResults: TraceQueryTestResultsInnerMost;
	BoxResults: TraceQueryTestResultsInnerMost;
	clone() : TraceQueryTestResultsInner;
	static C(Other: UObject | any): TraceQueryTestResultsInner;
}

declare class TraceQueryTestResults extends UObject { 
	ChannelResults: TraceQueryTestResultsInner;
	ObjectResults: TraceQueryTestResultsInner;
	ProfileResults: TraceQueryTestResultsInner;
	BatchOptions: TraceChannelTestBatchOptions;
	static Load(ResourceName: string): TraceQueryTestResults;
	static Find(Outer: UObject, ResourceName: string): TraceQueryTestResults;
	static GetDefaultObject(): TraceQueryTestResults;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TraceQueryTestResults;
	ToString(): string;
	static C(Other: UObject | any): TraceQueryTestResults;
}

declare class AutomationWaitForLoadingOptions { 
	WaitForReplicationToSettle: boolean;
	clone() : AutomationWaitForLoadingOptions;
	static C(Other: UObject | any): AutomationWaitForLoadingOptions;
}

declare class AutomationViewSettings extends DataAsset { 
	AntiAliasing: boolean;
	MotionBlur: boolean;
	TemporalAA: boolean;
	ScreenSpaceReflections: boolean;
	ScreenSpaceAO: boolean;
	DistanceFieldAO: boolean;
	ContactShadows: boolean;
	EyeAdaptation: boolean;
	Bloom: boolean;
	static Load(ResourceName: string): AutomationViewSettings;
	static Find(Outer: UObject, ResourceName: string): AutomationViewSettings;
	static GetDefaultObject(): AutomationViewSettings;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AutomationViewSettings;
	static C(Other: UObject | any): AutomationViewSettings;
}

declare type EComparisonTolerance = 'Zero' | 'Low' | 'Medium' | 'High' | 'Custom' | 'EComparisonTolerance_MAX';
declare var EComparisonTolerance : { Zero:'Zero',Low:'Low',Medium:'Medium',High:'High',Custom:'Custom',EComparisonTolerance_MAX:'EComparisonTolerance_MAX', };
declare class ComparisonToleranceAmount { 
	red: number;
	green: number;
	blue: number;
	Alpha: number;
	MinBrightness: number;
	MaxBrightness: number;
	clone() : ComparisonToleranceAmount;
	static C(Other: UObject | any): ComparisonToleranceAmount;
}

declare class AutomationScreenshotOptions { 
	Resolution: Vector2D;
	Delay: number;
	FrameDelay: number;
	bOverride_OverrideTimeTo: boolean;
	OverrideTimeTo: number;
	bDisableNoisyRenderingFeatures: boolean;
	bDisableTonemapping: boolean;
	ViewSettings: AutomationViewSettings;
	VisualizeBuffer: string;
	Tolerance: EComparisonTolerance;
	ToleranceAmount: ComparisonToleranceAmount;
	MaximumLocalError: number;
	MaximumGlobalError: number;
	bIgnoreAntiAliasing: boolean;
	bIgnoreColors: boolean;
	clone() : AutomationScreenshotOptions;
	static C(Other: UObject | any): AutomationScreenshotOptions;
	static GetDefaultScreenshotOptionsForGameplay(Tolerance: EComparisonTolerance,Delay: number): AutomationScreenshotOptions;
	static GetDefaultScreenshotOptionsForRendering(Tolerance: EComparisonTolerance,Delay: number): AutomationScreenshotOptions;
}

declare type EFieldIntegerType = 'Integer_DynamicState' | 'Integer_ActivateDisabled' | 'Integer_CollisionGroup' | 'Integer_PositionAnimated' | 'Integer_PositionStatic' | 'Integer_TargetMax' | 'Integer_MAX';
declare var EFieldIntegerType : { Integer_DynamicState:'Integer_DynamicState',Integer_ActivateDisabled:'Integer_ActivateDisabled',Integer_CollisionGroup:'Integer_CollisionGroup',Integer_PositionAnimated:'Integer_PositionAnimated',Integer_PositionStatic:'Integer_PositionStatic',Integer_TargetMax:'Integer_TargetMax',Integer_MAX:'Integer_MAX', };
declare type EFieldScalarType = 'Scalar_ExternalClusterStrain' | 'Scalar_Kill' | 'Scalar_DisableThreshold' | 'Scalar_SleepingThreshold' | 'Scalar_InternalClusterStrain' | 'Scalar_DynamicConstraint' | 'Scalar_TargetMax' | 'Scalar_MAX';
declare var EFieldScalarType : { Scalar_ExternalClusterStrain:'Scalar_ExternalClusterStrain',Scalar_Kill:'Scalar_Kill',Scalar_DisableThreshold:'Scalar_DisableThreshold',Scalar_SleepingThreshold:'Scalar_SleepingThreshold',Scalar_InternalClusterStrain:'Scalar_InternalClusterStrain',Scalar_DynamicConstraint:'Scalar_DynamicConstraint',Scalar_TargetMax:'Scalar_TargetMax',Scalar_MAX:'Scalar_MAX', };
declare type EFieldVectorType = 'Vector_LinearForce' | 'Vector_LinearVelocity' | 'Vector_AngularVelocity' | 'Vector_AngularTorque' | 'Vector_PositionTarget' | 'Vector_InitialLinearVelocity' | 'Vector_InitialAngularVelocity' | 'Vector_LinearImpulse' | 'Vector_TargetMax' | 'Vector_MAX';
declare var EFieldVectorType : { Vector_LinearForce:'Vector_LinearForce',Vector_LinearVelocity:'Vector_LinearVelocity',Vector_AngularVelocity:'Vector_AngularVelocity',Vector_AngularTorque:'Vector_AngularTorque',Vector_PositionTarget:'Vector_PositionTarget',Vector_InitialLinearVelocity:'Vector_InitialLinearVelocity',Vector_InitialAngularVelocity:'Vector_InitialAngularVelocity',Vector_LinearImpulse:'Vector_LinearImpulse',Vector_TargetMax:'Vector_TargetMax',Vector_MAX:'Vector_MAX', };
declare class DebugFloatHistory { 
	Samples: number[];
	MaxSamples: number;
	MinValue: number;
	MaxValue: number;
	bAutoAdjustMinMax: boolean;
	clone() : DebugFloatHistory;
	static C(Other: UObject | any): DebugFloatHistory;
	static AddFloatHistorySample(Value: number,FloatHistory: DebugFloatHistory): DebugFloatHistory;
}

declare class TimerHandle { 
	Handle: number;
	clone() : TimerHandle;
	static C(Other: UObject | any): TimerHandle;
	K2_InvalidateTimerHandle(): {Handle: TimerHandle, $: TimerHandle};
	K2_IsValidTimerHandle(): boolean;
	static K2_InvalidateTimerHandle(Handle?: TimerHandle): {Handle: TimerHandle, $: TimerHandle};
	static K2_IsValidTimerHandle(Handle: TimerHandle): boolean;
	static K2_SetTimerDelegate(delegate: UnrealEngineDelegate<() => void>,Time: number,bLooping: boolean,InitialStartDelay: number,InitialStartDelayVariance: number): TimerHandle;
	static K2_SetTimerForNextTickDelegate(delegate: UnrealEngineDelegate<() => void>): TimerHandle;
}

declare type EQuitPreference = 'Quit' | 'Background' | 'EQuitPreference_MAX';
declare var EQuitPreference : { Quit:'Quit',Background:'Background',EQuitPreference_MAX:'EQuitPreference_MAX', };
declare type ETextureRenderTargetFormat = 'RTF_R8' | 'RTF_RG8' | 'RTF_RGBA8' | 'RTF_RGBA8_SRGB' | 'RTF_R16f' | 'RTF_RG16f' | 'RTF_RGBA16f' | 'RTF_R32f' | 'RTF_RG32f' | 'RTF_RGBA32f' | 'RTF_RGB10A2' | 'RTF_MAX';
declare var ETextureRenderTargetFormat : { RTF_R8:'RTF_R8',RTF_RG8:'RTF_RG8',RTF_RGBA8:'RTF_RGBA8',RTF_RGBA8_SRGB:'RTF_RGBA8_SRGB',RTF_R16f:'RTF_R16f',RTF_RG16f:'RTF_RG16f',RTF_RGBA16f:'RTF_RGBA16f',RTF_R32f:'RTF_R32f',RTF_RG32f:'RTF_RG32f',RTF_RGBA32f:'RTF_RGBA32f',RTF_RGB10A2:'RTF_RGB10A2',RTF_MAX:'RTF_MAX', };
declare type EPixelFormat = 'PF_Unknown' | 'PF_A32B32G32R32F' | 'PF_B8G8R8A8' | 'PF_G8' | 'PF_G16' | 'PF_DXT1' | 'PF_DXT3' | 'PF_DXT5' | 'PF_UYVY' | 'PF_FloatRGB' | 'PF_FloatRGBA' | 'PF_DepthStencil' | 'PF_ShadowDepth' | 'PF_R32_FLOAT' | 'PF_G16R16' | 'PF_G16R16F' | 'PF_G16R16F_FILTER' | 'PF_G32R32F' | 'PF_A2B10G10R10' | 'PF_A16B16G16R16' | 'PF_D24' | 'PF_R16F' | 'PF_R16F_FILTER' | 'PF_BC5' | 'PF_V8U8' | 'PF_A1' | 'PF_FloatR11G11B10' | 'PF_A8' | 'PF_R32_UINT' | 'PF_R32_SINT' | 'PF_PVRTC2' | 'PF_PVRTC4' | 'PF_R16_UINT' | 'PF_R16_SINT' | 'PF_R16G16B16A16_UINT' | 'PF_R16G16B16A16_SINT' | 'PF_R5G6B5_UNORM' | 'PF_R8G8B8A8' | 'PF_A8R8G8B8' | 'PF_BC4' | 'PF_R8G8' | 'PF_ATC_RGB' | 'PF_ATC_RGBA_E' | 'PF_ATC_RGBA_I' | 'PF_X24_G8' | 'PF_ETC1' | 'PF_ETC2_RGB' | 'PF_ETC2_RGBA' | 'PF_R32G32B32A32_UINT' | 'PF_R16G16_UINT' | 'PF_ASTC_4x4' | 'PF_ASTC_6x6' | 'PF_ASTC_8x8' | 'PF_ASTC_10x10' | 'PF_ASTC_12x12' | 'PF_BC6H' | 'PF_BC7' | 'PF_R8_UINT' | 'PF_L8' | 'PF_XGXR8' | 'PF_R8G8B8A8_UINT' | 'PF_R8G8B8A8_SNORM' | 'PF_R16G16B16A16_UNORM' | 'PF_R16G16B16A16_SNORM' | 'PF_PLATFORM_HDR_0' | 'PF_PLATFORM_HDR_1' | 'PF_PLATFORM_HDR_2' | 'PF_NV12' | 'PF_R32G32_UINT' | 'PF_ETC2_R11_EAC' | 'PF_ETC2_RG11_EAC' | 'PF_R8' | 'PF_B5G5R5A1_UNORM' | 'PF_G16R16_SNORM' | 'PF_R8G8_UINT' | 'PF_R32G32B32_UINT' | 'PF_R32G32B32_SINT' | 'PF_R32G32B32F' | 'PF_R8_SINT' | 'PF_R64_UINT' | 'PF_R9G9B9EXP5' | 'PF_MAX';
declare var EPixelFormat : { PF_Unknown:'PF_Unknown',PF_A32B32G32R32F:'PF_A32B32G32R32F',PF_B8G8R8A8:'PF_B8G8R8A8',PF_G8:'PF_G8',PF_G16:'PF_G16',PF_DXT1:'PF_DXT1',PF_DXT3:'PF_DXT3',PF_DXT5:'PF_DXT5',PF_UYVY:'PF_UYVY',PF_FloatRGB:'PF_FloatRGB',PF_FloatRGBA:'PF_FloatRGBA',PF_DepthStencil:'PF_DepthStencil',PF_ShadowDepth:'PF_ShadowDepth',PF_R32_FLOAT:'PF_R32_FLOAT',PF_G16R16:'PF_G16R16',PF_G16R16F:'PF_G16R16F',PF_G16R16F_FILTER:'PF_G16R16F_FILTER',PF_G32R32F:'PF_G32R32F',PF_A2B10G10R10:'PF_A2B10G10R10',PF_A16B16G16R16:'PF_A16B16G16R16',PF_D24:'PF_D24',PF_R16F:'PF_R16F',PF_R16F_FILTER:'PF_R16F_FILTER',PF_BC5:'PF_BC5',PF_V8U8:'PF_V8U8',PF_A1:'PF_A1',PF_FloatR11G11B10:'PF_FloatR11G11B10',PF_A8:'PF_A8',PF_R32_UINT:'PF_R32_UINT',PF_R32_SINT:'PF_R32_SINT',PF_PVRTC2:'PF_PVRTC2',PF_PVRTC4:'PF_PVRTC4',PF_R16_UINT:'PF_R16_UINT',PF_R16_SINT:'PF_R16_SINT',PF_R16G16B16A16_UINT:'PF_R16G16B16A16_UINT',PF_R16G16B16A16_SINT:'PF_R16G16B16A16_SINT',PF_R5G6B5_UNORM:'PF_R5G6B5_UNORM',PF_R8G8B8A8:'PF_R8G8B8A8',PF_A8R8G8B8:'PF_A8R8G8B8',PF_BC4:'PF_BC4',PF_R8G8:'PF_R8G8',PF_ATC_RGB:'PF_ATC_RGB',PF_ATC_RGBA_E:'PF_ATC_RGBA_E',PF_ATC_RGBA_I:'PF_ATC_RGBA_I',PF_X24_G8:'PF_X24_G8',PF_ETC1:'PF_ETC1',PF_ETC2_RGB:'PF_ETC2_RGB',PF_ETC2_RGBA:'PF_ETC2_RGBA',PF_R32G32B32A32_UINT:'PF_R32G32B32A32_UINT',PF_R16G16_UINT:'PF_R16G16_UINT',PF_ASTC_4x4:'PF_ASTC_4x4',PF_ASTC_6x6:'PF_ASTC_6x6',PF_ASTC_8x8:'PF_ASTC_8x8',PF_ASTC_10x10:'PF_ASTC_10x10',PF_ASTC_12x12:'PF_ASTC_12x12',PF_BC6H:'PF_BC6H',PF_BC7:'PF_BC7',PF_R8_UINT:'PF_R8_UINT',PF_L8:'PF_L8',PF_XGXR8:'PF_XGXR8',PF_R8G8B8A8_UINT:'PF_R8G8B8A8_UINT',PF_R8G8B8A8_SNORM:'PF_R8G8B8A8_SNORM',PF_R16G16B16A16_UNORM:'PF_R16G16B16A16_UNORM',PF_R16G16B16A16_SNORM:'PF_R16G16B16A16_SNORM',PF_PLATFORM_HDR_0:'PF_PLATFORM_HDR_0',PF_PLATFORM_HDR_1:'PF_PLATFORM_HDR_1',PF_PLATFORM_HDR_2:'PF_PLATFORM_HDR_2',PF_NV12:'PF_NV12',PF_R32G32_UINT:'PF_R32G32_UINT',PF_ETC2_R11_EAC:'PF_ETC2_R11_EAC',PF_ETC2_RG11_EAC:'PF_ETC2_RG11_EAC',PF_R8:'PF_R8',PF_B5G5R5A1_UNORM:'PF_B5G5R5A1_UNORM',PF_G16R16_SNORM:'PF_G16R16_SNORM',PF_R8G8_UINT:'PF_R8G8_UINT',PF_R32G32B32_UINT:'PF_R32G32B32_UINT',PF_R32G32B32_SINT:'PF_R32G32B32_SINT',PF_R32G32B32F:'PF_R32G32B32F',PF_R8_SINT:'PF_R8_SINT',PF_R64_UINT:'PF_R64_UINT',PF_R9G9B9EXP5:'PF_R9G9B9EXP5',PF_MAX:'PF_MAX', };
declare class TextureRenderTarget2D extends TextureRenderTarget { 
	SizeX: number;
	SizeY: number;
	ClearColor: LinearColor;
	AddressX: TextureAddress;
	AddressY: TextureAddress;
	bForceLinearGamma: boolean;
	bHDR: boolean;
	bGPUSharedFlag: boolean;
	RenderTargetFormat: ETextureRenderTargetFormat;
	bAutoGenerateMips: boolean;
	MipsSamplerFilter: TextureFilter;
	MipsAddressU: TextureAddress;
	MipsAddressV: TextureAddress;
	OverrideFormat: EPixelFormat;
	static Load(ResourceName: string): TextureRenderTarget2D;
	static Find(Outer: UObject, ResourceName: string): TextureRenderTarget2D;
	static GetDefaultObject(): TextureRenderTarget2D;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureRenderTarget2D;
	static C(Other: UObject | any): TextureRenderTarget2D;
	ReleaseRenderTarget2D(): void;
	RenderTargetCreateStaticTexture2DEditorOnly(Name: string,CompressionSettings: TextureCompressionSettings,MipSettings: TextureMipGenSettings): Texture2D;
	ResizeRenderTarget2D(Width: number,Height: number): void;
	static ReleaseRenderTarget2D(TextureRenderTarget: TextureRenderTarget2D): void;
	static RenderTargetCreateStaticTexture2DEditorOnly(RenderTarget: TextureRenderTarget2D,Name: string,CompressionSettings: TextureCompressionSettings,MipSettings: TextureMipGenSettings): Texture2D;
	static ResizeRenderTarget2D(TextureRenderTarget: TextureRenderTarget2D,Width: number,Height: number): void;
}

declare class DrawToRenderTargetContext { 
	RenderTarget: TextureRenderTarget2D;
	clone() : DrawToRenderTargetContext;
	static C(Other: UObject | any): DrawToRenderTargetContext;
}

declare class TextureRenderTarget2DArray extends TextureRenderTarget { 
	SizeX: number;
	SizeY: number;
	Slices: number;
	ClearColor: LinearColor;
	OverrideFormat: EPixelFormat;
	bHDR: boolean;
	bForceLinearGamma: boolean;
	static Load(ResourceName: string): TextureRenderTarget2DArray;
	static Find(Outer: UObject, ResourceName: string): TextureRenderTarget2DArray;
	static GetDefaultObject(): TextureRenderTarget2DArray;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureRenderTarget2DArray;
	static C(Other: UObject | any): TextureRenderTarget2DArray;
}

declare class TextureRenderTargetVolume extends TextureRenderTarget { 
	SizeX: number;
	SizeY: number;
	SizeZ: number;
	ClearColor: LinearColor;
	OverrideFormat: EPixelFormat;
	bHDR: boolean;
	bForceLinearGamma: boolean;
	static Load(ResourceName: string): TextureRenderTargetVolume;
	static Find(Outer: UObject, ResourceName: string): TextureRenderTargetVolume;
	static GetDefaultObject(): TextureRenderTargetVolume;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TextureRenderTargetVolume;
	static C(Other: UObject | any): TextureRenderTargetVolume;
}

declare type EMIDCreationFlags = 'None' | 'Transient' | 'EMIDCreationFlags_MAX';
declare var EMIDCreationFlags : { None:'None',Transient:'Transient',EMIDCreationFlags_MAX:'EMIDCreationFlags_MAX', };
declare type ESpawnActorCollisionHandlingMethod = 'Undefined' | 'AlwaysSpawn' | 'AdjustIfPossibleButAlwaysSpawn' | 'AdjustIfPossibleButDontSpawnIfColliding' | 'DontSpawnIfColliding' | 'ESpawnActorCollisionHandlingMethod_MAX';
declare var ESpawnActorCollisionHandlingMethod : { Undefined:'Undefined',AlwaysSpawn:'AlwaysSpawn',AdjustIfPossibleButAlwaysSpawn:'AdjustIfPossibleButAlwaysSpawn',AdjustIfPossibleButDontSpawnIfColliding:'AdjustIfPossibleButDontSpawnIfColliding',DontSpawnIfColliding:'DontSpawnIfColliding',ESpawnActorCollisionHandlingMethod_MAX:'ESpawnActorCollisionHandlingMethod_MAX', };
declare class PredictProjectilePathParams { 
	StartLocation: Vector;
	LaunchVelocity: Vector;
	bTraceWithCollision: boolean;
	ProjectileRadius: number;
	MaxSimTime: number;
	bTraceWithChannel: boolean;
	TraceChannel: ECollisionChannel;
	ObjectTypes: EObjectTypeQuery[];
	ActorsToIgnore: Actor[];
	SimFrequency: number;
	OverrideGravityZ: number;
	DrawDebugType: EDrawDebugTrace;
	DrawDebugTime: number;
	bTraceComplex: boolean;
	clone() : PredictProjectilePathParams;
	static C(Other: UObject | any): PredictProjectilePathParams;
}

declare class PredictProjectilePathPointData { 
	Location: Vector;
	Velocity: Vector;
	Time: number;
	clone() : PredictProjectilePathPointData;
	static C(Other: UObject | any): PredictProjectilePathPointData;
}

declare class PredictProjectilePathResult { 
	PathData: PredictProjectilePathPointData[];
	LastTraceDestination: PredictProjectilePathPointData;
	HitResult: HitResult;
	clone() : PredictProjectilePathResult;
	static C(Other: UObject | any): PredictProjectilePathResult;
}

declare type ESuggestProjVelocityTraceOption = 'DoNotTrace' | 'TraceFullPath' | 'OnlyTraceWhileAscending' | 'ESuggestProjVelocityTraceOption_MAX';
declare var ESuggestProjVelocityTraceOption : { DoNotTrace:'DoNotTrace',TraceFullPath:'TraceFullPath',OnlyTraceWhileAscending:'OnlyTraceWhileAscending',ESuggestProjVelocityTraceOption_MAX:'ESuggestProjVelocityTraceOption_MAX', };
declare type EMouseCaptureMode = 'NoCapture' | 'CapturePermanently' | 'CapturePermanently_IncludingInitialMouseDown' | 'CaptureDuringMouseDown' | 'CaptureDuringRightMouseDown' | 'EMouseCaptureMode_MAX';
declare var EMouseCaptureMode : { NoCapture:'NoCapture',CapturePermanently:'CapturePermanently',CapturePermanently_IncludingInitialMouseDown:'CapturePermanently_IncludingInitialMouseDown',CaptureDuringMouseDown:'CaptureDuringMouseDown',CaptureDuringRightMouseDown:'CaptureDuringRightMouseDown',EMouseCaptureMode_MAX:'EMouseCaptureMode_MAX', };
declare type EGrammaticalGender = 'Neuter' | 'Masculine' | 'Feminine' | 'Mixed' | 'EGrammaticalGender_MAX';
declare var EGrammaticalGender : { Neuter:'Neuter',Masculine:'Masculine',Feminine:'Feminine',Mixed:'Mixed',EGrammaticalGender_MAX:'EGrammaticalGender_MAX', };
declare type EGrammaticalNumber = 'Singular' | 'Plural' | 'EGrammaticalNumber_MAX';
declare var EGrammaticalNumber : { Singular:'Singular',Plural:'Plural',EGrammaticalNumber_MAX:'EGrammaticalNumber_MAX', };
declare class DialogueVoice extends UObject { 
	Gender: EGrammaticalGender;
	Plurality: EGrammaticalNumber;
	LocalizationGUID: Guid;
	static Load(ResourceName: string): DialogueVoice;
	static Find(Outer: UObject, ResourceName: string): DialogueVoice;
	static GetDefaultObject(): DialogueVoice;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DialogueVoice;
	static C(Other: UObject | any): DialogueVoice;
}

declare class DialogueContext { 
	Speaker: DialogueVoice;
	Targets: DialogueVoice[];
	clone() : DialogueContext;
	static C(Other: UObject | any): DialogueContext;
}

declare class DialogueSoundWaveProxy extends SoundBase { 
	static Load(ResourceName: string): DialogueSoundWaveProxy;
	static Find(Outer: UObject, ResourceName: string): DialogueSoundWaveProxy;
	static GetDefaultObject(): DialogueSoundWaveProxy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DialogueSoundWaveProxy;
	static C(Other: UObject | any): DialogueSoundWaveProxy;
}

declare class DialogueContextMapping { 
	Context: DialogueContext;
	SoundWave: SoundWave;
	LocalizationKeyFormat: string;
	Proxy: DialogueSoundWaveProxy;
	clone() : DialogueContextMapping;
	static C(Other: UObject | any): DialogueContextMapping;
}

declare class DialogueWave extends UObject { 
	bMature: boolean;
	bOverride_SubtitleOverride: boolean;
	SpokenText: string;
	SubtitleOverride: string;
	VoiceActorDirection: string;
	ContextMappings: DialogueContextMapping[];
	LocalizationGUID: Guid;
	static Load(ResourceName: string): DialogueWave;
	static Find(Outer: UObject, ResourceName: string): DialogueWave;
	static GetDefaultObject(): DialogueWave;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): DialogueWave;
	static C(Other: UObject | any): DialogueWave;
	SpawnDialogueAttached(Context: DialogueContext,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,VolumeMultiplier: number,PitchMultiplier: number,StartTime: number,AttenuationSettings: SoundAttenuation,bAutoDestroy: boolean): AudioComponent;
	static SpawnDialogueAttached(Dialogue: DialogueWave,Context: DialogueContext,AttachToComponent: SceneComponent,AttachPointName: string,Location: Vector,Rotation: Rotator,LocationType: EAttachLocation,bStopWhenAttachedToDestroyed: boolean,VolumeMultiplier: number,PitchMultiplier: number,StartTime: number,AttenuationSettings: SoundAttenuation,bAutoDestroy: boolean): AudioComponent;
}

declare class InitialActiveSoundParams extends UObject { 
	AudioParams: AudioParameter[];
	static Load(ResourceName: string): InitialActiveSoundParams;
	static Find(Outer: UObject, ResourceName: string): InitialActiveSoundParams;
	static GetDefaultObject(): InitialActiveSoundParams;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): InitialActiveSoundParams;
	static C(Other: UObject | any): InitialActiveSoundParams;
}

declare type EAudioMixerStreamDataFormatType = 'Unknown' | 'Float' | 'Int16' | 'Unsupported' | 'EAudioMixerStreamDataFormatType_MAX';
declare var EAudioMixerStreamDataFormatType : { Unknown:'Unknown',Float:'Float',Int16:'Int16',Unsupported:'Unsupported',EAudioMixerStreamDataFormatType_MAX:'EAudioMixerStreamDataFormatType_MAX', };
declare type EAudioMixerChannelType = 'FrontLeft' | 'FrontRight' | 'FrontCenter' | 'LowFrequency' | 'BackLeft' | 'BackRight' | 'FrontLeftOfCenter' | 'FrontRightOfCenter' | 'BackCenter' | 'SideLeft' | 'SideRight' | 'TopCenter' | 'TopFrontLeft' | 'TopFrontCenter' | 'TopFrontRight' | 'TopBackLeft' | 'TopBackCenter' | 'TopBackRight' | 'Unknown' | 'ChannelTypeCount' | 'DefaultChannel' | 'EAudioMixerChannelType_MAX';
declare var EAudioMixerChannelType : { FrontLeft:'FrontLeft',FrontRight:'FrontRight',FrontCenter:'FrontCenter',LowFrequency:'LowFrequency',BackLeft:'BackLeft',BackRight:'BackRight',FrontLeftOfCenter:'FrontLeftOfCenter',FrontRightOfCenter:'FrontRightOfCenter',BackCenter:'BackCenter',SideLeft:'SideLeft',SideRight:'SideRight',TopCenter:'TopCenter',TopFrontLeft:'TopFrontLeft',TopFrontCenter:'TopFrontCenter',TopFrontRight:'TopFrontRight',TopBackLeft:'TopBackLeft',TopBackCenter:'TopBackCenter',TopBackRight:'TopBackRight',Unknown:'Unknown',ChannelTypeCount:'ChannelTypeCount',DefaultChannel:'DefaultChannel',EAudioMixerChannelType_MAX:'EAudioMixerChannelType_MAX', };
declare class AudioOutputDeviceInfo { 
	Name: string;
	DeviceID: string;
	NumChannels: number;
	SampleRate: number;
	Format: EAudioMixerStreamDataFormatType;
	OutputChannelArray: EAudioMixerChannelType[];
	bIsSystemDefault: boolean;
	bIsCurrentDevice: boolean;
	clone() : AudioOutputDeviceInfo;
	static C(Other: UObject | any): AudioOutputDeviceInfo;
	Conv_AudioOutputDeviceInfoToString(): string;
	static Conv_AudioOutputDeviceInfoToString(Info: AudioOutputDeviceInfo): string;
}

declare type ESwapAudioOutputDeviceResultState = 'Failure' | 'Success' | 'None' | 'ESwapAudioOutputDeviceResultState_MAX';
declare var ESwapAudioOutputDeviceResultState : { Failure:'Failure',Success:'Success',None:'None',ESwapAudioOutputDeviceResultState_MAX:'ESwapAudioOutputDeviceResultState_MAX', };
declare class SwapAudioOutputResult { 
	CurrentDeviceId: string;
	RequestedDeviceId: string;
	Result: ESwapAudioOutputDeviceResultState;
	clone() : SwapAudioOutputResult;
	static C(Other: UObject | any): SwapAudioOutputResult;
}

declare type ETransformConstraintType = 'Translation' | 'Rotation' | 'Scale' | 'Parent' | 'LookAt' | 'ETransformConstraintType_MAX';
declare var ETransformConstraintType : { Translation:'Translation',Rotation:'Rotation',Scale:'Scale',Parent:'Parent',LookAt:'LookAt',ETransformConstraintType_MAX:'ETransformConstraintType_MAX', };
declare class TickableTransformConstraint extends TickableConstraint { 
	ParentTRSHandle: TransformableHandle;
	ChildTRSHandle: TransformableHandle;
	bMaintainOffset: boolean;
	Weight: number;
	bDynamicOffset: boolean;
	Type: ETransformConstraintType;
	static Load(ResourceName: string): TickableTransformConstraint;
	static Find(Outer: UObject, ResourceName: string): TickableTransformConstraint;
	static GetDefaultObject(): TickableTransformConstraint;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TickableTransformConstraint;
	static C(Other: UObject | any): TickableTransformConstraint;
}

declare class TransformableComponentHandle extends TransformableHandle { 
	Component: SceneComponent;
	SocketName: string;
	static Load(ResourceName: string): TransformableComponentHandle;
	static Find(Outer: UObject, ResourceName: string): TransformableComponentHandle;
	static GetDefaultObject(): TransformableComponentHandle;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): TransformableComponentHandle;
	static C(Other: UObject | any): TransformableComponentHandle;
}

declare class ConstraintsManager extends UObject { 
	OnConstraintAdded_BP: UnrealEngineMulticastDelegate<(Mananger: ConstraintsManager, Constraint: TickableConstraint) => void>;
	OnConstraintRemoved_BP: UnrealEngineMulticastDelegate<(Mananger: ConstraintsManager, Constraint: TickableConstraint, bDoNotCompensate: boolean) => void>;
	Constraints: TickableConstraint[];
	static Load(ResourceName: string): ConstraintsManager;
	static Find(Outer: UObject, ResourceName: string): ConstraintsManager;
	static GetDefaultObject(): ConstraintsManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): ConstraintsManager;
	static C(Other: UObject | any): ConstraintsManager;
}

declare type EPathFollowingResult = 'Success' | 'Blocked' | 'OffPath' | 'Aborted' | 'Skipped_DEPRECATED' | 'Invalid' | 'EPathFollowingResult_MAX';
declare var EPathFollowingResult : { Success:'Success',Blocked:'Blocked',OffPath:'OffPath',Aborted:'Aborted',Skipped_DEPRECATED:'Skipped_DEPRECATED',Invalid:'Invalid',EPathFollowingResult_MAX:'EPathFollowingResult_MAX', };
declare class AIRequestID { 
	RequestID: number;
	clone() : AIRequestID;
	static C(Other: UObject | any): AIRequestID;
}

declare class AIAsyncTaskBlueprintProxy extends UObject { 
	OnSuccess: UnrealEngineMulticastDelegate<(MovementResult: EPathFollowingResult) => void>;
	OnFail: UnrealEngineMulticastDelegate<(MovementResult: EPathFollowingResult) => void>;
	static Load(ResourceName: string): AIAsyncTaskBlueprintProxy;
	static Find(Outer: UObject, ResourceName: string): AIAsyncTaskBlueprintProxy;
	static GetDefaultObject(): AIAsyncTaskBlueprintProxy;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIAsyncTaskBlueprintProxy;
	OnMoveCompleted(RequestID: AIRequestID,MovementResult: EPathFollowingResult): void;
	static C(Other: UObject | any): AIAsyncTaskBlueprintProxy;
}

declare class BlackboardKeyType extends UObject { 
	static Load(ResourceName: string): BlackboardKeyType;
	static Find(Outer: UObject, ResourceName: string): BlackboardKeyType;
	static GetDefaultObject(): BlackboardKeyType;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlackboardKeyType;
	static C(Other: UObject | any): BlackboardKeyType;
}

declare class BlackboardKeySelector { 
	AllowedTypes: BlackboardKeyType[];
	SelectedKeyName: string;
	SelectedKeyType: UnrealEngineClass;
	SelectedKeyID: number;
	bNoneIsAllowedValue: boolean;
	clone() : BlackboardKeySelector;
	static C(Other: UObject | any): BlackboardKeySelector;
}

declare class BlackboardEntry { 
	EntryName: string;
	EntryDescription: string;
	EntryCategory: string;
	KeyType: BlackboardKeyType;
	bInstanceSynced: boolean;
	clone() : BlackboardEntry;
	static C(Other: UObject | any): BlackboardEntry;
}

declare class BlackboardData extends DataAsset { 
	Parent: BlackboardData;
	ParentKeys: BlackboardEntry[];
	Keys: BlackboardEntry[];
	bHasSynchronizedKeys: boolean;
	static Load(ResourceName: string): BlackboardData;
	static Find(Outer: UObject, ResourceName: string): BlackboardData;
	static GetDefaultObject(): BlackboardData;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlackboardData;
	static C(Other: UObject | any): BlackboardData;
}

declare class BlackboardComponent extends ActorComponent { 
	BrainComp: BrainComponent;
	DefaultBlackboardAsset: BlackboardData;
	BlackboardAsset: BlackboardData;
	KeyInstances: BlackboardKeyType[];
	static Load(ResourceName: string): BlackboardComponent;
	static Find(Outer: UObject, ResourceName: string): BlackboardComponent;
	static GetDefaultObject(): BlackboardComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BlackboardComponent;
	SetValueAsVector(KeyName: string,VectorValue: Vector): void;
	SetValueAsString(KeyName: string,StringValue: string): void;
	SetValueAsRotator(KeyName: string,VectorValue: Rotator): void;
	SetValueAsObject(KeyName: string,ObjectValue: UObject): void;
	SetValueAsName(KeyName: string,NameValue: string): void;
	SetValueAsInt(KeyName: string,IntValue: number): void;
	SetValueAsFloat(KeyName: string,FloatValue: number): void;
	SetValueAsEnum(KeyName: string,EnumValue: number): void;
	SetValueAsClass(KeyName: string,ClassValue: UnrealEngineClass): void;
	SetValueAsBool(KeyName: string,BoolValue: boolean): void;
	IsVectorValueSet(KeyName: string): boolean;
	GetValueAsVector(KeyName: string): Vector;
	GetValueAsString(KeyName: string): string;
	GetValueAsRotator(KeyName: string): Rotator;
	GetValueAsObject(KeyName: string): UObject;
	GetValueAsName(KeyName: string): string;
	GetValueAsInt(KeyName: string): number;
	GetValueAsFloat(KeyName: string): number;
	GetValueAsEnum(KeyName: string): number;
	GetValueAsClass(KeyName: string): UnrealEngineClass;
	GetValueAsBool(KeyName: string): boolean;
	GetRotationFromEntry(KeyName: string,ResultRotation?: Rotator): {ResultRotation: Rotator, $: boolean};
	GetLocationFromEntry(KeyName: string,ResultLocation?: Vector): {ResultLocation: Vector, $: boolean};
	ClearValue(KeyName: string): void;
	static C(Other: UObject | any): BlackboardComponent;
}

declare type EPathFollowingAction = 'Error' | 'NoMove' | 'DirectMove' | 'PartialPath' | 'PathToGoal' | 'EPathFollowingAction_MAX';
declare var EPathFollowingAction : { Error:'Error',NoMove:'NoMove',DirectMove:'DirectMove',PartialPath:'PartialPath',PathToGoal:'PathToGoal',EPathFollowingAction_MAX:'EPathFollowingAction_MAX', };
declare class PathFollowingComponent extends ActorComponent { 
	MovementComp: NavMovementComponent;
	MyNavData: NavigationData;
	static Load(ResourceName: string): PathFollowingComponent;
	static Find(Outer: UObject, ResourceName: string): PathFollowingComponent;
	static GetDefaultObject(): PathFollowingComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PathFollowingComponent;
	OnNavDataRegistered(NavData: NavigationData): void;
	OnActorBump(SelfActor: Actor,OtherActor: Actor,NormalImpulse: Vector,Hit: HitResult): void;
	GetPathDestination(): Vector;
	GetPathActionType(): EPathFollowingAction;
	static C(Other: UObject | any): PathFollowingComponent;
}

declare class AISenseConfig extends UObject { 
	DebugColor: Color;
	MaxAge: number;
	bStartsEnabled: boolean;
	static Load(ResourceName: string): AISenseConfig;
	static Find(Outer: UObject, ResourceName: string): AISenseConfig;
	static GetDefaultObject(): AISenseConfig;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISenseConfig;
	static C(Other: UObject | any): AISenseConfig;
}

declare type EAISenseNotifyType = 'OnEveryPerception' | 'OnPerceptionChange' | 'EAISenseNotifyType_MAX';
declare var EAISenseNotifyType : { OnEveryPerception:'OnEveryPerception',OnPerceptionChange:'OnPerceptionChange',EAISenseNotifyType_MAX:'EAISenseNotifyType_MAX', };
declare class BehaviorTreeTemplateInfo { 
	Asset: BehaviorTree;
	Template: BTCompositeNode;
	clone() : BehaviorTreeTemplateInfo;
	static C(Other: UObject | any): BehaviorTreeTemplateInfo;
}

declare class BehaviorTreeManager extends UObject { 
	MaxDebuggerSteps: number;
	LoadedTemplates: BehaviorTreeTemplateInfo[];
	ActiveComponents: BehaviorTreeComponent[];
	static Load(ResourceName: string): BehaviorTreeManager;
	static Find(Outer: UObject, ResourceName: string): BehaviorTreeManager;
	static GetDefaultObject(): BehaviorTreeManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BehaviorTreeManager;
	static C(Other: UObject | any): BehaviorTreeManager;
}

declare class EnvQueryNode extends UObject { 
	VerNum: number;
	static Load(ResourceName: string): EnvQueryNode;
	static Find(Outer: UObject, ResourceName: string): EnvQueryNode;
	static GetDefaultObject(): EnvQueryNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryNode;
	static C(Other: UObject | any): EnvQueryNode;
}

declare class EnvQueryItemType extends UObject { 
	static Load(ResourceName: string): EnvQueryItemType;
	static Find(Outer: UObject, ResourceName: string): EnvQueryItemType;
	static GetDefaultObject(): EnvQueryItemType;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryItemType;
	static C(Other: UObject | any): EnvQueryItemType;
}

declare class EnvQueryGenerator extends EnvQueryNode { 
	OptionName: string;
	ItemType: UnrealEngineClass;
	bAutoSortTests: boolean;
	static Load(ResourceName: string): EnvQueryGenerator;
	static Find(Outer: UObject, ResourceName: string): EnvQueryGenerator;
	static GetDefaultObject(): EnvQueryGenerator;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryGenerator;
	static C(Other: UObject | any): EnvQueryGenerator;
}

declare type EEnvTestPurpose = 'Filter' | 'Score' | 'FilterAndScore' | 'EEnvTestPurpose_MAX';
declare var EEnvTestPurpose : { Filter:'Filter',Score:'Score',FilterAndScore:'FilterAndScore',EEnvTestPurpose_MAX:'EEnvTestPurpose_MAX', };
declare type EEnvTestFilterOperator = 'AllPass' | 'AnyPass' | 'EEnvTestFilterOperator_MAX';
declare var EEnvTestFilterOperator : { AllPass:'AllPass',AnyPass:'AnyPass',EEnvTestFilterOperator_MAX:'EEnvTestFilterOperator_MAX', };
declare type EEnvTestScoreOperator = 'AverageScore' | 'MinScore' | 'MaxScore' | 'Multiply' | 'EEnvTestScoreOperator_MAX';
declare var EEnvTestScoreOperator : { AverageScore:'AverageScore',MinScore:'MinScore',MaxScore:'MaxScore',Multiply:'Multiply',EEnvTestScoreOperator_MAX:'EEnvTestScoreOperator_MAX', };
declare type EEnvTestFilterType = 'Minimum' | 'Maximum' | 'Range' | 'Match' | 'EEnvTestFilterType_MAX';
declare var EEnvTestFilterType : { Minimum:'Minimum',Maximum:'Maximum',Range:'Range',Match:'Match',EEnvTestFilterType_MAX:'EEnvTestFilterType_MAX', };
declare class AIDataProvider extends UObject { 
	static Load(ResourceName: string): AIDataProvider;
	static Find(Outer: UObject, ResourceName: string): AIDataProvider;
	static GetDefaultObject(): AIDataProvider;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIDataProvider;
	static C(Other: UObject | any): AIDataProvider;
}

declare class AIDataProviderValue { 
	DataBinding: AIDataProvider;
	DataField: string;
	clone() : AIDataProviderValue;
	static C(Other: UObject | any): AIDataProviderValue;
}

declare class AIDataProviderTypedValue extends AIDataProviderValue { 
	PropertyType: UnrealEngineClass;
	clone() : AIDataProviderTypedValue;
	static C(Other: UObject | any): AIDataProviderTypedValue;
}

declare class AIDataProviderBoolValue extends AIDataProviderTypedValue { 
	DefaultValue: boolean;
	clone() : AIDataProviderBoolValue;
	static C(Other: UObject | any): AIDataProviderBoolValue;
}

declare class AIDataProviderFloatValue extends AIDataProviderTypedValue { 
	DefaultValue: number;
	clone() : AIDataProviderFloatValue;
	static C(Other: UObject | any): AIDataProviderFloatValue;
}

declare type EEnvTestScoreEquation = 'Linear' | 'Square' | 'InverseLinear' | 'SquareRoot' | 'Constant' | 'EEnvTestScoreEquation_MAX';
declare var EEnvTestScoreEquation : { Linear:'Linear',Square:'Square',InverseLinear:'InverseLinear',SquareRoot:'SquareRoot',Constant:'Constant',EEnvTestScoreEquation_MAX:'EEnvTestScoreEquation_MAX', };
declare type EEnvQueryTestClamping = 'None' | 'SpecifiedValue' | 'FilterThreshold' | 'EEnvQueryTestClamping_MAX';
declare var EEnvQueryTestClamping : { None:'None',SpecifiedValue:'SpecifiedValue',FilterThreshold:'FilterThreshold',EEnvQueryTestClamping_MAX:'EEnvQueryTestClamping_MAX', };
declare type EEQSNormalizationType = 'Absolute' | 'RelativeToScores' | 'EEQSNormalizationType_MAX';
declare var EEQSNormalizationType : { Absolute:'Absolute',RelativeToScores:'RelativeToScores',EEQSNormalizationType_MAX:'EEQSNormalizationType_MAX', };
declare class EnvQueryTest extends EnvQueryNode { 
	TestOrder: number;
	TestPurpose: EEnvTestPurpose;
	TestComment: string;
	MultipleContextFilterOp: EEnvTestFilterOperator;
	MultipleContextScoreOp: EEnvTestScoreOperator;
	FilterType: EEnvTestFilterType;
	BoolValue: AIDataProviderBoolValue;
	FloatValueMin: AIDataProviderFloatValue;
	FloatValueMax: AIDataProviderFloatValue;
	ScoringEquation: EEnvTestScoreEquation;
	ClampMinType: EEnvQueryTestClamping;
	ClampMaxType: EEnvQueryTestClamping;
	NormalizationType: EEQSNormalizationType;
	ScoreClampMin: AIDataProviderFloatValue;
	ScoreClampMax: AIDataProviderFloatValue;
	ScoringFactor: AIDataProviderFloatValue;
	ReferenceValue: AIDataProviderFloatValue;
	bDefineReferenceValue: boolean;
	bWorkOnFloatValues: boolean;
	static Load(ResourceName: string): EnvQueryTest;
	static Find(Outer: UObject, ResourceName: string): EnvQueryTest;
	static GetDefaultObject(): EnvQueryTest;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryTest;
	static C(Other: UObject | any): EnvQueryTest;
}

declare class EnvQueryOption extends UObject { 
	Generator: EnvQueryGenerator;
	Tests: EnvQueryTest[];
	static Load(ResourceName: string): EnvQueryOption;
	static Find(Outer: UObject, ResourceName: string): EnvQueryOption;
	static GetDefaultObject(): EnvQueryOption;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryOption;
	static C(Other: UObject | any): EnvQueryOption;
}

declare class EnvQuery extends DataAsset { 
	EdGraph: EdGraph;
	QueryName: string;
	Options: EnvQueryOption[];
	static Load(ResourceName: string): EnvQuery;
	static Find(Outer: UObject, ResourceName: string): EnvQuery;
	static GetDefaultObject(): EnvQuery;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQuery;
	static C(Other: UObject | any): EnvQuery;
}

declare class EnvQueryInstanceCache { 
	Template: EnvQuery;
	clone() : EnvQueryInstanceCache;
	static C(Other: UObject | any): EnvQueryInstanceCache;
}

declare class EnvQueryContext extends UObject { 
	static Load(ResourceName: string): EnvQueryContext;
	static Find(Outer: UObject, ResourceName: string): EnvQueryContext;
	static GetDefaultObject(): EnvQueryContext;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryContext;
	static C(Other: UObject | any): EnvQueryContext;
}

declare type EEnvQueryStatus = 'Processing' | 'Success' | 'Failed' | 'Aborted' | 'OwnerLost' | 'MissingParam' | 'EEnvQueryStatus_MAX';
declare var EEnvQueryStatus : { Processing:'Processing',Success:'Success',Failed:'Failed',Aborted:'Aborted',OwnerLost:'OwnerLost',MissingParam:'MissingParam',EEnvQueryStatus_MAX:'EEnvQueryStatus_MAX', };
declare class EnvQueryInstanceBlueprintWrapper extends UObject { 
	QueryID: number;
	ItemType: UnrealEngineClass;
	OptionIndex: number;
	OnQueryFinishedEvent: UnrealEngineMulticastDelegate<(QueryInstance: EnvQueryInstanceBlueprintWrapper, QueryStatus: EEnvQueryStatus) => void>;
	static Load(ResourceName: string): EnvQueryInstanceBlueprintWrapper;
	static Find(Outer: UObject, ResourceName: string): EnvQueryInstanceBlueprintWrapper;
	static GetDefaultObject(): EnvQueryInstanceBlueprintWrapper;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryInstanceBlueprintWrapper;
	SetNamedParam(ParamName: string,Value: number): void;
	GetResultsAsLocations(): Vector[];
	GetResultsAsActors(): Actor[];
	GetQueryResultsAsLocations(ResultLocations?: Vector[]): {ResultLocations: Vector[], $: boolean};
	GetQueryResultsAsActors(ResultActors?: Actor[]): {ResultActors: Actor[], $: boolean};
	GetItemScore(ItemIndex: number): number;
	static C(Other: UObject | any): EnvQueryInstanceBlueprintWrapper;
}

declare type EEnvQueryRunMode = 'SingleResult' | 'RandomBest5Pct' | 'RandomBest25Pct' | 'AllMatching' | 'EEnvQueryRunMode_MAX';
declare var EEnvQueryRunMode : { SingleResult:'SingleResult',RandomBest5Pct:'RandomBest5Pct',RandomBest25Pct:'RandomBest25Pct',AllMatching:'AllMatching',EEnvQueryRunMode_MAX:'EEnvQueryRunMode_MAX', };
declare class EnvQueryManager extends AISubsystem { 
	InstanceCache: EnvQueryInstanceCache[];
	LocalContexts: EnvQueryContext[];
	GCShieldedWrappers: EnvQueryInstanceBlueprintWrapper[];
	MaxAllowedTestingTime: number;
	bTestQueriesUsingBreadth: boolean;
	QueryCountWarningThreshold: number;
	QueryCountWarningInterval: number;
	ExecutionTimeWarningSeconds: number;
	HandlingResultTimeWarningSeconds: number;
	GenerationTimeWarningSeconds: number;
	static Load(ResourceName: string): EnvQueryManager;
	static Find(Outer: UObject, ResourceName: string): EnvQueryManager;
	static GetDefaultObject(): EnvQueryManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): EnvQueryManager;
	static RunEQSQuery(WorldContextObject: UObject,QueryTemplate: EnvQuery,Querier: UObject,RunMode: EEnvQueryRunMode,WrapperClass: UnrealEngineClass): EnvQueryInstanceBlueprintWrapper;
	static C(Other: UObject | any): EnvQueryManager;
}

declare class AIHotSpotManager extends UObject { 
	static Load(ResourceName: string): AIHotSpotManager;
	static Find(Outer: UObject, ResourceName: string): AIHotSpotManager;
	static GetDefaultObject(): AIHotSpotManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIHotSpotManager;
	static C(Other: UObject | any): AIHotSpotManager;
}

declare class NavLocalGridManager extends UObject { 
	static Load(ResourceName: string): NavLocalGridManager;
	static Find(Outer: UObject, ResourceName: string): NavLocalGridManager;
	static GetDefaultObject(): NavLocalGridManager;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavLocalGridManager;
	static SetLocalNavigationGridDensity(WorldContextObject: UObject,CellSize: number): boolean;
	static RemoveLocalNavigationGrid(WorldContextObject: UObject,GridId: number,bRebuildGrids: boolean): void;
	static FindLocalNavigationGridPath(WorldContextObject: UObject,Start: Vector,End: Vector,PathPoints?: Vector[]): {PathPoints: Vector[], $: boolean};
	static AddLocalNavigationGridForPoints(WorldContextObject: UObject,Locations: Vector[],Radius2D: number,Height: number,bRebuildGrids: boolean): number;
	static AddLocalNavigationGridForPoint(WorldContextObject: UObject,Location: Vector,Radius2D: number,Height: number,bRebuildGrids: boolean): number;
	static AddLocalNavigationGridForCapsule(WorldContextObject: UObject,Location: Vector,CapsuleRadius: number,CapsuleHalfHeight: number,Radius2D: number,Height: number,bRebuildGrids: boolean): number;
	static AddLocalNavigationGridForBox(WorldContextObject: UObject,Location: Vector,Extent: Vector,Rotation: Rotator,Radius2D: number,Height: number,bRebuildGrids: boolean): number;
	static C(Other: UObject | any): NavLocalGridManager;
}

declare class AISystem extends AISystemBase { 
	PerceptionSystemClassName: SoftClassPath;
	HotSpotManagerClassName: SoftClassPath;
	EnvQueryManagerClassName: SoftClassPath;
	AcceptanceRadius: number;
	PathfollowingRegularPathPointAcceptanceRadius: number;
	PathfollowingNavLinkAcceptanceRadius: number;
	bFinishMoveOnGoalOverlap: boolean;
	bAcceptPartialPaths: boolean;
	bAllowStrafing: boolean;
	bEnableBTAITasks: boolean;
	bAllowControllersAsEQSQuerier: boolean;
	bEnableDebuggerPlugin: boolean;
	bForgetStaleActors: boolean;
	bAddBlackboardSelfKey: boolean;
	bClearBBEntryOnBTEQSFail: boolean;
	DefaultSightCollisionChannel: ECollisionChannel;
	BehaviorTreeManager: BehaviorTreeManager;
	EnvironmentQueryManager: EnvQueryManager;
	PerceptionSystem: AIPerceptionSystem;
	AllProxyObjects: AIAsyncTaskBlueprintProxy[];
	HotSpotManager: AIHotSpotManager;
	NavLocalGrids: NavLocalGridManager;
	static Load(ResourceName: string): AISystem;
	static Find(Outer: UObject, ResourceName: string): AISystem;
	static GetDefaultObject(): AISystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISystem;
	AILoggingVerbose(): void;
	AIIgnorePlayers(): void;
	static C(Other: UObject | any): AISystem;
}

declare class AISubsystem extends UObject { 
	AISystem: AISystem;
	static Load(ResourceName: string): AISubsystem;
	static Find(Outer: UObject, ResourceName: string): AISubsystem;
	static GetDefaultObject(): AISubsystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISubsystem;
	static C(Other: UObject | any): AISubsystem;
}

declare class AISenseEvent extends UObject { 
	static Load(ResourceName: string): AISenseEvent;
	static Find(Outer: UObject, ResourceName: string): AISenseEvent;
	static GetDefaultObject(): AISenseEvent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISenseEvent;
	static C(Other: UObject | any): AISenseEvent;
}

declare class AIStimulus { 
	Age: number;
	ExpirationAge: number;
	Strength: number;
	StimulusLocation: Vector;
	ReceiverLocation: Vector;
	Tag: string;
	bSuccessfullySensed: boolean;
	clone() : AIStimulus;
	static C(Other: UObject | any): AIStimulus;
}

declare class AIPerceptionSystem extends AISubsystem { 
	Senses: AISense[];
	PerceptionAgingRate: number;
	static Load(ResourceName: string): AIPerceptionSystem;
	static Find(Outer: UObject, ResourceName: string): AIPerceptionSystem;
	static GetDefaultObject(): AIPerceptionSystem;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIPerceptionSystem;
	static ReportPerceptionEvent(WorldContextObject: UObject,PerceptionEvent: AISenseEvent): void;
	ReportEvent(PerceptionEvent: AISenseEvent): void;
	static RegisterPerceptionStimuliSource(WorldContextObject: UObject,Sense: UnrealEngineClass,Target: Actor): boolean;
	OnPerceptionStimuliSourceEndPlay(Actor: Actor,EndPlayReason: EEndPlayReason): void;
	static GetSenseClassForStimulus(WorldContextObject: UObject,Stimulus: AIStimulus): UnrealEngineClass;
	static C(Other: UObject | any): AIPerceptionSystem;
}

declare class AISense extends UObject { 
	DefaultExpirationAge: number;
	NotifyType: EAISenseNotifyType;
	bWantsNewPawnNotification: boolean;
	bAutoRegisterAllPawnsAsSources: boolean;
	PerceptionSystemInstance: AIPerceptionSystem;
	static Load(ResourceName: string): AISense;
	static Find(Outer: UObject, ResourceName: string): AISense;
	static GetDefaultObject(): AISense;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AISense;
	static C(Other: UObject | any): AISense;
}

declare class ActorPerceptionUpdateInfo { 
	TargetId: number;
	Target: Actor;
	Stimulus: AIStimulus;
	clone() : ActorPerceptionUpdateInfo;
	static C(Other: UObject | any): ActorPerceptionUpdateInfo;
}

declare class ActorPerceptionBlueprintInfo { 
	Target: Actor;
	LastSensedStimuli: AIStimulus[];
	bIsHostile: boolean;
	clone() : ActorPerceptionBlueprintInfo;
	static C(Other: UObject | any): ActorPerceptionBlueprintInfo;
}

declare class AIPerceptionComponent extends ActorComponent { 
	SensesConfig: AISenseConfig[];
	DominantSense: UnrealEngineClass;
	AIOwner: AIController;
	OnPerceptionUpdated: UnrealEngineMulticastDelegate<(UpdatedActors: Actor[]) => void>;
	OnTargetPerceptionUpdated: UnrealEngineMulticastDelegate<(Actor: Actor, Stimulus: AIStimulus) => void>;
	OnTargetPerceptionInfoUpdated: UnrealEngineMulticastDelegate<(UpdateInfo: ActorPerceptionUpdateInfo) => void>;
	static Load(ResourceName: string): AIPerceptionComponent;
	static Find(Outer: UObject, ResourceName: string): AIPerceptionComponent;
	static GetDefaultObject(): AIPerceptionComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIPerceptionComponent;
	SetSenseEnabled(SenseClass: UnrealEngineClass,bEnable: boolean): void;
	RequestStimuliListenerUpdate(): void;
	OnOwnerEndPlay(Actor: Actor,EndPlayReason: EEndPlayReason): void;
	GetPerceivedHostileActorsBySense(SenseToUse: UnrealEngineClass,OutActors?: Actor[]): {OutActors: Actor[]};
	GetPerceivedHostileActors(OutActors?: Actor[]): {OutActors: Actor[]};
	GetPerceivedActors(SenseToUse: UnrealEngineClass,OutActors?: Actor[]): {OutActors: Actor[]};
	GetKnownPerceivedActors(SenseToUse: UnrealEngineClass,OutActors?: Actor[]): {OutActors: Actor[]};
	GetCurrentlyPerceivedActors(SenseToUse: UnrealEngineClass,OutActors?: Actor[]): {OutActors: Actor[]};
	GetActorsPerception(Actor: Actor,Info?: ActorPerceptionBlueprintInfo): {Info: ActorPerceptionBlueprintInfo, $: boolean};
	ForgetAll(): void;
	static C(Other: UObject | any): AIPerceptionComponent;
}

declare type EAIRequestPriority = 'SoftScript' | 'Logic' | 'HardScript' | 'Reaction' | 'Ultimate' | 'MAX';
declare var EAIRequestPriority : { SoftScript:'SoftScript',Logic:'Logic',HardScript:'HardScript',Reaction:'Reaction',Ultimate:'Ultimate',MAX:'MAX', };
declare type EPawnActionResult = 'NotStarted' | 'InProgress' | 'Success' | 'Failed' | 'Aborted' | 'EPawnActionResult_MAX';
declare var EPawnActionResult : { NotStarted:'NotStarted',InProgress:'InProgress',Success:'Success',Failed:'Failed',Aborted:'Aborted',EPawnActionResult_MAX:'EPawnActionResult_MAX', };
declare class PawnAction extends UObject { 
	ChildAction: PawnAction;
	ParentAction: PawnAction;
	OwnerComponent: PawnActionsComponent;
	Instigator: UObject;
	BrainComp: BrainComponent;
	bAllowNewSameClassInstance: boolean;
	bReplaceActiveSameClassInstance: boolean;
	bShouldPauseMovement: boolean;
	bAlwaysNotifyOnFinished: boolean;
	static Load(ResourceName: string): PawnAction;
	static Find(Outer: UObject, ResourceName: string): PawnAction;
	static GetDefaultObject(): PawnAction;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnAction;
	GetActionPriority(): EAIRequestPriority;
	Finish(WithResult: EPawnActionResult): void;
	static CreateActionInstance(WorldContextObject: UObject,ActionClass: UnrealEngineClass): PawnAction;
	static C(Other: UObject | any): PawnAction;
}

declare class PawnActionStack { 
	TopAction: PawnAction;
	clone() : PawnActionStack;
	static C(Other: UObject | any): PawnActionStack;
}

declare class PawnActionEvent { 
	Action: PawnAction;
	clone() : PawnActionEvent;
	static C(Other: UObject | any): PawnActionEvent;
}

declare type EPawnActionAbortState = 'NeverStarted' | 'NotBeingAborted' | 'MarkPendingAbort' | 'LatentAbortInProgress' | 'AbortDone' | 'MAX';
declare var EPawnActionAbortState : { NeverStarted:'NeverStarted',NotBeingAborted:'NotBeingAborted',MarkPendingAbort:'MarkPendingAbort',LatentAbortInProgress:'LatentAbortInProgress',AbortDone:'AbortDone',MAX:'MAX', };
declare class PawnActionsComponent extends ActorComponent { 
	ControlledPawn: Pawn;
	ActionStacks: PawnActionStack[];
	ActionEvents: PawnActionEvent[];
	CurrentAction: PawnAction;
	static Load(ResourceName: string): PawnActionsComponent;
	static Find(Outer: UObject, ResourceName: string): PawnActionsComponent;
	static GetDefaultObject(): PawnActionsComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): PawnActionsComponent;
	K2_PushAction(NewAction: PawnAction,Priority: EAIRequestPriority,Instigator: UObject): boolean;
	static K2_PerformAction(Pawn: Pawn,Action: PawnAction,Priority: EAIRequestPriority): boolean;
	K2_ForceAbortAction(ActionToAbort: PawnAction): EPawnActionAbortState;
	K2_AbortAction(ActionToAbort: PawnAction): EPawnActionAbortState;
	static C(Other: UObject | any): PawnActionsComponent;
}

declare type ETaskResourceOverlapPolicy = 'StartOnTop' | 'StartAtEnd' | 'RequestCancelAndStartOnTop' | 'RequestCancelAndStartAtEnd' | 'ETaskResourceOverlapPolicy_MAX';
declare var ETaskResourceOverlapPolicy : { StartOnTop:'StartOnTop',StartAtEnd:'StartAtEnd',RequestCancelAndStartOnTop:'RequestCancelAndStartOnTop',RequestCancelAndStartAtEnd:'RequestCancelAndStartAtEnd',ETaskResourceOverlapPolicy_MAX:'ETaskResourceOverlapPolicy_MAX', };
declare class GameplayTask extends UObject { 
	InstanceName: string;
	ResourceOverlapPolicy: ETaskResourceOverlapPolicy;
	ChildTask: GameplayTask;
	static Load(ResourceName: string): GameplayTask;
	static Find(Outer: UObject, ResourceName: string): GameplayTask;
	static GetDefaultObject(): GameplayTask;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTask;
	ReadyForActivation(): void;
	EndTask(): void;
	static C(Other: UObject | any): GameplayTask;
}

declare class GameplayResourceSet { 
	clone() : GameplayResourceSet;
	static C(Other: UObject | any): GameplayResourceSet;
}

declare class GameplayTasksComponent extends ActorComponent { 
	bIsNetDirty: boolean;
	TaskPriorityQueue: GameplayTask[];
	TickingTasks: GameplayTask[];
	KnownTasks: GameplayTask[];
	OnClaimedResourcesChange: UnrealEngineMulticastDelegate<(NewlyClaimed: GameplayResourceSet, FreshlyReleased: GameplayResourceSet) => void>;
	SimulatedTasks: GameplayTask[];
	static Load(ResourceName: string): GameplayTasksComponent;
	static Find(Outer: UObject, ResourceName: string): GameplayTasksComponent;
	static GetDefaultObject(): GameplayTasksComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTasksComponent;
	OnRep_SimulatedTasks(PreviousSimulatedTasks: GameplayTask[]): void;
	static C(Other: UObject | any): GameplayTasksComponent;
}

declare class NavigationFilterArea { 
	AreaClass: UnrealEngineClass;
	TravelCostOverride: number;
	EnteringCostOverride: number;
	bIsExcluded: boolean;
	bOverrideTravelCost: boolean;
	bOverrideEnteringCost: boolean;
	clone() : NavigationFilterArea;
	static C(Other: UObject | any): NavigationFilterArea;
}

declare class NavigationFilterFlags { 
	bNavFlag0: boolean;
	bNavFlag1: boolean;
	bNavFlag2: boolean;
	bNavFlag3: boolean;
	bNavFlag4: boolean;
	bNavFlag5: boolean;
	bNavFlag6: boolean;
	bNavFlag7: boolean;
	bNavFlag8: boolean;
	bNavFlag9: boolean;
	bNavFlag10: boolean;
	bNavFlag11: boolean;
	bNavFlag12: boolean;
	bNavFlag13: boolean;
	bNavFlag14: boolean;
	bNavFlag15: boolean;
	clone() : NavigationFilterFlags;
	static C(Other: UObject | any): NavigationFilterFlags;
}

declare class NavigationQueryFilter extends UObject { 
	Areas: NavigationFilterArea[];
	IncludeFlags: NavigationFilterFlags;
	ExcludeFlags: NavigationFilterFlags;
	static Load(ResourceName: string): NavigationQueryFilter;
	static Find(Outer: UObject, ResourceName: string): NavigationQueryFilter;
	static GetDefaultObject(): NavigationQueryFilter;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): NavigationQueryFilter;
	static C(Other: UObject | any): NavigationQueryFilter;
}

declare class GameplayTaskResource extends UObject { 
	ManualResourceID: number;
	AutoResourceID: number;
	bManuallySetID: boolean;
	static Load(ResourceName: string): GameplayTaskResource;
	static Find(Outer: UObject, ResourceName: string): GameplayTaskResource;
	static GetDefaultObject(): GameplayTaskResource;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): GameplayTaskResource;
	static C(Other: UObject | any): GameplayTaskResource;
}

declare type EPathFollowingRequestResult = 'Failed' | 'AlreadyAtGoal' | 'RequestSuccessful' | 'EPathFollowingRequestResult_MAX';
declare var EPathFollowingRequestResult : { Failed:'Failed',AlreadyAtGoal:'AlreadyAtGoal',RequestSuccessful:'RequestSuccessful',EPathFollowingRequestResult_MAX:'EPathFollowingRequestResult_MAX', };
declare type EPathFollowingStatus = 'Idle' | 'Waiting' | 'Paused' | 'Moving' | 'EPathFollowingStatus_MAX';
declare var EPathFollowingStatus : { Idle:'Idle',Waiting:'Waiting',Paused:'Paused',Moving:'Moving',EPathFollowingStatus_MAX:'EPathFollowingStatus_MAX', };
declare class AIController extends Controller { 
	bStartAILogicOnPossess: boolean;
	bStopAILogicOnUnposses: boolean;
	bLOSflag: boolean;
	bSkipExtraLOSChecks: boolean;
	bAllowStrafe: boolean;
	bWantsPlayerState: boolean;
	bSetControlRotationFromPawnOrientation: boolean;
	PathFollowingComponent: PathFollowingComponent;
	BrainComponent: BrainComponent;
	PerceptionComponent: AIPerceptionComponent;
	ActionsComp: PawnActionsComponent;
	Blackboard: BlackboardComponent;
	CachedGameplayTasksComponent: GameplayTasksComponent;
	DefaultNavigationFilterClass: UnrealEngineClass;
	ReceiveMoveCompleted: UnrealEngineMulticastDelegate<(RequestID: AIRequestID, Result: EPathFollowingResult) => void>;
	static GetDefaultObject(): AIController;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): AIController;
	UseBlackboard(BlackboardAsset: BlackboardData,BlackboardComponent?: BlackboardComponent): {BlackboardComponent: BlackboardComponent, $: boolean};
	UnclaimTaskResource(ResourceClass: UnrealEngineClass): void;
	SetPathFollowingComponent(NewPFComponent: PathFollowingComponent): void;
	SetMoveBlockDetection(bEnable: boolean): void;
	RunBehaviorTree(BTAsset: BehaviorTree): boolean;
	OnUsingBlackBoard(BlackboardComp: BlackboardComponent,BlackboardAsset: BlackboardData): void;
	OnGameplayTaskResourcesClaimed(NewlyClaimed: GameplayResourceSet,FreshlyReleased: GameplayResourceSet): void;
	MoveToLocation(Dest: Vector,AcceptanceRadius: number,bStopOnOverlap: boolean,bUsePathfinding: boolean,bProjectDestinationToNavigation: boolean,bCanStrafe: boolean,FilterClass: UnrealEngineClass,bAllowPartialPath: boolean): EPathFollowingRequestResult;
	MoveToActor(Goal: Actor,AcceptanceRadius: number,bStopOnOverlap: boolean,bUsePathfinding: boolean,bCanStrafe: boolean,FilterClass: UnrealEngineClass,bAllowPartialPath: boolean): EPathFollowingRequestResult;
	K2_SetFocus(NewFocus: Actor): void;
	K2_SetFocalPoint(FP: Vector): void;
	K2_ClearFocus(): void;
	HasPartialPath(): boolean;
	GetPathFollowingComponent(): PathFollowingComponent;
	GetMoveStatus(): EPathFollowingStatus;
	GetImmediateMoveDestination(): Vector;
	GetFocusActor(): Actor;
	GetFocalPointOnActor(Actor: Actor): Vector;
	GetFocalPoint(): Vector;
	GetAIPerceptionComponent(): AIPerceptionComponent;
	ClaimTaskResource(ResourceClass: UnrealEngineClass): void;
	static C(Other: UObject | any): AIController;
}

declare class BrainComponent extends ActorComponent { 
	BlackboardComp: BlackboardComponent;
	AIOwner: AIController;
	static Load(ResourceName: string): BrainComponent;
	static Find(Outer: UObject, ResourceName: string): BrainComponent;
	static GetDefaultObject(): BrainComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BrainComponent;
	StopLogic(Reason: string): void;
	StartLogic(): void;
	RestartLogic(): void;
	IsRunning(): boolean;
	IsPaused(): boolean;
	static C(Other: UObject | any): BrainComponent;
}

declare class GameplayTagQuery { 
	TokenStreamVersion: number;
	TagDictionary: GameplayTag[];
	QueryTokenStream: number[];
	UserDescription: string;
	AutoDescription: string;
	clone() : GameplayTagQuery;
	static C(Other: UObject | any): GameplayTagQuery;
	IsTagQueryEmpty(): boolean;
	MakeGameplayTagQuery(): GameplayTagQuery;
	static IsTagQueryEmpty(TagQuery: GameplayTagQuery): boolean;
	static MakeGameplayTagQuery(TagQuery: GameplayTagQuery): GameplayTagQuery;
}

declare class GameplayTagContainer { 
	GameplayTags: GameplayTag[];
	ParentTags: GameplayTag[];
	clone() : GameplayTagContainer;
	static C(Other: UObject | any): GameplayTagContainer;
	AddGameplayTag(Tag?: GameplayTag): {TagContainer: GameplayTagContainer};
	AppendGameplayTagContainers(InTagContainer?: GameplayTagContainer): {InOutTagContainer: GameplayTagContainer};
	BreakGameplayTagContainer(GameplayTags?: GameplayTag[]): {GameplayTags: GameplayTag[]};
	DoesContainerMatchTagQuery(TagQuery: GameplayTagQuery): boolean;
	EqualEqual_GameplayTagContainer(B: GameplayTagContainer): boolean;
	GetDebugStringFromGameplayTagContainer(): string;
	GetNumGameplayTagsInContainer(): number;
	HasAllTags(OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	HasAnyTags(OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	HasTag(Tag: GameplayTag,bExactMatch: boolean): boolean;
	MakeLiteralGameplayTagContainer(): GameplayTagContainer;
	NotEqual_GameplayTagContainer(B: GameplayTagContainer): boolean;
	NotEqual_TagContainerTagContainer(B: string): boolean;
	RemoveGameplayTag(Tag?: GameplayTag): {TagContainer: GameplayTagContainer, $: boolean};
	static AddGameplayTag(TagContainer?: GameplayTagContainer,Tag?: GameplayTag): {TagContainer: GameplayTagContainer};
	static AppendGameplayTagContainers(InOutTagContainer?: GameplayTagContainer,InTagContainer?: GameplayTagContainer): {InOutTagContainer: GameplayTagContainer};
	static BreakGameplayTagContainer(GameplayTagContainer: GameplayTagContainer,GameplayTags?: GameplayTag[]): {GameplayTags: GameplayTag[]};
	static DoesContainerMatchTagQuery(TagContainer: GameplayTagContainer,TagQuery: GameplayTagQuery): boolean;
	static EqualEqual_GameplayTagContainer(A: GameplayTagContainer,B: GameplayTagContainer): boolean;
	static GetDebugStringFromGameplayTagContainer(TagContainer: GameplayTagContainer): string;
	static GetNumGameplayTagsInContainer(TagContainer: GameplayTagContainer): number;
	static HasAllTags(TagContainer: GameplayTagContainer,OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	static HasAnyTags(TagContainer: GameplayTagContainer,OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	static HasTag(TagContainer: GameplayTagContainer,Tag: GameplayTag,bExactMatch: boolean): boolean;
	static MakeLiteralGameplayTagContainer(Value: GameplayTagContainer): GameplayTagContainer;
	static NotEqual_GameplayTagContainer(A: GameplayTagContainer,B: GameplayTagContainer): boolean;
	static NotEqual_TagContainerTagContainer(A: GameplayTagContainer,B: string): boolean;
	static RemoveGameplayTag(TagContainer?: GameplayTagContainer,Tag?: GameplayTag): {TagContainer: GameplayTagContainer, $: boolean};
	static MakeGameplayTagContainerFromArray(GameplayTags: GameplayTag[]): GameplayTagContainer;
}

declare class GameplayTag { 
	TagName: string;
	clone() : GameplayTag;
	static C(Other: UObject | any): GameplayTag;
	EqualEqual_GameplayTag(B: GameplayTag): boolean;
	GetDebugStringFromGameplayTag(): string;
	GetTagName(): string;
	IsGameplayTagValid(): boolean;
	MakeGameplayTagContainerFromTag(): GameplayTagContainer;
	MakeLiteralGameplayTag(): GameplayTag;
	MatchesAnyTags(OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	MatchesTag(TagTwo: GameplayTag,bExactMatch: boolean): boolean;
	NotEqual_GameplayTag(B: GameplayTag): boolean;
	NotEqual_TagTag(B: string): boolean;
	static EqualEqual_GameplayTag(A: GameplayTag,B: GameplayTag): boolean;
	static GetDebugStringFromGameplayTag(GameplayTag: GameplayTag): string;
	static GetTagName(GameplayTag: GameplayTag): string;
	static IsGameplayTagValid(GameplayTag: GameplayTag): boolean;
	static MakeGameplayTagContainerFromTag(SingleTag: GameplayTag): GameplayTagContainer;
	static MakeLiteralGameplayTag(Value: GameplayTag): GameplayTag;
	static MatchesAnyTags(TagOne: GameplayTag,OtherContainer: GameplayTagContainer,bExactMatch: boolean): boolean;
	static MatchesTag(TagOne: GameplayTag,TagTwo: GameplayTag,bExactMatch: boolean): boolean;
	static NotEqual_GameplayTag(A: GameplayTag,B: GameplayTag): boolean;
	static NotEqual_TagTag(A: GameplayTag,B: string): boolean;
}

declare class BehaviorTreeComponent extends BrainComponent { 
	NodeInstances: BTNode[];
	DefaultBehaviorTreeAsset: BehaviorTree;
	static Load(ResourceName: string): BehaviorTreeComponent;
	static Find(Outer: UObject, ResourceName: string): BehaviorTreeComponent;
	static GetDefaultObject(): BehaviorTreeComponent;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BehaviorTreeComponent;
	SetDynamicSubtree(InjectTag: GameplayTag,BehaviorAsset: BehaviorTree): void;
	GetTagCooldownEndTime(CooldownTag: GameplayTag): number;
	AddCooldownTagDuration(CooldownTag: GameplayTag,CooldownDuration: number,bAddToExistingDuration: boolean): void;
	static C(Other: UObject | any): BehaviorTreeComponent;
}

declare class BTNode extends UObject { 
	NodeName: string;
	TreeAsset: BehaviorTree;
	ParentNode: BTCompositeNode;
	static Load(ResourceName: string): BTNode;
	static Find(Outer: UObject, ResourceName: string): BTNode;
	static GetDefaultObject(): BTNode;
	static CreateDefaultSubobject(Name: string, Transient?: boolean, Required?: boolean, Abstract?: boolean): BTNode;
	static C(Other: UObject | any): BTNode;
	ClearBlackboardValue(Key: BlackboardKeySelector): void;
	ClearBlackboardValueAsVector(Key: BlackboardKeySelector): void;
	GetBlackboardValueAsActor(Key: BlackboardKeySelector): Actor;
	GetBlackboardValueAsBool(Key: BlackboardKeySelector): boolean;
	GetBlackboardValueAsClass(Key: BlackboardKeySelector): UnrealEngineClass;
	GetBlackboardValueAsEnum(Key: BlackboardKeySelector): number;
	GetBlackboardValueAsFloat(Key: BlackboardKeySelector): number;
	GetBlackboardValueAsInt(Key: BlackboardKeySelector): number;
	GetBlackboardValueAsName(Key: BlackboardKeySelector): string;
	GetBlackboardValueAsObject(Key: BlackboardKeySelector): UObject;
	GetBlackboardValueAsRotator(Key: BlackboardKeySelector): Rotator;
	GetBlackboardValueAsString(Key: BlackboardKeySelector): string;
	GetBlackboardValueAsVector(Key: BlackboardKeySelector): Vector;
	GetOwnerComponent(): BehaviorTreeComponent;
	GetOwnersBlackboard(): BlackboardComponent;
	SetBlackboardValueAsBool(Key: BlackboardKeySelector,Value: boolean): void;
	SetBlackboardValueAsClass(Key: BlackboardKeySelector,Value: UnrealEngineClass): void;
	SetBlackboardValueAsEnum(Key: BlackboardKeySelector,Value: number): void;
	SetBlackboardValueAsFloat(Key: BlackboardKeySelector,Value: number): void;
	SetBlackboardValueAsInt(Key: BlackboardKeySelector,Value: number): void;
	SetBlackboardValueAsName(Key: BlackboardKeySelector,Value: string): void;
	SetBlackboardValueAsObject(Key: BlackboardKeySelector,Value: UObject): void;
	SetBlackboardValueAsRotator(Key: BlackboardKeySelector,Value: Rotator): void;
	SetBlackboardValueAsString(Key: BlackboardKeySelector,Value: string): void;
	SetBlackboardValueAsVector(Key: BlackboardKeySelector,Value: Vector): void;
	StartUsingExternalEvent(OwningActor: Actor): void;
	StopUsingExternalEvent(): void;
	static ClearBlackboardValue(NodeOwner: BTNode,Key: BlackboardKeySelector): void;
	static ClearBlackboardValueAsVector(NodeOwner: BTNode,Key: BlackboardKeySelector): void;
	static GetBlackboardValueAsActor(NodeOwner: BTNode,Key: BlackboardKeySelector): Actor;
	static GetBlackboardValueAsBool(NodeOwner: BTNode,Key: BlackboardKeySelector): boolean;
	static GetBlackboardValueAsClass(NodeOwner: BTNode,Key: BlackboardKeySelector): UnrealEngineClass;
	static GetBlackboardValueAsEnum(NodeOwner: BTNode,Key: BlackboardKeySelector): number;
	static GetBlackboardValueAsFloat(NodeOwner: BTNode,Key: BlackboardKeySelector): number;
	static GetBlackboardValueAsInt(NodeOwner: BTNode,Key: BlackboardKeySelector): number;
	static GetBlackboardValueAsName(NodeOwner: BTNode,Key: BlackboardKeySelector): string;
	static GetBlackboardValueAsObject(NodeOwner: BTNode,Key: BlackboardKeySelector): UObject;
	static GetBlackboardValueAsRotator(NodeOwner: BTNode,Key: BlackboardKeySelector): Rotator;
	static GetBlackboardValueAsString(NodeOwner: BTNode,Key: BlackboardKeySelector): string;
	static GetBlackboardValueAsVector(NodeOwner: BTNode,Key: BlackboardKeySelector): Vector;
	static GetOwnerComponent(NodeOwner: BTNode): BehaviorTreeComponent;
	static GetOwnersBlackboard(NodeOwner: BTNode): BlackboardComponent;
	static SetBlackboardValueAsBool(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: boolean): void;
	static SetBlackboardValueAsClass(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: UnrealEngineClass): void;
	static SetBlackboardValueAsEnum(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: number): void;
	static SetBlackboardValueAsFloat(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: number): void;
	static SetBlackboardValueAsInt(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: number): void;
	static SetBlackboardValueAsName(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: string): void;
	static SetBlackboardValueAsObject(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: UObject): void;
	static SetBlackboardValueAsRotator(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: Rotator): void;
	static SetBlackboardValueAsString(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: string): void;
	static SetBlackboardValueAsVector(NodeOwner: BTNode,Key: BlackboardKeySelector,Value: Vector): void;
	static StartUsingExternalEvent(NodeOwner: BTNode,OwningActor: Actor): void;
	static StopUsingExternalEvent(NodeOwner: BTNode): void;
}

